					LDA $19
					BNE DOWN_GEN
					RTS
DOWN_GEN            
					LDA $9A
					PHA
					AND #$F0
					SEC
					SBC #$08
					STA $9A
					LDA $9B
					PHA
					SBC #$00
					STA $9B
					JSR FIRE_GEN
					PLA
					STA $9B
					PLA
					STA $9A

					
                    PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					
					LDA $9A
					PHA
					AND #$F0
					SEC
					SBC #$10
					STA $9A
					LDA $9B
					PHA
					SBC #$00
					STA $9B
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					
					LDA $98
					PHA
					AND #$F0
					SEC
					SBC #$10
					STA $98
					LDA $99
					PHA
					SBC #$00
					STA $99
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					
					LDA $9A
					CLC
					ADC #$10
					STA $9A
					LDA $9B
					ADC #$00
					STA $9B
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSR SUBL_SET_MAP16      ;  |
                    PLP
					
					PLA
					STA $99
					PLA
					STA $98
					PLA
					STA $9B
					PLA
					STA $9A
					
					LDA #$07
					STA $1DFC
RETURN67            RTS                     ; return

SPRITE				LDA $14C8,x
					CMP #$08
					BNE RETURN67
					LDA $C2,x
					CMP #$02
					BNE RETURN67
					LDA $9E,x
					CMP #$36
					BNE RETURN67
SPRITE2				LDA $0A
					STA $9A
					LDA $0B
					STA $9B
					LDA $0C
					STA $98
					LDA $0D
					STA $99
					JSR DOWN_GEN
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN68            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$84
					TYX
                    STA $7FAB9E,x
                    PLX
                    
                    LDA $9A
                    STA $00E4,y
                    LDA $9B
                    STA $14E0,y             ; /
                    LDA $98
                    STA $00D8,y             ;  |
                    LDA $99
                    STA $14D4,y             ; /
					
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA $7FAB10,x
                    PLX
					LDA #$00
					STA $157C,y
					LDA #$30
					STA $15AC,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Map 16 Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUBL_SET_MAP16      PHP                     
                    REP #$30                
                    PHY                    
                    PHX                     
                    TAX                    
                    LDA $03                 
                    PHA                    
                    JSR SUB_8034           
                    PLA                  
                    STA $03                 
                    PLX                     
                    PLY                     
                    PLP                     
                    RTS                    

                    JMP $FEA301
RETURN18            PLX
                    PLB
                    PLP
                    RTS

SUB_8034            PHP                      
                    SEP #$20                
                    PHB                     
                    LDA #$00                 
                    PHA                  
                    PLB                   
                    REP #$30                 
                    PHX                     
                    LDA $9A                 ;A:0200 X:0266 Y:0001 0426 
                    STA $0C                 ;A:0070 X:0266 Y:0001 0458 
                    LDA $98                 ;A:0070 X:0266 Y:0001 0490 
                    STA $0E                 ;A:0130 X:0266 Y:0001 0522 
                    LDA.W #$0000            ;A:0130 X:0266 Y:0001 0554 
                    SEP #$20                ;A:0000 X:0266 Y:0001 0578 
                    LDA $5B                 ;A:0000 X:0266 Y:0001 0600 
                    STA $09                 ;A:0000 X:0266 Y:0001 0624 
                    LDA $1933               ;A:0000 X:0266 Y:0001 0648
                    BEQ NO_SHIFT            ;A:0000 X:0266 Y:0001 0680 
                    LSR $09
NO_SHIFT            LDY $0E                 ;A:0000 X:0266 Y:0001 0702 
                    LDA $09                 ;A:0000 X:0266 Y:0130 0734 
                    AND #$01                ;A:0000 X:0266 Y:0130 0758 
                    BEQ HORIZ               ;A:0000 X:0266 Y:0130 0774 
                    LDA $9B
                    STA $00
                    LDA $99
                    STA $9B
                    LDA $00  
                    STA $99
                    LDY $0C
HORIZ               CPY.W #$0200            ;A:0000 X:0266 Y:0130 0796 
                    BCS RETURN18            ;A:0000 X:0266 Y:0130 0820 
                    LDA $1933               ;A:0000 X:0266 Y:0130 0836 
                    ASL A                   ;A:0000 X:0266 Y:0130 0868 
                    TAX                     ;A:0000 X:0266 Y:0130 0882 
                    LDA $BEA8,x ;[$00:BEA8] ;A:0000 X:0000 Y:0130 0896 
                    STA $65                 ;A:00A8 X:0000 Y:0130 0928 
                    LDA $BEA9,x ;[$00:BEA9] ;A:00A8 X:0000 Y:0130 0952 
                    STA $66                 ;A:00BD X:0000 Y:0130 0984 
                    STZ $67                 ;A:00BD X:0000 Y:0130 1008 
                    LDA $1925               ;A:00BD X:0000 Y:0130 1032 
                    ASL A                   ;A:0000 X:0000 Y:0130 1064 
                    TAY                     ;A:0000 X:0000 Y:0130 1078 
                    LDA ($65),y ;[$00:BDA8] ;A:0000 X:0000 Y:0000 1092 
                    STA $04                 ;A:00D8 X:0000 Y:0000 1132 
                    INY                     ;A:00D8 X:0000 Y:0000 1156 
                    LDA ($65),y ;[$00:BDA9] ;A:00D8 1170 
                    STA $05                 ;A:00BA 1210 
                    STZ $06                 ;A:00BA 1234 
                    LDA $9B                 ;A:00BA 1258 
                    STA $07                 ;A:0000 1282 
                    ASL A                   ;A:0000 1306 
                    CLC                     ;A:0000 1320 
                    ADC $07                 ;A:0000 1334 
                    TAY                     ;A:0000 1358 
                    LDA ($04),y ;[$00:BAD8] ;A:0000 X:0000 Y:0000 0004  
                    STA $6B                 ;A:0000 X:0000 Y:0000 0044  
                    STA $6E                 ;A:0000 X:0000 Y:0000 0068  
                    INY                     ;A:0000 X:0000 Y:0000 0092  
                    LDA ($04),y ;[$00:BAD9] ;A:0000 0106  
                    STA $6C                 ;A:00C8 0146  
                    STA $6F                 ;A:00C8 0170  
                    LDA #$7E                ;A:00C8 0194  
                    STA $6D                 ;A:007E 0210  
                    INC A                   ;A:007E 0234  
                    STA $70                 ;A:007F 0248  
                    LDA $09                 ;A:007F 0272  
                    AND #$01                ;A:0000 0296  
                    BEQ NO_AND              ;A:0000 0312  
                    LDA $99
                    LSR A
                    LDA $9B 
                    AND #$01
                    BRA LABEL52
NO_AND              LDA $9B                 ;A:0000 0334  
                    LSR A                   ;A:0000 0358  
                    LDA $99                 ;A:0000 0372  
LABEL52             ROL A                   ;A:0001 0396  
                    ASL A                   ;A:0002 0410  
                    ASL A                   ;A:0004 0424  
                    ORA #$20                ;A:0008 0438  
                    STA $04                 ;A:0028 0454  
                    CPX.W #$0000            ;A:0028 0478  
                    BEQ NO_ADD              ;A:0028 0502  
                    CLC
                    ADC #$10 
                    STA $04
NO_ADD              LDA $98                 
                    AND #$F0                
                    CLC                     ;A:0030 0564  
                    ASL A                   ;A:0030 0578  
                    ROL A                   ;A:0060 0592  
                    STA $05                 ;A:00C0 0606  
                    ROL A                   ;A:00C0 0630  
                    AND #$03                ;A:0080 0644  
                    ORA $04                 ;A:0000 0660  
                    STA $06                 ;A:0028 0684  
                    LDA $9A                 ;A:0028 0708  
                    AND #$F0                ;A:0070 0732  
                    LSR A                   ;A:0070 0748  
                    LSR A                   ;A:0038 0762  
                    LSR A                   ;A:001C 0776  
                    STA $04                 ;A:000E 0790  
                    LDA $05                 ;A:000E 0814  
                    AND #$C0                ;A:00C0 0838  
                    ORA $04                 ;A:00C0 0854  
                    STA $07                 ;A:00CE 0878  
                    REP #$20                ;A:00CE 0902  
                    LDA $09                 ;A:00CE 0924  
                    AND.W #$0001            ;A:0100 0956  
                    BNE LABEL51             ;A:0000 0980  
                    LDA $1A                 ;A:0000 0996  
                    SEC                     ;A:0000 1028  
                    SBC.W #$0080            ;A:0000 1042  
                    TAX                     ;A:FF80 1066  
                    LDY $1C                 ;A:FF80 X:FF80 Y:0001 1080  
                    LDA $1933               ;A:FF80 X:FF80 Y:00C0 1112  
                    BEQ LABEL50             ;A:0000 X:FF80 Y:00C0 1152  
                    LDX $1E
                    LDA $20
                    SEC
                    SBC.W #$0080
                    TAY
                    BRA LABEL50
LABEL51             LDX $1A
                    LDA $1C
                    SEC
                    SBC.W #$0080
                    TAY
                    LDA $1933
                    BEQ LABEL50
                    LDA $1E
                    SEC
                    SBC.W #$0080
                    TAX  
                    LDY $20
LABEL50             STX $08                
                    STY $0A               
                    LDA $98               
                    AND.W #$01F0          
                    STA $04              
                    LDA $9A              
                    LSR A                
                    LSR A                
                    LSR A                
                    LSR A                
                    AND.W #$000F          
                    ORA $04              
                    TAY                    
                    PLA              
                    SEP #$20               
                    STA [$6B],y ;[$7E:C937] 
                    XBA                     
                    STA [$6E],y ;[$7F:C937] 
                    XBA                    
                    REP #$20                
                    ASL A              
                    TAY                     
                    PHK                   
                    PER.W #$0006           
                    PEA $804C
                    JMP.L $00C0FB
MAP16_RETURN        PLB
                    PLP
                    RTS

                    
                    NOP                    

