;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;J{r[
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$FF
					STA $7FFDDD
					LDA #$7F
					STA $7FFDDE
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT1
					JSR DIR_CHECK
					LDA #$40
					STA $1540,x
					LDA #$80
					STA $15AC,x
					RTL
INIT1				LDA $7FFEDF
					BNE INIT2
					LDA #$02
					STA $1504,x
					STZ $1656,x
					LDA #$93
					STA $167A,x
					LDA #$3B
					STA $166E,x
					LDA #$80
					STA $15AC,x
					LDA #$01
					STA $7FFEDF
					RTL
INIT2				STZ $14C8,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR KINOPIO
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR BOMB
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR AIR
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR BOMBIE
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR DICE
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR MISSILE
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR BODY
					RTS
MAIN7				JSR HEAD
					RTS
					
SPEED				dcb $F0,$10

KINOPIO				JSR SUB_GFX_K
					LDA $9D
					BNE KINO_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA $14C8,x
					CMP #$08
					BCC KINO_R
					LDA $1540,x
					BNE KINOPIO_2
					JSR DIR_CHECK
					LDA #$40
					STA $1540,x
KINOPIO_2			JSL $01A7DC
					LDA $15AC,x
					CMP #$30
					BCC KINOPIO_3
					INC $1570,x
					LDA $1588,x
					AND #$04
					BEQ KINOPIO_0
					LDA $1588,x
					AND #$03
					BEQ KINOPIO_1
KINOPIO_0			LDA $157C,x
					EOR #$01
					STA $157C,x
KINOPIO_1			LDA $157C,x
					TAY
					LDA SPEED,y
					STA $B6,x
					JSL $01802A
KINO_R				RTS
KINOPIO_3			CMP #$00
					BEQ KINOPIO_6
					CMP #$10
					BEQ KINOPIO_4
					BCC KINOPIO_5
					LDA #$01
					STA $1602,x
					RTS
KINOPIO_5			STZ $1602,x
					RTS
KINOPIO_4			JSR DIR_CHECK
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA $D8,x
					SEC
					SBC #$10
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					LDA #$C0
					STA $00AA,y
					PHX
					LDA $157C,x
					STA $157C,y
					TAX
					LDA BOMB_SPEED,x
					STA $00B6,y
					PLX
					STZ $1602,x
					RTS
KINOPIO_6			LDA #$80
					STA $15AC,x
					RTS
BOMB_SPEED			dcb $E0,$20
					
AIR					JSR SUB_GFX_AIR
					LDA $9D
					BNE AIR_R
					STZ $149F
					LDA $D8,x
					CLC
					ADC #$18
					STA $7FFFC0
					LDA $14D4,x
					ADC #$00
					STA $7FFFC1
					LDA $151C,x
					BEQ AIR_0
					JSR SUB_AIR
					RTS
AIR_0				LDA $C2,x
					BEQ AIR_1
					JSL $01A7DC
					BCC AIR_1
					LDA #$D0
					STA $7D
					JSL $01AB99
					LDA #$03
                    STA $1DF9
					LDA #$01
					STA $151C,x
					LDA #$80
					STA $1558,x
AIR_1				JSR MOVE_AIR
					STZ $1602,x
					LDA $15AC,x
					BEQ AIR_3
					CMP #$10
					BEQ AIR_2
					BCS AIR_R
					LDA #$01
					STA $1602,x
AIR_R				RTS
AIR_2				LDA $7FFF09
					BNE AIR_R
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					JSL $01ACF9
					AND #$1F
					CLC
					ADC #$E0
					STA $00B6,y
					LDA $C2,x
					BEQ AIR_R
					JSL $01ACF9
					AND #$3F
					CLC
					ADC #$C0
					STA $00B6,y
					RTS
AIR_3				LDA #$C0
					STA $15AC,x
					RTS
					
SUB_AIR				LDA $1558,x
					BEQ SUB_AIR_1
					REP #$20
					LDA $7FFFC0
					CMP.W #$0184
					SEP #$20
					BCS SUB_AIR_R
					LDA #$40
					STA $AA,x
					JSL $01801A
					LDA $151C,x
					CMP #$02
					BCS SUB_AIR_R
					REP #$20
					LDA $7FFFC0
					CMP $7FFFC2
					SEP #$20
					BCC SUB_AIR_R
					LDA #$02
					STA $151C,x
					LDA $7FFFC8
					INC A
					STA $7FFFC8
					LDA #$28
					STA $1DFC
					LDA $7FFFC8
					CMP #$05
					BCC SUB_AIR_R
					LDA #$1E
					STA $1DFB
					LDA #$18
					STA $1DFC
					STZ $14C8,x
					JSR SUB_AIR2
SUB_AIR_R			RTS
SUB_AIR_1			LDA #$E0
					STA $AA,x
					JSL $01801A
					REP #$20
					LDA $7FFFC0
					CMP.W #$00EC
					SEP #$20
					BCS SUB_AIR_R
					STZ $151C,x
					RTS

SUB_AIR2			LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR SUB_SMOKE
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR SUB_SMOKE
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSR SUB_SMOKE
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR SUB_SMOKE
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					JSR GEN_SPRITE
					LDA #$06
					STA $1504,y
					LDA #$00
					STA $1656,y
					LDA #$13
					STA $167A,y
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$00
					STA $1656,y
					LDA #$13
					STA $167A,y
					LDA #$E0
					STA $00B6,y
					LDA #$B0
					STA $00AA,y
					LDA #$FF
					STA $15AC,y
					RTS


MOVE_AIR			LDA $C2,x
					BNE MOVE_AIR_R
					INC $1570,x
					LDA $1570,x
					AND #$7F
					STA $03
					CMP #$40
					BCC MOVE_AIR_1
					LDA #$80
					SEC
					SBC $03
					STA $03
MOVE_AIR_1			STZ $04
					REP #$20
					LDA $1462
					CLC
					ADC.W #$00A0
					CLC
					ADC $03
					STA $0E
					SEP #$20
					LDA $0E
					STA $E4,x
					LDA $0F
					STA $14E0,x
					LDA $1463
					CMP #$06
					BEQ MOVE_AIR_2
MOVE_AIR_R			RTS
MOVE_AIR_2			STZ $1411
					LDA $E4,x
					CMP #$E0
					BNE MOVE_AIR_R
					INC $C2,x
					LDA #$01
					STA $1426
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$00
					STA $1656,y
					LDA #$13
					STA $167A,y
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					RTS
					
BOMBIE				JSR SUB_GFX
					LDA $9D
					BNE BOMBIE_R
					JSL $01A7DC
					LDA $7FFFC8
					CMP #$05
					BCS BOMBIE_DEL
					LDA $D8,x
					STA $7FFFC2
					LDA $14D4,x
					STA $7FFFC3
					LDA $C2,x
					BNE BOMBIE_1
					JSR BOMBIE0
BOMBIE_R			RTS
BOMBIE_DEL			STZ $14C8,x
					RTS
BOMBIE_1			CMP #$01
					BNE BOMBIE_2
					JSR BOMBIE1
					RTS
BOMBIE_2			CMP #$02
					BNE BOMBIE_3
					JSR BOMBIE2
					RTS
BOMBIE_3			CMP #$03
					;BNE BOMBIE_4
					JSR BOMBIE3
					RTS
					
BOMBIE0				LDA #$10
					STA $AA,x
					JSL $01801A ;y speed
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $1602,x
					LDA $14
					AND #$0F
					BNE BOMBIE0_2
					LDA #$17
					STA $1DFC
BOMBIE0_2			JSL $019138
					LDA $1588,x
					AND #$04
					BEQ BOMBIE0_R
					INC $C2,x
					LDA #$FF
					STA $15AC,x
BOMBIE0_R			RTS

BOMBIE1				LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					INC A
					INC A
					STA $1602,x
					LDA $15AC,x
					CMP #$C0
					BEQ BOMBIE1_2
					LDA $7FFFD8
					BNE BOMBIE1_3
					RTS
BOMBIE1_2			JSR SUB_BOMBIE1
					RTS
BOMBIE1_3			LDA #$04
					STA $1602,x
					INC $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
					
BOMBIE2				LDA $15AC,x
					BEQ BOMBIE2_2
					CMP #$E0
					BEQ BOMBIE2_1
					CMP #$B0
					BEQ BOMBIE2_1
					CMP #$80
					BEQ BOMBIE2_1
					CMP #$40
					BCS BOMBIE2_R
					LDA #$01
					STA $7FFF09
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					INC A
					INC A
					STA $1602,x
BOMBIE2_R			RTS
BOMBIE2_2			INC $C2,x
					LDA #$FF
					STA $15AC,x
					JSR BLK_CHANGE2
					RTS
BOMBIE2_1			LDA #$17
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA $D8,x
					SEC
					SBC #$10
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					LDA $E4,x
					SEC
					SBC #$08
					STA $00E4,y
					LDA $14E0,x
					SBC #$00
					STA $14E0,y
					LDA #$E0
					STA $00B6,y
					RTS

BOMBIE3				LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					CLC
					ADC #$05
					STA $1602,x
					LDA $15AC,x
					CMP #$90
					BCS BOMBIE3_2
					LDA #$10
					STA $AA,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ BOMBIE3_R
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FFFD8
					STA $7FFF09
BOMBIE3_R			RTS
BOMBIE3_2			LDA #$F0
					STA $AA,x
					JSL $01801A
					LDA $15AC,x
					CMP #$F0
					BEQ BOMBIE3_3
					CMP #$D0
					BEQ BOMBIE3_3
					CMP #$B0
					BEQ BOMBIE3_3
					CMP #$90
					BEQ BOMBIE3_3
					RTS
BOMBIE3_3			JSR BOMBIE2_1
					LDA #$F0
					STA $00B6,y
					RTS

SUB_BOMBIE1			LDA #$00
					STA $7FFFD0
					STA $7FFFD1
					STA $7FFFD2
					STA $7FFFD3
					STA $7FFFD4
					STA $7FFFD5
					JSR SUB_BOMBIE1_G
					LDA #$D0
					STA $00E4,y
					LDA #$50
					STA $00D8,y
					LDA #$00
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFFC8
					BEQ SUB_BOMBIE1_R
					JSR SUB_BOMBIE1_G
					LDA #$E0
					STA $00E4,y
					LDA #$40
					STA $00D8,y
					LDA #$10
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFFC8
					CMP #$01
					BEQ SUB_BOMBIE1_R
					JSR SUB_BOMBIE1_G
					LDA #$C0
					STA $00E4,y
					LDA #$40
					STA $00D8,y
					LDA #$20
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFFC8
					CMP #$02
					BEQ SUB_BOMBIE1_R
					JSR SUB_BOMBIE1_G
					LDA #$D0
					STA $00E4,y
					LDA #$30
					STA $00D8,y
					LDA #$30
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFFC8
					CMP #$03
					BEQ SUB_BOMBIE1_R
					JSR SUB_BOMBIE1_G
					LDA #$B0
					STA $00E4,y
					LDA #$30
					STA $00D8,y
					LDA #$40
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					LDA $7FFFC8
SUB_BOMBIE1_R		RTS
					
SUB_BOMBIE1_G		JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$00
					STA $1656,y
					LDA #$13
					STA $167A,y
					LDA #$3B
					STA $166E,y
					JSL $01ACF9
					STA $1570,y
					RTS
					

					
DIR_CHECK			STZ $157C,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS DIR_CHECK_R
					INC $157C,x
DIR_CHECK_R			RTS
					
DICE_NUMBER			dcb $18,$00,$28,$20,$10,$08
DICE				JSR SUB_GFX_DICE
					LDA $9D
					BNE DICE_R
					LDA $C2,x
					BNE DICE_6
					INC $1570,x
					LDA $15AC,x
					CMP #$D0
					BEQ DICE_2
					BCS DICE_R
					CMP #$A0
					BEQ DICE_3
					CMP #$89
					BCS DICE_4
					CMP #$88
					BEQ DICE_5
DICE_R				RTS
DICE_2				LDA #$C0
					STA $AA,x
					LDA #$E0
					STA $B6,x
					RTS
DICE_3				LDA #$E0
					STA $AA,x
					RTS
DICE_4				JSL $01802A
					RTS
DICE_5				INC $C2,x
DICE_5_2			JSL $01ACF9
					CLC
					ADC $94
					AND #$07
					STA $02
					CMP #$06
					BCS DICE_5_2
					PHX
					TAX
					LDA $7FFFD0,x
					PLX
					CMP #$00
					BNE DICE_5_2
					LDA $02
					STA $1602,x
					PHX
					TAX
					LDA #$01
					STA $7FFFD0,x
					PLX
					LDA $1602,x
					TAY
					LDA DICE_NUMBER,y
					STA $1570,x
					STA $7FFF70
					RTS
DICE_6				LDA $15AC,x
					BEQ DICE_DEL
					CMP #$40
					BEQ DICE_6_2
					RTS
DICE_6_2			LDA #$2B
					STA $1DFC
					JSR BLK_CHANGE
					RTS
DICE_DEL			STZ $14C8,x
					LDA #$01
					STA $7FFFD8
					RTS

DICE_BLOCK			dcb $90,$91,$92,$93,$86,$87
DICE_BLOCK2			dcb $0A,$0A,$0A,$0A,$0A,$0A

BLK_CHANGE			LDA $1602,x
					TAY
					LDA DICE_BLOCK,y
					STA $7FFF03
					LDA DICE_BLOCK2,y
					STA $7FFF04
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					ASL A
					STA $9A
					JSR SUB_BLK_CHANGE
					LDA $9A
					CLC
					ADC #$60
					STA $9A
					JSR SUB_BLK_CHANGE
					LDA $9A
					CLC
					ADC #$60
					STA $9A
					BCS BLK_CHANGE_R
					JSR SUB_BLK_CHANGE
BLK_CHANGE_R		RTS
					
SUB_BLK_CHANGE		LDA #$06
					STA $9B
					LDA #$90
					STA $98
					LDA #$01
					STA $99
					REP #$30
					LDA $7FFF03
					STA $03
					JSL $2E8DF0
                    SEP #$30
					RTS

BLK_CHANGE2_TBL1	dcb $07,$85,$08,$09,$0A,$0B,$07,$85,$08,$09,$0A,$0B,$07,$85,$08,$09
BLK_CHANGE2_TBL2	dcb $02,$07,$02,$02,$02,$02,$02,$07,$02,$02,$02,$02,$02,$07,$02,$02

BLK_CHANGE2			PHX
					LDX #$00
					LDA #$00
					STA $9A
BLK_CHANGE2_LOOP	LDA #$06
					STA $9B
					LDA #$90
					STA $98
					LDA #$01
					STA $99
					LDA BLK_CHANGE2_TBL1,x
					STA $03
					LDA BLK_CHANGE2_TBL2,x
					STA $04
					REP #$30
					LDA $03
					JSL $2E8DF0
                    SEP #$30
					LDA $9A
					CLC
					ADC #$10
					STA $9A
					INX
					CPX #$10
					BCC BLK_CHANGE2_LOOP
					PLX
					RTS

BOMB				LDA $1540,x
					BNE BOMB_1
					JSR SUB_GFX_BM
					LDA $9D
					BNE BOMB_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
BOMB_1				LDA $14C8,x
					CMP #$08
					BCC BOMB_R
					LDA $1540,x
					BNE BOMB_4
					JSL $01A7DC
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ BOMB_R
					LDA #$20
					STA $1540,x
					LDA #$10
					STA $1DFC
BOMB_R				RTS
BOMB_4				LDA $1540,x
					CMP #$01
					BEQ BOMB_DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
					RTS
BOMB_DELETE			STZ $14C8,x
BOMB_R				RTS

MISSILE				JSR SUB_GFX_MI
					LDA $9D
					BNE MISSILE_R
					LDA $14C8,x
					CMP #$08
					BCC MISSILE_R2
					JSL $01A7DC
					LDA #$02
					STA $AA,x
					JSL $018022
					JSL $01801A ;y speed
					LDA $14E0,x
					CMP #$06
					BNE MISSILE_DEL
MISSILE_R			RTS
MISSILE_DEL			STZ $14C8,x
					RTS
MISSILE_R2			STZ $B6,x
					RTS
					
BODY				JSR SUB_GFX_BODY
					LDA $9D
					BNE BODY_R
					LDA $14D4,x
					BEQ BODY_2
					LDA $D8,x
					CMP #$80
					BCC BODY_2
BODY_R				RTS
BODY_2				JSL $01802A
					RTS
					
HEAD				JSR SUB_GFX_HEAD
					LDA $9D
					BNE HEAD_R
					LDA $15AC,x
					BEQ HEAD_3
					LDA $14D4,x
					BEQ HEAD_2
					LDA $D8,x
					CMP #$78
					BCC HEAD_2
HEAD_R				RTS
HEAD_2				JSL $01802A
					INC $1570,x
					RTS
HEAD_3				LDA #$01
					STA $13CE ;#NAtO
					LDA #$01
					STA $0DD5
					INC $1DE9
					LDA #$0B
					STA $0100
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GFX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX_BM			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$0E
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
                    RTS


AIR_TILE			dcb $60,$60,$48,$64,$60,$60
					dcb $60,$60,$4A,$6A,$60,$60
AIR_HORZ			dcb $FB,$05,$00,$00,$FA,$06
AIR_VERT			dcb $0F,$0F,$00,$10,$16,$16
PROP_AIR			dcb $0C,$0C,$0F,$0F,$0C,$0C
SUB_GFX_AIR			JSR GET_DRAW_INFO
					STZ $02
					LDA $1602,x
					BEQ SUB_GFX_AIR_2
					LDA #$06
					STA $02
SUB_GFX_AIR_2		PHX
					LDX #$05
LOOP_AIR			LDA $00
					CLC
					ADC AIR_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC AIR_VERT,x
					STA $0301,y
					LDA PROP_AIR,x
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA AIR_TILE,x
					STA $0302,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_AIR
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $01B7B3
                    RTS 



K_VERT				dcb $F0,$00,$00
					dcb $F1,$01,$01
					dcb $F0,$00,$EC
TILE_K				dcb $48,$64,$64
					dcb $48,$68,$68
					dcb $4A,$6A,$0E
PROP_K				dcb $0F,$0F,$0F
					dcb $0F,$0F,$0F
					dcb $0F,$0F,$0D

SUB_GFX_K			JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$01
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					LDA $1602,x
					BEQ SUB_GFX_K_1
					LDA #$06
					STA $02
SUB_GFX_K_1			LDA $157C,x
					STA $0F
					PHX
					LDX #$02
K_LOOP				PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC K_VERT,x
					STA $0301,y
					LDA TILE_K,x
					STA $0302,y
					LDA PROP_K,x
					ORA $64
					STA $0303,y
					LDA $0F
					BEQ SUB_GFX_K_2
					LDA $0303,y
					ORA #$40
					STA $0303,y
SUB_GFX_K_2			PLX
					INY
					INY
					INY
					INY
					DEX
					BPL K_LOOP
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$02
                    JSL $01B7B3
                    RTS
					
					
HEAD_HORZ			dcb $F0,$00,$10,$F0,$00,$10
					dcb $F8,$08,$F8,$08,$10,$10
					dcb $F8,$08,$F8,$08,$F8,$08
					dcb $F8,$08,$F8,$08,$10,$10
					dcb $F0,$00,$10,$F0,$00,$10
					dcb $F8,$08,$F8,$08,$10,$10
					dcb $F8,$08,$F8,$08,$F8,$08
					dcb $F8,$08,$F8,$08,$10,$10

					
HEAD_VERT			dcb $F8,$F8,$F8,$08,$08,$08
					dcb $F8,$F8,$08,$08,$30,$50
					dcb $F0,$F0,$00,$00,$10,$10
					dcb $F8,$F8,$08,$08,$30,$50
					dcb $F8,$F8,$F8,$08,$08,$08
					dcb $F8,$F8,$08,$08,$30,$50
					dcb $F0,$F0,$00,$00,$10,$10
					dcb $F8,$F8,$08,$08,$30,$50
					
HEAD_TILE			dcb $EA,$EC,$EE,$EA,$EC,$EE
					dcb $C6,$C8,$E6,$E8,$B2,$B2
					dcb $0C,$0C,$C4,$C4,$E4,$E4
					dcb $C8,$C6,$E8,$E6,$B2,$B2
					dcb $EE,$EC,$EA,$EE,$EC,$EA
					dcb $E8,$E6,$C8,$C6,$B2,$B2
					dcb $E4,$E4,$C4,$C4,$0C,$0C
					dcb $E6,$E8,$C6,$C8,$B2,$B2
					
HEAD_PROP			dcb $0D,$0D,$0D,$8D,$8D,$8D
					dcb $0D,$0D,$0D,$0D,$0D,$0D
					dcb $0D,$4D,$0D,$4D,$0D,$4D
					dcb $4D,$4D,$4D,$4D,$4D,$4D
					dcb $4D,$4D,$4D,$CD,$CD,$CD
					dcb $CD,$CD,$CD,$CD,$CD,$CD
					dcb $8D,$CD,$8D,$CD,$8D,$CD
					dcb $8D,$8D,$8D,$8D,$8D,$8D

SUB_GFX_HEAD		JSR GET_DRAW_INFO
					LDA #$40
					TAY
					STA $15EA,x
					LDA $1570,x
					LSR A
					LSR A
					AND #$07
					ASL A
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$05
HEAD_LOOP			PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HEAD_HORZ,x
					STA $0200,y
					LDA $01
					CLC
					ADC HEAD_VERT,x
					STA $0201,y
					LDA HEAD_TILE,x
					STA $0202,y
					LDA HEAD_PROP,x
					ORA $64
					STA $0203,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL HEAD_LOOP
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS


BODY_HORZ			dcb $F8,$08,$F8,$08
BODY_VERT			dcb $FC,$FC,$0C,$0C
BODY_TILE			dcb $8A,$8A,$AA,$AA
BODY_PROP			dcb $0D,$4D,$0D,$4D

SUB_GFX_BODY		JSR GET_DRAW_INFO
					PHX
					LDX #$03
BODY_LOOP			LDA $00
					CLC
					ADC BODY_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC BODY_VERT,x
					STA $0301,y
					LDA BODY_TILE,x
					STA $0302,y
					LDA BODY_PROP,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL BODY_LOOP
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3
                    RTS


MI_TILE				dcb $84,$86
MI_HORZ				dcb $F8,$08
SUB_GFX_MI			JSR GET_DRAW_INFO
					PHX
					LDX #$01
MI_LOOP				LDA $00
					CLC
					ADC MI_HORZ,x
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA MI_TILE,x
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL MI_LOOP
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS 




TILEMAP             dcb $80,$82,$A0,$A2,$C0,$C2,$88,$E0
					dcb $80,$82,$A0,$A2,$C0,$C2,$A4,$E2
					dcb $80,$82,$A0,$A2,$C0,$C2,$A6,$B2
					dcb $80,$82,$A0,$A2,$C0,$C2,$A8,$B2
					dcb $8C,$8E,$CC,$AE,$C0,$CE,$B2,$B2
					dcb $8C,$8E,$CC,$AE,$C0,$CE,$B2,$E0
					dcb $8C,$8E,$CC,$AE,$C0,$CE,$B2,$E2
					
HORZ_DISP			dcb $F8,$08,$F8,$08,$F8,$08,$08,$00
					
VERT_DISP			dcb $E0,$E0,$F0,$F0,$00,$00,$F8,$10
					

SUB_GFX             JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					STA $02
					LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$07
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP,x
					STA $0302,y
					PLX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07
                    JSL $01B7B3
                    RTS                     ; return
					
DICE_TILE			dcb $04,$06,$24,$26;#2
					dcb $6C,$6E,$4C,$4E
					dcb $44,$46,$24,$2A;#6
					dcb $60,$62,$40,$42
					dcb $40,$42,$60,$62;#5
					dcb $28,$2A,$08,$0A
					dcb $00,$02,$20,$22;#1
					dcb $20,$22,$00,$02
					dcb $4C,$4E,$6C,$6E;#4
					dcb $24,$26,$04,$06
					dcb $08,$0A,$28,$2A;#3
					dcb $24,$26,$44,$46
					dcb $44,$46,$24,$2A;#6
					dcb $20,$22,$00,$02
					dcb $00,$02,$20,$22;#1
					dcb $60,$62,$40,$42
					
DICE_HORZ			dcb $F8,$08,$F8,$08
DICE_VERT			dcb $F8,$F8,$08,$08

SUB_GFX_DICE		JSR GET_DRAW_INFO
					LDA $1570,x
					LSR A
					LSR A
					AND #$0F
					STA $03
					ASL A
					ASL A
					STA $02
					LDA $03
					AND #$01
					STA $03
					LDA $151C,x
					TAY
					STA $15EA,x
					PHX
					LDX #$03
LOOP_DICE           PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA DICE_TILE,x
					STA $0202,y
					PLX
					LDA $00
					CLC
					ADC DICE_HORZ,x
					STA $0200,y
					LDA $01
					CLC
					ADC DICE_VERT,x
					STA $0201,y
					LDA #$03
					ORA $64
					STA $0203,y
					LDA $03
					BEQ SUB_GFX_DICE_2
					LDA $0203,y
					ORA #$80
					STA $0203,y
SUB_GFX_DICE_2		INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_DICE          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
