;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Lesalesa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					;XvCgExGFXw\
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$F0
					STA $D8,x
					LDA #$00
					STA $14D4,x
					LDA #$D0
					STA $E4,x
					LDA #$00
					STA $14E0,x
					
					LDA #$03 ;#Nbp[h
					STA $C2,x
					LDA #$26
					STA $7FFFDD ;BG1pGFX^Cw
					JSL $03DD7D
					LDA #$10
					STA $38
					STA $39
					LDA #$01
					STA $157C,x
					LDA #$FF
					STA $15AC,x
					JSR HDMA_COLOR
					LDA #$03
					STA $1602,x
					LDA #$A8
					STA $36
					LDA #$01
					STA $37
					LDA #$1E
					STA $1DFB
					LDA #$00
					STA $7FDFA0
					LDA #$40
					STA $7FDFA1
					RTL 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
					RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE1				dcb $04,$03,$02,$01,$00,$01,$02,$03,$04,$05,$06,$07,$07,$07,$07,$07,$07,$07,$07,$07
TABLE2				dcb $00,$00,$00,$08,$10,$14,$14,$16,$16,$18,$18,$17,$16,$16,$17,$18,$18,$17,$14,$10
					dcb $0C,$08,$04,$00,$A0,$07
BOWSER_R			RTS
START_HB_CODE		LDA $1504,x
					BNE MAIN0
					JSR MAIN
					RTS
MAIN0				CMP #$01
					BNE MAIN1
					JSR OPTION
					RTS 
MAIN1				CMP #$02
					BNE MAIN2
					JSR PUTI
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR PUTI2
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR STAR
					RTS
MAIN4				CMP #$05
					BNE MAIN5
					JSR ENE
					RTS
MAIN5				CMP #$06
					BNE MAIN6
					JSR JR
					RTS
MAIN6				JSR JR
					RTS
					
MAIN				LDA $7FFF80
					BNE MAIN_10
					INC A
					STA $7FFF80
					JSR GFX_LOAD
MAIN_10				JSR GET_DRAW_INFO
					JSR BACK_GROUND ;wipXvCg̕`ł
					JSR POS_OFFSET
					LDA #$90
					STA $2A
					LDA #$C8
					STA $2C
					JSR GRAPHIC_ROUTINE
					JSR GRAPHIC0 ;Nbp̃OtBbNwł
					JSR SUB_GFX
					LDA $9D
					BNE BOWSER_R
					JSL $018022		;x speed
					JSL $01801A		;y speed
					JSR MODE_DO
					LDA $16
					ORA $18
					BEQ MAIN_R
					LDA $7FDD00
					INC A
					STA $7FDD00
MAIN_R				RTS

ENE					JSR SUB_GFX_ENE
					LDA $9D
					BNE ENE_R
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $15AC,x
					BNE ENE_R
					STZ $14C8,x
ENE_R				RTS
					
OPTION				JSR SUB_GFX_OP
					LDA $9D
					BNE OPTION_R
					STZ $14E0,x
					JSL $018022
					JSL $01A7DC
					LDA $1570,x
					BNE OPTION_4
					LDA $15AC,x
					BNE OPTION_1
					LDA $1540,x
					CMP #$FE
					BEQ OPTION_2
					RTS
OPTION_1			LDA #$F0
					STA $AA,x
					JSL $01801A
OPTION_R			RTS
OPTION_2			LDA #$01
					STA $1570,x
					STZ $1540,x
					LDA $94
					AND #$FC
					STA $151C,x
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCS OPTION_3
					LDA #$E8
					STA $B6,x
					RTS
OPTION_3			LDA #$18
					STA $B6,x
					RTS
OPTION_4			LDA $1540,x
					BNE OPTION_5
					LDA $E4,x
					AND #$FC
					CMP $151C,x
					BNE OPTION_R
					STZ $B6,x
					LDA #$FF
					STA $1540,x
OPTION_7			STZ $AA,x
					RTS
OPTION_5			CMP #$E0
					BCS OPTION_R
					CMP #$C0
					BCS OPTION_6
					CMP #$90
					BCS OPTION_7
					CMP #$70
					BCS OPTION_8
					STZ $AA,x
					STZ $1540,x
					STZ $1570,x
					RTS
OPTION_6			LDA #$E0
					STA $AA,x
					JSL $01801A
					RTS
OPTION_8			LDA #$20
					STA $AA,x
					JSL $01801A
					RTS

PUTI_SPEED			dcb $10,$F0
PUTI				JSR SUB_GFX_PT
					LDA $9D
					BNE PTI_R
					JSL $01A7DC
					LDA $1602,x
					STA $B6,x
					JSL $01802A
					LDA $1588,x
					AND #$04
					BNE PUTI_3
					LDA $AA,x
					BPL PUTI_2
PTI_R				RTS
PUTI_2				LDA #$10
					STA $AA,x
					INC $1570,x
					TXA
					ASL A
					ASL A
					ASL A
					CLC
					ADC $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA PUTI_SPEED,y
					STA $1602,x
					RTS
PUTI_3				JSR SUB_SMOKE
					LDA #$03
					STA $1504,x
					STZ $B6,x
					RTS
					
PUTI2_SPEED			dcb $18,$E8
PUTI2				JSR SUB_GFX_P
					LDA $9D
					BNE PTI2_R
					JSL $01A7DC
					JSL $01802A
					LDA $14E0,x
					BEQ PUTI2_0
					STZ $14C8,x
					RTS
PUTI2_0				INC $1570,x
					TXA
					STA $03
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					CLC
					ADC $03
					AND #$03
					STA $1602,x
					LDA $1588,x
					AND #$04
					BEQ PTI2_AIR
					LDA $1540,x
					BNE PTI2_2
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					STA $157C,x
					TAY
					LDA PUTI2_SPEED,y
					STA $B6,x
					LDA #$E8
					STA $AA,x
PTI2_R				RTS
PTI2_2				STZ $B6,x
					RTS
PTI2_AIR			TXA
					ASL A
					CLC
					ADC #$08
					STA $1540,x
					RTS
					
STAR				JSR SUB_GFX_ST
					LDA $15AC,x
					BNE STAR_R
					STZ $14C8,x
STAR_R				RTS


JR					LDA $9D
                    BNE LABEL92
LABEL92				JSR JR_MOVE
					LDA $151C,x
					AND #$01
					STA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30
                    LDA $00
                    CLC
                    ADC.W #$0080
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06
                    SEP #$30
                    LDX $15E9
                    LDA $04
                    STA $4202
                    LDA $187B,x
                    LDY $05
                    BNE LABEL93
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $187B,x
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
					LDA $1504,x
					CMP #$07
					BEQ LABEL1034
					JSR SUB_GFX_JR
					JSR JR_DAMAGE
					BRA LABEL1035
LABEL1034			JSR SUB_GFX_JRENE
					JSL $01A7DC
					LDA $15AC,x
					BNE LABEL1035
					STZ $14C8,x
LABEL1035			PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE_DO				LDA $151C,x
					BNE MODE_DO_1
					JSR MODE0
					RTS
MODE_DO_1			CMP #$01
					BNE MODE_DO_2
					JSR MODE1
					RTS
MODE_DO_2			CMP #$02
					BNE MODE_DO_3
					JSR MODE2
					RTS
MODE_DO_3			CMP #$03
					BNE MODE_DO_4
					JSR MODE3
					RTS
MODE_DO_4			CMP #$04
					BNE MODE_DO_5
					JSR MODE4
					RTS
MODE_DO_5			CMP #$05
					BNE MODE_DO_6
					JSR MODE5
					RTS
MODE_DO_6			CMP #$06
					BNE MODE_DO_7
					JSR MODE6
					RTS
MODE_DO_7			CMP #$07
					BNE MODE_DO_8
					JSR MODE7
					RTS
MODE_DO_8			JSR MODE8
					RTS



MODE0_TABLE			dcb $03,$00,$02,$00

MODE0				JSR DAMAGE_CHECK
					LDA $15AC,x
					BEQ MODE0_3
					CMP #$FD
					BEQ MODE0_1
					BCS MODE0_R
					CMP #$BF
					BCC MODE0_2
					STZ $B6,x
					LDA #$FC
					STA $AA,x
					LDA $D8,x
					CMP #$60
					BCC MODE0_0
					LDA #$C0
					STA $15AC,x
					RTS
MODE0_1				JSR HDMA_COLOR2
					RTS
MODE0_2				STZ $AA,x
					LDA $36
					BNE MODE0_4
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAY
					LDA MODE0_TABLE,y
					STA $1602,x
					RTS
MODE0_3				LDA #$01
					STA $151C,x
					LDA #$03
					STA $1602,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE0_4				REP #$30
					LDA.W $36
					INC A
					INC A
					STA.W $36
					SEP #$30
MODE0_R				RTS
MODE0_0				LDA #$BF
					STA $15AC,x
					JSR GEN_SPRITE
					TYA
					STA $7FDF80
					LDA #$00
					STA $1662,y
					LDA #$01
					STA $1504,y
					LDA #$B0
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$E0
					STA $00D8,y
					LDA #$10
					STA $15AC,y
					JSR GEN_SPRITE
					TYA
					STA $7FDF81
					LDA #$00
					STA $1662,y
					LDA #$01
					STA $1504,y
					LDA #$50
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$E0
					STA $00D8,y
					LDA #$10
					STA $15AC,y
					LDA #$21
					STA $1DFB
					RTS
					
MODE1_8				LDA $157C,x
					BEQ MODE1_2_2
MODE1_8_2			REP #$30
					LDA.W $36
					DEC A
					DEC A
					STA.W $36
					SEP #$30
					RTS
MODE1_2				LDA $157C,x
					BEQ MODE1_8_2
MODE1_2_2			REP #$30
					LDA.W $36
					INC A
					INC A
					STA.W $36
					SEP #$30
					RTS
MODE1				JSR DAMAGE_CHECK
					LDA $15AC,x
					CMP #$F0
					BCS MODE1_2
					CMP #$E8
					BCS MODE1_3
					CMP #$E0
					BCS MODE1_4
					CMP #$C0
					BCS MODE1_5_0
					CMP #$B0
					BCS MODE1_2
					CMP #$A8
					BCS MODE1_3
					CMP #$A0
					BCS MODE1_4
					CMP #$80
					BCS MODE1_6
					CMP #$70
					BCS MODE1_2
					CMP #$68
					BCS MODE1_3
					CMP #$60
					BCS MODE1_4
					CMP #$40
					BCS MODE1_7
					CMP #$10
					BCS MODE1_8
					LDA $14
					AND #$03
					BNE MODE1_R
					INC $1570,x
					LDA $1570,x
					CMP #$50
					BCC MODE1_R
					LDA #$02
					STA $151C,x
					STZ $1570,x
					LDA #$FF
					STA $15AC,x
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					BEQ MODE1_R
					LDA #$04
					STA $151C,x
MODE1_R				RTS
MODE1_3				INC $38
					INC $38
					RTS
MODE1_4				DEC $38
					DEC $38
					RTS
MODE1_5_0			BRA MODE1_5
MODE1_6				CMP #$9C
					BEQ MODE1_5_2
					CMP #$98
					BEQ MODE1_5_3
					CMP #$88
					BEQ MODE1_5_2
					CMP #$84
					BEQ MODE1_5_1
					RTS
MODE1_7				CMP #$5C
					BEQ MODE1_5_2
					CMP #$58
					BEQ MODE1_5_3
					CMP #$48
					BEQ MODE1_5_2
					CMP #$44
					BEQ MODE1_5_1
					RTS
MODE1_5				CMP #$DC
					BEQ MODE1_5_2
					CMP #$D8
					BEQ MODE1_5_3
					CMP #$C8
					BEQ MODE1_5_2
					CMP #$C4
					BEQ MODE1_5_1
					RTS
MODE1_5_1			LDA #$03
					STA $1602,x
					RTS
MODE1_5_2			STZ $1602,x
					RTS
MODE1_5_3			LDA #$02
					STA $1602,x
					JSR MODE1_G
					RTS
					RTS
					
					
MODE2_TABLE			dcb $FC,$04
MODE2				JSR DAMAGE_CHECK
					LDA $15AC,x
					CMP #$C0
					BCS MODE2_1
					CMP #$B0
					BCS MODE2_0
					CMP #$00
					BCS MODE2_3
					RTS
MODE2_0				STZ $B6,x
					RTS
MODE2_1				LDY $157C,x
					LDA MODE2_TABLE,y
					STA $B6,x
					LDA $157C,x
					BEQ MODE2_2
					REP #$30
					LDA.W $36
					DEC A
					DEC A
					STA.W $36
					SEP #$30
					RTS
MODE2_2				REP #$30
					LDA.W $36
					INC A
					INC A
					STA.W $36
					SEP #$30
MODE2_R				RTS
MODE2_3				JSR PTI_DEL1
					LDA $157C,x
					BEQ MODE2_4
					LDA $E4,x
					CMP #$10
					BCC MODE2_3_2
					LDA $B6,x
					CMP #$D0
					BEQ MODE2_R
					CMP #$02
					BEQ MODE2_3_3
					DEC $B6,x
					LDA $B6,x
					BMI MODE2_R
					REP #$30
					LDA.W $36
					CLC
					ADC.W #$0004
					STA.W $36
					SEP #$30
					RTS
MODE2_3_2			LDA #$10
					STA $1DFC
					LDA #$40
					STA $1887
					LDA #$10
					STA $B6,x
					JSR PTI_DEL2
					RTS
MODE2_3_3			STZ $B6,x
					LDA #$03
					STA $151C,x
					LDA #$10
					STA $15AC,x
					STZ $36
					STZ $37
					RTS
MODE2_4				LDA $E4,x
					CMP #$E0
					BCS MODE2_4_2
					LDA $B6,x
					CMP #$30
					BEQ MODE2_R2
					CMP #$FE
					BEQ MODE2_4_3
					INC $B6,x
					LDA $B6,x
					BPL MODE2_R2
					REP #$30
					LDA.W $36
					SEC
					SBC.W #$0004
					STA.W $36
					SEP #$30
MODE2_R2			RTS
MODE2_4_2			LDA #$10
					STA $1DFC
					LDA #$40
					STA $1887
					LDA #$F0
					STA $B6,x
					JSR PTI_DEL2
					RTS
MODE2_4_3			STZ $B6,x
					LDA #$03
					STA $151C,x
					STZ $1570,x
					LDA #$10
					STA $15AC,x
					STZ $36
					STZ $37
					RTS
					
MODE3				LDA $1540,x
					BNE MODE3_3
					LDA $15AC,x
					BNE MODE3_2
MODE3_R2			STZ $AA,x
					JSR JUMP_CHECK
MODE3_R				RTS
MODE3_2				INC $39
					LDA #$20
					STA $AA,x
					LDA $15AC,x
					CMP #$01
					BNE MODE3_R
					JSR GEN_SPRITE
					LDA #$80
					STA $15AC,y
					LDA #$04
					STA $1504,y
					LDA $E4,x
					CLC
					ADC #$08
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$20
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$81
					STA $167A,x
					LDA #$F0
					STA $1540,x
					RTS
MODE3_3				CMP #$70
					BCS MODE3_R2
					CMP #$60
					BCS MODE3_4
					CMP #$30
					BEQ MODE3_5
					CMP #$28
					BEQ MODE3_6
					CMP #$20
					BEQ MODE3_7
					CMP #$02
					BEQ MODE3_8
					STZ $AA,x
					LDA #$10
					STA $39
					LDA #$60
					STA $D8,x
					RTS
MODE3_4				DEC $39
					LDA #$E0
					STA $AA,x
					RTS
MODE3_5				LDA #$01
					STA $1602,x
					RTS
MODE3_6				LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
MODE3_7				LDA #$03
					STA $1602,x
					RTS
MODE3_8				LDA #$FF
					STA $15AC,x
					STZ $1570,x
					STZ $1540,x
					LDA #$01
					STA $167A,x
					LDA #$01
					STA $151C,x
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					BEQ MODE3_R3
					LDA #$05
					STA $151C,x
MODE3_R3			RTS
					
					
MODE4_TABLE			dcb $FC,$04
MODE4				JSR DAMAGE_CHECK
					LDA $1570,x
					BNE MODE4_7
					LDA $15AC,x
					CMP #$C0
					BCS MODE4_1
					CMP #$B0
					BCS MODE4_0
					CMP #$80
					BCS MODE4_3
					CMP #$10
					BEQ MODE4_6
					JSR PTI_DEL1
					LDA $B6,x
					BEQ MODE4_R
					LDA $157C,x
					BEQ MODE4_5
					INC $B6,x
					RTS
MODE4_5				DEC $B6,x
					RTS
MODE4_0				STZ $B6,x
					RTS
MODE4_1				LDY $157C,x
					LDA MODE4_TABLE,y
					STA $B6,x
					LDA $157C,x
					BEQ MODE4_2
					REP #$30
					LDA.W $36
					DEC A
					DEC A
					STA.W $36
					SEP #$30
					RTS
MODE4_2				REP #$30
					LDA.W $36
					INC A
					INC A
					STA.W $36
					SEP #$30
MODE4_R				RTS
MODE4_3				JSR PTI_DEL1
					LDA $157C,x
					BEQ MODE4_4
					LDA $B6,x
					CMP #$D0
					BEQ MODE4_R
					DEC $B6,x
					RTS
MODE4_4				LDA $B6,x
					CMP #$30
					BEQ MODE4_R
					INC $B6,x
					RTS
MODE4_6				INC $1570,x
					RTS
MODE4_7				LDA $157C,x
					BEQ MODE4_7_2
					LDA $1540,x
					BEQ MODE4_7_1
					CMP #$C0
					BCS MODE4_7_4_0
					STZ $1540,x
					STZ $36
					STZ $37
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
					LDA #$01
					STA $151C,x
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					BEQ MODE4_R3
					LDA #$05
					STA $151C,x
MODE4_R3			RTS
MODE4_7_1			LDA #$10
					STA $B6,x
					LDA $E4,x
					CMP #$D0
					BCC MODE4_R
					JSR PTI_DEL2
					LDA #$FF
					STA $1540,x
					STZ $B6,x
					RTS
MODE4_7_4_0			BRA MODE4_7_4
MODE4_7_2			LDA $1540,x
					BEQ MODE4_7_3
					CMP #$C0
					BCS MODE4_7_5_0
					STZ $1540,x
					STZ $36
					STZ $37
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
					LDA #$01
					STA $151C,x
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					BEQ MODE4_R3
					LDA #$05
					STA $151C,x
					RTS
MODE4_7_5_0			BRA MODE4_7_5
MODE4_7_3			LDA #$F0
					STA $B6,x
					LDA $E4,x
					CMP #$10
					BCS MODE4_R4
					JSR PTI_DEL2
					LDA #$FF
					STA $1540,x
					STZ $B6,x
MODE4_R4			RTS
MODE4_7_4			REP #$30
					LDA.W $36
					INC A
					INC A
					STA.W $36
					SEP #$30
					RTS
MODE4_7_5			REP #$30
					LDA.W $36
					DEC A
					DEC A
					STA.W $36
					SEP #$30
					RTS

MODE5				JSR DAMAGE_CHECK
					LDA $15AC,x
					CMP #$F0
					BEQ MODE5_1
					CMP #$80
					BEQ MODE5_2
					CMP #$01
					BEQ MODE5_3
					RTS
MODE5_1				LDA $7FDF80
					TAY
					LDA #$FF
					STA $1540,y
					RTS
MODE5_2				LDA $7FDF81
					TAY
					LDA #$FF
					STA $1540,y
MODE5_R				RTS
MODE5_3				LDA #$02
					STA $151C,x
					STZ $1570,x
					LDA #$FF
					STA $15AC,x
					JSL $01ACF9
					CLC
					ADC $7FDD00
					AND #$01
					BEQ MODE5_R
					LDA #$04
					STA $151C,x
					RTS
					
MODE6_B				;DEC $38
					;DEC $39
					;LDA $38
					;CMP #$10
					;BNE MODE6_R4
					STZ $1570,x
					LDA #$07
					STA $151C,x
					STZ $157C,x
					STZ $1570,x
					LDA #$60
					STA $15AC,x
					STZ $C2,x
					LDA #$01
					STA $167A,x
					STZ $1528,x
					STZ $15F6,x
					RTS
MODE6_A				LDA #$10
					STA $B6,x
					LDA $E4,x
					CMP #$68
					BNE MODE6_R4
					INC $1570,x
					STZ $B6,x
MODE6_R4			RTS
MODE6				LDA $1570,x
					CMP #$01
					BEQ MODE6_A
					CMP #$02
					BEQ MODE6_B
					LDA $1540,x
					BNE MODE6_5_0
					LDA $15AC,x
 					CMP #$CO
					BCS MODE6_R
					CMP #$80
					BCS MODE6_2
					CMP #$5F
					BCS MODE6_R
					CMP #$5E
					BEQ MODE6_3
					CMP #$30
					BCS MODE6_4
					CMP #$2E
					BEQ MODE6_1
					RTS
MODE6_1				STZ $AA,x
					LDA #$FF
					STA $1540,x
					LDA #$20
					STA $38
					STA $39
					JSR HDMA_COLOR3
					LDA #$01
					STA $7FDFA0
					LDA #$18
					STA $E4,x
					LDA #$F1
					STA $D8,x
					LDA #$FF
					STA $14D4,x
					LDA #$00
					STA $14E0,x
					LDA #$05
					STA $1602,x
MODE6_R				RTS
MODE6_5_0			BRA MODE6_5
MODE6_2				INC $38
					INC $38
					INC $39
					INC $39
					RTS
MODE6_4				LDA #$18
					STA $AA,x
					RTS
MODE6_3				LDA #$04
					STA $1602,x
					LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSR SUB_SMOKE
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
MODE6_R2			RTS
MODE6_5				CMP #$40
					BCS MODE6_6
					LDA #$10
					STA $1540,x
					BRA MODE6_7
MODE6_6				LDA $7FDFA1
					BEQ MODE6_R2
MODE6_8				LDA $14
					AND #$01
					BEQ MODE6_R2
					LDA $7FDFA1
					DEC A
					STA $7FDFA1
					RTS
MODE6_7				LDA $7FDFA1
					CMP #$D0
					BEQ MODE6_9
					LDA #$02
					STA $7FDFA0
					BRA MODE6_8
MODE6_9				LDA #$03
					STA $7FDFA0
					LDA #$01
					STA $1570,x
					LDA #$23
					STA $1DFB
					RTS
					
MODE7_TABLE			dcb $21,$21,$74,$74,$53,$21,$53,$21
MODE7				LDA $C2,x
					BNE MODE7_2
					LDA $1540,x
					CMP #$C0
					BCS MODE7_R
					CMP #$80
					BCS MODE7_3
					JSR SUB_MODE7
					LDA $15AC,x
					BNE MODE7_R
					LDA #$50
					STA $15AC,x
					JSL $01ACF9
					SEC
					SBC $94
					AND #$07
					TAY
					LDA MODE7_TABLE,y
					STA $7FFF9E
					JSR GEN_NORMAL
					INC $1570,x
					LDA $1570,x
					CMP #$08
					BCC MODE7_R
					INC $C2,x
					STZ $1570,x
					LDA #$FF
					STA $1540,x
					STA $15AC,x
					STZ $B6,x
MODE7_R				RTS
MODE7_3				REP #$20
					INC $36
					INC $36
					INC $36
					INC $36
					SEP #$20
					RTS
MODE7_2				CMP #$01
					BNE MODE7_4
					JSR DAMAGE_CHECK
					LDA $1540,x
					CMP #$C0
					BCS MODE7_R
					CMP #$80
					BCS MODE7_3
					CMP #$40
					BCS MODE7_R
					JSR SUB_MODE7
					JSR MODE7_MOVE
					JSR MODE7_GEN
					JSR BLOCK_CHECK
					LDA $C2,x
					CMP #$02
					BEQ MODE7_R
					LDA $1570,x
					CMP #$08
					BCC MODE7_R
					LDA $14D4,x
					BEQ MODE7_R
					LDA $D8,x
					CMP #$F4
					BCS MODE7_R
					STZ $B6,x
					STZ $AA,x
					STZ $C2,x
					LDA #$F0
					STA $1540,x
					STZ $1570,x
					RTS
MODE7_4				LDA $15AC,x
					BNE MODE7_R
					LDA #$20
					STA $AA,x
					LDA $14D4,x
					BNE MODE7_R
					LDA $D8,x
					CMP #$E0
					BCC MODE7_R
					STZ $AA,x
					LDA #$D0
					STA $7D
					REP #$20
					LDA $96
					CMP.W #$1000
					BCC MODE7_4_R
					CMP.W #$FFC0
					BCS MODE7_4_R
					SEP #$20
					LDA #$06
					STA $1602,x
					LDA #$0C
					STA $38
					STA $39
					INC $151C,x
					LDA #$70
					STA $E4,x
					STZ $C2,x
					LDA #$00
					STA $7FE200
					STA $7FE300
					JSR COLOUR_CHANGE
MODE7_4_R			SEP #$20
					RTS

MODE8				LDA $C2,x
					BNE MODE8_1
					LDA #$F0
					STA $AA,x
					STZ $7D
					LDA #$80
					LDA $D8,x
					CMP #$51
					BCS MODE8_R
					LDA #$50
					STA $D8,x
					STZ $AA,x
					INC $C2,x
MODE8_R				RTS
MODE8_1				JSR MARIO_POS
					LDA $C2,x
					CMP #$01
					BEQ MODE8_R
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JR_DAMAGE			LDA $1558,x
					BNE RETURN4956
					LDA $1594,x
					CMP #$06
					BCS RETURN4956
					JSL $01A7DC
					BCC RETURN4956
					LDA $7D
					BMI JR_WIN
					CMP #$10
					BCC JR_WIN
					LDA #$28
					STA $1DFC
					INC $1594,x
					LDA #$80
					STA $1558,x
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA $1594,x
					CMP #$05
					BCC RETURN4956
					LDA #$06
					STA $1594,x
					LDA #$1E
					STA $1DFB
					LDA #$80
					STA $15AC,x
					JSR SUB_SMOKE
					JSR JR_ENE_DEL
RETURN4956			RTS
JR_WIN				LDA $1497
					BNE RETURN4956
					JSL $00F5B7 ;hurt mario
					RTS
JR_ENE_DEL			LDY #$00
JR_ENE_DEL_1		LDA $14C8,y
					BEQ JR_ENE_DEL_2
					LDA $1504,y
					CMP #$07
					BNE JR_ENE_DEL_2
					LDA #$00
					STA $14C8,y
JR_ENE_DEL_2		INY
					CPY #$0A
					BCC JR_ENE_DEL_1
					RTS

LABEL452			LDA $15AC,x
					BNE RETURN453
					JSR TELEPORT
RETURN453			RTS
JR_MOVE				LDA $9D
					BNE RETURN453
					LDA $1594,x
					CMP #$06
					BCS LABEL452
					LDA $1602,x
					SEC
					SBC $7FFD80
					STA $1602,x
					LDA $151C,x
					SBC $7FFD81
					STA $151C,x
					LDA $1504,x
					CMP #$07
					BEQ JR_MOVE_0
					LDA $C2,x
					BNE JR_GENE
					JSR JR_DIR_CHANGE
JR_MOVE_0			LDA $157C,x
					BNE JR_MOVE2
					LDA $1602,x
					CLC
					ADC $1594,x
                    STA $1602,x
                    LDA $151C,x
                    ADC #$00
                    AND #$01
                    STA $151C,x
					RTS
JR_MOVE2			LDA $1602,x
					SEC
					SBC $1594,x
					STA $1602,x
					LDA $151C,x
					SBC #$00
					AND #$01
					STA $151C,x
					RTS
JR_GENE				LDA $15AC,x
					BEQ JR_GENE4
					CMP #$60
					BEQ JR_GENE1
					CMP #$40
					BEQ JR_GENE2
					CMP #$20
					BEQ JR_GENE3
					RTS
JR_GENE4			LDA #$FF
					STA $15AC,x
					STZ $C2,x
					JSR JR_DIR_CHANGE_1
					RTS
JR_GENE1			JSR SUB_JR_GENE
					LDA #$03
					STA $1594,y
					RTS
JR_GENE2			LDA $157C,x
					EOR #$01
					STA $157C,x
					JSR SUB_JR_GENE
					LDA #$01
					STA $00C2,y
					LDA #$04
					STA $1594,y
					RTS
JR_GENE3			LDA $157C,x
					EOR #$01
					STA $157C,x
					JSR SUB_JR_GENE
					LDA #$02
					STA $00C2,y
					LDA #$05
					STA $1594,y
					RTS
					
SUB_JR_GENE			JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$00
					STA $1662,y
					LDA $157C,x
					STA $157C,y
					LDA #$C0
					STA $15AC,y
					LDA $1602,x
					STA $1602,y
					LDA $151C,x
					STA $151C,y
					LDA #$78
					STA $00E4,y
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$48
					STA $187B,y
					LDA #$17
					STA $1DFC
					RTS

JR_DIR_CHANGE		LDA $15AC,x
					BEQ JR_DIR_CHANGE_2
					CMP #$C0
					BEQ JR_DIR_CHANGE_1
					CMP #$80
					BEQ JR_DIR_CHANGE_1
					CMP #$40
					BEQ JR_DIR_CHANGE_1
					BRA RETURN395
JR_DIR_CHANGE_2		INC $C2,x
					LDA #$80
					STA $15AC,x
					RTS
JR_DIR_CHANGE_1		STZ $157C,x
					LDA $151C,x
					BNE RETURN395
					INC $157C,x
RETURN395			RTS
					
COLOUR_CHANGE_TBL	dcb $F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC
COLOUR_CHANGE_TBL2	dcb $80,$D2,$A0,$1F,$B9,$B5,$5F,$E0,$1F,$7C,$BE,$FF
COLOUR_CHANGE_TBL3	dcb $01,$10,$02,$11,$01,$36,$02,$03,$27,$4B,$63,$7F
COLOUR_CHANGE		LDY #$00
COLOUR_CHANGE_LP	LDA COLOUR_CHANGE_TBL,y
					STA $2121
					LDA COLOUR_CHANGE_TBL2,y
					STA $2122
					LDA COLOUR_CHANGE_TBL3,y
					STA $2122
					INY
					CPY #$0C
					BCC COLOUR_CHANGE_LP
					RTS

MARIO_POS			LDA $C2,x
					CMP #$01
					BEQ MARIO_POS_1
					REP #$20
					LDA.W #$0078
					SEC
					SBC $94
					STA $7FFD80
					CLC
					ADC $36
					STA $36
					SEP #$20
					
MARIO_POS_1			LDA #$78
					STA $94
					LDA $97
					BNE MARIO_POS_R
					LDA $96
					CMP #$28
					BCC MARIO_POS_R
					LDA #$28
					STA $96
					LDA #$01     
                    STA $1471
					LDA $C2,x
					CMP #$01
					BNE MARIO_POS_R
					LDA #$24
					STA $1DFB
					INC $C2,x
					JSR GEN_SPRITE
					LDA #$06
					STA $1504,y
					LDA #$78
					STA $00E4,y
					LDA #$88
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$70
					STA $15AC,y
					LDA #$00
					STA $1662,y
					LDA #$81
					STA $167A,y
					LDA #$50
					STA $187B,y
					LDA #$01
					STA $1594,y
					JSR GFX_LOAD2
MARIO_POS_R			RTS
						
TELEPORT			LDA #$52
					STA $19B8
					LDA #$05
					STA $19D8
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS


BLOCK_CHECK			STX $0D
					LDA $E4,x
					SEC
					SBC #$10
					STA $00
					LDA $14E0,x
					SBC #$00
					STA $01
					LDA $D8,x
					CLC
					ADC #$20
					STA $02
					LDA $14D4,x
					ADC #$00
					STA $03
					PHX
					LDX #$00
BLOCK_CHECK_LP		LDA $14C8,x
					CMP #$09
					BCC BLOCK_CHECK_2
					LDA $9E,x
					CMP #$53
					BNE BLOCK_CHECK_2
					LDA $E4,x
					STA $04
					LDA $14E0,x
					STA $05
					LDA $D8,x
					STA $0E
					LDA $14D4,x
					STA $0F
					REP #$20
					LDA $04
					SEC
					SBC $00
					CMP.W #$0040
					BCS BLOCK_CHECK_2
					LDA $0E
					SEC
					SBC $02
					CMP.W #$0040
					BCS BLOCK_CHECK_2
					SEP #$20
					STZ $14C8,x
					LDA #$28
					STA $1DFC
					PHX
					LDX $0D
					INC $1528,x
					PLX
BLOCK_CHECK_2		SEP #$20
					INX
					CPX #$0A
					BCC BLOCK_CHECK_LP
					PLX
					LDA $1528,x
					CMP #$03
					BCC BLOCK_CHECK_R
					LDA #$1E
					STA $1DFB
					INC $C2,x
					STZ $AA,x
					STZ $B6,x
					LDA #$40
					STA $15AC,x
BLOCK_CHECK_R		RTS

MODE7_GEN			LDA $15AC,x
					BNE MODE7_GEN_R
					LDA #$50
					STA $15AC,x
					LDA #$09
					STA $1DFC
					LDA $1570,x
					INC $1570,x
					AND #$01
					BEQ MODE7_GEN_2
					JSR MODE7_GEN_G
					LDA #$30
					STA $00B6,y
					LDA #$00
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$D0
					STA $00B6,y
					LDA #$01
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$30
					STA $00AA,y
					LDA #$02
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$D0
					STA $00AA,y
					LDA #$03
					STA $1602,y
MODE7_GEN_R			RTS
MODE7_GEN_2			JSR MODE7_GEN_G
					LDA #$22
					STA $00B6,y
					LDA #$22
					STA $00AA,y
					LDA #$04
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$DE
					STA $00B6,y
					LDA #$22
					STA $00AA,y
					LDA #$05
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$22
					STA $00B6,y
					LDA #$DE
					STA $00AA,y
					LDA #$06
					STA $1602,y
					JSR MODE7_GEN_G
					LDA #$DE
					STA $00B6,y
					LDA #$DE
					STA $00AA,y
					LDA #$07
					STA $1602,y
					RTS

MODE7_GEN_G			JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$00
					STA $1662,y
					LDA #$80
					STA $15AC,y
					RTS
					

MODE7_SPEED			dcb $18,$E8
SUB_MODE7			LDA $157C,x
					TAY
					LDA MODE7_SPEED,y
					STA $B6,x
					LDA $E4,x
					CMP #$08
					BCC SUB_MODE7_1
					CMP #$D8
					BCS SUB_MODE7_2
					RTS
SUB_MODE7_1			STZ $157C,x
					RTS
SUB_MODE7_2			LDA #$01
					STA $157C,x
					RTS
MODE7_MOVE			LDA $15F6,x
					TAY
					LDA MODE7_SPEED,y
					STA $AA,x
					LDA $14D4,x
					BEQ MODE7_MOVE_0
					LDA $D8,x
					CMP #$F2
					BCC MODE7_MOVE_1
					RTS
MODE7_MOVE_0		LDA $D8,x
					CMP #$90
					BCS MODE7_MOVE_2
					RTS
MODE7_MOVE_1		STZ $15F6,x
					RTS
MODE7_MOVE_2		LDA #$01
					STA $15F6,x
					RTS

POS_OFFSET			LDA $14E0,x
					CMP #$FF
					BEQ POS_OFFSET2
					CMP #$01
					BEQ POS_OFFSET3
					RTS
POS_OFFSET2			STZ $14E0,x
					STZ $E4,x
					RTS
POS_OFFSET3			STZ $14E0,x
					LDA #$FF
					STA $E4,x
					RTS
					
GFX_LOAD2			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0269 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$7800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSL $27DD40
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$026A ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$6800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSL $27DD40
					RTS



GFX_LOAD			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$021F ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$7000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSL $27DD40
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$021E ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$7800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSL $27DD40
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0001 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$6800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSL $27DD40
					RTS
					


MODE1_G_TABLE		dcb $00,$10,$20,$30
MODE1_G				LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					LDA $157C,x
					BNE MODE1_G_1
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
MODE1_G_1			JSR GEN_SPRITE
					LDA #$19
					STA $1686,y
					LDA #$02
					STA $1504,y
					LDA #$00
					STA $1662,y
					LDA #$90
					STA $00AA,y
					PHX
					LDA $15AC,x
					AND #$C0
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					TAX
					LDA MODE1_G_TABLE,x
					STA $1602,y
					PLX
					LDA $157C,x
					BEQ MODE1_G_R
					LDA #$00
					SEC
					SBC $1602,y
					STA $1602,y
MODE1_G_R			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

JUMP_CHECK			LDA $1570,x
					BNE JUMP_CHECK_R
					LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$28
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC JUMP_CHECK_2
					LDA $7D
					BMI JUMP_CHECK_2
					CMP #$10
					BCC JUMP_CHECK_2
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$28
                    STA $1DFC
					INC $1528,x
					LDA $1528,x
					CMP #$03
					BEQ JUMP_CHECK_3
					INC $1570,x
JUMP_CHECK_2		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
JUMP_CHECK_R		RTS
JUMP_CHECK_3		LDA #$1E
					STA $1DFB
					LDA $7FDF80
					TAY
					LDA #$00
					STA $14C8,y
					LDA $7FDF81
					TAY
					LDA #$00
					STA $14C8,y
					LDA #$06
					STA $151C,x
					LDA #$FF
					STA $15AC,x
					STZ $1540,x
					BRA JUMP_CHECK_2


DAMAGE_CHECK		LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$20
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
PTI_DEL1			LDA $E4,x
					AND #$F8
					STA $7FDDE4
					PHX
					LDX #$00
PTI_DEL1_L			LDA $14C8,x
					CMP #$08
					BNE PTI_DEL1_2
					LDA $1504,x
					CMP #$03
					BNE PTI_DEL1_2
					LDA $E4,x
					AND #$F8
					CMP $7FDDE4
					BNE PTI_DEL1_2
					STZ $14C8,x
					JSR SUB_SMOKE
PTI_DEL1_2			INX
					CPX #$0A
					BNE PTI_DEL1_L
					PLX
					RTS
					
PTI_DEL2			PHX
					LDX #$00
PTI_DEL2_L			LDA $14C8,x
					CMP #$08
					BNE PTI_DEL2_2
					LDA $1504,x
					CMP #$03
					BNE PTI_DEL2_2
					STZ $14C8,x
PTI_DEL2_2			INX
					CPX #$0A
					BNE PTI_DEL2_L
					PLX
					RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
					
DIREC_CHECK			LDA $1602,x
					STA $00
					LDA $151C,x
					STA $01
					REP #$20
					LDA $00
					CLC
					ADC.W #$0008
					LSR A
					LSR A
					LSR A
					LSR A
					SEP #$20
					AND #$1F
					STA $1570,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILE_ENE			dcb $AE,$AE,$EE,$EE,$CE,$CE,$CE,$CE
PROP_ENE			dcb $45,$05,$05,$85,$45,$05,$C5,$85
SUB_GFX_ENE			JSR GET_DRAW_INFO
					PHX
					LDA $1602,x
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILE_ENE,x
					STA $0302,y
					LDA PROP_ENE,x
					ORA $64
					STA $0303,y
					PLX
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					

PROP_JRENE			dcb $07,$05,$09
SUB_GFX_JRENE		JSR GET_DRAW_INFO
					PHX
					LDA $C2,x
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$66
					STA $0302,y
					LDA PROP_JRENE,x
					ORA $64
					STA $0303,y
					PLX
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP				dcb $20,$24,$24,$24
HORZ_DISP			dcb $F8,$F8,$F8,$F8
					dcb $18,$18,$18,$18
VERT_DISP			dcb $48,$58,$68,$78
PROPETIES			dcb $4D,$CD,$4D,$CD
					dcb $0D,$8D,$0D,$8D
					
SUB_GFX				JSR GET_DRAW_INFO
					LDA $7FDFA0
					BNE SUB_GFX_R
					LDA #$18
					TAY
					STA $15EA,x
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$03
					
LOOP_START			LDA TILEMAP,x           ; \ store tile
                    STA $0202,y
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0201,y             ; /
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					CLC
					ADC HORZ_DISP,x
                    STA $0200,y             ; /
                    LDA PROPETIES,x
                    ;ORA $64                 ; add in tile priority of level
                    STA $0203,y             ; store tile properties
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $28FCC0 ;# $200p̃OtBbN[`
SUB_GFX_R           RTS

					

					
TILEMAP_OP          dcb $26,$22,$22,$22,$22
VERT_DISP_OP        dcb $00,$10,$20,$30,$40
PROPETIES_OP		dcb $0D,$0D,$8D,$0D,$8D
					
SUB_GFX_OP			JSR GET_DRAW_INFO
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$04
LOOP_STARTOP        LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_OP,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_OP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
                    LDA PROPETIES_OP,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTOP
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILEMAP_JR			dcb $80,$82,$A0,$A2	;#
					dcb $C0,$C2,$E0,$E2 ;#11.25
					dcb $C4,$C6,$E4,$E6 ;#22.5
					dcb $C4,$C6,$E4,$E6 ;#33.75
					dcb $C8,$CA,$E8,$EA ;#45
					dcb $C8,$CA,$E8,$EA ;#56.25
					dcb $CC,$CE,$EC,$EE ;#67.5
					dcb $CC,$CE,$EC,$EE ;#78.75
					dcb $C0,$C2,$E0,$E2 ;#90
					dcb $8C,$8E,$AC,$AE ;#101.25
					dcb $8C,$8E,$AC,$AE ;#112.5
					dcb $88,$8A,$A8,$AA ;#123.75
					dcb $88,$8A,$A8,$AA ;#135
					dcb $84,$86,$A4,$A6 ;#146.25
					dcb $84,$86,$A4,$A6 ;#157.5
					dcb $80,$82,$A0,$A2 ;#168.75
					dcb $80,$82,$A0,$A2 ;#180
					dcb $C0,$C2,$E0,$E2 ;#191.25
					dcb $C4,$C6,$E4,$E6 ;#202.5
					dcb $C4,$C6,$E4,$E6 ;#213.75
					dcb $C8,$CA,$E8,$EA ;#225
					dcb $C8,$CA,$E8,$EA ;#236.25
					dcb $CC,$CE,$EC,$EE ;#247.5
					dcb $CC,$CE,$EC,$EE ;#258.75
					dcb $C0,$C2,$E0,$E2 ;#270
					dcb $8C,$8E,$AC,$AE ;#281.25
					dcb $8C,$8E,$AC,$AE ;#292.5
					dcb $88,$8A,$A8,$AA ;#303.75
					dcb $88,$8A,$A8,$AA ;#315
					dcb $84,$86,$A4,$A6 ;#326.25
					dcb $84,$86,$A4,$A6 ;#337.5
					dcb $80,$82,$A0,$A2 ;#348.75
					
					dcb $80,$82,$40,$42	;#
					dcb $C0,$C2,$E0,$6C ;#11.25
					dcb $C4,$C6,$E4,$4E ;#22.5
					dcb $C4,$C6,$E4,$6E ;#33.75
					dcb $C8,$CA,$E8,$0A ;#45
					dcb $C8,$CA,$E8,$2A ;#56.25
					dcb $CC,$0C,$EC,$0E ;#67.5
					dcb $CC,$2C,$EC,$2E ;#78.75
					dcb $C0,$C2,$4C,$E2 ;#90
					dcb $8C,$8E,$6A,$AE ;#101.25
					dcb $8C,$8E,$4A,$AE ;#112.5
					dcb $88,$8A,$68,$AA ;#123.75
					dcb $88,$8A,$48,$AA ;#135
					dcb $84,$86,$64,$A6 ;#146.25
					dcb $84,$86,$44,$46 ;#157.5
					dcb $80,$82,$60,$62 ;#168.75
					dcb $80,$82,$40,$42 ;#180
					dcb $C0,$C2,$E0,$6C ;#191.25
					dcb $C4,$C6,$E4,$4E ;#202.5
					dcb $C4,$C6,$E4,$6E ;#213.75
					dcb $C8,$CA,$E8,$0A ;#225
					dcb $C8,$CA,$E8,$2A ;#236.25
					dcb $CC,$0C,$EC,$0E ;#247.5
					dcb $CC,$2C,$EC,$2E ;#258.75
					dcb $C0,$C2,$4C,$E2 ;#270
					dcb $8C,$8E,$6A,$AE ;#281.25
					dcb $8C,$8E,$4A,$AE ;#292.5
					dcb $88,$8A,$68,$AA ;#303.75
					dcb $88,$8A,$48,$AA ;#315
					dcb $84,$86,$64,$A6 ;#326.25
					dcb $84,$86,$44,$46 ;#337.5
					dcb $80,$82,$60,$62 ;#348.75
					
					dcb $82,$80,$A2,$A0	;#
					dcb $82,$80,$A2,$A0 ;#11.25
					dcb $86,$84,$A6,$A4	;#22.5
					dcb $86,$84,$A6,$A4 ;#33.75
					dcb $8A,$88,$AA,$A8 ;#45
					dcb $8A,$88,$AA,$A8 ;#56.25
					dcb $8E,$8C,$AE,$AC ;#67.5
					dcb $8E,$8C,$AE,$AC ;#78.75
					dcb $E0,$E2,$C0,$C2 ;#90
					dcb $CE,$CC,$EE,$EC ;#101.25
					dcb $CE,$CC,$EE,$EC ;#112.5
					dcb $CA,$C8,$EA,$E8 ;#123.75
					dcb $CA,$C8,$EA,$E8 ;#135
					dcb $C6,$C4,$E6,$E4 ;#146.25
					dcb $C6,$C4,$E6,$E4 ;#157.5
					dcb $C2,$C0,$E2,$E0 ;#168.75
					dcb $82,$80,$A2,$A0 ;#180
					dcb $82,$80,$A2,$A0 ;#191.25
					dcb $86,$84,$A6,$A4 ;#202.5
					dcb $86,$84,$A6,$A4 ;#213.75
					dcb $8A,$88,$AA,$A8 ;#225
					dcb $8A,$88,$AA,$A8 ;#236.25
					dcb $8E,$8C,$AE,$AC ;#247.5
					dcb $8E,$8C,$AE,$AC ;#258.75
					dcb $E0,$E2,$C0,$C2 ;#270
					dcb $CE,$CC,$EE,$EC ;#281.25
					dcb $CE,$CC,$EE,$EC ;#292.5
					dcb $CA,$C8,$EA,$E8 ;#303.75
					dcb $CA,$C8,$EA,$E8 ;#315
					dcb $C6,$C4,$E6,$E4 ;#326.25
					dcb $C6,$C4,$E6,$E4 ;#337.5
					dcb $C2,$C0,$E2,$E0 ;#348.75
						
					dcb $82,$80,$42,$40	;#
					dcb $82,$80,$62,$60 ;#11.25
					dcb $86,$84,$46,$44 ;#22.5
					dcb $86,$84,$A6,$64 ;#33.75
					dcb $8A,$88,$AA,$48 ;#45
					dcb $8A,$88,$AA,$68 ;#56.25
					dcb $8E,$8C,$AE,$4A ;#67.5
					dcb $8E,$8C,$AE,$6A ;#78.75
					dcb $4C,$E2,$C0,$C2 ;#90
					dcb $2C,$CC,$2E,$EC ;#101.25
					dcb $0C,$CC,$0E,$EC ;#112.5
					dcb $CA,$C8,$2A,$E8 ;#123.75
					dcb $CA,$C8,$0A,$E8 ;#135
					dcb $C6,$C4,$6E,$E4 ;#146.25
					dcb $C6,$C4,$4E,$E4 ;#157.5
					dcb $C2,$C0,$6C,$E0 ;#168.75
					dcb $82,$80,$42,$40 ;#180
					dcb $82,$80,$62,$60 ;#191.25
					dcb $86,$84,$46,$44 ;#202.5
					dcb $86,$84,$A6,$64 ;#213.75
					dcb $8A,$88,$AA,$48 ;#225
					dcb $8A,$88,$AA,$68 ;#236.25
					dcb $8E,$8C,$AE,$4A ;#247.5
					dcb $8E,$8C,$AE,$6A ;#258.75
					dcb $4C,$E2,$C0,$C2 ;#270
					dcb $2C,$CC,$2E,$EC ;#281.25
					dcb $0C,$CC,$0E,$EC ;#292.5
					dcb $CA,$C8,$2A,$E8 ;#303.75
					dcb $CA,$C8,$0A,$E8 ;#315
					dcb $C6,$C4,$6E,$E4 ;#326.25
					dcb $C6,$C4,$4E,$E4 ;#337.5
					dcb $C2,$C0,$6C,$E0 ;#348.75
					
HORZ_JR				dcb $08,$F8,$08,$F8	;#
					dcb $0A,$FA,$0A,$FA ;#11.25
					dcb $0A,$FA,$0A,$FA ;#22.5
					dcb $0A,$FA,$0A,$FA ;#33.75
					dcb $0A,$FA,$0A,$FA ;#45
					dcb $05,$F5,$05,$F5 ;#56.25
					dcb $05,$F5,$05,$F5 ;#67.5
					dcb $05,$F5,$05,$F5 ;#78.75
					dcb $F8,$08,$F8,$08 ;#90
					dcb $F6,$06,$F6,$06 ;#101.25
					dcb $F6,$06,$F6,$06 ;#112.5
					dcb $F6,$06,$F6,$06 ;#123.75
					dcb $F6,$06,$F6,$06 ;#135
					dcb $F6,$06,$F6,$06 ;#146.25
					dcb $F5,$05,$F5,$05 ;#157.5
					dcb $F5,$05,$F5,$05 ;#168.75
					
					dcb $F8,$08,$F8,$08 ;#180
					dcb $F6,$06,$F6,$06 ;#191.25
					dcb $F6,$06,$F6,$06 ;#202.5
					dcb $F6,$06,$F6,$06 ;#213.75
					dcb $F6,$06,$F6,$06 ;#225
					dcb $FB,$0B,$FB,$0B ;#236.25
					dcb $FB,$0B,$FB,$0B ;#247.5
					dcb $FB,$0B,$FB,$0B ;#258.75
					dcb $08,$F8,$08,$F8 ;#270
					dcb $0A,$FA,$0A,$FA ;#281.25
					dcb $0A,$FA,$0A,$FA ;#292.5
					dcb $0A,$FA,$0A,$FA ;#303.75
					dcb $0A,$FA,$0A,$FA ;#315
					dcb $0A,$FA,$0A,$FA ;#326.25
					dcb $0B,$FB,$0B,$FB ;#337.5
					dcb $0B,$FB,$0B,$FB ;#348.75
					
VERT_JR				dcb $00,$00,$F0,$F0 ;#
					dcb $FE,$FE,$EE,$EE ;#11.25
					dcb $FE,$FE,$EE,$EE ;#22.5
					dcb $FC,$FC,$EC,$EC ;#33.75
					dcb $FC,$FC,$EC,$EC ;#45
					dcb $FD,$FD,$ED,$ED ;#56.25
					dcb $FD,$FD,$ED,$ED ;#67.5
					dcb $FD,$FD,$ED,$ED ;#78.75
					dcb $F0,$F0,$00,$00 ;#90
					dcb $F2,$F2,$02,$02 ;#101.25
					dcb $F2,$F2,$02,$02 ;#112.5
					dcb $F2,$F2,$02,$02 ;#123.75
					dcb $F2,$F2,$02,$02 ;#135
					dcb $F3,$F3,$03,$03 ;#146.25
					dcb $F3,$F3,$03,$03 ;#157.5
					dcb $F3,$F3,$03,$03 ;#168.75
					
					dcb $F0,$F0,$00,$00 ;#180
					dcb $F2,$F2,$02,$02 ;#191.25
					dcb $F2,$F2,$02,$02 ;#202.5
					dcb $F2,$F2,$02,$02 ;#213.75
					dcb $F4,$F4,$04,$04 ;#225
					dcb $F3,$F3,$03,$03 ;#236.25
					dcb $F3,$F3,$03,$03 ;#247.5
					dcb $F3,$F3,$03,$03 ;#258.75
					dcb $00,$00,$F0,$F0 ;#270
					dcb $FE,$FE,$EE,$EE ;#281.25
					dcb $FE,$FE,$EE,$EE ;#292.5
					dcb $FE,$FE,$EE,$EE ;#303.75
					dcb $FE,$FE,$EE,$EE ;#315
					dcb $FE,$FE,$EE,$EE ;#326.25
					dcb $FD,$FD,$ED,$ED ;#337.5
					dcb $FD,$FD,$ED,$ED ;#348.75
					
PROP_JR				dcb $CF,$CF,$CF,$CF ;#
					dcb $CE,$CE,$CE,$CE ;#11.25
					dcb $CF,$CF,$CF,$CF ;#22.5
					dcb $CE,$CE,$CE,$CE ;#33.75
					dcb $CF,$CF,$CF,$CF ;#45
					dcb $CE,$CE,$CE,$CE ;#56.25
					dcb $CF,$CF,$CF,$CF ;#67.5
					dcb $CE,$CE,$CE,$CE ;#78.75
					dcb $0F,$0F,$0F,$0F ;#90
					dcb $0E,$0E,$0E,$0E ;#101.25
					dcb $0F,$0F,$0F,$0F ;#112.5
					dcb $0E,$0E,$0E,$0E ;#123.75
					dcb $0F,$0F,$0F,$0F ;#135
					dcb $0E,$0E,$0E,$0E ;#146.25
					dcb $0F,$0F,$0F,$0F ;#157.5
					dcb $0E,$0E,$0E,$0E ;#168.75
					
					dcb $0F,$0F,$0F,$0F ;#180
					dcb $0E,$0E,$0E,$0E ;#191.25
					dcb $0F,$0F,$0F,$0F ;#202.5
					dcb $0E,$0E,$0E,$0E ;#213.75
					dcb $0F,$0F,$0F,$0F ;#225
					dcb $0E,$0E,$0E,$0E ;#236.25
					dcb $0F,$0F,$0F,$0F ;#247.5
					dcb $0E,$0E,$0E,$0E ;#258.75
					dcb $CF,$CF,$CF,$CF ;#270
					dcb $CE,$CE,$CE,$CE ;#281.25
					dcb $CF,$CF,$CF,$CF ;#292.5
					dcb $CE,$CE,$CE,$CE ;#303.75
					dcb $CF,$CF,$CF,$CF ;#315
					dcb $CE,$CE,$CE,$CE ;#326.25
					dcb $CF,$CF,$CF,$CF ;#337.5
					dcb $CE,$CE,$CE,$CE ;#348.75
					
					dcb $CF,$CF,$CF,$CF ;#
					dcb $CE,$CE,$CE,$CF ;#11.25
					dcb $CF,$CF,$CF,$CF ;#22.5
					dcb $CE,$CE,$CE,$CF ;#33.75
					dcb $CF,$CF,$CF,$CF ;#45
					dcb $CE,$CE,$CE,$CF ;#56.25
					dcb $CF,$CF,$CF,$CF ;#67.5
					dcb $CE,$CF,$CE,$CF ;#78.75
					dcb $0F,$0F,$0F,$0F ;#90
					dcb $0E,$0E,$0F,$0E ;#101.25
					dcb $0F,$0F,$0F,$0F ;#112.5
					dcb $0E,$0E,$0F,$0E ;#123.75
					dcb $0F,$0F,$0F,$0F ;#135
					dcb $0E,$0E,$0F,$0E ;#146.25
					dcb $0F,$0F,$0F,$0F ;#157.5
					dcb $0E,$0E,$0F,$0F ;#168.75
					
					dcb $0F,$0F,$0F,$0F ;#180
					dcb $0E,$0E,$0E,$0F ;#191.25
					dcb $0F,$0F,$0F,$0F ;#202.5
					dcb $0E,$0E,$0E,$0F ;#213.75
					dcb $0F,$0F,$0F,$0F ;#225
					dcb $0E,$0E,$0E,$0F ;#236.25
					dcb $0F,$0F,$0F,$0F ;#247.5
					dcb $0E,$0F,$0E,$0F ;#258.75
					dcb $CF,$CF,$CF,$CF ;#270
					dcb $CE,$CE,$CF,$CE ;#281.25
					dcb $CF,$CF,$CF,$CF ;#292.5
					dcb $CE,$CE,$CF,$CE ;#303.75
					dcb $CF,$CF,$CF,$CF ;#315
					dcb $CE,$CE,$CF,$CE ;#326.25
					dcb $CF,$CF,$CF,$CF ;#337.5
					dcb $CE,$CE,$CF,$CF ;#348.75
					
					dcb $8F,$8F,$8F,$8F ;#
					dcb $8E,$8E,$8E,$8E ;#11.25
					dcb $8F,$8F,$8F,$8F ;#22.5
					dcb $8E,$8E,$8E,$8E ;#33.75
					dcb $8F,$8F,$8F,$8F ;#45
					dcb $8E,$8E,$8E,$8E ;#56.25
					dcb $8F,$8F,$8F,$8F ;#67.5
					dcb $8E,$8E,$8E,$8E ;#78.75
					dcb $8F,$8F,$8F,$8F ;#90
					dcb $4E,$4E,$4E,$4E ;#101.25
					dcb $4F,$4F,$4F,$4F ;#112.5
					dcb $4E,$4E,$4E,$4E ;#123.75
					dcb $4F,$4F,$4F,$4F ;#135
					dcb $4E,$4E,$4E,$4E	 ;#146.25
					dcb $4F,$4F,$4F,$4F ;#157.5
					dcb $4E,$4E,$4E,$4E ;#168.75
						
					dcb $4F,$4F,$4F,$4F ;#180
					dcb $4E,$4E,$4E,$4E ;#191.25
					dcb $4F,$4F,$4F,$4F ;#202.5
					dcb $4E,$4E,$4E,$4E ;#213.75
					dcb $4F,$4F,$4F,$4F ;#225
					dcb $4E,$4E,$4E,$4E ;#236.25
					dcb $4F,$4F,$4F,$4F ;#247.5
					dcb $4E,$4E,$4E,$4E ;#258.75
					dcb $4F,$4F,$4F,$4F ;#270
					dcb $8E,$8E,$8E,$8E ;#281.25
					dcb $8F,$8F,$8F,$8F ;#292.5
					dcb $8E,$8E,$8E,$8E ;#303.75
					dcb $8F,$8F,$8F,$8F ;#315
					dcb $8E,$8E,$8E,$8E ;#326.25
					dcb $8F,$8F,$8F,$8F ;#337.5
					dcb $8E,$8E,$8E,$8E ;#348.75
						
					dcb $8F,$8F,$8F,$8F ;#
					dcb $8E,$8E,$8F,$8F ;#11.25
					dcb $8F,$8F,$8F,$8F ;#22.5
					dcb $8E,$8E,$8E,$8F ;#33.75
					dcb $8F,$8F,$8F,$8F ;#45
					dcb $8E,$8E,$8E,$8F ;#56.25
					dcb $8F,$8F,$8F,$8F ;#67.5
					dcb $8E,$8E,$8E,$8F ;#78.75
					dcb $8F,$8F,$8F,$8F ;#90
					dcb $4F,$4E,$4F,$4E ;#101.25
					dcb $4F,$4F,$4F,$4F ;#112.5
					dcb $4E,$4E,$4F,$4E ;#123.75
					dcb $4F,$4F,$4F,$4F ;#135
					dcb $4E,$4E,$4F,$4E	 ;#146.25
					dcb $4F,$4F,$4F,$4F ;#157.5
					dcb $4E,$4E,$4F,$4E ;#168.75
						
					dcb $4F,$4F,$4F,$4F ;#180
					dcb $4E,$4E,$4F,$4F ;#191.25
					dcb $4F,$4F,$4F,$4F ;#202.5
					dcb $4E,$4E,$4E,$4F ;#213.75
					dcb $4F,$4F,$4F,$4F ;#225
					dcb $4E,$4E,$4E,$4F ;#236.25
					dcb $4F,$4F,$4F,$4F ;#247.5
					dcb $4E,$4E,$4E,$4F ;#258.75
					dcb $4F,$4F,$4F,$4F ;#270
					dcb $8F,$8E,$8F,$8E ;#281.25
					dcb $8F,$8F,$8F,$8F ;#292.5
					dcb $8E,$8E,$8F,$8E ;#303.75
					dcb $8F,$8F,$8F,$8F ;#315
					dcb $8E,$8E,$8F,$8E ;#326.25
					dcb $8F,$8F,$8F,$8F ;#337.5
					dcb $8E,$8E,$8F,$8E ;#348.75

RETURN503			RTS
SUB_GFX_JR			LDA $1558,x
					AND #$02
					BNE RETURN503
					LDA $1594,x
					CMP #$06
					BCS RETURN503
					JSR DIREC_CHECK
					JSR GET_DRAW_INFO
					LDA $1570,x
					ASL A
					ASL A
					STA $02
					STZ $03
					STZ $0E
					LDA $C2,x
					BNE SUB_GFX_JR_1
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE SUB_GFX_JR_1
					LDA #$80
					STA $0E
SUB_GFX_JR_1		STZ $0F
					LDA $157C,x
					BEQ SUB_GFX_JR_2
					INC $0F
SUB_GFX_JR_2		PHX
					REP #$10
					LDX.W #$0003
LOOP_JR				PHX
					REP #$20
					TXA
					CLC
					ADC $02
					TAX
					SEP #$20
					LDA $00
					CLC 
					ADC HORZ_JR,x
					STA $0300,y             ; /
					LDA $01
                    CLC      
                    ADC VERT_JR,x         ; |
                    STA $0301,y             ; /
					REP #$20
					TXA
					CLC
					ADC $0E
					TAX
					SEP #$20
					LDA TILEMAP_JR,x           ; \ store tile
                    STA $0302,y             ; /
                    LDA PROP_JR,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_JR
					SEP #$10
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS


TILEMAP_PT          dcb $06,$08
VERT_DISP_PT        dcb $F0,$00
PROPETIES_PT		dcb $0B,$0D
					
SUB_GFX_PT			JSR GET_DRAW_INFO
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$01
LOOP_STARTPT        LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_PT,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_PT,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
                    LDA PROPETIES_PT,x
                    ;ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTPT
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
GFX_P_TABLE			dcb $00,$02,$04,$02
GFX_P_TABLE2		dcb $40,$00
SUB_GFX_P			LDY $1602,x
					LDA GFX_P_TABLE,y
					STA $03
					LDY $157C,x
					LDA GFX_P_TABLE2,y
					STA $02
					JSR GET_DRAW_INFO
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					STA $0300,y             ; /
					LDA $01
                    STA $0301,y             ; /
					LDA $03
                    STA $0302,y             ; /
					LDA #$0D
					ORA $02
                    STA $0303,y             ; store tile properties
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
HORZ_DISP_ST        dcb $E8,$08,$18
					dcb $F0,$08,$18
					dcb $F8,$00,$10
					dcb $F0,$08,$10
					
					dcb $E8,$F8,$18
					dcb $E8,$F8,$10
					dcb $F0,$00,$08
					dcb $F0,$F8,$10
					
VERT_DISP_ST        dcb $00,$F8,$04
					dcb $F8,$08,$FC
					dcb $08,$F4,$04
					dcb $04,$08,$F8
					dcb $FC,$08,$00
					dcb $04,$F8,$08
					dcb $FC,$0C,$F8
					dcb $08,$F8,$FC
					
PROPETIES_ST		dcb $05,$07,$09,$0B
					
SUB_GFX_ST			JSR GET_DRAW_INFO
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$07
					STA $03
					ASL A
					CLC
					ADC $03
					STA $03
					LDA $14
					LSR A
					LSR A
					AND #$03
					STA $02
					PHX
					LDX #$02
LOOP_STARTST        PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC HORZ_DISP_ST,x         ; |
					STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_ST,x         ; |
                    STA $0301,y             ; /
					PLX
					PHX
					LDX $02
					LDA #$28
                    STA $0302,y             ; /
                    LDA PROPETIES_ST,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTST
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
GEN_SPIRITE_2       PLX
                    
					LDA $E4,x
					CLC
					ADC #$08
                    STA $00E4,y
                    LDA $14E0,x
					ADC #$00
                    STA $14E0,y             ; /

					LDA $D8,x
					CLC
					ADC #$30
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					ADC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GRAPHIC_ROUTINE		LDA $14E0,x		;A:87C8 X:0009 Y:0004 P:eNvMXdizC
					XBA				;A:8700 X:0009 Y:0004 P:envMXdiZC
					LDA $E4,x		;A:0087 X:0009 Y:0004 P:eNvMXdizC
					LDY #$00		;A:00B2 X:0009 Y:0004 P:eNvMXdizC
					JSR SUB_DFAE		;#AxW(16bit)AY=0Ŏs
					LDA $14D4,x
					XBA
					LDA $D8,x
					LDY #$02
					JSR SUB_DFAE		;#AyW(16bit)AY=2Ŏs
					PHX
					REP #$30
					STZ $06
					LDY.W #$0003
					LDA.W $0D9B
					LSR A
					SEP #$30
					PLX
					LDA #$20
					STA $C6C0
					RTS

SUB_DFAE			PHX
					TYX
					REP #$20
					EOR #$FFFF
					INC A
					CLC
					ADC $03DEBB,x
					CLC
					ADC $1A,x ;#(xWȂ1A yWȂȂ2C)
					STA $3A,x
					SEP #$20
					PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GRA_TABLE1			dcb $FF,$FF,$07,$05,$03,$01,$FF,$FF
					dcb $FF,$FF,$27,$25,$23,$21,$FF,$FF
					dcb $FF,$FF,$47,$45,$43,$41,$FF,$FF
					dcb $FF,$FF,$67,$65,$63,$61,$FF,$FF
					dcb $FF,$FF,$00,$02,$04,$06,$FF,$FF
					dcb $FF,$FF,$20,$22,$24,$26,$FF,$FF
					dcb $FF,$FF,$40,$42,$44,$46,$FF,$FF
					dcb $FF,$FF,$60,$62,$64,$66,$FF,$FF
					
GRA_TABLE2			dcb $FF,$FF,$0F,$0D,$0B,$09,$FF,$FF
					dcb $FF,$FF,$2F,$2D,$2B,$29,$FF,$FF
					dcb $FF,$FF,$4F,$4D,$4B,$49,$FF,$FF
					dcb $FF,$FF,$6F,$6D,$6B,$69,$FF,$FF
					dcb $FF,$FF,$08,$0A,$0C,$0E,$FF,$FF
					dcb $FF,$FF,$28,$2A,$2C,$2E,$FF,$FF
					dcb $FF,$FF,$48,$4A,$4C,$4E,$FF,$FF
					dcb $FF,$FF,$68,$6A,$6C,$6E,$FF,$FF
										
GRA_TABLE3			dcb $FF,$FF,$17,$15,$13,$11,$FF,$FF
					dcb $FF,$FF,$37,$35,$33,$31,$FF,$FF
					dcb $FF,$FF,$57,$55,$53,$51,$FF,$FF
					dcb $FF,$FF,$77,$75,$73,$71,$FF,$FF
					dcb $FF,$FF,$10,$12,$14,$16,$FF,$FF
					dcb $FF,$FF,$30,$32,$34,$36,$FF,$FF
					dcb $FF,$FF,$50,$52,$54,$56,$FF,$FF
					dcb $FF,$FF,$70,$72,$74,$76,$FF,$FF
										
GRA_TABLE4			dcb $FF,$FF,$1F,$1D,$1B,$19,$FF,$FF
					dcb $FF,$FF,$3F,$3D,$3B,$39,$FF,$FF
					dcb $FF,$FF,$5F,$5D,$5B,$59,$FF,$FF
					dcb $FF,$FF,$7F,$7D,$7B,$79,$FF,$FF
					dcb $FF,$FF,$18,$1A,$1C,$1E,$FF,$FF
					dcb $FF,$FF,$38,$3A,$3C,$3E,$FF,$FF
					dcb $FF,$FF,$58,$5A,$5C,$5E,$FF,$FF
					dcb $FF,$FF,$78,$7A,$7C,$7E,$FF,$FF
					
GRA_TABLE6			dcb $FF,$80,$82,$84,$86,$88,$8A,$FF
					dcb $FF,$A0,$A2,$A4,$A6,$A8,$AA,$FF
					dcb $FF,$C0,$C2,$C4,$C6,$C8,$CA,$FF
					dcb $FF,$E0,$E2,$E4,$E6,$E8,$EA,$FF
					dcb $FF,$8C,$8E,$90,$92,$94,$96,$FF
					dcb $FF,$AC,$AE,$B0,$B2,$B4,$B6,$FF
					
GRA_TABLE7			dcb $FF,$80,$82,$84,$86,$88,$8A,$FF
					dcb $FF,$A0,$CC,$CE,$D0,$D2,$AA,$FF
					dcb $FF,$C0,$EC,$EE,$F0,$F2,$CA,$FF
					dcb $FF,$E0,$98,$9A,$9C,$9E,$EA,$FF
					dcb $FF,$8C,$B8,$BA,$BC,$BE,$96,$FF
					dcb $FF,$AC,$AE,$B0,$B2,$B4,$B6,$FF
					
GRAPHIC0			LDA $1602,x
					BNE GRAPHIC0_1
					JSR GRAPHIC
					RTS
GRAPHIC0_1			CMP #$01
					BNE GRAPHIC0_2
					JSR GRAPHIC2
					RTS
GRAPHIC0_2			CMP #$02
					BNE GRAPHIC0_3
					JSR GRAPHIC3
					RTS
GRAPHIC0_3			CMP #$03
					BNE GRAPHIC0_4
					JSR GRAPHIC4
					RTS
GRAPHIC0_4			CMP #$04
					BNE GRAPHIC0_5
					JSR GRAPHIC5
					RTS
GRAPHIC0_5			CMP #$05
					BNE GRAPHIC0_6
					JSR GRAPHIC6
					RTS
GRAPHIC0_6			JSR GRAPHIC7
					RTS


GRAPHIC				STZ $02
					LDA $157C,x
					BEQ GRAPHIC_1
					LDA #$20
					STA $02
GRAPHIC_1			PHX
					LDX #$00
GRAPHIC_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE1,x
					PLX
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC_LOOP
					PLX
					RTS
					
GRAPHIC2			STZ $02
					LDA $157C,x
					BEQ GRAPHIC2_1
					LDA #$20
					STA $02
GRAPHIC2_1			PHX
					LDX #$00
GRAPHIC2_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE2,x
					PLX
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC2_LOOP
					PLX
					RTS
					
GRAPHIC3			STZ $02
					LDA $157C,x
					BEQ GRAPHIC3_1
					LDA #$20
					STA $02
GRAPHIC3_1			PHX
					LDX #$00
GRAPHIC3_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE3,x
					PLX
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC3_LOOP
					PLX
					RTS
					
GRAPHIC4			STZ $02
					LDA $157C,x
					BEQ GRAPHIC4_1
					LDA #$20
					STA $02
GRAPHIC4_1			PHX
					LDX #$00
GRAPHIC4_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE4,x
					PLX
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC4_LOOP
					PLX
					RTS
					
GRAPHIC5			PHX
					LDX #$00
GRAPHIC5_LOOP		LDA #$FF
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC5_LOOP
					PLX
					RTS
					
GRAPHIC6			PHX
					LDX #$00
GRAPHIC6_LOOP		LDA GRA_TABLE6,x
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC6_LOOP
					PLX
					RTS
					
GRAPHIC7			PHX
					LDX #$00
GRAPHIC7_LOOP		LDA GRA_TABLE7,x
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC7_LOOP
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; BACK_GROUND
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MOON_HOR			dcb $10,$20,$30,$10,$20,$30,$10,$20,$30
MOON_VER			dcb $10,$10,$10,$20,$20,$20,$30,$30,$30
MOON_TILE			dcb $80,$82,$84,$A0,$A2,$A4,$C0,$C2,$C4
MOON_TILE2			dcb $86,$88,$8A,$A6,$A8,$AA,$C6,$C8,$CA

RETURN731			RTS
BACK_GROUND         ;XvCgœy`Ă܂
					LDA $1602,x
					CMP #$06
					BCS RETURN731
					PHX
					LDY #$30
					STZ $01
					LDA $190D
					STA $0F
					LDX #$0F	 ;#1ڂ̕`
BG_LOOP2			LDA #$C0
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA $01
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					CLC
					ADC #$10
					STA $01		;#xW10₷
					LDA #$8E	;#GFX^C
					STA $0202,y
					LDA #$0F
					;ORA $64
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP2
					LDA $7FDFA0
					CMP #$03
					BEQ BACK_GROUND_R
					CMP #$02
					BEQ BACK_GROUND_2
					LDY #$C0
					LDX #$08	 ;#̕`
BG_LOOP3			LDA MOON_VER,x
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA MOON_HOR,x
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					LDA MOON_TILE,x
					STA $0202,y
					LDA #$0F
					ORA $64
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP3
					LDA $7FDFA0
					CMP #$01
					BEQ BACK_GROUND_2
BACK_GROUND_R		PLX
					RTS
BACK_GROUND_2		LDY #$80
					LDX #$08	 ;#e̕`
BG_LOOP4			LDA MOON_VER,x
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA MOON_HOR,x
					SEC
					SBC $1A		;#ʈʒuxW
					CLC
					ADC $7FDFA1
					STA $0200,y
					LDA MOON_TILE2,x
					STA $0202,y
					LDA #$0F
					ORA $64
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP4
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA_COLOR			LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$21
					STA $7FFB22
					LDA #$22
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$E2
					STA $7FFB24
					LDA #$E3
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$01
					STA $7FE201
					LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					
					LDA #$01
					STA $7FE202
					STA $7FE303
					LDA #$02
					STA $7FE203
					LDA #$00
					STA $7FE304
					LDA #$00
					STA $7FE305
					
					LDA #$01
					STA $7FE204
					STA $7FE306
					LDA #$03
					STA $7FE205
					LDA #$0B
					STA $7FE307
					LDA #$00
					STA $7FE308
					
					LDA #$01
					STA $7FE206
					STA $7FE309
					LDA #$04
					STA $7FE207
					LDA #$14
					STA $7FE30A
					LDA #$00
					STA $7FE30B
					
					LDA #$01
					STA $7FE208
					STA $7FE30C
					LDA #$05
					STA $7FE209
					LDA #$1F
					STA $7FE30D
					LDA #$00
					STA $7FE30E
					
					LDA #$01
					STA $7FE20A
					STA $7FE30F
					LDA #$07
					STA $7FE20B
					LDA #$1F
					STA $7FE310
					LDA #$03
					STA $7FE311
					
					LDA #$01
					STA $7FE20C
					STA $7FE312
					LDA #$06
					STA $7FE20D
					LDA #$B7
					STA $7FE313
					LDA #$00
					STA $7FE314
					
					LDA #$01
					STA $7FE20E
					STA $7FE315
					LDA #$0E
					STA $7FE20F
					LDA #$D9
					STA $7FE316
					LDA #$57
					STA $7FE317
					
					LDA #$01
					STA $7FE210
					STA $7FE318
					LDA #$0F
					STA $7FE211
					LDA #$FF
					STA $7FE319
					LDA #$6B
					STA $7FE31A
					
					
					LDA #$01
					STA $7FE212
					STA $7FE31B
					LDA #$E4
					STA $7FE213
					LDA #$14
					STA $7FE31C
					LDA #$00
					STA $7FE31D
					
					LDA #$01
					STA $7FE214
					STA $7FE31E
					LDA #$E5
					STA $7FE215
					LDA #$1F
					STA $7FE31F
					LDA #$00
					STA $7FE320
					
					LDA #$01
					STA $7FE216
					STA $7FE321
					LDA #$F3
					STA $7FE217
					LDA #$A5
					STA $7FE322
					LDA #$34
					STA $7FE323
					
					LDA #$01
					STA $7FE218
					STA $7FE324
					LDA #$F4
					STA $7FE219
					LDA #$49
					STA $7FE325
					LDA #$49
					STA $7FE326
					
					LDA #$01
					STA $7FE21A
					STA $7FE327
					LDA #$F5
					STA $7FE21B
					LDA #$AD
					STA $7FE328
					LDA #$61
					STA $7FE329
					
					LDA #$01
					STA $7FE21C
					STA $7FE32A
					LDA #$F6
					STA $7FE21D
					LDA #$31
					STA $7FE32B
					LDA #$5A
					STA $7FE32C
					
					LDA #$01
					STA $7FE21E
					STA $7FE32D
					LDA #$F7
					STA $7FE21F
					LDA #$B7
					STA $7FE32E
					LDA #$72
					STA $7FE32F
					

					
					LDA #$00
					STA $7FE220
					STA $7FE330
					RTS
					
HDMA_COLOR2			LDA #$57
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$42
					STA $7FE301
					LDA #$04
					STA $7FE302
					
					LDA #$04
					STA $7FE202
					STA $7FE303
					LDA #$00
					STA $7FE203
					LDA #$43
					STA $7FE304
					LDA #$0C
					STA $7FE305
					
					LDA #$04
					STA $7FE204
					STA $7FE306
					LDA #$00
					STA $7FE205
					LDA #$64
					STA $7FE307
					LDA #$14
					STA $7FE308
					
					LDA #$04
					STA $7FE206
					STA $7FE309
					LDA #$00
					STA $7FE207
					LDA #$86
					STA $7FE30A
					LDA #$1C
					STA $7FE30B
					
					LDA #$04
					STA $7FE208
					STA $7FE30C
					LDA #$00
					STA $7FE209
					LDA #$A7
					STA $7FE30D
					LDA #$24
					STA $7FE30E
					
					LDA #$04
					STA $7FE20A
					STA $7FE30F
					LDA #$00
					STA $7FE20B
					LDA #$C9
					STA $7FE310
					LDA #$2C
					STA $7FE311
					
					LDA #$04
					STA $7FE20C
					STA $7FE312
					LDA #$00
					STA $7FE20D
					LDA #$0A
					STA $7FE313
					LDA #$35
					STA $7FE314
					
					LDA #$04
					STA $7FE20E
					STA $7FE315
					LDA #$00
					STA $7FE20F
					LDA #$2D
					STA $7FE316
					LDA #$3D
					STA $7FE317
					
					LDA #$04
					STA $7FE210
					STA $7FE318
					LDA #$00
					STA $7FE211
					LDA #$4F
					STA $7FE319
					LDA #$35
					STA $7FE31A
					
					LDA #$04
					STA $7FE212
					STA $7FE31B
					LDA #$00
					STA $7FE213
					LDA #$92
					STA $7FE31C
					LDA #$2D
					STA $7FE31D
					
					LDA #$04
					STA $7FE214
					STA $7FE31E
					LDA #$00
					STA $7FE215
					LDA #$B4
					STA $7FE31F
					LDA #$25
					STA $7FE320
					
					LDA #$04
					STA $7FE216
					STA $7FE321
					LDA #$00
					STA $7FE217
					LDA #$37
					STA $7FE322
					LDA #$1E
					STA $7FE323
					
					LDA #$04
					STA $7FE218
					STA $7FE324
					LDA #$00
					STA $7FE219
					LDA #$B9
					STA $7FE325
					LDA #$16
					STA $7FE326
					
					LDA #$04
					STA $7FE21A
					STA $7FE327
					LDA #$00
					STA $7FE21B
					LDA #$5C
					STA $7FE328
					LDA #$17
					STA $7FE329
					
					LDA #$04
					STA $7FE21C
					STA $7FE32A
					LDA #$00
					STA $7FE21D
					LDA #$FF
					STA $7FE32B
					LDA #$37
					STA $7FE32C
					
					LDA #$01
					STA $7FE21E
					STA $7FE32D
					LDA #$00
					STA $7FE21F
					LDA #$00
					STA $7FE32E
					LDA #$00
					STA $7FE32F
					
					LDA #$00
					STA $7FE220
					STA $7FE330
					RTS
					
HDMA_COLOR3			LDA #$01
					STA $7FE220
					STA $7FE330
					LDA #$01
					STA $7FE221
					LDA #$39
					STA $7FE331
					LDA #$1E
					STA $7FE332
					
					LDA #$01
					STA $7FE222
					STA $7FE333
					LDA #$02
					STA $7FE223
					LDA #$BB
					STA $7FE334
					LDA #$2E
					STA $7FE335
					
					LDA #$01
					STA $7FE224
					STA $7FE336
					LDA #$03
					STA $7FE225
					LDA #$3D
					STA $7FE337
					LDA #$37
					STA $7FE338
					
					LDA #$01
					STA $7FE226
					STA $7FE339
					LDA #$04
					STA $7FE227
					LDA #$BF
					STA $7FE33A
					LDA #$3F
					STA $7FE33B
					
					LDA #$01
					STA $7FE228
					STA $7FE33C
					LDA #$05
					STA $7FE229
					LDA #$FF
					STA $7FE33D
					LDA #$4F
					STA $7FE33E
					
					LDA #$01
					STA $7FE22A
					STA $7FE33F
					LDA #$06
					STA $7FE22B
					LDA #$00
					STA $7FE340
					LDA #$00
					STA $7FE341
					
					LDA #$01
					STA $7FE22C
					STA $7FE342
					LDA #$07
					STA $7FE22D
					LDA #$FF
					STA $7FE343
					LDA #$7F
					STA $7FE344
					
					LDA #$00
					STA $7FE22E
					STA $7FE345
					RTS
RETURNK68           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA $7FFF9E
                    STA $009E,y
					LDA #$08
					STA $14C8,y
GEN_NORMAL_2                    
                    LDA $E4,x               ;\ set x position for new sprite
					CLC
					ADC #$08
                    STA $00E4,y

                    LDA $14E0,x             ;  |
					ADC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					CLC
					ADC #$30
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
					STA $14D4,y             ; /
                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
					LDA #$99
					STA $1686,y
					;LDA #$02
					;STA $15F6,y
					JSL $01ACF9
					CLC
					ADC $94
					AND #$01
					STA $157C,y
					LDA $7FFF9E
					CMP #$53
					BNE RETURNK68
					LDA #$09
					STA $14C8,y
                    RTS                     ; return
