;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Bowser form Mario3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


TILEMAP             dcb $00,$02,$20,$22,$40,$42,$00,$02,$20,$22,$04,$06,$24,$26,$44,$46,$40,$42,$08,$0A,$28,$2A,$40,$42
                    dcb $0E,$0E,$2E,$2E,$4E,$4E,$0C,$0C,$2C,$2C,$4C,$4C,$80,$82,$A0,$A2,$C0,$C2,$84,$86,$A4,$A6,$C4,$C6
HORZ_DISP           dcb $F8,$08,$F8,$08,$F8,$08,$08,$F8,$08,$F8,$08,$F8         
VERT_DISP           dcb $F0,$F0,$00,$00,$10,$10,$F3,$F3,$03,$03,$13,$13,$F0,$F0,$00,$00,$10,$10,$F0,$F0,$00,$00,$10,$10
                    dcb $F5,$F5,$05,$05,$15,$15,$F0,$F0,$00,$00,$10,$10,$F0,$F0,$00,$00,$10,$10,$F0,$F0,$00,$00,$10,$10
PROPERTIES          dcb $40,$00             ;xyppccct format


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    LDA #$01
                    STA $157C,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $C2,x
					BEQ BOWSER_MAIN
					CMP #$01
					BEQ GHOST_MAIN
					JSR FIRE_MAIN
RETURN				RTS
GHOST_MAIN			JSL $01802A
					RTS
BOWSER_MAIN			LDA $1540,x
                    BEQ ALIVE
                    JSR DEATH
                    RTS
ALIVE               JSR SUB_GFX             ; draw hammer bro gfx
                    LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $1534,x
                    TAY
                    LDA $1528,x
                    STA $1528,y
					LDA $1558,x
					BNE RETURN
                    JSR DEATH_CEHCK
                    JSL $01802A             ; update position based on speed values
					JSL $01A7DC
					LDA $1528,x               ;Mode
                    BNE NO_MODE0
                    JSR MODE0
                    RTS
NO_MODE0            LDA $1528,x
                    CMP #$01
                    BNE NO_MODE1
                    JSR MODE1
                    RTS
NO_MODE1            CMP #$02
                    BNE NO_MODE2
                    JSR MODE2
                    RTS
NO_MODE2            CMP #$03
                    BNE NO_MODE3
                    JSR MODE3
                    RTS
NO_MODE3            JSR MODE4
RETURN2				RTS
DEATH				LDA $9D
					BNE RETURN2
					LDA $14AD
                    BNE DEATH5
                    LDA $1540,x
                    CMP #$C0
                    BEQ DEATH1
                    CMP #$60
                    BEQ DEATH3
                    CMP #$20
                    BEQ DEATH4
                    RTS
DEATH1              LDA #$2B
                    STA $1DFC
                    RTS
DEATH3              LDA #$09
                    STA $1DFC
                    LDA #$20
                    STA $1887
                    RTS
DEATH4              LDA EXTRA_BITS,x
					AND #$04
					BNE DEATH2
					LDA #$2A
                    STA $1DF9
DEATH5              LDA #$FF
                    STA $14AD
					LDA #$10
					STA $1540,x
                    RTS
DEATH2				LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS
					
X_SPEEDF            dcb $10,$F0
RETURNF             RTS
FIRE_MAIN			JSR SUB_GFXF             ; draw sprite gfx
                    LDA $14C8,x             ; \ if sprite status != 8...
                    CMP #$08                ;  }   
                    BNE RETURNF              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURNF              ; /    ... return

                    JSL $27FAF4 ;SUB_OFF_SCREEN_HB
                    
                    PHY
                    JSR SUB_VERT_POS
                    TYA
                    BEQ NO_CHANGE
                    STZ $15AC,x
NO_CHANGE           PLY
                    INC $1570,x             ; increment number of frames hammer bro has been on screen
                    LDA $1570,x             ; \ calculate which frame to show:
                    LSR A                   ;  | 
                    LSR A                   ;  | 
                    LSR A                   ;  |
                    AND #$03
                    STA $1602,x             ; / write frame to show
                    LDA $15AC,x
                    BNE NOT_MODEF2
                    LDA $1602,x
                    CLC
                    ADC #$04
                    STA $1602,x
NOT_MODEF2          LDA $157C,x
                    PHX
                    TAX
                    LDA X_SPEEDF,x
                    PLX
                    STA $B6,x
                    STZ $AA,x
                    LDA $15AC,x
                    BEQ NOT_MODEF1
                    LDA #$10
                    STA $AA,x
NOT_MODEF1          JSL $01802A             ; update position based on speed values
                    JSL $01A7DC             ; check for mario/sprite contact
                    RTS                     ; return
					
SUB_VERT_POS        LDA $96
                    CLC
                    ADC #$10
                    STA $151C,x
                    LDA $97
                    ADC #$00
                    STA $1504,x
                    LDY #$00
                    LDA $151C,x
                    SEC
                    SBC $D8,x
                    STA $0F
                    LDA $1504,x
                    SBC $14D4,x
                    BPL LABEL11
                    INY
LABEL11             RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET            dcb $18,$E8
X_OFFSET2           dcb $00,$FF

RETURN68            RTS     
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$17
                    STA $1DFC
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    PHY
                    LDA $157C,x
                    TAY
                    LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC X_OFFSET,y
                    PLY
                    STA $00E4,y

                    PHY
                    LDA $157C,x
                    TAY
                    LDA $14E0,x             ;  |
                    ADC X_OFFSET2,y
                    PLY
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
                    LDA $157C,x
                    STA $157C,y
                    LDA #$40
                    STA $15AC,y             ;Time untill change mode
					LDA #$99
					STA $1686,y
					LDA #$00
					STA $1656,y
					LDA #$00
					STA $1662,y
                    LDA #$02
					STA $00C2,y
RETURN67            RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GHOST_GEN           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI GHOST_E            ; / after: Y has index of sprite being generated
                    TYA
                    STA $1534,x
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC #$08
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    ADC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    LDA #$01
					STA $00C2,y
					LDA $1528,x
                    STA $1528,y
GHOST_E             RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    LDA $1602,x             ; \
                    ASL A                   ;  | $03 = index to frame start (frame to show * 6 tile per frame)
                    ASL A
                    CLC
                    ADC $1602,x
                    ADC $1602,x
                    STA $03                 ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
                    PHX                     ; push sprite index
                    LDX #$05                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    TXA
                    CLC
                    ADC $03
                    TAX                  
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDX $02                 ; \
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    LDA $1602,x
                    CMP #$04
                    BCC NOT_MIRROR
                    CMP #$06
                    BCS NOT_MIRROR
                    PLX
                    TXA
                    PHX
                    AND #$01
                    CLC
                    ADC $02
                    AND #$01
                    TAX
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

NOT_MIRROR          PLX                     ; \ pull, X = current tile of the frame we're drawing
                    PHX
                    LDA $02
                    BNE FACING_RIGHT
                    TXA
                    CLC
                    ADC #$06
                    TAX
FACING_RIGHT        LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC
                    ADC HORZ_DISP,x
                    STA $0300,y             ; /
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAPF             dcb $C8,$CA,$CC,$CE,$88,$8A,$CC,$CE
                     dcb $A8,$AA,$AC,$AE,$E8,$EA,$AC,$AE
HORZ_DISPF           dcb $03,$F3,$03,$13
PROPERTIESF          dcb $4D,$0D

SUB_GFXF            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    LDA $1602,x             ; \Sprite Image Table 
                    ASL A                   ;  | $03 = index to frame start (frame to show * 6 tile per frame)
                    STA $03                 ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
                    PHX                     ; push sprite index
                    LDX #$01
LOOP_STARTF         PHX                     ; push current tile number
                    TXA                     ; \ X = index to horizontal displacement
                    CLC
                    ADC $03                 ; / get index of tile (index to first tile of frame + current tile number)
                    TAX                     ; \ 
                    
                    LDA TILEMAPF,x           ; \ store tile
                    STA $0302,y             ; / 

                    LDX $02                 ; \
                    LDA PROPERTIESF,x        ;  | get tile properties using sprite direction
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    PLX
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                    PHX
					TXA
					CLC
					ADC $02
					ADC $02
                    TAX
					LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORZ_DISPF,x         ;  |
                    STA $0300,y             ; /
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTF          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; 8x8
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSETG           dcb $F0,$10
X_OFFSET2G          dcb $FF,$00

MODE0               LDA $E4,x
                    AND #$F0
                    CLC
                    ADC #$08
                    STA $E4,x
                    LDA $1588,x
                    AND #$04
                    BEQ MODE0_E
                    INC $1528,x
                    LDA #$FF
                    STA $15AC,x
                    JSR GHOST_GEN
MODE0_E             RTS

MODE1               JSR GROUND_CHECK
                    TYA
                    BEQ MODE1_AIR
                    LDA $1534,x
                    TAY
                    LDA #$00
                    STA $AA,x
                    STA $00AA,y
                    LDA $1594,x
                    BNE SMALLJUMP
                    LDA #$10
                    STA $1594,x
                    LDA #$01
                    STA $1602,x
                    LDA $15AC,x
                    BNE MODE1_2
                    STZ $1594,x
                    INC $1528,x
					LDA #$20
                    STA $1558,x
                    RTS
SMALLJUMP           DEC $1594,x
                    CMP #$03
                    BCS MODE1_2
                    STZ $1594,x
                    LDA $1534,x
                    TAY
                    LDA #$F0
                    STA $AA,x
                    STA $00AA,y
                    BRA MODE1_2
MODE1_AIR           DEC $AA,x
                    DEC $AA,x
                    LDA $1534,x
                    TAY
                    LDA $00AA,y
                    DEC A
                    DEC A
                    STA $00AA,y
                    STZ $1602,x
MODE1_2             LDA $15AC,x
                    AND #$7F
                    CMP #$50
                    BCS MODE1_E
                    CMP #$40
                    BCC MODE1_2A
                    LDA #$02
                    STA $1602,x
                    BRA MODE1_E
MODE1_2A            CMP #$28
                    BCC MODE1_2B
                    LDA #$03
                    STA $1602,x
MODE1_2B            CMP #$25
                    BNE MODE1_E
                    JSR FIRE_GEN
MODE1_E             RTS

MODE2               LDA $B6,x
                    BNE JUMP_UP
                    JSR CALC_DIS
                    BRA MODE2_E
JUMP_UP             LDA $1534,x
                    TAY
                    LDA #$B0
                    STA $AA,x
                    STA $00AA,y
                    LDA $E4,x
                    AND #$F0
                    CMP $1504,x
                    BNE MODE2_E
                    LDA $1534,x
                    TAY
                    INC $1528,x
                    LDA #$00
                    STA $AA,x
                    STA $00AA,y
                    STA $B6,x
                    STA $00B6,y
                    LDA $1504,x
                    CLC
                    ADC #$08
                    STA $E4,x
                    LDA #$10
                    STA $15AC,x
MODE2_E             RTS

MODE3               LDA #$04
                    STA $1602,x
                    LDA $15AC,x
                    BEQ JUMP_DOWN
                    JSR GHOST_MOVE
                    LDA #$00
                    STA $AA,x
                    STA $00AA,y
                    BRA MODE3_E
JUMP_DOWN           JSR GROUND_CHECK
                    TYA
                    BEQ JUMP_AIR
                    LDA $1534,x
                    TAY
                    LDA #$00
                    STA $AA,x
                    STA $00AA,y
                    LDA #$20
                    STA $1887
                    LDA #$09
                    STA $1DFC
                    INC $1528,x
                    LDA #$F0
                    STA $15AC,x
                    BRA MODE3_E
JUMP_AIR            LDA $1534,x
                    TAY
                    LDA #$60
                    STA $AA,x
                    STA $00AA,y
MODE3_E             RTS

MODE4               JSR GROUND_CHECK
                    TYA
                    BEQ MODE4_A
                    LDA $1534,x
                    TAY
                    LDA #$00
                    STA $AA,x
                    STA $00AA,y
MODE4_A             LDA $15AC,x
                    CMP #$D0
                    BCS MODE4_2
                    CMP #$C0
                    BCS MODE4_3
                    CMP #$B0
                    BCS MODE4_4
                    CMP #$A0
                    BCS MODE4_3
                    CMP #$9F
                    BEQ MODE4_5
                    CMP #$90
                    BCS MODE4_6
                    LDA #$FF
                    STA $15AC,x
                    LDA #$01
                    STA $1528,x
                    BRA MODE4_E
MODE4_2             LDA #$05
                    STA $1602,x
                    BRA MODE4_E
MODE4_3             LDA #$01
                    STA $157C,x
                    LDA #$06
                    STA $1602,x
                    BRA MODE4_E
MODE4_4             STZ $157C,x
                    LDA #$06
                    STA $1602,x
                    BRA MODE4_E
MODE4_5             JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    BRA MODE4_E
MODE4_6             LDA #$07
                    STA $1602,x
MODE4_E             RTS

GHOST_MOVE          LDA $1534,x
                    TAY
                    LDA $E4,x               ; \ set x position for new sprite
                    CLC
                    ADC #$08
                    STA $00E4,y
                    LDA $14E0,x             ;  |
                    ADC #$00
                    STA $14E0,y             ; /
                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /
                    RTS

GROUND_CHECK        LDA #$00
                    TAY
                    LDA $1588,x
                    AND #$04
                    BEQ GROUND_CHECK2
                    INY
                    BRA RETURN58
GROUND_CHECK2       PHY
                    LDA $1534,x
                    TAY
                    LDA $1588,y
                    PLY
                    AND #$04
                    BEQ RETURN58
                    INY
RETURN58            RTS


DEATH_CEHCK         LDA $14D4,x
                    BEQ RETURN37
                    LDA $D8,x
                    CMP #$B0
                    BCC RETURN37
                    LDA #$FF
                    STA $1540,x
                    LDA #$1E
                    STA $1DFB
					LDA $1534,x
                    TAY
					LDA #$00
					STA $14C8,y
RETURN37            RTS





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CALC_DIS            LDY #$00
                    LDA $94
                    AND #$F0
                    STA $1504,x
                    LDA $94
                    SEC                     
                    SBC $E4,x               
                    STA $0F
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABELS             
                    INY                     
LABELS              LDA $E4,x
                    AND #$F0
                    CMP $1504,x
                    BNE NOT_SAME
                    TYA
                    BNE SAME_LEFT
                    LDA $1504,x
                    CLC
                    ADC #$10
                    STA $1504,x
                    LDA $0F
                    CLC
                    ADC #$10
                    STA $0F
                    BRA NOT_SAME
SAME_LEFT           LDA $1504,x
                    SEC
                    SBC #$10
                    STA $1504,x
                    LDA $0F
                    SEC
                    SBC #$10
                    STA $0F
NOT_SAME            TYA
                    BNE FACE_LEFT
                    STZ $157C,x
                    LDA $0F
                    LSR A
                    STA $B6,x
                    BNE RETURN70
                    LDA #$01
                    STA $B6,x
                    BRA RETURN70
FACE_LEFT           LDA #$01
                    STA $157C,x
                    LDA #$FF
                    SEC
                    SBC $0F
                    LSR A
                    STA $0F
                    LDA #$FF
                    SEC
                    SBC $0F
                    STA $B6,x
                    BNE RETURN70
                    LDA #$F5
                    STA $B6,x
RETURN70            PHY
                    LDA $1534,x
                    TAY
                    LDA $B6,x
                    STA $00B6,y
                    PLY
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00
                    LDA $94
                    SEC
                    SBC $E4,x
                    STA $0F
                    LDA $95
                    SBC $14E0,x
                    BPL LABEL16
                    INY
LABEL16             RTS


