;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GreatDeamon DarkKnight
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
                    PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_2
					RTL
INIT_2				LDA #$89
					STA $167A,x
					LDA $E4,x
					AND #$30
					;ASL A
					CLC
					ADC #$60
					STA $151C,x
INIT_E              RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED             dcb $0C,$F4
X_SPEED2            dcb $30,$D0

MAIN5				JSR K_SUB_GFX4
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDY $157C,x
					LDA X_SPEED2,y
					STA $B6,x
					JSL $01802A
					JSL $01A7DC
					RTS
					
MAIN4				CMP #$66
					BEQ MAIN5
					JSR K_SUB_GFX3
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$E0
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					JSL $01A7DC				 ; check for mario/sprite contact
					LDA $15AC,x
					CMP #$01
					BNE RETURN
					STZ $14C8,x
					RTS

RETURN              RTS
CODE_START          LDA EXTRA_BITS,x
					AND #$04
					BNE DEAMON_MAIN
					LDA $C2,x
					BNE MAIN4
					JSR K_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
                    JSL $27FAF4 ;SUB_OFF_SCREEN_X0
                    JSL $01802A
					JSL $01A7DC				 ; check for mario/sprite contact
					INC $1570,x
					LDA $15AC,x
					CMP #$20
					BEQ MAIN3
					CMP #$00
					BNE RETURN
					LDA $1504,x
					CMP #$20
					BCC RETURN
					CMP #$E0
					BCS RETURN
					LDA #$80
					STA $15AC,x
					RTS
MAIN3				JSR GEN_SPRITE
					LDA #$27
					STA $1DFC
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					LDA $D8,x
					CLC
					ADC #$20
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$10
					STA $00C2,y
					LDA #$20
					STA $15AC,y
RETURN4				RTS
					
DEAMON_MAIN			JSR D_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN4
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN4
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN4
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					INC $1570,x
					JSR DAMAGE_CHECK
					LDA $1497
					BEQ DEAMON_MAIN10
					STZ $18BD
DEAMON_MAIN10		STZ $B6,x 
					LDA $15AC,x
					BEQ DEAMON_MAIN1
					CMP #$40
					BCS DEAMON_MAIN1
					BRA NOT_MOVE
DEAMON_MAIN1		LDY $157C,x             ; \ set x speed based on direction
                    LDA X_SPEED,y           ;  |
                    STA $B6,x               ; /
NOT_MOVE			JSL $01802A
					LDA $1588,x             ; \ if sprite is in contact with an object...
                    AND #$03                ; |
                    BEQ AIR_CHECK
                    LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x             ; /
					BRA DEAMON_MAIN2
AIR_CHECK			LDA $1588,x
					AND #$04
					BNE DEAMON_MAIN2
					LDA $157C,x             ; | flip the direction status
                    EOR #$01                ; |
                    STA $157C,x 
DEAMON_MAIN2		LDA $1504,x
					CMP #$20
					BCC RETURN15
					CMP #$E0
					BCS RETURN15
					BRA DEAMON_MAIN3
RETURN15			LDA $151C,x
					STA $15AC,x
RETURN14			RTS
DEAMON_MAIN3		LDA $15AC,x
					CMP #$01
					BNE DEAMON_MAIN4
					LDA #$C0
					STA $15AC,x
					RTS
DEAMON_MAIN4		CMP #$41
					BNE DEAMON_MAIN5
					PHY
                    JSR SUB_GET_DIR
                    TYA
                    STA $157C,x
                    PLY
					RTS
DEAMON_MAIN5		CMP #$20
					BNE RETURN14
					LDA $1504,x
					CMP #$20
					BCC RETURN14
					CMP #$E0
					BCS RETURN14
					JSR GEN_SPRITE
					LDA #$66
					STA $00C2,y
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					LDA $77
					AND #$04
					BEQ RETURN14
					LDA #$30
					STA $18BD
					RTS

DAMAGE_CHECK		LDA $1540,x
					BNE RETURN22
					JSL $01A7DC
					BCC RETURN22
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$08
					BCC ENE_WINS
					LDA $1528,x
					CMP #$02
					BCS WIN2
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					INC $1528,x
					LDA #$60
					STA $1540,x
					RTS
WIN2				LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$03
                    STA $1DF9
					LDA #$02
					STA $14C8,x
					RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN22             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN22            RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
K_SUB_GFX3			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$E6
					STA $0302,y
					LDA #$0C
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
					RTS

K_PROPERTIES3       dcb $4E,$0E
K_SUB_GFX4			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$8A
					STA $0302,y
					PHX
					LDA $157C,x
					TAX
					LDA K_PROPERTIES3,x
					PLX
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
					RTS


K_HORIZ_DISP          dcb $F8,$08,$F8,$08
K_VERT_DISP           dcb $F0,$F0,$00,$00
K_TILEMAP             dcb $44,$46,$64,$66,$48,$4A,$68,$6A,$4C,$4C,$4E,$4E
K_PROPERTIES          dcb $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$4D,$0D,$4D,$0D

K_HORIZ_DISP2          dcb $F8,$08,$F8,$08,$00
K_VERT_DISP2           dcb $F0,$F0,$00,$00,$E0
K_TILEMAP2             dcb $40,$40,$60,$62,$20
K_PROPERTIES2          dcb $0D,$4D,$0D,$0D,$0D


K_SUB_GFX           JSR GET_DRAW_INFO
					LDA $00
					STA $1504,x
					LDA $15AC,x
					BEQ K_SUB_GFX_2
					CMP #$20
					BCC K_SUB_GFX_1
					CMP #$40
					BCC K_SUB_GFX_3
					BRA K_SUB_GFX_2
K_SUB_GFX_1			LDA #$08
					STA $03
					BRA K_SUB_GFX_4
K_SUB_GFX_2			LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
					
K_SUB_GFX_4			PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
K_LOOP_START        PHX                     ; push, current tile

					LDA $00
					CLC
					ADC K_HORIZ_DISP,x
					STA $0300,y
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC K_VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					TXA
					CLC
					ADC $03
					TAX
                    
                    LDA K_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA K_PROPERTIES,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL K_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
K_SUB_GFX_3         PHX
                    LDX #$04
K_LOOP_START2       PHX                     ; push, current tile

					LDA $00
					CLC
					ADC K_HORIZ_DISP2,x
					STA $300,y
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC K_VERT_DISP2,x         ; |
                    STA $0301,y             ; /
                    
                    LDA K_TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; /

					LDA K_PROPERTIES2,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL K_LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


D_HORIZ_DISP        dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
					dcb $10,$00,$F0,$10,$00,$F0,$10,$00,$F0
					dcb $F0,$00,$F0,$00,$10,$F0,$00,$10
					dcb $10,$00,$10,$00,$F0,$10,$00,$F0
					dcb $F0,$00,$10,$F0,$00,$08,$F0,$00,$10
					dcb $10,$00,$F0,$10,$00,$F8,$10,$00,$F0
					dcb $F8,$08,$F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8,$08,$F8
					dcb $F8,$08,$F8,$08,$F8,$08,$F4,$04
					dcb $08,$F8,$08,$F8,$08,$F8,$0C,$FC
					dcb $E8,$F8,$08,$E8,$F8,$08,$E2
					dcb $18,$08,$F8,$18,$08,$F8,$1E
D_VERT_DISP         dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00
					dcb $E0,$E0,$F0,$F0,$F0,$00,$00,$00
					dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00
					dcb $E0,$E0,$F0,$F0,$00,$00
					dcb $D0,$D0,$E0,$E0,$F0,$F0,$00,$00
					dcb $F0,$F0,$F0,$00,$00,$00,$08
D_TILEMAP           dcb $A0,$A2,$A4,$C0,$C2,$C4,$E0,$E2,$E4
					dcb $86,$88,$A6,$A8,$AA,$C6,$C8,$CA
					dcb $A0,$A2,$A4,$C0,$EB,$EC,$80,$82,$84
					dcb $8C,$8E,$AC,$AE,$CC,$CE
					dcb $42,$0A,$28,$2A,$0C,$0E,$2C,$2E
					dcb $00,$04,$06,$02,$24,$26,$22
D_PROPERTIES        dcb $4E,$0E
TILE_NUM			dcb $08,$07,$08,$05,$07,$06
OFFSET				dcb $00,$09,$11,$1A,$20,$28

D_SUB_GFX_R			RTS
D_SUB_GFX           JSR GET_DRAW_INFO
					LDA $00
					STA $1504,x
					LDA $1540,x
					AND #$01
					BNE D_SUB_GFX_R
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					STA $03
					CMP #$03
					BNE GFX1
					LDA #$01
					STA $03
GFX1				LDA $15AC,x
					BEQ GFX4
					CMP #$40
					BCS GFX4
					CMP #$20
					BCS GFX5
					LDA #$05
					STA $03
					BRA GFX4
GFX5				CMP #$30
					BCS GFX6
					LDA #$04
					STA $03
					BRA GFX4
GFX6				LDA #$03
					STA $03
GFX4				PHX
					LDX $03
					LDA TILE_NUM,x
					STA $0F
					LDA OFFSET,x
					STA $7FEE0F
					CLC
					ADC $7FEE0F
					STA $7FEE0E
					PLX
					LDA $157C,x
					STA $02
					BNE GFX2
					LDA $7FEE0E
					CLC
					ADC $0F
					ADC #$01
					STA $7FEE0E
					
GFX2				PHX
					LDX $02
					LDA D_PROPERTIES,x
					STA $7FEE0D
					LDA $03
					CMP #$04
					BCC GFX3
					LDA $7FEE0D
					INC A
					STA $7FEE0D
GFX3                LDX $0F
D_LOOP_START        PHX                     ; push, current tile
                    
					TXA
					CLC
					ADC $7FEE0F
					TAX
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC D_VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
                    LDA D_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
					
					PHX
					TXA
					CLC
					ADC $7FEE0E
					TAX
					
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC D_HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

					LDA $7FEE0D
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL D_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA $0F
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_OFFSET			dcb $1E,$E2
GEN_OFFSET2			dcb $00,$FF

RETURN67            RTS
GEN_SPRITE          LDY $157C,x
					LDA GEN_OFFSET,y
					STA $02
					LDA GEN_OFFSET2,y
					STA $03
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
					CLC
					ADC $02
                    STA $00E4,y
                    LDA $14E0,x
					ADC $03
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$09
					STA $1656,y
					LDA #$0B
					STA $167A,y
					LDA $157C,x
					STA $157C,y
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     






