;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Big Kirby
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $C2,x
					STZ $1528,x
					STZ $1504,x
					LDA #$20
					STA $15AC,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN              RTS                    
START_HB_CODE       JSR HDMA1
					LDA $1468
					CMP #$80
					BCC M_FACE
					JSR FACE
M_FACE				LDA $C2,x
					BEQ MAIN1
					CMP #$03
					BEQ MAIN30_0
					CMP #$01
					BNE MAIN0
					JSR SUB_GFX             ; draw hammer bro gfx
					BRA MAIN
MAIN0				JSR SUB_GFX2
					BRA MAIN
MAIN1				LDA $1602,x
					BEQ MAIN
					JSR SUB_GFX3
MAIN                LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$02                ;  }   ... not (killed with spin jump [4] or star[2])
                    BEQ RETURN 
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $C2,x
					CMP #$01
					BEQ MAIN10
					CMP #$02
					BEQ MAIN20
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D8,x
					LDA $7FF003
					CMP #$04
					BNE MAIN_M
					JSR MODE_CHANGE
					RTS
MAIN_M				CMP #$09
					BEQ MAIN40_0
					JSR SUBMODE
					RTS
MAIN30_0			BRA MAIN30
MAIN10				STZ $B6,x
					LDA #$30
					STA $AA,x
					JSL $01802A
					LDA $D8,x
					CMP #$D0
					BCC MAIN10_E
					STZ $14C8,x
MAIN10_E			RTS
MAIN40_0			BRA MAIN40_A
MAIN20				STZ $B6,x
					LDA #$30
					STA $AA,x
					JSL $01802A
					LDA $14
					AND #$03
					BNE MAIN20_3
					LDA $E4,x               ;
                    STA $9A                 ;
                    LDA $14E0,x             ;
                    STA $9B                 ;
                    LDA $D8,x               ;
                    STA $98                 ;
                    LDA $14D4,x             ;
                    STA $99                 ;
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA $9A
					CLC
					ADC #$10
					STA $9A
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
MAIN20_3			LDA $D8,x
					CMP #$FE
					BCC MAIN20_E
					STZ $14C8,x
MAIN20_E			RTS

MAIN40_A			BRA MAIN40
MAIN30				LDA $15AC,x
					CMP #$20
					BCC MAIN31
					JSR SUB_GFX4
					BRA MAIN32
MAIN31				JSR SUB_GFX5
MAIN32				LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$02                ;  }   ... not (killed with spin jump [4] or star[2])
                    BEQ MAIN3E
                    CMP #$08
                    BNE MAIN3E
                    LDA $9D                 ; \ if sprites locked...
                    BNE MAIN3E
					LDA $AA,x
					PHA
					JSL $01802A
					PLA
					STA $AA,x
					LDA $15AC,x
					BEQ MAIN3R
					CMP #$10
					BCS MAIN3E
					JSL $01A7DC
					BCC MAIN3E
					LDA $1497               ; \ if mario is invincible...
                    BNE MAIN3E             ; /   ... return
                    JSL $00F5B7             ; hurt mario
MAIN3E				RTS
MAIN3R				STZ $14C8,x
					RTS
MAIN40				STZ $1602,x
					LDA #$1E
					STA $1DFB
					LDA #$00
					STA $7FF002
					LDA $14AD
					CMP #$D0
					BCS MAIN4E
					CMP #$CF
					BEQ MAIN41
					DEC $1468
					LDA $1468
					BNE MAIN4E
					LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
MAIN4E				RTS
MAIN41				STZ $14AD
					LDA #$26
					STA $1DF9
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE_CHANGE			STZ $14AD
					STZ $1602,x
					STZ $15AC,x
					LDA $1467
					BNE CHANGE2
					LDA #$00
					STA $7FF002
					DEC $1468
					LDA $1468
					BNE CHANGE_E
					LDA #$FF
					STA $1467
CHANGE_E			RTS
CHANGE2				INC $1468
					LDA $1468
					CMP #$B0
					BNE CHANGE_E
					LDA #$05
					STA $7FF003
					LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $1528,x
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_POS				dcb $40,$C0,$80,$60,$90,$B0,$40,$D0,$B0,$C0,$A0,$E0,$D0,$50,$80,$60

RETURN67            RTS
STONE_GEN           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					PHX 
					LDA $1504,x
					AND #$0F
					TAX
					LDA X_POS,x
					PLX
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

					LDA #$10
                    STA $00D8,y             ;  |
					LDA #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUBMODE				LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			JSR MODE3
					RTS

MODE0				LDA $15AC,x
					BNE MODE0_2
					LDA #$20
					STA $15AC,x
					JSR STONE_GEN
					LDA #$01
					STA $00C2,y
					INC $1504,x
MODE0_2				LDA $13
					AND #$03
					BNE MODE0_E
					INC $1468
					LDA $1468
					CMP #$B0
					BNE MODE0_E
					LDA #$01
					STA $1528,x
					LDA #$29
					STA $13BF
					LDA #$02
					STA $1426
					LDA #$F0
					STA $15AC,x
MODE0_E				RTS

MODE1				LDA $15AC,x
					CMP #$B0
					BEQ MODE1_G1
					CMP #$50
					BEQ MODE1_G2
					CMP #$00
					BEQ MODE1_E
					RTS
MODE1_E				LDA #$02
					STA $1528,x
					STZ $1504,x
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $7FF002
					RTS
MODE1_G1			LDA #$20
					STA $13BF
					LDA #$2B
					STA $1DFC
					STZ $1504,x
					JSR STONE_GEN
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $1602,y
					RTS
MODE1_G2			LDA #$2B
					STA $1DFC
					LDA #$05
					STA $1504,x
					JSR STONE_GEN
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $1602,y
					RTS
					
MODE2				LDA $1504,x
					BNE MODE2_4
					STZ $1602,x
					LDA $15AC,x
					BEQ MODE2_3
					CMP #$C0
					BCS MODE2_E
					CMP #$30
					BCC MODE2_E
					CMP #$30
					BEQ MODE2_2
					LDA #$01
					STA $1602,x
MODE2_E				RTS
MODE2_2				JSR STONE_GEN
					JSR SPEED_DEC
					LDA #$03
					STA $00C2,y
					LDA #$78
					STA $00E4,y
					LDA #$90
					STA $00D8,y
					LDA #$40
					STA $15AC,y
					LDA #$17
					STA $1DFC
					RTS
MODE2_3				LDA $7FF003
					CMP #$04
					BCS MODE2_3_2
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $1504,x
					RTS
MODE2_3_2			LDA #$30
					STA $15AC,x
					LDA #$01
					STA $1504,x
					RTS
MODE2_4				LDA $15AC,x
					BNE MODE2_E
					STZ $1504,x
					LDA $7FF003
					CMP #$04
					BCS MODE2_4_2
					LDA #$FF
					STA $15AC,x
					RTS
MODE2_4_2			LDA #$80
					STA $15AC,x
					RTS
					
MODE3				LDA $15AC,x
					BEQ MODE3_E
					CMP #$D0
					BEQ MODE3_G1
					CMP #$90
					BEQ MODE3_G2
					CMP #$50
					BEQ MODE3_G3
					RTS
MODE3_E				LDA #$02
					STA $1528,x
					STZ $1504,x
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $7FF002
					RTS
MODE3_G1			LDA #$2B
					STA $1DFC
					STZ $1504,x
					JSR STONE_GEN
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $1602,y
					LDA #$00
					STA $00E4,y
					RTS
MODE3_G2			LDA #$2B
					STA $1DFC
					STZ $1504,x
					JSR STONE_GEN
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $1602,y
					LDA #$70
					STA $00E4,y
					RTS
					
MODE3_G3			LDA #$2B
					STA $1DFC
					STZ $1504,x
					JSR STONE_GEN
					LDA #$02
					STA $00C2,y
					LDA #$00
					STA $1602,y
					LDA #$E0
					STA $00E4,y
					RTS
					
SPEED_DEC			LDA $94
					CMP #$80
					BCS SPEED_DEC2
					LDA #$80
					SEC
					SBC $94
					LSR A
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $00B6,y
					BRA SPEED_DEC3
SPEED_DEC2			LDA $94
					SEC
					SBC #$80
					LSR A
					LSR A
					STA $00B6,y
SPEED_DEC3			LDA $96
					CLC
					ADC #$10
					STA $0F
					CMP #$90
					BCS SPEED_DEC4
					LDA #$90
					SEC
					SBC $0F
					LSR A
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $00AA,y
					RTS
SPEED_DEC4			LDA $0F
					SEC
					SBC #$90
					LSR A
					LSR A
					STA $00AA,y
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FACE				LDA $19
					BEQ FACE2
					LDA $0D87
					CMP #$80
					BNE FACE1
					LDA $0D86
					CMP #$51
					BEQ FACE_E
					LDA $0D86
					CMP #$58
					BEQ FACE_E
FACE1				LDA #$71
					STA $0D86
					LDA #$00
					STA $0D85
					LDA #$73
					STA $0D90
					LDA #$00
					STA $0D8F
					RTS
FACE2				LDA $0D92
					CMP #$73
					BNE FACE3
					LDA $0D91
					CMP #$80
					BEQ FACE_E
					BRA FACE4
FACE3				CMP #$56
					BNE FACE4
					LDA $0D91
					CMP #$40
					BEQ FACE_E
FACE4				LDA #$78
					STA $0D88
					LDA #$C0
					STA $0D87
					LDA #$6A
					STA $0D90
					LDA #$80
					STA $0D8F
FACE_E				RTS

RETURN_HDMA			RTS
HDMA1				
					LDA $7FFB28
					;BNE HDMA1_1
					BNE RETURN_HDMA
					LDA #$02
					STA $00212E
					LDA #$17
					STA $00212C
					LDA #$00
					STA $00212D
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB21
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					
					LDA #$23
					STA $7FFB22
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					STA $7FFB33
					LDA #$E0
					STA $7FFB24
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					STA $7FFB35

HDMA1_1				LDA #$70
					STA $7FE000
					LDA #$00
					STA $7FE001
					LDA #$28
					STA $7FE002
					LDA #$00
					STA $7FE003
					LDA #$01
					STA $7FE004
					LDA #$F0
					STA $7FE005
					LDA #$00
					STA $7FE006

					LDA #$58
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$42
					STA $7FE201
					LDA #$04
					STA $7FE202
					
					LDA #$04
					STA $7FE102
					STA $7FE203
					LDA #$00
					STA $7FE103
					LDA #$43
					STA $7FE204
					LDA #$0C
					STA $7FE205
					
					LDA #$04
					STA $7FE104
					STA $7FE206
					LDA #$00
					STA $7FE105
					LDA #$64
					STA $7FE207
					LDA #$14
					STA $7FE208
					
					LDA #$04
					STA $7FE106
					STA $7FE209
					LDA #$00
					STA $7FE107
					LDA #$86
					STA $7FE20A
					LDA #$1C
					STA $7FE20B
					
					LDA #$04
					STA $7FE108
					STA $7FE20C
					LDA #$00
					STA $7FE109
					LDA #$A7
					STA $7FE20D
					LDA #$24
					STA $7FE20E
					
					LDA #$04
					STA $7FE10A
					STA $7FE20F
					LDA #$00
					STA $7FE10B
					LDA #$C9
					STA $7FE210
					LDA #$2C
					STA $7FE211
					
					LDA #$04
					STA $7FE10C
					STA $7FE212
					LDA #$00
					STA $7FE10D
					LDA #$0A
					STA $7FE213
					LDA #$35
					STA $7FE214
					
					LDA #$04
					STA $7FE10E
					STA $7FE215
					LDA #$00
					STA $7FE10F
					LDA #$2D
					STA $7FE216
					LDA #$3D
					STA $7FE217
					
					LDA #$04
					STA $7FE110
					STA $7FE218
					LDA #$00
					STA $7FE111
					LDA #$4F
					STA $7FE219
					LDA #$35
					STA $7FE21A
					
					LDA #$04
					STA $7FE112
					STA $7FE21B
					LDA #$00
					STA $7FE113
					LDA #$92
					STA $7FE21C
					LDA #$2D
					STA $7FE21D
					
					LDA #$04
					STA $7FE114
					STA $7FE21E
					LDA #$00
					STA $7FE115
					LDA #$B4
					STA $7FE21F
					LDA #$25
					STA $7FE220
					
					LDA #$04
					STA $7FE116
					STA $7FE221
					LDA #$00
					STA $7FE117
					LDA #$37
					STA $7FE222
					LDA #$1E
					STA $7FE223
					
					LDA #$04
					STA $7FE118
					STA $7FE224
					LDA #$00
					STA $7FE119
					LDA #$B9
					STA $7FE225
					LDA #$16
					STA $7FE226
					
					LDA #$04
					STA $7FE11A
					STA $7FE227
					LDA #$00
					STA $7FE11B
					LDA #$5C
					STA $7FE228
					LDA #$17
					STA $7FE229
					
					LDA #$04
					STA $7FE11C
					STA $7FE22A
					LDA #$00
					STA $7FE11D
					LDA #$FF
					STA $7FE22B
					LDA #$37
					STA $7FE22C
					
					LDA #$04
					STA $7FE11E
					STA $7FE22D
					LDA #$00
					STA $7FE11F
					LDA #$00
					STA $7FE22E
					LDA #$00
					STA $7FE22F
					
					LDA #$00
					STA $7FE120
					STA $7FE230
					RTS






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $00
                    STA $0300,y             ; /                  

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y
                    

                    LDA #$80
                    STA $0302,y             ; / 

        
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $A0,$A2,$C0,$C2
VERT_DISP           dcb $F0,$F0,$00,$00
HORZ_DISP99			dcb $00,$10,$00,$10

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC                     ;  |
                    ADC HORZ_DISP99,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					

                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					
					LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORZ_DISP3           dcb $F0,$10,$F0,$10
VERT_DISP3           dcb $00,$00,$20,$20
PROPETIES3			 dcb $00,$40,$40,$00 

SUB_GFX3             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START3          
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP3,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC                     ;  |
                    ADC HORZ_DISP3,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
                    LDA #$C4
                    STA $0302,y             ; / 
					
					LDA PROPETIES3,x
					ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
SUB_GFX4             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $00
                    STA $0300,y             ; /                  

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC
					ADC #$F8
                    STA $0301,y
                    

                    LDA #$82
                    STA $0302,y             ; / 

        
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP5             dcb $84,$86,$A4,$A6
HORZ_DISP5           dcb $F8,$08,$F8,$08
VERT_DISP5           dcb $F0,$F0,$00,$00

SUB_GFX5             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START5         
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP5,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
					CLC                     ;  |
                    ADC HORZ_DISP5,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
                    LDA TILEMAP5,x
                    STA $0302,y             ; / 
					
					LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START5          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
