;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; bg[
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$5B
					BEQ QUINT_INIT
                    JSR SUB_HORZ_POS
                    TYA
                    STA $157C,x
					RTL
QUINT_INIT			LDA #$01
					STA $1504,x
					LDA #$83
					STA $167A,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPEED				dcb $08,$F8
SPEED2				dcb $28,$D8
X_SPEED				dcb $40,$C0

START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR METTOLE
					RTS
MAIN1				JSR QUINT
					RTS
					
SPEED_Q				dcb $D8,$28

QUINT				JSR SUB_GFX_Q
					LDA $9D
					BNE QUINT_R
					JSL $01802A
					JSR MARIO_CHECK_Q
					LDA $C2,x
					CMP #$01
					BEQ QUINT_2
					REP #$20
					LDA $1462
					CMP.W #$01E0
					BCC QUINT_1
					SEP #$20
					LDA $15AC,x
					CMP #$20
					BCS QUINT_R
					LDA #$01
					STA $C2,x
					LDA #$23
					STA $1DFB
					RTS
QUINT_1				SEP #$20
					LDA #$80
					STA $15AC,x
QUINT_R				RTS
QUINT_2				LDA $1528,x
					CMP #$03
					BCS QUINT_6
					LDA $15AC,x
					CMP #$01
					BEQ QUINT_4
					BCS QUINT_3
					LDA $157C,x
					TAY
					LDA SPEED_Q,y
					STA $B6,x
					LDA $1588,x
					AND #$01
					BNE QUINT_RIGHT
					LDA $1588,x
					AND #$08
					BNE QUINT_UP
					LDA $1588,x
					AND #$02
					BNE QUINT_LEFT
					LDA $14E0,x
					CMP #$01
					BNE QUINT_5
					LDA $E4,x
					CMP #$F0
					BCC QUINT_LEFT
QUINT_5				LDA $1588,x
					AND #$04
					BEQ QUINT_R
					LDA #$10
					STA $15AC,x
					RTS
QUINT_6				LDA #$1E
					STA $1DFB
					JSR TIUN
					RTS
QUINT_RIGHT			STZ $157C,x
					BRA QUINT_5
QUINT_LEFT			LDA #$01
					STA $157C,x
					BRA QUINT_5
QUINT_UP			STZ $AA,x
					RTS
QUINT_3				STZ $B6,x
					RTS
QUINT_4				LDA #$B0
					STA $AA,x
					RTS

RETURN              RTS
METTOLE				JSR SUB_GFX
					LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$08                ;  }   ... not (killed with spin jump [4] or star[2])
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR MARIO_CHECK
					LDA $1558,x
					BNE RETURN
					JSL $01802A
					LDA $C2,x
					BNE METT0_2
					JSR METT0
					RTS
METT0_2				CMP #$01
					BNE METT0_3
					JSR METT2
					RTS
METT0_3				JSR METT4
					RTS
					
METT0				JSR SUB_HORZ_POS
					REP #$30
					LDA $0E
					CMP.W #$0060
					BCC METT0_0
					CMP.W #$FFA0
					BCS METT0_0
					SEP #$30
					RTS
METT0_0				SEP #$30
					LDA EXTRA_BITS,x
					AND #$04
					BNE METT0_1
					LDA #$01
					STA $C2,x
					JSR GEN_ENE
					LDA #$01
					STA $1602,x
					LDA #$60
					STA $15AC,x
RETURN2				RTS
METT0_1				LDA #$02
					STA $C2,x
					LDA #$A0
					STA $15AC,x
					RTS

METT3				CMP #$60
					BNE METT3_2
					JSR GEN_ENE
METT3_2				STZ $1602,x
					JSR SUB_HORZ_POS
                    TYA
                    STA $157C,x
					LDA #$81
					STA $167A,x
					LDA #$38
					STA $166E,x
RETURN4				RTS
METT2				STZ $B6,x
					LDA $15AC,x
					CMP #$60
					BCS METT3
					LDA #$01
					STA $1602,x
					LDA #$01
					STA $167A,x
					LDA #$08
					STA $166E,x
					LDA $15AC,x
					BEQ METT2_3
					CMP #$40
					BCS RETURN4
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					INC A
					STA $1602,x
					LDA $157C,x
					BEQ METT2_2
					LDA $1588,x
					AND #$02
					BNE METT2_1
					LDA #$F0
					STA $B6,x
RETURN3				RTS
METT2_1				LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					RTS
METT2_3				LDA #$A0
					STA $15AC,x
					RTS
METT2_2				LDA $1588,x
					AND #$01
					BNE METT2_4
					LDA #$10
					STA $B6,x
					RTS
METT2_4				LDA $E4,x
					SEC
					SBC #$01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS
					
METT4_1				CMP #$00
					BEQ METT4_4
					STZ $1602,x
					JSR SUB_HORZ_POS
                    TYA
                    STA $157C,x
					LDA #$81
					STA $167A,x
					LDA #$38
					STA $166E,x
					RTS
METT4_4				LDA #$A0
					STA $15AC,x
					RTS
METT4				LDA $15AC,x
					CMP #$30
					BCC METT4_1
					LDA #$01
					STA $1602,x
					LDA #$01
					STA $167A,x
					LDA #$08
					STA $166E,x
					LDA $15AC,x
					AND #$1F
					BEQ METT4_2
					RTS
METT4_2				LDA $157C,x
					BNE METT4_3
					JSR SPIT
					LDA #$18
					STA $1747,y
					LDA #$00
					STA $173D,y
					RTS
METT4_3				JSR SPIT
					LDA #$E8
					STA $1747,y
					LDA #$00
					STA $173D,y
					RTS

MARIO_CHECK_Q		JSL $01A7DC
					BCS ENE_WINS
					LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS MARIO_CHECK_Q2
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
MARIO_CHECK_QR		RTS
MARIO_CHECK_Q2		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS
					LDA $0F
					CMP #$18
					BCC ENE_WINS
					LDA #$C0
					STA $7D
					JSL $01AB99
					LDA $1540,x
					BNE MARIO_CHECK_QR
					LDA #$40
					STA $1540,x
					INC $1528,x
					LDA #$28
					STA $1DFC
					RTS

ENE_WINS			LDA $1497
                    BNE MARIO_CHECK_R
                    JSL $00F5B7
MARIO_CHECK_R       RTS
MARIO_CHECK			LDA $1602,x
					BEQ MARIO_CHECK_2
					JSL $01A7DC
					RTS
MARIO_CHECK_2		JSL $01A7DC
					BCC MARIO_CHECK_R
					LDA $7D
					BMI ENE_WINS
					CMP #$10
					BCC ENE_WINS
					LDA #$B0
					STA $7D
					JSL $01AB99
					LDA #$03
					STA $1DF9
					RTS
					
GEN_ENE				LDA $157C,x
					BNE GEN_ENE_2
					JSR SPIT
					LDA #$18
					STA $1747,y
					LDA #$00
					STA $173D,y
					JSR SPIT
					LDA #$10
					STA $1747,y
					LDA #$0C
					STA $173D,y
					JSR SPIT
					LDA #$10
					STA $1747,y
					LDA #$F4
					STA $173D,y
					RTS
GEN_ENE_2			JSR SPIT
					LDA #$E8
					STA $1747,y
					LDA #$00
					STA $173D,y
					JSR SPIT
					LDA #$F0
					STA $1747,y
					LDA #$0C
					STA $173D,y
					JSR SPIT
					LDA #$F0
					STA $1747,y
					LDA #$F4
					STA $173D,y
					RTS

SPIT                LDY #$E8
                    LDA $157C,x
                    AND #$01
                    BNE LABEL9
                    LDY #$18
LABEL9              STY $00
                    LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     
LABEL7              LDA #$02                ; \ projectile is a fireball
                    STA $170B,y             ; /

                    LDA $E4,x               ; \ set x position
                    STA $171F,y             ;  |
                    LDA $14E0,x             ;  |
                    STA $1733,y             ; /
                    
                    LDA $D8,x               ; \ set y position
					CLC
					ADC #$04
                    STA $1715,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
                    STA $1729,y             ; /
LABEL6              RTS

RETURN67            RTS
TIUN                JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$3B
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$99
					STA $00C2,y
					LDA #$00
					STA $1570,y
					LDA #$2C
					STA $1DFC
					STZ $14C8,x
					LDA #$01
					STA $7FFEE0
					LDA $7FFE00
					TAY
					LDA #$F0
					STA $15AC,y
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_Q			dcb $8A,$8C,$8E,$CA,$CC
					dcb $8A,$E8,$EA,$EC,$CC
HORZ_DISP_Q			dcb $00,$00,$00,$F0,$10
					dcb $00,$00,$00,$10,$F0
VERT_DISP_Q			dcb $EC,$FC,$0C,$F4,$F4
					dcb $EC,$FC,$0C,$FB,$F4
PROPETIES_Q			dcb $0D,$0D,$0D,$0D,$0D
					dcb $4D,$4D,$4D,$4D,$4D
					
SUB_GFX_Q_R			RTS
SUB_GFX_Q			LDA $1540,x
					AND #$02
					BNE SUB_GFX_Q_R
					JSR GET_DRAW_INFO
					STZ $02
					STZ $03
					LDA $157C,x
					BEQ SUB_GFX_Q_1
					LDA #$05
					STA $02
SUB_GFX_Q_1			LDA $15AC,x
					BEQ SUB_GFX_Q_2
					LDA #$05
					STA $03
SUB_GFX_Q_2			PHX
					LDX #$04
LOOP_Q				PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP_Q,x
					STA $0300,y
					LDA PROPETIES_Q,x
					ORA $64
					STA $0303,y
					PLX
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $01
					CLC
					ADC VERT_DISP_Q,x
					STA $0301,y
					LDA TILEMAP_Q,x
					STA $0302,y
					PLX
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_Q
					PLX
                    LDY #$02
                    LDA #$04
                    JSL $01B7B3
                    RTS


TILEMAP             dcb $86,$88,$E2,$E2
					dcb $86,$88,$A6,$A8
					dcb $C6,$C8,$E6,$E8
HORZ_DISP			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISP			dcb $00,$00,$F0,$F0
					dcb $F7,$F7,$07,$07
					dcb $F0,$F0,$00,$00
PROPETIES			dcb $09,$09,$09,$09
					dcb $49,$49,$49,$49

SUB_GFX             JSR GET_DRAW_INFO
                    PHX
					LDA $1602,x
					ASL A
					ASL A
					STA $02
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					LDX #$03
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00
                    STA $0300,y
					LDA TILEMAP,x
					STA $0302,y
					PLX
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0300,y
					LDA PROPETIES,x
					ORA $64
					STA $0303,y
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0E                 
                    LDA $95                
                    SBC $14E0,x             
					STA $0F
                    BPL LABEL16             
                    INY
LABEL16             RTS                     


