;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;~[WpX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			LDA EXTRA_BITS,x
			AND #$04
			BEQ NOT_DEATH
			LDA #$09
			STA $1504,x
			RTL
NOT_DEATH	LDA $010B
			CMP #$23
			BEQ BOMB_INIT
			CMP #$3F
			BEQ ROOM2_INIT
			CMP #$7A
			BEQ ITEM_INIT
			CMP #$4B
			BEQ MAP4B_INIT
			CMP #$4C
			BEQ LESALESA_INIT
			RTL
LESALESA_INIT
			LDA #$0B
			STA $1504,x
			RTL
MAP4B_INIT	LDA #$0A
			STA $1504,x
			LDA #$48
			STA $1468
			STZ $1469
			RTL
BOMB_INIT	STZ $1504,x
			LDA #$04
			STA $15F6,x
			LDA $D8,x
			STA $1528,x
			LDA $14D4,x
			STA $151C,x
LAVA_CHECK	LDA $D8,x
			CLC
			ADC #$10
			STA $D8,x
			LDA $14D4,x
			ADC #$00
			STA $14D4,x
			JSL $019138
			LDA $164A,x ;#`FbNH
			BEQ LAVA_CHECK
			RTL
ROOM2_INIT	LDA $14E0,x
			BEQ TRAP0_INIT
			CMP #$04
			BEQ PIRAHA3_INIT
			LDA $E4,x
			ORA #$08
			STA $E4,x
			LDA $14E0,x
			CMP #$03
			BEQ PIRAHA2_INIT
			LDA #$02
			STA $1504,x
			LDA #$20
			STA $1540,x
			RTL
PIRAHA3_INIT
			LDA #$04
			STA $1504,x
			RTL
ITEM_INIT	LDA #$19
			STA $1686,x
			LDA #$06
			STA $1504,x
			LDA $14E0,x
			CMP #$01
			BEQ INIT_R
			LDA #$08
			STA $1504,x
			LDA $E4,x
			ORA #$08
			STA $E4,x
INIT_R		RTL
TRAP0_INIT	LDA #$01
			STA $1504,x
			LDA #$60
			STA $15AC,x
			RTL
PIRAHA2_INIT
			LDA #$03
			STA $1504,x
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;MAIN
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;
SPRITE_ROUTINE
			LDA $1504,x
			BNE MAIN1
			JSR BUBLE_MAIN
			RTS
MAIN1		CMP #$01
			BNE MAIN2
			JSR TRAP0
			RTS
MAIN2		CMP #$02
			BNE MAIN3
			JSR PIRAHA1
			RTS
MAIN3		CMP #$03
			BNE MAIN4
			JSR PIRAHA2
			RTS
MAIN4		CMP #$04
			BNE MAIN5
			JSR PIRAHA_GEN
			RTS
MAIN5		CMP #$05
			BNE MAIN6
			JSR PIRAHA3
			RTS
MAIN6		CMP #$06
			BNE MAIN7
			JSR GOAL
			RTS
MAIN7		CMP #$07
			BNE MAIN8
			JSR TRAP1
			RTS
MAIN8		CMP #$08
			BNE MAIN9
			JSR MASH
			RTS
MAIN9		CMP #$09
			BNE MAINA
			JSR DEATH
			RTS
MAINA		CMP #$0A
			BNE MAINB
			JSR MAP4B
			RTS
MAINB		JSR LESALESA
			RTS
			
			
LESALESA	JSR SUB_GFX_LE
			LDA $9D
			BNE LESALESA_R
			LDA $C2,x
			BNE LESALESA_2
			LDA $15AC,x
			BEQ LESALESA_1
			CMP #$F0
			BEQ LESALESA_3
			CMP #$EF
			BEQ LESALESA_4
			CMP #$EE
			BEQ LESALESA_5
			RTS
LESALESA_1	LDA $94
			CMP #$A0
			BCC LESALESA_R
			LDA #$FF
			STA $15AC,x
LESALESA_R	RTS
LESALESA_3	LDA #$01
			STA $1426
			RTS
LESALESA_4	LDA #$02
			STA $1426
			RTS
LESALESA_5	LDA #$06
			STA $71
			STZ $89
			STZ $88
			LDA $1FF2
			ORA #$08
			STA $1FF2
			RTS
LESALESA_2	CMP #$02
			BEQ LESALESA_7
			LDA $94
			STA $E4,x
			LDA $95
			STA $14E0,x
			INC $1570,x
			LDA $1570,x
			LSR A
			AND #$1F
			CMP #$10
			BCC LESALESA_6
			EOR #$FF
			AND #$0F
LESALESA_6	CLC
			ADC #$20
			STA $02
			LDA $96
			SEC
			SBC $02
			STA $D8,x
			LDA $97
			SBC #$00
			STA $14D4,x
			RTS
LESALESA_7	LDA $15AC,x
			CMP #$D0
			BCS LESALESA_8
			CMP #$9F
			BEQ LESALESA_9
			CMP #$90
			BEQ LESALESA_A
			CMP #$10
			BEQ LESALESA_B
			CMP #$04
			BEQ LESALESA_C
			RTS
LESALESA_8	LDA #$F8
			STA $AA,x
			JSL $01801A
			RTS
LESALESA_9	LDA #$02
			STA $1602,x
			RTS
LESALESA_A	LDA #$01
			STA $1602,x
			LDA #$21
			STA $1DFC
			LDA #$1E
			STA $1DFB
			LDA #$66
			STA $7FF345
			LDA #$01
			STA $7FE802
			STA $7FE805
			RTS
LESALESA_B	LDA #$22
			STA $13BF
			LDA #$02
			STA $1426
			RTS
LESALESA_C	LDA #$23
			STA $13BF
			LDA $19B9
			STA $19B8
			LDA $19D9
			STA $19D8
			LDA $1B94
			STA $1B93
			LDA #$06
			STA $71
			STZ $89
			STZ $88
			RTS
			
MAP4B		LDA $9D
			BNE MAP4B_R
			LDA $C2,x
			BNE MAP4B_2
			LDA $94
			STA $E4,x
			LDA $95
			STA $14E0,x
			LDA $1FF2
			AND #$08
			BNE MAP4B_R
			LDA $95
			CMP #$03
			BNE MAP4B_R
			LDA $16
			AND #$08
			BEQ MAP4B_R
			INC $C2,x
			LDA #$C0
			STA $15AC,x
			STA $1887
MAP4B_R		RTS
MAP4B_2		LDA $15AC,x
			BEQ MAP4B_R
			LDA $15AC,x
			AND #$1F
			BNE MAP4B_3
			LDA #$17
			STA $1DFC
MAP4B_3		LDA $15AC,x
			CMP #$70
			BCS MAP4B_R
			REP #$20
			INC $1468
			SEP #$20
			RTS

DEATH_DEL2	JSR SUB_SMOKE
			STZ $14C8,x
			STZ $1497
			RTS
DEATH		LDA $7FF345
			CMP #$66
			BEQ DEATH_DEL2
			LDA $1FF2
			AND #$10
			BEQ DEATH_D
			JSR SUB_GFX_DE
			LDA $9D
			BNE DEATH_R
			LDA $010B
			CMP #$5D
			BEQ DEATH_2
			CMP #$4C
			BEQ DEATH_2
			LDA $C2,x
			BNE DEATH_2
			LDA $1FF2
			AND #$08
			BEQ DEATH_2
			JSR GEN_SPRITE
			LDA #$0B
			STA $1504,y
			LDA #$01
			STA $00C2,y
			INC $C2,x
			LDA $010B
			CMP #$BC
			BNE DEATH_2
			LDA #$01
			STA $1602,y
			LDA #$FF
			STA $15AC,y
			LDA #$02
			STA $00C2,y
DEATH_2		LDA $94
			STA $E4,x
			LDA $95
			STA $14E0,x
			LDA $96
			SEC
			SBC #$10
			STA $D8,x
			LDA $97
			SBC #$00
			STA $14D4,x
			LDA $1497
			CMP #$20
			BCS DEATH_R
			LDA #$60
			STA $1497
DEATH_R		RTS
DEATH_D		STZ $14C8,x
			RTS

TRAP0		LDA $9D
			BNE TRAP0_R
			LDA $15AC,x
			BNE TRAP0_R2
			LDA $1468
			CMP #$70
			BEQ TRAP0_D
			DEC $1468
			DEC $1468
			DEC $1468
			DEC $1468
TRAP0_R		RTS
TRAP0_R2	LDA #$C0
			STA $1468
			RTS
TRAP0_D		LDA #$09
			STA $1DFC
			STZ $14C8,x
			RTS

TRAP1		LDA $E4,x
			SEC
			SBC #$30
			STA $E4,x
			LDA $14E0,x
			SBC #$00
			STA $14E0,x
			JSR SUB_SMOKE
			LDA #$0D
			STA $7FFE0F
			JSR GEN_NORMAL
			LDA #$08
			STA $1540,y
			LDA #$00
			STA $157C,y
			
			LDA $E4,x
			CLC
			ADC #$50
			STA $E4,x
			LDA $14E0,x
			ADC #$00
			STA $14E0,x
			JSR SUB_SMOKE
			LDA #$0D
			STA $7FFE0F
			JSR GEN_NORMAL
			LDA #$08
			STA $1540,y
			LDA #$01
			STA $157C,y
			STZ $14C8,x
			RTS
			
PIRAHA_GEN			LDA $9D
					BNE PIRAHA_GEN_R
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					CMP #$04
					BCC PIRAHA_GEN_R
					CMP #$06
					BEQ PIRAHA_GEN_R
					LDA $14
					AND #$3F
					BNE PIRAHA_GEN_R
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$E0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					JSL $01ACF9
					AND #$7F
					CLC
					ADC #$20
					CLC
					ADC $94
					STA $00E4,y
					LDA $95
					ADC #$00
					STA $14E0,y
PIRAHA_GEN_R		RTS
			
PIRAHA1				JSR SUB_GFX_P
					LDA $9D
					BNE PIRAHA1_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					JSL $01801A
					LDA $C2,x
					BEQ PIRAHA1_2
					JSL $01A7DC
					LDY #$00
PIRAHA1_1			LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					PHY
					JSL $01A7DC
					PLY
					INY
					CPY #$07
					BCC PIRAHA1_1
					LDA $D8,x
					SEC
					SBC #$70
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
PIRAHA1_2			LDA $C2,x
					BEQ PIRAHA1_3
					CMP #$01
					BEQ PIRAHA1_4
					CMP #$02
					BEQ PIRAHA1_5
					CMP #$03
					BEQ PIRAHA1_6
PIRAHA1_R			RTS
PIRAHA1_3			STZ $AA,x
					JSR MARIO_NEAR
					LDA $1540,x
					BNE PIRAHA1_R
PIRAHA1_6			INC $C2,x
					LDA #$80
					STA $1540,x
					RTS
PIRAHA1_4			LDA #$F0
					STA $AA,x
					LDA $1540,x
					BNE PIRAHA1_R
					INC $C2,x
					LDA #$68
					STA $1540,x
					RTS
PIRAHA1_5			STZ $AA,x
					LDA $1540,x
					BEQ PIRAHA1_6
					RTS
PIRAHA1_6			LDA #$10
					STA $AA,x
					LDA $1540,x
					BNE PIRAHA1_R
					STZ $C2,x
					LDA #$48
					STA $1540,x
					RTS
					
PIRAHA2				JSR SUB_GFX_P2
					LDA $9D
					BNE PIRAHA2_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					JSL $01801A
					LDA $C2,x
					BEQ PIRAHA2_2
					JSL $01803A
PIRAHA2_2			LDA $C2,x
					BEQ PIRAHA2_3
					CMP #$01
					BEQ PIRAHA2_4
					CMP #$02
					BEQ PIRAHA2_5
					CMP #$03
					BEQ PIRAHA2_6
PIRAHA2_R			RTS
PIRAHA2_3			STZ $AA,x
					JSR MARIO_NEAR
					LDA $1540,x
					BNE PIRAHA2_R
PIRAHA2_6			INC $C2,x
					LDA #$20
					STA $1540,x
					RTS
PIRAHA2_4			LDA #$F0
					STA $AA,x
					LDA $1540,x
					BNE PIRAHA2_R
					INC $C2,x
					LDA #$68
					STA $1540,x
					RTS
PIRAHA2_5			STZ $AA,x
					LDA $1540,x
					BEQ PIRAHA2_6
					AND #$07
					BEQ PIRAHA2_7
					RTS
PIRAHA2_6			LDA #$10
					STA $AA,x
					LDA $1540,x
					BNE PIRAHA2_R
					STZ $C2,x
					LDA #$48
					STA $1540,x
					RTS
PIRAHA2_7			LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					STA $02
					LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     
LABEL7              LDA #$0B                ; \ projectile is a fireball
                    STA $170B,y             ; /
                    LDA $E4,x
                    STA $171F,y             ;  |
                    LDA $14E0,x
                    STA $1733,y             ; /
                    LDA $D8,x
                    STA $1715,y             ;  |
                    LDA $14D4,x
                    STA $1729,y             ; /
					LDA #$C0
					STA $173D,y
					JSL $01ACF9
					AND #$0F
					CLC
					ADC #$10
					STA $1747,y
					LDA $02
					BMI LABEL6
					LDA $1747,y
					CLC
					ADC #$D0
					STA $1747,y 
LABEL6              RTS

PIRAHA3				JSR SUB_GFX_P3
					LDA $9D
					BNE PIRAHA3_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA #$10
					STA $AA,x
					JSL $01801A ;y speed
					JSL $01A7DC
					LDA $14D4,x
					BEQ PIRAHA3_R
					LDA $D8,x
					CMP #$70
					BCC PIRAHA3_R
					STZ $14C8,x
PIRAHA3_R			RTS
			
SUB_SMOKE          LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS
					
MARIO_NEAR			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					REP #$20
					LDA $94
					SEC
					SBC $00
					CMP.W #$FFE0
					BCS MARIO_NEAR_1
					CMP.W #$0020
					BCC MARIO_NEAR_1
					SEP #$20
					RTS
MARIO_NEAR_1		SEP #$20
					LDA #$10
					STA $1540,x
					RTS

BUBLE_MAIN		
			LDA $14C8,x
			CMP #$08
			BNE RETURN

			STZ $15D0,x
			LDA $1558,x
			BEQ SPRITE_MAIN
			STA $15D0,x ;#???
			DEC A
			BNE RETURN
			LDA #$27
			STA $1DFC
RETURN		RTS

SPRITE_MAIN	JSR SPRITE_GFX
			LDA $9D
			BNE RETURN
			JSR BOMBER
			LDA $1540,x
			BNE RETURN
LABEL_04	JSL $01A7DC
			INC $1570,x
			LDA $1570,x
			LSR A
			LSR A
			AND #$01
			STA $1602,x

			LDA $15F6,x
			AND #$7F
			LDY $AA,x
			BMI NOT_INVERTED
			INC $1602,x
			INC $1602,x
			ORA #$80
NOT_INVERTED	
			STA $15F6,x

			JSL $019138
			LDA $164A,x
			BEQ LABEL_00
			LDA $AA,x
			BMI LABEL_00
			JSL $01ACF9 ;#_֐
			AND #$3F
			ADC #$10
			STA $1558,x
			LDA $D8,x
			SEC
			SBC $1528,x
			STA $00
			LDA $14D4,x
			SBC $151C,x
			LSR A
			ROR $00
			LDA $00
			LSR A
			LSR A
			LSR A
			PHX
			TAX
			LDA $01E07B,x ;#̌
			TAY
			PLX
			TYA
			BMI STORE_AA
			STA $1564,x
			LDA #$80
STORE_AA	STA $AA,x
			RTS

LABEL_00	JSR POS_UPDATE
			LDA $14
			AND #$07
			ORA $C2,x
			BNE LABEL_01
			JSL $0285DF ;#GtFNg

LABEL_01	LDA $1564,x
			BNE LABEL_02
			LDA $AA,x
			BMI LABEL_03
			LDY $C2,x
			PHX
			TYX
			CMP $01E091,x
			PLX
			BCS LABEL_02
LABEL_03	CLC
			ADC #$02
			STA $AA,x

LABEL_02	JSL $27FAF4 ;SUB_OFF_SCREEN_X0

			REP #$20
			LDA.w #$8600
			STA $0D8B
			LDA.w #$8800
			STA $0D95
			SEP #$20
			RTS
			
BOMBER		LDA $1540,x
			BNE BOMBER_2
			LDA $1528,x
			CMP $D8,x
			BNE BOMB_R
			LDA $151C,x
			CMP $14D4,x
			BNE BOMB_R
			LDA $15A0,x
			ORA $186C,x
			BNE BOMB_R
			LDA $E4,x
			SEC
			SBC $94
			STA $0F
			LDA $14E0,x
			SBC $95
			BCC BOMBER_L
			LDA $0F
			CMP #$40
			BCC BOMBER_1
			RTS
BOMBER_L	LDA $0F
			CMP #$C0
			BCC BOMB_R
BOMBER_1	LDA #$40
			STA $1540,x
			LDA #$09
			STA $1DFC
BOMBER_2	LDA $1540,x
			CMP #$01
			BEQ DELETE
			PHB 
			LDA #$02
			PHA
			PLB
			JSL $028086
			PLB
BOMB_R		RTS
DELETE		STZ $14C8,x
			RTS
GOAL		LDA $C2,x
			BNE GOAL_2
			JSR SUB_GFX_G
			LDA $9D
			BNE GOAL_R
			JSR STARDUST
			LDA $E4,x
			STA $02
			LDA $14E0,x
			STA $03
			REP #$20
			LDA $02
			SEC
			SBC $94
			BCC GOAL_R
			CMP.W #$0030
			BCS GOAL_R
			SEP #$20
			INC $C2,x
GOAL_R		SEP #$20
			RTS
GOAL_2		JSR SUB_GFX_G2
			LDA $9D
			BNE GOAL_R
			LDA $D8,x
			PHA
			SEC
			SBC #$10
			STA $D8,x
			JSR STARDUST
			PLA
			STA $D8,x
			JSL $01802A
			STZ $B6,x
			LDA $1588,x
			AND #$01
			BNE GOAL_3
			LDA #$30
			STA $B6,x
GOAL_3		LDA $14D4,x
			BEQ GOAL_R
			LDA $D8,x
			CMP #$90
			BCC GOAL_R
			STZ $14C8,x
			RTS
			
MASH		JSR SUB_GFX_M
			LDA $9D
			BNE MASH_R
			JSL $27FB02 ;SUB_OFF_SCREEN_HB
			LDA $E4,x
			STA $02
			LDA $14E0,x
			STA $03
			REP #$20
			LDA $02
			SEC
			SBC $94
			BCC MASH_R
			CMP.W #$0020
			BCS MASH_R
			SEP #$20
			LDA $E4,x
			CMP #$88
			BEQ MASH_0
			LDA #$85
			STA $7FFE0F
			BRA MASH_1
MASH_0		LDA #$78
			STA $7FFE0F
MASH_1		JSR GEN_NORMAL
			LDA #$01
			STA $00C2,y
			STZ $14C8,x
MASH_R		SEP #$20
			RTS
;;;;;;;;;;;;;;;;;;;;;;;
;;
;Pos update		;
;;;;;;;;;;;;;;;;;;;;;;;;;

POS_UPDATE	LDA $AA,x
			PHA
			JSL $01802A
			PLA
			STA $AA,x
			RTS
			

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_GFX	LDA $1602,x
			ASL A
			ASL A
			STA $02

			LDA $15F6,x
			ORA $64
			STA $03

			JSR GET_DRAW_INFO
			LDA $1540,x
			BEQ SPRITE_GFX_2
			RTS
SPRITE_GFX_2
			PHX
			LDX #$03
GFX_LOOP	PHX

			LDA $00
			CLC
			ADC $019CD3,x
			STA $0300,y

			LDA $01
			CLC
			ADC $019CD7,x
			STA $0301,y

			LDA $019CDF,x
			ORA $03
			STA $0303,y

			TXA
			ORA $02
			TAX
			LDA $019C35,x
			STA $0302,y

			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL GFX_LOOP
			PLX
			LDY #$00
			LDA #$03
			JSL $01B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1		dcb $0C,$1C
SPR_T2		dcb $01,$02

GET_DRAW_INFO		
			STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X	LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC.W #$0040
			CMP.W #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP	
			LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y	DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			RTS

INVALID		PLA
			PLA
			RTS


			
STARDUST	LDA $14
			AND #$0F
			BNE STARDUST_R
			JSL $01ACF9
			AND #$0F
			CLC
			LDY #$00
			ADC #$FC
			BPL STARDUST_2
			DEY
STARDUST_2	CLC
			ADC $E4,x
			STA $02
			TYA
			ADC $14E0,x
			PHA
			LDA $02
			CMP $1A
			PLA
			SBC $1B
			BNE STARDUST_R
			LDA $148E
			AND #$0F
			CLC
			ADC #$FE
			ADC $D8,x
			STA $00
			LDA $14D4,x
			ADC #$00
			STA $01
			JSL $0285BA	
STARDUST_R	RTS

SUB_GFX_M			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$24
					STA $0302,y
					LDA #$08
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
					RTS

SUB_GFX_G			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$E8
					STA $0302,y
					LDA #$0B
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
					RTS

G2_TILE				dcb $EA,$EC,$EE,$EC
SUB_GFX_G2			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC #$0C
					STA $0301,y
					LDA #$E8
					STA $0302,y
					LDA #$0B
					ORA $64
					STA $0303,y
					LDA $00
					STA $0304,y
					LDA $01
					STA $0305,y
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA G2_TILE,x
					STA $0306,y
					PLX
					LDA #$0B
					ORA $64
					STA $0307,y
					LDY #$02
                    LDA #$01
                    JSL $01B7B3
					RTS

SUB_GFX_P3			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$AC
					STA $0302,y
					LDA $14
					AND #$08
					BNE SUB_GFX_P3_1
					LDA #$AE
					STA $0302,y
SUB_GFX_P3_1		LDA #$88
					STA $0303,y
					PHY
					TYA
                    LSR A
                    LSR A
					TAY
					LDA #$02
					STA $0460,y
					PLY
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC #$08
					STA $0301,y
					LDA #$C4
					STA $0302,y
					LDA $14
					AND #$08
					BNE SUB_GFX_P3_2
					LDA #$C5
					STA $0302,y
SUB_GFX_P3_2		LDA #$8A
					STA $0303,y
					PHY
					TYA
                    LSR A
                    LSR A
					TAY
					LDA #$00
					STA $0460,y
					PLY
					INY
					INY
					INY
					INY
					LDA $00
					CLC
					ADC #$08
					STA $0300,y
					LDA $01
					SEC
					SBC #$08
					STA $0301,y
					LDA #$C4
					STA $0302,y
					LDA $14
					AND #$08
					BNE SUB_GFX_P3_3
					LDA #$C5
					STA $0302,y
SUB_GFX_P3_3		LDA #$CA
					STA $0303,y
					PHY
					TYA
                    LSR A
                    LSR A
					TAY
					LDA #$00
					STA $0460,y
					PLY
                    LDY #$FF
                    LDA #$02
                    JSL $01B7B3
                    RTS

DEATH_TILE			dcb $E0,$E4
DEATH_TILE2			dcb $02,$22
SUB_GFX_DE			JSR GET_DRAW_INFO
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAX
					LDA DEATH_TILE,x
					STA $0302,y
					LDA $010B
					CMP #$BC
					BNE SUB_GFX_DE_1
					LDA DEATH_TILE2,x
					STA $0302,y
SUB_GFX_DE_1		PLX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$05
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
                    RTS

SUB_GFX_P2			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$AC
					STA $0302,y
					LDA $14
					AND #$08
					BNE SUB_GFX_P2_1
					LDA #$AE
					STA $0302,y
SUB_GFX_P2_1		LDA #$08
					STA $0303,y
					LDA $00
					STA $0304,y
					LDA $01
					CLC
					ADC #$10
					STA $0305,y
					LDA #$CE
					STA $0306,y
					LDA #$0A
					STA $0307,y
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS

VERT_DISP_P			dcb $10,$20,$30,$40,$50,$60,$70
SUB_GFX_P			JSR GET_DRAW_INFO
					LDA #$00
					TAY
					STA $15EA,x
					LDA $00
					STA $0200,y
					LDA $01
					STA $0201,y
					LDA #$AC
					STA $0202,y
					LDA $14
					AND #$08
					BNE SUB_GFX_P_1
					LDA #$AE
					STA $0202,y
SUB_GFX_P_1			LDA #$08
					STA $0203,y
					PHX
					LDX #$06
LOOP_P				LDA $00
					STA $0204,y
					LDA $01
					CLC
					ADC VERT_DISP_P,x
					STA $0205,y
					LDA #$CE
					STA $0206,y
					LDA #$0A
					STA $0207,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_P          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS
					
LESA_TILE			dcb $A0,$A2,$C0,$C2,$48,$4A,$68,$6A,$4C,$4E,$6C,$6E
LESA_HORZ			dcb $F8,$08,$F8,$08
LESA_VERT			dcb $F8,$F8,$08,$08
SUB_GFX_LE			JSR GET_DRAW_INFO
					LDA #$0D
					STA $0F
					LDA $010B
					CMP #$BC
					BNE SUB_GFX_LE_1
					LDA #$0B
					STA $0F
SUB_GFX_LE_1		LDA $1602,x
					ASL A
					ASL A
					STA $02
					PHX
					LDX #$03
LESA_LOOP			LDA $00
					CLC
					ADC LESA_HORZ,x
					STA $0300,y
					LDA $01
					CLC
					ADC LESA_VERT,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA LESA_TILE,x
					STA $0302,y
					PLX
					LDA $0F
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LESA_LOOP          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURNK67           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK67            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA $7FFE0F
                    STA $009E,y
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    RTS
