;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; NOVA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$85
					BEQ INIT_2
					LDA $14E0,x
					CMP #$10
					BEQ INIT_4
					LDA #$24
					STA $166E,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE LASER_INIT
					JSL $01ACF9
					CLC
					ADC $94
					CLC
					ADC $96
					AND #$03
					INC A
					STA $1504,x
					LDA $1504,x
					CMP #$03
					BCC INIT_R
					JSL $01ACF9
					STA $1602,x
                    RTL
LASER_INIT			JSL $01ACF9
					STA $1570,x
					LDA $E4,x
					AND #$10
					BEQ INIT_R
					INC $157C,x
INIT_R				RTL
INIT_2				LDA $E4,x
					ORA #$0C
					STA $E4,x
					LDA $D8,x
					ORA #$0C
					STA $D8,x
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT_3
					LDA #$05
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					RTL
INIT_4				LDA #$82
					STA $167A,x
					LDA #$0E
					STA $1504,x
					RTL
INIT_3				LDA #$06
					STA $1504,x
					LDA #$40  ;#a
					STA $187B,x
					LDA #$50
					STA $15AC,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR LASER
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR ZAKO1
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR ZAKO2
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR ZAKO3
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR ZAKO4
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR NOVA
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR MARX
					RTS
MAIN7				CMP #$07
					BNE MAIN8
					JSR STAR
					RTS
MAIN8				CMP #$08
					BNE MAIN9
					JSR DUST1
					RTS
MAIN9				CMP #$09
					BNE MAINA
					JSR DUST2
					RTS
MAINA				CMP #$0A
					BNE MAINB
					JSR DUST3
					RTS
MAINB				CMP #$0B
					BNE MAINC
					JSR DUST4
					RTS
MAINC				CMP #$0C
					BNE MAIND
					JSR DUST5
					RTS
MAIND				CMP #$0D
					BNE MAINE
					JSR BOMB
					RTS
MAINE				CMP #$0E
					BNE MAINF
					JSR GOAL
					RTS
MAINF				CMP #$0F
					BNE MAING
					JSR MARX2
					RTS
MAING				JSR WILY
					RTS

BOMB				JSR SUB_GFX_B
					LDA $9D
					BOMB_R
					LDA $15AC,x
					BEQ BOMB_D
BOMB_R				RTS
BOMB_D				STZ $14C8,x
					RTS

LASER				JSR SUB_GFX2
					LDA $9D
					BNE LASER_R
					INC $1570,x
					JSR SUB_FIRE_THROW
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
LASER_R				RTS

ZAKO1				JSR SUB_GFX1
					LDA $9D
					BNE ZAKO1_R
					LDA #$E8
					STA $B6,x
					JSL $018022
					JSL $01A7DC
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
ZAKO1_R				RTS

ZAKO2				JSR SUB_GFX1
					LDA $9D
					BNE ZAKO2_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $C2,x
					CMP #$02
					BEQ ZAKO2_2
					CMP #$01
					BEQ ZAKO2_3
					INC $1570,x
					LDA $1570,x
					CMP #$20
					BEQ ZAKO2_1
ZAKO2_2				LDA #$E8
					STA $B6,x
					JSL $018022
					JSL $01A7DC
ZAKO2_R				RTS
ZAKO2_1				INC $C2,x
					LDA $96
					CLC
					ADC #$10
					STA $02
					LDA $97
					ADC #$00
					STA $03
					LDA $02
					AND #$FE
					STA $1602,x
					SEC
					SBC $D8,x
					LDA $03
					STA $1594,x
					SBC $14D4,x
					BCS ZAKO2_0
					LDA #$E0
					STA $AA,x
					RTS
ZAKO2_0				LDA #$20
					STA $AA,x
					RTS
ZAKO2_3				JSL $01801A
					JSL $01A7DC
					LDA $14D4,x
					CMP $1594,x
					BNE ZAKO2_R
					LDA $D8,x
					CMP $1602,x
					BNE ZAKO2_R
					INC $C2,x
					RTS
					
ZAKO3				JSR SUB_GFX
					LDA $9D
					BNE ZAKO3_R
					INC $1602,x
					LDA $14
					AND #$03
					BNE ZAKO3_0
					INC $1570,x
					LDA $1570,x
					CMP #$06
					BCC ZAKO3_0
					STZ $1570,x
ZAKO3_0				
					JSL $01A7DC
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$20
					STA $AA,x
					LDA $1602,x
					AND #$20
					BNE ZAKO3_1
					LDA #$E0
					STA $AA,x
ZAKO3_1				JSL $01801A
ZAKO3_R				RTS
					
ZAKO4				JSR SUB_GFX
					LDA $9D
					BNE ZAKO4_R
					INC $1602,x
					LDA $14
					AND #$03
					BNE ZAKO4_0
					INC $1570,x
					LDA $1570,x
					CMP #$06
					BCC ZAKO4_0
					STZ $1570,x
ZAKO4_0				JSL $01A7DC
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$20
					STA $AA,x
					LDA $1602,x
					AND #$40
					BNE ZAKO4_1
					LDA #$E0
					STA $AA,x
ZAKO4_1				JSL $01801A
					LDA #$E8
					STA $B6,x
					JSL $018022
ZAKO4_R				RTS

NOVA				JSR SUB_GFX_NOVA
					LDA $9D
					BNE NOVA_R
					JSR MARIO_ROUTINE
					LDA $C2,x
					BEQ NOVA_0
					JSR NOVA_FINISH
					RTS
NOVA_0				JSR FRAME_DAMAGE
					LDA $15AC,x
					BEQ NOVA_G
					CMP #$FE
					BEQ NOVA_1
NOVA_R				RTS
NOVA_1				JSR LIFE_GAGE
					LDA #$60
					STA $15AC,x
					STA $40
					RTS
NOVA_G				LDA #$60
					STA $15AC,x
					JSR NOVA_GEN
					RTS

STAR				JSR SUB_GFX_STAR
					LDA $9D
					BNE STAR_R
					LDA $7FFDDD
					BNE STAR_D
					LDA #$E0
					STA $B6,x
					JSL $018022
					JSL $01A7DC
					LDA $14E0,x
					CMP #$FF
					BNE STAR_R
STAR_D				STZ $14C8,x
STAR_R				RTS

DUST1				STZ $1602,x
					JSR SUB_GFX_DUST
					LDA $9D
					BNE DUST1_R
					LDA $7FFDDD
					BNE DUST1_D
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $15AC,x
					CMP #$FE
					BEQ DUST1_2
					LDA $14E0,x
					BEQ DUST1_R
DUST1_D				STZ $14C8,x
DUST1_R				RTS
DUST1_2				JSR SPEED
					LDA $1602,x
					STA $B6,x
					LDA $1594,x
					STA $AA,x
					RTS

DUST2				LDA #$01
					STA $1602,x
					JSR SUB_GFX_DUST
					LDA $9D
					BNE DUST2_R
					LDA $7FFDDD
					BNE DUST2_D
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $15AC,x
					BEQ DUST2_D
					CMP #$FE
					BEQ DUST2_1
					JSR SUB_DUST2_1
					JSR SUB_DUST2_2
					LDA $14E0,x
					CMP #$FF
					BNE DUST2_R
DUST2_D				STZ $14C8,x
DUST2_R				RTS
DUST2_1				LDA #$E8
					STA $AA,x
					RTS
SUB_DUST2_1			LDA $B6,x
					BNE SUB_DUST2_R
					LDA $14D4,x
					BNE SUB_DUST2_1_2
					LDA $D8,x
					CMP #$E0
					BCS SUB_DUST2_R
					LDA #$18
					STA $AA,x
SUB_DUST2_R			RTS
SUB_DUST2_1_2		LDA $D8,x
					CMP #$80
					BCC SUB_DUST2_R
					LDA #$E8
					STA $AA,x
					RTS
SUB_DUST2_2			LDA $B6,x
					BNE SUB_DUST2_2_R
					LDA $96
					CLC
					ADC #$10
					STA $02
					LDA $97
					ADC #$00
					STA $03
					LDA $14D8,x
					CMP $03
					BNE SUB_DUST2_2_R
					LDA $D8,x
					AND #$F8
					STA $03
					LDA $02
					AND #$F8
					CMP $03
					BNE SUB_DUST2_2_R
					STZ $AA,x
					LDA #$D8
					STA $B6,x
SUB_DUST2_2_R		RTS

DUST3_TABLE1		dcb $18,$18,$E8,$E8
DUST3_TABLE2		dcb $18,$E8,$18,$E8
DUST3				LDA #$04
					STA $1602,x
					JSR SUB_GFX_DUST
					LDA $9D
					BNE DUST3_R
					LDA $7FFDDD
					BNE DUST3_D
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSR SUB_DUST3
					LDA $15AC,x
					BEQ DUST3_D
					CMP #$FE
					BEQ DUST3_1
					RTS
DUST3_D				STZ $14C8,x
DUST3_R				RTS
DUST3_1				JSL $01ACF9
					CLC
					ADC $96
					AND #$03
					TAY
					LDA DUST3_TABLE1,y
					STA $B6,x
					LDA DUST3_TABLE2,y
					STA $AA,x
					RTS
SUB_DUST3			LDA $14D4,x
					BEQ SUB_DUST3_1
					LDA $D8,x
					CMP #$80
					BCC SUB_DUST3_2
					LDA #$E8
					STA $AA,x
					BRA SUB_DUST3_2
SUB_DUST3_1			LDA $D8,x
					CMP #$E0
					BCS SUB_DUST3_2
					LDA #$18
					STA $AA,x
SUB_DUST3_2			LDA $E4,x
					CMP #$E8
					BCC SUB_DUST3_3
					LDA #$E8
					STA $B6,x
					RTS
SUB_DUST3_3			CMP #$08
					BCS SUB_DUST3_R
					LDA #$18
					STA $B6,x
SUB_DUST3_R			RTS

DUST4				LDA #$02
					STA $1602,x
					JSR SUB_GFX_DUST
					LDA $9D
					BNE DUST4_R
					LDA $7FFDDD
					BNE DUST4_D
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $15AC,x
					CMP #$FE
					BEQ DUST4_1
					JSR SUB_DUST4
					LDA $14E0,x
					BNE DUST4_D
					LDA $14D4,x
					CMP #$02
					BEQ DUST4_D
					CMP #$01
					BEQ DUST4_R
					LDA $D8,x
					CMP #$A0
					BCC DUST4_D
DUST4_R				RTS
DUST4_D				STZ $14C8,x
					RTS
DUST4_1				LDA #$F0
					STA $B6,x
					RTS
SUB_DUST4			LDA $AA,x
					BNE SUB_DUST4_R
					LDA $94
					AND #$FC
					STA $02
					LDA $E4,x
					AND #$FC
					CMP $02
					BNE SUB_DUST4_R
					STZ $B6,x
					LDA #$28
					STA $AA,x
					LDA $96
					CLC
					ADC #$10
					STA $02
					LDA $97
					ADC #$00
					STA $03
					LDA $02
					SEC
					SBC $D8,x
					LDA $03
					SBC $14D4,x
					BCS SUB_DUST4_R
					LDA #$D8
					STA $AA,x
SUB_DUST4_R			RTS

DUST5				LDA #$03
					STA $1602,x
					JSR SUB_GFX_DUST
					LDA $9D
					BNE DUST5_R
					LDA $7FFDDD
					BNE DUST5_D
					LDA #$E8
					STA $B6,x
					JSL $01A7DC
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $14E0,x
					BEQ DUST5_R
DUST5_D				STZ $14C8,x
DUST5_R				RTS

GOAL				LDA $C2,x
					BNE GOAL_2
					JSR SUB_GFX_G
					LDA $9D
					BNE GOAL_R
					JSR STAR_DUST
					JSL $01A7DC
					BCS GOAL_1
GOAL_R				RTS
GOAL_1				INC $C2,x
					LDA #$FF
                    STA $1493
					LDA #$0B
                    STA $1DFB
					RTS
GOAL_2				LDA $1493
					CMP #$02
					BCC GOAL_3
					LDA #$20
					STA $15AC,x
					RTS
GOAL_3				LDA $15AC,x
					BNE GOAL_R
					STZ $1493
					STZ $41
					STZ $42
					STZ $43
					LDA #$0F
					STA $1504,x
					LDA $96
					CLC
					ADC #$08
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					LDA $94
					SEC
					SBC #$C0
					STA $E4,x
					LDA $95
					SBC #$00
					STA $14E0,x
					LDA #$2B
					STA $1DFC
					LDA #$1E
					STA $1DFB
					LDA $13E0
					STA $1602,x
					LDA $13DF
					STA $151C,x
					LDA $76
					STA $1570,x
					LDA #$FF
					STA $18BD
					STZ $C2,x
					RTS

MARX2				JSR SUB_GFX_MARX
					LDA $9D
					BNE MARX2_R
					LDA $1602,x
					STA $13E0
					LDA $151C,x
					STA $13DF
					LDA $1570,x
					STA $76
					LDA #$30
					STA $B6,x
					JSL $018022
					LDA $C2,x
					BNE MARX2_2
					JSL $01A7DC
					BCS MARX2_2
MARX2_R				RTS
MARX2_2				LDA #$01
					STA $C2,x
					REP #$20
					LDA $94
					CLC
					ADC.W #$0003
					STA $94
					SEP #$20
					LDA $7E
					CMP #$E0
					BCC MARX2_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STAR_DUST			LDA $14   ;#ʓɂƂ̂݌鏈ɂ
					AND #$07
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS


NOVA_FINISH			LDA $7FFDDE
					CMP #$1F
					BEQ NOVA_FINISH_1
					INC A
					STA $7FFDDE
					LDA #$00
					STA $2121
					LDA $7FFDDE
					STA $2122
					LDA #$00
					STA $2122
NOVA_FINISH_1		LDA $1887
					BNE NOVA_FINISH_2
					LDA #$40
					STA $1887
NOVA_FINISH_2		LDA $15AC,x
					CMP #$FE
					BEQ NOVA_FINISH_3
					CMP #$40
					BCS NOVA_FINISH_G
					CMP #$30
					BEQ NOVA_WARP
NOVA_FINISH_R		RTS
NOVA_FINISH_3		LDA #$00
					STA $212C
					LDA #$1F
					STA $212D
					RTS
NOVA_WARP			LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
NOVA_FINISH_G		LDA $14
					AND #$0F
					BNE NOVA_FINISH_R
					JSR GEN_SPRITE
					LDA #$0D
					STA $1504,y
					LDA #$18
					STA $15AC,y
					JSL $01ACF9
					LSR A
					CLC
					ADC #$70
					STA $00E4,y
					JSL $01ACF9
					LSR A
					STA $00D8,y
					LDA #$27
					STA $1DF9
					RTS


MARIO_ROUTINE		LDA $94
					CMP #$50
					BCC MARIO_ROUTINE_1
					LDA #$50
					STA $94
MARIO_ROUTINE_1		REP #$20
					INC $1466
					INC $1466
					SEP #$20
					RTS


RETURN201			RTS
SUB_FIRE_THROW      LDA $15A0,x
                    ORA $186C,x             ;  |
                    BNE RETURN201
					LDA $1570,x
					AND #$3F
					BNE RETURN201

SPIT                LDY #$E8
                    LDA $157C,x
                    AND #$01
                    BNE LABEL9
                    LDY #$18
LABEL9              STY $00
                    LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     

LABEL7              LDA #$02                ; \ projectile is a fireball
                    STA $170B,y             ; /

                    LDA $E4,x               ; \ set x position
                    STA $171F,y             ;  |
                    LDA $14E0,x             ;  |
                    STA $1733,y             ; /
                    
                    LDA $D8,x               ; \ set y position
                    STA $1715,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $1729,y             ; /
                    
					JSR SPEED
					LDA $1602,x
					STA $1747,y
					LDA $1594,x
					STA $173D,y

LABEL6              RTS 

RETURN91			RTS
FRAME_DAMAGE		LDA $1540,x
					BNE RETURN91
					LDY #$07
FRAME_DAMAGE_0      LDA $1540,x
					BNE FRAME_DAMAGE_1
					LDA $170B,y
					CMP #$11
                    BNE FRAME_DAMAGE_1
					LDA $1733,y
					BNE FRAME_DAMAGE_1
					LDA $171F,y
					CMP #$A0
					BCC FRAME_DAMAGE_1
					CMP #$C0
					BCS FRAME_DAMAGE_1
					LDA $1729,y
					BEQ FRAME_DAMAGE_1
					LDA $1715,y
					CMP #$18
					BCC FRAME_DAMAGE_1
					CMP #$50
					BCS FRAME_DAMAGE_1
					LDA #$40
					STA $1540,x
					LDA #$20
					STA $1887
					LDA #$09
					STA $1DFC
					INC $1528,x
					JSR GAGE_DOWN
FRAME_DAMAGE_1      DEY
                    BPL FRAME_DAMAGE_0
                    RTS                     

GAGE_DOWN			LDA #$3F
					SEC
					SBC $1528,x
					STA $02
					LDA #$5A
					STA $03
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$20
					LDA $1528,x
					CMP #$18
					BEQ GAGE_DOWN_2
					RTS
GAGE_DOWN_2			LDA #$1E
					STA $1DFB
					LDA #$01
					STA $7FFDDD
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

LIFE_GAGE			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5A22
					STA $2116
					LDA.W #$2017
					STA $2118
					LDA.W #$5A23
					STA $2116
					LDA.W #$2018
					STA $2118
					LDA.W #$5A24
					STA $2116
					LDA.W #$201F
					STA $2118
					LDA.W #$5A25
					STA $2116
					LDA.W #$200A
					STA $2118
					
					LDA.W #$5A27
					STA $03
LIFE_GAGE_LP1		LDA $03
					STA $2116
					LDA.W #$2044
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$5A3F
					BCC LIFE_GAGE_LP1
					SEP #$20
					RTS
					
GEN_STAR			LDA $9D
					BNE GEN_STAR_R
					LDA $15AC,x
					BNE GEN_STAR_R
					JSR GEN_SPRITE
					LDA #$07
					STA $1504,y
					LDA #$50
					STA $15AC,x
GEN_STAR_R			RTS

NOVA_GEN_TABLE		dcb $08,$08,$08,$08,$09,$09,$09,$0A,$0A,$0A,$0B,$0B,$0B,$0C,$0C,$0C
HORZ_GEN_TABLE		dcb $AC,$AC,$AC,$AC,$8C,$8C,$8C,$D8,$D8,$D8,$98,$98,$98,$7E,$7E,$7E
VERT_GEN_TABLE		dcb $64,$64,$64,$64,$48,$48,$48,$44,$44,$44,$58,$58,$58,$34,$34,$34
NOVA_GEN			LDA $9D
					BNE NOVA_GEN_R
					JSR GEN_SPRITE
					PHX
					JSL $01ACF9
					CLC
					ADC $96
					AND #$0F
					TAX
					LDA NOVA_GEN_TABLE,x
					STA $1504,y
					LDA HORZ_GEN_TABLE,x
					STA $00E4,y
					LDA VERT_GEN_TABLE,x
					STA $00D8,y
					LDA #$FF
					STA $15AC,y
					PLX
NOVA_GEN_R			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_DUST		dcb $80,$82,$A0,$A2,$28
					dcb $84,$86,$A4,$A6,$28
					dcb $C0,$C2,$E0,$E2,$28
					dcb $C8,$CA,$E8,$EA,$AA
					dcb $AC,$AE,$CC,$CE,$8E
HORZ_DUST			dcb $F8,$08,$F8,$08,$08
VERT_DUST			dcb $F8,$F8,$08,$08,$E8

SUB_GFX_DUST		LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $02
					JSR GET_DRAW_INFO
                    PHX                     ; push sprite index
					LDX #$04
LOOP_START_DUST          
					LDA $00
					CLC
					ADC HORZ_DUST,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT_DUST,x
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_DUST,x           ; \ store tile
                    STA $0302,y
					PLX
					
					LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_DUST

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


SUB_GFX_STAR		JSR GET_DRAW_INFO
					LDA $00
                    STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$A8
                    STA $0302,y
					LDA #$09
                    ORA $64                 ;  | put in level properties
                    STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS

SUB_GFX_G			JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $01
					STA $0301,y
					LDA $00
                    STA $0300,y             ; /
					
					LDA #$8C
                    STA $0302,y
					
					LDA #$0B
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return



TILEMAP             dcb $0A,$0C,$0E,$0E,$0C,$0A
PROPE				dcb $0D,$0D,$0D,$4D,$4D,$4D

SUB_GFX             LDA $1570,x
					STA $03
					JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    LDA $01
					STA $0301,y
					LDA $00
                    STA $0300,y             ; /
					
					PHX
					LDX $03
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					
					LDA PROPE,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP1            dcb $88,$8A
					dcb $EC,$EE
HORZ				dcb $00,$10


SUB_GFX1            LDA $1570,x
					LSR A
					LSR A
					AND #$01
					ASL A
					STA $02
					JSR GET_DRAW_INFO
                    PHX                     ; push sprite index
					LDX #$01
LOOP_START1          
					LDA $00
					CLC
					ADC HORZ,x
                    STA $0300,y
					LDA $01
					STA $0301,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP1,x           ; \ store tile
                    STA $0302,y
					PLX
					
					LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
TILEMAP_MARX        dcb $C4,$C6,$E4,$E6
HORZ_MARX			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_MARX			dcb $F8,$F8,$08,$08
PROP_MAXR			dcb $03,$03,$03,$03
					dcb $43,$43,$43,$43

SUB_GFX_MARX        STZ $03
					LDA $1504,x
					CMP #$0F
					BNE SUB_GFX_MARX_1
					LDA #$04
					STA $03
SUB_GFX_MARX_1		JSR GET_DRAW_INFO
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START_MARX     
					LDA $01
					CLC
					ADC VERT_MARX,x
					STA $0301,y
					LDA TILEMAP_MARX,x           ; \ store tile
                    STA $0302,y
					
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_MARX,x
                    STA $0300,y
					LDA PROP_MAXR,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_MARX         ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
WILY2_TBL			dcb $F8,$08,$F8,$08
WILY2_TBL2			dcb $F8,$F8,$08,$08
WILY2_TBL3			dcb $0B,$4B,$8B,$CB
SUB_GFX_WILY2		JSR GET_DRAW_INFO
					LDA #$A8
					STA $03
					LDA $14
					LSR A
					LSR A
					AND #$01
					BEQ SUB_GFX_WILY2_2
					LDA #$C8
					STA $03
SUB_GFX_WILY2_2		PHX                     ; push sprite index
					LDX #$03
LOOP_WILY2			LDA $00
					CLC
					ADC WILY2_TBL,x
					STA $0300,y
					LDA $01
					CLC
					ADC WILY2_TBL2,x
					STA $0301,y
					LDA $03
					STA $0302,y
					LDA WILY2_TBL3,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_WILY2
					PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

SUB_GFX_WILY		JSR GET_DRAW_INFO
					LDA $00
					CLC
					ADC $04
					STA $0300,y
					LDA $01
					CLC
					ADC $06
					STA $0301,y
					LDA #$88
					STA $0302,y
					LDA #$0B
					ORA $64
					STA $0303,y
					LDA $00
					SEC
					SBC $04
					STA $0304,y
					LDA $01
					SEC
					SBC $06
					STA $0305,y
					LDA #$88
					STA $0306,y
					LDA #$0B
					ORA $64
					STA $0307,y
					LDA $00
					CLC
					ADC $06
					STA $0308,y
					LDA $01
					SEC
					SBC $04
					STA $0309,y
					LDA #$88
					STA $030A,y
					LDA #$0B
					ORA $64
					STA $030B,y
					LDA $00
					SEC
					SBC $06
					STA $030C,y
					LDA $01
					CLC
					ADC $04
					STA $030D,y
					LDA #$88
					STA $030E,y
					LDA #$0B
					ORA $64
					STA $030F,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

TILEMAP_B       dcb $6C,$6E,$6E,$6C
				dcb $06,$08,$08,$06
				dcb $4C,$4E,$4E,$4C
HORZ_B			dcb $F8,$08,$F8,$08
VERT_B			dcb $F8,$F8,$08,$08
PROP_B			dcb $0B,$0B,$CB,$CB
SUB_GFX_B			STZ $02
					LDA $15AC,x
					CMP #$10
					BCS SUB_GFX_B_1
					LDA #$04
					STA $02
					LDA $15AC,x
					CMP #$08
					BCS SUB_GFX_B_1
					LDA #$08
					STA $02
SUB_GFX_B_1			JSR GET_DRAW_INFO
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START_B     
					LDA $00
					CLC
					ADC HORZ_B,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT_B,x
					STA $0301,y
					
					LDA PROP_B,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_B,x           ; \ store tile
                    STA $0302,y
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_B         ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03               ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX2           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $01
					STA $0301,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0300,y             ; /
					
					LDA #$64
                    STA $0302,y
					
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					LDA $157C,x
					BEQ SUB_GFX2_1
					LDA $0303,y
					ORA #$80
					STA $0303,y
SUB_GFX2_1
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
HORZ_DISP_NOVA			dcb $E8,$F8,$E8,$F8,$18,$08,$18,$08,$F8,$08
VERT_DISP_NOVA			dcb $F7,$F7,$07,$07,$F7,$F7,$07,$07,$10,$10
TILEMAP_NOVA			dcb $00,$02,$20,$22,$00,$02,$20,$22,$2D,$2D
						dcb $40,$42,$60,$62,$24,$26,$44,$46,$2D,$2D
						dcb $48,$4A,$68,$6A,$48,$4A,$68,$6A,$2D,$2D
PROPETIES_NOVA			dcb $0D,$0D,$0D,$0D,$4D,$4D,$4D,$4D,$0D,$4D

SUB_GFX_NOVA        JSR GET_DRAW_INFO
					LDY #$50
					TYA
					STA $15EA,x
					STZ $02
					LDA $1540,x
					BEQ SUB_GFX_NOVA_1
					LDA #$0A
					STA $02
SUB_GFX_NOVA_1		LDA $C2,x
					BEQ SUB_GFX_NOVA_2
					LDA #$14
					STA $02
SUB_GFX_NOVA_2		PHX                     ; push sprite index
                    LDX #$09              ; loop counter = (number of tiles per frame) - 1
LOOP_START_NOVA     PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP_NOVA,x           ; \ store tile
                    STA $0202,y
					PLX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_NOVA,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_NOVA,x         ;  |
                    STA $0201,y             ; /
                    
                    LDA PROPETIES_NOVA,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_NOVA          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$09
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPEED_DEC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   
SPEED				LDA #$20
					STA $7FF570
					LDA #$10
					STA $151C,x
					LDA $96
					PHA
					CLC
					ADC #$10
					STA $96
					LDA $97
					PHA
					ADC #$00
					STA $97
					JSR SPEED_DEC
					PLA
					STA $97
					PLA
					STA $96
					JSR Y_SPEED_CHECK
					RTS
					LDA $1602,x
					STA $1747,y
					LDA $1594,x
					STA $173D,y

Y_SPEED_CHECK		LDA $1594,x
					BMI Y_SPEED_CHECK_2
					CMP #$20
					BCC Y_SPEED_CHECK_R
Y_SPEED_CHECK_A		LSR A
					STA $1594,x
					LDA $1602,x
					BMI Y_SPEED_CHECK_1
					LSR A
					STA $1602,x
					LDA $1594,x
					CMP #$20
					BCS Y_SPEED_CHECK_A
					RTS
Y_SPEED_CHECK_1		EOR #$FF
					LSR A
					EOR #$FF
					STA $1602,x
					LDA $1594,x
					CMP #$20
					BCS Y_SPEED_CHECK_A
Y_SPEED_CHECK_R		RTS


Y_SPEED_CHECK_2		CMP #$E0
					BCS Y_SPEED_CHECK_R
Y_SPEED_CHECK_B		EOR #$FF
					LSR A
					EOR #$FF
					STA $1594,x
					LDA $1602,x
					BMI Y_SPEED_CHECK_3
					LSR A
					STA $1602,x
					LDA $1594,x
					CMP #$E0
					BCC Y_SPEED_CHECK_B
					RTS
Y_SPEED_CHECK_3		EOR #$FF
					LSR A
					EOR #$FF
					STA $1602,x
					LDA $1594,x
					CMP #$E0
					BCC Y_SPEED_CHECK_B
					RTS
					
SPEED_DEC           LDA $E4,x
                    SEC
                    SBC $94
                    STA $0F
                    LDA $14E0,x
                    SBC $95
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2               JSR LEFT_SPEED2
VERC                LDA $D8,x
                    SEC
                    SBC $96
                    STA $0F
                    LDA $14D4,x
                    SBC $97
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    LDA $1594,x
                    CMP #$10
                    BCS VER_E
                    LDA #$10
                    STA $1594,x
                    BRA VER_E
FACE_UP             JSR UP_SPEED
                    LDA $1594,x
                    CMP #$F0
                    BCC VER_E
                    LDA #$F0
                    STA $1594,x
VER_E               RTS

UP_SPEED            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2                 STA $0F
                    BRA UP5
UP3                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4                 JSR UP1_2
UP5                 LDA #$00
                    SEC
                    SBC $0F
                    STA $1594,x
                    RTS

DOWN_SPEED          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2               STA $1594,x
                    RTS
DOWN3               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4               JSR UP1_2
DOWN5               LDA $0F
                    STA $1594,x
                    RTS
UP1_1
LOOPUP1             LDA $0F37
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE LOOPUP1
LOOPUP1E            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE           RTS

UP1_2               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $0F37
                    RTS
LOOPUP3             LDA $0F37
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $0F37
                    LDA $0F37
                    BNE UP1_2
LOOPUP2E            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE           RTS

LEFT_SPEED1         STZ $0F38
                    LDA $0F
                    CMP $7FF570
                    BCC LEFT1_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2             CMP $151C,x
                    BCS LEFT1_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3             LDA #$00
                    SEC
                    SBC $0F
                    STA $1602,x
                    RTS

LEFT1_40            
LOOP140             LDA $0F
                    CMP $7FF570
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP140E            RTS
LEFT1_20            
LOOP120             LDA $0F
                    CMP $151C,x
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $0F37
                    BRA LOOP140
LOOP120E            RTS

LEFT_SPEED2         STZ $0F37
                    INC $0F37
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $0F38
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $1602,x
                    RTS

RIGHT_SPEED         STZ $0F38
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP $7FF570
                    BCC RIGHT_2
                    LDA #$02
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2             CMP $151C,x
                    BCS RIGHT_3
                    LDA #$01
                    STA $0F38
                    STZ $0F37
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3             LDA $0F
                    STA $1602,x
                    RTS
					
MARX_FINISH			JSR SUB_GFX_MARX
					LDA $9D
					BNE MARX_R
					JSL $01801A
					LDA $14D4,x
					BNE MARX_R
					LDA $D8,x
					CMP #$A0
					BCS MARX_R
					STZ $14C8,x
MARX_R				RTS


MARX				LDA $C2,x
					BNE MARX_FINISH
SUB_WILY			LDA $9D
                    BNE LABEL92
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					LDA $010B
					CMP #$5D
					BEQ LABEL470
                    LDA #$02 ;#]x
					CLC
                    ADC $1602,x
                    STA $1602,x
                    LDA #$00
                    ADC $151C,x
                    AND #$01
                    STA $151C,x
					BRA LABEL92
LABEL470			LDA #$10 ;#]x
					CLC
                    ADC $1602,x
                    STA $1602,x
                    LDA #$00
                    ADC $151C,x
                    AND #$01
                    STA $151C,x
LABEL92             LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30
                    LDA $00
                    CLC
                    ADC.W #$0080
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06
                    SEP #$30
                    LDX $15E9
                    LDA $04
                    STA $4202
                    LDA $187B,x
                    LDY $05
                    BNE LABEL93
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /
LABEL94             STA $04
                    LDA $06
                    STA $4202
                    LDA $187B,x
                    LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
					LDA $010B
					CMP #$5D
					BEQ LBL473
                    JSR SUB_GFX_MARX
					LDA $7FFDDD
					BNE LABEL981
					JSR GEN_STAR
LBL473				PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x
					LDA $010B
					CMP #$5D
					BNE LBL472
					JSR SUB_GFX_WILY
LBL472				RTS
LABEL981			PLA
					PLA
					PLA
					PLA
					STZ $B6,x
					LDA #$E0
					STA $AA,x
					LDA #$01
					STA $C2,x
					RTS
					
WILY				LDA $187B,x
					BEQ WILY_2
					JSR SUB_WILY
					LDA $9D
					BNE WILY_R
					LDA $14
					AND #$01
					BNE WILY_R
					DEC $187B,x
WILY_R				RTS
WILY_2				JSR SUB_GFX_WILY2
					LDA $9D
					BNE WILY_R
					JSL $27FAF4;SUB_OFF_SCREEN_X0
					LDA $15AC,x
					BEQ WILY_DEL
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSL $01A7DC
					LDA $15AC,x
					CMP #$90
					BEQ WILY_3
					RTS
WILY_DEL			STZ $14C8,x
					RTS
WILY_3				JSR SPEED
					LDA $1602,x
					BMI WILY_4
					ASL A
					STA $B6,x
					BRA WILY_5
WILY_4				EOR #$FF
					INC A
					ASL A
					EOR #$FF
					INC A
					STA $B6,x
WILY_5				LDA $1594,x
					BMI WILY_6
					ASL A
					STA $AA,x
					RTS
WILY_6				EOR #$FF
					INC A
					ASL A
					EOR #$FF
					INC A
					STA $AA,x
					RTS
