;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Opening
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
					NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite initialization JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$FF
					STA $18BD
					JSR HDMA2
					LDA #$03
					STA $1558,x
					LDA #$60
					STA $15AC,x
					LDA $010B
					CMP #$4B
					BEQ INIT_1
					CMP #$4C
					BEQ INIT_2
					CMP #$4D
					BEQ INIT_3
                    RTL
INIT_1				LDA #$01
					STA $1504,x
					RTL
INIT_2				LDA #$02
					STA $1504,x
					RTL
INIT_3				LDA #$03
					STA $1504,x
					JSR HDMA_COLOR
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            
                    dcb "MAIN"                        
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_SPRITE_CODE   ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DEL_MAIN			CMP #$01
					BEQ DEL_2
					STZ $40
					LDA #$00
					STA $212C
					LDA #$17
					STA $212D
MAINR				RTS
DEL_2				LDA #$24
					STA $40
					LDA #$15
					STA $212C
					LDA #$02
					STA $212D
					LDA $010B
					CMP #$4B
					BNE MAINR
					STZ $40
					RTS
START_SPRITE_CODE   LDA $1540,x
					BEQ MAINA
					CMP #$24
					BCS MAIN0
					LDA $14
					AND #$01
					BNE MAIN0
					LDA $7FE001
					BEQ MAINB
					DEC A
					STA $7FE001
					BRA MAIN0
MAINB				LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
MAINA				LDA $7FE001
					CMP #$0F
					BEQ MAIN0
					LDA $1558,x
					BNE DEL_MAIN
					LDA $14
					AND #$01
					BEQ MAIN0
					LDA $7FE001
					INC A
					STA $7FE001
MAIN0				LDA #$FF
					STA $18BD
					JSR STATUS_DEL
					LDA $1504,x
					BNE MAIN1
					JSR ROOMC5
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR ROOM14B
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR ROOM14C
					RTS
MAIN3				JSR ROOM14D
					RTS

ROOMC5				JSR SUB_GFX0
					LDA $1540,x
					BNE ROOMC5_1
					LDA $16
					ORA $18
					AND #$C0
					BEQ ROOMC5_1
					LDA #$26
					STA $1540,x
					RTS
ROOMC5_1			LDA $15AC,x
					BNE ROOMC5_R
					JSR SUB_ROOMC5
ROOMC5_R            RTS

ROOM14B				LDA $1540,x
					BNE ROOM14B_0
					LDA $16
					ORA $18
					AND #$C0
					BEQ ROOM14B_0
					LDA #$26
					STA $1540,x
					RTS
ROOM14B_0			LDA $1570,x
					CMP #$37
					BNE ROOM14B_1
					LDA $15AC,x
					CMP #$20
					BNE ROOM14B_1
					LDA #$AF
					STA $40
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					RTS
ROOM14B_1			LDA $15AC,x
					BNE ROOM14B_R
					JSR SUB_ROOM14B
ROOM14B_R           RTS

ROOM14C				LDA $1540,x
					BNE ROOM14C_1
					LDA $16
					ORA $18
					AND #$C0
					BEQ ROOM14C_1
					LDA #$26
					STA $1540,x
					RTS
ROOM14C_1			LDA $15AC,x
					BNE ROOM14C_R
					JSR SUB_ROOM14C
ROOM14C_R           RTS

ROOM14D				JSR SUB_GFX
					LDA $C2,x
					CMP #$02
					BEQ ROOM14D_2
					LDA $1602,x
					BNE ROOM14D_2
					LDA $16
					ORA $18
					AND #$C0
					BEQ ROOM14D_1
					LDA #$22
					STA $15AC,x
					LDA #$01
					STA $1602,x
					RTS
ROOM14D_1			LDA $1570,x
					CMP #$44
					BNE ROOM14D_0
					LDA $15AC,x
					CMP #$10
					BNE ROOM14D_0
					LDA #$01
					STA $C2,x
					LDA #$71
					STA $40
					LDA #$05
					STA $212C
					LDA #$10
					STA $212D
ROOM14D_0			LDA $15AC,x
					BNE ROOM14D_R
					JSR SUB_ROOM14D
ROOM14D_R           RTS
ROOM14D_2			LDA $15AC,x
					CMP #$20
					BCC ROOM14D_4
					CMP #$E0
					BCS ROOM14D_R
					CMP #$A0
					BCC ROOM14D_3
					LDA $14
					AND #$01
					BNE ROOM14D_R
					JSR COLOR1
					RTS
ROOM14D_3			CMP #$60
					BCC ROOM14D_R
					LDA $14
					AND #$01
					BNE ROOM14D_R
					JSR COLOR2
					RTS
ROOM14D_4			STZ $18BD
					LDA #$A0
					STA $7B
					LDA #$0B
					STA $71
					STZ $40
					LDA #$11
					STA $212C
					LDA #$06
					STA $212D
					RTS

SUB_ROOMC5_TBL1		dcb $01,$07,$13,$79,$35,$18,$49,$6B,$58,$7A,$13,$18,$0B,$13,$02,$42,$18,$37,$09,$03
					dcb $48,$84,$4B,$04,$02,$09,$07,$15,$1C,$01,$41,$42,$35,$0F,$36,$0B,$0F
					dcb $01,$0F,$79,$01,$14,$38,$59,$A7,$62,$A7,$5B,$5E,$46
SUB_ROOMC5_TBL2		dcb $26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$38,$39
					dcb $46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56
					dcb $66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$72,$73,$74
SUB_ROOMC5_TBL4		dcb $02,$02,$01,$02,$02,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $02,$01,$02,$02,$02,$02,$02,$02,$02,$10,$02,$02,$FF
SUB_ROOMC5			LDA $1570,x
					TAY
					INC $1570,x
					LDA SUB_ROOMC5_TBL1,y
					STA $00
					LDA #$39
					STA $01
					LDA SUB_ROOMC5_TBL2,y
					STA $02
					LDA #$5A
					STA $03
					LDA SUB_ROOMC5_TBL4,y
					STA $15AC,x
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA $00
					STA $2118
					SEP #$20
					LDA $15AC,x
					CMP #$FF
					BNE SUB_ROOMC5_R
					LDA #$90
					STA $1540,x
SUB_ROOMC5_R		RTS


SUB_ROOM14B_TBL1	dcb $1A,$13,$1A,$79,$13,$19,$5B,$5E,$46,$42,$3C,$02,$0B,$21,$13,$0F,$0F,$03
					dcb $05,$39,$05,$79,$01,$38,$05,$06,$79,$37,$04,$02,$09,$07,$18,$19,$43,$03,$01,$19
					dcb $03,$01,$03,$43,$15,$11,$11,$79,$07,$13,$0B,$43,$0B,$79,$12,$01,$0F
					dcb $0B,$05,$0B,$1C,$01,$41,$19,$14,$05,$79,$07,$19,$11,$11,$79,$05,$14,$05,$65,$0F
					
SUB_ROOM14B_TBL2	dcb $26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37
					dcb $46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A
					dcb $66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76
					dcb $A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9
					
SUB_ROOM14B_TBL4	dcb $02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $02,$02,$01,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$01,$02,$02,$02,$60
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$01,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$FF
SUB_ROOM14B			LDA $1570,x
					TAY
					INC $1570,x
					LDA SUB_ROOM14B_TBL1,y
					STA $00
					LDA #$39
					STA $01
					LDA SUB_ROOM14B_TBL2,y
					STA $02
					LDA #$5A
					STA $03
					LDA SUB_ROOM14B_TBL4,y
					STA $15AC,x
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA $00
					STA $2118
					SEP #$20
					LDA $15AC,x
					CMP #$FF
					BNE SUB_ROOM14B_R
					LDA #$90
					STA $1540,x
SUB_ROOM14B_R		RTS


SUB_ROOM14C_TBL1	dcb $48,$84,$4B,$04,$02,$09,$07,$18,$04,$02,$0A,$1E,$13,$14,$65,$0F,$5B,$5E,$46,$19
					dcb $1D,$79,$02,$06,$79,$21,$07,$18,$05,$06,$79,$37,$42,$11,$07,$0B,$0F,$18,$12,$79,$00,$38
SUB_ROOM14C_TBL2	dcb $26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$38,$39
					dcb $66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B
SUB_ROOM14C_TBL4	dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $01,$02,$02,$01,$02,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$01,$02,$02,$FF
SUB_ROOM14C			LDA $1570,x
					TAY
					INC $1570,x
					LDA SUB_ROOM14C_TBL1,y
					STA $00
					LDA #$39
					STA $01
					LDA SUB_ROOM14C_TBL2,y
					STA $02
					LDA #$5A
					STA $03
					LDA SUB_ROOM14C_TBL4,y
					STA $15AC,x
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA $00
					STA $2118
					SEP #$20
					LDA $15AC,x
					CMP #$FF
					BNE SUB_ROOM14C_R
					LDA #$90
					STA $1540,x
SUB_ROOM14C_R		RTS

SUB_ROOM14D_TBL1	dcb $13,$10,$19,$05,$39,$19,$12,$0F,$32,$19,$02,$03,$0B,$79,$15
					dcb $0E,$0B,$12,$04,$02,$09,$07,$19,$1D,$3A,$1A,$79,$0F
					dcb $5B,$5E,$46,$19,$09,$43,$13,$79,$19
					dcb $3C,$0F,$05,$14,$49,$6B,$58,$7A,$04,$02,$09,$07,$15,$34,$42,$11,$08
					dcb $48,$84,$4B,$04,$02,$09,$07,$42,$0A,$65,$12,$01,$65,$0F
					dcb $0B,$05,$0B,$1D,$3A,$43,$0F,$79,$19,$0C,$79,$18,$48,$84,$4B,$04,$02,$09,$07,$12,$79,$19
					dcb $5B,$5E,$46,$1C,$18,$1B,$07,$0B,$66,$02,$42,$10,$05,$02,$35,$18,$0F,$10,$05,$79
					dcb $02,$09,$79,$06,$19,$0B,$79,$34,$12,$01,$0F,$18,$12,$79,$00,$38
					
SUB_ROOM14D_TBL2	dcb $66,$67,$68,$69,$6A,$6B,$6C,$6F,$70,$71,$72,$73,$74,$75,$76
					dcb $86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$90,$91,$92
					dcb $C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE
					dcb $E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0,$F1,$F2,$F3,$F4,$F5,$F6
					dcb $06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13
					dcb $46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B
					dcb $66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79
					dcb $86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$90,$91,$92,$93,$94,$95

SUB_ROOM14D_TBL4	dcb $02,$02,$02,$02,$02,$02,$10,$02,$02,$02,$02,$02,$01,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$01,$02,$40
					dcb $02,$02,$02,$02,$02,$02,$01,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$60
					dcb $02,$02,$02,$02,$02,$02,$01,$02,$02,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02,$01,$02,$20
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$01,$20
					dcb $02,$01,$02,$02,$02,$01,$02,$02,$02,$02,$02,$02,$01,$02,$02,$FF
					
SUB_ROOM14D			LDA $1570,x
					TAY
					INC $1570,x
					LDA SUB_ROOM14D_TBL1,y
					STA $00
					LDA #$39
					STA $01
					LDA SUB_ROOM14D_TBL2,y
					STA $02
					
					LDA #$59
					STA $03
					CPY #$36
					BCC SUB_ROOM14D_1
					LDA #$5A
					STA $03
SUB_ROOM14D_1
					LDA SUB_ROOM14D_TBL4,y
					STA $15AC,x
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA $00
					STA $2118
					SEP #$20
					LDA $15AC,x
					CMP #$FF
					BNE SUB_ROOM14D_R
					LDA #$02
					STA $C2,x
					REP #$20
					LDA.W #$0421
					STA $7FE800
					STA $7FE900
					LDA.W #$0000
					STA $7FE802
					STA $7FE804
					STA $7FE80A
					STA $7FE80C
					STA $7FE906
					STA $7FE908
					STA $7FE90A
					LDA.W #$0060
					STA $7FE806
					LDA.W #$1C00
					STA $7FE808
					LDA.W #$0020
					STA $7FE902
					STA $7FE904
					LDA.W #$0800
					STA $7FE90C
					SEP #$20
SUB_ROOM14D_R		RTS

COLOR2				LDA #$F1
					STA $2121
					LDA $7FE900
					STA $2122
					LDA $7FE901
					STA $2122
					LDA $7FE900
					CMP #$F7
					BEQ COLOR2_1
					REP #$20
					LDA $7FE900
					CLC
					ADC.W #$0842
					STA $7FE900
					SEP #$20
					
COLOR2_1			LDA #$F2
					STA $2121
					LDA $7FE902
					STA $2122
					LDA $7FE903
					STA $2122
					LDA $7FE902
					CMP #$83
					BEQ COLOR2_2
					REP #$20
					LDA $7FE902
					CLC
					ADC.W #$1021
					STA $7FE902
					SEP #$20
					
COLOR2_2			LDA #$F3
					STA $2121
					LDA $7FE904
					STA $2122
					LDA $7FE905
					STA $2122
					LDA $7FE905
					CMP #$02
					BEQ COLOR2_3
					REP #$20
					LDA $7FE904
					CLC
					ADC.W #$0040
					STA $7FE904
					SEP #$20
					
COLOR2_3			LDA #$F4
					STA $2121
					LDA $7FE906
					STA $2122
					LDA $7FE907
					STA $2122
					LDA $7FE906
					CMP #$9E
					BEQ COLOR2_4
					REP #$20
					LDA $7FE906
					CLC
					ADC.W #$0443
					STA $7FE906
					SEP #$20
					
COLOR2_4			LDA #$F5
					STA $2121
					LDA $7FE908
					STA $2122
					LDA $7FE909
					STA $2122
					LDA $7FE908
					CMP #$60
					BEQ COLOR2_5
					REP #$20
					LDA $7FE908
					CLC
					ADC.W #$0020
					STA $7FE908
					SEP #$20
					
COLOR2_5			LDA #$F6
					STA $2121
					LDA $7FE90A
					STA $2122
					LDA $7FE90B
					STA $2122
					LDA $7FE90A
					CMP #$B4
					BEQ COLOR2_6
					REP #$20
					LDA $7FE90A
					CLC
					ADC.W #$0024
					STA $7FE90A
					SEP #$20
					
COLOR2_6			LDA #$F7
					STA $2121
					LDA $7FE90C
					STA $2122
					LDA $7FE90D
					STA $2122
					LDA $7FE90C
					CMP #$45
					BEQ COLOR2_R
					REP #$20
					LDA $7FE90C
					CLC
					ADC.W #$0841
					STA $7FE90C
					SEP #$20
COLOR2_R			RTS

COLOR1				LDA #$E1
					STA $2121
					LDA $7FE800
					STA $2122
					LDA $7FE801
					STA $2122
					LDA $7FE800
					CMP #$F7
					BEQ COLOR1_1
					REP #$20
					LDA $7FE800
					CLC
					ADC.W #$0842
					STA $7FE800
					SEP #$20
					
COLOR1_1			LDA #$E2
					STA $2121
					LDA $7FE802
					STA $2122
					LDA $7FE803
					STA $2122
					LDA $7FE802
					CMP #$8C
					BEQ COLOR1_2
					REP #$20
					LDA $7FE802
					CLC
					ADC.W #$0823
					STA $7FE802
					SEP #$20
					
COLOR1_2			LDA #$E3
					STA $2121
					LDA $7FE804
					STA $2122
					LDA $7FE805
					STA $2122
					LDA $7FE804
					CMP #$18
					BEQ COLOR1_3
					REP #$20
					LDA $7FE804
					CLC
					ADC.W #$0402
					STA $7FE804
					SEP #$20
					
COLOR1_3			LDA #$E4
					STA $2121
					LDA $7FE806
					STA $2122
					LDA $7FE807
					STA $2122
					LDA $7FE806
					CMP #$5E
					BEQ COLOR1_4
					REP #$20
					LDA $7FE806
					CLC
					ADC.W #$0422
					STA $7FE806
					SEP #$20
					
COLOR1_4			LDA #$E5
					STA $2121
					LDA $7FE808
					STA $2122
					LDA $7FE809
					STA $2122
					LDA $7FE808
					CMP #$5E
					BEQ COLOR1_5
					REP #$20
					LDA $7FE808
					CLC
					ADC.W #$0823
					STA $7FE808
					SEP #$20
					
COLOR1_5			LDA #$E6
					STA $2121
					LDA $7FE80A
					STA $2122
					LDA $7FE80B
					STA $2122
					LDA $7FE80A
					CMP #$54
					BEQ COLOR1_6
					REP #$20
					LDA $7FE80A
					CLC
					ADC.W #$0022
					STA $7FE80A
					SEP #$20
					
COLOR1_6			LDA #$E7
					STA $2121
					LDA $7FE80C
					STA $2122
					LDA $7FE80D
					STA $2122
					LDA $7FE80C
					CMP #$18
					BEQ COLOR1_R
					REP #$20
					LDA $7FE80C
					CLC
					ADC.W #$0043
					STA $7FE80C
					SEP #$20
COLOR1_R			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine - specific to sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX0			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$46
					STA $0302,y
					LDA #$0F
					ORA $64
					STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS



TILEMAP             dcb $02,$21,$23,$41,$43,$61,$63,$06,$08,$0A,$26,$28,$2A
					dcb $0C,$0E,$2C,$2E,$4C,$4E,$6C,$6E,$48,$4A,$68,$6A
HORZ_DISP           dcb $00,$F8,$08,$F8,$08,$F8,$08,$F0,$00,$10,$F0,$00,$10
					dcb $40,$50,$40,$50,$40,$50,$40,$50,$40,$50,$40,$50
VERT_DISP           dcb $00,$10,$10,$20,$20,$30,$30,$40,$40,$40,$50,$50,$50
					dcb $00,$00,$10,$10,$20,$20,$30,$30,$40,$40,$50,$50
PROPERTIES			dcb $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
					dcb $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F

SUB_GFX_R			RTS
SUB_GFX             LDA $C2,x
					BEQ SUB_GFX_R
					JSR GET_DRAW_INFO
					LDA #$00
					TAY
					STA $15EA,x
					
                    PHX
                    ;LDX #$0C
					LDX #$18
LOOP_START          
					LDA HORZ_DISP,x
					CLC
					ADC $00
					STA $0200,y
					LDA VERT_DISP,x
					CLC
					ADC $01
					STA $0201,y
					LDA TILEMAP,x
					STA $0202,y
					LDA PROPERTIES,x
					ORA $64
					STA $0203,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_START
					
					PLX
                    LDY #$02
                    LDA #$18
					;JSL $01B7B3
					JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ; | set horizontal offscreen if necessary
                    LDA $14E0,x             ; |
                    SBC $1B                 ; |
                    BEQ ON_SCREEN_X         ; |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ; |
                    LDA $E4,x               ; |
                    REP #$20                ; |
                    SEC                     ; |
                    SBC $1A                 ; | mark sprite invalid if far enough off screen
                    CLC                     ; |
                    ADC.W #$0040            ; |
                    CMP.W #$0180            ; |
                    SEP #$20                ; |
                    ROL A                   ; |
                    AND #$01                ; |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ; | 
                    AND #$20                ; | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ; | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ; | set vertical offscreen if necessary
                    ADC TABLE1,y            ; |
                    PHP                     ; |
                    CMP $1C                 ; | (vert screen boundry)
                    ROL $00                 ; |
                    PLP                     ; |
                    LDA $14D4,x             ; | 
                    ADC #$00                ; |
                    LSR $00                 ; |
                    SBC $1D                 ; |
                    BEQ ON_SCREEN_Y         ; |
                    LDA $186C,x             ; | (vert offscreen)
                    ORA TABLE2,y            ; |
                    STA $186C,x             ; |
ON_SCREEN_Y         DEY                     ; |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ; | 
                    SBC $1A                 ; | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ; | 
                    SBC $1C                 ; | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ; |    ...(not just this subroutine)
                    RTS                     ; /

					
STATUS_DEL			LDA $7FFB20
					BNE STATUS_DEL_R
					LDA #$10
					STA $7FFB20
					LDA #$02
					STA $7FFB21
					LDA #$11
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$DF
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					LDA #$30
					STA $7FDF00
					LDA #$00
					STA $7FDF01
					LDA #$01
					STA $7FDF02
					LDA #$60
					STA $7FDF03
					LDA #$00
					STA $7FDF04
					STA $7FDF05
					STA $7FDF06
STATUS_DEL_R		RTS


HDMA2				LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$00
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E0
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					LDA #$10
					STA $7FE000
					LDA #$00
					STA $7FE001
					STA $7FE002
					RTS
					
HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$40
					STA $7FFB30
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB31
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB32
					LDA #$00
					STA $7FFB1B
					STA $7FFB33
					LDA #$E1
					STA $7FFB1C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB1D
					STA $7FFB35
					
					LDA #$00
					STA $02
					STA $03
					REP #$20
					LDA.W #$0004
					STA $00
					SEP #$20
					
HDMA_COLOR_LOOP		PHX
					LDX $02
					LDA #$04
					STA $7FE100,x
					LDA #$39
					STA $7FE101,x
					INC $02
					INC $02
					
					LDX $03
					LDA #$04
					STA $7FE200,x
					REP #$20
					LDA $00
					STA $7FE201,x
					CLC
					ADC.W #$0421
					STA $00
					SEP #$20
					INC $03
					INC $03
					INC $03
					PLX
					LDA $02
					CMP #$10
					BCC HDMA_COLOR_LOOP
					
					PHX
					LDX $02
					LDA #$00
					STA $7FE100,x
					LDX $03
					LDA #$00
					STA $7FE200,x
					PLX
					RTS
