;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Picture
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA $14E0,x
					CMP #$03
					BNE INIT1
					STZ $C2,x ;#mRmR
					LDA #$01
					STA $1570,x
					STZ $1602,x
					LDA #$0B
					STA $1504,x
                    RTL
INIT1
					CMP #$04
					BNE INIT2
					LDA #$01
					STA $C2,x ;#eT
					STZ $1570,x
					STZ $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT2				CMP #$05
					BNE INIT3
					LDA #$02
					STA $C2,x ;#J
					LDA #$02
					STA $1570,x
					STZ $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT3				CMP #$06
					BNE INIT4
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA #$03
					STA $C2,x ;#KK
					LDA #$02
					STA $1570,x
					LDA #$01
					STA $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT4				CMP #$07
					BNE INIT5
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA #$04
					STA $C2,x ;#Α
					LDA #$02
					STA $1570,x
					LDA #$02
					STA $1602,x
					LDA #$01
					STA $1504,x
					RTL
INIT5				CMP #$08
					BNE INIT6
					LDA #$01
					STA $C2,x ;#eT
					STZ $1570,x
					STZ $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT6				CMP #$09
					BNE INIT8
					LDA $E4,x
					CMP #$10
					BNE INIT7
					LDA #$05
					STA $C2,x ;#ou
					STZ $1570,x
					LDA #$01
					STA $1602,x
					LDA #$05
					STA $1504,x
					RTL
INIT7				LDA #$06
					STA $C2,x ;#eTEX
					STZ $1570,x
					LDA #$02
					STA $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT8				CMP #$0A
					BNE INITA
					LDA $E4,x
					BNE INIT9
					LDA #$07
					STA $C2,x ;#Rg
					STZ $1570,x
					LDA #$03
					STA $1602,x
					LDA #$03
					STA $1504,x
					RTL
INIT9				LDA #$08
					STA $C2,x ;#L[
					STZ $1570,x
					LDA #$04
					STA $1602,x
					LDA #$02
					STA $1504,x
					RTL
INITA				CMP #$0B
					BNE INITB
					LDA #$06
					STA $C2,x ;#eTEX
					STZ $1570,x
					LDA #$02
					STA $1602,x
					LDA #$03
					STA $1504,x
					RTL
INITB				LDA #$09
					STA $C2,x ;#ubNeT
					STZ $1570,x
					LDA #$05
					STA $1602,x
					LDA #$03
					STA $1504,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                     ; return           
CODE_START          LDA $1570,x
					BNE GFX2
					JSR SUB_GFX
					BRA MAIN
GFX2				CMP #$01
					BNE GFX4
					JSR SUB_GFX2
					BRA MAIN
GFX4				JSR SUB_GFX4
MAIN				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $C2,x
					CMP #$01
					BEQ GEN2
					CMP #$09
					BEQ GEN2
					CMP #$03
					BEQ GEN1
					LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BCC RETURN2
					LDA $0F
					AND #$F8
					CMP #$40
					BNE RETURN2
					JSR GEN_SPRITE
					STZ $14C8,x
					RTS
GEN1				LDA $E4,x
					SEC
					SBC $94
					STA $0F
					LDA $14E0,x
					SBC $95
					BCC RETURN2
					LDA $0F
					AND #$F8
					CMP #$80
					BNE RETURN2
					JSR GEN_SPRITE
					STZ $14C8,x
RETURN2				RTS
GEN2				LDA $94
					SEC
					SBC $E4,x
					STA $0F
					LDA $95
					SBC $14E0,x
					BCC RETURN2
					LDA $0F
					AND #$F8
					CMP #$10
					BNE RETURN2
					JSR GEN_SPRITE
					STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPRITE				dcb $04,$37,$30,$B4,$BC,$B6,$39,$27,$1C,$AF
RETURN68            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full					
					PHX
					LDA $C2,x
					TAX
					LDA SPRITE,x
					STA $0F
					PLX
					
                    BMI RETURN68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA $0F
                    STA $009E,y
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					LDA #$01
					STA $157C,y
					LDA $C2,x
					CMP #$04
					BEQ SEKIZO
					CMP #$06
					BEQ TELE
					CMP #$05
					BEQ BUB
					CMP #$08
					BEQ KILL
                    RTS                          ; return
SEKIZO				LDA #$02
					STA $00C2,y
					LDA #$35
					STA $166E,y
					STA $15F6,y
					RTS
TELE				LDA #$F0
					STA $00B6,y
					RTS
BUB					LDA #$00
					STA $157C,y
					LDA #$F0
					STA $00AA,y
					STA $00B6,y
					RTS
KILL				LDA #$01
					STA $00C2,y
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP1			dcb $8C,$C4,$ED,$CE,$A6,$8C

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $1602,x
					STA $02
					LDA $1504,x
					STA $03

LOOP_START1         PHX                     ; push current tile number
                    LDX $02
					
                    LDA $00                 ; \ til
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP1,x
                    STA $0302,y            ; / 
					
					LDA #$00            ;  |
                    ORA $03
					ORA $64
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing 

                    LDY #$02                ; \ 02, because we di
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP2			dcb $82,$A0
HORZ_DISP2          dcb $00,$00
VERT_DISP2          dcb $F0,$00

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					PHX                     ; push sprite index
                    LDX #$01                ; loop counter = (number of tiles per frame) - 1
LOOP_START2         
					
                    LDA $00                 ; \ til
					CLC                     ;  |
                    ADC HORZ_DISP2,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0301,y             ; /   set y position of the tile

					
					LDA TILEMAP2,x
                    STA $0302,y            ; / 
					
					LDA #$00            ;  |
                    ORA #$0A
					ORA $64
                    STA $0303,y             ; / store tile properties
                    

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we di
                    LDA #$01                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP4			dcb $64,$68,$CC,$CC,$6C,$A0,$C0,$C2,$30,$41,$CC,$CC
HORZ_DISP4          dcb $F9,$00,$00,$00,$F8,$08,$F8,$08,$F8,$00,$00,$00
VERT_DISP4          dcb $F0,$00,$10,$20,$00,$00,$10,$10,$F8,$00,$10,$20

SUB_GFX4            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

					LDA $1602,x
					ASL A
					ASL A
					STA $02
					LDA $1504,x
					STA $03
					PHX                     ; push sprite index
                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         PHX                     ; push current tile number
                    
					TXA
					CLC
					ADC $02
					TAX
					
                    LDA $00                 ; \ til
					CLC                     ;  |
                    ADC HORZ_DISP4,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP4,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP4,x
                    STA $0302,y            ; / 
					
					LDA #$00            ;  |
                    ORA $03
					ORA $64
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we di
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /




