;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10

                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0

                    IS_ON_YOSHI     = $187A
                    
                    ;data
                    YOSHI_OFFSET    = $10
                    SIZE            = $08
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_R
					LDA $14D4,x
					CMP #$0C
					BNE INIT_R
					LDA #$01
					STA $1528,x
					REP #$20
					LDA.W #$0CB0
					STA $7FFFD0;݂̈ʒuItZbg
					LDA.W #$0CB0
					STA $7FFFD2;ړ
					SEP #$20
					JSR HDMA_COLOUR
INIT_R				RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA EXTRA_BITS,x
					AND #$04
					BNE MAIN2
					JSR WATER
					RTS
MAIN2				LDA $1528,x
					BNE MAIN3
					JSR LIFT
					RTS
MAIN3				JSR CODE
					RTS
					
LIFT_R				RTS
LIFT				JSR SUB_GFX_L
					LDA $9D
					BNE LIFT_R
					LDA #$97
					STA $167A,x
					JSR SUB_B852
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $019138
					LDA $1588,x
					STA $157C,x
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $019138
					LDA $1588,x
					ORA $157C,x
					STA $157C,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					REP #$20
					LDA $02
					CMP $7FFFD0
					SEP #$20
					BEQ LIFT_2
					BCS LIFT_1
					LDA $157C,x
					AND #$04
					BNE LIFT_2
					LDA #$10
					STA $AA,x
					JSL $01801A
					BRA LIFT_2
LIFT_1				LDA $157C,x
					AND #$08
					BNE LIFT_2
					LDA #$F0
					STA $AA,x
					JSL $01801A
LIFT_2				JSL $01A7DC
					BCS LIFT_3
					LDA $D8,x
					PHA
					CLC
					ADC #$08
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					BCS LIFT_3
					RTS
LIFT_3				LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCC LIFT_4
					LDA $157C,x
					AND #$01
					BNE LIFT_LEFT
LIFT_RIGHT			LDA #$20
					STA $B6,x
					JSL $018022
					RTS
LIFT_4				LDA $157C,x
					AND #$02
					BNE LIFT_RIGHT
LIFT_LEFT			LDA #$E0
					STA $B6,x
					JSL $018022
RETURN02			RTS

WATER				JSR SUB_GFX
					LDA $9D
					BNE WATER_R
					LDA #$22
					STA $1504,x
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					JSL $01A7DC
					BCC WATER_R
					LDA $151C,x
					BNE WATER_R
					LDA #$22
					STA $1DFC
					JSR RESET151C
					LDA $D8,x
					STA $7FFFD2
					LDA $14D4,x
					STA $7FFFD3
					LDA #$01
					STA $151C,x
WATER_R				RTS

RESET151C			STX $02
					LDY #$00
RESET151C_L			CPY $02
					BEQ RESET151C_2
					LDA $14C8,y
					CMP #$08
					BCC RESET151C_2
					LDA $1504,y
					CMP #$22
					BNE RESET151C_2
					LDA #$00
					STA $151C,y
RESET151C_2			INY
					CPY #$0A
					BCC RESET151C_L
					RTS




TILEMAP             dcb $C0,$C2,$E0,$E2
					dcb $C4,$C6,$E4,$E6
					dcb $E8,$EA,$EC,$EE
					dcb $A0,$A2,$A4,$C8
HORZ_DISP			dcb $F8,$08,$F8,$08
VERT_DISP			dcb $F8,$F8,$08,$08
PROPETIES			dcb $05,$07,$09,$0B

SUB_GFX             JSR GET_DRAW_INFO
					PHX
                    LDA $14
					LSR A
					LSR A
					;LSR A
					AND #$03
					ASL A
					ASL A
					STA $02
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA PROPETIES,x
					STA $03
					LDX #$03
LOOP_START          LDA $00
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA TILEMAP,x
					STA $0302,y
					PLX
					LDA $03
					ORA $64
					STA $0303,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILE_L				dcb $60,$62,$60,$62
HOZR_L				dcb $F8,$08,$F8,$08
VERT_L				dcb $00,$00,$08,$08
SUB_GFX_L			JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_L				LDA $00
					CLC
					ADC HOZR_L,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_L,x
					STA $0301,y
					LDA TILE_L,x
					STA $0302,y
					LDA #$01
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_L
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
					STZ $00
					STZ $01
					STZ $02
					STZ $05
					STZ $06
                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
					
					
RETURN892			RTS
SUB_B852            STZ $1570,x
					JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					ORA $154C,x
                    BNE RETURN05
					
                    LDA $D8,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$14     
                    CMP $09      
                    BCS RETURN05
                    LDA $7D    
                    BMI RETURN05     
                    STZ $7D  ;#ɏĂ
                    LDA #$01     
                    STA $1471       
					STA $1570,x
					LDA $0D      
                    CLC          
                    ADC #$1F     ;#1F?
					
                    LDY $187A; IS_ON_YOSHI         ; adjust for yoshi  
                    BEQ NO_YOSHI      
                    CLC
                    ADC #$10
					
NO_YOSHI			STA $00

                    LDA $D8,x
                    SEC          
                    SBC $00      
                    STA $96
                    LDA $14D4,x  
                    SBC #$00     
                    STA $97
                    LDY #$00     
RETURN05            RTS           

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA $14D4,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 
					
					
CODE				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA #$04
					STA $212C
					LDA #$13
					STA $212D
					LDA #$02
					STA $1413
					JSR MOVE_WATER
					JSR HDMA_WATER
					JSR IN_WATER
					RTS
					
MOVE_WATER			REP #$20
					LDA $7FFFD0
					CMP $7FFFD2
					BEQ MOVE_WATER_R
					BCS MOVE_WATER_2
					INC A
					STA $7FFFD0
					BRA MOVE_WATER_R
MOVE_WATER_2		DEC A
					STA $7FFFD0
MOVE_WATER_R		SEP #$20
					RTS
					
IN_WATER			STZ $85
					REP #$20
					LDA $96
					CLC
					ADC.W #$0010
					CMP $7FFFD0
					BCC IN_WATER_R
					SEP #$20
					LDA #$01
					STA $85
IN_WATER_R			SEP #$20
					RTS
					
HDMA_WATER			REP #$20
					LDA $7FFFD0
					SEC
					SBC $1464
					BCC HDMA_WATER_2
					CMP.W #$00F0
					BCS HDMA_WATER_3
					CMP.W #$0080
					BCS HDMA_WATER_4
					SEP #$20
					STA $7FF200
					STA $7FF300
					LDA #$00
					STA $7FF201
					STA $7FF301
					STA $7FF302
					LDA #$01
					STA $7FF202
					STA $7FF303
					LDA #$00
					STA $7FF304
					LDA #$40
					STA $7FF305
					LDA #$00
					STA $7FF203
					STA $7FF204
					STA $7FF306
					RTS
HDMA_WATER_2		SEP #$20
					LDA #$01
					STA $7FF200
					STA $7FF300
					LDA #$00
					STA $7FF201
					LDA #$00
					STA $7FF301
					LDA #$40
					STA $7FF302
					LDA #$00
					STA $7FF202
					STA $7FF303
					RTS
HDMA_WATER_4		BRA HDMA_WATER_40
HDMA_WATER_3		SEP #$20
					LDA #$01
					STA $7FF200
					STA $7FF300
					LDA #$00
					STA $7FF201
					STA $7FF301
					STA $7FF302
					LDA #$00
					STA $7FF202
					STA $7FF303
					RTS
HDMA_WATER_40		SEP #$20
					SEC
					SBC #$7F
					STA $7FF202
					STA $7FF303
					LDA #$00
					STA $7FF203
					STA $7FF304
					STA $7FF305
					LDA #$01
					STA $7FF204
					STA $7FF306
					LDA #$00
					STA $7FF205
					STA $7FF206
					STA $7FF309
					LDA #$00
					STA $7FF307
					LDA #$40
					STA $7FF308
					LDA #$7F
					STA $7FF200
					STA $7FF300
					LDA #$00
					STA $7FF201
					STA $7FF301
					STA $7FF302
					RTS

HDMA_COLOUR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$F2
					STA $7FFB1C
					LDA #$F3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FF200
					STA $7FF300
					LDA #$00
					STA $7FF201
					STA $7FF301
					STA $7FF302
					LDA #$01
					STA $7FF202
					STA $7FF303
					LDA #$00
					STA $7FF203
					STA $7FF304
					STA $7FF305
					STA $7FF204
					STA $7FF306
					RTS
