;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Wily Stage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;#Xe[W1NAtO 1F34:10
;#Xe[W2NAtO 1F34:20
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$2D
					BEQ INIT_1
					LDA #$01
					STA $1504,x
					LDA $94
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCC INIT_R
					STZ $1411
					STZ $1412
					LDA #$F0
					STA $1462
					LDA #$02
					STA $1602,x
					LDA $010B
					CMP #$56
					BNE INIT_R
					LDA #$A2
					STA $1464
INIT_R				RTL
INIT_1				LDA $14E0,x
					CMP #$03
					BNE INIT_5
					LDA #$02
					STA $1504,x
					RTL
INIT_5				LDA EXTRA_BITS,x
					AND #$04
					BEQ INIT_0
					STZ $0DC1
					STZ $0DC2
					LDA #$15
					STA $15AC,x
					LDA #$02
					STA $1540,x
					RTL
INIT_0				LDA #$FF
					STA $15AC,x
					LDA #$FF
					STA $1540,x
					LDA $E4,x
					ORA #$0C
					STA $E4,x
					LDA $D8,x
					ORA #$02
					STA $D8,x
					LDA $D8,x
					AND #$F0
					CMP #$D0
					BEQ INIT_2
					CMP #$20
					BEQ INIT_3
					CMP #$70
					BEQ INIT_4
					RTL
INIT_2				JSR LAYER3_DEL
					STZ $1602,x
					RTL
INIT_3				LDA #$20
					STA $1602,x
					LDA #$01
					STA $1528,x
					RTL
INIT_4				LDA #$40
					STA $1602,x
					LDA #$02
					STA $1528,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					BNE NOT_MAIN1
					JSR LOGO
					RTS
NOT_MAIN1			CMP #$01
					BNE NOT_MAIN2
					JSR SHATTER
					RTS
NOT_MAIN2			CMP #$02
					BNE NOT_MAIN3
					JSR MIDPOINT
					RTS
NOT_MAIN3			CMP #$03
					BNE NOT_MAIN4
					JSR TIUN
					RTS
NOT_MAIN4			CMP #$04
					BNE NOT_MAIN3
					JSR FINISH
					RTS
NOT_MAIN5			;JSR WARP
					RTS
					
LOGO				LDA EXTRA_BITS,x
					AND #$04
					BEQ LOGO_0
					JSR WILY_FACE
					RTS
LOGO_0				JSR SUB_GFX_LOGO
	                LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
					LDA $1528,x
					CMP #$01
					BEQ LOGO2
					CMP #$02
					BEQ LOGO3
					LDA $1F34
					AND #$30
					CMP #$30
					BNE LOGO_1_R
					LDA $15AC,x
					BEQ LOGO_1_2
					LDA #$80
					STA $1540,x
					RTS
LOGO_1_2			LDA $1540,x
					CMP #$01
					BEQ LOGO_1_5
					CMP #$00
					BNE LOGO_1_R
					INC $1570,x
					LDA $1570,x
					CMP #$81
					BCC LOGO_1_3
					CMP #$C0
					BEQ LOGO_1_4
					CMP #$B0
					BCS LOGO_1_6
					RTS
LOGO_1_3			REP #$20
					LDA $7FE301
					SEC
					SBC.W #$0002
					STA $7FE301
					SEP #$20
LOGO_1_5			LDA $E4,x
					CLC
					ADC #$02
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
LOGO_1_R			RTS
LOGO_1_4			LDA $19BA
					STA $19B8
					LDA $19DA
					STA $19D8
					LDA $1B95
					STA $1B93
					LDA #$06
					STA $71
					STZ $89
					STZ $88
LOGO_R				RTS
LOGO_1_6			LDA $7FE901
					BEQ LOGO_1_R
					DEC A
					STA $7FE901
					RTS
LOGO3				BRA LOGO300
LOGO2				LDA $1F34
					AND #$10
					BEQ LOGO_2_R
					LDA $1F34
					AND #$20
					BNE LOGO2_2
					LDA $15AC,x
					BEQ LOGO_2_2
					LDA #$80
					STA $1540,x
					RTS
LOGO2_2				LDA #$01
					STA $7FE305
					STZ $14C8,x
					RTS
LOGO_2_2			LDA $1540,x
					CMP #$01
					BEQ LOGO_2_5
					CMP #$00
					BNE LOGO_2_R
					INC $1570,x
					LDA $1570,x
					CMP #$81
					BCC LOGO_2_3
					CMP #$C0
					BEQ LOGO_2_4
					CMP #$B0
					BCS LOGO_2_6
					RTS
LOGO300				BRA LOGO30
LOGO_2_3			REP #$20
					LDA $7FE304
					CLC
					ADC.W #$0002
					STA $7FE304
					SEP #$20
LOGO_2_5			LDA $E4,x
					SEC
					SBC #$02
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
LOGO_2_R			RTS
LOGO_2_4			LDA $19B9
					STA $19B8
					LDA $19D9
					STA $19D8
					LDA $1B94
					STA $1B93
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
LOGO_2_6			LDA $7FE901
					BEQ LOGO_2_R
					DEC A
					STA $7FE901
					RTS


LOGO30				LDA $1F34
					AND #$10
					BNE LOGO3_2
					LDA $15AC,x
					BEQ LOGO_3_2
					LDA #$80
					STA $1540,x
					RTS
LOGO3_2				LDA #$FF
					STA $7FE308
					STZ $14C8,x
					RTS
LOGO_3_2			LDA $1540,x
					CMP #$01
					BEQ LOGO_3_5
					CMP #$00
					BNE LOGO_3_R
					INC $1570,x
					LDA $1570,x
					CMP #$81
					BCC LOGO_3_3
					CMP #$C0
					BEQ LOGO_3_4
					CMP #$B0
					BCS LOGO_3_6
					RTS
LOGO_3_3			REP #$20
					LDA $7FE307
					SEC
					SBC.W #$0002
					STA $7FE307
					SEP #$20
LOGO_3_5			LDA $E4,x
					CLC
					ADC #$02
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
LOGO_3_R			RTS
LOGO_3_4			LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
LOGO_3_6			LDA $7FE901
					BEQ LOGO_3_R
					DEC A
					STA $7FE901
					RTS

WILY_FACE			JSR SUB_GFX_FACE
					LDA #$24
					STA $40
					LDA #$11
					STA $212C
					LDA #$06
					STA $212D
					LDA $1540,x
					BEQ WILY_FACE2
					STZ $40
					LDA #$00
					STA $212C
					LDA #$17
					STA $212D
WILY_FACE2			LDA $9D
					BNE WILY_FACE_R
					LDA #$FF
					STA $18BD
					LDA $15AC,x
					BEQ WILY_FACE_R
					LDA $7FE901
					CMP #$0F
					BEQ WILY_FACE_R
					INC A
					STA $7FE901
WILY_FACE_R			RTS



NEXT_SHATTER		JSR SHATTER4
					LDA $7FFFA0
					BEQ SHATTER_R
					LDA EXTRA_BITS,x
					AND #$FB
					STA EXTRA_BITS,x
					RTS
SHATTER				JSR SUB_GFX_SHA
					LDA $9D
					BNE SHATTER_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA EXTRA_BITS,x
					AND #$04
					BNE NEXT_SHATTER
					LDA $1602,x
					BNE SHATTER_02
					JSR SHATTER1
SHATTER_R			RTS
SHATTER_02			CMP #$01
					BNE SHATTER_03
					JSR SHATTER2
					RTS
SHATTER_03			JSR SHATTER3
					RTS

SHATTER1			LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					JSL $01A7DC
					BCS SHATTER_12
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_12
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_12
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_12
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
SHATTER_1R			RTS
SHATTER_12			LDA #$01
					STA $1602,x
					STZ $1570,x
					LDA #$44
					STA $15AC,x
					LDA #$0E
					STA $1DFC
					LDA $13E0
					STA $1528,x
					LDA $13DF
					STA $151C,x
					LDA $76
					STA $157C,x
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					RTS
					
SHATTER2			LDA #$FF
					STA $18BD
					LDA $1528,x
					STA $13E0
					LDA $151C,x
					STA $13DF
					LDA $157C,x
					STA $76
					LDA $1540,x
					BNE SHATTER2_3
					LDA $15AC,x
					BNE SHATTER2_1
					LDA $14
					AND #$01
					BNE SHATTER2_2
					REP #$20
					INC $94
					SEP #$20
SHATTER2_2			REP #$20
					INC $1462
					INC $1462
					INC $1462
					INC $1462
					SEP #$20
					INC $1570,x
					LDA $1570,x
					CMP #$3C
					BCC SHATTER2_R
					LDA #$44
					STA $1540,x
					LDA #$0E
					STA $1DFC
SHATTER2_R			RTS
SHATTER2_1			LDA #$F0
					STA $AA,x
					JSL $01801A
					RTS
SHATTER2_3			LDA #$10
					STA $AA,x
					JSL $01801A
					LDA $1540,x
					CMP #$01
					BNE SHATTER2_R
					LDA #$02
					STA $1602,x
					STZ $18BD
					RTS
					
SHATTER3			LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					JSL $01A7DC
					BCS SHATTER_32
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_32
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_32
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_32
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
SHATTER_3R			RTS
SHATTER_32			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $E4,x
					CLC
					ADC #$10
					STA $94
					LDA $14E0,x
					ADC #$00
					STA $95
					RTS
					
SHATTER4			LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					JSL $01A7DC
					BCS SHATTER_42
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_42
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_42
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS SHATTER_42
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
SHATTER_4R			RTS
SHATTER_42			PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $E4,x
					SEC
					SBC #$10
					STA $94
					LDA $14E0,x
					SBC #$00
					STA $95
					RTS
					
MIDPOINT			LDA #$03
					STA $212C
					LDA #$14
					STA $212D
					LDA $9D
					BNE MIDPOINT_R
					LDA #$1E
					STA $1DFB
					LDA $1F34
					AND #$30
					BEQ MIDPOINT_WARP
					CMP #$30
					BEQ MIDPOINT_2
					LDA $19BC
					STA $19BB
					LDA $19DC
					STA $19DB
					LDA $1B97
					STA $1B96
					BRA MIDPOINT_WARP
MIDPOINT_2			LDA $19BD
					STA $19BB
					LDA $19DD
					STA $19DB
					LDA $1B98
					STA $1B96
MIDPOINT_WARP		LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
MIDPOINT_R			RTS


TIUN				LDA $0DDA
					CMP #$FF
					BNE TIUN_2
					JSR SUB_GEN2
					STZ $14C8,x
					RTS
TIUN_2				LDA $9D
					BNE TIUN_R
					TXA
					STA $7FFE00
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					LDA $010B
					CMP #$55
					BEQ TIUN_R
					CMP #$58
					BEQ TIUN_R
					CMP #$59
					BEQ TIUN_R
					CMP #$5A
					BEQ TIUN_R
					LDA $15AC,x
					BEQ TIUN_3
					CMP #$01
					BNE TIUN_R
					LDA #$04
					STA $1504,x
					LDA #$60
					STA $15AC,x
					LDA #$23
					STA $1DF9
					RTS
TIUN_3				LDA $010B
					CMP #$56
					BNE TIUN_R
					LDA $1463
					CMP #$11
					BNE TIUN_R
					LDA #$60
					STA $15AC,x
TIUN_R				RTS

FINISH				JSR SUB_GFX_WA
					LDA $9D
					BNE FINISH_R
					STZ $7B
					STZ $B6,x
					LDA #$13
					STA $78
					STA $18BD
					LDA $15AC,x
					CMP #$58
					BCS FINISH_R
					CMP #$01
					BEQ FINISH_END
					LDA #$B0
					STA $AA,x
					JSL $01801A
FINISH_R			RTS
FINISH_END			LDA $010B
					CMP #$57
					BEQ TELEPORT
					CMP #$5C
					BEQ TELEPORT
					LDA $010B
					CMP #$56
					BEQ FINISH_END_2
FINISH_END_1		LDA $1F34
					ORA #$10
					STA $1F34
					BRA FINISH_END_3
FINISH_END_2		LDA $1F34
					ORA #$20
					STA $1F34
FINISH_END_3		LDA $1EF3
					AND #$BF
					STA $1EF3 ;#ԃtO폜
					LDA $1F39 ;#hSRCtO폜
					AND #$BF
					STA $1F39
					
					LDA $0DD5
					BEQ LBL01
					BPL RETURN001
LBL01				STZ $13CE
					;LDA #$01
					;STA $13CE ;#NAtO
					LDA #$01
					STA $0DD5
					INC $1DE9
					LDA #$0B
					STA $0100
					STZ $14C8,x
RETURN001			RTS

TELEPORT			STZ $14C8,x
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS

SUB_GEN2			PHX
					LDX #$00
TIUN_300			LDA #$00
					STA $7FFBB0,x
					INX
					CPX #$20
					BCC TIUN_300
					PLX
					JSR GEN_SPRITE
					LDA #$00
					STA $1570,y
					RTS
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$3B
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$99
					STA $7FFEE0
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP             dcb $A0,$A2,$80,$82
HORZ_DISP			dcb $F8,$08,$F8,$08,
VERT_DISP			dcb $00,$00,$F0,$F0

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START          
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y
					LDA #$07
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     
					
VERT_SHAR_DISP		dcb $D0,$E0,$F0,$00

SUB_GFX_SHA         JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$03
LOOP_START          
					LDA $01
					CLC
					ADC VERT_SHAR_DISP,x
					STA $0301,y
					LDA $00
                    STA $0300,y             ; /
					
					LDA #$00
                    STA $0302,y
					LDA #$05
                    ;ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     
					
HORZ_DISP_LOGO			dcb $00,$10,$20,$00,$10,$20,$00,$10
VERT_DISP_LOGO			dcb $00,$00,$00,$10,$10,$10,$20,$20
TILEMAP_LOGO			dcb $88,$8A,$8C,$A8,$AA,$AC,$C8,$CA

SUB_GFX_LOGO        JSR GET_DRAW_INFO
					LDA $1602,x
					TAY
					STA $15EA,x
					PHX                     ; push sprite index
                    LDX #$07              ; loop counter = (number of tiles per frame) - 1
LOOP_START_LOGO     LDA TILEMAP_LOGO,x           ; \ store tile
                    STA $0202,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_LOGO,x         ;  |
                    STA $0200,y             ; /
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_LOGO,x         ;  |
                    STA $0201,y             ; /
                    
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_LOGO          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
HORZ_DISP_FACE			dcb $F0,$00,$10,$20,$F0,$00,$10,$20,$F0,$00,$10,$20
VERT_DISP_FACE			dcb $00,$00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20
TILEMAP_FACE			dcb $80,$82,$82,$80,$A0,$A2,$A2,$A0,$C0,$C2,$C2,$C0
FACE_PROP				dcb $0D,$0D,$4D,$4D,$0D,$0D,$4D,$4D,$0D,$0D,$4D,$4D

SUB_GFX_FACE        JSR GET_DRAW_INFO
					LDY #$60
					TYA
					STA $15EA,x
					PHX                     ; push sprite index
                    LDX #$0B              ; loop counter = (number of tiles per frame) - 1
LOOP_START_FACE     LDA TILEMAP_FACE,x           ; \ store tile
                    STA $0202,y
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP_FACE,x         ;  |
                    STA $0200,y             ; /
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP_FACE,x         ;  |
                    STA $0201,y             ; /
                    
                    LDA FACE_PROP,x
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_FACE          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0B
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					

TILEMAP1            dcb $C0,$C2,$E0,$E2,$E8
HORZ_DISP1			dcb $F8,$08,$F8,$08,$FD
VERT_DISP1			dcb $F0,$F0,$00,$00,$E0

SUB_GFX1             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDX #$04
LOOP_START1          
					LDA $01
					CLC
					ADC VERT_DISP1,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_DISP1,x
                    STA $0300,y             ; /
					
					LDA TILEMAP1,x           ; \ store tile
                    STA $0302,y
					LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP2            dcb $8A,$8C,$8E,$8C,$8A,$8C,$8E,$8C,$8A,$8C,$8E,$8C,$8A,$8C,$8E,$8C
HORZ_DISP2			dcb $00,$F8,$08,$00,$00,$00,$08,$F8,$00,$F8,$05,$F0,$00,$08,$F0,$F8
VERT_DISP2			dcb $C3,$D8,$E8,$F0,$C3,$D8,$E0,$F8,$C3,$D0,$E8,$F0,$C3,$D8,$E0,$E8

SUB_GFX2             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
                    PHX                     ; push sprite index
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					STA $02
					LDX #$02
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_DISP2,x
                    STA $0300,y             ; /
					
					LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y

                    LDA #$05
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$02                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP_WA			dcb $02,$02,$22,$22,$06,$26,$06,$64
HORZ_WA				dcb $F8,$07,$F8,$07,$00,$00,$00,$00
VERT_WA				dcb $F0,$F0,$00,$00,$E0,$F0,$00,$00
PROP_WA				dcb $0B,$4B,$0B,$4B,$0B,$0B,$8B,$0B
SUB_GFX_WA			JSR GET_DRAW_INFO
					STZ $02
					LDA $15AC,x
					CMP #$58
					BCS SUB_GFX_WA_2
					LDA #$04
					STA $02
SUB_GFX_WA_2		PHX
					LDX #$03
LOOP_WA		        PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_WA,x
					STA $0301,y
					LDA $00                 ; 
					CLC
					ADC HORZ_WA,x
                    STA $0300,y             ; /
					
					LDA TILEMAP_WA,x           ; \ store tile
                    STA $0302,y

                    LDA PROP_WA,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_WA          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

LAYER3_DEL			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$00
					STA $7FFB31
					LDA #$11
					STA $7FFB1A
					LDA #$0D
					STA $7FFB22
					LDA #$0E
					STA $7FFB2A
					LDA #$00
					STA $7FFB32
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					STA $7FFB2B
					STA $7FFB33
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$E8
					STA $7FFB2C
					LDA #$E9
					STA $7FFB34
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					STA $7FFB2D
					STA $7FFB35
					
					LDA #$01
					STA $7FE200
					LDA #$00
					STA $7FE201
					STA $7FE203
					LDA #$01
					STA $7FE202
					
					LDA #$01
					STA $7FE800
					LDA #$C4
					STA $7FE801
					LDA #$00
					STA $7FE802
					STA $7FE803
					
					LDA #$4F
					STA $7FE300
					LDA #$00
					STA $7FE301
					STA $7FE302
					LDA #$48
					STA $7FE303
					LDA #$00
					STA $7FE304
					STA $7FE305
					LDA #$48
					STA $7FE306
					LDA #$00
					STA $7FE307
					STA $7FE308
					STA $7FE309
					
					LDA #$01
					STA $7FE900
					LDA #$00
					STA $7FE901
					LDA #$00
					STA $7FE902
					RTS
