;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; C[}V
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$70
					STA $E4,x
					LDA #$03
					STA $14E0,x
					LDA $D8,x
					ORA #$08
					STA $D8,x
					LDA #$03
					STA $15AC,x
					LDA #$87
					STA $1662,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR MACHINE
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR WHEEL
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR MOUTH
					RTS
MAIN3				JSR BOMB
					RTS

BOMB				JSR SUB_GFX_B
					LDA $9D
					BNE BOMB_R
					LDA $15AC,x
					BNE BOMB_R
					STZ $14C8,x
BOMB_R				RTS

DELETE2				STZ $14C8,x
					RTS
WHEEL				LDA $7FFAE5
					BNE WHEEL_1
					JSR SUB_GFX_W
					BRA WHEEL_2
WHEEL_1				JSR SUB_GFX_W2
WHEEL_2
					LDA $9D
					BNE WHEEL_R
					LDA $7FFAC2
					CMP #$0B
					BEQ DELETE2
					JSL $01802A
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $7FFAE5
					BNE WHEEL_3
					STZ $AA,x
					STZ $B6,x
					LDA $7FFAE4
					SEC
					SBC #$2B
					STA $E4,x
					LDA $7FFAE0
					SBC #$00
					STA $14E0,x
					LDA $7FFAD8
					CLC
					ADC #$66
					STA $D8,x
					LDA $7FFAD4
					ADC #$00
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
WHEEL_R				RTS
WHEEL_3				CMP #$02
					BEQ WHEEL_4
					STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$E0
					BCS WHEEL_R
					CMP #$D0
					BCS WHEEL_5
					CMP #$A4
					BCS WHEEL_6
					CMP #$70
					BCS WHEEL_R
					CMP #$44
					BCS WHEEL_7
					CMP #$34
					BCS WHEEL_8
					CMP #$24
					BCS WHEEL_9
					RTS
WHEEL_5				LDA #$20
					STA $AA,x
					RTS
WHEEL_6				LDA #$C0
					STA $B6,x
					RTS
WHEEL_7				LDA #$40
					STA $B6,x
					RTS
WHEEL_8				LDA #$E0
					STA $AA,x
					RTS
WHEEL_9				LDA #$00
					STA $7FFAE5
					LDA #$11
					STA $1686,x
WHEEL_R2			RTS
WHEEL_4				LDA $15AC,x
					CMP #$60
					BCS WHEEL_A
					CMP #$5F
					BEQ WHEEL_B
					CMP #$30
					BCS WHEEL_C
					CMP #$2F
					BEQ WHEEL_9
					RTS
WHEEL_A				LDA #$EB
					STA $B6,x
					LDA $1588,x
					AND #$04
					BEQ WHEEL_R2
					LDA #$B0
					STA $AA,x
					RTS
WHEEL_B				STZ $B6,x
					LDA #$B5
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$A0
					STA $D8,x
					STZ $14D4,x
					LDA #$91
					STA $1686,x
					RTS
WHEEL_C				LDA #$40
					STA $AA,x
					RTS
DELETE				STZ $14C8,x
					RTS
					
MOUTH				JSR SUB_GFX_M
					LDA $9D
					BNE MOUTH_R
					LDA $7FFAC2
					CMP #$0B
					BEQ DELETE
					LDA $7FFAE6
					BNE MOUTH_1
					STZ $AA,x
					STA $B6,x
					LDA $7FFAE4
					SEC
					SBC #$52
					STA $E4,x
					LDA $7FFAE0
					SBC #$00
					STA $14E0,x
					LDA $7FFAD8
					CLC
					ADC #$3D
					STA $D8,x
					LDA $7FFAD4
					ADC #$00
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
MOUTH_R				RTS
MOUTH_1				LDA $15AC,x
					CMP #$F0
					BCS MOUTH_R
					CMP #$DE
					BCS MOUTH_2
					CMP #$B0
					BEQ MOUTH_3
					CMP #$90
					BCS MOUTH_R
					CMP #$7E
					BCS MOUTH_4
					CMP #$70
					BEQ MOUTH_5
					RTS
MOUTH_2				LDA #$10
					STA $AA,x
					JSL $01801A ;y speed
					RTS
MOUTH_4				LDA #$F0
					STA $AA,x
					JSL $01801A ;y speed
					RTS
MOUTH_5				LDA #$00
					STA $7FFAE6
					RTS
MOUTH_3				JSR GEN_SPRITE
					PHX
					TYX
					LDA #$14
					STA NEW_SPRITE_NUM,x
					PLX
					LDA $7FFAE6
					CMP #$01
					BNE MOUTH_6
					LDA #$06
					STA $1504,y
					LDA #$00
					STA $1570,y
					LDA #$00
					STA $157C,y
					LDA #$01
					STA $167A,y
					LDA #$4C
					STA $190F,y
					LDA #$28
					STA $166E,y
					LDA #$50
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$80
					STA $00E4,y
					LDA #$02
					STA $14E0,y
					LDA #$07
					STA $1DFC
					RTS
MOUTH_6				CMP #$02
					BNE MOUTH_7
					LDA #$0B
					STA $1504,y
					LDA #$87
					STA $1662,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					LDA #$01
					STA $00C2,y
					LDA #$E0
					STA $00B6,y
					LDA #$08
					STA $00AA,y
					RTS
MOUTH_7				LDA #$07
					STA $1504,y
					LDA #$00
					STA $157C,y
					LDA #$03
					STA $167A,y
					LDA #$91
					STA $1686,y
					LDA #$17
					STA $1DFC
					JSL $01ACF9
					AND #$0F
					CMP #$05
					BCC MOUTH_R2
					LDA #$D0
					STA $15AC,x
MOUTH_R2			RTS

MACHINE				JSR SUB_GFX
					LDA $9D
					BNE MACHINE_R
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSR LAYER2
					JSR DAMAGE
					JSR WOOD_CHECK
					LDA $E4,x
					STA $7FFAE4
					LDA $14E0,x
					STA $7FFAE0
					LDA $D8,x
					STA $7FFAD8
					LDA $14D4,x
					STA $7FFAD4
					LDA $C2,x
					STA $7FFAC2
					BNE MACHINE_1
					JSR MACHINE0
MACHINE_R			RTS
MACHINE_1			CMP #$01
					BNE MACHINE_2
					JSR MACHINE1
					RTS
MACHINE_2			CMP #$02
					BNE MACHINE_3
					JSR MACHINE2
					RTS
MACHINE_3			CMP #$03
					BNE MACHINE_4
					JSR MACHINE3
					RTS
MACHINE_4			CMP #$06
					BCS MACHINE_5
					JSR MACHINE4
					RTS
MACHINE_5			CMP #$06
					BNE MACHINE_6
					JSR MACHINE6
					RTS
MACHINE_6			CMP #$0A
					BCS MACHINE_7
					JSR MACHINE7
					RTS
MACHINE_7			CMP #$0A
					BNE MACHINE_8
					JSR MACHINEA
					RTS
MACHINE_8			JSR MACHINEB
					RTS


MACHINE0			LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					LDA $1463
					CMP #$02
					BCC MACHINE0_0
					STZ $1462
					STZ $1411
					LDA $7FFD76
					STA $76
					LDA $7FFDE0
					STA $13E0
					LDA $7FFDDF
					STA $13DF
					LDA #$02
					STA $18BD
					LDA #$F0
					STA $B6,x
					LDA #$1E
					STA $1DFB
					
					LDA $1466
					CMP #$90
					BCC MACHINE0_R
					LDA #$24
					STA $1DFB
					INC $C2,x
					LDA #$80
					STA $15AC,x
					STZ $B6,x
MACHINE0_R			RTS
MACHINE0_0			LDA $76
					STA $7FFD76
					LDA $13E0
					STA $7FFDE0
					LDA $13DF
					STA $7FFDDF
					LDA $15AC,x
					CMP #$02
					BNE MACHINE0_R
					JSR GEN_SPRITE
					LDA #$03
					STA $167A,y
					LDA #$01
					STA $1504,y
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					RTS
MACHINE1_TABLE		dcb $02,$03,$04,$05,$06,$07,$08,$09
MACHINE1_TABLE2		dcb $FF,$FF,$10,$10,$FF,$10,$10,$10

MACHINE1			STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					BNE MACHINE1_R
					LDA $94
					CMP #$80
					BCS MACHINE1_2
					JSL $01ACF9
					AND #$07
					TAY
					LDA MACHINE1_TABLE,y
					STA $C2,x
					LDA MACHINE1_TABLE2,y
					STA $15AC,x
MACHINE1_R			RTS
MACHINE1_2			LDA #$0A
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

MACHINE2			STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$F0
					BCS MACHINE2_R
					CMP #$E8
					BCS MACHINE2_1
					CMP #$D0
					BCS MACHINE2_R
					CMP #$A0
					BCS MACHINE2_2
					CMP #$70
					BCS MACHINE2_3
					CMP #$6F
					BEQ MACHINE2_4
					CMP #$60
					BCS MACHINE2_R
					CMP #$58
					BCS MACHINE2_5
					CMP #$50
					BEQ MACHINE2_6
MACHINE2_R			RTS
MACHINE2_1			LDA #$20
					STA $AA,x
					RTS
MACHINE2_2			LDA #$C8
					STA $B6,x
					RTS
MACHINE2_3			LDA #$38
					STA $B6,x
					RTS
MACHINE2_4			JSL $01ACF9
					AND #$0F
					CMP #$05
					BCC MACHINE2_R
					LDA #$E8
					STA $15AC,x
					RTS
MACHINE2_5			LDA #$E0
					STA $AA,x
					RTS
MACHINE2_6			LDA #$20
					STA $15AC,x
					DEC $C2,x
					RTS
					
MACHINE3			STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$E0
					BCS MACHINE3_1
					CMP #$B0
					BCS MACHINE3_3
					CMP #$A0
					BCS MACHINE3_R
					CMP #$90
					BCS MACHINE3_4
					CMP #$8F
					BEQ MACHINE3_5
					CMP #$70
					BCS MACHINE3_R
					CMP #$60
					BCS MACHINE3_6
					CMP #$50
					BCS MACHINE3_R
					CMP #$20
					BCS MACHINE3_7
					CMP #$10
					BEQ MACHINE3_8
MACHINE3_R			RTS
MACHINE3_1			AND #$02
					BNE MACHINE3_2
					LDA $D8,x
					AND #$F8
					STA $D8,x
					RTS
MACHINE3_2			LDA $D8,x
					ORA #$02
					STA $D8,x
					RTS
MACHINE3_3			LDA #$D0
					STA $B6,x
					RTS
MACHINE3_4			LDA #$58
					STA $AA,x
					RTS
MACHINE3_5			LDA #$10
					STA $1DFC
					LDA #$18
					STA $1887
					RTS
MACHINE3_6			LDA #$A8
					STA $AA,x
					RTS
MACHINE3_7			LDA #$30
					STA $B6,x
					RTS
MACHINE3_8			LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
MACHINE4			LDA $15AC,x
					BEQ MACHINE4_3
					CMP #$01
					BEQ MACHINE4_2
MACHINE4_R			RTS
MACHINE4_2			LDA $C2,x
					SEC
					SBC #$03
					STA $7FFAE5
					RTS
MACHINE4_3			LDA $7FFAE5
					BNE MACHINE4_R
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
Y_FIRE              dcb $18,$18,$0C,$0C,$E8,$E8,$F4,$F4
X_FIRE              dcb $18,$E8,$20,$E0
MACHINE6			LDA $15AC,x
					CMP #$F0
					BEQ MACHINE6_G
					CMP #$D0
					BEQ MACHINE6_G
					CMP #$B0
					BEQ MACHINE6_G
					CMP #$90
					BEQ MACHINE6_G
					CMP #$70
					BEQ MACHINE6_G
					CMP #$50
					BEQ MACHINE6_G
					CMP #$30
					BEQ MACHINE6_2
					RTS
MACHINE6_2			LDA #$20
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
MACHINE6_G			JSR SPIT
					LDA $E4,x
					PHA
					SEC
					SBC #$44
					STA $E4,x
					STA $171F,y
					LDA #$02
					STA $1733,y
					LDA $D8,x
					PHA
					CLC
					ADC #$60
					STA $1715,y
					STA $D8,x
					LDA #$01
					STA $1729,y
					PHY
					JSR SUB_GET_X_DIFF
					JSR SUB_GET_Y_DIFF
					PLY
					PLA
					STA $D8,x
					PLA
					STA $E4,x
					PHX
					LDA $151C,x             ;  |
					ASL A                   ;  |
					ASL A                   ;  |
					ORA $157C,x             ;  |
					TAX                     ;  |
					LDA Y_FIRE,x            ;  |
					STA $173D,y             ;  |
					PLX                     ; /     
					PHX
					LDA $157C,x             ;  |
					TAX                     ;  |
					LDA X_FIRE,x            ;  |
					STA $1747,y             ; /
					PLX 
					RTS
MACHINE7			LDA $15AC,x
					BEQ MACHINE7_3
					CMP #$01
					BEQ MACHINE7_2
MACHINE7_R			RTS
MACHINE7_2			LDA $C2,x
					SEC
					SBC #$06
					STA $7FFAE6
					RTS
MACHINE7_3			LDA $7FFAE6
					BNE MACHINE7_R
					LDA #$01
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
MACHINEA			STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$F0
					BCS MACHINEA_R
					CMP #$E0
					BCS MACHINEA_1
					CMP #$DF
					BEQ MACHINEA_2
					CMP #$C0
					BCS MACHINEA_R
					CMP #$B0
					BCS MACHINEA_3
					CMP #$A0
					BEQ MACHINEA_4
MACHINEA_R			RTS
MACHINEA_1			LDA #$58
					STA $AA,x
					RTS
MACHINEA_2			LDA #$10
					STA $1DFC
					LDA #$18
					STA $1887
					RTS
MACHINEA_3			LDA #$A8
					STA $AA,x
					RTS
MACHINEA_4			LDA #$20
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
MACHINEB			STZ $B6,x
					STZ $AA,x
					LDA #$14
					STA $212C
					LDA #$03
					STA $212D
					REP #$20
					LDA $7FF502
					STA $7FF500
					SEP #$20
					LDA $15AC,x
					CMP #$D0
					BCS MACHINEB_1
					LDA $14
					AND #$01
					BNE MACHINEB_1
					REP #$20
					LDA $7FF502
					CMP #$7FFF
					BEQ MACHINEB_0
					CLC
					ADC #$421
					STA $7FF502
MACHINEB_0			SEP #$20
MACHINEB_1			LDA $15AC,x
					BEQ MACHINEB_2
					AND #$0F
					BEQ MACHINEB_G
MACHINEB_R			RTS
MACHINEB_G			LDA #$18
					STA $1DFC
					JSR GEN_SPRITE
					JSL $01ACF9
					AND #$7F
					STA $02
					JSL $01ACF9
					AND #$3F
					STA $03
					LDA #$05
					STA $1504,y
					LDA $E4,x
					SEC
					SBC #$68
					CLC
					ADC $02
					STA $00E4,y
					LDA $D8,x
					CLC
					ADC $03
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$10
					STA $15AC,y
					RTS
MACHINEB_2			LDA #$22
					STA $1DFB
					STZ $14C8,x
					STZ $1466
					STZ $1467
					LDA #$C0
					STA $1468
					STZ $1469
					JSR GEN_SPRITE
					PHX
					TYX
					LDA #$2E
					STA NEW_SPRITE_NUM,x
					LDA #$78
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$60
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
					PLX
					RTS
					
					
SUB_GET_X_DIFF      LDY #$00
                    LDA $D1
                    SEC
                    SBC $E4,x
                    STA $0F
                    LDA $D2
                    SBC $14E0,x
                    BPL TO_RIGHT
TO_LEFT             INY
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $157C,x
                    RTS
SUB_GET_Y_DIFF      LDY #$00
                    LDA $D3
                    PHA
                    CLC
                    ADC #$10
                    STA $D3
                    LDA $D4
                    PHA
                    ADC #$00
                    STA $D4
                    LDA $D3
                    SEC
                    SBC $D8,x
                    STA $0E
                    LDA $D4
                    SBC $14D4,x
                    BPL LABEL14
                    INY
LABEL14             TYA
                    STA $151C,x 
                    
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    RTS

					
LAYER2				LDA $94
					CMP #$D8
					BCC LAYER2_2
					LDA #$D8
					STA $94
LAYER2_2			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					REP #$20
					LDA.W #$0370
					SEC
					SBC $00
					STA $1466
					LDA.W #$01B8
					SEC
					SBC $02
					STA $1468
					SEP #$20
					RTS
					
DAMAGE_R			RTS
DAMAGE				;JSL $01A7DC
					LDA $C2,x
					CMP #$0B
					BEQ DAMAGE_R
					LDA $E4,x
					PHA
					SEC
					SBC #$30
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					SEC
					SBC #$30
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$20
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
WOOD_CHECK			LDA $E4,x
					SEC
					SBC #$4E
					STA $00
					LDA $14E0,x
					SBC #$00
					STA $01
					LDA $D8,x
					CLC
					ADC #$21
					STA $02
					LDA $14D4,x
					ADC #$00
					STA $03
					STX $04
					PHX
					LDX #$00
WOOD_CHECK_L0		LDA $14C8,x
					BEQ WOOD_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE WOOD_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE WOOD_CHECK_2
					LDA $1504,x
					CMP #$03
					BNE WOOD_CHECK_2
					LDA $1528,x
					CMP #$01
					BNE WOOD_CHECK_2
					LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0024
					BCC WOOD_CHECK_3
					CMP.W #$FFDC
					BCS WOOD_CHECK_3
					SEP #$20
					BRA WOOD_CHECK_2
WOOD_CHECK_L		BRA WOOD_CHECK_L0
WOOD_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0024
					BCC WOOD_CHECK_4
					CMP.W #$FFCC
					BCS WOOD_CHECK_4
					SEP #$20
WOOD_CHECK_2		BRA WOOD_CHECK_20
WOOD_CHECK_4		SEP #$20
					STZ $14C8,x
					PHX
					LDX $04
					INC $1528,x
					LDA $1528,x
					CMP #$0B
					BCS WOOD_CHECK_5
					LDA #$28
					STA $1DFC
WOOD_CHECK_21		PLX
WOOD_CHECK_20		INX
					CPX #$0A
					BCC WOOD_CHECK_L
					PLX
					RTS
WOOD_CHECK_5		PLX
					PLX
					LDA #$1E
					STA $1DFB
					LDA #$0B
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

SPIT                LDY #$E8
                    LDA $157C,x
                    AND #$01
                    BNE LABEL9
                    LDY #$18
LABEL9              STY $00
                    LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     
LABEL7              LDA #$02                ; \ projectile is a fireball
                    STA $170B,y             ; /

                    LDA $E4,x               ; \ set x position
                    STA $171F,y             ;  |
                    LDA $14E0,x             ;  |
                    STA $1733,y             ; /
                    
                    LDA $D8,x               ; \ set y position
                    STA $1715,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $1729,y             ; /
LABEL6              RTS

					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_W			dcb $8A,$8C,$AA,$AC,$AE,$CA,$CC
HORZ_DISP_W			dcb $F4,$04,$F4,$04,$14,$F4,$04
VERT_DISP_W			dcb $E8,$E8,$F8,$F8,$F8,$08,$08

SUB_GFX_W			JSR GET_DRAW_INFO
					LDA #$60
					TAY
					STA $15EA,x
					PHX
					LDX #$06
LOOP_W				LDA $00
					CLC
					ADC HORZ_DISP_W,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP_W,x
					STA $0201,y
					LDA TILEMAP_W,x
					STA $0202,y
					LDA #$03
					ORA $64
					STA $0203,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_W
					PLX
                    LDY #$02
                    LDA #$06
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS

TILEMAP_W2			dcb $E0,$E2,$E4,$E6,$E8,$EA,$EC,$EE
HORZ_DISP_W2		dcb $F4,$04,$14,$F4,$04,$14,$F4,$04
					dcb $08,$F8,$E8,$08,$F8,$E8,$08,$F8
VERT_DISP_W2		dcb $EC,$EC,$EC,$FC,$FC,$FC,$0C,$0C

SUB_GFX_W2			JSR GET_DRAW_INFO
					LDA #$60
					TAY
					STA $15EA,x
					STZ $02
					LDA #$03
					STA $03
					LDA $14
					AND #$02
					BNE SUB_GFX_W2_1
					LDA #$43
					STA $03
					LDA #$08
					STA $02
SUB_GFX_W2_1		PHX
					LDX #$07
LOOP_W2				PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP_W2,x
					STA $0200,y
					PLX
					LDA $01
					CLC
					ADC VERT_DISP_W2,x
					STA $0201,y
					LDA TILEMAP_W2,x
					STA $0202,y
					LDA $03
					ORA $64
					STA $0203,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_W2
					PLX
                    LDY #$02
                    LDA #$07
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS

TILEMAP_M			dcb $82,$84,$A0,$A2,$A4,$C0,$C2,$C4
HORZ_DISP_M			dcb $00,$10,$F0,$00,$10,$F0,$00,$10
VERT_DISP_M			dcb $F0,$F0,$00,$00,$00,$10,$10,$10

SUB_GFX_M			JSR GET_DRAW_INFO
					LDA #$C0
					TAY
					STA $15EA,x
					PHX
					LDX #$07
LOOP_M				LDA $00
					CLC
					ADC HORZ_DISP_M,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP_M,x
					STA $0201,y
					LDA TILEMAP_M,x
					STA $0202,y
					LDA #$03
					STA $0203,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_M
					PLX
                    LDY #$02
                    LDA #$07
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS
					
					
SUB_GFX_B			JSR GET_DRAW_INFO
					LDA #$2A
					STA $0F
					LDA $15AC,x
					CMP #$08
					BCS SUB_GFX_B2
					LDA #$2C
					STA $0F
SUB_GFX_B2			LDA $00
                    STA $0300,y
                    LDA $01
                    STA $0301,y
                    LDA $0F
                    STA $0302,y
                    LDA #$0D
                    ORA $64
                    STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS


TILEMAP             dcb $86,$A6,$A8,$A6,$A8,$86,$88,$8E,$CE
					dcb $C6,$C6,$C6,$C6,$C6,$C6,$C6,$8E,$CE
HORZ_DISP			dcb $00,$00,$10,$00,$10,$00,$20,$B2,$B2
VERT_DISP			dcb $08,$18,$18,$27,$27,$37,$17,$19,$29
PROPETIES			dcb $03,$03,$03,$83,$83,$83,$03,$07,$07

SUB_GFX_R			RTS
SUB_GFX             LDA $C2,x
					CMP #$0B
					BEQ SUB_GFX_R
					JSR GET_DRAW_INFO
					STZ $03
					LDA $14
					AND #$02
					BEQ SUB_GFX_2
					LDA #$09
					STA $03
SUB_GFX_2			LDA #$30
					TAY
					STA $15EA,x
					PHX
					LDX #$08
LOOP_START          PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x
					STA $0202,y
					PLX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0201,y
					LDA PROPETIES,x
					STA $0203,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$08
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        STZ $157C,x                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0E                 
                    LDA $95                
                    SBC $14E0,x             
                    BCC LABEL16             
                    INC $157C,x
LABEL16             RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return


