DOWN_GEN            LDA $16
					AND #$08
					BEQ RETURN67
					
					LDA $98
					PHA
					SEC
					SBC #$10
					STA $98
					LDA $99
					PHA
					SBC #$00
					STA $99
					
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP
					
					PLA
					STA $99
					PLA
					STA $98
					
					PHP
                    REP #$30                ; \ change sprite to block 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    PLP                     ; / 
					
					LDA #$2A
					STA $1DFC
					PHY
                    JSR NORMAL_GEN
					PLY
RETURN67            RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS
NORMAL_GEN          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					
					LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$85
                    STA $009E,y
					
					LDA #$29
					PHX
                    TYX
                    STA $7FAB9E,x
                    PLX
                    
                    LDA $9A
                    STA $00E4,y

                    LDA $9B
                    STA $14E0,y             ; /

                    LDA $98
                    STA $00D8,y             ;  |
                    LDA $99
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA $7FAB10,x
					LDA #$07
					STA $1504,x
                    PLX
                    RTS                          ; return
