;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WFmTChn[g
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$78
					STA $E4,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR GENOCIDE
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR BEAM
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR EFFECT
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR FLAME
					RTS
MAIN4				JSR FINISH
					RTS


GENOCIDE_R			RTS
GENOCIDE			JSR SUB_GFX
					LDA $9D
					BNE GENOCIDE_R
					JSR MARIO_CHECK
					LDA $C2,x
					BNE GENOCIDE_2
					JSR GENOCIDE1
					RTS
GENOCIDE_2			CMP #$01
					BNE GENOCIDE_3
					JSR GENOCIDE2
					RTS
GENOCIDE_3			CMP #$02
					BNE GENOCIDE_4
					JSR GENOCIDE3
					RTS
GENOCIDE_4			CMP #$03
					BNE GENOCIDE_5
					JSR GENOCIDE4
					RTS
GENOCIDE_5			CMP #$04
					BNE GENOCIDE_6
					JSR GENOCIDE5
					RTS
GENOCIDE_6			CMP #$05
					BNE GENOCIDE_7
					JSR GENOCIDE6
					RTS
GENOCIDE_7			CMP #$06
					BNE GENOCIDE_8
					JSR GENOCIDE7
					RTS
GENOCIDE_8			CMP #$07
					BNE GENOCIDE_9
					JSR GENOCIDE8
					RTS
GENOCIDE_9			CMP #$08
					BNE GENOCIDE_A
					JSR GENOCIDE9
					RTS
GENOCIDE_A			CMP #$09
					BNE GENOCIDE_B
					JSR GENOCIDEA
					RTS
GENOCIDE_B			CMP #$0A
					BNE GENOCIDE_C
					JSR GENOCIDEB
					RTS
GENOCIDE_C			CMP #$0B
					BNE GENOCIDE_D
					JSR GENOCIDEC
					RTS
GENOCIDE_D			CMP #$0C
					BNE GENOCIDE_E
					JSR GENOCIDED
					RTS
GENOCIDE_E			CMP #$0D
					BNE GENOCIDE_F
					JSR GENOCIDEE
					RTS
GENOCIDE_F			CMP #$0E
					BNE GENOCIDE_10
					JSR GENOCIDEF
					RTS
GENOCIDE_10			CMP #$0F
					BNE GENOCIDE_11
					JSR GENOCIDE10
					RTS
GENOCIDE_11			CMP #$10
					BNE GENOCIDE_12
					JSR GENOCIDE11
					RTS
GENOCIDE_12			CMP #$11
					BNE GENOCIDE_13
					JSR GENOCIDE12
					RTS
GENOCIDE_13			CMP #$12
					BNE GENOCIDE_14
					JSR GENOCIDE13
					RTS
GENOCIDE_14			CMP #$13
					BNE GENOCIDE_15
					JSR GENOCIDE14
					RTS
GENOCIDE_15			RTS
					
					
EFFECT				JSR SUB_GFX_EF
					LDA $9D
					BNE EFFECT_R
					LDA $7FE3F0
					BEQ EFFECT_D
					LDA $15AC,x
					BEQ EFFECT_D
EFFECT_R			RTS
EFFECT_D			STZ $14C8,x
					RTS
					
FLAME				JSR SUB_GFX_FL
					LDA $9D
					BNE FLAME_R
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA $15AC,x
					CMP #$C0
					BCS FLAME_R
					CMP #$BF
					BEQ FLAME_2
					JSL $01802A
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $D8,x
					SEC
					SBC #$40
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
FLAME_R				RTS
FLAME_2				LDA #$C0
					STA $AA,x
					LDA #$17
					STA $1DFC
					RTS
					
FINISH				JSR SUB_GFX_FINISH
					LDA $9D
					BNE FINISH_R
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ FINISH_R
					STZ $B6,x
					LDA $15AC,x
					BEQ FINISH_R
					CMP #$01
					BEQ FINISH_2
					CMP #$A0
					BCS FINISH_R
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					INC A
					STA $1602,x
FINISH_R			RTS
FINISH_2			LDA $1EF3
					AND #$BF
					STA $1EF3 ;#ԃtO폜
					LDA $1F39 ;#hSRCtO폜
					AND #$BF
					STA $1F39
					LDA $1F34
					AND #$CF
					STA $1F34
					LDA #$01
					STA $13CE ;#NAtO
					LDA #$01
					STA $0DD5
					INC $1DE9
					LDA #$0B
					STA $0100
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GENOCIDE1			LDA $15AC,x
					BEQ GENOCIDE1_4
					CMP #$FD
					BEQ GENOCIDE1_1
					CMP #$C0
					BEQ GENOCIDE1_2
					CMP #$BC
					BEQ GENOCIDE1_3
					CMP #$B8
					BEQ GENOCIDE1_3
					CMP #$91
					BCS GENOCIDE1_R
					AND #$0F
					BEQ GENOCIDE1_9
					RTS
GENOCIDE1_1			JSR SUB_GENOCIDE1
					JSR HDMA_LAYER
					RTS
GENOCIDE1_2			LDA #$17
					STA $1DFC
GENOCIDE1_3			INC $1602,x
					STZ $1570,x
GENOCIDE1_R			RTS
GENOCIDE1_4			LDA $7FE502
					CMP #$01
					BEQ GENOCIDE1_5
					CMP #$02
					BEQ GENOCIDE1_7
GENOCIDE1_8			REP #$20
					LDA $7FE501
					CLC
					ADC.W #$0008
					STA $7FE501
					SEP #$20
					RTS
GENOCIDE1_5			LDA $1540,x
					BEQ GENOCIDE1_6
					CMP #$E0
					BCS GENOCIDE1_R
					BRA GENOCIDE1_8
GENOCIDE1_6			LDA #$FF
					STA $1540,x
					RTS
GENOCIDE1_7			LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FE501
					STA $7FE502
					INC $C2,x
					STZ $1540,x
					RTS
GENOCIDE1_9			JSR SUB_TV1
					RTS
					
					
GENOCIDE2			LDA $15AC,x
					BEQ GENOCIDE2_2
					CMP #$F0
					BCS GENOCIDE2_R
					AND #$0F
					BNE GENOCIDE2_R
					BEQ GENOCIDE2_G
GENOCIDE2_R			RTS
GENOCIDE2_2			LDA #$FF
					STA $15AC,x
					INC $C2,x
					STZ $1570,x
					RTS
					
GENOCIDE2_G_TBL1	dcb $DC,$E4,$E4,$E4,$E4,$DA,$DA,$E2,$E2
GENOCIDE2_G_TBL2	dcb $A0,$B0,$B0,$C0,$C0,$C0,$C0,$D8,$D8
GENOCIDE2_G_TBL3	dcb $00,$D8,$28,$C0,$40,$C0,$40,$B0,$50
GENOCIDE2_G_TBL4	dcb $00,$02,$04,$06,$08,$06,$08,$0A,$0C

GENOCIDE2_G			JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					STA $167A,y
					PHX
					JSL $01ACF9
					AND #$07
					BEQ GENOCIDE2_G_2
					JSL $01ACF9
					AND #$07
					INC A
GENOCIDE2_G_2		TAX ;#^񒆁A㏬AE㏬A㒆AE㒆AAEAAE
					LDA GENOCIDE2_G_TBL1,x
					STA $15AC,y
					LDA GENOCIDE2_G_TBL2,x
					STA $00AA,y
					LDA GENOCIDE2_G_TBL3,x
					STA $00B6,y
					LDA GENOCIDE2_G_TBL4,x
					STA $1602,y
					STX $C2,y
					PLX
					RTS
					
GENOCIDE3			STZ $AA,x
					LDA $15AC,x
					BEQ GENOCIDE3_4
					CMP #$E0
					BCS GENOCIDE3_R
					CMP #$50
					BCS GENOCIDE3_2
					CMP #$30
					BCS GENOCIDE3_R
					CMP #$10
					BCS GENOCIDE3_3
GENOCIDE3_R			RTS
GENOCIDE3_2			AND #$0F
					BNE GENOCIDE3_R
					JSR SUB_TV2
					RTS
GENOCIDE3_3			LDA #$E0
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDE3_4			LDA #$01
					STA $7FE402
					JSR LAYER2_RESET
					JSR GFX_LOAD1
					JSR KEISEN_MAP
					LDA #$FF
					STA $15AC,x
					INC $C2,x
HDMA_RESET			PHX
					REP #$10
					LDX.W #$0000
GENOCIDE3_5			LDA #$01
					STA $7FE500,x
					LDA #$00
					STA $7FE501,x
					STA $7FE502,x
					INX
					INX
					INX
					CPX.W #$02A0
					BCC GENOCIDE3_5
					LDA #$00
					STA $7FE500,x
					SEP #$10
					PLX
					LDA #$00
					STA $7FE800
					LDA #$14
					STA $212C
					LDA #$03
					STA $212D
					RTS
					
GENOCIDE4			LDA $15AC,x
					CMP #$80
					BCS GENOCIDE4_5
					CMP #$7F
					BEQ GENOCIDE4_6
					RTS
GENOCIDE4_5			JSR SUB_GENOCIDE4
					RTS
GENOCIDE4_6			INC $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $1602,x
					REP #$20
					LDA.W #$7FFF
					STA $7FF500
					SEP #$20
					JSR LAYER2_RESET
					JSR GFX_LOAD2
					JSR HDMA_RESET
					JSR WATER_LOAD
					STZ $151C,x
					STZ $1528,x
					RTS
					

GENOCIDE5			JSR WOOD_CHECK
					STZ $85
					REP #$20
					LDA $96
					CMP.W #$0110
					SEP #$20
					BCC GENOCIDE5_1
					INC $85
GENOCIDE5_1			LDA $15AC,x
					BNE GENOCIDE5_3
					LDA #$FF
					STA $15AC,x
					RTS
GENOCIDE5_3			CMP #$C0
					BEQ GENOCIDE5_5
					CMP #$80
					BEQ GENOCIDE5_2
					CMP #$7A
					BEQ GENOCIDE5_4
GENOCIDE5_R			RTS
GENOCIDE5_4			STZ $1602,x
					RTS
GENOCIDE5_2			LDA $1528,x
					CMP #$03
					BEQ GENOCIDE5_6
					JSR SUB_GENOCIDE5
					RTS
GENOCIDE5_5			LDA $1528,x
					CMP #$03
					BEQ GENOCIDE5_R
					JSR GEN_SPRITE
					PHX
					TYX
					LDA #$0F
					STA NEW_SPRITE_NUM,x
					JSL $01ACF9
					LSR A
					CLC
					ADC #$C0
					STA $D8,x
					LDA #$00
					ADC #$00
					STA $14D4,x
					JSL $01ACF9
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $187B,x
					LDA #$10
					STA $1504,x
					LDA #$F0
					STA $15AC,x
					PLX
					RTS
GENOCIDE5_6			LDA #$78
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					LDA #$01
					STA $1602,x
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $7FE3F0
					STZ $1540,x
					STZ $151C,x
					STZ $157C,x
					STZ $1528,x
					STZ $85
					LDY #$00
					JSR WILY_PALETE
					RTS
					
GENOCIDE6			LDA $15AC,x
					CMP #$FB
					BEQ GENOCIDE6_1
					CMP #$F7
					BEQ GENOCIDE6_1
					CMP #$E0
					BEQ GENOCIDE6_2
					CMP #$E0
					BCS GENOCIDE6_R
					CMP #$60
					BCS GENOCIDE6_3
					CMP #$5F
					BEQ GENOCIDE6_4
					CMP #$5E
					BEQ GENOCIDE6_5
					CMP #$40
					BCS GENOCIDE6_R
					CMP #$20
					BCS GENOCIDE6_6
					CMP #$01
					BEQ GENOCIDE6_7
GENOCIDE6_R			RTS
GENOCIDE6_1			INC $1602,x
					RTS
GENOCIDE6_2			STZ $40
					LDA #$00
					STA $0701
					STA $0702
					JSR GFX_LOAD1
					JSR LAYER2_RESET
					JSR KEISEN_MAP
					RTS
GENOCIDE6_3			LDA #$20
					STA $40
					JSR SUB_GENOCIDE4
					RTS
GENOCIDE6_4			JSR LAYER2_RESET
					JSR HDMA_RESET
					JSR SUB_GFX0
					JSR MAIN_PALETE
					JSR FUTURE_MAP
					LDA #$00
					STA $7FE503
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					RTS
GENOCIDE6_5			LDA #$00
					STA $7FE402
					RTS
GENOCIDE6_6			LDA #$20
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDE6_7			LDA #$FF
					STA $15AC,x
					INC $C2,x
					RTS
					
GENOCIDE7_TBL		dcb $06,$03,$08,$02,$07,$00
GENOCIDE7_4			LDA $7FE502
					CMP #$01
					BEQ GENOCIDE7_5
					CMP #$02
					BEQ GENOCIDE7_7
GENOCIDE7_8			REP #$20
					LDA $7FE501
					CLC
					ADC.W #$0008
					STA $7FE501
					SEP #$20
					RTS
GENOCIDE7_5			LDA $1540,x
					BEQ GENOCIDE7_6
					CMP #$E0
					BCS GENOCIDE7_R
					BRA GENOCIDE7_8
GENOCIDE7_6			LDA #$FF
					STA $1540,x
					RTS
GENOCIDE7_7			LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FE501
					STA $7FE502
					INC $C2,x
					STZ $1540,x
					RTS
GENOCIDE7			LDA $15AC,x
					BEQ GENOCIDE7_4
					CMP #$F0
					BEQ GENOCIDE7_1
					CMP #$EC
					BEQ GENOCIDE7_2
					CMP #$B1
					BCS GENOCIDE7_R
					CMP #$60
					BCS GENOCIDE7_0
					RTS
GENOCIDE7_0			AND #$0F
					BEQ GENOCIDE7_3
GENOCIDE7_R			RTS
GENOCIDE7_1			LDA #$00
					STA $00
					TAY
					LDA #$0C
					STA $01
					JSR SUB_BEAM1_2
					LDA #$2C
					STA $00
					TAY
					LDA #$40
					STA $01
					JSR SUB_BEAM1_2
					LDA #$58
					STA $00
					TAY
					LDA #$6C
					STA $01
					JSR SUB_BEAM1_2
					RTS
GENOCIDE7_2			LDA #$00
					STA $00
					TAY
					LDA #$0C
					STA $01
					JSR SUB_BEAM3_2
					LDA #$2C
					STA $00
					TAY
					LDA #$40
					STA $01
					JSR SUB_BEAM3_2
					LDA #$58
					STA $00
					TAY
					LDA #$6C
					STA $01
					JSR SUB_BEAM3_2
					STZ $1570,x
					LDA #$01
					STA $7FDF01
					STA $7FDF04
					STA $7FDF05
					RTS
GENOCIDE7_3			LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA GENOCIDE7_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
					JSR SUB_TV1_2
					RTS
					
GENOCIDE8			LDA $15AC,x
					BEQ GENOCIDE8_2
					CMP #$F0
					BCS GENOCIDE8_R
					AND #$0F
					BNE GENOCIDE8_R
					BEQ GENOCIDE8_G
GENOCIDE8_R			RTS
GENOCIDE8_2			LDA #$FF
					STA $15AC,x
					INC $C2,x
					STZ $1570,x
					RTS
GENOCIDE8_G			JSR GENOCIDE2_G
					RTS
GENOCIDE9			LDA $15AC,x
					BEQ GENOCIDE9_4
					CMP #$C0
					BEQ GENOCIDE9_5
					CMP #$B0
					BCS GENOCIDE9_R
					CMP #$50
					BCS GENOCIDE9_2
					CMP #$30
					BCS GENOCIDE9_R
					CMP #$10
					BCS GENOCIDE9_3
GENOCIDE9_R			RTS
GENOCIDE9_2			AND #$0F
					BNE GENOCIDE9_R
					JSR SUB_TV3
					RTS
GENOCIDE9_3			LDA #$E0
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDE9_4			LDA #$01
					STA $7FE402
					STZ $1570,x
					JSR LAYER2_RESET
					JSR GFX_LOAD1
					JSR KEISEN_MAP
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					JSR HDMA_RESET
					RTS
GENOCIDE9_5			JSR SUB_LAVA_WINDOW
					RTS

GENOCIDEA			LDA $15AC,x
					CMP #$80
					BCS GENOCIDEA_5
					CMP #$7F
					BEQ GENOCIDEA_6
					RTS
GENOCIDEA_5			JSR SUB_GENOCIDE4
					RTS
GENOCIDEA_6			INC $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $1602,x
					REP #$20
					LDA.W #$7FFF
					STA $7FF500
					SEP #$20
					JSR LAYER2_RESET
					JSR GFX_LOAD3
					JSR HDMA_RESET
					JSR LAVA_LOAD
					STZ $151C,x
					STZ $1528,x
					RTS
					
GENOCIDEB			JSR WOOD_CHECK
					JSR SUB_GENOCIDEB
					LDA $15AC,x
					BNE GENOCIDEB_3
					LDA #$FF
					STA $15AC,x
					RTS
GENOCIDEB_3			CMP #$C0
					BEQ GENOCIDEB_5
					CMP #$80
					BEQ GENOCIDEB_2
					CMP #$7A
					BEQ GENOCIDEB_4
GENOCIDEB_R			RTS
GENOCIDEB_4			STZ $1602,x
					RTS
GENOCIDEB_2			LDA $1528,x
					CMP #$03
					BEQ GENOCIDEB_6
					JSR SUB_GENOCIDE5
					RTS
GENOCIDEB_5			LDA $1528,x
					CMP #$03
					BEQ GENOCIDEB_R
					JSR GEN_SPRITE
					PHX
					TYX
					LDA #$0F
					STA NEW_SPRITE_NUM,x
					JSL $01ACF9
					LSR A
					CLC
					ADC #$C0
					STA $D8,x
					LDA #$00
					ADC #$00
					STA $14D4,x
					JSL $01ACF9
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $187B,x
					LDA #$10
					STA $1504,x
					LDA #$F0
					STA $15AC,x
					PLX
					RTS
GENOCIDEB_6			LDA #$78
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					LDA #$01
					STA $1602,x
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $7FE3F0
					STZ $1540,x
					STZ $151C,x
					STZ $157C,x
					STZ $1528,x
					STZ $85
					LDY #$00
					JSR WILY_PALETE
					RTS
SUB_GENOCIDEB		LDA $1528,x
					CMP #$03
					BCS SUB_GENOCIDEB_R
					LDA $15AC,x
					AND #$3F
					CMP #$0C
					BNE SUB_GENOCIDEB_R
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					JSL $01ACF9
					STA $00E4,y
					LDA #$02
					STA $14E0,y
					LDA #$90
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$FF
					STA $15AC,y
					LDA #$91
					STA $1686,y
SUB_GENOCIDEB_R		RTS
					
GENOCIDEC			LDA $15AC,x
					CMP #$FB
					BEQ GENOCIDEC_1
					CMP #$F7
					BEQ GENOCIDEC_1
					CMP #$E0
					BEQ GENOCIDEC_2
					CMP #$E0
					BCS GENOCIDEC_R
					CMP #$60
					BCS GENOCIDEC_3
					CMP #$5F
					BEQ GENOCIDEC_4
					CMP #$5E
					BEQ GENOCIDEC_5
					CMP #$40
					BCS GENOCIDEC_R
					CMP #$20
					BCS GENOCIDEC_6
					CMP #$01
					BEQ GENOCIDEC_7
GENOCIDEC_R			RTS
GENOCIDEC_1			INC $1602,x
					RTS
GENOCIDEC_2			STZ $40
					JSR GFX_LOAD1
					JSR LAYER2_RESET
					JSR KEISEN_MAP
					RTS
GENOCIDEC_3			LDA #$20
					STA $40
					JSR SUB_GENOCIDE4
					RTS
GENOCIDEC_4			JSR LAYER2_RESET
					JSR HDMA_RESET
					JSR SUB_GFX0
					JSR MAIN_PALETE
					JSR FUTURE_MAP
					JSR SUB_LAVA_WINDOW
					LDA #$00
					STA $7FE503
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					RTS
GENOCIDEC_5			LDA #$00
					STA $7FE402
					RTS
GENOCIDEC_6			LDA #$20
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDEC_7			LDA #$FF
					STA $15AC,x
					INC $C2,x
					RTS
					
GENOCIDED_TBL		dcb $03,$08,$00
GENOCIDED_4			LDA $7FE502
					CMP #$01
					BEQ GENOCIDED_5
					CMP #$02
					BEQ GENOCIDED_7
GENOCIDED_8			REP #$20
					LDA $7FE501
					CLC
					ADC.W #$0008
					STA $7FE501
					SEP #$20
					RTS
GENOCIDED_5			LDA $1540,x
					BEQ GENOCIDED_6
					CMP #$E0
					BCS GENOCIDED_R
					BRA GENOCIDED_8
GENOCIDED_6			LDA #$FF
					STA $1540,x
					RTS
GENOCIDED_7			LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FE501
					STA $7FE502
					INC $C2,x
					STZ $1540,x
					RTS
GENOCIDED			LDA $15AC,x
					BEQ GENOCIDED_4
					CMP #$F0
					BEQ GENOCIDED_1
					CMP #$EC
					BEQ GENOCIDED_2
					CMP #$B1
					BCS GENOCIDED_R
					CMP #$90
					BCS GENOCIDED_0
					RTS
GENOCIDED_0			AND #$0F
					BEQ GENOCIDED_3
GENOCIDED_R			RTS
GENOCIDED_1			LDA #$0C
					STA $00
					TAY
					LDA #$18
					STA $01
					JSR SUB_BEAM1_2
					LDA #$6C
					STA $00
					TAY
					LDA #$80
					STA $01
					JSR SUB_BEAM1_2
					LDA #$40
					STA $00
					TAY
					LDA #$4C
					STA $01
					JSR SUB_BEAM1_2
					RTS
GENOCIDED_2			LDA #$0C
					STA $00
					TAY
					LDA #$18
					STA $01
					JSR SUB_BEAM3_2
					LDA #$6C
					STA $00
					TAY
					LDA #$80
					STA $01
					JSR SUB_BEAM3_2
					LDA #$40
					STA $00
					TAY
					LDA #$4C
					STA $01
					JSR SUB_BEAM3_2
					STZ $1570,x
					LDA #$01
					STA $7FDF02
					STA $7FDF06
					STA $7FDF07
					RTS
GENOCIDED_3			LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA GENOCIDED_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
					JSR SUB_TV1_2
					RTS
					
GENOCIDEE			LDA $15AC,x
					BEQ GENOCIDEE_2
					CMP #$F0
					BCS GENOCIDEE_R
					AND #$0F
					BNE GENOCIDEE_R
					BEQ GENOCIDEE_G
GENOCIDEE_R			RTS
GENOCIDEE_2			LDA #$FF
					STA $15AC,x
					INC $C2,x
					STZ $1570,x
					RTS
GENOCIDEE_G			JSR GENOCIDE2_G
					RTS
GENOCIDEF			LDA $15AC,x
					BEQ GENOCIDEF_4
					CMP #$C0
					BEQ GENOCIDEF_5
					CMP #$B0
					BCS GENOCIDEF_R
					CMP #$80
					BCS GENOCIDEF_2
					CMP #$30
					BCS GENOCIDEF_R
					CMP #$10
					BCS GENOCIDEF_3
GENOCIDEF_R			RTS
GENOCIDEF_2			AND #$0F
					BNE GENOCIDEF_R
					JSR SUB_TV4
					RTS
GENOCIDEF_3			LDA #$E0
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDEF_4			LDA #$01
					STA $7FE402
					STZ $1570,x
					JSR LAYER2_RESET
					JSR GFX_LOAD1
					JSR KEISEN_MAP
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					JSR HDMA_RESET
					RTS
GENOCIDEF_5			JSR SUB_SNOW_WINDOW
					RTS
					
GENOCIDE10			LDA $15AC,x
					CMP #$80
					BCS GENOCIDE10_5
					CMP #$7F
					BEQ GENOCIDE10_6
					RTS
GENOCIDE10_5		JSR SUB_GENOCIDE4
					RTS
GENOCIDE10_6		INC $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $1602,x
					REP #$20
					LDA.W #$7FFF
					STA $7FF500
					SEP #$20
					JSR LAYER2_RESET
					JSR GFX_LOAD4
					JSR HDMA_RESET
					JSR SNOW_LOAD
					STZ $151C,x
					STZ $1528,x
					RTS
					
GENOCIDE11			JSR WOOD_CHECK
					JSR SUB_GENOCIDE11
					LDA $15AC,x
					BNE GENOCIDE11_3
					LDA #$FF
					STA $15AC,x
					RTS
GENOCIDE11_3		CMP #$C0
					BEQ GENOCIDE11_5
					CMP #$80
					BEQ GENOCIDE11_2
					CMP #$7A
					BEQ GENOCIDE11_4
GENOCIDE11_R		RTS
GENOCIDE11_4		STZ $1602,x
					RTS
GENOCIDE11_2		LDA $1528,x
					CMP #$03
					BEQ GENOCIDE11_6
					JSR SUB_GENOCIDE5
					RTS
GENOCIDE11_5		LDA $1528,x
					CMP #$03
					BEQ GENOCIDE11_R
					JSR GEN_SPRITE
					PHX
					TYX
					LDA #$0F
					STA NEW_SPRITE_NUM,x
					JSL $01ACF9
					LSR A
					CLC
					ADC #$C0
					STA $D8,x
					LDA #$00
					ADC #$00
					STA $14D4,x
					JSL $01ACF9
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $187B,x
					LDA #$10
					STA $1504,x
					LDA #$F0
					STA $15AC,x
					PLX
					RTS
GENOCIDE11_6		LDA #$78
					STA $E4,x
					LDA #$02
					STA $14E0,x
					LDA #$20
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$FF
					STA $15AC,x
					INC $C2,x
					LDA #$01
					STA $1602,x
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $7FE3F0
					STZ $1540,x
					STZ $151C,x
					STZ $157C,x
					STZ $1528,x
					STZ $85
					LDY #$00
					JSR WILY_PALETE
					RTS
SUB_GENOCIDE11		LDA $1528,x
					CMP #$03
					BCS SUB_GENOCIDE11_R
					LDA $15AC,x
					AND #$0F
					CMP #$0C
					BNE SUB_GENOCIDE11_R
					JSR SNOW_FALL
SUB_GENOCIDE11_R	RTS
SNOW_FALL			LDY #$07
LABEL8              LDA $170B,y
                    BEQ LABEL7
                    DEY
                    BPL LABEL8
                    RTS                     
LABEL7              LDA #$0C                ; \ projectile is a fireball
                    STA $170B,y             ; /

                    JSL $01ACF9
                    STA $171F,y             ;  |
                    LDA #$02
                    STA $1733,y             ; /
                    
                    LDA #$C0
                    STA $1715,y             ;  |
                    LDA #$00
                    STA $1729,y             ; /
LABEL6              RTS

GENOCIDE12			LDA $15AC,x
					CMP #$FB
					BEQ GENOCIDE12_1
					CMP #$F7
					BEQ GENOCIDE12_1
					CMP #$E0
					BEQ GENOCIDE12_2
					CMP #$E0
					BCS GENOCIDE12_R
					CMP #$60
					BCS GENOCIDE12_3
					CMP #$5F
					BEQ GENOCIDE12_4
					CMP #$5E
					BEQ GENOCIDE12_5
					CMP #$40
					BCS GENOCIDE12_R
					CMP #$20
					BCS GENOCIDE12_6
					CMP #$01
					BEQ GENOCIDE12_7
GENOCIDE12_R		RTS
GENOCIDE12_1		INC $1602,x
					RTS
GENOCIDE12_2		STZ $40
					JSR GFX_LOAD1
					JSR LAYER2_RESET
					JSR KEISEN_MAP
					RTS
GENOCIDE12_3		LDA #$20
					STA $40
					JSR SUB_GENOCIDE4
					RTS
GENOCIDE12_4		JSR LAYER2_RESET
					JSR HDMA_RESET
					JSR SUB_GFX0
					JSR MAIN_PALETE
					JSR FUTURE_MAP
					JSR SUB_SNOW_WINDOW
					LDA #$00
					STA $7FE503
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					RTS
GENOCIDE12_5		LDA #$00
					STA $7FE402
					RTS
GENOCIDE12_6		LDA #$20
					STA $AA,x
					JSL $01801A
					RTS
GENOCIDE12_7		LDA #$FF
					STA $15AC,x
					INC $C2,x
					RTS
					

GENOCIDE13_F		LDA #$1E
					STA $1DFB
					LDA #$00
					STA $7FE501
					STA $7FE502
					JSR TIUN
					LDA #$04
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					JSR GFX_LOAD5
					JSR FINISH_PALETE
					STZ $1602,x
					LDA #$C0
					STA $AA,x
					LDA #$10
					STA $B6,x
					LDA #$01
					STA $7FDF12
					RTS
GENOCIDE13			LDA $1528,x
					BNE GENOCIDE13_F
					LDA $15AC,x
					CMP #$EC
					BCS GENOCIDE13_0
					JSR WOOD_CHECK
GENOCIDE13_0		LDA $15AC,x
					BEQ GENOCIDE13_4
					CMP #$F0
					BEQ GENOCIDE13_1
					CMP #$EC
					BEQ GENOCIDE13_2
					RTS
GENOCIDE13_1		LDA #$18
					STA $00
					TAY
					LDA #$2C
					STA $01
					JSR SUB_BEAM1_2
					LDA #$4C
					STA $00
					TAY
					LDA #$58
					STA $01
					JSR SUB_BEAM1_2
					LDA #$80
					STA $00
					TAY
					LDA #$B0
					STA $01
					JSR SUB_BEAM1_2
					RTS
GENOCIDE13_2		LDA #$18
					STA $00
					TAY
					LDA #$2C
					STA $01
					JSR SUB_BEAM3_2
					LDA #$4C
					STA $00
					TAY
					LDA #$58
					STA $01
					JSR SUB_BEAM3_2
					LDA #$80
					STA $00
					TAY
					LDA #$B0
					STA $01
					JSR SUB_BEAM3_2
					STZ $1570,x
					LDA #$01
					STA $7FDF03
					STA $7FDF08
					STA $7FDF00
GENOCIDE13_R		RTS
GENOCIDE13_4		LDA $7FE502
					CMP #$01
					BEQ GENOCIDE13_5
					CMP #$02
					BEQ GENOCIDE13_7
GENOCIDE13_8		REP #$20
					LDA $7FE501
					CLC
					ADC.W #$0008
					STA $7FE501
					SEP #$20
					RTS
GENOCIDE13_5		LDA $1540,x
					BEQ GENOCIDE13_6
					CMP #$E0
					BCS GENOCIDE13_R
					BRA GENOCIDE13_8
GENOCIDE13_6		LDA #$FF
					STA $1540,x
					RTS
GENOCIDE13_7		LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FE501
					STA $7FE502
					INC $C2,x
					STZ $1540,x
					RTS
					
GENOCIDE14_F		LDA #$1E
					STA $1DFB
					LDA #$00
					STA $7FE501
					STA $7FE502
					JSR TIUN
					LDA #$04
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					JSR GFX_LOAD5
					JSR FINISH_PALETE
					STZ $1602,x
					LDA #$C0
					STA $AA,x
					LDA #$10
					STA $B6,x
					LDA #$01
					STA $7FDF12
					RTS
GENOCIDE14			LDA $1528,x
					BNE GENOCIDE14_F
					JSR WOOD_CHECK
					LDA $15AC,x
					BEQ GENOCIDE14_2
					CMP #$F0
					BCS GENOCIDE14_R
					AND #$0F
					BNE GENOCIDE14_R
					BEQ GENOCIDE14_G
GENOCIDE14_R		RTS
GENOCIDE14_2		LDA #$E0
					STA $15AC,x
					DEC $C2,x
					STZ $1570,x
					RTS
GENOCIDE14_G		JSR GENOCIDE2_G
					RTS
					
SUB_GENOCIDE4		LDA $7FE800
					INC A
					INC A
					INC A
					INC A
					STA $7FE800
					CMP #$20
					BNE GENOCIDE4_1
					LDA #$00
					STA $7FE800
					JSR HDMA_RESET
					RTS
GENOCIDE4_1			PHX
					REP #$10
					LDX.W #$017D
					LDY.W #$0020
GENOCIDE4_2			LDA $7FE800
					STA $4202
					TYA
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA #$7F
					STA $4206
					LDA $4214
					STA $7FE501,x
					INY
					INX
					INX
					INX
					CPX.W #$02A0
					BCC GENOCIDE4_2
					SEP #$10
					PLX
					
					PHX
					REP #$10
					LDX.W #$011A
					LDY.W #$0020
GENOCIDE4_3			LDA $7FE800
					STA $4202
					TYA
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA #$7F
					STA $4206
					LDA $4214
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $7FE501,x
					LDA #$00
					SBC #$00
					STA $7FE502,x
					INY
					DEX
					DEX
					DEX
					CPX.W #$FFFD
					BNE GENOCIDE4_3
					SEP #$10
					PLX
					RTS
					
LAVA_WIN_TBL1		dcb $31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
LAVA_WIN_TBL2		dcb $CE,$C6,$4B,$2E,$54,$5B,$1F,$BF,$1F,$7F,$1F,$5F,$DF,$5F,$FF
LAVA_WIN_TBL3		dcb $39,$18,$00,$00,$00,$00,$00,$00,$01,$01,$02,$02,$02,$03,$03
SUB_LAVA_WINDOW		LDY #$00
SUB_LAVA_WINDOW_2	LDA LAVA_WIN_TBL1,y
					STA $2121
					LDA LAVA_WIN_TBL2,y
					STA $2122
					LDA LAVA_WIN_TBL3,y
					STA $2122
					INY
					CPY #$0F
					BCC SUB_LAVA_WINDOW_2
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0257 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1880     ;#]
					STA $00
					LDA.W #$AE00     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1980     ;#]
					STA $00
					LDA.W #$B000     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1A80     ;#]
					STA $00
					LDA.W #$B200     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1B80     ;#]
					STA $00
					LDA.W #$B400     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1C80     ;#]
					STA $00
					LDA.W #$B600     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1D80     ;#]
					STA $00
					LDA.W #$B800     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					
					REP #$20
					LDA.W #$1C60     ;#]
					STA $00
					LDA.W #$BA00     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1D60     ;#]
					STA $00
					LDA.W #$BC00     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1E60     ;#]
					STA $00
					LDA.W #$BA40     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1F60     ;#]
					STA $00
					LDA.W #$BC40     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS
					
SNOW_WIN_TBL1		dcb $31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
SNOW_WIN_TBL2		dcb $82,$C4,$08,$4C,$8C,$0C,$D2,$18,$9E,$DF,$5F,$00,$00,$CE,$C6
SNOW_WIN_TBL3		dcb $18,$28,$31,$39,$39,$5A,$49,$4A,$52,$5A,$5B,$00,$00,$39,$18
SUB_SNOW_WINDOW		LDY #$00
SUB_SNOW_WINDOW_2	LDA SNOW_WIN_TBL1,y
					STA $2121
					LDA SNOW_WIN_TBL2,y
					STA $2122
					LDA SNOW_WIN_TBL3,y
					STA $2122
					INY
					CPY #$0F
					BCC SUB_SNOW_WINDOW_2
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0257 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1880     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1980     ;#]
					STA $00
					LDA.W #$AF00     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1A80     ;#]
					STA $00
					LDA.W #$B100     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1B80     ;#]
					STA $00
					LDA.W #$B300     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1C80     ;#]
					STA $00
					LDA.W #$B500     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1D80     ;#]
					STA $00
					LDA.W #$B700     ;#]
					STA $02
					LDA.W #$0100     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					
					REP #$20
					LDA.W #$1C60     ;#]
					STA $00
					LDA.W #$B900     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1D60     ;#]
					STA $00
					LDA.W #$BB00     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1E60     ;#]
					STA $00
					LDA.W #$B940     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					REP #$20
					LDA.W #$1F60     ;#]
					STA $00
					LDA.W #$BB40     ;#]
					STA $02
					LDA.W #$0040     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS

GENOCIDE5_TBL		dcb $01,$01,$01,$01,$02,$02,$02,$02,$03,$03,$03,$03,$04,$01,$02,$03
GENOCIDE5_TBL2		dcb $BD,$25,$9E,$A6,$98
GENOCIDE5_TBL3		dcb $77,$72,$31,$1B,$79
GENOCIDE5_TBL4		dcb $F7,$64,$1D,$08,$D6,
GENOCIDE5_TBL5		dcb $66,$75,$09,$13,$78,
GENOCIDE5_TBL6		dcb $31,$02,$79,$67,$52
GENOCIDE5_TBL7		dcb $52,$5D,$08,$16,$68
WILY_PALETE			LDA #$9F
					STA $2121
					LDA GENOCIDE5_TBL2,y
					STA $2122
					LDA GENOCIDE5_TBL3,y
					STA $2122
					LDA #$BC
					STA $2121
					LDA GENOCIDE5_TBL2,y
					STA $2122
					LDA GENOCIDE5_TBL3,y
					STA $2122
					LDA #$9D
					STA $2121
					LDA GENOCIDE5_TBL4,y
					STA $2122
					LDA GENOCIDE5_TBL5,y
					STA $2122
					LDA #$BA
					STA $2121
					LDA GENOCIDE5_TBL4,y
					STA $2122
					LDA GENOCIDE5_TBL5,y
					STA $2122
					LDA #$9A
					STA $2121
					LDA GENOCIDE5_TBL6,y
					STA $2122
					LDA GENOCIDE5_TBL7,y
					STA $2122
					LDA #$B8
					STA $2121
					LDA GENOCIDE5_TBL6,y
					STA $2122
					LDA GENOCIDE5_TBL7,y
					STA $2122
					RTS

SUB_GENOCIDE5		LDA #$00
					STA $7FE3F0
					STZ $1540,x
					JSL $01ACF9
					CLC
					ADC $94
					AND #$0F
					TAY
					LDA GENOCIDE5_TBL,y
					STA $151C,x
					TAY
					JSR WILY_PALETE
					LDA #$03
					STA $1602,x
					REP #$20
					LDA.W #$3DEF
					STA $7FF500
					SEP #$20
					JSL $01ACF9
					CLC
					ADC $94
					CLC
					ADC #$B0
					STA $D8,x
					LDA #$00
					ADC #$00
					STA $14D4,x
					JSL $01ACF9
					STA $E4,x
					LDA #$02
					STA $14E0,x
					STZ $157C,x
					LDA $E4,x
					CMP #$78
					BCS GENOCIDE5_R3
					INC $157C,x
GENOCIDE5_R3		RTS

BEAM_TBL1			dcb $01,$03,$05,$07,$09,$07,$09,$0B,$0D

BEAM				LDA $7FDF12
					CMP #$01
					BEQ BEAM_D
					LDA $1540,x
					BNE BEAM_0
					JSR SUB_GFX_B
BEAM_0				LDA $9D
					BNE BEAM_R
					LDA $14C8,x
					CMP #$08
					BCC BEAM_D
					LDA $1540,x
					BNE BOMB_2
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSL $01A7DC
					LDA $15AC,x
					CMP #$D0
					BEQ BEAM_3
					BCS BEAM_R
					CMP #$CC
					BEQ BEAM_4
					CMP #$CC
					BCS BEAM_1
					LDA #$60
					STA $AA,x
					STZ $1602,x
					JSL $019138
					LDA $1588,x
					AND #$04
					BNE BOMB
BEAM_R				RTS
BEAM_D				STZ $14C8,x
					RTS
BEAM_3				JSR SUB_BEAM1
					RTS
BEAM_4				LDA $C2,x
					PHX
					TAX
					LDA $7FDF00,x
					PLX
					CMP #$00
					BNE BEAM_4_2
					JSR SUB_BEAM2
					RTS
BEAM_4_2			JSR SUB_BEAM3
					RTS
BEAM_1				LDA $C2,x
					TAY
					LDA BEAM_TBL1,y
					STA $1602,x
					STZ $AA,x
					STZ $B6,x
					RTS
BOMB				LDA #$18
					STA $1540,x
					LDA #$09
					STA $1DFC
					RTS
BOMB_2				LDA $1540,x
					CMP #$01
					BEQ BOMB_DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
					RTS
BOMB_DELETE			STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					
VRAM				LDA #$80
					STA $2115   ;#VRAM
					REP #$20
					LDA $00     ;#]
					STA $2116
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18
					STA $4311
					LDA #$7E
					STA $4314
					REP #$20
					LDA $02     ;#]
					STA $4312
					LDA $04     ;#]TCY
					STA $4315
					SEP #$20
					LDA #$02
					STA $420B
					RTS
					
SUB_GFX0			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0251 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$7800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$024E ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0250 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS

GFX_LOAD1			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0252 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0253 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS
GFX_LOAD2			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0254 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$0000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0255 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$0800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0256 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS
					
GFX_LOAD3			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0258 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$0800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$0259 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS

GFX_LOAD4			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$025A ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$0000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$025B ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$0800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$025C ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$1000     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS

GFX_LOAD5			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$025D ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					PHX
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					PLX
					REP #$20
					LDA.W #$7800     ;#]
					STA $00
					LDA.W #$AD00     ;#]
					STA $02
					LDA.W #$1000     ;#]TCY
					STA $04
					SEP #$20
					JSR VRAM
					RTS
					
PALETE1_1			dcb $91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F
					dcb $B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC
					dcb $21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
					dcb $31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
PALETE1_2			dcb $AD,$6B,$32,$9A,$8C,$F7,$52,$DB,$9E,$31,$3E,$7D,$F7,$7C,$BD
					dcb $C6,$AD,$D1,$4F,$6B,$F7,$52,$31,$3E,$F7,$7C,$BD
					dcb $24,$27,$2A,$2C,$2F,$12,$17,$38,$59,$7A,$9B,$BC,$FD,$1F,$3F
					dcb $E1,$C6,$24,$86,$E9,$0A,$2B,$4C,$8E,$D1,$14,$CE,$9A,$DD,$A1
PALETE1_3			dcb $14,$35,$1D,$08,$3D,$40,$02,$29,$15,$56,$65,$42,$66,$03,$77
					dcb $1C,$10,$20,$01,$35,$40,$02,$52,$65,$66,$03,$77
					dcb $04,$04,$04,$04,$04,$00,$00,$04,$08,$08,$0C,$10,$14,$19,$19
					dcb $4C,$18,$75,$79,$7D,$7E,$7E,$7E,$7E,$7E,$7F,$39,$7F,$7F,$3C
PALETEW_1			dcb $21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E
PALETEW_2			dcb $9A,$57,$14,$D1,$8E,$4C,$2B,$0A,$E9,$86,$24,$02,$E1,$A1
PALETEW_3			dcb $7F,$7F,$7F,$7E,$7E,$7E,$7E,$7E,$7D,$79,$75,$61,$4C,$3C
					
WATER_PALETE		LDY #$00
WATER_PALETE_2		LDA PALETEW_1,y
					STA $2121
					LDA PALETEW_2,y
					STA $2122
					LDA PALETEW_3,y
					STA $2122
					INY
					CPY #$0E
					BCC WATER_PALETE_2
					RTS
					
PALETEL_1			dcb $21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
PALETEL_2			dcb $1F,$1F,$54,$4A,$45,$5F,$24,$9F,$BF,$7F,$DF,$1F,$5B,$2E,$5F
PALETEL_3			dcb $02,$01,$00,$00,$00,$03,$00,$00,$02,$01,$03,$00,$00,$00,$02
					
LAVA_PALETE			LDY #$00
LAVA_PALETE_2		LDA PALETEL_1,y
					STA $2121
					LDA PALETEL_2,y
					STA $2122
					LDA PALETEL_3,y
					STA $2122
					INY
					CPY #$0F
					BCC LAVA_PALETE_2
					RTS
PALETES_1			dcb $21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
PALETES_2			dcb $D2,$08,$DF,$9E,$82,$18,$8C,$0C,$5F,$C4,$4C,$16,$12,$06,$00
PALETES_3			dcb $49,$31,$5A,$52,$18,$4A,$39,$5A,$5B,$28,$39,$00,$00,$00,$00
SNOW_PALETE			LDY #$00
SNOW_PALETE_2		LDA PALETES_1,y
					STA $2121
					LDA PALETES_2,y
					STA $2122
					LDA PALETES_3,y
					STA $2122
					INY
					CPY #$0F
					BCC SNOW_PALETE_2
					RTS
					
PALETEF_1			dcb $B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD
PALETEF_2			dcb $A5,$83,$05,$13,$ED,$05,$32,$8C,$D8,$31,$7D,$F7,$BD
PALETEF_3			dcb $24,$44,$35,$18,$18,$65,$1D,$3D,$29,$56,$42,$66,$77
FINISH_PALETE		LDY #$00
FINISH_PALETE_2		LDA PALETEF_1,y
					STA $2121
					LDA PALETEF_2,y
					STA $2122
					LDA PALETEF_3,y
					STA $2122
					INY
					CPY #$0D
					BCC FINISH_PALETE_2
					RTS
					
MAIN_PALETE			LDY #$00
MAIN_PALETE_2		LDA PALETE1_1,y
					STA $2121
					LDA PALETE1_2,y
					STA $2122
					LDA PALETE1_3,y
					STA $2122
					INY
					CPY #$39
					BCC MAIN_PALETE_2
					RTS

SUB_GENOCIDE1		JSR SUB_GFX0
					JSR MAIN_PALETE
					JSR LAYER1_RESET
					JSR LAYER2_RESET
					JSR TV_MAP
					JSR FUTURE_MAP
					LDA #$16
					STA $212C
					LDA #$01
					STA $212D
					RTS
					
WATER_LOAD			JSR WATER_PALETE
					LDA #$80
					STA $2115
					PHX
					REP #$30
					LDA.W #$7FDD
					STA $0701
					LDA.W #$3300
					STA $02
					LDX.W #$0000
WATER_LOAD_2		
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $34F800,x
					ORA.W #$0800
					STA $2118 ;#ރf[^(2byte)
					INC $02
					LDA $02
					CMP.W #$3400
					BNE WATER_LOAD_1
					LDA.W #$3800
					STA $02
WATER_LOAD_1		INX
					INX
					CPX.W #$0700
					BCC WATER_LOAD_2
					SEP #$30
					PLX
					RTS

LAVA_LOAD			JSR LAVA_PALETE
					LDA #$80
					STA $2115
					PHX
					REP #$30
					LDA.W #$3300
					STA $02
					LDX.W #$0000
LAVA_LOAD_2		
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $2BE640,x
					ORA.W #$0800
					STA $2118 ;#ރf[^(2byte)
					INC $02
					LDA $02
					CMP.W #$3400
					BNE LAVA_LOAD_1
					LDA.W #$3800
					STA $02
LAVA_LOAD_1			INX
					INX
					CPX.W #$0700
					BCC LAVA_LOAD_2
					SEP #$30
					PLX
					RTS
					
SNOW_LOAD			JSR SNOW_PALETE
					LDA #$80
					STA $2115
					PHX
					REP #$30
					LDA.W #$3300
					STA $02
					LDX.W #$0000
SNOW_LOAD_2		
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $2CAD50,x
					ORA.W #$0800
					STA $2118 ;#ރf[^(2byte)
					INC $02
					LDA $02
					CMP.W #$3400
					BNE SNOW_LOAD_1
					LDA.W #$3800
					STA $02
SNOW_LOAD_1			INX
					INX
					CPX.W #$0700
					BCC SNOW_LOAD_2
					SEP #$30
					PLX
					RTS
					
MARIO_CHECK			REP #$20
					LDA $94
					CMP.W #$0208
					BCS MARIO_CHECK_R
					LDA.W #$0208
					STA $94
MARIO_CHECK_R		SEP #$20
					RTS

FUTURE_MAP_TBL1		dcb $40,$41,$42,$43,$44,$45,$46,$47,$4A,$4B,$4C,$4D,$4E,$4F
					dcb $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F
					dcb $60,$61,$62,$63,$64,$65,$66,$67,$6A,$6B,$6C,$6D,$6E,$6F
					dcb $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F
					dcb $80,$81,$82,$83,$84,$85,$86,$87,$8A,$8B,$8C,$8D,$8E,$8F
					dcb $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F
					dcb $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$AA,$AB,$AC,$AD,$AE,$AF
					dcb $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
					
FUTURE_MAP_TBL2		dcb $40,$41,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D
					dcb $0E,$0F,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
					dcb $50,$51,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D
					dcb $1E,$1F,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F
					dcb $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D
					dcb $2E,$2F,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F
					dcb $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D
					dcb $3E,$3F,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F

FUTURE_MAP			LDY #$00
FUTURE_MAP_2		LDA FUTURE_MAP_TBL1,y
					STA $02
					LDA #$3C
					STA $03
					LDA FUTURE_MAP_TBL2,y
					STA $0E
					LDA #$09
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY #$78
					BCC FUTURE_MAP_2
					RTS

TV_MAP_TBL1			dcb $A8,$A9,$AA,$AB,$C8,$C9,$CA,$CB,$E8,$E9,$EA,$EB ;#㏬ 00`
					dcb $B4,$B5,$B6,$B7,$D4,$D5,$D6,$D7,$F4,$F5,$F6,$F7 ;#E㏬ 0C`
					dcb $C4,$C5,$C6,$C7,$E4,$E5,$E6,$E7,$04,$05,$06,$07,$08,$09,$24,$25,$26,$27,$28,$29 ;#㒆 18`
					dcb $D8,$D9,$DA,$DB,$F8,$F9,$FA,$FB,$16,$17,$18,$19,$1A,$1B,$36,$37,$38,$39,$3A,$3B ;#E㒆 2C`
					dcb $A2,$A3,$A4,$A5,$C2,$C3,$C4,$C5,$E2,$E3,$E4,$E5 ;# 40`
					dcb $BA,$BB,$BC,$BD,$DA,$DB,$DC,$DD,$FA,$FB,$FC,$FD ;#E 4C`
					dcb $88,$89,$8A,$8B,$A8,$A9,$AA,$AB,$C8,$C9,$CA,$CB,$CC,$CD,$E8,$E9,$EA,$EB,$EC,$ED ;# 58`
					dcb $94,$95,$96,$97,$B4,$B5,$B6,$B7,$D2,$D3,$D4,$D5,$D6,$D7,$F2,$F3,$F4,$F5,$F6,$F7 ;#E 6C`
					dcb $0C,$0D,$0E,$0F,$10,$11,$12,$13,$2C,$2D,$2E,$2F,$30,$31,$32,$33 ;# 80`
					dcb $4C,$4D,$4E,$4F,$50,$51,$52,$53,$6C,$6D,$6E,$6F,$70,$71,$72,$73
					dcb $8C,$8D,$8E,$8F,$90,$91,$92,$93,$AC,$AD,$AE,$AF,$B0,$B1,$B2,$B3
					
TV_MAP_TBL2			dcb $23,$23,$23,$23,$23,$23,$23,$23,$23,$23,$23,$23
					dcb $23,$23,$23,$23,$23,$23,$23,$23,$23,$23,$23,$23
					dcb $23,$23,$23,$23,$23,$23,$23,$23,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $23,$23,$23,$23,$23,$23,$23,$23,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					dcb $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28
					
					
TV_MAP_TBL3			dcb $D0,$D1,$D2,$D3,$E0,$E1,$E2,$E3,$F0,$F1,$F2,$F3
					dcb $D0,$D1,$D2,$D3,$E0,$E1,$E2,$E3,$F0,$F1,$F2,$F3
					dcb $A0,$A1,$A2,$A3,$B0,$B1,$B2,$B3,$B0,$B1,$B2,$B3,$B4,$B5,$A0,$A1,$A2,$A3,$A4,$A5
					dcb $A2,$A3,$A4,$A5,$B2,$B3,$B4,$B5,$B0,$B1,$B2,$B3,$B4,$B5,$A0,$A1,$A2,$A3,$A4,$A5
					dcb $D0,$D1,$D2,$D3,$E0,$E1,$E2,$E3,$F0,$F1,$F2,$F3
					dcb $D0,$D1,$D2,$D3,$E0,$E1,$E2,$E3,$F0,$F1,$F2,$F3
					dcb $A0,$A1,$A2,$A3,$B0,$B1,$B2,$B3,$B0,$B1,$B2,$B3,$B4,$B5,$A0,$A1,$A2,$A3,$A4,$A5
					dcb $A2,$A3,$A4,$A5,$B2,$B3,$B4,$B5,$B0,$B1,$B2,$B3,$B4,$B5,$A0,$A1,$A2,$A3,$A4,$A5
					dcb $80,$81,$82,$83,$84,$85,$86,$87,$90,$91,$92,$93,$94,$95,$96,$97
					dcb $90,$91,$92,$93,$94,$95,$96,$97,$90,$91,$92,$93,$94,$95,$96,$97
					dcb $90,$91,$92,$93,$94,$95,$96,$97,$80,$81,$82,$83,$84,$85,$86,$87
					
TV_MAP_TBL4			dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$91,$91,$91,$91,$91,$91
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$91,$91,$91,$91,$91,$91
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$91,$91,$91,$91,$91,$91
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$91,$91,$91,$91,$91,$91
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
					dcb $11,$11,$11,$11,$11,$11,$11,$11,$91,$91,$91,$91,$91,$91,$91,$91
					
TV_MAP_TBL5			dcb $88,$89,$8E,$8F,$C8,$C9,$CE,$CF,$D8,$D9,$DE,$DF
					dcb $88,$89,$8E,$8F,$C8,$C9,$CE,$CF,$D8,$D9,$DE,$DF
					dcb $C6,$89,$8A,$8B,$D6,$99,$9A,$9B,$E6,$C9,$CA,$CB,$CE,$E7,$F6,$D9,$DA,$DB,$DE,$F7
					dcb $8A,$8B,$8E,$C7,$9A,$9B,$9E,$D7,$E6,$C9,$CA,$CB,$CE,$E7,$F6,$D9,$DA,$DB,$DE,$F7
					dcb $88,$89,$8E,$8F,$C8,$C9,$CE,$CF,$D8,$D9,$DE,$DF
					dcb $88,$89,$8E,$8F,$C8,$C9,$CE,$CF,$D8,$D9,$DE,$DF
					dcb $C6,$89,$8A,$8B,$D6,$99,$9A,$9B,$E6,$C9,$CA,$CB,$CE,$E7,$F6,$D9,$DA,$DB,$DE,$F7
					dcb $8A,$8B,$8E,$C7,$9A,$9B,$9E,$D7,$E6,$C9,$CA,$CB,$CE,$E7,$F6,$D9,$DA,$DB,$DE,$F7
					dcb $88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F
					dcb $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
					dcb $C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF

TV_MAP				LDY #$00
TV_MAP_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL3,y
					STA $0E
					LDA TV_MAP_TBL4,y
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY #$B0
					BCC TV_MAP_2
					RTS

;#^񒆁A㏬AE㏬A㒆AE㒆AAEAAE
SUB_BEAM_TBL1		dcb $80,$00,$0C,$18,$2C,$58,$6C,$40,$4C
SUB_BEAM_TBL2		dcb $B0,$0C,$18,$2C,$40,$6C,$80,$4C,$58

SUB_BEAM1			LDY $C2,x
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_BEAM1_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL3,y
					STA $0E
					LDA TV_MAP_TBL4,y
					ORA #$0C
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_BEAM1_2
					RTS
					
SUB_BEAM2			LDY $C2,x
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_BEAM2_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL3,y
					STA $0E
					LDA TV_MAP_TBL4,y
					ORA #$04
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_BEAM2_2
					RTS
					
SUB_BEAM3			LDY $C2,x
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_BEAM3_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL3,y
					STA $0E
					LDA TV_MAP_TBL4,y
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_BEAM3_2
					RTS

SUB_TV1_TBL			dcb $02,$07,$05,$04,$01,$06,$03,$08,$00
SUB_TV3_TBL			dcb $02,$07,$03,$06,$08,$00
SUB_TV4_TBL			dcb $03,$08,$00
SUB_TV1				LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA SUB_TV1_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_TV1_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL3,y
					STA $0E
					LDA TV_MAP_TBL4,y
					ORA #$04
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_TV1_2
					RTS
					
SUB_TV2				LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA SUB_TV1_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_TV2_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL5,y
					STA $0E
					LDA TV_MAP_TBL4,y
					AND #$2F
					ORA #$0C
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_TV2_2
					RTS
					
SUB_TV3				LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA SUB_TV3_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_TV3_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL5,y
					STA $0E
					LDA TV_MAP_TBL4,y
					AND #$2F
					ORA #$0C
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_TV3_2
					RTS
					
SUB_TV4				LDA #$06
					STA $1DF9
					LDA $1570,x
					INC $1570,x
					TAY
					LDA SUB_TV4_TBL,y
					TAY
					LDA SUB_BEAM_TBL1,y
					STA $00
					LDA SUB_BEAM_TBL2,y
					STA $01
					LDY $00
SUB_TV4_2			LDA TV_MAP_TBL1,y
					STA $02
					LDA TV_MAP_TBL2,y
					STA $03
					LDA TV_MAP_TBL5,y
					STA $0E
					LDA TV_MAP_TBL4,y
					AND #$2F
					ORA #$0C
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY $01
					BCC SUB_TV4_2
					RTS
					
KEISEN_MAP			LDA #$39
					STA $03
					STZ $02
					LDA #$40
					STA $0E
					LDA #$05
					STA $0F
					
KEISEN_MAP2			LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $02
					AND.W #$001F
					CMP.W #$0010
					BCS KEISEN_MAP2_4
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					BRA KEISEN_MAP2_0
KEISEN_MAP2_4		LDA $0E
					ORA.W #$4000
					STA $2118 ;#ރf[^(2byte)
KEISEN_MAP2_0		LDA $02
					AND.W #$001F
					CMP.W #$001F
					BEQ KEISEN_MAP2_3
					CMP.W #$000F
					BEQ KEISEN_MAP2_1
					BCS KEISEN_MAP2_2
					INC $0E
					BRA KEISEN_MAP2_1
KEISEN_MAP2_2		DEC $0E
					BRA KEISEN_MAP2_1
KEISEN_MAP2_3		LDA $0E
					CLC
					ADC.W #$0010
					STA $0E
KEISEN_MAP2_1		INC $02
					LDA $02
					CMP.W #$3A80
					SEP #$20
					BCC KEISEN_MAP2

					LDA #$33
					STA $03
					STZ $02
					LDA #$F0
					STA $0E
					LDA #$85
					STA $0F
KEISEN_MAP3			LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $02
					AND.W #$001F
					CMP.W #$0010
					BCS KEISEN_MAP3_4
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					BRA KEISEN_MAP3_0
KEISEN_MAP3_4		LDA $0E
					ORA.W #$4000
					STA $2118 ;#ރf[^(2byte)
KEISEN_MAP3_0		LDA $02
					AND.W #$001F
					CMP.W #$001F
					BEQ KEISEN_MAP3_3
					CMP.W #$000F
					BEQ KEISEN_MAP3_1
					BCS KEISEN_MAP3_2
					INC $0E
					BRA KEISEN_MAP3_1
KEISEN_MAP3_2		DEC $0E
					BRA KEISEN_MAP3_1
KEISEN_MAP3_3		LDA $0E
					SEC
					SBC.W #$0010
					STA $0E
KEISEN_MAP3_1		INC $02
					LDA $02
					CMP.W #$3400
					BNE KEISEN_MAP3_5
					LDA.W #$3800
					STA $02
KEISEN_MAP3_5		CMP.W #$3880
					SEP #$20
					BCC KEISEN_MAP3

KEISEN_MAP4			LDY #$00
KEISEN_MAP4_2		LDA KEISEN_MAP_TBL1,y
					STA $02
					LDA KEISEN_MAP_TBL2,y
					STA $03
					LDA KEISEN_MAP_TBL3,y
					STA $0E
					LDA KEISEN_MAP_TBL4,y
					STA $0F
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					SEP #$20
					INY
					CPY #$44
					BCC KEISEN_MAP4_2
					RTS

KEISEN_MAP_TBL1		dcb $00,$01,$20,$21,$40,$41,$60,$61,$80,$81,$82,$A0,$A1,$A2,$C0,$C1,$C2,$E0,$E1,$E2
					dcb $00,$01,$02,$03,$20,$21,$22,$23,$40,$41,$42,$43,$60,$61
					dcb $1E,$1F,$3C,$3D,$3E,$3F,$5C,$5D,$5E,$5F,$7C,$7D,$7E,$7F
					dcb $9D,$9E,$9F,$BD,$BE,$BF,$DD,$DE,$DF,$FD,$FE,$FF,$1E,$1F,$3E,$3F,$5E,$5F,$7E,$7F
KEISEN_MAP_TBL2		dcb $3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D
					dcb $3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E
					dcb $37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37
					dcb $37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$37,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C
KEISEN_MAP_TBL3		dcb $07,$06,$17,$16,$27,$26,$37,$36,$0B,$0A,$09,$1B,$1A,$19,$2B,$2A,$29,$3B,$3A,$39
					dcb $0F,$0E,$0D,$0C,$1F,$1E,$1D,$1C,$2F,$2E,$2D,$2C,$3F,$3E
					dcb $3E,$3F,$2C,$2D,$2E,$2F,$1C,$1D,$1E,$1F,$0C,$0D,$0E,$0F
					dcb $39,$3A,$3B,$29,$2A,$2B,$19,$1A,$1B,$09,$0A,$0B,$36,$37,$26,$27,$16,$17,$06,$07
KEISEN_MAP_TBL4		dcb $45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45
					dcb $45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45,$45
					dcb $85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85
					dcb $85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85,$85
					
LAYER1_RESET		REP #$20
					LDA.W #$2000
					STA $02
					LDA.W #$007F
					STA $0E
					SEP #$20
					
LAYER1_RESET_1		LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					LDA $02
					INC $02
					LDA $02
					CMP.W #$3000
					SEP #$20
					BCC LAYER1_RESET_1
					RTS
					
LAYER2_RESET		REP #$20
					LDA.W #$3000
					STA $02
					LDA.W #$007F
					STA $0E
					SEP #$20
LAYER2_RESET_1		LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116 ;#VRAMAhX(2byte)
					LDA $0E
					STA $2118 ;#ރf[^(2byte)
					LDA $02
					INC $02
					LDA $02
					CMP.W #$4000
					SEP #$20
					BCC LAYER2_RESET_1
					RTS

					
					
					
WOOD_CHECK_FL		REP #$20
					LDA $7FF500
					CMP.W #$7FFF
					SEP #$20
					BNE WOOD_CHECK_R
					INC $1528,x
					LDA #$FF
					STA $1540,x
					LDA #$28
					STA $1DFC
					LDA #$01
					STA $7FE3F0
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$40
					STA $15AC,y
WOOD_CHECK_R		RTS
WOOD_CHECK			STZ $06
					LDA $C2,x
					CMP #$12
					BCC WOOD_CHECK_0
					INC $06
					LDA #$03
					STA $05
					BRA WOOD_CHECK_1
WOOD_CHECK_0		LDA $1540,x
					BNE WOOD_CHECK_R
					LDA $151C,x
					BEQ WOOD_CHECK_R
					CMP #$04
					BEQ WOOD_CHECK_FL
					STA $05
WOOD_CHECK_1		LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					STX $04
					PHX
					LDX #$00
WOOD_CHECK_L0		LDA $14C8,x
					BEQ WOOD_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE WOOD_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE WOOD_CHECK_2
					LDA $1504,x
					CMP $05
					BNE WOOD_CHECK_2
					LDA $06
					BEQ WOOD_CHECK_5
					LDA $1528,x
					CMP #$01
					BNE WOOD_CHECK_2
WOOD_CHECK_5		LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0020
					BCC WOOD_CHECK_3
					CMP.W #$FFE0
					BCS WOOD_CHECK_3
					SEP #$20
					BRA WOOD_CHECK_2
WOOD_CHECK_L		BRA WOOD_CHECK_L0
WOOD_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0020
					BCC WOOD_CHECK_4
					CMP.W #$FFE0
					BCS WOOD_CHECK_4
					SEP #$20
WOOD_CHECK_2		BRA WOOD_CHECK_20
WOOD_CHECK_4		SEP #$20
					STZ $14C8,x
					PHX
					LDX $04
					INC $1528,x
					LDA #$FF
					STA $1540,x
					LDA #$28
					STA $1DFC
					LDA $06
					BNE WOOD_CHECK_21
					LDA #$01
					STA $7FE3F0
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$40
					STA $15AC,y
WOOD_CHECK_21		PLX
WOOD_CHECK_20		INX
					CPX #$0A
					BCC WOOD_CHECK_L
					PLX
					RTS


HDMA_LAYER			LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB29
					STA $7FFB31
					LDA #$0D
					STA $7FFB2A
					LDA #$0F
					STA $7FFB32
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E4
					STA $7FFB2C
					LDA #$E5
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35
					
					LDA #$01
					STA $7FE400
					STA $7FE500
					LDA #$00
					STA $7FE401
					STA $7FE402
					STA $7FE403
					STA $7FE501
					STA $7FE502
					STA $7FE503
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_B			dcb $8A,$8A
					dcb $8A,$8A
					dcb $AA,$AA
					dcb $AA,$8A
					dcb $AA,$AA
					dcb $AA,$8A
					dcb $CA,$CA
					dcb $CA,$8A
					dcb $CA,$CA
					dcb $CA,$8A
					dcb $EA,$EA
					dcb $EA,$8A
					dcb $EA,$EA
					dcb $EA,$8A
HORZ_DISP_B			dcb $00,$00
					dcb $00,$00
					dcb $03,$0B
					dcb $03,$00
					dcb $FC,$F4
					dcb $FC,$00
					dcb $07,$15
					dcb $07,$00
					dcb $F8,$EA
					dcb $F8,$00
					dcb $08,$18
					dcb $08,$00
					dcb $F7,$E7
					dcb $F7,$00
VERT_DISP_B			dcb $00,$10
					dcb $00,$00
					dcb $00,$10
					dcb $00,$00
					dcb $00,$10
					dcb $00,$00
					dcb $00,$0E
					dcb $00,$00
					dcb $00,$0E
					dcb $00,$00
					dcb $FE,$06
					dcb $FE,$00
					dcb $FE,$06
					dcb $FE,$00
PROPETIES_B			dcb $0D,$0D
					dcb $0D,$0D
					dcb $0D,$0D
					dcb $0D,$0D
					dcb $4D,$4D
					dcb $4D,$0D
					dcb $0D,$0D
					dcb $0D,$0D
					dcb $4D,$4D
					dcb $4D,$0D
					dcb $0D,$0D
					dcb $0D,$0D
					dcb $4D,$4D
					dcb $4D,$0D

SUB_GFX_B			JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					STA $03
					PHX
					LDX #$01
LOOP_B				PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP_B,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_B,x
					STA $0301,y
					LDA TILEMAP_B,x
					STA $0302,y
					LDA PROPETIES_B,x
					ORA $64
					STA $0303,y
					PLX
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_B
					PLX
                    LDY #$02
                    LDA #$01
                    JSL $01B7B3
                    RTS


VERT_DISP_FL		dcb $00,$10,$20,$30,$40
TILEMAP_FL			dcb $4A,$6A,$6A,$6A,$6A
SUB_GFX_FL			JSR GET_DRAW_INFO
					LDA #$05
					STA $03
					LDA $14
					AND #$04
					BNE SUB_GFX_FL_2
					LDA #$45
					STA $03
SUB_GFX_FL_2		PHX
					LDX #$04
LOOP_FL				LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_FL,x
					STA $0301,y
					LDA TILEMAP_FL,x
					STA $0302,y
					LDA $03
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_FL
					PLX
					LDY #$02
					LDA #$04
					JSL $01B7B3
SUB_GFX_FL_R		RTS

HORZ_DISP_EF		dcb $F8,$08,$F8,$08
VERT_DISP_EF		dcb $F8,$F8,$08,$08
TILEMAP_EF			dcb $EC,$EC,$EE,$EE
PROPETIES_EF		dcb $09,$49,$09,$49
SUB_GFX_EF			LDA $14
					LSR A
					AND #$01
					BEQ SUB_GFX_EF_R
					JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_EF				LDA $00
					CLC
					ADC HORZ_DISP_EF,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_EF,x
					STA $0301,y
					LDA TILEMAP_EF,x
					STA $0302,y
					LDA PROPETIES_EF,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_EF
					PLX
					LDY #$02
					LDA #$03
					JSL $01B7B3
SUB_GFX_EF_R		RTS


TILEMAP_FI			dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$CE
					dcb $C0,$C2,$C4,$E0,$E2,$E4,$E6,$46,$6E
					dcb $C8,$CA,$CC,$E8,$EA,$EC,$EE,$6E,$6E
					dcb $88,$8A,$8C,$8E,$A8,$AA,$AC,$AE,$6E
					dcb $C8,$CA,$CC,$E8,$EA,$EC,$EE,$6E,$6E
HORZ_DISP_FI		dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18,$F8
					dcb $EF,$FF,$0F,$E8,$F8,$08,$18,$F4,$00
					dcb $EF,$FF,$0F,$E8,$F8,$08,$18,$00,$00
					dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18,$00
					dcb $EF,$FF,$0F,$E8,$F8,$08,$18,$00,$00
VERT_DISP_FI		dcb $F0,$F0,$F0,$F0,$00,$00,$00,$00,$10
					dcb $F0,$F0,$F0,$00,$00,$00,$00,$E0,$00
					dcb $F0,$F0,$F0,$00,$00,$00,$00,$00,$00
					dcb $F0,$F0,$F0,$F0,$00,$00,$00,$00,$00
					dcb $F0,$F0,$F0,$00,$00,$00,$00,$00,$00
SUB_GFX_FINISH		JSR GET_DRAW_INFO
					LDA #$00
					TAY
					STA $15EA,x
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $03
					PHX
					LDX #$08
LOOP_START_FI		PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP_FI,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP_FI,x
					STA $0201,y
					LDA TILEMAP_FI,x
					STA $0202,y
					LDA #$07
					ORA $64
					STA $0203,y
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START_FI          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$08
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS



TILEMAP             dcb $82,$84,$86,$A0,$A2,$A4,$E8,$C0,$C2,$C4,$C6,$E0,$E2,$E4,$E6
HORZ_DISP			dcb $F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
					dcb $08,$F8,$E8,$18,$08,$F8,$E8,$18,$08,$F8,$E8,$18,$08,$F8,$E8
VERT_DISP			dcb $E8,$E8,$E8,$F8,$F8,$F8,$F8,$08,$08,$08,$08,$18,$18,$18,$18
PROPETIES			dcb $03,$03,$03,$03,$03,$03,$03,$07,$07,$07,$07,$07,$07,$07,$07
					dcb $43,$43,$43,$43,$43,$43,$43,$47,$47,$47,$47,$47,$47,$47,$47
TILEMAP2            dcb $8C,$8D,$8E,$8E,$8D,$8C
HORZ_DISP2			dcb $E0,$E8,$F8,$08,$18,$20
PROPETIES2			dcb $03,$03,$03,$43,$43,$43
TILEMAP3            dcb $CC,$CE,$CE,$CC,$CC,$CE,$CE,$CC
HORZ_DISP3			dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18
VERT_DISP3			dcb $F8,$F8,$F8,$F8,$07,$07,$07,$07
PROPETIES3			dcb $03,$03,$43,$43,$83,$83,$C3,$C3

SUB_GFX_R			RTS
SUB_GFX             JSR GET_DRAW_INFO
					LDA #$30
					TAY
					STA $15EA,x
					LDA $1602,x
					BEQ SUB_GFX_R
					CMP #$03
					BNE SUB_GFX2
					STZ $03
					LDA $157C,x
					BEQ SUB_GFX_2
					LDA #$0F
					STA $03
SUB_GFX_2			PHX
					LDX #$0E
LOOP_START          PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP,x
					STA $0200,y
					LDA PROPETIES,x
					ORA $64
					STA $0203,y
					PLX
					LDA TILEMAP,x
					STA $0202,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0201,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0E
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS                     ; return

SUB_GFX2			CMP #$02
					BEQ SUB_GFX3
					PHX
					LDX #$05
SUB_GFX2_LOOP		LDA $00
					CLC
					ADC HORZ_DISP2,x
					STA $0200,y
					LDA $01
					STA $0201,y
					LDA TILEMAP2,x
					STA $0202,y
					LDA PROPETIES2,x
					ORA $64
					STA $0203,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL SUB_GFX2_LOOP          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$05
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS
SUB_GFX3			PHX
					LDX #$07
SUB_GFX3_LOOP		LDA $00
					CLC
					ADC HORZ_DISP3,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_DISP3,x
					STA $0201,y
					LDA TILEMAP3,x
					STA $0202,y
					LDA PROPETIES3,x
					ORA $64
					STA $0203,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL SUB_GFX3_LOOP          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        STZ $157C,x                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0E                 
                    LDA $95                
                    SBC $14E0,x             
                    BCC LABEL16             
                    INC $157C,x
LABEL16             RTS                     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    
RETURN67            RTS                     ; return
TIUN                PHX
					LDX #$00
TIUN_300			LDA #$00
					STA $7FFBB0,x
					INX
					CPX #$20
					BCC TIUN_300
					PLX
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA #$3B
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$99
					STA $00C2,y
					LDA #$00
					STA $1570,y
					LDA #$2C
					STA $1DFC
					LDA #$01
					STA $7FFEE0
					LDA $7FFE00
					TAY
					LDA #$F0
					STA $15AC,y
                    RTS
