;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Ah
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$62
					BEQ INIT2
					CMP #$63
					BEQ INIT3
					CMP #$64
					BEQ INIT4
					CMP #$65
					BEQ INIT5
					CMP #$66
					BEQ INIT6
					LDA #$03
					STA $151C,x
					LDA #$FF
					STA $15AC,x
					LDA #$11
					STA $1686,x
INIT_RTL			RTL
INIT2				LDA #$01
					STA $1504,x
					LDA #$18
					STA $15AC,x
					RTL
INIT3				LDA #$02
					STA $1504,x
					LDA #$08
					STA $15AC,x
					LDA #$06
					STA $1570,x
					RTL
INIT4				LDA #$04
					STA $1504,x
					RTL
INIT5				LDA #$05
					STA $1504,x
					LDA #$30
					STA $15AC,x
					LDA #$20
					STA $1540,x
					RTL
INIT6				LDA #$06
					STA $1504,x
					LDA #$60
					STA $15AC,x
					LDA $1F30
					ORA #$04
					STA $1F30
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR ADON
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR BALL
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR LEVEL163
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR BLOCK
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR LEVEL164
					RTS
MAIN5				CMP #$05
					BNE MAIN6
					JSR LEVEL165
					RTS
MAIN6				CMP #$06
					BNE MAIN7
					JSR LEVEL166
					RTS
MAIN7				CMP #$07
					BNE MAIN8
					JSR BOMB
					RTS
MAIN8				CMP #$08
					BNE MAIN9
					JSR COMMAND
					RTS
MAIN9				CMP #$09
					BNE MAINA
					JSR NIGHT
					RTS
MAINA				CMP #$0A
					BNE MAINB
					JSR ENE
					RTS
MAINB				CMP #$0B
					BNE MAINC
					JSR STAR
					RTS
MAINC				CMP #$0C
					BNE MAIND
					JSR YOSHI
					RTS
MAIND				JSR SWORD
					RTS
					
ADON				JSR SUB_GFX
					LDA $C2,x
					BNE ADON_2
					LDA #$90
					STA $94
					STZ $95
					LDA #$1E
					STA $1DFB
					INC $C2,x
					LDA $1FEF
					AND #$04
					BEQ ADON_2
					JSR GEN_SPRITE
					LDA #$0C
					STA $1504,y
					LDA #$00
					STA $00E4,y
					INC $C2,x
ADON_2				LDA $9D
					BNE ADON_R
					JSL $01802A
					LDA $C2,x
					CMP #$01
					BNE ADON_3
					JSR START
ADON_R				RTS
ADON_3				JSR MARIO_DAMAGE
					LDA $C2,x
					CMP #$02
					BNE ADON_4
					JSR ADON2
					RTS
ADON_4				CMP #$03
					BNE ADON_5
					JSR ADON3
					RTS
ADON_5				CMP #$04
					BNE ADON_6
					JSR ADON4
					RTS
ADON_6				JSR ADON5
					RTS

ADON2				LDA $15AC,x
					CMP #$C0
					BEQ ADON2_2
					CMP #$A0
					BEQ ADON2_3
					CMP #$80
					BEQ ADON2_4
					CMP #$71
					BCS ADON2_R
					CMP #$70
					BEQ ADON2_5
					CMP #$30
					BCS ADON2_6
					CMP #$2F
					BEQ ADON2_7
					CMP #$2F
					BCS ADON2_R
					LDA $1588,x
					AND #$04
					BNE ADON2_1
ADON2_R				RTS
ADON2_1				LDA #$10
					STA $1DFC
					LDA #$03
					STA $1DF9
					LDA #$01
					STA $7FFF06
					LDA #$20
					STA $1887
					INC $C2,x
					LDA #$20
					STA $15AC,x
					RTS
ADON2_2				LDA #$01
					STA $1426
					RTS
ADON2_4				LDA #$02
					STA $1426
					LDA #$24
					STA $1DFB
					RTS
ADON2_3				LDA #$0D
					STA $151C,x
					RTS
ADON2_5				LDA #$08
					STA $1DFC
					LDA #$01
					STA $1602,x
ADON2_6				LDA #$C0
					STA $AA,x
					RTS
ADON2_7				LDA #$2B
					STA $1DFC
					STZ $E4,x
					LDA #$02
					STA $1602,x
					RTS

					
ADON3_SPEED			dcb $D0,$30
ADON3				
					LDA $15AC,x
					BNE ADON3_0
					LDA #$04
					STA $1602,x
					LDA $157C,x
					TAY
					LDA ADON3_SPEED,y
					STA $B6,x
					LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $02
					CMP.W #$0078
					BCC STOP
					CMP.W #$0160
					BCS STOP
					SEP #$20
ADON3_R				RTS
ADON3_0				JSR DIR_CHECK
					RTS
STOP				SEP #$20
					STZ $B6,x
					LDA #$03
					STA $1602,x
					LDA $157C,x
					EOR #$01
					STA $157C,x
					INC $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
					
ADON4				LDA $15AC,x
					CMP #$E0
					BEQ ADON4_2
					CMP #$A1
					BCS ADON4_R
					CMP #$A0
					BEQ ADON4_3
					CMP #$60
					BCS ADON4_4
					CMP #$5F
					BEQ ADON4_5
					BCS ADON4_R
					LDA #$38
					STA $AA,x
					LDA $1588,x
					AND #$04
					BNE ADON4_6
					RTS
ADON4_6				LDA #$10
					STA $1DFC
					LDA #$01
					STA $7FFF06
					LDA #$03
					STA $C2,x
					LDA #$20
					STA $15AC,x
					JSR NEEDLE_CHECK
					LDA #$01
					STA $7FFF08
					LDA #$20
					STA $1887
					LDA $77
					AND #$04
					BEQ ADON4_R
					LDA #$60
					STA $18BD
ADON4_R				RTS
ADON4_2				LDA #$00
					STA $7FFF08
					JSR GEN_SPRITE
					LDA #$0D
					STA $1504,y
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					LDA #$A0
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$15
					STA $167A,y
					RTS
ADON4_3				LDA #$08
					STA $1DFC
					LDA #$01
					STA $1602,x
ADON4_4				LDA #$A0
					STA $AA,x
					RTS
ADON4_5				LDA #$2B
					STA $1DFC
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA #$02
					STA $1602,x
					RTS
					
ADON5				LDA $15AC,x
					CMP #$A0
					BEQ ADON5_1
					CMP #$9F
					BEQ ADON5_2
					CMP #$60
					BEQ ADON5_3
					RTS
ADON5_1				LDA #$0C
					STA $13BF
					LDA #$01
					STA $1426
					RTS
ADON5_2				LDA #$0D
					STA $13BF
					RTS
ADON5_3				LDA $1FEF
					AND #$FB
					STA $1FEF ;#3UP[tO폜
					LDA $1F30 ;#hSRCtO폜
					AND #$FB
					STA $1F30
					LDA #$01
					STA $13CE ;#NAtO
					LDA #$01
					STA $0DD5
					INC $1DE9
					LDA #$0B
					STA $0100
					RTS
					
NEEDLE_CHECK		LDA $E4,x
					STA $02
					LDA $14E0,x
					STA $03
					REP #$20
					LDA $7FFF20
					SEC
					SBC $02
					CMP.W #$0010
					BCC NEEDLE_CHECK_1
					CMP.W #$FFF0
					BCS NEEDLE_CHECK_1
					SEP #$20
					RTS
NEEDLE_CHECK_1		SEP #$20
					LDA #$28
					STA $1DFC
					INC $1528,x
					LDA $1528,x
					CMP #$03
					BCS NEEDLE_CHECK_2
					RTS
NEEDLE_CHECK_2		LDA #$1E
					STA $1DFB
					LDA #$80
					STA $2115   ;#VRAM
					REP #$20
					LDA.W #$7800     ;#]
					STA $2116
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18
					STA $4311
					LDA #$7E
					STA $4314
					REP #$20
					LDA.W #$AD00     ;#]
					STA $4312
					LDA.W #$1000    ;#]TCY
					STA $4315
					SEP #$20
					LDA #$02
					STA $420B
					LDA #$C0
					STA $AA,x
					LDA #$05
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
					
MARIO_DAMAGE		LDA $18BD
					BEQ MARIO_DAMAGE_2
					LDA $1497
					BEQ MARIO_DAMAGE_2
					STZ $18BD
MARIO_DAMAGE_2		LDA $1528,x
					CMP #$03
					BCS MARIO_DAMAGE_R
					LDA $1497
					BNE MARIO_DAMAGE_R
					LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					JSL $01A7DC
					BCS MARIO_DAMAGE_3
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS MARIO_DAMAGE_3
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS MARIO_DAMAGE_3
					BRA MARIO_DAMAGE_4
MARIO_DAMAGE_3		LDA $1497
					BNE MARIO_DAMAGE_4
					JSL $00F5B7
MARIO_DAMAGE_4		PLA
					STA $14D4,x
					PLA
					STA $D8,x
MARIO_DAMAGE_R		RTS
					
DIR_CHECK			STZ $157C,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS DIR_CHECK_R
					INC $157C,x
DIR_CHECK_R			RTS
					
YOSHI				JSR SUB_GFX_Y
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA $7FFF06
					BEQ YOSHIR
					LDA #$02
					STA $14C8,x
YOSHIR				RTS

START				LDA $7E
					CMP #$E0
					BCC START_R
					LDA $1F30
					AND #$04
					BNE START_2
					LDA $1EAF
					AND #$40
					BEQ TELEPORT
					LDA $19BA
					STA $19B9
					LDA $19DA
					STA $19D9
					LDA $1B95
					STA $1B94
TELEPORT			LDA #$06
					STA $71
					STZ $89
					STZ $88
START_R				RTS
START_2				LDA $19BB
					STA $19B9
					LDA $19DB
					STA $19D9
					LDA $1B96
					STA $1B94
					BRA TELEPORT

BALL				JSR SUB_GFX_B
					LDA $9D
					BNE BALL_R
					JSR MOVE_BALL
					LDA $15AC,x
					BNE BALL_1
					JSL $01ACF9
					AND #$1F
					CLC
					ADC #$10
					STA $15AC,x
					LDA #$21
					STA $1DFC
					JSR GEN_BLK
BALL_1				LDA $E4,x
					STA $0F
					LDA #$1C
					STA $B6,x
					JSL $018022
					LDA $E4,x
					SEC
					SBC $0F
					STA $0E
					STZ $0F
					REP #$20
					LDA $1462
					CLC
					ADC $0E
					STA $1462
					SEP #$20
					LDA $7E
					CMP #$08
					BCS BALL_R
					REP #$20
					INC $94
					INC $94
					SEP #$20
BALL_R				RTS

GEN_BLK				LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
                    REP #$30 
                    LDA.W #$0BFF
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					RTS

GEN_BLK2			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
                    REP #$30 
                    LDA.W #$098E
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					LDA $9A
					CLC
					ADC #$10
					STA $9A
					LDA $9B
					ADC #$00
					STA $9B
					LDA $151C,x
					BNE GEN_BLK2_2
                    REP #$30 
                    LDA.W #$098F
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					BRA GEN_BLK2_3
GEN_BLK2_2			REP #$30 
                    LDA.W #$01EB
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
GEN_BLK2_3			LDA $98
					CLC
					ADC #$10
					STA $98
					LDA $99
					ADC #$00
					STA $99
                    REP #$30 
                    LDA.W #$0E32
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
                    REP #$30 
                    LDA.W #$0E12
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					RTS
					
DELETE_BKL			LDA $1570,x
					CMP #$0A
					BCC DELETE_BKL_R
					PHX
					SEC
					SBC #$0A
					TAX
					LDA BLK_X1,x
					STA $9A
					LDA BLK_X2,x
					STA $9B
					LDA BLK_Y1,x
					STA $98
					LDA BLK_Y2,x
					STA $99
					REP #$30 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					LDA $9A
					CLC
					ADC #$10
					STA $9A
					LDA $9B
					ADC #$00
					STA $9B
                    REP #$30 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					LDA $98
					CLC
					ADC #$10
					STA $98
					LDA $99
					ADC #$00
					STA $99
                    REP #$30 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					LDA $9A
					SEC
					SBC #$10
					STA $9A
					LDA $9B
					SBC #$00
					STA $9B
                    REP #$30 
                    LDA.W #$0025
                    STA $03                 ;  |
                    JSL $2E8DF0
                    SEP #$30
					PLX
					JSR SUB_SMOKE
DELETE_BKL_R		RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $98
					SEC
					SBC #$08
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $9A
					CLC
					ADC #$08
                    STA $17C8,y             ; /
                    RTS

MOVE_BALL			LDA $14E0,x
					CMP #$04
					BCC MOVE_R
					LDA $1570,x
					AND #$7F
					CMP #$40
					BCC MOVE_1
					LDA #$0C
					STA $AA,x
					BRA MOVE_2
MOVE_1				LDA #$F4
					STA $AA,x
MOVE_2				JSL $01801A
					INC $1570,x
					REP #$20
					LDA $94
					CMP.W #$0850
					SEP #$20
					BCC MOVE_R
					JSR TELEPORT
MOVE_R				RTS

BLK_X1				dcb $00,$00,$20,$20,$40,$40,$60,$60,$80,$80,$A0,$A0,$C0,$C0,$E0,$E0
					dcb $E0,$00,$00,$20,$20,$40,$60,$80,$80,$60,$80,$20,$80,$20,$40,$80
					dcb $20,$80,$20,$20,$40,$60,$80,$A0,$A0,$C0,$C0,$E0,$E0,$E0,$E0,$00
					dcb $00,$20,$20,$20,$20,$40,$60,$70,$80,$A0,$C0,$C0,$E0,$00,$20,$40
					dcb $40,$40,$40,$40,$40,$40,$40,$40,$F0,$F0,$D0,$B0,$A0,$A0,$B0,$D0
					dcb $F0,$00,$10,$20,$30,$40,$50,$60,$70,$80,$90,$A0,$B0,$D0,$E0,$F0
					dcb $00,$A0,$00,$C0,$00,$B0,$00,$B0,$B0,$C0,$D0,$F0,$F0,$10,$10,$30
					dcb $30,$50,$50,$70,$70,$90,$90,$B0,$B0,$D0,$D0,$F0
					
BLK_X2				dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
					dcb $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02
					dcb $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$03,$03,$03
					dcb $03,$03,$03,$03,$03,$03,$03,$03,$02,$02,$02,$02,$02,$02,$02,$02
					dcb $02,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
					dcb $04,$03,$04,$03,$04,$03,$04,$03,$03,$03,$03,$03,$03,$04,$04,$04
					dcb $04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04
					
BLK_Y1				dcb $00,$60,$00,$60,$00,$60,$60,$F0,$60,$E0,$50,$D0,$40,$C0,$40,$20
					dcb $C0,$20,$B0,$20,$00,$00,$00,$00,$E0,$C0,$C0,$A0,$A0,$80,$80,$80
					dcb $60,$60,$40,$20,$20,$20,$20,$20,$90,$30,$A0,$F0,$D0,$B0,$40,$10
					dcb $50,$10,$A0,$80,$60,$B0,$A0,$10,$90,$A0,$10,$B0,$B0,$30,$30,$30
					dcb $10,$F0,$D0,$B0,$90,$70,$50,$30,$90,$70,$70,$70,$50,$30,$10,$10
					dcb $10,$90,$10,$70,$10,$70,$10,$70,$10,$70,$10,$90,$10,$20,$40,$60
					dcb $80,$B0,$A0,$C0,$C0,$E0,$E0,$00,$20,$40,$60,$00,$60,$00,$60,$F0
					dcb $60,$E0,$50,$E0,$40,$D0,$30,$C0,$30,$B0,$20,$10
					
BLK_Y2				dcb $01,$01,$01,$01,$01,$01,$01,$00,$01,$00,$01,$00,$01,$00,$01,$01
					dcb $00,$01,$00,$01,$01,$01,$01,$01,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
					dcb $00,$01,$00,$00,$00,$00,$00,$01,$00,$00,$01,$00,$00,$01,$01,$01
					dcb $01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$00
					dcb $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$01

					
LEVEL_163_B			JSR SUB_GFX_STAR
					LDA $9D
					BNE LEVEL_163_B_R
					LDA $1540,x
					CMP #$F0
					BEQ LEVEL_163_B2
					BCS LEVEL_163_B3
					CMP #$00
					BNE LEVEL_163_B_4
					JSL $01A7DC
					BCC LEVEL_163_B_R
					LDA #$FF
					STA $1540,x
					RTS
LEVEL_163_B3		STZ $7B
					STZ $7D
					RTS
LEVEL_163_B2		LDA #$10
					STA $1DFC
					LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $D8,x
					STA $96
					LDA $14D4,x
					STA $97
					JSR SUB_SMOKE
LEVEL_163_B_R		RTS
LEVEL_163_B_4		LDA #$60
					STA $7B
					STZ $7D
					RTS
LEVEL163			LDA EXTRA_BITS,x
					AND #$04
					BNE LEVEL_163_B
					LDA $9D
					BNE LEVEL163_R
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					LDA $15AC,x
					BNE LEVEL163_R
					LDA #$10
					STA $15AC,x
					LDA $1570,x
					CMP #$86
					BCS LEVEL163_R
					CMP #$7C
					BCS LEVEL163_2
					LDA #$2B
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					PHX
					LDA $1570,x
					TAX
					LDA BLK_X1,x
					STA $00E4,y
					LDA BLK_X2,x
					STA $14E0,y
					LDA #$00
					STA $00D8,y
					STA $14D4,y
					LDA BLK_Y1,x
					STA $1528,y
					LDA BLK_Y2,x
					STA $1570,y
					PLX
					LDA $1570,x
					CMP #$3E
					BNE LEVEL163_2
					LDA #$01
					STA $151C,y
LEVEL163_2			JSR DELETE_BKL
LEVEL163_R2			INC $1570,x
LEVEL163_R			RTS

BLOCK				JSR SUB_GFX_BL
					LDA $9D
					BNE BLOCK_R
					LDA #$7F
					STA $AA,x
					JSL $01801A
					LDA $1528,x
					STA $02
					LDA $1570,x
					STA $03
					LDA $D8,x
					STA $0E
					LDA $14D4,x
					STA $0F
					REP #$20
					LDA $0E
					CMP $02
					SEP #$20
					BCC BLOCK_R
					JSR GEN_BLK2
					STZ $14C8,x
BLOCK_R				RTS

CAPE_TBL			dcb $04,$05,$06,$05
LEVEL164			LDA $9D
					BNE LEVEL164_R
					JSR SUB_164
					REP #$20
					INC $1466
					INC $1466
					INC $1466
					INC $1466
					SEP #$20
					LDA #$60
					STA $7B
					LDA #$01
					STA $76
					STZ $7D
					LDA $15
					AND #$08
					BNE LEVEL164_UP
					LDA $15
					AND #$04
					BNE LEVEL164_DOWN
LEVEL164_R			RTS
LEVEL164_UP			LDA $80
					CMP #$20
					BCC LEVEL164_R
					LDA #$E0
					STA $7D
					RTS
LEVEL164_DOWN		LDA $80
					CMP #$C0
					BCS LEVEL164_R
					LDA #$20
					STA $7D
					RTS
					
SUB_164				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					JSR STAR_DUST
					LDA #$0C
					STA $13E0
					LDA $14
					LSR A
					LSR A
					AND #$03
					TAY
					LDA CAPE_TBL,y
					STA $13DF
					RTS
					
SUB_165				LDA $15AC,x
					BNE SUB_165_R
					LDA #$30
					STA $15AC,x
					REP #$20
					LDA $96
					CLC
					ADC.W #$00C0
					STA $96
					LDA $1464
					CLC
					ADC.W #$00C0
					STA $1464
SUB_165_R			LDA $1540,x
					BNE SUB_165_R2
					REP #$20
					LDA $1468
					CLC
					ADC.W #$0040
					STA $1468
					SEP #$20
					LDA #$20
					STA $1540,x
SUB_165_R2			RTS


LEVEL165			LDA $9D
					BNE LEVEL165_R
					JSR SUB_164
					JSR SUB_165
					REP #$20
					INC $1462
					INC $1462
					INC $1462
					INC $1462
					DEC $1464
					DEC $1464
					DEC $1464
					DEC $1464
					INC $94
					INC $94
					INC $94
					INC $94
					DEC $96
					DEC $96
					DEC $96
					DEC $96
					INC $1466
					INC $1466
					DEC $1468
					DEC $1468
					SEP #$20
					LDA #$01
					STA $76
					STZ $7B
					STZ $7D
					LDA $15
					AND #$08
					BNE LEVEL165_UP
					LDA $15
					AND #$02
					BNE LEVEL165_UP
					LDA $15
					AND #$04
					BNE LEVEL165_DOWN
					LDA $15
					AND #$01
					BNE LEVEL165_DOWN
LEVEL165_R			RTS
LEVEL165_UP			LDA $80
					CMP #$60
					BCC LEVEL165_R
					REP #$20
					DEC $94
					DEC $94
					DEC $96
					DEC $96
					SEP #$20
					RTS
LEVEL165_DOWN		LDA $80
					CMP #$C0
					BCS LEVEL165_R
					REP #$20
					INC $94
					INC $94
					INC $96
					INC $96
					SEP #$20
					RTS

LEVEL166			LDA $9D
					BNE LEVEL166_R2
					LDA $94
					STA $E4,x
					LDA #$25
					STA $13E0
					STZ $7B
					JSR SCROLL166
					LDA $C2,x
					CMP #$10
					BNE LEVEL166_0
					REP #$20
					LDA $96
					CMP.W #$0160
					BCC LEVEL166_G
					LDA.W #$0160
					STA $96
LEVEL166_G			SEP #$20
					JSR SUB_LEVEL166
					JSR CHECK_MARIO
					BRA LEVEL166_2
LEVEL166_0			STZ $7D
					LDA $15AC,x
					BNE LEVEL166_2
					LDA $7FFF00
					BNE LEVEL166_1
					LDA $C2,x
					CMP #$03
					BNE LEVEL166_3
					LDA #$10
					STA $C2,x
					LDA #$02
					STA $19
					JSR GEN_SPRITE
					LDA #$09
					STA $1504,y
					LDA #$78
					STA $00E4,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
LEVEL166_R2			RTS
LEVEL166_3			LDA #$01
					STA $7FFF00
					JSR GEN_SPRITE
					LDA $C2,x
					STA $151C,y
					LDA #$07
					STA $1504,y
					LDA #$C0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$FF
					STA $15AC,y
					INC $C2,x
LEVEL166_1			LDA #$20
					STA $15AC,x
LEVEL166_2			LDA $15
					AND #$02
					BNE LEVEL166_LE
					LDA $15
					AND #$01
					BNE LEVEL166_RI
LEVEL166_R			RTS
LEVEL166_LE			LDA $7E
					CMP #$08
					BCC LEVEL166_R
					LDA #$D0
					STA $7B
					RTS
LEVEL166_RI			LDA $7E
					CMP #$E8
					BCS LEVEL166_R
					LDA #$30
					STA $7B
					RTS
SCROLL166			REP #$20
					DEC $1468
					DEC $1468
					DEC $1468
					DEC $1468
					LDA $1468
					CMP.W #$0040
					BNE SCROLL166_R
					LDA.W #$00C0
					STA $1468
SCROLL166_R			SEP #$20
					RTS
					
SUB_LEVEL166		LDA $1540,x
					BNE SUB_LEVEL166_R
					LDA $16
					ORA $18
					AND #$C0
					BEQ SUB_LEVEL166_R
					LDA #$10
					STA $1540,x
					JSR GEN_SPRITE
					LDA #$0B
					STA $1504,y
SUB_LEVEL166_R		RTS
CHECK_MARIO			LDA $19
					BNE CHECK_MARIO_2
					LDA #$02
					STA $19
					INC $1528,x
					JSR MARIO_DOWN
CHECK_MARIO_2		RTS
					
BOMB_SPEED			dcb $08,$0C,$10
BOMB				LDA $1540,x
					BNE BOMB_1
					JSR SUB_GFX_BM
BOMB_1				LDA $9D
					BNE BOMB_R
					LDA $1540,x
					BNE BOMB_4
					LDA $151C,x
					TAY
					LDA BOMB_SPEED,y
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BEQ BOMB_0
					LDA $D8,x
					CMP #$70
					BCS BOMB_3
BOMB_0				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $C2,x
					BEQ BOMB_2
					LDA $C2,x
					CMP #$07
					BCS BOMB_3
					JSR COMMAND_CHECK
BOMB_R				RTS
BOMB_2				JSR GEN_COMMAND
					RTS
BOMB_3				PHX
					LDX #$00
BOMB_3_LOOP			PHX
					LDA $7FFF01,x
					TAX
					STZ $14C8,x
					PLX
					INX
					CPX #$06
					BCC BOMB_3_LOOP
					PLX
					LDA #$15
					STA $167A,x
					LDA #$20
					STA $1540,x
					LDA #$09
					STA $1DFC
					RTS
BOMB_4				LDA $1540,x
					CMP #$01
					BEQ BOMB_DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
					RTS
BOMB_DELETE			STZ $14C8,x
					LDA #$00
					STA $7FFF00
					RTS

COMMAND_CHECK		LDA $16
					ORA $18
					BEQ COMMAND_CHECK_R
					PHX
					LDA $C2,x
					STA $0F
					TAX
					LDA $7FFF10,x
					PLX
					CMP #$00
					BEQ CHECK_RIGHT
					CMP #$01
					BEQ CHECK_LEFT
					CMP #$02
					BEQ CHECK_DOWN
					CMP #$03
					BEQ CHECK_UP
					CMP #$04
					BEQ CHECK_A
					CMP #$05
					BEQ CHECK_B
					CMP #$06
					BEQ CHECK_X
					CMP #$07
					BEQ CHECK_Y
COMMAND_CHECK_R		RTS
CHECK_RIGHT			LDA $16
					AND #$01
					BEQ WRONG
					BRA RIGHT
CHECK_LEFT			LDA $16
					AND #$02
					BEQ WRONG
					BRA RIGHT
CHECK_DOWN			LDA $16
					AND #$04
					BEQ WRONG
					BRA RIGHT
CHECK_UP			LDA $16
					AND #$08
					BEQ WRONG
					BRA RIGHT
CHECK_A				LDA $18
					AND #$80
					BEQ WRONG
					BRA RIGHT
CHECK_B				LDA $16
					AND #$80
					BEQ WRONG
					LDA $18
					AND #$80
					BNE WRONG
					BRA RIGHT
CHECK_X				LDA $18
					AND #$40
					BEQ WRONG
					BRA RIGHT
CHECK_Y				LDA $16
					AND #$40
					BEQ WRONG
					LDA $18
					AND #$40
					BNE WRONG
					BRA RIGHT
WRONG				LDA #$01
					STA $C2,x
					LDA #$2A
					STA $1DFC
					PHX
					LDX #$00
WRONG_LOOP			PHX
					LDA $7FFF01,x
					TAX
					STZ $151C,x
					PLX
					INX
					CPX #$06
					BCC WRONG_LOOP
					PLX
					RTS
RIGHT				INC $C2,x
					LDA #$29
					STA $1DFC
					PHX
					LDX $0F
					LDA $7FFF00,x
					TAX
					LDA #$01
					STA $151C,x
					PLX
					RTS

GEN_COMMAND			INC $C2,x
					JSR SUB_COMMAND
					LDA #$30
					STA $00E4,y
					TYA
					STA $7FFF01
					LDA $1602,y
					STA $7FFF11
					JSR SUB_COMMAND
					LDA #$50
					STA $00E4,y
					TYA
					STA $7FFF02
					LDA $1602,y
					STA $7FFF12
					JSR SUB_COMMAND
					LDA #$70
					STA $00E4,y
					TYA
					STA $7FFF03
					LDA $1602,y
					STA $7FFF13
					JSR SUB_COMMAND
					LDA #$90
					STA $00E4,y
					TYA
					STA $7FFF04
					LDA $1602,y
					STA $7FFF14
					JSR SUB_COMMAND
					LDA #$B0
					STA $00E4,y
					TYA
					STA $7FFF05
					LDA $1602,y
					STA $7FFF15
					JSR SUB_COMMAND
					LDA #$D0
					STA $00E4,y
					TYA
					STA $7FFF06
					LDA $1602,y
					STA $7FFF16
					RTS
					
SUB_COMMAND			JSR GEN_SPRITE
					LDA #$00
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$08
					STA $1504,y
					JSL $01ACF9
					CLC
					ADC $94
					AND #$07
					STA $1602,y
					RTS
					
COMMAND				JSR SUB_GFX_CM
					LDA $9D
					BNE COMMAND_R
COMMAND_R			RTS

STAR_DUST			LDA $14   ;#ʓɂƂ̂݌鏈ɂ
					AND #$03
					BNE STARDUST_R
					JSL $01ACF9
					AND #$0F
					CLC
					LDY #$00
					ADC #$FC
					BPL STARDUST_2
					DEY
STARDUST_2			CLC
					ADC $E4,x
					STA $02
					TYA
					ADC $14E0,x
					PHA
					LDA $02
					CMP $1A
					PLA
					SBC $1B
					BNE STARDUST_R
					LDA $148E
					AND #$0F
					CLC
					ADC #$FE
					ADC $D8,x
					STA $00
					LDA $14D4,x
					ADC #$00
					STA $01
					JSL $0285BA
STARDUST_R			RTS

NIGHT_SPEED			dcb $D0,$30
NIGHT_TIME			dcb $02,$04,$08,$10,$18,$20,$30,$40
NIGHT				LDA $1558,x
					BNE NIGHT_G
					JSR SUB_GFX_NIGHT
NIGHT_G				LDA $9D
					BNE NIGHT_R
					LDA $1558,x
					BEQ NIGHT_0
					LDA $1540,x
					CMP #$01
					BEQ NIGHT_DELETE
					PHB 
					LDA #$02
					PHA
					PLB
					JSL $028086
					PLB
					RTS
NIGHT_DELETE		LDA $1FEF
					ORA #$04
					STA $1FEF
					STZ $14C8,x
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					RTS
NIGHT_0				LDA $C2,x
					BNE NIGHT_1
					LDA #$10
					STA $AA,x
					JSL $01801A
					LDA $D8,x
					CMP #$F0
					BCC NIGHT_R
					INC $C2,x
					LDA #$20
					STA $1540,x
					LDA #$40
					STA $15AC,x
					JSR LIFE_GAGE
					JSR MARIO_GAGE
NIGHT_R				RTS
NIGHT_1				JSR NIGHT_MOVE
					JSR NIGHT_CHECK
					LDA $15AC,x
					BNE NIGHT_R
					JSL $01ACF9
					CLC
					ADC $94
					AND #$07
					TAY
					LDA NIGHT_TIME,y
					STA $15AC,x
					JSR ATTACK
					RTS
NIGHT_MOVE			LDA $157C,x
					TAY
					LDA NIGHT_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $1540,x
					BNE NIGHT_MOVE_1
					JSL $01ACF9
					SEC
					SBC $94
					LSR A
					AND #$01
					STA $157C,x
					LDA #$10
					STA $1540,x
NIGHT_MOVE_1		LDA $E4,x
					CMP #$E8
					BCS NIGHT_MOVE_2
					CMP #$08
					BCC NIGHT_MOVE_3
					RTS
NIGHT_MOVE_2		STZ $157C,x
					RTS
NIGHT_MOVE_3		LDA #$01
					STA $157C,x
					RTS
NIGHT_CHECK			LDA $E4,x
					STA $02
					LDY #$00
NIGHT_CHECK_L		LDA $14C8,y
					CMP #$08
					BCC NIGHT_CHECK_2
					LDA $1504,y
					CMP #$0B
					BNE NIGHT_CHECK_2
					LDA $14D4,y
					BNE NIGHT_CHECK_2
					LDA $00E4,y
					SEC
					SBC $02
					CMP #$18
					BCC NIGHT_CHECK_1
					CMP #$E8
					BCC NIGHT_CHECK_2
NIGHT_CHECK_1		INC $1528,x
					JSR GAGE_DOWN
					LDA #$28
					STA $1DFC
					LDA #$00
					STA $14C8,y
NIGHT_CHECK_2		INY
					CPY #$0A
					BCC NIGHT_CHECK_L
					RTS
					

ATTACK				JSR GEN_SPRITE
					LDA #$0A
					STA $1504,y
					LDA #$15
					STA $167A,y
					JSL $01ACF9
					AND #$03
					STA $151C,y
					JSL $01ACF9
					SEC
					SBC $94
					AND #$03
					BEQ ATTACK_2
					JSL $01ACF9
					CLC
					SBC $13
					AND #$1F
					CLC
					ADC #$20
					STA $00AA,y
ATTACK_R			RTS
ATTACK_2			LDA #$30
					STA $00AA,y
					LDA #$18
					STA $00B6,y
					LDA #$01
					STA $157C,y
					JSL $01ACF9
					SEC
					SBC $13
					AND #$01
					BEQ ATTACK_R
					LDA #$E8
					STA $00B6,y
					LDA #$02
					STA $157C,y
					RTS
					
LIFE_GAGE			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5A63
					STA $2116
					LDA.W #$300B
					STA $2118
					LDA.W #$5A64
					STA $2116
					LDA.W #$3018
					STA $2118
					LDA.W #$5A65
					STA $2116
					LDA.W #$301C
					STA $2118
					LDA.W #$5A66
					STA $2116
					LDA.W #$301C
					STA $2118
					
					LDA.W #$5A68
					STA $03
LIFE_GAGE_LP1		LDA $03
					STA $2116
					LDA.W #$3044
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$5A7F
					BCC LIFE_GAGE_LP1
					SEP #$20
					RTS
					
MARIO_GAGE			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5A82
					STA $2116
					LDA.W #$3430
					STA $2118
					LDA.W #$5A83
					STA $2116
					LDA.W #$3431
					STA $2118
					LDA.W #$5A84
					STA $2116
					LDA.W #$3432
					STA $2118
					LDA.W #$5A85
					STA $2116
					LDA.W #$3433
					STA $2118
					LDA.W #$5A86
					STA $2116
					LDA.W #$3434
					STA $2118
					
					LDA.W #$5A88
					STA $03
MARIO_GAGE_LP1		LDA $03
					STA $2116
					LDA.W #$3444
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$5A8C
					BCC MARIO_GAGE_LP1
					SEP #$20
					RTS
GAGE_DOWN			LDA #$7F
					SEC
					SBC $1528,x
					STA $02
					LDA #$5A
					STA $03
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA.W #$30FC
					STA $2118
					SEP #$20
					LDA $1528,x
					CMP #$17
					BEQ GAGE_DOWN_2
					RTS
GAGE_DOWN_2			LDA #$40
					STA $1540,x
					LDA #$FF
					STA $1558,x
					LDA #$29
					STA $1DF9
					RTS
					
MARIO_DOWN			LDA #$8C
					SEC
					SBC $1528,x
					STA $02
					LDA #$5A
					STA $03
					LDA #$80
					STA $2115
					REP #$20
					LDA $02
					STA $2116
					LDA.W #$34FC
					STA $2118
					SEP #$20
					LDA $1528,x
					CMP #$04
					BEQ MARIO_DOWN_2
					RTS
MARIO_DOWN_2		JSL $00F606 ;
					RTS
					
ENE					JSR SUB_GFX_ENE
					LDA $9D
					BNE ENE_R
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSL $01A7DC
					LDA $14E0,x
					BNE ENE_DEL
					LDA $14D4,x
					BEQ ENE_R
					LDA $D8,x
					CMP #$A0
					BCS ENE_DEL
ENE_R				RTS
ENE_DEL				STZ $14C8,x
					RTS
					
STAR				JSR SUB_GFX_ST
					LDA $9D
					BNE STAR_R
					LDA $14C8,x
					CMP #$08
					BCC STAR_DEL
					LDA #$A0
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BNE STAR_R
					LDA $D8,x
					CMP #$D0
					BCS STAR_R
STAR_DEL			STZ $14C8,x
STAR_R				RTS

SWORD				JSR SUB_GFX_SD
					LDA $9D
					BNE SWORD_R
					JSL $01A7DC
					LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					LDA $7FFF08
					BNE SWORD_DEL
					LDA $D8,x
					CMP #$38
					BCC SWORD_R
					LDA #$D0
					STA $AA,x
					JSL $01801A
					LDA $E4,x
					STA $7FFF20
					LDA $14E0,x
					STA $7FFF21
SWORD_R				RTS
SWORD_DEL			STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GFX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SD_VERT				dcb $00,$10,$20,$30
TILE_SD				dcb $68,$6A,$6E,$4E

SUB_GFX_SD			JSR GET_DRAW_INFO
					PHX
					LDX #$03
SD_LOOP				LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC SD_VERT,x
					STA $0301,y
					LDA TILE_SD,x
					STA $0302,y
					LDA #$0F
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL SD_LOOP
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3
                    RTS 


SUB_GFX_ST			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$48
					STA $0302,y
					LDA #$04
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
                    RTS 

TILE_Y				dcb $06,$08
HORZ_Y				dcb $F6,$00
VERT_Y				dcb $F0,$00
SUB_GFX_Y			JSR GET_DRAW_INFO
					PHX
					LDX #$01
LOOP_Y				LDA $00
					CLC
					ADC HORZ_Y,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_Y,x
					STA $0301,y
					LDA TILE_Y,x
					STA $0302,y
					LDA #$0A
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_Y         ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS

TILE_ENE			dcb $C2,$C2,$C0
HORZ_ENE			dcb $00,$00,$00
					dcb $F8,$FC,$00
					dcb $08,$04,$00
VERT_ENE			dcb $F0,$F8,$00
PROP_ENE			dcb $05,$07,$09,$0B

SUB_GFX_ENE			JSR GET_DRAW_INFO
					LDA $157C,x
					ASL A
					CLC
					ADC $157C,x
					STA $02
					PHX
					LDA $151C,x
					TAX
					LDA PROP_ENE,x
					STA $0F
					LDX #$02
LOOP_ENE			LDA $01
					CLC
					ADC VERT_ENE,x
					STA $0301,y
					LDA TILE_ENE,x
					STA $0302,y
					LDA $0F
					ORA $64
					STA $0303,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_ENE,x
					STA $0300,y
					PLX
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_ENE         ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$02
                    JSL $01B7B3
                    RTS                     ; return


TILEMAP_NI			dcb $A4,$A6,$A8,$C4,$C6,$C8,$E4,$E6,$E8
HORZ_NI				dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
VERT_NI				dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00

SUB_GFX_NIGHT		JSR GET_DRAW_INFO
					LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$08
LOOP_NI				LDA $00
					CLC
					ADC HORZ_NI,x
					STA $0200,y
					LDA $01
					CLC
					ADC VERT_NI,x
					STA $0201,y
					LDA TILEMAP_NI,x
					STA $0202,y
					LDA #$03
					ORA $64
					STA $0203,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_NI          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$08
                    JSL $28FCC0 ;# $200p̃OtBbN[`
                    RTS           

TILEMAP2			dcb $88,$8C,$A6,$A8,$AA,$AC,$AE,$C4,$C6,$C8,$CA,$CC,$E2,$E4,$E8
HORZ_DISP2			dcb $10,$20,$F0,$00,$10,$20,$30,$E0,$F0,$00,$10,$20,$D0,$E0,$00
VERT_DISP2			dcb $F0,$F0,$00,$00,$00,$00,$00,$10,$10,$10,$10,$10,$20,$20,$20

SUB_GFX2			LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$0E
LOOP2_START         LDA $00
					CLC
					ADC HORZ_DISP2,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP2,x
					STA $0301,y
					LDA TILEMAP2,x
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP2_START         ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0E
                    JSL $01B7B3
                    RTS  




TILEMAP             dcb $AA,$8A,$8C,$8E,$88,$AE,$CC,$CE,$EC,$EE,$CA,$EA,$E0,$E0,$E0,$E0,$E0,$E0;#_X
					dcb $0A,$0C,$0C,$0A,$2A,$2C,$2C,$2A,$4A,$4C,$4C,$4A,$6C,$6C,$EA,$E0,$E0,$E0;#Wv
					dcb $00,$02,$00,$20,$20,$22,$22,$40,$40,$60,$42,$42,$60,$62,$62,$EA,$E0,$E0;#
					dcb $04,$06,$24,$26,$44,$46,$48,$64,$08,$28,$EA,$E0,$E0,$E0,$E0,$E0,$E0,$E0;#|[Y
					dcb $84,$86,$A0,$A2,$A4,$A6,$A8,$C0,$C2,$C4,$C6,$E2,$E4,$E6,$E8,$80,$82,$EA;#_bV
					
HORZ_DISP			dcb $00,$F0,$00,$10,$00,$10,$FA,$0A,$FA,$0A,$07,$05,$00,$00,$00,$00,$00,$00
					dcb $E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$F8,$08,$00,$00,$00,$00
					dcb $F0,$00,$10,$F8,$08,$F8,$08,$F8,$08,$E8,$F8,$08,$18,$F8,$08,$00,$00,$00
					dcb $F8,$08,$F8,$08,$F4,$04,$14,$F4,$09,$12,$FC,$00,$00,$00,$00,$00,$00,$00
					dcb $0A,$1A,$E8,$F8,$08,$18,$28,$EA,$FA,$0A,$1A,$F8,$08,$18,$28,$F8,$08,$F5
					
VERT_DISP			dcb $B0,$BA,$C0,$C0,$D0,$D0,$E0,$E0,$F0,$F0,$00,$B2,$00,$00,$00,$00,$00,$00
					dcb $E0,$E0,$E0,$E0,$F0,$F0,$F0,$F0,$00,$00,$00,$00,$10,$10,$D8,$00,$00,$00
					dcb $C0,$C0,$C0,$D0,$D0,$E0,$E0,$F0,$F0,$01,$00,$00,$01,$10,$10,$B8,$00,$00
					dcb $D8,$D8,$E8,$E8,$F8,$F8,$F8,$08,$08,$11,$CC,$00,$00,$00,$00,$00,$00,$00
					dcb $D0,$D0,$E0,$E0,$E0,$E0,$E0,$F0,$F0,$F0,$F0,$00,$00,$05,$00,$10,$10,$DB
					
PROPETIES			dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$00,$40,$40,$00,$00,$40,$40,$00,$00,$40,$40,$00,$40,$00,$00,$00,$00
					dcb $00,$00,$40,$00,$40,$00,$40,$00,$40,$00,$00,$40,$40,$00,$40,$00,$00,$00
					dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
					dcb $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00


SUB_GFX             JSR GET_DRAW_INFO
					LDA $C2,x
					CMP #$05
					BNE SUB_GFX_0
					JSR SUB_GFX2
					RTS
SUB_GFX_0			LDA $157C,x
					STA $03
					LDA $1602,x
					ASL A
					STA $02
					ASL A
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					LDA $151C,x
					STA $0F
					LDA #$40
					TAY
					STA $15EA,x
					PHX
					LDX #$11
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA HORZ_DISP,x
					STA $0E
					LDA $03
					BEQ NO_FLIP1
					LDA $0E
					EOR #$FF
					INC A
					STA $0E
NO_FLIP1			LDA $00
					CLC
					ADC $0E
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA TILEMAP,x
					STA $0302,y
					LDA PROPETIES,x
					ORA $0F
					STA $0303,y
					LDA $03
					BEQ NO_FLIP
					LDA $0303,y
					EOR #$40
					STA $0303,y
NO_FLIP				PLX
					LDA $0F
					CMP #$03
					BEQ NO_PRI
					LDA $0303,y
					ORA $64
					STA $0303,y
NO_PRI				INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$11
                    JSL $01B7B3
                    RTS                     ; return
					
					
VERT_BM				dcb $F0,$00
TILE_BM				dcb $8E,$AE
SUB_GFX_BM			JSR GET_DRAW_INFO
					PHX
					LDX #$01
LOOP_BM				LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_BM,x
					STA $0301,y
					LDA TILE_BM,x
					STA $0302,y
					LDA #$07
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_BM
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS    

					
HORZ_CM				dcb $F8,$00,$F8,$00,$08 ;#
					dcb $F8,$00,$F8,$00,$F8 ;#
					dcb $F8,$00,$F8,$00,$00 ;#
					dcb $F8,$00,$F8,$00,$00 ;#
					dcb $F8,$00,$F8,$00,$00 ;#A
					dcb $F8,$00,$F8,$00,$00 ;#B
					dcb $F8,$00,$F8,$00,$00 ;#X
					dcb $F8,$00,$F8,$00,$00 ;#Y
VERT_CM				dcb $00,$00,$10,$10,$08
					dcb $00,$00,$10,$10,$08
					dcb $00,$00,$10,$10,$10
					dcb $00,$00,$10,$10,$00
					dcb $00,$00,$10,$10,$08
					dcb $00,$00,$10,$10,$08
					dcb $00,$00,$10,$10,$08
					dcb $00,$00,$10,$10,$08
TILE_CM				dcb $80,$80,$A0,$A0,$90
					dcb $80,$80,$A0,$A0,$90
					dcb $80,$80,$A0,$A0,$81
					dcb $80,$80,$A0,$A0,$81
					dcb $82,$82,$A2,$A2,$84
					dcb $82,$82,$A2,$A2,$85
					dcb $82,$82,$A2,$A2,$95
					dcb $82,$82,$A2,$A2,$94
PROP_CM				dcb $0D,$4D,$0D,$4D,$49
					dcb $0D,$4D,$0D,$4D,$09
					dcb $0D,$4D,$0D,$4D,$89
					dcb $0D,$4D,$0D,$4D,$09
					dcb $09,$49,$09,$49,$09
					dcb $05,$45,$05,$45,$05
					dcb $07,$47,$07,$47,$07
					dcb $0B,$4B,$0B,$4B,$0B
SIZE_CM				dcb $02,$02,$02,$02,$00

SUB_GFX_CM			JSR GET_DRAW_INFO
					LDA $151C,x
					STA $02
					LDA $1602,x
					ASL A
					ASL A
					CLC
					ADC $1602,x
					STA $03
					PHX
					LDX #$04
LOOP_CM				PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_CM,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_CM,x
					STA $0301,y
					LDA TILE_CM,x
					STA $0302,y
					LDA PROP_CM,x
					ORA $64
					STA $0303,y
					LDA $02
					BEQ SUB_GFX_CM_2
					LDA $0303,y
					AND #$F0
					ORA #$0F
					STA $0303,y
SUB_GFX_CM_2		PLX
					PHY
					TYA                     ; \ get index to sprite property map ($460)...
					LSR A                   ; |    ...we use the sprite OAM index...
					LSR A                   ; |    ...and divide by 4 because a 16x16 tile is 4 8x8 tiles
					TAY                     ; | 
					LDA SIZE_CM,x
					STA $0460,y            ; /  
					PLY 
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_CM
                    PLX                     ; pull, X = sprite index
                    LDY #$FF              ; \ FF, because we wrote to 460
                    LDA #$04
                    JSL $01B7B3
                    RTS    


TILE_B				dcb $EC,$EE
PROP_B				dcb $05,$07,$09,$0B

SUB_GFX_B			JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					LDA $14
					LSR A
					LSR A
					AND #$01
					TAX
					LDA TILE_B,x
					STA $0302,y
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA PROP_B,x
					ORA $64
					STA $0303,y
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3
                    RTS
					
HOZR_BL				dcb $00,$10,$00,$10
VERT_BL				dcb $00,$00,$10,$10
TILE_BL				dcb $80,$82,$A0,$A2

SUB_GFX_BL			JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_BL				LDA $00
					CLC
					ADC HOZR_BL,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_BL,x
					STA $0301,y
					LDA TILE_BL,x
					STA $0302,y
					LDA #$0F
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_BL
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $01B7B3
                    RTS
					
PROP_STAR			dcb $8D,$0D
VERT_STAR			dcb $00,$10
SUB_GFX_STAR		JSR GET_DRAW_INFO
					PHX
					LDX #$01
LOOP_STAR			LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_STAR,x
					STA $0301,y
					LDA #$C2
					STA $0302,y
					LDA PROP_STAR,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL LOOP_STAR
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$01
                    JSL $01B7B3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS

