;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; , adapted by mikeyk
;;
;; Description: 
;;   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;big boo, boo, boo block
                    ;symbolic names for ram addresses
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATUS   = $14C8
                    SPRITE_STATE    = $C2  
                    SPRITE_OAM      = $15EA
                    SPRITE_DIR      = $157C
                    
                    ;unassigned                  
                    ;$1540  -    shake timer
                    ;$15AC
                    ;$1570
                    ;$1602
                    ;$167A
                    ;$1662
                    ;$1558
                    
                    TILE = $88
EXTRA_BITS = $7FAB10
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT" 
					LDA EXTRA_BITS,x
					AND #$04
					BNE TELEPORT_INI
                    LDA #$05
                    STA $151C,x
                    RTL
TELEPORT_INI		LDA #$87
					STA $167A,x
					RTL
      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TBL_ACCEL_X         dcb $02,$FE
TBL_MAX_SPEED_X     dcb $28,$D8
TBL_ACCEL_Y         dcb $02,$FE
TBL_MAX_SPEED_Y     dcb $18,$E8
T_F8D1              dcb $01,$02,$02,$01



D_CION_CHECK		LDA $010B
					CMP #$D2
					BNE D_COIN_R
					LDA $14E0,x
					BNE D_COIN_R
					LDA $1F38
					AND #$08
					BNE D_COIN_R
					STZ $14C8,x
D_COIN_R			RTS




RETURN				RTS
TELEPORT			JSR D_CION_CHECK
					JSR SUB_GFX2
					LDA $9D
                    BNE RETURN
					JSL $01A7DC
					BCC RETURN
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					RTS



SPRITE_CODE_START   JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA EXTRA_BITS,x
					AND #$04
					BNE TELEPORT
                    LDA #$10
LBL_21              STA $18B6
                    LDA SPRITE_STATUS,x
                    CMP #$08
                    BNE LBL_01
                    LDA $9D
                    BEQ LBL_02
LBL_01
                    JMP LBL_17
LBL_02
                    JSR SUB_HORZ_POS
					TYA
					STA $1528,x
                    LDA SPRITE_STATE,x
                    BEQ LBL_20
                    LDA $0F
                    CLC
                    ADC #$0A
                    CMP #$14
                    BCC LBL_04
LBL_20
                    STZ SPRITE_STATE,x
LBL_03
                    LDA $0F
                    CLC
                    ADC #$0A
                    CMP #$14
                    BCC LBL_04
                    LDA $15AC,x
                    BNE LBL_12
                    TYA
                    CMP SPRITE_DIR,x
                    BEQ LBL_04
                    LDA #$1F
                    STA $15AC,x
                    BRA LBL_12
LBL_04
                    STZ $1602,x
                    LDA SPRITE_STATE,x
                    BEQ LBL_14
                    LDA #$03
                    STA $1602,x
                    LDY $9E,x               
                    LDA #$00
                    INC A
LBL_05
                    AND $13
                    BNE LBL_11
                    INC $1570,x
                    LDA $1570,x
                    BNE LBL_06
                    LDA #$20
                    ;STA $1558,x
LBL_06
                    LDA SPRITE_X_SPEED,x
                    BEQ LBL_08
                    BPL LBL_07
                    INC A
                    INC A
LBL_07
                    DEC A
LBL_08
                    STA SPRITE_X_SPEED,x
                    LDA SPRITE_Y_SPEED,x
                    BEQ LBL_10
                    BPL LBL_09
                    INC A
                    INC A
LBL_09
                    DEC A
LBL_10
                    STA SPRITE_Y_SPEED,x
LBL_11
                    BRA LBL_16
LBL_12
                    CMP #$10
                    BNE LBL_13
                    
LBL_13
                    LSR A
                    LSR A
                    LSR A
                    TAY
                    LDA T_F8D1,y
                    STA $1602,x
LBL_14
                    STZ $1570,x
                    LDA $13
                    AND #$03
                    BNE LBL_16
                    
                    JSR SUB_HORZ_POS
                    LDA SPRITE_X_SPEED,x
                    CMP TBL_MAX_SPEED_X,y
                    BEQ LBL_15
                    CLC
                    ADC TBL_ACCEL_X,y
                    STA SPRITE_X_SPEED,x
LBL_15
                    JSR SUB_VERT_POS     
                    LDA SPRITE_Y_SPEED,x
                    CMP TBL_MAX_SPEED_Y,y
                    BEQ LBL_16
                    CLC
                    ADC TBL_ACCEL_Y,y
                    STA SPRITE_Y_SPEED,x
LBL_16
                    JSL $018022             ;x speed
                    JSL $01801A             ;y speed
LBL_17
                    LDA SPRITE_STATUS,x
                    CMP #$08
                    BNE LBL_19
                    JSL $01A7DC		        ;interact with mario
LBL_19
                    JSR SUB_GFX
                    RTS                             


                 
                    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORIZ_DISP          dcb $F8,$08,$F8,$08,$08,$F8,$08,$F8
VERT_DISP           dcb $F8,$F8,$08,$08
TILEMAP             dcb $C6,$C8,$E6,$E8
PROPERTIES          dcb $0B,$4B


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $1528,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					STA $02
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					

					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    
					LDA $0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
HORIZ_DISP2          dcb $F8,$08,$F8,$08
VERT_DISP2           dcb $F8,$F8,$08,$08
PROPERTIES2          dcb $05,$45,$85,$C5
TILEMAP2			 dcb $EC,$CC,$CE,$CC,$EC,$EA,$C4,$EA


SUB_GFX2             JSR GET_DRAW_INFO

					PHX
					LDA $14
					LSR A
					LSR A
					AND #$07
					TAX
					LDA TILEMAP2,x
					STA $02
					PLX
					
					PHX
                    LDX #$03                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					LDA $02
                    STA $0302,y             ; /
					

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

                    
					LDA PROPERTIES2,x
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00				;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
					LDA $D1					;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
					SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
					SBC $E4,x				;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
					STA $0F					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
					LDA $D2					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
					SBC $14E0,x				;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
					BPL SPR_L16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
					INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
SPR_L16				RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_VERT_POS
; This routine determines if Mario is above or below the sprite.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B829
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_VERT_POS		LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
					LDA $D3                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
					SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
					SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
					STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
					LDA $D4                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
					SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
					BPL SPR_L11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
					INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
SPR_L11				RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

               


                    
