;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bonus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$50
					STA $15AC,x
					STZ $14F8,x
					LDA #$00
					STA $7FFFA1
					STA $7FFFA2
					STA $7FFFA3
					STA $7FFFA4
					STZ $1890
					STZ $14AF
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE       LDA #$C0
					STA $1464
					STZ $AA,x
					STZ $B6,x
					LDA $1528,x
					CMP #$09
					BNE NOT_MODEA
					JSR MODEA
					RTS
NOT_MODEA			JSR DELETE_MARIO
					LDA $1528,x
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$01
					BNE NOT_MODE2
					JSR MODE2
                    RTS
NOT_MODE2			CMP #$02
					BNE NOT_MODE3
					JSR MODE3
                    RTS
NOT_MODE3			CMP #$03
					BNE NOT_MODE4
					JSR MODE4
                    RTS
NOT_MODE4			CMP #$04
					BNE NOT_MODE5
					JSR MODE5
                    RTS
NOT_MODE5			CMP #$05
					BNE NOT_MODE6
					JSR MODE6
                    RTS
NOT_MODE6			CMP #$06
					BNE NOT_MODE7
					JSR MODE7
                    RTS
NOT_MODE7			CMP #$07
					BNE NOT_MODE8
					JSR MODE8
                    RTS
NOT_MODE8			CMP #$08
					BNE NOT_MODE9
					JSR MODE9
                    RTS
NOT_MODE9			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DELETE_MARIO		LDA #$F0
                    STA $18BD
					STZ $97
					STZ $95
					LDA #$80
					STA $96
					STA $94
					STZ $18
					STZ $17
					RTS
					
EXIT_MARIO			LDA #$60
					STA $14AB
					STZ $14C8,x
					RTS
					
MODE1				JSR SUB_GFX
					LDA $7FFFA4
					BNE MODE1_3
					LDA $0016
					AND #$80
					BEQ MODE1_1
					LDA #$01
					STA $7FFFA4
					LDA #$40
					STA $15AC,x
					LDA #$2A
					STA $1DFC
					RTS
MODE1_1				LDA $15AC,x
					BNE MODE1_E
					LDA $1540,x
					BNE MODE1_2
					LDA $0DBF
					AND #$0F
					ASL A
					ASL A
					ASL A
					ASL A
					CLC
					ADC #$02
					STA $1540,x
MODE1_2				CMP #$01
					BNE MODE1_E
					LDA #$25
					STA $1DFC
					LDA #$01
					STA $14AF
					LDA #$01
					STA $1528,x
					STZ $1570,x
MODE1_E				RTS
MODE1_3				LDA $15AC,x
					BNE MODE1_E
					LDA #$80
					STA $15AC,x
					STZ $0DAE
					LDA #$09
					STA $1528,x
					STZ $0DAE
					RTS

MODE2				JSR SUB_GFX
					LDA $0016
					AND #$80
					BNE MODE2_2
					LDA $1570,x
					CMP #$63
					BCS MODE2_2
					INC $1570,x
					LDA $7FFFA2
					CMP #$09
					BEQ MODE2_1
					INC A
					STA $7FFFA2
					RTS
MODE2_1				LDA #$00
					STA $7FFFA2
					LDA $7FFFA3
					INC A
					STA $7FFFA3
					RTS
MODE2_2				STZ $0DAE
					LDA #$70
					STA $15AC,x
					LDA #$02
					STA $1528,x
					STZ $14AF
					STZ $14F8,x
					LDA $1570,x
					CMP #$28   ; LBL1 TIME
					BCC MODE2_3
					LDA #$01
					STA $14F8,x
MODE2_3				STZ $1602,x
					LDA #$27
					STA $1DFC
					RTS

MODE3				LDA #$01
					STA $7FFFA1;
					LDA $15AC,x
					CMP #$50
					BCC MODE3_1
					RTS
MODE3_1				CMP #$00
					BEQ MODE3_2
					JSR SUB_GFX2
					LDA #$0F
					STA $0DAE
					RTS
MODE3_2				INC $1602,x
					LDA $1602,x
					CMP #$30
					BCC MODE3_4
					LDA #$80
					STA $15AC,x
					STZ $0DAE
					LDA #$00
					STA $7FFFA1
					STA $7FFFA2
					STA $7FFFA3
					LDA $14F8,x
					BEQ MODE3_3
					LDA #$09
					STA $1528,x
					RTS
MODE3_3				LDA #$03
					STA $1528,x
					INC $1890
					RTS
MODE3_4				JSR SUB_GFX2
					RTS

MODE4				LDA $15AC,x
					CMP #$60
					BCC MODE4_0
					RTS
MODE4_0				JSR SUB_GFX3
					LDA #$0F
					STA $0DAE
					LDA $7FFFA4
					BNE MODE4_3
					LDA $0016
					AND #$80
					BEQ MODE4_1
					LDA #$01
					STA $7FFFA4
					LDA #$40
					STA $15AC,x
					LDA #$2A
					STA $1DFC
					RTS
MODE4_1				LDA $15AC,x
					BNE MODE4_E
					LDA $1540,x
					BNE MODE4_2
					LDA $0DBF
					AND #$F0
					CLC
					ADC #$02
					STA $1540,x
MODE4_2				CMP #$01
					BNE MODE4_E
					LDA #$25
					STA $1DFC
					LDA #$01
					STA $14AF
					LDA #$04
					STA $1528,x
					STZ $1570,x
MODE4_E				RTS
MODE4_3				LDA $15AC,x
					BNE MODE4_E
					LDA #$80
					STA $15AC,x
					LDA #$09
					STA $1528,x
					STZ $0DAE
					RTS

MODE5				JSR SUB_GFX3
					LDA $0016
					AND #$80
					BNE MODE5_2
					LDA $1570,x
					CMP #$63
					BCS MODE5_2
					INC $1570,x
					LDA $7FFFA2
					CMP #$09
					BEQ MODE5_1
					INC A
					STA $7FFFA2
					RTS
MODE5_1				LDA #$00
					STA $7FFFA2
					LDA $7FFFA3
					INC A
					STA $7FFFA3
					RTS
MODE5_2				STZ $0DAE
					LDA #$70
					STA $15AC,x
					LDA #$05
					STA $1528,x
					STZ $14AF
					STZ $14F8,x
					LDA $1570,x
					CMP #$1E   ; LBL2 TIME
					BCC MODE5_3
					LDA #$01
					STA $14F8,x
MODE5_3				STZ $1602,x
					LDA #$27
					STA $1DFC
					RTS
					
MODE6				LDA #$01
					STA $7FFFA1;
					LDA $15AC,x
					CMP #$50
					BCC MODE6_1
					RTS
MODE6_1				CMP #$00
					BEQ MODE6_2
					JSR SUB_GFX4
					LDA #$0F
					STA $0DAE
					RTS
MODE6_2				INC $1602,x
					LDA $1602,x
					CMP #$30
					BCC MODE6_4
					LDA #$80
					STA $15AC,x
					STZ $0DAE
					LDA #$00
					STA $7FFFA1
					STA $7FFFA2
					STA $7FFFA3
					LDA $14F8,x
					BEQ MODE6_3
					LDA #$09
					STA $1528,x
					RTS
MODE6_3				LDA #$06
					STA $1528,x
					LDA #$03
					STA $1890
					RTS
MODE6_4				JSR SUB_GFX4
					RTS



MODE7				LDA $15AC,x
					CMP #$60
					BCC MODE7_0
					RTS
MODE7_0				JSR SUB_GFX5
					LDA #$0F
					STA $0DAE
					LDA $7FFFA4
					BNE MODE7_3
					LDA $0016
					AND #$80
					BEQ MODE7_1
					LDA #$01
					STA $7FFFA4
					LDA #$40
					STA $15AC,x
					LDA #$2A
					STA $1DFC
					RTS
MODE7_1				LDA $15AC,x
					BNE MODE7_E
					LDA $1540,x
					BNE MODE7_2
					LDA $0F34
					AND #$F0
					CLC
					ADC #$02
					STA $1540,x
MODE7_2				CMP #$01
					BNE MODE7_E
					LDA #$25
					STA $1DFC
					LDA #$01
					STA $14AF
					LDA #$07
					STA $1528,x
					STZ $1570,x
MODE7_E				RTS
MODE7_3				LDA $15AC,x
					BNE MODE7_E
					LDA #$80
					STA $15AC,x
					LDA #$09
					STA $1528,x
					STZ $0DAE
					RTS

MODE8				JSR SUB_GFX5
					LDA $0016
					AND #$80
					BNE MODE8_2
					LDA $1570,x
					CMP #$63
					BCS MODE8_2
					INC $1570,x
					LDA $7FFFA2
					CMP #$09
					BEQ MODE8_1
					INC A
					STA $7FFFA2
					RTS
MODE8_1				LDA #$00
					STA $7FFFA2
					LDA $7FFFA3
					INC A
					STA $7FFFA3
					RTS
MODE8_2				STZ $0DAE
					LDA #$70
					STA $15AC,x
					LDA #$08
					STA $1528,x
					STZ $14AF
					STZ $14F8,x
					LDA $1570,x
					CMP #$14   ; LBL3 TIME
					BCC MODE8_3
					LDA #$01
					STA $14F8,x
MODE8_3				STZ $1602,x
					LDA #$27
					STA $1DFC
					RTS
					
MODE9				LDA #$01
					STA $7FFFA1;
					LDA $15AC,x
					CMP #$50
					BCC MODE9_1
					RTS
MODE9_1				CMP #$00
					BEQ MODE9_2
					JSR SUB_GFX6
					LDA #$0F
					STA $0DAE
					RTS
MODE9_2				INC $1602,x
					LDA $1602,x
					CMP #$30
					BCC MODE9_4
					LDA #$80
					STA $15AC,x
					STZ $0DAE
					LDA #$09
					STA $1528,x
					LDA #$00
					STA $7FFFA1
					STA $7FFFA2
					STA $7FFFA3
					LDA $14F8,x
					BNE MODE9_3
					LDA #$05
					STA $1890
MODE9_3				RTS
MODE9_4				JSR SUB_GFX6
					RTS
					
					
MODEA				LDA $15AC,x
					CMP #$60
					BCC MODEA_1
					LDA #$80 
					STA $94
					STZ $95
					LDA #$70
					STA $96
					LDA $187A
					BEQ NO_YOSHI
					LDA #$60 
					STA $96
NO_YOSHI			LDA #$01
					STA $97
					STZ $18BD
					RTS
MODEA_1				LDA #$0F
					STA $0DAE
					LDA $1890
					BEQ MODEA_2
					LDA $15AC,x
					CMP #$40
					BCS MODEA_3
					JSR UP_GEN
					DEC $1890
					LDA #$60
					STA $15AC,x
MODEA_3				RTS
MODEA_2				JSR UP_CHECK
					TYA
					BEQ MODEA_4
					RTS
MODEA_4				LDA #$60
					STA $14AB
					STZ $14C8,x
					RTS
					

UP_CHECK            PHX
                    LDX #$09
UP_LOOP1            LDA $14C8,x
					BEQ UP_LOOP3
                    LDA $009E,x
					CMP #$78
                    BNE UP_LOOP3
					LDA #$01
					TAY
UP_LOOP3            DEX
                    BPL UP_LOOP1
                    PLX
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
UP_GEN			    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$78
                    STA $009E,y

                    LDA #$18
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

                    LDA #$F0                ;  |
                    STA $00D8,y             ;  |
                    LDA #$00               ;  |
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
					STZ $B6,x
                    PLX
                    LDA #$02
					STA $1DFC
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$A0,$82,$A2
HORIZ_DISP          dcb $40,$40,$A0,$A0
VERT_DISP           dcb $B2,$C2,$B1,$C1
PALLET				dcb $01,$01,$0B,$0B

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                    PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    LDA PALLET,x
					STA $02				
					LDA HORIZ_DISP,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP2            dcb $80,$A6,$86,$82,$A4,$84
HORIZ_DISP2         dcb $A0,$A0,$B0,$40,$40,$30
VERT_DISP2          dcb $B2,$C2,$C2,$B2,$C2,$C2
PALLET2				dcb $01,$01,$01,$0B,$0B,$0B

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
					LDA $14F8,x
					BEQ GFX2_2
					LDA $1602,x
					CMP #$10
					BCC GFX2_01
					LDA #$10
GFX2_01				STA $03
					STZ $0F
					BRA GFX2_3
GFX2_2				LDA $1602,x
					CMP #$10
					BCC GFX2_02
					LDA #$10
GFX2_02				STA $0F
					STZ $03
GFX2_3              PHX                     ; push sprite index
                    LDX #$05                ; loop counter = (number of tiles per frame) - 1
LOOP_START2         PHX                     ; push current tile number
                    LDA PALLET2,x
					STA $02				
					LDA HORIZ_DISP2,x         ;  |
					CPX #$00
					BNE LOOP2_2
					CLC
					ADC $03
					BRA LOOP2_3
LOOP2_2				CPX #$03
					BNE LOOP2_3
					SEC
					SBC $0F
LOOP2_3             STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP2,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP2,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$05                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP3            dcb $80,$A0,$88,$A8,$84
HORIZ_DISP3         dcb $40,$40,$9A,$A0,$90
VERT_DISP3          dcb $B2,$C2,$B6,$C0,$C6
PALLET3				dcb $01,$01,$0B,$0B,$0B

SUB_GFX3            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                    PHX                     ; push sprite index

                    LDX #$04                ; loop counter = (number of tiles per frame) - 1
LOOP_START3         PHX                     ; push current tile number
                    LDA PALLET3,x
					STA $02				
					LDA HORIZ_DISP3,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP3,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP3,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP4            dcb $80,$A6,$86,$88,$AA,$AC,$8C,$8A
HORIZ_DISP4         dcb $A0,$A0,$B0,$40,$40,$50,$48,$58
VERT_DISP4          dcb $B2,$C2,$C2,$B4,$C2,$C2,$B2,$B2
PALLET4				dcb $01,$01,$01,$0B,$0B,$0B,$0B,$0B

SUB_GFX4            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
					LDA $14F8,x
					BEQ GFX4_2
					LDA $1602,x
					CMP #$10
					BCC GFX4_01
					LDA #$10
GFX4_01				STA $03
					STZ $0F
					BRA GFX4_3
GFX4_2				LDA $1602,x
					CMP #$10
					BCC GFX4_02
					LDA #$10
GFX4_02				STA $0F
					STZ $03
GFX4_3              PHX                     ; push sprite index
                    LDX #$07                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         PHX                     ; push current tile number
                    LDA PALLET4,x
					STA $02				
					LDA HORIZ_DISP4,x         ;  |
					CPX #$00
					BNE LOOP4_2
					CLC
					ADC $03
					BRA LOOP4_3
LOOP4_2				CPX #$03
					BNE LOOP4_3
					SEC
					SBC $0F
LOOP4_3             STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP4,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP4,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$07                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP5            dcb $80,$A0,$E4,$E6,$C0,$C2,$E0,$E2,$84
HORIZ_DISP5         dcb $40,$40,$A0,$B0,$A0,$B0,$A0,$B0,$92
VERT_DISP5          dcb $B2,$C2,$A0,$A0,$B0,$B0,$C0,$C0,$BE
PALLET5				dcb $01,$01,$0F,$0F,$0F,$0F,$0F,$0F,$0D

SUB_GFX5            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                 
                    PHX                     ; push sprite index

                    LDX #$08                ; loop counter = (number of tiles per frame) - 1
LOOP_START5         PHX                     ; push current tile number
                    LDA PALLET5,x
					STA $02				
					LDA HORIZ_DISP5,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP5,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP5,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START5          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$08                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP6            dcb $80,$A6,$86,$EC,$EE,$C8,$CA,$E8,$EA,$84
HORIZ_DISP6         dcb $A0,$A0,$B0,$40,$50,$40,$50,$40,$50,$34
VERT_DISP6          dcb $B2,$C2,$C2,$A0,$A0,$B0,$B0,$C0,$C0,$BE
PALLET6				dcb $01,$01,$01,$0F,$0F,$0F,$0F,$0F,$0F,$0D

SUB_GFX6            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
					LDA $14F8,x
					BEQ GFX6_2
					LDA $1602,x
					CMP #$10
					BCC GFX6_01
					LDA #$10
GFX6_01				STA $03
					STZ $0F
					BRA GFX6_3
GFX6_2				LDA $1602,x
					CMP #$10
					BCC GFX6_02
					LDA #$10
GFX6_02				STA $0F
					STZ $03
GFX6_3              PHX                     ; push sprite index
                    LDX #$09                ; loop counter = (number of tiles per frame) - 1
LOOP_START6         PHX                     ; push current tile number
                    LDA PALLET6,x
					STA $02				
					LDA HORIZ_DISP6,x         ;  |
					CPX #$00
					BNE LOOP6_2
					CLC
					ADC $03
					BRA LOOP6_3
LOOP6_2				CPX #$03
					BEQ LOOP6_4
					CPX #$04
					BEQ LOOP6_4
					CPX #$05
					BEQ LOOP6_4
					CPX #$06
					BEQ LOOP6_4
					BRA LOOP6_3
LOOP6_4				SEC
					SBC $0F
LOOP6_3             STA $0300,y             ; /   set x position of the tile
                    
                    LDA VERT_DISP6,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
					
					LDA TILEMAP6,x         ;  |
                    STA $0302,y  
                    
                    PHX
                    LDA #$00
                    LDX $15E9               ;  |
                    ORA $02              ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START6          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$09                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /





