;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $C2,x
					STZ $157C,x
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS                    
START_HB_CODE
		STZ $7B
		STZ $7D
		LDA $C2,x
		CMP #$06
		BNE MAIN2
		JSR LAST_CHECK
		RTS
MAIN2	CMP #$07
		BNE MAIN3
		JSR SOMEUP
		RTS
MAIN3
		JSR TRIGER_CHECK
		JSR STOP_CHECK
		JSR MOVE_CHECK
		JSR HDMA
		RTS

SOMEUP	LDA $15AC,x
		BNE SOMEUP_E
		LDA $157C,x
		BEQ TELEPORT
		LDA #$05
		STA $1DFC
		LDA $0DB4
		CMP #$63
		BEQ SOMEUP2
		INC $0DB4
		INC $0DBE
SOMEUP2	DEC $157C,x
		LDA #$20
		STA $15AC,x
SOMEUP_E RTS
TELEPORT	
		LDA #$06
		STA $71
		STZ $89
		STZ $88
		RTS
		
LAST_CHECK
		INC $C2,x
		LDA #$20
		STA $15AC,x
		LDY #$00
		LDA $1570,x
		STA $1602,x
		CMP #$80
		BNE LAST2
		STZ $1602,x
LAST2	LDA $151C,x
		STA $1528,x
		CMP #$80
		BNE LAST3
		STZ $1528,x
LAST3	LDA $1528,x
		CMP $1602,x
		BEQ LAST4
		LDY #$01
LAST4	LDA $1504,x
		STA $1528,x
		CMP #$80
		BNE LAST5
		STZ $1528,x
LAST5	LDA $1528,x
		CMP $1602,x
		BEQ LAST6
		LDY #$01
LAST6	CPY #$01
		BEQ LAST_E
		LDA $1602,x
		CMP #$00
		BNE LAST7
		LDA #$02
		STA $157C,x
		RTS
LAST7	CMP #$40
		BNE LAST8
		LDA #$03
		STA $157C,x
		RTS
LAST8	LDA #$05
		STA $157C,x
LAST_E	RTS
		


		
MOVE_CHECK	
		LDA $C2,x
		CMP #$02
		BCS MOVE2
		INC $1570,x
		INC $1570,x
MOVE2	LDA $C2,x
		CMP #$04
		BCS MOVE3
		DEC $151C,x
		DEC $151C,x
MOVE3	LDA $C2,x
		CMP #$06
		BCS MOVE4
		INC $1504,x
		INC $1504,x
		INC $1504,x
		INC $1504,x
MOVE4	RTS
		
TRIGER_CHECK
		LDA $C2,x
		BEQ TRIGER_1
		CMP #$02
		BEQ TRIGER_1
		CMP #$04
		BEQ TRIGER_1
TRIGER_E RTS
TRIGER_1 LDA $15AC,x
		BNE TRIGER_E
		LDA $16
		AND #$80
		BEQ TRIGER_E
		LDA #$01
		STA $1DFC
		INC $C2,x
		LDA #$40
		STA $15AC,x
		RTS

		
STOP_CHECK
		LDA $C2,x
		CMP #$01
		BEQ STOP1
		CMP #$03
		BEQ STOP2
		CMP #$05
		BEQ STOP3
STOP_E	RTS
STOP1	LDA $15AC,x
		BNE STOP_E
		LDA $1570,x
		AND #$3F
		BNE STOP_E
		INC $C2,x
		RTS
STOP2	LDA $15AC,x
		BNE STOP_E
		LDA $151C,x
		AND #$3F
		BNE STOP_E
		INC $C2,x
		RTS
STOP3	LDA $15AC,x
		BNE STOP_E
		LDA $1504,x
		AND #$3F
		BNE STOP_E
		INC $C2,x
		RTS

HDMA
		LDA $7FFB18
		BNE LBL1
		LDA #$08
		STA $7FFB18
		LDA #$02
		STA $7FFB19
		LDA #$0F
		STA $7FFB1A
		LDA #$00
		STA $7FFB1B
		LDA #$F0
		STA $7FFB1C
		LDA #$7F
		STA $7FFB1D
LBL1	LDA #$78
		STA $7FF000
		LDA $1570,x
		STA $7FF001
		LDA #$00
		STA $7FF002
		LDA #$18
		STA $7FF003
		LDA $151C,x
		STA $7FF004
		LDA #$00
		STA $7FF005
		LDA #$40
		STA $7FF006
		LDA $1504,x
		STA $7FF007
		LDA #$00
		STA $7FF008
		STA $7FF009
		RTS
