;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Yellow Devil mk2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					EXTRA_BITS = $7FAB10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$60
					STA $15AC,x
					LDA $D8,x
					ORA #$09
					STA $D8,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN              RTS                    
START_HB_CODE       LDA $1504,x
					CMP #$01
					BNE MAIN1
					JSR BLOCK
					RTS
MAIN1				CMP #$02
					BNE MAIN2
					JSR ENE
					RTS
MAIN2				CMP #$03
					BNE MAIN4
					JSR BLOCK2
					RTS
MAIN4				LDA $C2,x
					BEQ MAIN3
					CMP #$02
					BEQ MAIN3
					CMP #$04
					BEQ MAIN3
					CMP #$05
					BEQ MAIN3
					JSR SUB_GFXB             ; draw hammer bro gfx
MAIN3				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					LDA #$07
					STA $1662,x
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
RETURN2             RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			JSR MODE5
					RTS

Y_POS1			dcb $50,$30,$60,$40,$60,$30,$50,$70,$70,$60,$40,$30,$40,$50,$40,$60,$30,$30,$70,$50,$60,$40,$70,$50
X_POS1			dcb $E0,$E0,$E0,$E0,$D0,$D0,$D0,$E0,$D0,$C0,$D0,$C0,$C0,$C0,$B0,$B0,$B0,$A0,$B0,$B0,$A0,$A0,$A0,$A0
BLOCK1			dcb $64,$44,$74,$54,$73,$43,$63,$56,$55,$72,$53,$42,$52,$62,$51,$71,$41,$40,$46,$61,$70,$50,$45,$60
MODE0				LDA $15AC,x
					BNE RETURN2
					LDA $1570,x
					CMP #$18
					BCS MODE0_2
					JSR GEN_SPRITE
					PHX
					LDA $1570,x
					TAX
					LDA Y_POS1,x
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$00
					STA $00E4,y
					STA $14E0,y
					LDA X_POS1,x
					STA $151C,y
					LDA BLOCK1,x
					STA $1528,y
					LDA #$01
					STA $1504,y
					LDA #$30
					STA $00B6,y
					PLX
					INC $1570,x
					LDA #$20
					STA $15AC,x
MODE0_R				RTS
MODE0_2				LDA $1570,x
					CMP #$19
					BEQ MODE0_3
					INC $1570,x
					LDA #$40
					STA $15AC,x
					RTS
MODE0_3				LDA #$01
					STA $C2,x
					LDA #$80
					STA $15AC,x
					LDA #$8E
					STA $1602,x
					RTS
MODE1				JSR DAMAGE_CHECK
					JSR BLK_CHECK
					LDA $15AC,x
					BEQ MODE1_3
					CMP #$70
					BEQ MODE1_2
					CMP #$50
					BEQ MODE1_2
					CMP #$30
					BEQ MODE1_2
					CMP #$10
					BEQ MODE1_2
					RTS
MODE1_3				STZ $1570,x
					LDA #$02
					STA $C2,x
					LDA #$20
					STA $15AC,x
					RTS
MODE1_2				JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$AE
					STA $1602,y
					JSR SPEED_DEC1
					RTS
					
Y_POS2			dcb $50,$30,$60,$40,$60,$30,$50,$70,$70,$60,$40,$30,$40,$50,$40,$60,$30,$30,$70,$50,$60,$40,$70,$50
X_POS2			dcb $A0,$A0,$A0,$A0,$B0,$B0,$B0,$A0,$B0,$C0,$B0,$C0,$C0,$C0,$D0,$D0,$D0,$E0,$D0,$D0,$E0,$E0,$E0,$E0
BLOCK2			dcb $6B,$4B,$7B,$5B,$7C,$4C,$6C,$59,$5A,$7D,$5C,$4D,$5D,$6D,$5E,$7E,$4E,$4F,$49,$6E,$7F,$5F,$4A,$6F
MODE2				LDA $15AC,x
					BNE MODE2_R
					LDA $1570,x
					CMP #$18
					BCS MODE2_2
					JSR GEN_SPRITE
					PHX
					LDA $1570,x
					TAX
					LDA Y_POS2,x
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA #$00
					STA $00E4,y
					STA $14E0,y
					LDA X_POS2,x
					STA $00E4,y
					SEC
					SBC #$90
					STA $151C,y
					LDA BLOCK2,x
					STA $1528,y
					LDA #$01
					STA $1504,y
					LDA #$D0
					STA $00B6,y
					LDA #$10
					STA $15AC,y
					CPX #$17
					BNE MODE2_1
					LDA X_POS2,x
					STA $7FFC01
					LDA Y_POS2,x
					STA $7FFC02
					JSR GEN_NORMAL
MODE2_1				PLX
					INC $1570,x
					LDA #$20
					STA $15AC,x
MODE2_R				RTS
MODE2_2				LDA $1570,x
					CMP #$19
					BEQ MODE2_3
					INC $1570,x
					LDA #$40
					STA $15AC,x
					RTS
MODE2_3				LDA #$03
					STA $C2,x
					LDA #$80
					STA $15AC,x
					LDA #$8E
					STA $1602,x
					LDA #$30
					STA $E4,x
					LDA #$01
					STA $157C,x
					RTS
					
MODE3				JSR DAMAGE_CHECK2
					JSR BLK_CHECK2
					LDA $15AC,x
					BEQ MODE3_3
					CMP #$70
					BEQ MODE3_2
					CMP #$50
					BEQ MODE3_2
					CMP #$30
					BEQ MODE3_2
					CMP #$10
					BEQ MODE3_2
					RTS
MODE3_3				STZ $1570,x
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE3_2				JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$AE
					STA $1602,y
					JSR SPEED_DEC1
					RTS
					
MODE4_1				LDA #$01
					STA $C2,x
					LDA #$80
					STA $15AC,x
					LDA #$8E
					STA $1602,x
					LDA #$C0
					STA $E4,x
					STZ $157C,x
					RTS
MODE4				LDA $1540,x
					CMP #$01
					BEQ MODE4_1
					LDA $15AC,x
					CMP #$01
					BEQ MODE4_0
					CMP #$F0
					BEQ MODE4_2
					CMP #$D0
					BEQ MODE4_3
					CMP #$B0
					BEQ MODE4_4
					CMP #$90
					BEQ MODE4_5
					CMP #$70
					BEQ MODE4_6
					RTS
MODE4_0				LDA #$60
					STA $1540,x
					RTS
MODE4_2				LDA #$50
					STA $E4,x
					JSR MODE4_SUB
					LDA #$E0
					STA $151C,y
					LDA #$10
					STA $00B6,y
					LDA #$30
					STA $E4,x
					LDA #$39
					STA $D8,x
					RTS
MODE4_3				LDA #$40
					STA $E4,x
					JSR MODE4_SUB
					LDA #$D0
					STA $151C,y
					LDA #$10
					STA $00B6,y
					LDA #$30
					STA $E4,x
					LDA #$39
					STA $D8,x
					RTS
MODE4_4				LDA #$30
					STA $E4,x
					JSR MODE4_SUB
					LDA #$C0
					STA $151C,y
					LDA #$10
					STA $00B6,y
					LDA #$30
					STA $E4,x
					LDA #$39
					STA $D8,x
					RTS
MODE4_5				LDA #$20
					STA $E4,x
					JSR MODE4_SUB
					LDA #$B0
					STA $151C,y
					LDA #$10
					STA $00B6,y
					LDA #$30
					STA $E4,x
					LDA #$39
					STA $D8,x
					RTS
MODE4_6				LDA #$10
					STA $E4,x
					JSR MODE4_SUB
					LDA #$A0
					STA $151C,y
					LDA #$10
					STA $00B6,y
					LDA #$30
					STA $E4,x
					LDA #$39
					STA $D8,x
					LDA #$10
					STA $7FFC01
					LDA #$70
					STA $7FFC02
					JSR GEN_NORMAL
					RTS
MODE5				LDA $15AC,x
					BNE MODE5_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
MODE5_R				RTS
					
MODE4_SUB			LDA #$30
					STA $D8,x
					JSR BLOCK_RESET
					LDA #$40
					STA $D8,x
					JSR BLOCK_RESET
					LDA #$50
					STA $D8,x
					JSR BLOCK_RESET
					LDA #$60
					STA $D8,x
					JSR BLOCK_RESET
					LDA #$70
					STA $D8,x
					JSR BLOCK_RESET
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$10
					STA $1528,y
					LDA #$19
					STA $1686,y
					RTS
					
DAMAGE_CHECK		LDA $E4,x
					PHA
					LDA $D8,x
					PHA
					LDA #$B0
					STA $E4,x
					LDA #$40
					STA $D8,x
					JSL $01A7DC
					PLA
					STA $D8,x
					PLA
					STA $E4,x
					RTS
DAMAGE_CHECK2		LDA $E4,x
					PHA
					LDA $D8,x
					PHA
					LDA #$10
					STA $E4,x
					LDA #$40
					STA $D8,x
					JSL $01A7DC
					PLA
					STA $D8,x
					PLA
					STA $E4,x
					RTS

BLOCK_IMG			dcb $CE,$EA,$EC,$EE

BLOCK				JSR SUB_GFXB             ; draw hammer bro gfx
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURNB              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURNB
					LDA $15AC,x
					BNE BLOCK_START
					STZ $AA,x
					JSL $01802A
					JSL $01A7DC
					LDA $1540,x
					BNE BLOCK_END2
					LDA $E4,x
					AND #$FC
					CMP $151C,x
					BEQ BLOCK_END
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					TAY
					LDA BLOCK_IMG,y
					STA $1602,x
RETURNB				RTS
BLOCK_START			LDA $15AC,x
					CMP #$0F
					BEQ BLOCK_START3
					CMP #$08
					BCC BLOCK_START2
					LDA #$CA
					STA $1602,x
					RTS
BLOCK_START2		LDA #$CC
					STA $1602,x
					RTS
BLOCK_END			LDA $151C,x
					STA $E4,x
					LDA #$18
					STA $1540,x
					STZ $B6,x
					RTS
BLOCK_END2			LDA $1540,x
					CMP #$10
					BCS RETURNB
					CMP #$08
					BCC BLOCK_END3
					LDA #$CC
					STA $1602,x
					RTS
BLOCK_END3			CMP #$01
					BEQ BLOCK_END4
					LDA #$CA
					STA $1602,x
					RTS
BLOCK_END4			JSR GEN_BLK1
					STZ $14C8,x
					RTS
BLOCK_START3		JSR BLOCK_RESET
					RTS
					
BLOCK2				JSR SUB_GFXB2
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURNB2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURNB2
					LDA $C2,x
					BNE BLOCK2_7
					LDA $1528,x
					BEQ BLOCK2_4
					LDA #$CE
					STA $1602,x
					LDA $1528,x
					BEQ BLOCK2_2
					CMP #$08
					BCC BLOCK2_3
					LDA #$CA
					STA $1602,x
					BRA BLOCK2_2
BLOCK2_3			LDA #$CC
					STA $1602,x
BLOCK2_2			JSL $01A7DC
					DEC $1528,x
RETURNB2			RTS
BLOCK2_4			JSL $01A7DC
					LDA $15AC,x
					BEQ BLOCK2_5
					LDA #$CE
					STA $1602,x
					LDA $1540,x
					BEQ RETURNB2
					CMP #$08
					BCC BLOCK2_6
					LDA #$CA
					STA $1602,x
					RTS
BLOCK2_6			LDA #$CC
					STA $1602,x
					RTS
BLOCK2_5			LDA $E4,x
					CMP $151C,x
					BCS BLOCK2_7
					INC $1570,x
					LDA $1570,x
					LSR A
					LSR A
					LSR A
					AND #$03
					TAY
					LDA BLOCK_IMG,y
					STA $1602,x
					JSL $01802A
					LDA #$10
					STA $1540,x
					LDA $1588,x
					AND #$04
					BEQ RETURNB2
					LDA #$B0
					STA $AA,x
					RTS
BLOCK2_7			LDA #$01
					STA $C2,x
					LDA $151C,x
					STA $E4,x
					LDA #$30
					STA $D8,x
					LDA $1528,x
					CMP #$11
					BEQ BLOCK2_9
					INC $1528,x
					LDA $1528,x
					CMP #$08
					BCC BLOCK2_8
					LDA #$CA
					STA $1602,x
					RTS
BLOCK2_8			LDA #$CC
					STA $1602,x
					RTS
BLOCK2_9			STZ $14C8,x
					LDA $151C,x
					CMP #$E0
					BNE BLOCK2_9_1
					JSR GEN_BLK3
					RTS
BLOCK2_9_1			LDA $151C,x
					CMP #$D0
					BNE BLOCK2_9_2
					JSR GEN_BLK4
					RTS
BLOCK2_9_2			LDA $151C,x
					CMP #$C0
					BNE BLOCK2_9_3
					JSR GEN_BLK5
					RTS
BLOCK2_9_3			LDA $151C,x
					CMP #$B0
					BNE BLOCK2_9_4
					JSR GEN_BLK6
					RTS
BLOCK2_9_4			JSR GEN_BLK7
					RTS


ENE					JSR SUB_GFXB
					LDA $9D
					BNE RETURNE
					LDA $AA,x
					PHA
					JSL $01802A
					JSL $01A7DC
					PLA
					STA $AA,x
					LDA $14E0,x
					BNE RETURN_E
RETURNE				RTS
RETURN_E			STZ $14C8,x
					RTS

BLOCK_RESET			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP
					REP #$30
					LDA.W #$0025
					STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK1			LDA $E4,x
					STA $9A
					LDA $14E0,x
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					LDA $1528,x
					STA $03
					LDA #$0D
					STA $04
					PHP
					REP #$30
					LDA.W $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK2			LDA $E4,x
					CLC
					ADC #$10
					AND #$F0
					STA $9A
					LDA $14E0,x
					ADC #$00
					STA $9B
					LDA $D8,x
					STA $98
					LDA $14D4,x
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0BCC
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
GEN_BLK3			LDA #$E0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$30
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D44
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D54
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D64
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D74
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D56
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK4			LDA #$D0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$30
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D43
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D53
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D63
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D73
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D55
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK5			LDA #$C0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$30
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D42
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D52
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D62
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D72
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK6			LDA #$B0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$30
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D41
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D51
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D61
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D71
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D46
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
GEN_BLK7			LDA #$A0
					STA $9A
					LDA #$00
					STA $9B
					LDA #$30
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D40
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D50
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D60
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D70
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $98
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D45
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURNK68           RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
					LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x               ;\ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURNK67           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK67            ; / after: Y has index of sprite being generated

                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$53
                    STA $009E,y
                    
                    LDA $7FFC01
                    STA $00E4,y
                    LDA #$00
                    STA $14E0,y             ; /

                    LDA $7FFC02
					STA $00D8,y             ;  |
                    LDA #$01
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
					LDA #$F0
					STA $1540,y
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


										
SUB_GFXB            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					LDA $1602,x
                    STA $0302,y             ; /
					LDA $01
					STA $0301,y
					LDA $00                 ; \ 
                    STA $0300,y             ; /
					LDA #$0F             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					LDA $157C,x
					BEQ SUB_GFXB_2
					LDA #$4F            
                    ORA $64                 ;  | put in level properties
                    STA $0303,y 
SUB_GFXB_2          LDY #$02                ; \ 02, because we didn't write to 460 yet
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen   
                    RTS                
					


SUB_GFXB2           JSR GET_DRAW_INFO
					LDA $1602,x
					STA $03
					LDA $1528,x
					STA $02
					LDA #$00
					STA $7FFC00
					LDA $C2,x
					BNE SUB_GFXB3
					PHX
                    LDX #$04                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC $7FFC00
                    STA $0301,y             ; /
					
					LDA $03
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
					LDA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					LDA $7FFC00
					SEC
					SBC $02
					STA $7FFC00
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS      
SUB_GFXB3			PHX
                    LDX #$04                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START2          LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC $7FFC00
                    STA $0301,y             ; /
					
					LDA $03
                    STA $0302,y             ; /

                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    STA $0300,y             ; /
                    
					LDA #$0F
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
					LDA $7FFC00
					CLC
					ADC $02
					STA $7FFC00
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START2

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS      
					
Y_MAGIC             dcb $30,$30,$18,$18,$D0,$D0,$E8,$E8
X_MAGIC             dcb $30,$D0,$40,$C0
SPEED_DEC1			LDA $1602,x 
					PHA
					LDA $1504,x
					PHA
					PHY
					JSR SUB_GET_X_DIFF
					JSR SUB_GET_Y_DIFF
					PLY
					PHX                     ; \ set y speed of fire ball
                    LDA $1602,x             ;  |
                    ASL A                   ;  |
                    ASL A                   ;  |
                    ORA $1504,x             ;  |
                    TAX                     ;  |
                    LDA Y_MAGIC,x            ;  |
                    STA $00AA,y
                    PLX                     ; /     
                    PHX                     ; \  set x speed of fire ball
                    LDA $1504,x             ;  |
                    TAX                     ;  |
                    LDA X_MAGIC,x            ;  |
                    STA $00B6,y
                    PLX
					PLA
					STA $1504,x
					PLA
					STA $1602,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in y position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GET_Y_DIFF      LDY #$00                
                    LDA $D3                 
                    PHA
                    CLC                     
                    ADC #$10                
                    STA $D3                 
                    LDA $D4                 
                    PHA
                    ADC #$00                
                    STA $D4                 

                    LDA $D3                 
                    SEC                     
                    SBC $D8,x               
                    STA $0E                 
                    LDA $D4                 
                    SBC $14D4,x             
                    BPL LABEL14            
                    INY                     
LABEL14             TYA                     ;  | 
                    STA $1602,x 
                    
                    PLA
                    STA $D4
                    PLA
                    STA $D3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; difference in x position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   

SUB_GET_X_DIFF      LDY #$00                
                    LDA $D1                 
                    SEC                    
                    SBC $E4,x              
                    STA $0F                 
                    LDA $D2                 
                    SBC $14E0,x            
                    BPL TO_RIGHT            
TO_LEFT             INY                     
                    LDA $0F
                    CMP #$B0
                    BCS SET_VAL
                    INY
                    INY                 
                    BRA SET_VAL
TO_RIGHT            LDA $0F
                    CMP #$50
                    BCC SET_VAL
                    INY
                    INY 
SET_VAL             TYA
                    STA $1504,x
                    RTS
					

CHECK1_R			RTS
BLK_CHECK			TXY
					PHX
					LDX #$00
CHECK1_L			LDA $9E,x
					CMP #$53
					BNE CHECK1_2
					LDA $14C8,x
					CMP #$09
					BCC CHECK1_2
					LDA $E4,x
					CMP #$B8
					BCC CHECK1_2
					CMP #$C8
					BCS CHECK1_2
					LDA $14D4,x
					BEQ CHECK1_2
					LDA $D8,x
					CMP #$20
					BCC CHECK1_2
					CMP #$58
					BCS CHECK1_2
					STZ $14C8,x
					LDA #$28
					STA $1DFC
					LDA $1528,y
					INC A
					STA $1528,y
CHECK1_2			INX
					CPX #$0A
					BNE CHECK1_L
					PLX
					LDA $1528,x
					CMP #$03
					BCS CHECK1_3
					RTS
CHECK1_3			LDA #$40
					STA $15AC,x
					LDA #$05
					STA $C2,x
					LDA #$1E
					STA $1DFB
					RTS
CHECK2_R			RTS
BLK_CHECK2			TXY
					PHX
					LDX #$00
CHECK2_L			LDA $9E,x
					CMP #$53
					BNE CHECK2_2
					LDA $14C8,x
					CMP #$09
					BCC CHECK2_2
					LDA $E4,x
					CMP #$28
					BCC CHECK2_2
					CMP #$38
					BCS CHECK2_2
					LDA $14D4,x
					BEQ CHECK2_2
					LDA $D8,x
					CMP #$20
					BCC CHECK2_2
					CMP #$58
					BCS CHECK2_2
					STZ $14C8,x
					LDA #$28
					STA $1DFC
					LDA $1528,y
					INC A
					STA $1528,y
CHECK2_2			INX
					CPX #$0A
					BNE CHECK2_L
					PLX
					LDA $1528,x
					CMP #$03
					BCS CHECK2_3
					RTS
CHECK2_3			LDA #$40
					STA $15AC,x
					LDA #$05
					STA $C2,x
					LDA #$1E
					STA $1DFB
					RTS
