;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; S[@
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$07
					STA $1662,x
					LDA #$83
					STA $167A,x
					LDA #$0F
					STA $7FFD01
					TXA
					STA $7FFD00
					LDA #$00
					STA $7FD120
					STA $7FD121
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE       LDA $1504,x
					BNE MAIN1
					JSR GOVA
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR RIGHT
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR LEFT
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR ENE1
					RTS
MAIN4				JSR ENE2
					RTS


RETURN              RTS
GOVA				LDA $C2,x
					BEQ GOVA_1
					JSR SUB_GFX
GOVA_1				LDA $9D
					BNE RETURN
					JSR MARIO_CHECK
					LDA $C2,x
					BNE GOVA_2
					JSR GOVA0
					RTS
GOVA_2				CMP #$01
					BNE GOVA_3
					JSR GOVA1
					RTS
GOVA_3				CMP #$02
					BNE GOVA_4
					JSR GOVA2
					RTS
GOVA_4				CMP #$03
					BNE GOVA_5
					JSR GOVA3
					RTS
GOVA_5				CMP #$04
					BNE GOVA_6
					JSR GOVA4
					RTS
GOVA_6				CMP #$05
					BNE GOVA_7
					JSR GOVA5
					RTS
GOVA_7				JSR GOVA6
					RTS
					
GOVA0				LDA #$1E
					STA $1DFB
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $1463
					BEQ RETURN
					STZ $1462
					STZ $1411
					LDA #$21
					STA $1DFB
					INC $C2,x
					LDA #$60
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$40
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$32
					STA $40
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$60
					STA $151C,y
					LDA #$30
					STA $1528,y
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$C0
					STA $151C,y
					LDA #$20
					STA $1570,y
					LDA #$10
					STA $1528,y
					LDA #$F0
					STA $AA,x
					STZ $B6,x
					LDA #$60
					STA $15AC,x
					RTS

GOVA1_TBL			dcb $00,$10,$F0,$00,$08,$F8,$18,$E8
GOVA1				JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSR SET1602
					JSR DIR_CHECK
					LDA $15AC,x
					BEQ GOVA1_3
					CMP #$60
					BEQ GOVA1_2
					BCS GOVA1_1
					JSR MOVE_OFFSET
GOVA1_R				RTS
GOVA1_3				JSL $01ACF9
					AND #$03
					BNE GOVA1_3_2
					LDA #$32
					STA $40
					LDA #$0F
					STA $7FFD01
					STZ $AA,x
					STZ $B6,x
					JSL $01ACF9
					AND #$03
					INC A
					INC A
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
GOVA1_3_2			LDA #$A0
					STA $15AC,x
					RTS
GOVA1_1				STZ $AA,x
					STZ $B6,x
					RTS
GOVA1_2				JSL $01ACF9
					AND #$07
					TAY
					LDA GOVA1_TBL,y
					STA $AA,x
					JSL $01ACF9
					AND #$07
					TAY
					LDA GOVA1_TBL,y
					STA $B6,x
					RTS
					
GOVA2				LDA $15AC,x
					CMP #$D0
					BEQ GOVA2_2
					CMP #$B0
					BEQ GOVA2_1
					RTS
GOVA2_1				LDA #$A0
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
GOVA2_2				LDA $D8,x
					SEC
					SBC #$30
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $E4,x
					CLC
					ADC #$18
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$08
					STA $00B6,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$18
					STA $00B6,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$28
					STA $00B6,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$F8
					STA $00B6,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$E8
					STA $00B6,y
					JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$C0
					STA $00AA,y
					LDA #$D8
					STA $00B6,y
					LDA $D8,x
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					LDA $E4,x
					SEC
					SBC #$18
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					RTS
					
GOVA3				LDA $15AC,x
					CMP #$D0
					BEQ GOVA3_2
					CMP #$80
					BEQ GOVA3_1
					RTS
GOVA3_1				LDA #$A0
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
GOVA3_2				JSR GEN_SPRITE
					LDA #$04
					STA $1504,y
					LDA #$A0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					JSL $01ACF9
					STA $00E4,y
					LDA #$87
					STA $1662,y
					LDA #$2B
					STA $1DFC
					RTS

GOVA4				LDA $15AC,x
					BEQ GOVA4_1
					AND #$0F
					BEQ GOVA4_2
					RTS
GOVA4_1				LDA #$A0
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
GOVA4_2				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$A0
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					JSL $01ACF9
					STA $00E4,y
					RTS
					
GOVA5				LDA $15AC,x
					CMP #$B0
					BEQ GOVA5_1
					CMP #$D0
					BEQ GOVA5_2
					RTS
GOVA5_1				LDA #$A0
					STA $15AC,x
					LDA #$01
					STA $C2,x
					RTS
GOVA5_2				LDA #$0D
					STA $7FFD01
					LDA #$72
					STA $40
					LDA #$10
					STA $1DF9
					RTS

GOVA6				STZ $AA,x
					STZ $B6,x
					LDA #$00
					STA $2121
					LDA $7FD120
					STA $2122
					LDA $7FD121
					STA $2122
					REP #$20
					LDA $7FD120
					BEQ GOVA6_0
					SEC
					SBC.W #$0421
					STA $7FD120
GOVA6_0				SEP #$20
					STA $2122
					LDA $15AC,x
					CMP #$C0
					BEQ GOVA6_1
					CMP #$80
					BEQ GOVA6_1
					CMP #$70
					BEQ GOVA6_1
					CMP #$30
					BEQ GOVA6_2
					BCS GOVA6_R
					JSR TELEPORT
					LDA #$18
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BEQ GOVA6_R
					LDA $D8,x
					CMP #$50
					BCC GOVA6_R
					LDA #$50
					STA $D8,x
GOVA6_R				RTS
GOVA6_1				LDA #$FF
					STA $7FD120
					LDA #$7F
					STA $7FD121
					LDA #$18
					STA $1DFC
					RTS
GOVA6_2				LDA #$2B
					STA $1DFC
					RTS
TELEPORT			LDA $94
					CMP #$E0
					BCC TELEPORT_R
					LDA #$06
					STA $71
					STZ $89
					STZ $88
TELEPORT_R			RTS

RIGHT				JSR SUB_GFX_HAND
					LDA $9D
					BNE RIGHT_R
					LDA $7FFD00
					TAY
					LDA $00C2,y
					CMP #$02
					BEQ RIGHT_2
					CMP #$03
					BEQ RIGHT_2
					CMP #$04
					BEQ RIGHT_3
					CMP #$05
					BEQ RIGHT_3
					CMP #$06
					BEQ RIGHT_4
					LDA #$10
					STA $0E
					JSR MOVE_HAND
					STZ $1602,x
RIGHT_R				RTS
RIGHT_2				LDA #$03
					STA $1602,x
					RTS
RIGHT_3				LDA #$02
					STA $1602,x
					RTS
RIGHT_4				LDA $7FFD00
					TAY
					LDA $00AA,y
					STA $AA,x
					JSL $01801A ;y speed
					RTS

LEFT				JSR SUB_GFX_HAND
					LDA $9D
					BNE LEFT_R
					LDA $7FFD00
					TAY
					LDA $00C2,y
					CMP #$02
					BEQ LEFT_2
					CMP #$03
					BEQ LEFT_2
					CMP #$04
					BEQ LEFT_3
					CMP #$05
					BEQ LEFT_3
					CMP #$06
					BEQ LEFT_4
					LDA #$08
					STA $0E
					LDA $157C,x
					BEQ LEFT_1
					LDA #$18
					STA $0E
LEFT_1				JSR MOVE_HAND
					LDA #$01
					STA $1602,x
LEFT_R				RTS
LEFT_2				LDA #$01
					STA $1602,x
					RTS
LEFT_3				LDA #$02
					STA $1602,x
					RTS
LEFT_4				LDA $7FFD00
					TAY
					LDA $00AA,y
					STA $AA,x
					JSL $01801A ;y speed
					RTS
					
ENE1				JSR SUB_GFX_E
					LDA $9D
					BNE ENE1_R
					JSL $01A7DC
					JSL $01802A
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
ENE1_R				RTS

ENE2				JSR SUB_GFX_E2
					LDA $9D
					BNE ENE2_R
					JSL $01802A
					LDA $E4,x
					SEC
					SBC #$18
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$18
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $27FB02 ;SUB_OFF_SCREEN_HB
					LDA $14D4,x
					BEQ ENE2_R
					LDA $D8,x
					CMP #$30
					BCC ENE2_R
					LDA #$C0
					STA $AA,x
					LDA $C2,x
					BNE ENE2_R
					INC $C2,x
					LDA #$20
					STA $B6,x
					LDA $94
					SEC
					SBC $E4,x
					BCS ENE2_R
					LDA #$E0
					STA $B6,x
ENE2_R				RTS

MOVE_OFFSET			LDA $E4,x
					CMP #$08
					BCC MOVE_OFFSET_1
					CMP #$B8
					BCS MOVE_OFFSET_2
					BRA MOVE_OFFSET_3
MOVE_OFFSET_1		LDA $B6,x
					BPL MOVE_OFFSET_R
					EOR #$FF
					STA $B6,x
					BRA MOVE_OFFSET_3
MOVE_OFFSET_2		LDA $B6,x
					BMI MOVE_OFFSET_R
					EOR #$FF
					STA $B6,x
MOVE_OFFSET_3		LDA $14D4,x
					BNE MOVE_OFFSET_4
					LDA $D8,x
					CMP #$D0
					BCS MOVE_OFFSET_R
					LDA $AA,x
					BPL MOVE_OFFSET_R
					EOR #$FF
					STA $AA,x
MOVE_OFFSET_R		RTS
MOVE_OFFSET_4		LDA $D8,x
					CMP #$60
					BCC MOVE_OFFSET_R
					LDA $AA,x
					BMI MOVE_OFFSET_R
					EOR #$FF
					STA $AA,x
					RTS

MOVE_HAND			INC $1570,x
					LDA $1570,x
					LSR A
					AND #$1F
					STA $02
					CMP #$10
					BCC MOVE_HAND_1
					EOR #$1F
					STA $02
MOVE_HAND_1			INC $1528,x
					LDA $1528,x
					LSR A
					AND #$1F
					STA $03
					CMP #$10
					BCC MOVE_HAND_2
					EOR #$1F
					STA $03
MOVE_HAND_2
					LDA $7FFD00
					TAY
					LDA $157C,y
					STA $157C,x
					LDA $00E4,y
					CLC
					ADC $02
					ADC $0E
					STA $E4,x
					LDA $14E0,y
					ADC #$00
					STA $14E0,x
					LDA $00D8,y
					ADC $03
					STA $D8,x
					LDA $14D4,y
					ADC #$00
					STA $14D4,x
					RTS

SET1602				INC $1570,x
					LDA $1570,x
					CMP #$01
					BNE SET1602_2
					INC $1602,x
					LDA $1602,x
					CMP #$04
					BCC SET1602_R
					STZ $1602,x
SET1602_R			RTS
SET1602_2			CMP #$0C
					BCC SET1602_R
					STZ $1570,x
					RTS
DIR_CHECK			LDA $E4,x
					CLC
					ADC #$18
					STA $02
					LDA $14E0,x
					ADC #$00
					STA $03
					STZ $157C,x
					REP #$20
					LDA $02
					SEC
					SBC $94
					BCS DIR_CHECK_2
					SEP #$20
					INC $157C,x
DIR_CHECK_2			SEP #$20
					RTS
					
MARIO_CHECK			LDA $C2,x
					BEQ CHECK_R
					CMP #$06
					BEQ CHECK_R
					LDA $1540,x
					BNE CHECK_R
					LDA $97
					BEQ CHECK_1
					LDA $96
					CMP #$18
					BCS CHECK_R
CHECK_1				JSL $01A7DC
					BCC CHECK_R
					LDA $7D
					BMI CHECK_0
					CMP #$10
					BCS MARIO_WIN
CHECK_0				LDA $D8,x
					SEC
					SBC $96
					STA $0F
					LDA $14D4,x
					SBC $97
					BCC ENE_WINS
					LDA $0F
					CMP #$10
					BCC ENE_WINS
MARIO_WIN			LDA #$FF
					STA $1540,x
					LDA #$28
					STA $1DFC
					LDA #$C0
					STA $7D
					JSL $01AB99
					INC $1528,x
					LDA $1528,x
					CMP #$0F
					BCS CHECK_2
CHECK_R				RTS
ENE_WINS			LDA $1497
                    BNE CHECK_R
                    JSL $00F5B7
					RTS
CHECK_2				STZ $1540,x
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $15AC,x
					LDA #$06
					STA $C2,x
					LDA #$32
					STA $40
					LDA #$0F
					STA $7FFD01
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_GFX_E			JSR GET_DRAW_INFO
					TXA
					ASL A
					ASL A
					TAY
					STA $15EA,x
					LDA $00
					STA $0200,y
					LDA $01
					STA $0201,y
					LDA #$0E
					STA $0202,y
					LDA #$0F
					ORA $64
					STA $0203,y
					LDY #$02
                    LDA #$00
					JSL $28FCC0
                    RTS

HORZ_DISP_E2		dcb $E0,$00,$20,$00,$E4,$0C,$1C,$F4
					dcb $EB,$15,$15,$EB,$F4,$1C,$0C,$E4
VERT_DISP_E2		dcb $18,$F8,$18,$38,$0C,$FC,$24,$34
					dcb $03,$03,$2D,$2D,$FC,$0C,$34,$24

SUB_GFX_E2			JSR GET_DRAW_INFO
					LDA #$80
					TAY
					STA $15EA,x
					LDA $14
					LSR A
					;LSR A
					AND #$03
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$03
LOOP_E2				PHX
                    TXA
                    CLC
                    ADC $03
                    TAX
                    LDA $00
                    CLC
                    ADC HORZ_DISP_E2,x
                    STA $0200,y
                    LDA $01
                    CLC
                    ADC VERT_DISP_E2,x
                    STA $0201,y
					PLX
                    LDA #$0E
                    STA $0202,y
                    LDA #$0F
                    ORA $64
                    STA $0203,y
                    INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_E2
                    PLX
                    LDY #$02
                    LDA #$03
                    JSL $28FCC0
                    RTS

TILE_HAND			dcb $08,$0A,$28,$2A,$48,$4A,$6A,$6E
					dcb $08,$0A,$28,$2A,$2C,$2E,$4E,$6E
					dcb $8C,$8E,$AC,$AE,$8A,$EA,$AA,$CA
					dcb $CC,$CE,$EC,$EE,$E8,$C6,$C8,$A8
					
HORZ_HAND			dcb $F8,$08,$F8,$08,$F8,$08,$08,$00
					dcb $F8,$08,$F8,$08,$F8,$08,$08,$00
					dcb $F0,$00,$F0,$00,$F0,$D4,$E4,$E4
					dcb $F8,$08,$F8,$08,$FC,$EC,$FC,$FC
					
					dcb $08,$F8,$08,$F8,$08,$F8,$F8,$00
					dcb $08,$F8,$08,$F8,$08,$F8,$F8,$00
					dcb $10,$00,$10,$00,$10,$2C,$1C,$1C
					dcb $08,$F8,$08,$F8,$04,$14,$04,$04
					
VERT_HAND			dcb $F8,$F8,$08,$08,$20,$18,$28,$00
					dcb $F8,$F8,$08,$08,$20,$18,$28,$00
					dcb $F8,$F8,$08,$08,$18,$20,$18,$28
					dcb $F8,$F8,$08,$08,$E8,$D0,$D8,$C8
SUB_GFX_HR			RTS
SUB_GFX_HAND		LDA $7FFD00
					TAY
					LDA $1540,y
					BEQ SUB_GFX_H1
					LDA $14
					AND #$02
					BEQ SUB_GFX_HR
SUB_GFX_H1			JSR GET_DRAW_INFO
					LDA $151C,x
					TAY
					STA $15EA,x
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					STA $02
					STZ $03
					LDA $7FFD01
					STA $0F
					LDA $157C,x
					BEQ SUB_GFX_HAND_2
					LDA #$20
					STA $03
					LDA $0F
					ORA #$40
					STA $0F
SUB_GFX_HAND_2		PHX
					LDX #$07
LOOP_HAND			PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_HAND,x
					STA $0301,y
					LDA TILE_HAND,x
					STA $0302,y
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_HAND,x
					STA $0300,y
					LDA $0F
					STA $0303,y
					PLX
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_HAND          ; / 
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07
                    ;JSL $28FCC0 ;# $200p̃OtBbN[`
					JSL $01B7B3
                    RTS                     ; return


TILEMAP				dcb $00,$02,$04,$20,$22,$24,$26,$40,$42,$44,$46,$60,$62
					dcb $84,$86,$88,$20,$22,$A4,$A6,$40,$42,$C4,$C2,$E2,$6E
					dcb $00,$02,$04,$20,$80,$82,$40,$A0,$A2,$C0,$6E,$6E,$6E
					dcb $84,$86,$88,$20,$22,$A4,$A6,$40,$42,$C4,$C2,$E2,$6E
HORZ_DISP			dcb $00,$10,$20,$00,$10,$20,$30,$00,$10,$20,$30,$18,$28
					dcb $00,$10,$20,$00,$10,$20,$30,$00,$10,$20,$18,$18,$00
					dcb $00,$10,$20,$00,$10,$20,$00,$10,$20,$10,$00,$00,$00
					dcb $00,$10,$20,$00,$10,$20,$30,$00,$10,$20,$18,$18,$00
					dcb $30,$20,$10,$30,$20,$10,$00,$30,$20,$10,$00,$18,$08
					dcb $30,$20,$10,$30,$20,$10,$00,$30,$20,$10,$18,$18,$00
					dcb $30,$20,$10,$30,$20,$10,$30,$20,$10,$20,$00,$00,$00
					dcb $30,$20,$10,$30,$20,$10,$00,$30,$20,$10,$18,$18,$00
VERT_DISP			dcb $00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20,$30,$30
					dcb $00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$30,$40,$00
					dcb $00,$00,$00,$10,$10,$10,$20,$20,$20,$30,$00,$00,$00
					dcb $00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$30,$40,$00

SUB_GFX_R			RTS
SUB_GFX             LDA $1540,x
					BEQ SUB_GFX_1
					LDA $14
					AND #$02
					BEQ SUB_GFX_R
SUB_GFX_1			JSR GET_DRAW_INFO
					LDA $1602,x
					ASL A
					ASL A
					ASL A
					ASL A
					SEC
					SBC $1602,x
					SBC $1602,x
					SBC $1602,x
					STA $02
					STZ $03
					LDA $7FFD01
					STA $0F
					LDA $157C,x
					BEQ SUB_GFX_2
					LDA #$34
					STA $03
					LDA $0F
					ORA #$40
					STA $0F
SUB_GFX_2			LDA #$80
					TAY
					STA $15EA,x
					PHX
					LDX #$0C
LOOP_START          PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_DISP,x
					STA $0301,y
					LDA TILEMAP,x
					STA $0302,y
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
					CLC
					ADC HORZ_DISP,x
                    STA $0300,y
					PLX
					LDA $0F
					STA $0303,y
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0C
                    ;JSL $28FCC0 ;# $200p̃OtBbN[`
					JSL $01B7B3
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
					LDA $14D4,x
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
RETURN67            RTS                     ; return

