;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Kirby
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$01
					STA $157C,x
					STZ $1602,x
					STZ $40
					STZ $1528,x
					TXA
					STA $7FF001
					JSR YOSHI_INDEX
					LDA #$FF
					STA $15AC,x
					STZ $1504,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


STAR                INC $1558,x
RETURN              RTS                    
START_HB_CODE       LDA $1528,x
					BEQ M_GFX
					LDA $1594,x
					BEQ M_GFX0
					CMP #$01
					BNE M_GFX1
					JSR SUB_GFX2
					BRA M_GFX
M_GFX1				CMP #$02
					BNE M_GFX2
					JSR SUB_GFX3
					BRA M_GFX
M_GFX2				JSR SUB_GFX4
					BRA M_GFX
M_GFX0				JSR SUB_GFX             ; draw hammer bro gfx
M_GFX               LDA $14C8,x             ; \ if hammer bro status != 8...
                    CMP #$02                ;  }   ... not (killed with spin jump [4] or star[2])
                    BEQ STAR
                    CMP #$08
                    BNE RETURN              ; /    ... return
                    LDA $9D                 ; \ if sprites locked...
                    BNE RETURN              ; /    ... return
                    
					LDA $16
					ORA $18
					BEQ MAIN1
					INC $151C,x
MAIN1					
					JSR SUB_MODE
                    LDA $E4,x
					CMP #$E0
					BCS MAIN_R
					CMP #$10
					BCC MAIN_L
					BRA MAIN2
MAIN_R				LDA $B6,x
					CMP #$80
					BCS MAIN2
					STZ $B6,x
					BRA MAIN2
MAIN_L				LDA $B6,x
					CMP #$80
					BCC MAIN2
					STZ $B6,x
MAIN2		        JSL $01802A             ; update position based on speed values
                    
                    JSR DAMAGE_CHECK
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MODE0				LDA $15AC,x
					CMP #$80
					BEQ MODE0_3
					CMP #$A0
					BCC MODE0_2
					STZ $7B
					LDA $7FF002
					TAY
					LDA #$00
					STA $157C,y
					LDA $77
					AND #$04
					BEQ MODE0_E
					STZ $7D
MODE0_E				RTS
MODE0_2				LDA $7FF002
					TAY
					LDA #$00
					STA $157C,y
					STZ $7B
					STZ $7D
					LDA $15AC,x
					CMP #$9F
					BNE MODE0_E
					LDA #$01
					STA $1426
					RTS
MODE0_3				LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $1528,x
					LDA #$20
					STA $40
					RTS

MODE1				LDA $7FF002
					TAY
					LDA #$00
					STA $157C,y
					STZ $7B
					STZ $7D
					LDA $15AC,x
					CMP #$C0
					BEQ MODE1_0
					CMP #$C0
					BCC MODE1_1
					STZ $1602,x
					LDA $7FF002
					TAY
					LDA #$00
					STA $157C,y
					STZ $7B
					STZ $7D
					RTS
MODE1_0				LDA #$C0
					STA $AA,x
					LDA #$F0
					STA $B6,x
					RTS
MODE1_1				CMP #$40
					BCC MODE1_2
					LDA $1588,x
					AND #$04
					BEQ MODE1_A
					STZ $B6,x
					STZ $1602,x
					RTS
MODE1_A				LDA #$01
					STA $1602,x
MODE1_E				RTS
MODE1_2				CMP #$30
					BEQ MODE1_3
					CMP #$2F
					BNE MODE1_E
					LDA #$24
					STA $13BF
					LDA #$01
					STA $1426
					LDA #$02
					STA $1528,x
					LDA #$05
					STA $1DFB
					LDA #$20
					STA $15AC,x
					RTS
MODE1_3				LDA #$02
					STA $1426
					RTS
					
MODE2				LDA $1504,x
					BNE MODE2_4
					LDA #$20
					STA $13BF
					LDA $15AC,x
					BEQ MODE2_2
					STZ $B6,x
					JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
					RTS
MODE2_2				LDA #$01
					STA $1504,x
					LDA #$40
					STA $15AC,x
					LDA $157C,x
					BNE MODE2_3
					LDA $94
					SEC
					SBC $E4,x
					LSR A
					STA $B6,x
					RTS
MODE2_3				LDA $E4,x
					SEC
					SBC $94
					LSR A
					STA $B6,x
					LDA #$00
					SEC
					SBC $B6,x
					STA $B6,x
					RTS
MODE2_4				LDA $15AC,x
					CMP #$20
					BCC MODE2_5
					LDA #$D0
					STA $AA,x
					LDA #$01
					STA $1602,x
					RTS
MODE2_5				CMP #$00
					BEQ MODE2_6
					STZ $B6,x
					STZ $AA,x
					LDA $1594,x
					BNE MODE2_E
					JSR MODE_CHANGE
MODE2_E				RTS
MODE2_6				LDA #$50
					STA $AA,x
					LDA $1588,x
					AND #$04
					BEQ MODE2_E
					LDA #$03
					STA $1528,x
					LDA #$20
					STA $1887
					JSR FIRE_GEN
					LDA #$0F
					STA $00C2,y
					LDA #$30
					STA $00B6,y
					JSR FIRE_GEN
					LDA #$0F
					STA $00C2,y
					LDA #$D0
					STA $00B6,y
					LDA #$09
					STA $1DFC
					LDA #$50
					STA $15AC,x
					RTS
					
MODE3				JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
					LDA $15AC,x
					BNE MODE3_E
					LDA #$10
					STA $15AC,x
					STZ $1594,x
					STZ $1602,x
					LDA #$02
					STA $1528,x
					STZ $1504,x
					RTS
MODE3_E				JSR DAMAGE_CHECK2
					RTS
					
MODE4				JSR SUB_GET_DIR         ; \ always face mario
                    TYA                     ;  | 
                    STA $157C,x
					LDA #$02
					STA $1602,x
					LDA $15AC,x
					BNE MODE4_2
					LDA $1588,x
					AND #$04
					BEQ MODE4_E
					LDA #$50
					STA $15AC,x
					STZ $B6,x
MODE4_E				RTS
MODE4_2				CMP #$01
					BEQ MODE4_3
					LDA #$18
					STA $1686,x
					RTS
MODE4_3				LDA #$19
					STA $1686,x
					LDA #$10
					STA $15AC,x
					STZ $1602,x
					LDA #$02
					STA $1528,x
					STZ $1504,x
					RTS



MODE_CHANGE			LDA $151C,x
					AND $94
					AND #$03
					INC A
					STA $1594,x
					CMP #$04
					BNE CHENGE_E
					LDA $94
					AND #$01
					INC A
					STA $1594,x
CHENGE_E			RTS






SUB_MODE			LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			JSR MODE4
					RTS

DAMAGE_CHECK		JSL $01A7DC
					BCC RETURN2
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$08
					BCC ENE_WINS
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$02
                    STA $1DF9
					RTS
					RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURN2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN2             RTS

X_SPEED				dcb $F0,$10

DAMAGE_CHECK2		LDA $E4,x
					AND #$FC
					STA $0F
					TXY
					PHX
					LDX #$00
DAMAGE_LOOP			LDA $9E,x
					CMP #$36
					BNE DAMAGE2
					LDA $14C8,x
					BEQ DAMAGE2
					LDA $C2,x
					CMP #$0D
					BNE DAMAGE2
					LDA $14E0,x
					BNE DAMAGE2
					LDA $E4,x
					AND #$FC
					CMP $0F
					BNE DAMAGE2
					LDA #$28
					STA $1DFC
					LDA #$04
					STA $1528,y
					LDA #$00
					STA $15AC,y
					STA $1594,y
					STZ $14C8,x
					PHX
					LDA $157C,y
					TAX
					LDA X_SPEED,x
					STA $00B6,y
					LDA #$C0
					STA $00AA,y
					PLX
DAMAGE2				CPX #$09
					BEQ DAMAGE3
					INX
					BRA DAMAGE_LOOP
DAMAGE3				PLX
					RTS


YOSHI_INDEX			PHX
					LDX #$00
YOSHI_LOOP			LDA $9E,x
					CMP #$35
					BNE YOSHI2
					LDA $14C8,x
					BEQ YOSHI2
					TXA
					STA $7FF002
YOSHI2				CPX #$09
					BEQ YOSHI3
					INX
					BRA YOSHI_LOOP
YOSHI3				PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RETURN67            RTS
FIRE_GEN            JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					INC A
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

                    LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $C4,$C6,$E4,$E6,$84,$86,$A4,$A6,$C0,$C2,$E0,$E2
HORZ_DISP			dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00
PROPERTIES          dcb $40,$00

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
                    LDA $157C,x             ; \ $02 = sprite direction
                    STA $02                 ; /
					LDA $1602,x
					ASL A
					ASL A
					STA $03
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                   
                    
NO_ADJ              PHX
					TXA
					CLC
					ADC $02
					ADC $02
					ADC $02
					ADC $02
					TAX
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /      
					PLX              

                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        
                    LDX $02                 ; \
                    LDA PROPERTIES,x        ;  | get tile properties using sprite direction
                    ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

					
TILEMAP2            dcb $80,$82,$A0,$A2
HORZ_DISP2			dcb $F8,$08,$F8,$08
VERT_DISP2          dcb $F0,$F0,$00,$00

SUB_GFX2            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START2         PHX                     ; push current tile number
                   
                    
            
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP2,x         ;  |
                    STA $0300,y             ; /      


                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0301,y             ; /
                    

                    LDA TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 

        
                    LDA #$00
                    ORA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP3            dcb $88,$8A,$A8,$AA
HORZ_DISP3			dcb $F8,$08,$F8,$08
VERT_DISP3          dcb $F0,$F0,$00,$00

SUB_GFX3            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
					PHX                     ; push sprite index

                    LDX #$03                ; loop counter = (number of tiles per frame) - 1
LOOP_START3         PHX                     ; push current tile number
                   
                    
           
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP3,x         ;  |
                    STA $0300,y             ; /      


                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP3,x         ;  |
                    STA $0301,y             ; /
                    

                    LDA TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; / 

        
                    LDA #$00
                    ORA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP4            dcb $8C,$8E,$AC,$AE,$CC,$CE,$EC,$EE
HORZ_DISP4			dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08
VERT_DISP4          dcb $D0,$D0,$E0,$E0,$F0,$F0,$00,$00

SUB_GFX4            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
               ; /
					PHX                     ; push sprite index

                    LDX #$07                ; loop counter = (number of tiles per frame) - 1
LOOP_START4         PHX                     ; push current tile number
                   
                    
           
					LDA $00
					CLC                     ;  |
                    ADC HORZ_DISP4,x         ;  |
                    STA $0300,y             ; /      


                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP4,x         ;  |
                    STA $0301,y             ; /
                    

                    LDA TILEMAP4,x           ; \ store tile
                    STA $0302,y             ; / 

        
                    LDA #$00
                    ORA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START4          ; / 

                    PLX                     ; pull, X = sprite index
                    
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

