;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Lesalesa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$00
					STA $D8,x
					STZ $14D4,x
					LDA #$10
					STA $E4,x
					LDA #$00
					STA $14E0,x
					
					LDA #$03 ;#Nbp[h
					STA $C2,x
					LDA #$0A
					STA $7FFFDD ;BG1pGFX^Cw
					JSL $03DD7D ;[`BBG1FFiGFX^C̉E^CjŖ߂܂BƂĂ܂
					JSR HDMA_COLOR ;\
					JSR HDMA_COLOR2;| pbgύXĂ邾ł
					LDA #$40
					STA $38
					STA $39
					LDA #$80
					STA $15AC,x
					LDA #$24
					STA $1DFB
					LDA #$00
					STA $157C,x
					STA $7FFF64
					STA $7FFF65
					RTL 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
					LDA $7FFF64
					BEQ HAMMER_R
					STZ $64                ;}ĨO̗Dxς邱ƂŁABGPOɕ\܂
HAMMER_R            RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE1				dcb $04,$03,$02,$01,$00,$01,$02,$03,$04,$05,$06,$07,$07,$07,$07,$07,$07,$07,$07,$07
TABLE2				dcb $00,$00,$00,$08,$10,$14,$14,$16,$16,$18,$18,$17,$16,$16,$17,$18,$18,$17,$14,$10
					dcb $0C,$08,$04,$00,$A0,$07
BOWSER_R			RTS
START_HB_CODE		LDA $1504,x
					BNE MAIN0
					JSR MAIN
					RTS
MAIN0				CMP #$01
					BNE MAIN1
					JSR BAWL
					RTS 
MAIN1				CMP #$02
					BNE MAIN2
					JSR BAWL2
					RTS
MAIN2				CMP #$03
					BNE MAIN3
					JSR BAWL3
					RTS
MAIN3				CMP #$04
					BNE MAIN4
					JSR TELESA
					RTS
MAIN4				JSR BLK_SPRITE
					RTS
					
MAIN				JSR GET_DRAW_INFO
					JSR BACK_GROUND ;wipXvCg̕`ł
					LDA #$90
					STA $2A
					LDA #$C8
					STA $2C
					LDA #$30
					STA $64
					JSR GRAPHIC_ROUTINE
					JSR GRAPHIC0 ;Nbp̃OtBbNwł
					;JSL $03DEDF ;̓IWił
					LDA $9D
					BNE BOWSER_R
					STZ $149F
					JSL $018022		;x speed
					JSL $01801A		;y speed
					JSR MODE_DO
					RTS
					
BAWL				JSR SUB_GFX_B
					LDA $9D
					BNE BAWL_R
					JSL $01802A
					LDA $AA,x
					CMP #$80
					BCS BAWL_2
					JSL $01A7DC
BAWL_2				LDA $14D4,x
					CMP #$01
					BNE BAWL_R
					STZ $14C8,x
BAWL_R				RTS

BAWL2				JSR SUB_GFX_B
					LDA $9D
					BNE BAWL2_R
					JSL $01802A
					JSL $01A7DC
					LDA $157C,x
					BNE BAWL2_2
					LDA $D8,x
					CMP #$B0
					BCC BAWL2_2
					LDA #$01
					STA $157C,x
					LDA #$B0
					STA $AA,x
BAWL2_2				LDA $14D4,x
					CMP #$01
					BNE BAWL_R
					STZ $14C8,x
BAWL2_R				RTS

BAWL3_SPEED			dcb $40,$C0
BAWL3				JSR SUB_GFX_B
					LDA $9D
					BNE BAWL3_R
					LDY $157C,x
					LDA BAWL3_SPEED,y
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					JSL $01A7DC
					LDA $14E0,x
					BEQ BAWL3_R
					STZ $14C8,x
BAWL3_R				RTS

TELESA				JSR SUB_GFX_T
					LDA $9D
					BNE TELESA_R
					LDA #$D0
					STA $B6,x
					JSL $018022
					JSL $01A7DC
					LDA $14E0,x
					CMP #$FF
					BNE TELESA_R
					STZ $14C8,x
TELESA_R			RTS

BLK_SPRITE			JSR SUB_GFX_BL
					LDA $1540,x
					BEQ BLK_SPRITE_1
					CMP #$FE
					BEQ BLK_SPRITE_2
					JSL $01A7DC
					BCC BLK_SPRITE_R
					JSR GEN_NORMAL
					LDA #$C0
					STA $1540,y
					LDA $E4,x
					STA $00E4,y
					LDA $14E0,x
					STA $14E0,y
					LDA $D8,x
					STA $00D8,y
					LDA $14D4,x
					STA $14D4,y
					STZ $14C8,x
					RTS
BLK_SPRITE_1		STZ $14C8,x
BLK_SPRITE_2		JSR SUB_SMOKE
BLK_SPRITE_R		RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE_DO				LDA $151C,x
					STA $7FFF1C
					LDA $1570,x
					STA $7FFF70
					LDA $1528,x
					STA $7FFF28
					LDA $151C,x
					BNE MODE_DO_1
					JSR MODE0
					RTS
MODE_DO_1			CMP #$01
					BNE MODE_DO_2
					JSR MODE1
					RTS
MODE_DO_2			CMP #$02
					BNE MODE_DO_3
					JSR MODE2
					RTS
MODE_DO_3			CMP #$03
					BNE MODE_DO_4
					JSR MODE3
					RTS
MODE_DO_4			CMP #$04
					BNE MODE_DO_5
					JSR MODE4
					RTS
MODE_DO_5			CMP #$05
					BNE MODE_DO_6
					JSR MODE5
					RTS
MODE_DO_6			CMP #$06
					BNE MODE_DO_7
					JSR MODE6
					RTS
MODE_DO_7			JSR MODE7
					RTS




MODE1_TABLE			dcb $10,$F0

MODE0				LDA $1558,x
					BEQ MODE0_8
					JSR MODE0_SUB2
					RTS
MODE0_8				LDA $1540,x
					BEQ MODE0_7
					JSR MODE0_SUB
					RTS
MODE0_7				LDA $1528,x
					BEQ MODE0_6
					LDA #$FF
					STA $1540,x
					LDA #$02
					STA $1602,x
					STZ $AA,x
					STZ $B6,x
					RTS
MODE0_6				LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSR ATACK_CHECK1
					JSR BLK_CHECK
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					LDA $15AC,x
					BNE MODE0_0
					LDA #$20
					STA $15AC,x
					INC $1570,x
					LDA $1570,x
					AND #$0F
					BEQ MODE0_5
					JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					JSR SPEED_DEC3
					BRA MODE0_0
MODE0_5				JSR GEN_NORMAL
					LDA #$A0
					STA $1686,y
					LDA #$C0
					STA $1540,y
					JSR SPEED_DEC3
MODE0_0				LDA $14
					AND #$20
					BEQ MODE0_1
					LDA #$04
					STA $AA,x
					BRA MODE0_2
MODE0_1				LDA #$FC
					STA $AA,x
MODE0_2				LDY $157C,x
					LDA MODE1_TABLE,y
					STA $B6,x
					LDA $E4,x
					CMP #$20
					BCC MODE0_3
					CMP #$D0
					BCS MODE0_4
MODE0_R				RTS
MODE0_3				LDA #$00
					STA $157C,x
					RTS
MODE0_4				LDA #$01
					STA $157C,x
					LDA #$00
					STA $7FFB20
					STA $7FFB28
					RTS
MODE0_SUB			LDA $1540,x
					CMP #$01
					BEQ MODE0_SUB_7
					CMP #$D0
					BCS MODE0_SUB_R
					CMP #$CF
					BEQ MODE0_SUB_2
					CMP #$A0
					BCS MODE0_SUB_3
					CMP #$61
					BEQ MODE0_SUB_5
					CMP #$60
					BCC MODE0_SUB_4
					RTS
MODE0_SUB_2			LDA #$0E
					STA $1DFC
MODE0_SUB_R			RTS
MODE0_SUB_3			LDA $38
					CMP #$20
					BCC MODE0_SUB_R
					DEC $38
					DEC $39
					RTS
MODE0_SUB_5			LDA #$60
					STA $1887
					LDA #$20
					STA $1DFC
					RTS
MODE0_SUB_7			LDA #$FF
					STA $1558,x
					STA $1887
					LDA #$20
					STA $38
					STA $39
					STZ $1602,x
					STZ $1570,x
					RTS
MODE0_SUB_4			LDA #$01
					STA $1602,x
					LDA $1540,x
					AND #$08
					BNE MODE0_SUB_6
					LDA #$10
					STA $38
					STA $39
					RTS
MODE0_SUB_6			LDA #$20
					STA $38
					STA $39
					RTS
					
MODE0_SUB2_TABLE	dcb $08,$28,$48,$68,$88,$A8,$C8,$E8
MODE0_SUB2			LDA $1558,x
					AND #$1F
					BEQ MODE0_SUB2_2
					LDA $1558,x
					CMP #$01
					BEQ MODE0_SUB2_3
					RTS
MODE0_SUB2_3		LDA #$F8
					STA $AA,x
					LDA #$01
					STA $151C,x
					STZ $157C,x
MODE0_SUB2_2		LDA #$2B
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					LDA #$00
					STA $00B6,y
					STA $157C,y
					PHY
					LDY $1570,x
					LDA MODE0_SUB2_TABLE,y
					PLY
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$00
					STA $00D8,y
					STA $14D4,y
					INC $1570,x
					RTS
					
MODE1				LDA $157C,x
					BNE MODE1_1
					LDA $14D4,x
					CMP #$FF
					BNE MODE1_R
					LDA $D8,x
					CMP #$B0
					BCS MODE1_R
					STZ $AA,x
					STZ $1570,x
					STZ $15AC,x
					STZ $1540,x
					STZ $1558,x
					LDA #$70
					STA $E4,x
					LDA #$0B
					STA $7FFFDD
					JSL $03DD7D
					JSR HDMA_COLOR
					JSR HDMA_COLOR3
					LDA #$01
					STA $157C,x
					LDA #$08
					STA $AA,x
					LDA #$03
					STA $1602,x
					LDA #$3C
					STA $38
					STA $39
					LDA #$03
					STA $1570,x
MODE1_R				RTS
MODE1_1				LDA $14D4,x
					BNE MODE1_R
					LDA #$02
					STA $151C,x
					LDA #$38
					STA $B6,x
					STZ $157C,x
					RTS
					
MODE2				JSR ATACK_CHECK2
					LDA $1528,x
					CMP #$02
					BNE MODE2_A
					RTS
MODE2_A				LDA $D8,x
					CMP #$78
					BCC MODE2_0
					STZ $AA,x
MODE2_0				JSR SIZE_SUB1
					LDA $157C,x
					BEQ MODE2_1
					INC $B6,x
					LDA $B6,x
					BEQ MODE2_5
					CMP #$38
					BEQ MODE2_3
					RTS
MODE2_5				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					LDA #$17
					STA $1DFC
					LDA #$00
					STA $157C,y
					LDA $00E4,y
					CLC
					ADC #$10
					STA $00E4,y
					RTS
MODE2_1				DEC $B6,x
					LDA $B6,x
					BEQ MODE2_6
					CMP #$C8
					BEQ MODE2_2
					RTS
MODE2_6				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $157C,y
					LDA $00E4,y
					SEC
					SBC #$10
					STA $00E4,y
					RTS
MODE2_3				JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					JSR SPEED_DEC3
					LDA #$A0
					STA $00AA,y
					LDA #$17
					STA $1DFC
					STZ $157C,x
					RTS
MODE2_2				JSR GEN_SPRITE
					LDA #$01
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					JSR SPEED_DEC3
					LDA #$A0
					STA $00AA,y
					LDA #$17
					STA $1DFC
					LDA #$01
					STA $157C,x
					RTS
					
MODE3_TABLE			dcb $A8,$A0,$A8,$90

					


					
					
MODE3_B				LDA #$0E
					STA $1DFC
MODE3_R2			RTS
MODE3_C				LDA $14
					AND #$01
					BEQ MODE3_R2
					LDA $38
					CMP #$11
					BCC MODE3_R2
					DEC $38
					DEC $39
					RTS
MODE3_D				LDA #$01
					STA $1602,x
					LDA #$60
					STA $1887
					LDA #$20
					STA $1DFC
					RTS
MODE3_E				LDA $1558,x
					AND #$08
					BNE MODE3_E_2
					LDA #$0C
					STA $38
					STA $39
					RTS
MODE3_E_2			LDA #$10
					STA $38
					STA $39
					RTS
MODE3_F				STZ $1602,x
					LDA #$18
					STA $1558,x
					LDA #$10
					STA $38
					STA $39
					LDA #$F0
					STA $AA,x
					JSR MODE3_SUB
					RTS
MODE3_A				LDA $1558,x
					CMP #$C0
					BCS MODE3_R2
					CMP #$BF
					BEQ MODE3_B
					CMP #$81
					BCS MODE3_C
					CMP #$80
					BEQ MODE3_D
					CMP #$20
					BCS MODE3_E
					CMP #$10
					BCS MODE3_F
					RTS
MODE3_7				LDA #$FF
					STA $15AC,x
					STZ $1570,x
					RTS
MODE3				LDA $1558,x
					BNE MODE3_A
					JSR MOVE_MEKA
					JSR KAME_CHECK
					LDA $1528,x
					CMP #$03
					BNE MODE3_0
					RTS
MODE3_0				LDA $1540,x
					BNE MODE3_7
					LDA $15AC,x
					BNE MODE3_2
					LDA $157C,x
					BNE MODE3_1
					LDA #$0A
					STA $7FFFDD
					JSL $03DD7D
					JSR HDMA_COLOR
					LDA #$01
					STA $157C,x
					RTS
MODE3_1				LDA #$08
					STA $AA,x
					STZ $B6,x
					LDA $14D4,x
					BNE MODE3_R
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
MODE3_R				RTS
MODE3_2				STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$FE
					BEQ MODE3_3
					CMP #$D0
					BEQ MODE3_4
					CMP #$A0
					BEQ MODE3_4
					CMP #$70
					BEQ MODE3_4
					CMP #$30
					BEQ MODE3_4
					CMP #$01
					BEQ MODE3_6
					RTS
MODE3_3				JSR GEN_SPRITE
					LDA #$50
					STA $00D8,y
					LDA #$01
					STA $157C,y
MODE3_5				LDA #$04
					STA $1504,y
					LDA #$10
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$00
					STA $14D4,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					RTS
MODE3_4				JSR GEN_SPRITE
					LDA #$50
					STA $00D8,y
					LDA #$00
					STA $157C,y
					PHY
					LDY $1570,x
					LDA MODE3_TABLE,y
					PLY
					STA $00D8,y
					INC $1570,x
					BRA MODE3_5
MODE3_6				JSR MEKA_CHECK
					CPY #$01
					BEQ MODE3_6_2
					JSR GEN_MEKA
					LDA #$01
					STA $157C,y
					LDA #$F8
					STA $00E4,y
					LDA #$B0
					STA $00D8,y
					LDA #$00
					STA $14D4,x
					STA $14E0,y
MODE3_6_2			LDA #$FF
					STA $1540,x
					RTS
					
MODE4_SPEED			dcb $00,$FC,$04
MODE4				LDA $1570,x
					AND #$F0
					CMP #$30
					BNE MODE4_0
					JSR MODE4_SUB1
					RTS
MODE4_0				CMP #$40
					BNE MODE4_A
					JSR MODE4_SUB2
					RTS
MODE4_A				CMP #$50
					BNE MODE4_B
					JSR MODE4_SUB3
					RTS
MODE4_B				CMP #$60
					BNE MODE4_C
					JSR MODE4_SUB5
					RTS
MODE4_C				LDA $15AC,x
					BNE MODE4_3
					LDA $38
					CMP #$C0
					BCS MODE4_2
					LDA #$1C
					STA $AA,x
					LDA $14D4,x
					BEQ MODE4_1
					LDA $D8,x
					CMP #$C0
					BCC MODE4_R
MODE4_1				LDA $38
					CMP #$20
					BCS MODE4_1_2
					LDA $14
					AND #$01
					BEQ MODE4_R
MODE4_1_2			INC $38
					INC $39
					LDA $38
					CMP #$40
					BCC MODE4_R
					INC $38
					INC $39
					INC $38
					INC $39
MODE4_R				RTS
MODE4_2				STZ $AA,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE4_3				JSR FACE_CHANGE
					LDA $15AC,x
					CMP #$C0
					BCS MODE4_R
					CMP #$BF
					BEQ MODE4_4
					CMP #$10
					BCS MODE4_5
					RTS
MODE4_4				JSR HDMA_COLOR4
					LDA #$05
					STA $1602,x
					LDA #$17
					STA $1DFC
					LDA #$30
					STA $7FFF65
					LDA #$00
					STA $7FFF64
					LDA $1570,x
					AND #$F0
					STA $1570,x
					LDA $94
					CMP #$30
					BCC MODE4_4_1
					CMP #$C0
					BCS MODE4_4_2
					RTS
MODE4_4_1			LDA $1570,x
					ORA #$01
					STA $1570,x
					RTS
MODE4_4_2			LDA $1570,x
					ORA #$02
					STA $1570,x
					RTS
MODE4_5				LDA $38
					CMP #$03
					BEQ MODE4_5_3
					CMP #$20
					BCS MODE4_5_2
					CMP #$08
					BCS MODE4_5_0
					LDA #$00
					STA $7FFF65
					LDA #$01
					STA $7FFF64
MODE4_5_0			LDA $14
					AND #$01
					BEQ MODE4_5_1
					LDA $38
					CMP #$06
					BCS MODE4_5_2
					JSR MODE4_DAMAGE
MODE4_5_2			DEC $38
					DEC $39
					LDA $38
					CMP #$40
					BCC MODE4_5_1
					DEC $38
					DEC $39
					DEC $38
					DEC $39
MODE4_5_1			REP #$30
					LDA.W $36
					CLC
					ADC.W #$0010
					STA.W $36
					SEP #$30
					LDA $1570,x
					AND #$0F
					TAY
					LDA MODE4_SPEED,y
					STA $B6,x
					RTS
MODE4_5_3			LDA #$C2
					STA $15AC,x
					LDA #$C0
					STA $38
					STA $39
					LDA #$70
					STA $E4,x
					LDA #$00
					STA $14E0,x
					STZ $B6,x
					STZ $36
					STZ $37
					LDA $1570,x
					CLC
					ADC #$10
					STA $1570,x
					CMP #$30
					BCS MODE4_6
					RTS
MODE4_6				LDA #$0A
					STA $7FFFDD
					JSL $03DD7D
					JSR HDMA_COLOR
					LDA #$30
					STA $1570,x
					STZ $1602,x
					LDA #$C0
					STA $38
					STA $39
					LDA #$00
					STA $7FFF65
					LDA #$00
					STA $7FFF64
					RTS
					
MODE5_TABALE		dcb $10,$F0
MODE5				LDA $1540,x
					BEQ MODE5_B
					JSR MODE5_SUB
					RTS
MODE5_B				JSR MODE5_DAMAGE
					JSR BLK_CHECK3
					LDA $1528,x
					CMP #$05
					BNE MODE5_A
					LDA #$FF
					STA $1540,x
					STZ $AA,x
					STZ $B6,x
					LDA #$0C
					STA $39
					LDA #$02
					STA $1602,x
					RTS
MODE5_A				LDA $1570,x
					CMP #$04
					BCC MODE5_0
					JSR GEN_SPRITE
					LDA #$05
					STA $1504,y
					LDA #$78
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					STA $00D8,y
					LDA #$FF
					STA $1540,y
					STZ $1570,x
MODE5_0				LDA $14
					AND #$01
					BEQ MODE5_1
					INC $AA,x
MODE5_1				LDY $157C,x
					LDA MODE5_TABALE,y
					STA $B6,x
					LDA $14D4,x
					BNE MODE5_4
					LDA $D8,x
					CMP #$80
					BCC MODE5_4
					LDA #$D8
					STA $AA,x
					LDA #$08
					STA $1DFC
					INC $1570,x
MODE5_4				JSR MODE5_SIZE
MODE5_5				LDA $E4,x
					CMP #$D0
					BCS MODE5_2
					CMP #$20
					BCC MODE5_3
					RTS
MODE5_2				LDA #$01
					STA $157C,x
					RTS
MODE5_3				STZ $157C,x
					RTS
					
MODE5_SIZE			LDA $14D4,x
					BNE MODE5_SIZE_3
					LDA $AA,x
					CMP #$80
					BCS MODE5_SIZE_2
					LDA $D8,x
					CMP #$60
					BCC MODE5_SIZE_3
					LDA $14
					AND #$01
					BEQ MODE5_SIZE_R
					INC $39
MODE5_SIZE_R		RTS
MODE5_SIZE_2		LDA $D8,x
					CMP #$60
					BCC MODE5_SIZE_3
					LDA $14
					AND #$01
					BEQ MODE5_SIZE_R
					DEC $39
					RTS
MODE5_SIZE_3		LDA #$0C
					STA $39
					RTS
					
MODE6_TABLE			dcb $0C,$F4
MODE6				LDA $1540,x
					BEQ MODE6_0
					JSR MODE6_SUB
					RTS
MODE6_0				LDA $15AC,x
					CMP #$D1
					BCS MODE6_R
					CMP #$D0
					BEQ MODE6_1
					CMP #$90
					BCS MODE6_R
					CMP #$01
					BCS MODE6_4
					STZ $AA,x
					STZ $B6,x
					LDA #$FF
					STA $1540,x
MODE6_R				RTS
MODE6_1				LDA #$10
					STA $1DF9
					JSR HDMA_COLOR5
					RTS
MODE6_2				LDA #$01
					STA $157C,x
					RTS
MODE6_3				STZ $157C,x
					RTS
MODE6_4				LDY $157C,x
					LDA MODE6_TABLE,y
					STA $B6,x
					STZ $AA,x
					LDA $E4,x
					CMP #$90
					BCS MODE6_2
					CMP #$50
					BCC MODE6_3
					RTS
					
MODE7				STZ $AA,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE7_R
					CMP #$BF
					BEQ MODE7_2
					CMP #$41
					BCS MODE7_1
					CMP #$40
					BEQ MODE7_3
					CMP #$01
					BEQ MODE7_4
					RTS
MODE7_2				LDA #$2B
					STA $1DFC
MODE7_R				RTS
MODE7_1				INC $38
					INC $39
					REP #$30
					LDA.W $36
					CLC
					ADC.W #$20
					STA.W $36
					SEP #$30
					RTS
MODE7_3				LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $D8,x
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR SUB_SMOKE
					LDA #$60
					STA $D8,x
					LDA #$FF
					STA $14D4,x
					LDA #$
					RTS
MODE7_4				LDA $1FF2
					AND #$E7
					STA $1FF2
					LDA $1EC5
					AND #$BF
					STA $1EC5 ;#ԃtO폜
					LDA $1F34
					AND #$CF
					STA $1F34
					LDA #$01
					STA $13CE ;#NAtO
					LDA #$01
					STA $0DD5
					INC $1DE9
					LDA #$0B
					STA $0100
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE3_SUB			LDA $14D4,x
					CMP #$FF
					BNE MODE3_SUB_R
					LDA $D8,x
					CMP #$AC
					BCS MODE3_SUB_R
					INC $151C,x
					LDA #$0B
					STA $7FFFDD
					JSL $03DD7D
					JSR HDMA_COLOR
					LDA #$
					STA $1602,x
					LDA #$10
					STA $AA,x
					LDA #$70
					STA $E4,x
					LDA #$04
					STA $1602,x
					STZ $15AC,x
					STZ $157C,x
					STZ $1558,x
					STZ $1540,x
					STZ $1570,x
MODE3_SUB_R			RTS

MODE4_SUB1			LDA $38
					CMP #$10
					BEQ MODE4_SUB1_2
					DEC $38
					DEC $39
					LDA $38
					CMP #$40
					BCC MODE4_SUB1_1
					DEC $38
					DEC $39
					DEC $38
					DEC $39
MODE4_SUB1_1		LDA #$EC
					STA $AA,x
					RTS
MODE4_SUB1_2		STZ $AA,x
					LDA #$40
					STA $1570,x
					LDA #$60
					STA $15AC,x
					RTS
					
MODE4_SUB2_TABLE	dcb $10,$F0
MODE4_SUB2_TABLE2	dcb $20,$E0
MODE4_SUB2			JSR MODE4_DAMAGE2
					JSR BLK_CHECK2
					LDA $1528,x
					CMP #$04
					BNE MODE4_SUB2_1
					LDA #$FF
					STA $1558,x
					LDA #$60
					STA $1570,x
					STZ $B6,x
					LDA #$02
					STA $1602,x
					RTS
MODE4_SUB2_1		LDA $1570,x
					AND #$0F
					CMP #$04
					BEQ MODE4_SUB2_2
					CMP #$05
					BEQ MODE4_SUB2_4
					JSR MODE4_DER
					LDY $157C,x
					LDA MODE4_SUB2_TABLE,y
					STA $B6,x
					STZ $AA,x
MODE4_SUB2_R		RTS
MODE4_SUB2_2		STZ $B6,x
					LDA $15AC,x
					BNE MODE4_SUB2_R
					LDA #$40
					STA $AA,x
					LDA $D8,x
					CMP #$70
					BCS MODE4_SUB2_3
					RTS
MODE4_SUB2_3		LDA #$70
					STA $D8,x
					LDA #$30
					STA $1887
					LDA #$10
					STA $1DFC
					STZ $AA,x
					INC $1570,x
					LDA #$40
					STA $15AC,x
					RTS
MODE4_SUB2_4		LDA $15AC,x
					CMP #$01
					BEQ MODE4_SUB2_5
					CMP #$00
					BEQ MODE4_SUB2_6
					RTS
MODE4_SUB2_5		STZ $157C,x
					LDA $E4,x
					CLC
					ADC #$08
					CMP $94
					BCC MODE4_SUB2_R
					LDA #$01
					STA $157C,x
					RTS
MODE4_SUB2_6		LDA $E4,x
					STA $7FFFE4
					LDY $157C,x
					LDA MODE4_SUB2_TABLE2,y
					STA $B6,x
					LDA $157C,x
					BEQ MODE4_SUB2_7
					REP #$30
					LDA.W $36
					SEC
					SBC.W #$10
					STA.W $36
					SEP #$30
					LDA $14E0,x
					BEQ MODE4_SUB2_R2
					LDA $E4,x
					CMP #$C8
					BCC MODE4_SUB2_8
MODE4_SUB2_R2		RTS
MODE4_SUB2_7		LDA #$01
					REP #$30
					LDA.W $36
					CLC
					ADC.W #$10
					STA.W $36
					SEP #$30
					LDA $14E0,x
					BEQ MODE4_SUB2_R2
					LDA $E4,x
					CMP #$38
					BCS MODE4_SUB2_8
					RTS
MODE4_SUB2_8		LDA $157C,x
					EOR #$01
					STA $157C,x
					LDA #$0A
					STA $D8,x
					LDA #$00
					STA $14D4,x
					LDA #$02
					STA $1602,x
					LDA #$50
					STA $1570,x
					STZ $36
					STZ $37
					RTS
					
MODE4_SUB3_TABLE	dcb $10,$F0
MODE4_SUB3			LDA $1540,x
					BEQ MODE4_SUB3_1
					JSR MODE4_SUB4
					RTS
MODE4_SUB3_1		LDY $157C,x
					LDA MODE4_SUB3_TABLE,y
					STA $B6,x
					LDA $14E0,x
					BNE MODE4_SUB3_2
					LDA $E4,x
					CMP #$30
					BCC MODE4_SUB3_2
					CMP #$B0
					BCS MODE4_SUB3_2
					STZ $B6,x
					LDA $15AC,x
					CMP #$C0
					BCS MODE4_SUB3_R
					CMP #$BF
					BEQ MODE4_SUB3_3
					CMP #$60
					BCS MODE4_SUB3_4
					CMP #$5F
					BEQ MODE4_SUB3_5
MODE4_SUB3_R		RTS
MODE4_SUB3_2		LDA #$FF
					STA $15AC,x
					RTS
MODE4_SUB3_3		LDA #$60
					STA $1887
					LDA #$01
					STA $1602,x
					LDA #$60
					STA $1887
					LDA #$20
					STA $1DFC
					RTS
MODE4_SUB3_4		AND #$08
					BNE MODE4_SUB3_4_2
					LDA #$0C
					STA $38
					STA $39
					RTS
MODE4_SUB3_4_2		LDA #$10
					STA $38
					STA $39
					RTS
MODE4_SUB3_5		STZ $1602,x
					LDA #$FF
					STA $1887
					STA $1540,x
					BRA MODE4_SUB3_4_2
					

MODE4_SUB4			LDA $1540,x
					CMP #$20
					BEQ MODE4_SUB4_2
					AND #$1F
					BNE MODE4_SUB4_R
					LDA #$2B
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$02
					STA $1504,y
					LDA #$3F
					STA $166E,y
					LDA #$03
					STA $167A,y
					LDA #$00
					STA $00B6,y
					STA $157C,y
					JSL $01ACF9
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$00
					STA $00D8,y
					STA $14D4,y
					INC $1570,x
MODE4_SUB4_R		RTS
MODE4_SUB4_2		JSR GEN_NORMAL
					LDA #$C0
					STA $1540,y
					JSL $01ACF9
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					LDA #$00
					STA $00D8,y
					STA $14D4,y
					LDA #$30
					STA $1570,x
					LDA #$60
					STA $15AC,x
					STZ $1540,x
					RTS
					
MODE4_DAMAGE2		LDA #$07
					STA $1662,x
					LDA #$23
					STA $167A,x
					LDA $E4,x
					PHA
					SEC
					SBC #$18
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
MODE5_DAMAGE		LDA #$07
					STA $1662,x
					LDA #$23
					STA $167A,x
					LDA $E4,x
					PHA
					SEC
					SBC #$18
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$20
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$30
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
MODE4_SUB5			LDA $1558,x
					CMP #$D0
					BCS MODE4_SUB5_R
					CMP #$CF
					BEQ MODE4_SUB5_1
					CMP #$90
					BCS MODE4_SUB5_2
					CMP #$8F
					BEQ MODE4_SUB5_3
					RTS
MODE4_SUB5_1		LDA #$0E
					STA $1DFC
MODE4_SUB5_R		RTS
MODE4_SUB5_2		LDA $38
					CMP #$0D
					BCC MODE4_SUB5_R
					LDA $14
					AND #$03
					BNE MODE4_SUB5_R
					DEC $38
					DEC $39
					RTS
MODE4_SUB5_3		STZ $1570,x
					STZ $15AC,x
					STZ $1540,x
					STZ $1558,x
					INC $151C,x
					STZ $1602,x
					RTS
					
MODE5_SUB			LDA $1540,x
					CMP #$D0
					BCS MODE5_SUB_R
					CMP #$CF
					BEQ MODE5_SUB_1
					CMP #$90
					BCS MODE5_SUB_2
					CMP #$8F
					BEQ MODE5_SUB_3
					RTS
MODE5_SUB_1			LDA #$0E
					STA $1DFC
MODE5_SUB_R			RTS
MODE5_SUB_2			LDA $38
					CMP #$07
					BCC MODE5_SUB_R
					LDA $14
					AND #$03
					BNE MODE5_SUB_R
					DEC $38
					DEC $39
					RTS
MODE5_SUB_3			STZ $1570,x
					LDA #$FF
					STA $15AC,x
					STZ $1540,x
					STZ $1558,x
					INC $151C,x
					LDA #$40
					STA $D8,x
					STZ $14D4,x
					RTS
					
					
MODE6_DAMAGE		LDA $1602,x
					BNE MODE6_DAMAGE_R
					LDA $1497
					BNE MODE6_DAMAGE_R
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS MODE6_DAMAGE_2
					LDA $94
					SEC
					SBC $E4,x
					CMP #$40
					BCS MODE6_DAMAGE_R
					JSL $00F5B7
					RTS
MODE6_DAMAGE_2		LDA $E4,x
					SEC
					SBC $94
					CMP #$40
					BCS MODE6_DAMAGE_R
					JSL $00F5B7
MODE6_DAMAGE_R		RTS




MODE6_SUB			JSR MEKA_CHECK6
					LDA $1528,x
					CMP #$06
					BEQ MODE6_SUB_R
					LDA $1540,x
					CMP #$01
					BEQ MODE6_SUB_4
					CMP #$C0
					BEQ MODE6_SUB_1
					CMP #$80
					BEQ MODE6_SUB_2
					CMP #$40
					BEQ MODE6_SUB_6
					JSR MODE6_DAMAGE
MODE6_SUB_R			RTS
MODE6_SUB_1			LDA #$10
					STA $1DF9
					JSR HDMA_COLOR
					RTS
MODE6_SUB_2			STZ $1602,x
					LDA $157C,x
					BNE MODE6_SUB_3
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					RTS
MODE6_SUB_3			LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE6_SUB_4			LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $1602,x
					LDA $157C,x
					BEQ MODE6_SUB_5
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					RTS
MODE6_SUB_5			LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					RTS
MODE6_SUB_6			JSR GEN_MEKA
					LDA $94
					STA $00E4,y
					LDA $95
					STA $14E0,y
					LDA #$D0
					STA $00D8,y
					LDA #$FF
					STA $14D4,y
					RTS
					
MODE4_DER			LDA $E4,x
					CMP #$08
					BCC MODE4_DER_2
					CMP #$D8
					BCS MODE4_DER_3
					LDA $15AC,x
					BNE MODE4_DER_R
					INC $1570,x
					LDA #$60
					STA $15AC,x
					LDA $E4,x
					CLC
					ADC #$08
					CMP $94
					BCS MODE4_DER_3
MODE4_DER_2			STZ $157C,x
MODE4_DER_R			RTS
MODE4_DER_3			LDA #$01
					STA $157C,x
					RTS



MODE4_DAMAGE		LDA $1497
					BNE MODE4_DAMAGE_R
					LDA $1570,x
					AND #$0F
					CMP #$01
					BEQ MODE4_DAMAGE_3
					CMP #$02
					BEQ MODE4_DAMAGE_2
					LDA $94
					CMP #$30
					BCC MODE4_DAMAGE_R
					CMP #$C0
					BCS MODE4_DAMAGE_R
MODE4_DAMAGE_1		JSL $00F5B7
MODE4_DAMAGE_R		RTS
MODE4_DAMAGE_2		LDA $94
					CMP #$60
					BCS MODE4_DAMAGE_1
					RTS
MODE4_DAMAGE_3		LDA $94
					CMP #$90
					BCC MODE4_DAMAGE_1
					RTS

MOVE_MEKA			PHX
					LDY #$00
					LDX #$00
MOVE_MEKA_1			LDA $9E,x
					CMP #$A2
					BNE MOVE_MEKA_2
					LDA $14C8,x
					CMP #$08
					BNE MOVE_MEKA_2
					LDA $14E0,x
					BNE MOVE_MEKA_3
					LDA #$01
					STA $157C,x
					LDA #$D0
					STA $B6,x
					INC $1570,x
					BRA MOVE_MEKA_2
MOVE_MEKA_3			STZ $14C8,x
MOVE_MEKA_2			INX
					CPX #$0A
					BNE MOVE_MEKA_1
					PLX
					RTS


MEKA_CHECK			PHX
					LDY #$00
					LDX #$00
MEKA_CHECK_1		LDA $9E,x
					CMP #$A2
					BNE MEKA_CHECK_2
					LDA $14C8,x
					CMP #$08
					BCC MEKA_CHECK_2
					LDY #$01
MEKA_CHECK_2		INX
					CPX #$0A
					BNE MEKA_CHECK_1
					PLX
					RTS

SIZE_SUB1			LDA $B6,x
					CMP #$80
					BCC SIZE_SUB1_RIGHT
					LDA #$01
					STA $7FFF64
					STZ $1570,x
					LDA #$80
					CLC
					ADC $B6,x
					LSR A
					LSR A
					STA $38
					STA $39
					RTS
SIZE_SUB1_RIGHT		LDA #$00
					STA $7FFF64
					LDA $B6,x
					LSR A
					CLC
					ADC #$20
					STA $38
					STA $39
					LDA $E4,x
					CMP #$70
					BCS SIZE_SUB1_2
					LDA $B6,x
					CMP #$10
					BCC SIZE_SUB1_3
					CMP #$20
					BCC SIZE_SUB1_4
					LDA #$03
					STA $1570,x
					RTS
SIZE_SUB1_3			LDA #$01
					STA $1570,x
					RTS
SIZE_SUB1_4			LDA #$02
					STA $1570,x
					RTS
SIZE_SUB1_2			LDA $B6,x
					CMP #$10
					BCC SIZE_SUB1_5
					CMP #$20
					BCC SIZE_SUB1_6
					LDA #$03
					STA $1570,x
					RTS
SIZE_SUB1_5			LDA #$05
					STA $1570,x
					RTS
SIZE_SUB1_6			LDA #$04
					STA $1570,x
					RTS



ATACK_CHECK1		JSL $01A7DC
					BCC DAMAGE_R
					LDA $1497
					BNE DAMAGE_R
					JSL $00F5B7
DAMAGE_R			RTS

ATACK_CHECK2_R		RTS
ATACK_CHECK2		LDA $38
					CMP #$1B
					BCC ATACK_CHECK2_R
					CMP #$26
					BCS ATACK_CHECK2_R
					LDA $E4,x
					PHA
					CLC
					ADC #$08
					STA $E4,x
					LDA $D8,x
					PHA
					CLC
					ADC #$28
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS ATACK_CHECK2_2
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCS ATACK_CHECK2_2
ATACK_CHECK2_1		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $E4,x
					RTS
ATACK_CHECK2_2		LDA $7D
					CMP #$80
					BCS ATACK_CHECK2_3
					CMP #$08
					BCC ATACK_CHECK2_3
					JSR SUB_SMOKE
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $E4,x
					JSR GEN_FEATURE
					LDA #$3B
					STA $1540,y
					STA $154C,y
					LDA #$D0
					STA $00AA,y
					LDA #$08
					STA $1DF9
					LDA #$D0
					STA $E4,x
					LDA #$00
					STA $14E0,x
					LDA #$FF
					STA $14D4,x
					LDA #$B0
					STA $D8,x
					STZ $B6,x
					INC $151C,x
					STZ $1602,x
					STZ $157C,x
					STZ $15AC,x
					LDA #$20
					STA $38
					STA $39
					INC $1528,x
					STZ $1558,x
					LDA #$00
					STA $7FFF64
					RTS
ATACK_CHECK2_3		LDA $1497
					BNE ATACK_CHECK2_1
					JSL $00F5B7
					BRA ATACK_CHECK2_1

SPEED_DEC3			LDA #$C0
					STA $00AA,y
					LDA $00E4,y
					CMP $94
					BCC MODE0_RIGHT
					LDA $00E4,y
					SEC
					SBC $94
					LSR A
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $00B6,y
MODE0_R				RTS
MODE0_RIGHT			LDA $94
					SEC
					SBC $00E4,y
					LSR A
					LSR A
					STA $00B6,y
					RTS
					
				
					
KAME_CHECK			TXY
					PHX
					LDX #$00
KAME_LOOP			LDA $9E,x
					CMP #$A2
					BNE KAME_CHECK_2
					LDA $14C8,x
					CMP #$09
					BCC KAME_CHECK_2
					LDA $14E0,x
					BNE KAME_CHECK_2
					LDA $14D4,x
					BNE KAME_CHECK_2
					LDA $D8,x
					CMP #$40
					BCS KAME_CHECK_2
					CMP #$20
					BCC KAME_CHECK_2
					LDA $00E4,y
					CMP #$C0
					BCC KAME_CHECK_2
					CMP #$F0
					BCS KAME_CHECK_2
					LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					JSR SPRITE_DEL
					LDA #$02
					STA $1602,y
					LDA #$FF
					STA $1558,y
KAME_CHECK_2		INX
					CPX #$0A
					BCC KAME_LOOP
					PLX
					RTS

MEKA_CHECK6			LDA $7FE301
					CMP #$C5
					BEQ MEKA_CHECK6_A
					RTS
MEKA_CHECK6_A		TXY
					PHX
					LDX #$00
MEKA_CHECK6_LOOP	LDA $9E,x
					CMP #$A2
					BNE MEKA_CHECK6_2
					LDA $14C8,x
					CMP #$09
					BCC MEKA_CHECK6_2
					LDA $00E4,y
					SEC
					SBC $E4,x
					LDA $14E0,y
					SBC $14E0,x
					BCC MEKA_CHECK6_1
					LDA $00E4,y
					SEC
					SBC $E4,x
					STA $0F
					LDA $14E0,y
					SBC $14E0,x
					BNE MEKA_CHECK6_2
					LDA $0F
					CMP #$50
					BCS MEKA_CHECK6_2
MEKA_CHECK6_3		LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					LDA #$1E
					STA $1DFB
					LDA $151C,y
					INC A
					STA $151C,y
					LDA #$FF
					STA $15AC,y
					JSR SPRITE_DEL
					LDA #$02
					STA $1602,x
					STZ $B6,x
MEKA_CHECK6_2		INX
					CPX #$0A
					BCC MEKA_CHECK6_LOOP
					PLX
					RTS
MEKA_CHECK6_1		LDA $E4,x
					SEC
					SBC $00E4,y
					STA $0F
					LDA $14E0,x
					SBC $14E0,y
					BNE MEKA_CHECK6_2
					LDA $0F
					CMP #$50
					BCS MEKA_CHECK6_2
					BRA MEKA_CHECK6_3
					


BLK_CHECK2			TXY
					PHX
					LDX #$00
BLK2_LOOP			LDA $9E,x
					CMP #$53
					BNE BLK_CHECK2_2
					LDA $14C8,x
					CMP #$09
					BCC BLK_CHECK2_2
					LDA $1540,x
					CMP #$90
					BCS BLK_CHECK2_2
					LDA $14E0,x
					BNE BLK_CHECK2_2
					LDA $14D4,x
					BNE BLK_CHECK2_2
					LDA $00D8,y
					CLC
					ADC #$10
					CMP $D8,x
					BCS BLK_CHECK2_2
					LDA $00D8,y
					CLC
					ADC #$50
					CMP $D8,x
					BCC BLK_CHECK2_2
					LDA $00E4,y
					SEC
					SBC #$18
					CMP $E4,x
					BCS BLK_CHECK2_2
					LDA $00E4,y
					CLC
					ADC #$30
					CMP $E4,x
					BCC BLK_CHECK2_2
					LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					STA $7FFF28
					JSR SPRITE_DEL
					LDA #$02
					STA $1602,x
					STZ $B6,x
BLK_CHECK2_2		INX
					CPX #$0A
					BCC BLK2_LOOP
					PLX
					RTS


BLK_CHECK3			TXY
					PHX
					LDX #$00
BLK3_LOOP			LDA $9E,x
					CMP #$53
					BNE BLK_CHECK3_2
					LDA $14C8,x
					CMP #$09
					BCC BLK_CHECK3_2
					LDA $1540,x
					CMP #$90
					BCS BLK_CHECK3_2
					LDA $14E0,x
					BNE BLK_CHECK3_2
					LDA $14D4,x
					BNE BLK_CHECK3_2
					LDA $00D8,y
					CMP $D8,x
					BCS BLK_CHECK3_2
					LDA $00D8,y
					CLC
					ADC #$60
					CMP $D8,x
					BCC BLK_CHECK3_2
					LDA $00E4,y
					SEC
					SBC #$20
					CMP $E4,x
					BCS BLK_CHECK3_2
					LDA $00E4,y
					CLC
					ADC #$30
					CMP $E4,x
					BCC BLK_CHECK3_2
					LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					STA $7FFF28
					JSR SPRITE_DEL
					LDA #$02
					STA $1602,x
					STZ $B6,x
BLK_CHECK3_2		INX
					CPX #$0A
					BCC BLK3_LOOP
					PLX
					RTS
					
BLK_CHECK			TXY
					PHX
					LDX #$00
BLK_LOOP			LDA $9E,x
					CMP #$53
					BNE BLK_CHECK_2
					LDA $14C8,x
					CMP #$09
					BCC BLK_CHECK_2
					LDA $1540,x
					CMP #$90
					BCS BLK_CHECK_2
					LDA $14E0,x
					BNE BLK_CHECK_2
					LDA $14D4,x
					BNE BLK_CHECK_2
					LDA $D8,x
					CMP #$48
					BCS BLK_CHECK_2
					CMP #$38
					BCC BLK_CHECK_2
					LDA $00E4,y
					SEC
					SBC #$10
					CMP $E4,x
					BCS BLK_CHECK_2
					CLC
					ADC #$20
					CMP $E4,x
					BCC BLK_CHECK_2
					LDA #$28
					STA $1DFC
					STZ $14C8,x
					LDA $1528,y
					INC A
					STA $1528,y
					JSR SPRITE_DEL
BLK_CHECK_2			INX
					CPX #$0A
					BCC BLK_LOOP
					PLX
					RTS
					
SPRITE_DEL			TYA
					STA $7FFF02
					PHX
					LDX #$00
SPRITE_DEL_LOOP		TXA
					CMP $7FFF02
					BEQ SPRITE_DEL_2
					STZ $14C8,x
SPRITE_DEL_2		INX
					CPX #$0A
					BCC SPRITE_DEL_LOOP
					PLX
					RTS
					
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS 
					
FACE_CHANGE			LDA $19
					BEQ FACE2
					LDA $0D87
					CMP #$80
					BNE FACE1
					LDA $0D86
					CMP #$51
					BEQ FACE_E
					LDA $0D86
					CMP #$58
					BEQ FACE_E
FACE1				LDA #$71
					STA $0D86
					LDA #$00
					STA $0D85
					LDA #$73
					STA $0D90
					LDA #$00
					STA $0D8F
					RTS
FACE2				LDA $0D92
					CMP #$73
					BNE FACE3
					LDA $0D91
					CMP #$80
					BEQ FACE_E
					BRA FACE4
FACE3				CMP #$56
					BNE FACE4
					LDA $0D91
					CMP #$40
					BEQ FACE_E
FACE4				LDA #$78
					STA $0D88
					LDA #$C0
					STA $0D87
					LDA #$6A
					STA $0D90
					LDA #$80
					STA $0D8F
FACE_E				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)

                    PHX                     ; push sprite index

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$24
                    STA $0302,y             ; / 

                    LDA #$00
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

TILEMAP_B			dcb $86,$A6,$A6,$86
PROPERTIES_B        dcb $00,$00,$80,$80

SUB_GFX_B           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    PHX                     ; push sprite index
					LDA $14
					LSR A
					LSR A
					AND #$03
					TAX
					LDA TILEMAP_B,x
					STA $03
					LDA PROPERTIES_B,x
					STA $0F

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA $03
                    STA $0302,y             ; / 

                    LDA $0F
                    ORA #$04
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
BU_COLOR			dcb $00,$02,$04,$06,$08,$0A,$0C,$0E
SUB_GFX_BL          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                    
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$40
                    STA $0302,y             ; / 

                    PHX
					LDA $14
					LSR A
					LSR A
					AND #$07
					TAX
					LDA BU_COLOR,x
					PLX
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
TILEMAP_T           dcb $82,$84,$A2,$A4
					dcb $8A,$8C,$AA,$AC
HORZ_DISP_T         dcb $F8,$08,$F8,$08
VERT_DISP_T         dcb $F8,$F8,$08,$08
					
SUB_GFX_T			JSR GET_DRAW_INFO
					LDA $157C,x
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$03
LOOP_STARTT         LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
					CLC
					ADC HORZ_DISP_T,x
                    STA $0300,y             ; /
					LDA $01
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP_T,x         ; |
                    STA $0301,y             ; /
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_T,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
                    LDA #$0C
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_STARTT
                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
GEN_SPIRITE_2       PLX
                    
					LDA $E4,x
					CLC
					ADC #$08
                    STA $00E4,y
                    LDA $14E0,x
					ADC #$00
                    STA $14E0,y             ; /

					LDA $D8,x
					CLC
					ADC #$30
                    STA $00D8,y             ;  |
                    LDA $14D4,x
					ADC #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

GEN_FEATURE			JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    LDA #$77
                    STA $009E,y
					BRA GEN_NORMAL_2
GEN_MEKA			JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    LDA #$A2
                    STA $009E,y
					BRA GEN_NORMAL_2
RETURNK68           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK68            ; / after: Y has index of sprite being generated

                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$53
                    STA $009E,y
GEN_NORMAL_2                    
                    LDA $E4,x               ;\ set x position for new sprite
					CLC
					ADC #$08
                    STA $00E4,y

                    LDA $14E0,x             ;  |
					ADC #$00
                    STA $14E0,y             ; /

                    LDA $D8,x               ;\ set y position for new sprite
					CLC
					ADC #$30
					STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
					ADC #$00
					STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GRAPHIC_ROUTINE		LDA $14E0,x		;A:87C8 X:0009 Y:0004 P:eNvMXdizC
					XBA				;A:8700 X:0009 Y:0004 P:envMXdiZC
					LDA $E4,x		;A:0087 X:0009 Y:0004 P:eNvMXdizC
					LDY #$00		;A:00B2 X:0009 Y:0004 P:eNvMXdizC
					JSR SUB_DFAE		;#AxW(16bit)AY=0Ŏs
					LDA $14D4,x
					XBA
					LDA $D8,x
					LDY #$02
					JSR SUB_DFAE		;#AyW(16bit)AY=2Ŏs
					PHX
					REP #$30
					STZ $06
					LDY.W #$0003
					LDA.W $0D9B
					LSR A
					SEP #$30
					PLX
					LDA #$20
					STA $C6C0
					RTS

SUB_DFAE			PHX
					TYX
					REP #$20
					EOR #$FFFF
					INC A
					CLC
					ADC $03DEBB,x
					CLC
					ADC $1A,x ;#(xWȂ1A yWȂȂ2C)
					STA $3A,x
					SEP #$20
					PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Nbp͑Ŝ64x96sNZ̃TCY8x8TCYŃOtBbNw肵܂
;l̓^Cԍ~QŁA+1ōE]܂
;ʒuƃAhX͉̃e[u̒ʂł
;C6C0	C6C1	C6C2	C6C3	C6C4	C6C5	C6C6	C6C7
;C6C8	C6C9	C6CA	C6CB	C6CC	C6CD	C6CE	C6CF
;C6D0	C6D1	C6D2	C6D3	C6D4	C6D5	C6D6	C6D7
;C6D8	C6D9	C6DA	C6DB	C6DC	C6DD	C6DE	C6DF
;C688	C689	C68A	C68B	C68C	C68D	C68E	C68F
;C690	C691	C692	C693	C694	C695	C696	C697
;C698	C699	C69A	C69B	C69C	C69D	C69E	C69F
;C6A0	C6A1	C6A2	C6A3	C6A4	C6A5	C6A6	C6A7
;C6A8	C6A9	C6AA	C6AB	C6AC	C6AD	C6AE	C6AF
;C6B0	C6B1	C6B2	C6B3	C6B4	C6B5	C6B6	C6B7
;C6B8	C6B9	C6BA	C6BB	C6BC	C6BD	C6BE	C6BF
;C680	C681	C682	C683	C684	C685	C686	C687

GRA_TABLE1			dcb $FF,$00,$02,$04,$06,$08,$0A,$FF
					dcb $FF,$20,$22,$24,$26,$28,$2A,$FF
					dcb $FF,$40,$42,$44,$46,$48,$4A,$FF
					dcb $FF,$60,$62,$64,$66,$68,$6A,$FF
					dcb $FF,$80,$82,$84,$86,$88,$8A,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $FF,$0B,$09,$07,$05,$03,$01,$FF
					dcb $FF,$2B,$29,$27,$25,$23,$21,$FF
					dcb $FF,$4B,$49,$47,$45,$43,$41,$FF
					dcb $FF,$6B,$69,$67,$65,$63,$61,$FF
					dcb $FF,$8B,$89,$87,$85,$83,$81,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $FF,$00,$02,$04,$06,$08,$0A,$FF
					dcb $FF,$20,$22,$24,$26,$28,$2A,$FF
					dcb $FF,$A0,$42,$44,$46,$48,$4A,$FF
					dcb $FF,$C0,$62,$64,$66,$68,$6A,$FF
					dcb $FF,$E0,$82,$84,$86,$88,$8A,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $FF,$0B,$09,$07,$05,$03,$01,$FF
					dcb $FF,$2B,$29,$27,$25,$23,$21,$FF
					dcb $FF,$4B,$49,$47,$45,$43,$A1,$FF
					dcb $FF,$6B,$69,$67,$65,$63,$C1,$FF
					dcb $FF,$8B,$89,$87,$85,$83,$E1,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					
GRA_TABLE2			dcb $FF,$0C,$0E,$10,$12,$14,$16,$FF
					dcb $FF,$2C,$2E,$30,$32,$34,$36,$FF
					dcb $FF,$4C,$4E,$50,$52,$54,$56,$FF
					dcb $FF,$6C,$6E,$70,$72,$74,$76,$FF
					dcb $FF,$8C,$8E,$90,$92,$94,$FF,$FF
					dcb $FF,$AC,$AE,$B0,$B2,$B4,$FF,$FF
					dcb $FF,$17,$15,$13,$11,$0F,$0D,$FF
					dcb $FF,$37,$35,$33,$31,$2F,$2D,$FF
					dcb $FF,$57,$55,$53,$51,$4F,$4D,$FF
					dcb $FF,$77,$75,$73,$71,$6F,$6D,$FF
					dcb $FF,$FF,$95,$93,$91,$8F,$8D,$FF
					dcb $FF,$FF,$B5,$B3,$B1,$AF,$AD,$FF
					
GRA_TABLE3			dcb $FF,$FF,$18,$1A,$1C,$1E,$BA,$BC
					dcb $FF,$FF,$38,$3A,$3C,$3E,$DA,$DC
					dcb $FF,$FF,$58,$5A,$5C,$5E,$FA,$FC
					dcb $FF,$FF,$78,$7A,$7C,$7E,$B6,$B8
					dcb $FF,$FF,$98,$9A,$9C,$9E,$D6,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $BD,$BB,$1F,$1D,$1B,$19,$FF,$FF
					dcb $DD,$DB,$3F,$3D,$3B,$39,$FF,$FF
					dcb $FD,$FB,$5F,$5D,$5B,$59,$FF,$FF
					dcb $B9,$B7,$7F,$7D,$7B,$79,$FF,$FF
					dcb $FF,$D7,$9F,$9D,$9B,$99,$FF,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					
GRA_TABLE4			dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$34,$36,$36,$35,$FF,$FF
					dcb $FF,$FF,$54,$36,$36,$55,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF
					dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$34,$36,$36,$1B,$FF,$FF
					dcb $FF,$FF,$54,$36,$36,$3B,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF
					dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$34,$36,$18,$59,$FF,$FF
					dcb $FF,$FF,$54,$36,$38,$79,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF
					dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$34,$18,$56,$35,$FF,$FF
					dcb $FF,$FF,$54,$38,$39,$55,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF
					dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$58,$56,$36,$35,$FF,$FF
					dcb $FF,$FF,$78,$39,$36,$55,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF
					dcb $FF,$FF,$14,$16,$17,$15,$FF,$FF
					dcb $FF,$FF,$1A,$36,$36,$35,$FF,$FF
					dcb $FF,$FF,$3A,$36,$36,$55,$FF,$FF
					dcb $FF,$FF,$74,$76,$77,$75,$FF,$FF

GRA_TABLE5			dcb $FF,$0B,$09,$07,$05,$03,$01,$FF
					dcb $FF,$2B,$29,$27,$25,$23,$21,$FF
					dcb $FF,$4B,$49,$47,$45,$43,$41,$FF
					dcb $FF,$6B,$69,$67,$65,$63,$61,$FF
					dcb $FF,$8B,$89,$87,$85,$83,$81,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					
GRA_TABLE6			dcb $FF,$FF,$0C,$0E,$10,$FF,$FF,$FF
					dcb $FF,$FF,$2C,$2E,$30,$FF,$FF,$FF
					dcb $FF,$FF,$4C,$4E,$50,$52,$FF,$FF
					dcb $FF,$FF,$6C,$6E,$70,$72,$FF,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					dcb $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
					
GRAPHIC0			LDA $1602,x
					BNE GRAPHIC0_1
					JSR GRAPHIC
					RTS
GRAPHIC0_1			CMP #$01
					BNE GRAPHIC0_2
					JSR GRAPHIC2
					RTS
GRAPHIC0_2			CMP #$02
					BNE GRAPHIC0_3
					JSR GRAPHIC3
					RTS
GRAPHIC0_3			CMP #$03
					BNE GRAPHIC0_4
					JSR GRAPHIC4
					RTS
GRAPHIC0_4			CMP #$04
					BNE GRAPHIC0_5
					JSR GRAPHIC5
					RTS
GRAPHIC0_5			JSR GRAPHIC6
					RTS

GRAPHIC				STZ $02
					LDA $157C,x
					BEQ GRAPHIC_1
					LDA #$30
					STA $02
GRAPHIC_1			LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ GRAPHIC_2
					LDA $02
					CLC
					ADC #$60
					STA $02
GRAPHIC_2			PHX
					LDX #$00
GRAPHIC_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE1,x
					PLX
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC_LOOP
					PLX
					RTS
					
GRAPHIC2			STZ $02
					LDA $157C,x
					BEQ GRAPHIC2_1
					LDA #$30
					STA $02
GRAPHIC2_1			PHX
					LDX #$00
GRAPHIC2_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE2,x
					PLX
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC2_LOOP
					PLX
					RTS
					
GRAPHIC3			STZ $02
					LDA $157C,x
					BEQ GRAPHIC3_1
					LDA #$30
					STA $02
GRAPHIC3_1			PHX
					LDX #$00
GRAPHIC3_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE3,x
					PLX
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC3_LOOP
					PLX
					RTS

GRAPHIC4			STZ $02
					LDA $1570,x
					BEQ GRAPHIC4_2
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					STA $02
GRAPHIC4_2			PHX
					LDX #$00
GRAPHIC4_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE4,x
					PLX
					STA $7EC690,x
					INX
					CPX #$20
					BCC GRAPHIC4_LOOP
					PLX
					RTS
					
GRAPHIC5			PHX
					LDX #$00
GRAPHIC5_LOOP		LDA GRA_TABLE5,x
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC5_LOOP
					PLX
					RTS
					
GRAPHIC6			PHX
					LDX #$00
GRAPHIC6_LOOP		LDA GRA_TABLE6,x
					STA $7EC688,x
					INX
					CPX #$30
					BCC GRAPHIC6_LOOP
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; BACK_GROUND
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BACK_GROUND         ;XvCgœy`Ă܂
					PHX
					LDY #$14
					STZ $01
					LDA $190D
					STA $0F
					LDX #$0F	 ;#1ڂ̕`
BG_LOOP2			LDA #$C0
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA $01
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					CLC
					ADC #$10
					STA $01		;#xW10₷
					LDA #$88	;#GFX^C
					STA $0202,y
					LDA #$02	;#^C̃vpeB(GFX2,pbg9)
					ORA $7FFF65
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP2
					LDX #$0F	 ;#2ڂ̕`
BG_LOOP3			LDA #$D0
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA $01
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					CLC
					ADC #$10
					STA $01		;#xW10₷
					LDA #$A8	;#GFX^C
					STA $0202,y
					LDA #$02	;#^C̃vpeB(GFX2,pbg9)
					ORA $7FFF65
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP3
					PLX
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HDMA_COLOR			LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					LDA #$02
					STA $7FFB29
					LDA #$21
					STA $7FFB22
					LDA #$22
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$E2
					STA $7FFB24
					LDA #$E3
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$01
					STA $7FE201
					LDA #$C5
					STA $7FE301
					LDA #$10
					STA $7FE302
					
					LDA #$01
					STA $7FE202
					STA $7FE303
					LDA #$02
					STA $7FE203
					LDA #$A7
					STA $7FE304
					LDA #$21
					STA $7FE305
					
					LDA #$01
					STA $7FE204
					STA $7FE306
					LDA #$03
					STA $7FE205
					LDA #$F3
					STA $7FE307
					LDA #$0C
					STA $7FE308
					
					LDA #$01
					STA $7FE206
					STA $7FE309
					LDA #$04
					STA $7FE207
					LDA #$3C
					STA $7FE30A
					LDA #$19
					STA $7FE30B
					
					LDA #$01
					STA $7FE208
					STA $7FE30C
					LDA #$05
					STA $7FE209
					LDA #$8C
					STA $7FE30D
					LDA #$36
					STA $7FE30E
					
					LDA #$01
					STA $7FE20A
					STA $7FE30F
					LDA #$06
					STA $7FE20B
					LDA #$4F
					STA $7FE310
					LDA #$4B
					STA $7FE311
					
					LDA #$01
					STA $7FE20C
					STA $7FE312
					LDA #$07
					STA $7FE20D
					LDA #$B5
					STA $7FE313
					LDA #$5B
					STA $7FE314
					
					LDA #$00
					STA $7FE20E
					STA $7FE315
					RTS

HDMA_COLOR2			LDA #$01
					STA $7FE20E
					STA $7FE315
					LDA #$91
					STA $7FE20F
					LDA #$82
					STA $7FE316
					LDA #$18
					STA $7FE317
					
					LDA #$01
					STA $7FE210
					STA $7FE318
					LDA #$92
					STA $7FE211
					LDA #$A6
					STA $7FE319
					LDA #$28
					STA $7FE31A
					
					LDA #$01
					STA $7FE212
					STA $7FE31B
					LDA #$93
					STA $7FE213
					LDA #$09
					STA $7FE31C
					LDA #$39
					STA $7FE31D
					
					LDA #$01
					STA $7FE214
					STA $7FE31E
					LDA #$94
					STA $7FE215
					LDA #$CB
					STA $7FE31F
					LDA #$38
					STA $7FE320
					
					LDA #$01
					STA $7FE216
					STA $7FE321
					LDA #$95
					STA $7FE217
					LDA #$EA
					STA $7FE322
					LDA #$34
					STA $7FE323
					
					LDA #$01
					STA $7FE218
					STA $7FE324
					LDA #$96
					STA $7FE219
					LDA #$8C
					STA $7FE325
					LDA #$41
					STA $7FE326
					
					LDA #$01
					STA $7FE21A
					STA $7FE327
					LDA #$97
					STA $7FE21B
					LDA #$4E
					STA $7FE328
					LDA #$55
					STA $7FE329
					
					LDA #$01
					STA $7FE21C
					STA $7FE32A
					LDA #$98
					STA $7FE21D
					LDA #$0E
					STA $7FE32B
					LDA #$4A
					STA $7FE32C
					
					LDA #$01
					STA $7FE21E
					STA $7FE32D
					LDA #$99
					STA $7FE21F
					LDA #$D4
					STA $7FE32E
					LDA #$59
					STA $7FE32F
					
					LDA #$01
					STA $7FE220
					STA $7FE330
					LDA #$9A
					STA $7FE221
					LDA #$11
					STA $7FE331
					LDA #$62
					STA $7FE332
					
					LDA #$01
					STA $7FE222
					STA $7FE333
					LDA #$9D
					STA $7FE223
					LDA #$D3
					STA $7FE334
					LDA #$6E
					STA $7FE335
					
					LDA #$01
					STA $7FE224
					STA $7FE336
					LDA #$9F
					STA $7FE225
					LDA #$57
					STA $7FE337
					LDA #$77
					STA $7FE338
					
					LDA #$01
					STA $7FE226
					STA $7FE339
					LDA #$E1
					STA $7FE227
					LDA #$84
					STA $7FE33A
					LDA #$10
					STA $7FE33B
					
					LDA #$01
					STA $7FE228
					STA $7FE33C
					LDA #$E2
					STA $7FE229
					LDA #$C5
					STA $7FE33D
					LDA #$20
					STA $7FE33E
					
					LDA #$01
					STA $7FE22A
					STA $7FE33F
					LDA #$E3
					STA $7FE22B
					LDA #$07
					STA $7FE340
					LDA #$25
					STA $7FE341
					
					LDA #$01
					STA $7FE22C
					STA $7FE342
					LDA #$E4
					STA $7FE22D
					LDA #$6A
					STA $7FE343
					LDA #$29
					STA $7FE344
					
					LDA #$01
					STA $7FE22E
					STA $7FE345
					LDA #$E5
					STA $7FE22F
					LDA #$8A
					STA $7FE346
					LDA #$39
					STA $7FE347
					
					LDA #$01
					STA $7FE230
					STA $7FE348
					LDA #$E6
					STA $7FE231
					LDA #$15
					STA $7FE349
					LDA #$15
					STA $7FE34A
					
					LDA #$01
					STA $7FE232
					STA $7FE34B
					LDA #$E7
					STA $7FE233
					LDA #$EE
					STA $7FE34C
					LDA #$39
					STA $7FE34D
					
					LDA #$01
					STA $7FE234
					STA $7FE34E
					LDA #$E8
					STA $7FE235
					LDA #$5D
					STA $7FE34F
					LDA #$1D
					STA $7FE350
					
					LDA #$01
					STA $7FE236
					STA $7FE351
					LDA #$E9
					STA $7FE237
					LDA #$0E
					STA $7FE352
					LDA #$52
					STA $7FE353
					
					LDA #$01
					STA $7FE238
					STA $7FE354
					LDA #$EA
					STA $7FE239
					LDA #$30
					STA $7FE355
					LDA #$36
					STA $7FE356
					
					LDA #$01
					STA $7FE23A
					STA $7FE357
					LDA #$EB
					STA $7FE23B
					LDA #$72
					STA $7FE358
					LDA #$3A
					STA $7FE359
					
					LDA #$01
					STA $7FE23C
					STA $7FE35A
					LDA #$EC
					STA $7FE23D
					LDA #$72
					STA $7FE35B
					LDA #$52
					STA $7FE35C
					
					LDA #$01
					STA $7FE23E
					STA $7FE35D
					LDA #$ED
					STA $7FE23F
					LDA #$B5
					STA $7FE35E
					LDA #$4E
					STA $7FE35F
					
					LDA #$01
					STA $7FE240
					STA $7FE360
					LDA #$EE
					STA $7FE241
					LDA #$18
					STA $7FE361
					LDA #$57
					STA $7FE362
					
					LDA #$01
					STA $7FE242
					STA $7FE363
					LDA #$EF
					STA $7FE243
					LDA #$18
					STA $7FE364
					LDA #$63
					STA $7FE365
					
					LDA #$00
					STA $7FE244
					STA $7FE366
					RTS
					
HDMA_COLOR3			LDA #$84
					STA $7FE301
					LDA #$10
					STA $7FE302
					LDA #$83
					STA $7FE304
					LDA #$74
					STA $7FE305
					LDA #$00
					STA $7FE307
					LDA #$00
					STA $7FE308
					LDA #$FF
					STA $7FE30A
					LDA #$7F
					STA $7FE30B
					LDA #$10
					STA $7FE30D
					LDA #$42
					STA $7FE30E
					LDA #$F7
					STA $7FE310
					LDA #$5E
					STA $7FE311
					LDA #$9C
					STA $7FE313
					LDA #$73
					STA $7FE314
					RTS
HDMA_COLOR4			LDA #$18
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$1F
					STA $7FE304
					LDA #$00
					STA $7FE305
					LDA #$DF
					STA $7FE307
					LDA #$01
					STA $7FE308
					LDA #$9F
					STA $7FE30A
					LDA #$02
					STA $7FE30B
					LDA #$5F
					STA $7FE30D
					LDA #$03
					STA $7FE30E
					LDA #$FF
					STA $7FE310
					LDA #$03
					STA $7FE311
					LDA #$FF
					STA $7FE313
					LDA #$7F
					STA $7FE314
					RTS
					
HDMA_COLOR5			LDA #$84
					STA $7FE301
					LDA #$0C
					STA $7FE302
					LDA #$E5
					STA $7FE304
					LDA #$14
					STA $7FE305
					LDA #$A8
					STA $7FE307
					LDA #$0C
					STA $7FE308
					LDA #$CD
					STA $7FE30A
					LDA #$14
					STA $7FE30B
					LDA #$27
					STA $7FE30D
					LDA #$1D
					STA $7FE30E
					LDA #$26
					STA $7FE310
					LDA #$19
					STA $7FE311
					LDA #$68
					STA $7FE313
					LDA #$21
					STA $7FE314
					RTS
