;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Marx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
					CIRCLE = $27EFD0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $E4,x
					ORA #$08
					STA $E4,x
					LDA #$FF
					STA $15AC,x
					STZ $1411
					LDA #$02
					STA $19
					STZ $0DC1
					STZ $0DC2
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

START_HB_CODE       LDA $9D
					BNE START_HB_CODE_1
					LDA $7FF112
					STA $1471
START_HB_CODE_1		LDA $1504,x
					BNE NOT_MAIN1
					JSR MAIN
					RTS
NOT_MAIN1			CMP #$01
					BNE NOT_MAIN2
					JSR CUTTER
					RTS
NOT_MAIN2			CMP #$02
					BNE NOT_MAIN3
					JSR BOMB
					RTS
NOT_MAIN3			CMP #$03
					BNE NOT_MAIN4
					JSR FEATHER
					RTS
NOT_MAIN4			CMP #$04
					BNE NOT_MAIN5
					JSR ARROW
					RTS
NOT_MAIN5			CMP #$05
					BNE NOT_MAIN6
					JSR ARROW2
					RTS
NOT_MAIN6			CMP #$06
					BNE NOT_MAIN7
					JSR SEED
					RTS
NOT_MAIN7			CMP #$07
					BNE NOT_MAIN8
					JSR TUTA
					RTS
NOT_MAIN8			CMP #$08
					BNE NOT_MAIN9
					JSR BEAM
					RTS
NOT_MAIN9			CMP #$09
					BNE NOT_MAINA
					JSR BH
					RTS
NOT_MAINA			CMP #$0A
					BNE NOT_MAINB
					JSR BH_SUB
					RTS
NOT_MAINB			CMP #$0B
					BNE NOT_MAINC
					JSR CHIBI
					RTS
NOT_MAINC			CMP #$0C
					BNE NOT_MAIND
					JSR KIRBY
					RTS
NOT_MAIND			CMP #$0D
					BNE NOT_MAINE
					JSR KIRBY_FLASH
					RTS
NOT_MAINE			JSR KIRBY_BH
					RTS
MAIN				LDA $9D
					BNE MAIN_1
					JSR MARIO_CHECK
					LDA #$03
					STA $0F31
					STZ $149F
					JSR LAYER3_MOVE
					LDA $E4,x
					STA $7FF0E4
					LDA $14E0,x
					STA $7FF0E0
					LDA $D8,x
					STA $7FF0D8
					LDA $14D4,x
					STA $7FF0D4
MAIN_1				LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			LDA $C2,x
					CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			CMP #$06
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$07
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			CMP #$08
					BNE NOT_MODE8
					JSR MODE8
					RTS
NOT_MODE8			CMP #$09
					BNE NOT_MODE9
					JSR MODE9
					RTS
NOT_MODE9			CMP #$0A
					BNE NOT_MODEA
					JSR MODEA
					RTS
NOT_MODEA			CMP #$0B
					BNE NOT_MODEB
					JSR MODEB
					RTS
NOT_MODEB			CMP #$0C
					BNE NOT_MODEC
					JSR MODEC
					RTS
NOT_MODEC			CMP #$0D
					BNE NOT_MODED
					JSR MODED
					RTS
NOT_MODED			CMP #$0E
					BNE NOT_MODEE
					JSR MODEE
					RTS
NOT_MODEE			CMP #$0F
					BNE NOT_MODEF
					JSR MODEF
					RTS
NOT_MODEF			CMP #$10
					BNE NOT_MODE10
					JSR MODE10
					RTS
NOT_MODE10

CUTTER				JSR SUB_GFX_CT
					LDA $9D
					BNE MAIN2_R
					LDA $15AC,x
					BEQ MAIN2_DELETE
					JSR DAMAGE_RT
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSR SUB_MAIN2_1
					JSR SUB_MAIN2_2
					LDA $C2,x
					BNE MAIN2_1
					INC $1570,x
MAIN2_R				RTS
MAIN2_1				DEC $1570,x
					RTS
MAIN2_DELETE		STZ $14C8,x
					RTS
					
BOMB_GFX			LDA $C2,x
					BEQ BOMB_GFX_0
					LDA $14
					LSR A
					LSR A
					AND #$01
					BEQ BOMB_GFX_1
					LDA #$02
					STA $1602,x
					JSR SUB_GFX
					RTS
BOMB_GFX_0			LDA $1540,x
					CMP #$08
					BCS BOMB_GFX_1
					CMP #$01
					BCS BOMB_GFX_2
					LDA #$04
					STA $1602,x
					JSR SUB_GFX
					RTS
BOMB_GFX_1			LDA #$01
					STA $1602,x
					JSR SUB_GFX
					RTS
BOMB_GFX_2			STZ $1602,x
					JSR SUB_GFX
					RTS
BOMB				JSR BOMB_GFX
					LDA $9D
					BNE BOMB_R
					LDA $C2,x
					BEQ BOMB_1
					CMP #$02
					BEQ BOMB_3
					LDA #$60
					STA $B6,x
					JSL $018022
					JSR DAMAGE_RT
					LDA $14E0,x
					BNE BOMB_DELETE
					RTS
BOMB_3
					LDA #$A0
					STA $B6,x
					JSL $018022
					JSR DAMAGE_RT
					LDA $14E0,x
					BNE BOMB_DELETE
					RTS
BOMB_1				LDA $1540,x
					BNE BOMB_2
					JSL $01802A
					STZ $1570,x
					JSR DAMAGE_RT
					LDA $14D4,x
					BEQ BOMB_R
					LDA $D8,x
					CMP #$80
					BCC BOMB_R
					LDA #$10
					STA $1540,x
					JSR SPRITE_GEN
					LDA #$02
					STA $1504,y
					LDA #$01
					STA $00C2,y
					JSR SPRITE_GEN
					LDA #$02
					STA $1504,y
					LDA #$02
					STA $00C2,y
BOMB_R				RTS
BOMB_2				CMP #$01
					BEQ BOMB_DELETE
					CMP #$08
					BCS BOMB_R
					INC $1570,x
					INC $1570,x
					RTS
BOMB_DELETE			STZ $14C8,x
					RTS
					
FEATHER				JSR SUB_GFX_FT
					LDA $9D
					BNE FEATHER_R
					INC $1570,x
					JSL $01802A
					JSR DAMAGE_RT
					LDA $14D4,x
					BEQ FEATHER_R
					LDA $D8,x
					CMP #$A0
					BCC FEATHER_R
					STZ $14C8,x
FEATHER_R			RTS

ARROW_SPEED			dcb $81,$7F
ARROW				JSR SUB_GFX_AL
					LDA $9D
					BNE ARROW_R
					LDA $14E0,x
					BNE ARROW_DEL
					JSR DAMAGE_RT
					LDA $157C,x
					TAY
					LDA ARROW_SPEED,y
					STA $B6,x
					JSL $018022
ARROW_R				RTS
ARROW_DEL			STZ $14C8,x
					RTS
					
ARROW2_TABLE1		dcb $EC,$DC,$EC,$00,$14,$24,$14,$00
ARROW2_TABLE2		dcb $FF,$FF,$FF,$00,$00,$00,$00,$00
ARROW2_TABLE3		dcb $F0,$00,$10,$00,$10,$00,$F0,$00
ARROW2_TABLE4		dcb $FF,$00,$00,$00,$00,$00,$FF,$00

ARROW2				LDA $1528,x
					AND #$07
					CMP #$03
					BEQ ARROW2_2
					CMP #$07
					BEQ ARROW2_2
					TAY
					LDA $7FF0E4
					CLC
					ADC ARROW2_TABLE1,y
					STA $E4,x
					LDA $7FF0E0
					ADC ARROW2_TABLE2,y
					STA $14E0,x
					LDA $7FF0D8
					CLC
					ADC ARROW2_TABLE3,y
					STA $D8,x
					LDA $7FF0D4
					ADC ARROW2_TABLE4,y
					STA $14D4,x
					LDA #$02
					STA $1602,x
					JSR SUB_GFX
ARROW2_2			LDA $9D
					BNE ARROW_2_R
					INC $1528,x
					LDA $15AC,x
					CMP #$01
					BNE ARROW_2_R
					STZ $14C8,x
ARROW_2_R			RTS

SEED				JSR SUB_GFX_SEED
					LDA $9D
					BNE SEED_R
					LDA $1540,x
					CMP #$01
					BEQ SEED_DEL
					CMP #$00
					BNE SEED_R
					JSR DAMAGE_RT
					JSL $01802A
					LDA $14D4,x
					BEQ SEED_R
					LDA $D8,x
					CMP #$80
					BCC SEED_R
					LDA #$38
					STA $1540,x
SEED_R				RTS
SEED_DEL			STZ $14C8,x
					LDA #$0E
					STA $1DFC
					JSR SPRITE_GEN
					LDA #$07
					STA $1504,y
					LDA #$0F
					STA $15AC,y
					LDA #$00
					STA $7FF0E6
					RTS
					
TUTA_SPEED			dcb $E0,$20
TUTA_DEL			STZ $14C8,x
					RTS
TUTA				JSR SUB_GFX_TUTA
					LDA $9D
					BNE TUTA_R
					LDA $7FF0E6
					CMP #$10
					BEQ TUTA_DEL
					JSR TUTA_DAMAGE
					LDA $15AC,x
					CMP #$01
					BEQ TUTA_2
					LDA $7FF0E6
					BEQ TUTA_R
					CLC
					ADC $C2,x
					AND #$01
					TAY
					LDA TUTA_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					BEQ TUTA_R
					STZ $14C8,x
					LDA $7FF0E6
					INC A
					INC A
					STA $7FF0E6
TUTA_R				RTS
TUTA_2				LDA $C2,x
					CMP #$03
					BEQ TUTA_3
					CMP #$03
					BCS TUTA_R
					JSR SPRITE_GEN
					LDA #$07
					STA $1504,y
					LDA #$0F
					STA $15AC,y
					LDA $C2,x
					INC A
					STA $00C2,y
					LDA $D8,x
					SEC
					SBC #$40
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					RTS
TUTA_3				LDA #$01
					STA $7FF0E6
					LDA $94
					CMP #$78
					BCS TUTA_R
					LDA #$02
					STA $7FF0E6
					RTS
					
BEAM				JSR SUB_GFX_BEAM
					LDA $9D
					BNE BEAM_R
					LDA $157C,x
					BNE BEAM_2
					LDA #$90
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					CMP #$FF
					BEQ BEAM_DELETE
BEAM_R				RTS
BEAM_2				LDA #$70
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					CMP #$01
					BEQ BEAM_DELETE
					RTS
BEAM_DELETE			STZ $14C8,x
					RTS
					

BH					LDA $1558,x
					AND #$01
					BNE BH_1
					LDA #$03
					STA $1602,x
					JSR SUB_GFX
BH_1				LDA $9D
					BNE BH_R
					JSR VACUME
					JSR GEN_BH2
					LDA $15AC,x
					CMP #$E0
					BEQ BH_2
					CMP #$E0
					BCS BH_R
					CMP #$20
					BCS BH_3
					CMP #$01
					BEQ BH_4
BH_R				RTS
BH_2				JSR SUB_BH1
					RTS
BH_3				JSR SUB_BH2
					RTS
BH_4				STZ $1504,x
					LDA #$F0
					STA $15AC,x
					LDA #$04
					STA $C2,x
					LDA #$03
					STA $7FF0D9
					RTS
SUB_BH1				JSR VRAM6
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					STA $7FF0DA
					JSR HDMA_CIRCLE
					LDA $E4,x
					CLC
					ADC #$08
					STA $7FDEFD;#SxW
					LDA $D8,x
					CLC
					ADC #$48
					STA $7FDEFE;#SyW
					LDA #$60
					STA $7FDEFF;#~̔a
					JSR CIRCLE_GEN
					LDA #$04
					STA $7FE903
					STA $7FE901
					LDA #$13
					STA $212D
					LDA #$64
					STA $40
					RTS
SUB_BH2				LDA $14
					AND #$01
					BNE SUB_BH2_1
					LDA $7FDEFF
					DEC A
					STA $7FDEFF
					JSR CIRCLE_GEN
SUB_BH2_1			LDA $14
					AND #$0F
					BNE BH_3_1
					LDA #$17
					STA $1DFC
BH_3_1				LDA $14
					AND #$03
					BNE BH_R2
					LDA $7FF0DA
					CMP #$7C
					BEQ BH_R2
					CLC
					ADC #$04
					STA $7FF0DA
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA $7FF0DA
					STA $2122
BH_R2				RTS

VACUME				LDA $1558,x
					BNE VACUME_R
					LDA $18BD
					BEQ VACUME_A
					LDA #$40
					STA $13E0
					LDA #$50
					STA $13DF
					LDA #$01
					STA $76
					LDA #$FF
					STA $18BD
VACUME_R			RTS
VACUME_A			JSL $01A7DC
					BCC VACUME_B
					LDA #$FF
					STA $18BD
					RTS
VACUME_B			REP #$30
					LDA.W $96
					CLC
					ADC.W #$0010
					STA $96
					SEP #$30
					JSR VACUMEB
					REP #$30
					LDA.W $96
					SEC
					SBC.W #$0010
					STA $96
					SEP #$30
					RTS
VACUMEB				LDA $94
					SEC
					SBC $E4,x
					STA $02
					BCC VACUME_1
					LDA $96
					SEC
					SBC $D8,x
					STA $03
					LDA $97
					SBC $14D4,x
					BCC VACUME_0
					LDA $02
					CMP $03
					BCC VACUME_2
					LDA #$D0
					STA $7B
					LDA #$E8
					STA $7D
					RTS
VACUME_2			LDA #$E8
					STA $7B
					LDA #$D0
					STA $7D
					RTS
VACUME_0			LDA $03
					EOR #$FF
					CMP $02
					BCC VACUME_3
					LDA #$30
					STA $7D
					LDA #$E8
					STA $7B
					RTS
VACUME_3			LDA #$18
					STA $7D
					LDA #$D0
					STA $7B
					RTS
VACUME_1			LDA $02
					EOR #$FF
					STA $02
					LDA $96
					SEC
					SBC $D8,x
					STA $03
					LDA $97
					SBC $14D4,x
					BCC VACUME_4
					LDA $02
					CMP $03
					BCC VACUME_5
					LDA #$30
					STA $7B
					LDA #$E8
					STA $7D
					RTS
VACUME_5			LDA #$18
					STA $7B
					LDA #$D0
					STA $7D
					RTS
VACUME_4			LDA $03
					EOR #$FF
					CMP $02
					BCC VACUME_6
					LDA #$30
					STA $7D
					LDA #$18
					STA $7B
					RTS
VACUME_6			LDA #$18
					STA $7D
					LDA #$30
					STA $7B
					RTS


BH_SUB_SPEED		dcb $E0,$EC,$00,$14,$20,$14,$00,$EC
BH_SUB_SPEED2		dcb $00,$EC,$E0,$EC,$00,$14,$20,$14
BH_SUB				JSR SUB_GFX_BH2
					LDA $9D
					BNE BH_SUB_R
					LDA $15AC,x
					BEQ BH_SUB_D
					LDA $1570,x
					TAY
					LDA BH_SUB_SPEED,y
					STA $B6,x
					LDA BH_SUB_SPEED2,y
					STA $AA,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
BH_SUB_R			RTS
BH_SUB_D			STZ $14C8,x
					RTS
					
CHIBI_SPEED			dcb $D8,$28
CHIBI				JSR SUB_GFX1
					LDA $9D
					BNE CHIBI_R
					LDA $14C8,x
					CMP #$08
					BCC CHIBI_R
					JSL $01A7DC
					JSL $01802A
					LDA $14D4,x
					BEQ CHIBI_1
					LDA $D8,x
					CMP #$80
					BCC CHIBI_1
					LDA #$A0
					STA $AA,x
					JSL $01ACF9
					AND #$01
					STA $157C,x
					LDA #$01
					STA $1570,x
CHIBI_1				LDA $1570,x
					BEQ CHIBI_R
					LDA $157C,x
					TAY
					LDA CHIBI_SPEED,y
					STA $B6,x
					LDA $E4,x
					CMP #$08
					BCC CHIBI_2
					CMP #$E8
					BCS CHIBI_3
CHIBI_R				RTS
CHIBI_2				LDA #$01
					STA $157C,x
					RTS
CHIBI_3				STZ $157C,x
					RTS
					
KIRBY				LDA $C2,x
					BNE NOT_KIRBY
					JSR KIRBY0
					RTS
NOT_KIRBY			LDA $9D
					BNE NOT_KIRBY0
					JSR MARIO_CHECK
					LDA #$03
					STA $0F31
					STZ $149F
					JSR LAYER3_MOVE
NOT_KIRBY0			LDA $C2,x
					CMP #$01
					BNE NOT_KIRBY1
					JSR KIRBY1
					RTS
NOT_KIRBY1			CMP #$02
					BNE NOT_KIRBY2
					JSR KIRBY2
					RTS
NOT_KIRBY2			CMP #$03
					BNE NOT_KIRBY3
					JSR KIRBY3
					RTS
NOT_KIRBY3			CMP #$04
					BNE NOT_KIRBY4
					JSR KIRBY4
					RTS
NOT_KIRBY4			CMP #$05
					BNE NOT_KIRBY5
					JSR KIRBY5
					RTS
NOT_KIRBY5			JSR KIRBY6
					RTS

KIRBY0				JSR SUB_GFX_KIRBY
					LDA $9D
					BNE KIRBY_R
					LDA $15AC,x
					BNE KIRBY_2
					JSL $01802A
					LDA $14D4,x
					BEQ KIRBY_R
					LDA $D8,x
					CMP #$80
					BCC KIRBY_R
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $1602,x
KIRBY_R				RTS
KIRBY_2				CMP #$E0
					BEQ KIRBY_3
					CMP #$C0
					BEQ KIRBY_4
					CMP #$A0
					BEQ KIRBY_5
					CMP #$9F
					BCS KIRBY_R
					JSR KIRBY_FLASH_G
					RTS
KIRBY_3				LDA #$02
					STA $1602,x
					LDA #$01
					STA $7FF123
					LDA #$2B
					STA $1DFC
					RTS
KIRBY_4				LDA #$03
					STA $1602,x
					RTS
KIRBY_5				LDA #$22
					STA $1DFC
					LDA #$04
					STA $1602,x
					JSR VRAM6
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$10
					STA $7FE901
					STA $7FE903
					LDA #$07
					STA $212D
					LDA #$64
					STA $40
					RTS
KIRBY_FLASH_G		LDA $15AC,x
					AND #$07
					BNE KIRBY_FLASH_G_R
					JSR SPRITE_GEN
					LDA #$0D
					STA $1504,y
					LDA #$10
					STA $1540,y
					LDA $15AC,x
					CMP #$98
					BEQ KIRBY_FLASH_G_1
					CMP #$90
					BEQ KIRBY_FLASH_G_2
					CMP #$88
					BEQ KIRBY_FLASH_G_3
					CMP #$80
					BEQ KIRBY_FLASH_G_4
KIRBY_FLASH_G_R		RTS
KIRBY_FLASH_G_1		LDA $E4,x
					CLC
					ADC #$10
					STA $00E4,y
					LDA $D8,x
					SEC
					SBC #$0C
					STA $00D8,y
					LDA #$30
					STA $1528,y
					RTS
KIRBY_FLASH_G_2		LDA $E4,x
					STA $00E4,y
					LDA $D8,x
					STA $00D8,y
					LDA #$34
					STA $1528,y
					RTS
KIRBY_FLASH_G_3		LDA $E4,x
					SEC
					SBC #$10
					STA $00E4,y
					LDA $D8,x
					SEC
					SBC #$04
					STA $00D8,y
					LDA #$38
					STA $1528,y
					RTS
KIRBY_FLASH_G_4		LDA $E4,x
					CLC
					ADC #$04
					STA $00E4,y
					LDA $D8,x
					SEC
					SBC #$0C
					STA $00D8,y
					LDA #$40
					STA $1528,y
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					JSR KIRBY_RAM2
					RTS
					
KIRBY_FLASH			JSR SUB_GFX_FLASH
					LDA $9D
					BNE KIRBY_FLASH_R
					LDA $1540,x
					BNE KIRBY_FLASH_R
					STZ $14C8,x
KIRBY_FLASH_R		RTS

KIRBY1				STZ $1602,x
					JSR SUB_GFX_KIRBY1
					LDA $9D
					BNE KIRBY1_R
					LDA $15AC,x
					CMP #$E1
					BEQ KIRBY1_1
					CMP #$E0
					BCS KIRBY1_R
					CMP #$A0
					BCS KIRBY1_2
					CMP #$9F
					BEQ KIRBY1_3
KIRBY1_R			RTS
KIRBY1_1			JSR KIRBY_GAGE
					LDA #$17
					STA $7FE901
					LDA #$13
					STA $7FE903
					LDA #$04
					STA $212D
					STZ $40
					LDA #$E0
					STA $AA,x
					RTS
KIRBY1_2			JSL $01801A
					RTS
KIRBY1_3			LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $C2,x
					RTS

KIRBY2_GFX			LDA $1540,x
					BEQ KIRBY2_GFX_1
					CMP #$F8
					BCS KIRBY2_GFX_2
					CMP #$F2
					BCS KIRBY2_GFX_3
					CMP #$EA
					BCS KIRBY2_GFX_4
KIRBY2_GFX_R		RTS
KIRBY2_GFX_1		JSR SUB_GFX_KIRBY1
					RTS
KIRBY2_GFX_2		LDA #$02
					STA $1602,x
					JSR SUB_GFX
					RTS
KIRBY2_GFX_3		LDA #$01
					STA $1602,x
					JSR SUB_GFX
					RTS
KIRBY2_GFX_4		STZ $1602,x
					JSR SUB_GFX
					RTS
					
KIRBY2				JSR KIRBY2_GFX
					LDA $9D
					BNE KIRBY2_R
					LDA $1540,x
					BEQ KIRBY2_0
					CMP #$F3
					BEQ KIRBY2_5
					CMP #$F2
					BCS KIRBY2_R
					CMP #$EA
					BCS KIRBY2_4
					CMP #$E0
					BEQ KIRBY2_6
					RTS
KIRBY2_4			INC $1570,x
					INC $1570,x
					RTS
KIRBY2_6			LDA $7FF235
					CMP #$10
					BNE KIRBY2_6_A
					JSR FINISH
					RTS
KIRBY2_6_A			STZ $1540,x
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
					LDA #$01
					STA $157C,x
					LDA #$B0
					STA $E4,x
					LDA #$FF
					STA $14E0,x
					LDA #$03
					STA $C2,x
					STZ $1602,x
					RTS
KIRBY2_0			LDA $15AC,x
					CMP #$E0
					BEQ KIRBY2_1
					CMP #$C0
					BEQ KIRBY2_2
					CMP #$40
					BEQ KIRBY2_3
KIRBY2_R			RTS
KIRBY2_1			LDA #$01
					STA $1602,x
					RTS
KIRBY2_3			LDA #$FF
					STA $1540,x
					STZ $1570,x
					RTS
KIRBY2_5			LDA #$27
					STA $1DFC
					RTS
KIRBY2_2			STZ $1602,x
					LDA #$26
					STA $1DFC
					JSR KIRBY2_G2
					LDA #$D0
					STA $00B6,y
					LDA #$18
					STA $00AA,y
					JSR KIRBY2_G2
					LDA #$E8
					STA $00B6,y
					LDA #$30
					STA $00AA,y
					JSR KIRBY2_G2
					LDA #$18
					STA $00B6,y
					LDA #$30
					STA $00AA,y
					LDA #$01
					STA $00C2,y
					JSR KIRBY2_G2
					LDA #$30
					STA $00B6,y
					LDA #$18
					STA $00AA,y
					
					JSR KIRBY2_G2
					LDA #$D0
					STA $00B6,y
					LDA #$E8
					STA $00AA,y
					JSR KIRBY2_G2
					LDA #$E8
					STA $00B6,y
					LDA #$D0
					STA $00AA,y
					JSR KIRBY2_G2
					LDA #$18
					STA $00B6,y
					LDA #$D0
					STA $00AA,y
					LDA #$01
					STA $00C2,y
					JSR KIRBY2_G2
					LDA #$30
					STA $00B6,y
					LDA #$E8
					STA $00AA,y
					RTS
KIRBY2_G2			JSR SPRITE_GEN
					LDA #$01
					STA $1504,y
					LDA #$80
					STA $15AC,y
					RTS

KIRBY_GAGE			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5064
					STA $2116
					LDA.W #$2414
					STA $2118
					LDA.W #$5065
					STA $2116
					LDA.W #$2412
					STA $2118
					LDA.W #$5066
					STA $2116
					LDA.W #$241B
					STA $2118
					LDA.W #$5067
					STA $2116
					LDA.W #$240B
					STA $2118
					LDA.W #$5068
					STA $2116
					LDA.W #$2422
					STA $2118
					LDA.W #$506B
					STA $03
KIRBY_GAGE_LP		LDA $03
					STA $2116
					LDA.W #$2444
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$506D
					BCC KIRBY_GAGE_LP
					SEP #$20
					RTS
					
					
KIRBY3_4			STZ $B6,x
					LDA #$FF
					STA $15AC,x
					LDA #$78
					STA $E4,x
					STZ $14E0,x
					JSR VRAM3
					LDA #$30
					STA $40
					LDA #$A0
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$04
					STA $C2,x
					RTS
KIRBY3				JSR SUB_GFX_KIRBY1
					LDA $9D
					BNE KIRBY3_R
					LDA #$18
					STA $B6,x
					JSL $018022
					LDA $15AC,x
					BEQ KIRBY3_4
					CMP #$D0
					BEQ KIRBY3_1
					CMP #$C8
					BEQ KIRBY3_G
					CMP #$C0
					BEQ KIRBY3_2
					CMP #$B8
					BEQ KIRBY3_1
					CMP #$B0
					BEQ KIRBY3_G
					CMP #$A8
					BEQ KIRBY3_2
					CMP #$A0
					BEQ KIRBY3_1
					CMP #$98
					BEQ KIRBY3_G
					CMP #$90
					BEQ KIRBY3_2
					CMP #$88
					BEQ KIRBY3_1
					CMP #$80
					BEQ KIRBY3_G
					CMP #$78
					BEQ KIRBY3_2
					CMP #$70
					BEQ KIRBY3_1
					CMP #$68
					BEQ KIRBY3_G
					CMP #$60
					BEQ KIRBY3_2
					CMP #$58
					BEQ KIRBY3_1
					CMP #$50
					BEQ KIRBY3_G
					CMP #$48
					BEQ KIRBY3_2
					CMP #$40
					BEQ KIRBY3_1
					CMP #$38
					BEQ KIRBY3_G
					CMP #$30
					BEQ KIRBY3_2
KIRBY3_R			RTS
KIRBY3_1			LDA #$01
					STA $1602,x
					RTS
KIRBY3_2			STZ $1602,x
					RTS
KIRBY3_G			JSR SPRITE_GEN
					LDA #$02
					STA $1504,y
					LDA #$2B
					STA $1DFC
					LDA $E4,x
					CLC
					ADC #$10
					STA $00E4,y
					LDA #$02
					STA $1602,x
					RTS
					
					
					
KIRBY4_GFX			LDA $15AC,x
					CMP #$D0
					BCS KIRBY4_GFX_R
					LDA #$05
					STA $1602,x
					JSR SUB_GFX_KIRBY
KIRBY4_GFX_R		RTS
KIRBY4				JSR KIRBY4_GFX
					LDA $9D
					BNE KIRBY4_R
					LDA $15AC,x
					BEQ KIRBY4_2
					CMP #$D0
					BCS KIRBY4_1
					JSR KIRBY4_SUB
KIRBY4_R			RTS
KIRBY4_2			LDA #$FF
					STA $15AC,x
					STZ $B6,x
					LDA #$05
					STA $C2,x
					STZ $1528,x
					LDA #$D0
					STA $AA,x
					LDA #$27
					STA $1DFC
					RTS
KIRBY4_1			LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
KIRBY4_SUB			LDA $157C,x
					TAY
					LDA KIRBY4_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $14
					AND #$07
					BNE KIRBY4_R
					STZ $157C,x
					LDA $14E0,x
					BMI KIRBY4_SUB_2
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS KIRBY4_R
KIRBY4_SUB_2		INC $157C,x
					RTS
KIRBY4_SPEED		dcb $D0,$30

KIRBY5				STZ $1602,x
					JSR SUB_GFX_KIRBY1
					LDA $9D
					BNE KIRBY5_R
					LDA $15AC,x
					CMP #$80
					BEQ KIRBY5_2
					LDA $14D4,x
					BNE KIRBY5_1
					STZ $AA,x
					RTS
KIRBY5_R			RTS
KIRBY5_2			LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $C2,x
					STZ $40
					STZ $1528,x
					LDA $7FF234
					CMP #$02
					BNE KIRBY5_R
					LDA #$06
					STA $C2,x
					RTS
KIRBY5_1			JSL $01801A
					LDA $1528,x
					BNE KIRBY5_R
					JSL $01A7DC
					BCC KIRBY5_R
					INC $1528,x
					JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA $7FF234
					INC A
					STA $7FF234
					CMP #$01
					BEQ KIRBY5_3
					CMP #$02
					BEQ KIRBY5_4
					RTS
KIRBY5_3			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$506C
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$20
					RTS
KIRBY5_4			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$506B
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$20
					LDA #$1E
					STA $1DFB
					RTS

KIRBY6				JSR SUB_GFX_KIRBY1
					LDA $9D
					BNE KIRBY6_R
					LDA $15AC,x
					CMP #$C0
					BCS KIRBY6_R
					CMP #$BF
					BEQ KIRBY6_1
					CMP #$A0
					BEQ KIRBY6_2
					JSR KIRBY6_SUB
KIRBY6_R			RTS
KIRBY6_1			LDA #$01
					STA $1602,x
					RTS
KIRBY6_2			LDA #$02
					STA $1602,x
					JSR SPRITE_GEN
					LDA #$0E
					STA $1504,y
					LDA #$FF
					STA $15AC,y
					LDA #$2B
					STA $1DFC
					RTS
KIRBY6_SUB			LDA $7FF235
					CMP #$10
					BNE KIRBY6_R2
					LDA #$18
					STA $AA,x
					JSL $01801A
					LDA $14D4,x
					BEQ KIRBY6_R2
					LDA $D8,x
					CMP #$50
					BCC KIRBY6_R2
					STZ $14C8,x
KIRBY6_R2			RTS







KIRBY_BH			JSR SUB_GFX
					LDA $9D
					BNE KIRBY_BH_R
					LDA $15AC,x
					CMP #$D0
					BCS KIRBY_BH_1
					LDA #$03
					STA $1602,x
					LDA $15AC,x
					CMP #$C0
					BEQ KIRBY_BH_2
					CMP #$40
					BCS KIRBY_BH_3
					CMP #$10
					BNE KIRBY_BH_R
					LDA #$FF
					STA $1540,x
					STZ $1570,x
					LDA #$02
					STA $C2,x
					LDA #$0C
					STA $1504,x
					RTS
KIRBY_BH_1			LDA #$20
					STA $AA,x
					JSL $01801A
					LDA #$04
					STA $1602,x
					LDA #$20
					STA $1558,x
KIRBY_BH_R			RTS
KIRBY_BH_2			JSR KIRBY_BH_SUB2
					LDA #$10
					STA $7FF235
					RTS
KIRBY_BH_3			JSR KIRBY_BH_SUB3
					LDA $15AC,x
					CMP #$60
					BCC KIRBY_BH_R
					JSR GEN_BH2
					RTS


KIRBY_BH_SUB2		JSR VRAM6
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					STA $7FF0DA
					JSR HDMA_CIRCLE
					LDA $E4,x
					CLC
					ADC #$08
					STA $7FDEFD;#SxW
					LDA $D8,x
					CLC
					ADC #$48
					STA $7FDEFE;#SyW
					LDA #$60
					STA $7FDEFF;#~̔a
					JSR CIRCLE_GEN
					LDA #$04
					STA $7FE903
					STA $7FE901
					LDA #$13
					STA $212D
					LDA #$64
					STA $40
					RTS
KIRBY_BH_SUB3		LDA $7FDEFF
					BEQ KIRBY_BH_SUB3_A
					DEC A
					STA $7FDEFF
KIRBY_BH_SUB3_A		JSR CIRCLE_GEN
					LDA $14
					AND #$0F
					BNE KIRBY_BH_3_2
					LDA #$17
					STA $1DFC
KIRBY_BH_3_2		LDA $14
					AND #$03
					BNE KIRBY_BH_3_R
					LDA $7FF0DA
					CMP #$7C
					BEQ KIRBY_BH_3_R
					CLC
					ADC #$04
					STA $7FF0DA
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA $7FF0DA
					STA $2122
KIRBY_BH_3_R		RTS


FINISH				LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					STZ $14C8,x
					RTS					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE0				LDA $9D
					BNE MODE0_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE0_1
					LDA $77
					AND #$04
					BEQ MODE0_R
					LDA #$01
					STA $7FF111
					STZ $1412
					LDA #$01
					STA $C2,x
					STZ $15AC,x
					STZ $157C,x
					;LDA #$23
					;STA $1DFB
MODE0_R				RTS
MODE0_1				JSR LAYER3_DELETE
					;LDA #$1E
					;STA $1DFB
					JSR HDMA_SCL
					JSR LAYER_INIT
					LDA #$04
					STA $212D
					RTS
					
MODE1_GFX			LDA $15AC,x
					BEQ MODE1_GFX_1
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BEQ MODE1_GFX_1
					JSR SUB_GFX2
					RTS
MODE1_GFX_1			JSR SUB_GFX1
					RTS
MODE1				JSR MODE1_GFX
					LDA $9D
					BNE MODE1_R
					LDA $15AC,x
					BEQ MODE1_0
					CMP #$C0
					BNE MODE1_R
					LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					JSR LAYER3_1
					JSR LIFE_GAGE
					RTS
MODE1_0				LDA #$18
					STA $AA,x
					JSL $01801A
					LDA $D8,x
					CMP #$F8
					BCC MODE1_R
					STZ $AA,x
					LDA #$FF
					STA $15AC,x
MODE1_R				RTS

MODE2_GFX			LDA $15AC,x
					CMP #$F0
					BCS MODE2_GFX_R
					CMP #$E8
					BCS MODE2_GFX_1
					CMP #$E4
					BCS MODE2_GFX_2
					CMP #$D0
					BCS MODE2_GFX_3
					STZ $1602,x
					JSR SUB_GFX3
MODE2_GFX_R			RTS
MODE2_GFX_1			STZ $1602,x
					JSR SUB_GFX
					RTS
MODE2_GFX_2			LDA #$01
					STA $1602,x
					JSR SUB_GFX
					RTS
MODE2_GFX_3			JSR SUB_GFX6
					RTS
MODE2				JSR MODE2_GFX ;#o
					LDA $9D
					BNE MODE2_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE2_1
					CMP #$F1
					BEQ MODE2_0
					CMP #$F0
					BCS MODE2_R
					CMP #$E4
					BCS MODE2_2
					CMP #$D0
					BCS MODE2_3
					CMP #$C0
					BCS MODE2_R
					CMP #$80
					BCS MODE2_4
					CMP #$7F
					BEQ MODE2_5
MODE2_R				RTS
MODE2_0				STZ $14AF
					LDA #$27
					STA $1DFC
					LDA #$00
					STA $7FF0E6
					RTS
MODE2_1				JSR VRAM1
					LDA #$30
					STA $40
					LDA #$10
					STA $1570,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
					LDA $7FF0DD
					BNE MODE2_1_3
					LDA $7FF0D9
					CMP #$01
					BNE MODE2_R
MODE2_1_3			LDA #$40
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$78
					STA $E4,x
					STZ $14E0,x
					RTS
MODE2_2				LDA $1570,x
					BEQ MODE2_R
					DEC $1570,x
					DEC $1570,x
					RTS
MODE2_3				INC $1570,x
					INC $1570,x
					RTS
MODE2_4				STZ $40
					JSR MARX_MOVE
					LDA $7FF0DD
					BNE MODE2_LAST
					RTS
MODE2_5				LDA $7FF0D9
					CMP #$01 ;#ubNz[[h
					BEQ MODE2_B
					JSR MODE_CHANGE
					RTS
MODE2_B				LDA #$0E
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE2_LAST			LDA #$10
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE2_SPEED			dcb $F4,$0C
MODE2_SPEED2		dcb $E8,$18
MARX_MOVE			LDA $7FF0D9
					CMP #$02
					BCS MARX_MOVE_2
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA MODE2_SPEED,y
					STA $AA,x
					JSL $01801A
					RTS
MARX_MOVE_2			LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA MODE2_SPEED2,y
					STA $AA,x
					JSL $01801A
					RTS
					
MODE3_GFX			LDA $15AC,x
					CMP #$F0
					BCS MODE3_GFX_1
					CMP #$EA
					BCS MODE3_GFX_2
					CMP #$E4
					BCS MODE3_GFX_3
					CMP #$DE
					BCS MODE3_GFX_2
MODE3_GFX_1			STZ $1602,x
					JSR SUB_GFX3
					RTS
MODE3_GFX_2			JSR SUB_GFX7
					RTS
MODE3_GFX_3			LDA #$05
					STA $1602,x
					JSR SUB_GFX
					RTS
MODE3				JSR MODE3_GFX;#Jb^[
					LDA $9D
					BNE MODE3_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE3_1
					CMP #$E0
					BEQ MODE3_G
					CMP #$B0
					BCS MODE3_R
					CMP #$30
					BCS MODE3_2
					CMP #$2F
					BEQ MODE3_3
MODE3_R				RTS
MODE3_3				LDA #$FF
					STA $15AC,x
					STZ $1570,x
					LDA #$04
					STA $C2,x
					RTS
MODE3_1				LDA #$30
					STA $40
					JSR VRAM4
					STZ $1570,x
					RTS
MODE3_2				STZ $40
					LDA $14
					LSR A
					LSR A
					LSR A
					LSR A
					AND #$01
					TAY
					LDA MODE2_SPEED,y
					STA $AA,x
					JSL $01801A
					RTS
MODE3_G				LDA #$26
					STA $1DFC
					JSR MODE3_G2
					LDA $E4,x
					SEC
					SBC #$08
					STA $00E4,y
					LDA $14E0,x
					SBC #$00
					STA $14E0,y
					LDA #$D0
					STA $00B6,y
					LDA #$18
					STA $00AA,y
					LDA $7FF0D9
					CMP #$02
					BCC MODE3_R
					JSR MODE3_G2
					LDA $E4,x
					SEC
					SBC #$08
					STA $00E4,y
					LDA $14E0,x
					SBC #$00
					STA $14E0,y
					LDA #$E8
					STA $00B6,y
					LDA #$30
					STA $00AA,y
					JSR MODE3_G2
					LDA $E4,x
					CLC
					ADC #$08
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA #$18
					STA $00B6,y
					LDA #$30
					STA $00AA,y
					LDA #$01
					STA $00C2,y
					JSR MODE3_G2
					LDA $E4,x
					CLC
					ADC #$08
					STA $00E4,y
					LDA $14E0,x
					ADC #$00
					STA $14E0,y
					LDA #$30
					STA $00B6,y
					LDA #$18
					STA $00AA,y
					LDA #$01
					STA $00C2,y
					RTS
MODE3_G2			JSR SPRITE_GEN
					LDA #$01
					STA $1504,y
					LDA $D8,x
					CLC
					ADC #$18
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA #$80
					STA $15AC,y
					RTS
					
MODE4_GFX			LDA $15AC,x
					CMP #$F8
					BCS MODE4_GFX_1
					CMP #$F2
					BCS MODE4_GFX_2
					CMP #$EE
					BCS MODE4_GFX_3
					CMP #$E6
					BCS MODE4_GFX_4
MODE4_GFX_R			RTS
MODE4_GFX_1			JSR SUB_GFX7
					RTS
MODE4_GFX_2			LDA #$05
					STA $1602,x
					JSR SUB_GFX
					RTS
MODE4_GFX_3			LDA #$01
					STA $1602,x
					JSR SUB_GFX
					RTS
MODE4_GFX_4			STZ $1602,x
					JSR SUB_GFX
					RTS
MODE4_B				LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS
MODE4_C				LDA $157C,x
					BNE MODE4_C_2
					LDA #$0F
					STA $C2,x
					STZ $15AC,x
					RTS
MODE4_C_2			STZ $14C8,x
					RTS
MODE4				JSR MODE4_GFX ;#B
					LDA $9D
					BNE MODE4_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE4_2
					CMP #$F0
					BEQ MODE4_0
					CMP #$EE
					BCS MODE4_R
					CMP #$E6
					BCS MODE4_1
					CMP #$D6
					BEQ MODE4_3
MODE4_R				RTS
MODE4_0				LDA #$27
					STA $1DFC
					RTS
MODE4_1				INC $1570,x
					INC $1570,x
					RTS
MODE4_2				JSR VRAM1
					STZ $1570,x
					LDA #$30
					STA $40
					RTS
MODE4_3				STZ $14AF
					LDA $7FF0E5
					BNE MODE4_5
					LDA $7FF0DD
					BNE MODE4_B
					LDA $7FF0D9
					CMP #$01 ;#ubNz[[h
					BEQ MODE4_B
					CMP #$02
					BEQ MODE4_C
					CMP #$03
					BEQ MODE4_C_2
					JSL $01ACF9 ;#_Ŗ[h
					SEC
					SBC $94
					AND #$0F
					CMP #$02
					BCC MODE4_4
					CMP #$04
					BCC MODE4_5
					JSL $01ACF9
					CLC
					ADC $94
					LSR A
					CLC
					ADC #$38
					STA $E4,x
					STZ $14E0,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
					LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
					RTS
MODE4_4				LDA #$70
					STA $D8,x
					LDA #$01
					STA $14D4,x
					JSR VRAM2
					LDA #$30
					STA $40
					LDA $94
					CMP #$78
					BCS MODE4_4_2
					STZ $157C,x
					LDA #$30
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$FF
					STA $15AC,x
					LDA #$08
					STA $C2,x
					RTS
MODE4_5				LDA #$F8
					STA $15AC,x
					LDA #$0A
					STA $C2,x
					LDA $7FF0E5
					INC A
					STA $7FF0E5
					JSL $01ACF9
					CLC
					ADC $94
					LSR A
					CLC
					ADC #$38
					STA $E4,x
					STZ $14E0,x
					RTS
MODE4_4_2			LDA #$01
					STA $157C,x
					LDA #$C0
					STA $E4,x
					LDA #$FF
					STA $14E0,x
					LDA #$FF
					STA $15AC,x
					LDA #$08
					STA $C2,x
					RTS

MODE5_GFX			LDA $15AC,x
					CMP #$FE
					BCS MODE5_GFX_1
					CMP #$D0
					BCS MODE5_GFX_2
					CMP #$B8
					BCS MODE5_GFX_3
					CMP #$B0
					BCS MODE5_GFX_4
					CMP #$90
					BCS MODE5_GFX_2
					CMP #$78
					BCS MODE5_GFX_3
					CMP #$70
					BCS MODE5_GFX_4
					CMP #$50
					BCS MODE5_GFX_2
					CMP #$38
					BCS MODE5_GFX_3
					CMP #$30
					BCS MODE5_GFX_4
					RTS
MODE5_GFX_1			STZ $1602,x
					JSR SUB_GFX3
					RTS
MODE5_GFX_2			STZ $40
					JSR SUB_GFX5
					RTS
MODE5_GFX_3			LDA #$01
					STA $1602,x
					LDA #$30
					STA $40
					JSR SUB_GFX4
					RTS
MODE5_GFX_4			LDA #$02
					STA $1602,x
					JSR SUB_GFX3
					RTS
MODE5				JSR MODE5_GFX ;#e
					LDA $9D
					BNE MODE5_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE5_1
					CMP #$D0
					BCS MODE5_2
					CMP #$C8
					BEQ MODE5_G
					CMP #$B0
					BCS MODE5_R
					CMP #$90
					BCS MODE5_3
					CMP #$88
					BEQ MODE5_G
					CMP #$70
					BCS MODE5_R
					CMP #$50
					BCS MODE5_3
					CMP #$48
					BEQ MODE5_G
					CMP #$31
					BCS MODE5_R
					CMP #$30
					BEQ MODE5_4
MODE5_R				RTS
MODE5_4				STZ $157C,x
					LDA #$FF
					STA $15AC,x
					STZ $B6,x
					LDA #$04
					STA $C2,x
					RTS
MODE5_1				JSR VRAM3
					STZ $40
					LDA $E4,x
					CMP #$78
					BCC MODE5_R
					LDA #$01
					STA $157C,x
					RTS
MODE5_G				BRA MODE5_G_0
MODE5_2				LDA #$E0
					STA $15AC,x
					LDA $157C,x
					BEQ MODE5_2_2
					LDA #$28
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$D8
					BCS MODE5_2_3
					RTS
MODE5_2_2			LDA #$D8
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$18
					BCS MODE5_R
MODE5_2_3			LDA #$CF
					STA $15AC,x
					LDA #$30
					STA $40
					LDA $157C,x
					EOR #$01
					STA $157C,x
					RTS
MODE5_3				LDA $157C,x
					BEQ MODE5_3_2
					LDA #$28
					STA $B6,x
					JSL $018022
					RTS
MODE5_3_2			LDA #$D8
					STA $B6,x
					JSL $018022
					RTS
MODE5_G_0			JSR SPRITE_GEN
					LDA #$02
					STA $1504,y
					LDA #$2B
					STA $1DFC
					RTS
					
MODE6_GFX			LDA $15AC,x
					CMP #$F0
					BCS MODE6_GFX_1
					JSR SUB_GFX5
					RTS
MODE6_GFX_1			STZ $1602,x
					JSR SUB_GFX4
					RTS
MODE6				JSR MODE6_GFX ;#A^bN
					LDA $9D
					BNE MODE6_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE6_1
					CMP #$F0
					BCS MODE6_2
					CMP #$E8
					BCS MODE6_R
					BRA MODE6_3
					RTS
MODE6_1				STZ $157C,x
					LDA $94
					CMP #$78
					BCC MODE6_R
					LDA #$01
					STA $157C,x
					RTS
MODE6_2				LDA #$F8
					STA $15AC,x
					LDA $157C,x
					BNE MODE6_2_2
					LDA #$30
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$D8
					BCC MODE6_R
					LDA #$EF
					STA $15AC,x
					LDA #$60
					STA $AA,x
MODE6_R				RTS
MODE6_2_2			LDA #$D0
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$18
					BCS MODE6_R
					LDA #$EF
					STA $15AC,x
					LDA #$60
					STA $AA,x
					RTS
MODE6_3				LDA $AA,x
					BEQ MODE6_3_1
					DEC $AA,x
					DEC $AA,x
MODE6_3_1			LDA $157C,x
					BNE MODE6_3_2
					LDA #$C0
					STA $B6,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $14E0,x
					CMP #$FF
					BNE MODE6_R
					LDA $E4,x
					CMP #$C0
					BCC MODE6_4
					RTS
MODE6_3_2			LDA #$40
					STA $B6,x
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					LDA $14E0,x
					CMP #$01
					BNE MODE6_R
					LDA $E4,x
					CMP #$40
					BCC MODE6_R
MODE6_4				STZ $AA,x
					STZ $B6,x
					JSL $01ACF9
					CLC
					ADC $94
					LSR A
					CLC
					ADC #$38
					STA $E4,x
					STZ $14E0,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
					LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $1570,x
					STZ $157C,x
					RTS

MODE7_GFX			LDA $15AC,x
					CMP #$F0
					BCS MODE7_GFX_1
					JSR SUB_GFX5
					RTS
MODE7_GFX_1			STZ $1602,x
					JSR SUB_GFX4
					RTS
MODE7				JSR MODE7_GFX ;#H
					LDA $9D
					BNE MODE7_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE7_1
					CMP #$F0
					BCS MODE7_2
					BRA MODE7_3
MODE7_1				STZ $40
					JSR VRAM2
					STZ $157C,x
					LDA $94
					CMP #$78
					BCC MODE7_R
					LDA #$01
					STA $157C,x
					RTS
MODE7_2				LDA #$F8
					STA $15AC,x
					LDA $157C,x
					BNE MODE7_2_2
					LDA #$30
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$D8
					BCC MODE7_R
					LDA #$EF
					STA $15AC,x
					LDA #$30
					STA $40
MODE7_R				RTS
MODE7_2_2			LDA #$D0
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$18
					BCS MODE7_R
					LDA #$EF
					STA $15AC,x
					LDA #$30
					STA $40
					RTS
MODE7_3				LDA $7FF0D9
					CMP #$02
					BCC MODE7_4
					LDA $14
					AND #$0F
					BNE MODE7_4
					JSR SPRITE_GEN
					LDA #$03
					STA $1504,y
MODE7_4				LDA $157C,x
					BNE MODE7_4_2
					LDA #$E0
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$08
					BCC MODE7_4_3
					RTS
MODE7_4_2			LDA #$20
					STA $B6,x
					JSL $018022
					LDA $E4,x
					CMP #$E8
					BCC MODE7_R
MODE7_4_3			LDA #$FF
					STA $15AC,x
					STZ $40
					LDA #$04
					STA $C2,x
					STZ $157C,x
					STZ $B6,x
					RTS
					
MODE8_GFX			LDA $15AC,x
					BNE MODE8_GFX_1
					LDA $1558,x
					BEQ MODE8_GFX_1
					STZ $1602,x
					JSR SUB_GFX4
					RTS
MODE8_GFX_1			JSR SUB_GFX5
					RTS
MODE8				JSR MODE8_GFX ;#
					LDA $9D
					BNE MODE8_R
					LDA $15AC,x
					BEQ MODE8_2
					CMP #$10
					BCS MODE8_0
					CMP #$01
					BNE MODE8_R
					JSR SPRITE_GEN
					LDA #$05
					STA $1504,y
					LDA #$70
					STA $15AC,y
					RTS
MODE8_0				LDA $157C,x
					BNE MODE8_1
					LDA #$E0
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					BNE MODE8_R
					LDA $E4,x
					CMP #$C0
					BCS MODE8_R
					LDA #$10
					STA $15AC,x
					LDA #$80
					STA $1558,x
					RTS
MODE8_1				LDA #$20
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					BNE MODE8_R
					LDA $E4,x
					CMP #$30
					BCC MODE8_R
					LDA #$10
					STA $15AC,x
					LDA #$80
					STA $1558,x
MODE8_R				RTS
MODE8_2				LDA $1558,x
					BEQ MODE8_4
					CMP #$10
					BCS MODE8_3
					STZ $40
					RTS
MODE8_3				LDA $7FF0D9
					CMP #$02
					BCC MODE8_3_1
					STZ $AA,x
					LDA $14
					AND #$07
					BNE MODE8_3_1
					LDA #$06
					STA $1DFC
					JSR SPRITE_GEN
					JSL $01ACF9
					LSR A
					LSR A
					LSR A
					STA $1602,y
					JSL $01ACF9
					LSR A
					LSR A
					LSR A
					STA $1528,y
					JSL $01ACF9
					LSR A
					LSR A
					LSR A
					LSR A
					CLC
					ADC $D8,x
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					LDA #$04
					STA $1504,y
MODE8_3_1			LDA #$F0
					STA $B6,x
					LDA $157C,x
					BEQ MODE8_3_2
					LDA #$10
					STA $B6,x
MODE8_3_2			JSL $018022
MODE8_R2			RTS
MODE8_4				DEC $AA,x
					LDA $157C,x
					BNE MODE8_4_2
					LDA #$D0
					STA $B6,x
					JSL $018022
					JSL $01801A
					LDA $14E0,x
					CMP #$FF
					BNE MODE8_R2
					LDA $E4,x
					CMP #$C0
					BCC MODE8_5
					RTS
MODE8_4_2			LDA #$30
					STA $B6,x
					JSL $018022
					JSL $01801A
					LDA $14E0,x
					CMP #$01
					BNE MODE8_R2
					LDA $E4,x
					CMP #$40
					BCS MODE8_5
					RTS
MODE8_5				STZ $AA,x
					STZ $B6,x
					STZ $157C,x
					LDA #$FF
					STA $15AC,x
					LDA #$02
					STA $C2,x
					STZ $1558,x
					JSL $01ACF9
					CLC
					ADC $94
					LSR A
					CLC
					ADC #$38
					STA $E4,x
					STZ $14E0,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
					RTS
					

MODE9				LDA #$01
					STA $1602,x
					JSR SUB_GFX3 ;#c^
					LDA $9D
					BNE MODE9_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE9_1
					CMP #$21
					BCS MODE9_2
					CMP #$20
					BEQ MODE9_3
					LDA $7FF0E6
					CMP #$03
					BCC MODE9_R
					LDA $7FF0D9
					CMP #$02
					BCS MODE9_V
					LDA #$10
					STA $7FF0E6
					JSR MODE6_4
					RTS
MODE9_V				LDA #$2B
					STA $1DFC
					LDA $94
					STA $E4,x
					LDA #$0B
					STA $C2,x
					STZ $B6,x
					JSR NORMAL_GEN
					TYA
					STA $7FF0E8
MODE9_R				RTS
MODE9_1				LDA #$28
					STA $AA,x
					LDA #$30
					STA $40
					JSR VRAM4
					RTS
MODE9_2				JSL $01801A
					LDA $AA,x
					BPL MODE9_2_3
					CMP #$A0
					BCC MODE9_2_2
MODE9_2_3			DEC $AA,x
					DEC $AA,x
MODE9_2_2			LDA $14D4,x
					BNE MODE9_R
					LDA $D8,x
					CMP #$81
					BCS MODE9_R
					STZ $AA,x
					LDA #$21
					STA $15AC,x
					RTS
MODE9_3				LDA #$2B
					STA $1DFC
					JSR SPRITE_GEN
					LDA #$06
					STA $1504,y
					LDA #$78
					STA $00E4,y
					STZ $40
					RTS
					
MODEA_GFX			LDA $15AC,x
					CMP #$F0
					BCS MODEA_GFX_R
					CMP #$E8
					BCS MODEA_GFX_1
					STZ $1570,x
					LDA #$05
					STA $1602,x
					JSR SUB_GFX
MODEA_GFX_R			RTS
MODEA_GFX_1			STZ $1602,x
					JSR SUB_GFX
					RTS
MODEA_GFX_2			LDA #$01
					STA $1602,x
					JSR SUB_GFX
					RTS
MODEA_GFX_3			JSR SUB_GFX6
					RTS
MODEA				JSR MODEA_GFX ;#A[v
					LDA $9D
					BNE MODEA_R
					LDA $15AC,x
					CMP #$F7
					BEQ MODEA_1
					CMP #$F1
					BEQ MODEA_0
					CMP #$F0
					BCS MODEA_R
					CMP #$E8
					BCS MODEA_2
					CMP #$E2
					BCS MODEA_3
MODEA_R				RTS
MODEA_0				LDA #$27
					STA $1DFC
					RTS
MODEA_1				LDA #$10
					STA $1570,x
					JSL $01ACF9
					LSR A
					CLC
					ADC #$F0
					STA $D8,x
					LDA #$00
					ADC #$00
					STA $14D4,x
					RTS
MODEA_2				LDA $1570,x
					BEQ MODEA_R
					DEC $1570,x
					DEC $1570,x
					RTS
MODEA_3				STZ $1570,x
					LDA #$FF
					STA $15AC,x
					LDA #$04
					STA $C2,x
					LDA $7FF0E5
					CMP #$05
					BCC MODEA_R
					LDA #$00
					STA $7FF0E5
					RTS
					
MODEB_GFX			LDA $1558,x
					BEQ MODEB_GFX1
					CMP #$E0
					BCS MODEB_GFX1
					CMP #$AB
					BCS MODEB_GFX2
					LDA #$01
					STA $1602,x
					JSR SUB_GFX9
					RTS
MODEB_GFX1			JSR SUB_GFX8
					RTS
MODEB_GFX2			STZ $1602,x
					JSR SUB_GFX9
					RTS
MODEB_SPEED			dcb $60,$A0
MODEB				JSR MODEB_GFX
					LDA $9D
					BNE MODEB_R
					LDA $7FF0E8
					TAY
					LDA $14D4,y
					BEQ MODEB_A
					LDA $00D8,y
					CMP #$80
					BCC MODEB_A
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $00B6,y
MODEB_A				LDA $1558,x
					BEQ MODEB_0
					CMP #$C0
					BEQ MODEB_3
					CMP #$C0
					BCS MODEB_R
					CMP #$AC
					BCS MODEB_4
					CMP #$AB
					BEQ MODEB_1
					CMP #$50
					BCS MODEB_2
					CMP #$20
					BCS MODEB_5
					CMP #$1F
					BEQ MODEB_6
					RTS
MODEB_0				JSL $01802A
					LDA $14D4,x
					BEQ MODEB_R
					LDA $D8,x
					CMP #$80
					BCC MODEB_R
					LDA #$10
					STA $1DFC
					LDA #$20
					STA $1887
					LDA #$FF
					STA $1558,x
					JSR VRAM1
					LDA #$30
					STA $40
MODEB_R				RTS
MODEB_1				JSR HDMA_LASER
					STZ $157C,x
					LDA $E4,x
					CMP $94
					BCS MODEB_1_2
					LDA #$01
					STA $157C,x
MODEB_1_2			LDA $157C,x
					TAY
					LDA MODEB_SPEED,y
					STA $B6,x
					LDA #$17
					STA $1DFC
					RTS
MODEB_2				LDA $14E0,x
					BEQ MODEB_2_6
					LDA $E4,x
					AND #$F0
					CMP #$80
					BEQ MODEB_2_7
MODEB_2_6			JSL $018022
MODEB_2_7			JSR MODEB_SUB
					RTS
MODEB_3				JSR MODEB_SUB2
					RTS
MODEB_4				JSR MODEB_SUB3
					RTS
MODEB_5				JSR MODEB_SUB4
					RTS
MODEB_6				STZ $40
					LDA #$01
					STA $7FDF00
					STA $7FE100
					LDA #$00
					STA $7FDF01
					STA $7FF0E6
					LDA #$FF
					STA $7FE101
					LDA #$00
					STA $7FDF02
					STA $7FE102
					LDA #$E5
					STA $15AC,x
					LDA #$04
					STA $C2,x
					LDA #$13
					STA $7FE903
					LDA #$17
					STA $7FE901
					LDA #$04
					STA $212D
					STZ $B6,x
					STZ $AA,x
					STZ $1558,x
					LDA $7FF0E8
					TAY
					LDA #$00
					STA $14C8,y
					JSR SUB_SMOKE
					RTS

MODEB_SUB			LDA $7FDF04
					SEC
					SBC #$08
					STA $0F
					LDA $97
					BEQ MODEB_SUB_8
					LDA $96
					CMP $0F
					BCC MODEB_SUB_8
					LDA $1497
					BNE MODEB_SUB_8
					BCC MODEB_SUB_8
					JSL $00F5B7
MODEB_SUB_8			LDA $14
					AND #$1F
					BNE MODEB_SUB_0
					JSR SPRITE_GEN
					LDA #$08
					STA $1504,y
					JSL $01ACF9
					LSR A
					LSR A
					CLC
					ADC #$48
					STA $00D8,y
					LDA #$01
					STA $14D4,y
					LDA $157C,x
					STA $157C,y
					JSL $01ACF9
					AND #$03
					STA $00C2,y
MODEB_SUB_0			LDA $7FDF06
					CMP #$60
					BCS MODEB_SUB_1
					LDA $7FDF04
					DEC A
					STA $7FDF04
					STA $7FE104
					LDA $7FDF06
					INC A
					INC A
					STA $7FDF06
					STA $7FE106
MODEB_SUB_1			LDA $157C,x
					BNE MODEB_2_2
					LDA #$00
					STA $7FDF07
					LDA $14E0,x
					BNE MODEB_2_1
					LDA $E4,x
					STA $7FE107
					RTS
MODEB_2_1			LDA #$FF
					STA $7FE107
					RTS
MODEB_2_2			LDA #$FF
					STA $7FE107
					LDA $14E0,x
					BEQ MODEB_2_3
					LDA $E4,x
					CLC
					ADC #$10
					BCS MODEB_2_3
					LDA #$00
					STA $7FDF07
					RTS
MODEB_2_3			LDA $E4,x
					CLC
					ADC #$10
					STA $7FDF07
					RTS
MODEB_SUB2			JSR VRAM6
					JSR HDMA_CIRCLE
					LDA $E4,x
					CLC
					ADC #$08
					STA $7FDEFD;#SxW
					LDA #$C8
					STA $7FDEFE;#SyW
					LDA #$04
					STA $7FDEFF;#~̔a
					JSR CIRCLE_GEN
					RTS
MODEB_SUB3			LDA $7FDEFF
					INC A
					INC A
					STA $7FDEFF
					JSR CIRCLE_GEN
					LDA #$04
					STA $7FE903
					LDA #$13
					STA $212D
					LDA #$64
					STA $40
					RTS
MODEB_SUB4			LDA $7FDF06
					CMP #$03
					BCC MODEB_5_2
					DEC A
					DEC A
					STA $7FDF06
					STA $7FE106
					LDA $7FDF04
					INC A
					STA $7FDF04
					STA $7FE104
MODEB_5_2			RTS


MODEC_GFX			LDA $15AC,x
					CMP #$D0
					BCS MODEC_GFX1
					LDA #$02
					STA $1602,x
					JSR SUB_GFX3
					RTS
MODEC_GFX1			LDA #$01
					STA $1602,x
					JSR SUB_GFX4
					RTS
MODEC				JSR MODEC_GFX ;#A{
					LDA $9D
					BNE MODEC_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODEC_1
					CMP #$D0
					BEQ MODEC_G
					LDA $7FF0D9
					CMP #$02
					BCC MODEC_3
					LDA $15AC,x
					CMP #$B0
					BEQ MODEC_G
					CMP #$90
					BEQ MODEC_G
					CMP #$70
					BEQ MODEC_G
					CMP #$30
					BEQ MODEC_2
MODEC_R				RTS
MODEC_1				JSR VRAM4
					LDA #$30
					STA $40
					RTS
MODEC_2				LDA #$FF
					STA $15AC,x
					STZ $B6,x
					LDA #$04
					STA $C2,x
					RTS
MODEC_3				LDA $15AC,x
					CMP #$90
					BEQ MODEC_2
					RTS
MODEC_G				JSR SPRITE_GEN
					LDA #$02
					STA $1504,y
					LDA #$2B
					STA $1DFC
					LDA $D8,x
					CLC
					ADC #$10
					STA $00D8,y
					LDA $14D4,x
					ADC #$00
					STA $14D4,y
					RTS
					
MODED_SPEED			dcb $C0,$40
MODED				JSR SUB_GFXA	;#
					LDA $9D
					BNE MODED_R1
					LDA $15AC,x
					CMP #$FE
					BEQ MODED_1
					CMP #$E8
					BCS MODED_R
					CMP #$A0
					BCS MODED_2
					CMP #$9F
					BEQ MODED_3
					CMP #$40
					BCS MODED_4
					CMP #$3F
					BEQ MODED_5
					RTS
MODED_5				LDA $1602,x
					BNE MODED_DEL
					LDA #$FF
					STA $15AC,x
					LDA #$04
					STA $C2,x
MODED_R1			RTS
MODED_DEL			STZ $14C8,x
					RTS
MODED_1				JSR SPRITE_GEN
					STZ $157C,x
					LDA #$0D
					STA $00C2,y
					LDA #$01
					STA $157C,y
					LDA #$FE
					STA $15AC,y
					LDA $D8,x
					SEC
					SBC #$04
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					LDA #$01
					STA $1602,y
					RTS
MODED_2				LDA $157C,x
					TAY
					LDA MODED_SPEED,y
					STA $B6,x
					JSL $018022
					RTS
MODED_3				LDA #$70
					STA $D8,x
					LDA #$01
					STA $14D4,x
					LDA #$78
					STA $E4,x
					LDA $157C,x
					BNE MODED_3_2
					LDA #$FF
					STA $14E0,x
MODED_R				RTS
MODED_3_2			LDA #$01
					STA $14E0,x
					RTS
MODED_4				LDA $157C,x
					EOR #$01
					TAY
					LDA MODED_SPEED,y
					STA $B6,x
					JSL $018022
					LDA $14E0,x
					BNE MODED_R
					LDA $157C,x
					BNE MODED_4_2
					LDA $E4,x
					CMP #$78
					BCC MODED_R
					LDA #$78
					STA $E4,x
					RTS
MODED_4_2			LDA $E4,x
					CMP #$79
					BCS MODED_R
					LDA #$78
					STA $E4,x
					RTS

MODEE_SPEED			dcb $F0,$10
MODEE				JSR SUB_GFXA ;#ubNz[
					LDA $9D
					BNE MODEE_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODEE_1
					CMP #$F0
					BEQ MODEE_2
					CMP #$F0
					BCS MODEE_R
					CMP #$D0
					BCS MODEE_3
					CMP #$90
					BEQ MODEE_4
MODEE_R				RTS
MODEE_1				JSR SPRITE_GEN
					STZ $157C,x
					LDA #$0E
					STA $00C2,y
					LDA #$01
					STA $157C,y
					LDA #$FE
					STA $15AC,y
					LDA $D8,x
					SEC
					SBC #$04
					STA $00D8,y
					LDA $14D4,x
					SBC #$00
					STA $14D4,y
					LDA #$01
					STA $1602,y
					RTS
MODEE_2				LDA $157C,x
					BNE MODEE_2_2
					JSR SPRITE_GEN
					LDA #$09
					STA $1504,y
					LDA #$FF
					STA $15AC,y
					LDA #$20
					STA $1558,y
MODEE_2_2			LDA $157C,x
					TAY
					LDA MODEE_SPEED,y
					STA $B6,x
					RTS
MODEE_3				JSL $018022
					RTS
MODEE_4				LDA #$F7
					STA $15AC,x
					STZ $1570,x
					STZ $B6,x
					LDA #$02
					STA $7FF0D9
					LDA #$04
					STA $C2,x
					RTS
					
MODEF				LDA $7FF0D9
					CMP #$03
					BEQ MODEF_1
					LDA $9D
					BNE MODEF_R
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $157C,x
					LDA #$D0
					STA $E4,x
					LDA #$FF
					STA $14E0,x
					LDA #$F0
					STA $D8,x
					STZ $14D4,x
MODEF_2				LDA $18BD
					BEQ MODEF_R
					LDA #$40
					STA $13E0
					LDA #$50
					STA $13DF
					LDA #$01
					STA $76
					LDA #$FF
					STA $18BD
MODEF_R				RTS
MODEF_1				JSR SUB_GFX5
					LDA $9D
					BNE MODEF_R
					LDA $15AC,x
					BEQ MODEF_5
					CMP #$D0
					BCS MODEF_2
					CMP #$CF
					BEQ MODEF_3
					CMP #$A0
					BCS MODEF_R
					CMP #$20
					BCS MODEF_4
					RTS
MODEF_3				JSR MODEF_SUB
					RTS
MODEF_5				JSR CHIBI_CHECK
					CPY #$00
					BNE MODEF_R
					JSR MODEF_SUB2
					RTS
MODEF_4				LDA #$30
					STA $B6,x
					JSL $018022
					LDA $15AC,x
					CMP #$80
					BEQ MODEF_G
					CMP #$70
					BEQ MODEF_G
					CMP #$60
					BEQ MODEF_G
					CMP #$50
					BEQ MODEF_G
					RTS
MODEF_G				JSR SPRITE_GEN
					LDA #$0B
					STA $1504,y
					JSL $01ACF9
					AND #$01
					STA $157C,y
					LDA #$2B
					STA $1DFC
					LDA #$30
					STA $1656,y
					LDA #$80
					STA $1662,y
					LDA #$01
					STA $167A,y
					LDA #$1F
					STA $166E,y
					RTS
					
MODEF_SUB			JSR VRAM3
					LDA #$0E
					STA $2121
					LDA #$0B
					STA $2122
					LDA #$01
					STA $2122
					LDA #$0F
					STA $2121
					LDA #$10
					STA $2122
					LDA #$0E
					STA $2122
					LDA #$00
					STA $7FDF01
					STA $7FDF02
					STA $7FE102
					LDA #$FF
					STA $7FE101
					LDA #$14
					STA $7FE903
					LDA #$14
					STA $7FE901
					LDA #$03
					STA $212D
					STZ $40
					STZ $7D
					STZ $7B
					LDA #$78
					STA $94
					STZ $95
					LDA #$70
					STA $96
					LDA #$01
					STA $97
					STZ $18BD
					RTS
MODEF_SUB2			LDA #$04
					STA $7FF0D9
					LDA #$E5
					STA $15AC,x
					LDA #$04
					STA $C2,x
					LDA #$13
					STA $7FE903
					LDA #$17
					STA $7FE901
					LDA #$04
					STA $212D
					STZ $B6,x
					LDA #$78
					STA $94
					LDA #$80
					STA $96
					STZ $97
					STZ $7D
					STZ $7B
					RTS
					
MODE10				STZ $1602,x
					JSR SUB_GFX3
					LDA $9D
					BNE MODE10_R
					LDA $15AC,x
					CMP #$FE
					BEQ MODE10_1
					CMP #$DF
					BEQ MODE10_0
					CMP #$B8
					BCS MODE10_2
					CMP #$B7
					BEQ MODE10_4
					CMP #$B6
					BEQ MODE10_5
					CMP #$80
					BCS MODE10_6
					CMP #$40
					BEQ MODE10_7
					JSR MODE10_SUB4
MODE10_R			RTS
MODE10_4			LDA #$17
					STA $7FE901
					LDA #$13
					STA $7FE903
					LDA #$04
					STA $212D
					RTS
MODE10_5			LDA #$30
					STA $40
					JSR VRAM5
					RTS
MODE10_2			JSR MODE10_SUB3
					RTS
MODE10_1			JSR MODE10_SUB1
					RTS
MODE10_0			JSR MODE10_SUB2
					RTS
MODE10_6			LDA $D8,x
					CMP #$70
					BCS MODE10_R
					LDA #$10
					STA $AA,x
					JSL $01801A
					RTS
MODE10_7			JSR KIRBY_RAM1
					JSR SPRITE_GEN
					LDA #$0C
					STA $1504,y
					LDA #$80
					STA $00D8,y
					LDA #$00
					STA $14D4,y
					LDA #$C0
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STZ $40
					LDA #$23
					STA $1DFB
					RTS
MODE10_SUB1			LDA #$10
					STA $7FE901
					STA $7FE903
					LDA #$07
					STA $212D
					LDA #$64
					STA $40
					JSR VRAM6
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
MODE10_SUB2			LDA #$00
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					REP #$30
					LDA.W #$7FFF
					STA $7FF122
					SEP #$30
					LDA #$18
					STA $1DFC
					RTS
MODE10_SUB3			REP #$30
					LDA $7FF122
					BEQ MODE10_SUB3_1
					SEC
					SBC.W #$0421
					STA $7FF122
MODE10_SUB3_1		SEP #$30
					LDA #$00
					STA $2121
					LDA $7FF122
					STA $2122
					LDA $7FF123
					STA $2122
					RTS
MODE10_SUB4			LDA $1558,x
					BNE MODE10_SUB4_1
					LDA $7FF123
					BEQ MODE10_SUB4_R
					LDA #$20
					STA $1558,x
					RTS
MODE10_SUB4_1		LDA $1558,x
					CMP #$01
					BEQ MODE10_SUB4_2
					LDA #$20
					STA $B6,x
					JSL $018022
MODE10_SUB4_R		RTS
MODE10_SUB4_2		STZ $14C8,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHANGE_TABLE		dcb $03,$05,$06,$07,$09,$0C,$0D,$06
MODE_CHANGE			LDA #$FF
					STA $15AC,x
					JSL $01ACF9
					CLC
					ADC $13
					SEC
					SBC $94
					AND #$07
					CMP #$07
					BEQ MODE_CHANGE_1
					TAY
					LDA CHANGE_TABLE,y
					STA $C2,x
					RTS
MODE_CHANGE_1		JSL $01ACF9
					AND #$07
					TAY
					LDA CHANGE_TABLE,y
					STA $C2,x
					RTS
					
LAYER3_MOVE			LDA $7FF0D9
					CMP #$03
					BEQ LAYER3_MOVE_2
					LDA $24
					INC A
					INC A
					AND #$1F
					STA $24
					RTS
LAYER3_MOVE_2		LDA $24
					DEC A
					AND #$1F
					STA $24
					LDA $22
					INC A
					AND #$1F
					STA $22
					RTS
CHIBI_CHECK			LDY #$00
					PHX
					LDX #$00
CHIBI_CHECK_LOOP	LDA $14C8,x
					BEQ CHIBI_CHECK_1
					LDA $1504,x
					CMP #$0B
					BNE CHIBI_CHECK_1
					LDY #$01
CHIBI_CHECK_1		INX
					CPX #$0A
					BCC CHIBI_CHECK_LOOP
					PLX
					RTS
					
SUB_MAIN2_1			LDA $E4,x
					SEC
					SBC #$E8
					LDA $14E0,x
					SBC #$00
					BCC SUB_MAIN2_1_2
					LDA $B6,x
					BMI SUB_MAIN2_1_R
					EOR #$FF
					STA $B6,x
SUB_MAIN2_1_R		RTS
SUB_MAIN2_1_2		LDA $E4,x
					SEC
					SBC #$08
					LDA $14E0,x
					SBC #$00
					BCS SUB_MAIN2_1_R
					LDA $B6,x
					BPL SUB_MAIN2_1_R
					EOR #$FF
					STA $B6,x
					RTS
					
SUB_MAIN2_2			LDA $D8,x
					SEC
					SBC #$80
					LDA $14D4,x
					SBC #$01
					BCC SUB_MAIN2_2_2
					LDA $AA,x
					BMI SUB_MAIN2_2_R
					EOR #$FF
					STA $AA,x
SUB_MAIN2_2_R		RTS
SUB_MAIN2_2_2		LDA $D8,x
					SEC
					SBC #$C0
					LDA $14D4,x
					SBC #$00
					BCS SUB_MAIN2_2_R
					LDA $AA,x
					BPL SUB_MAIN2_2_R
					EOR #$FF
					STA $AA,x
					RTS

LAYER3_DELETE		LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5000
					STA $03
LAYER3_D_LOOP		LDA $03
					STA $2116
					LDA.W #$2CFC
					STA $2118
					LDA $03
					INC A
					STA $03
					CMP.W #$6000
					BCC LAYER3_D_LOOP
					SEP #$20
					PHX
					LDX #$00
LAYER3_D_LOOP2		LDA #$FC
					STA $7FFFD0,x
					INX
					CPX #$20
					BCC LAYER3_D_LOOP2
					PLX
					STZ $22
					STZ $23
					STZ $24
					STZ $25
					RTS
					


DAMAGE_RT			LDA $1497
					BNE DAMAGE_R
					JSL $01A7DC
					BCC DAMAGE_R
					JSL $00F5B7
DAMAGE_R			RTS





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
NEW_SPEED           dcb $B0,$50
RETURN69            RTS  
SPRITE_GEN			JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN69            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x               ; \ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables                   ; /
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					
                    RTS                     ; return



RETURN6A            RTS  
NORMAL_GEN			JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN6A            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    
					LDA #$2F
					STA $009E,y
					LDA $E4,x
					CMP #$78
					BCC NORMAL_GEN_1
                    LDA #$30
                    STA $00E4,y
					BRA NORMAL_GEN_2
NORMAL_GEN_1		LDA #$C0
                    STA $00E4,y
NORMAL_GEN_2        LDA #$00
                    STA $14E0,y             ; /

                    LDA #$80
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables               
                    PLX
					RTS
					
					
BH2_X				dcb $60,$3C,$00,$C4,$A0,$C4,$00,$3C
BH2_X2				dcb $00,$00,$00,$FF,$FF,$FF,$00,$00
BH2_Y				dcb $00,$3C,$60,$3C,$00,$C4,$A0,$C4
BH2_Y2				dcb $00,$00,$00,$00,$00,$FF,$FF,$FF

GEN_BH23			LDA #$D0
					STA $7FF0F0
RETURN6B			RTS
GEN_BH2				LDA $1558,x
					BNE GEN_BH23
					LDA $15AC,x
					CMP #$30
					BCC RETURN6B
					LDA $14
					AND #$07
					BNE RETURN6B
					JSL $02A9DE
                    BMI RETURN6B
					LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $E4,x               ; \ set x position for new sprite
                    STA $00E4,y

                    LDA $14E0,x             ;  |
                    STA $14E0,y             ; /

                    LDA $D8,x               ; \ set y position for new sprite
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables                   ; /
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA $7FF0F0
					STA $1528,y
					SEC
					SBC #$04
					STA $7FF0F0
					JSL $01ACF9
					AND #$01
					STA $1602,y
					LDA #$30
					STA $15AC,y
					LDA #$0A
					STA $1504,y
					PHX
					JSL $01ACF9
					AND #$07
					STA $1570,y
					TAX
					LDA BH2_X,x
					CLC
					ADC $00E4,y
					STA $00E4,y
					LDA BH2_X2,x
					ADC $14E0,y
					STA $14E0,y
					LDA BH2_Y,x
					CLC
					ADC $00D8,y
					STA $00D8,y
					LDA BH2_Y2,x
					ADC $14D4,y
					STA $14D4,y
					PLX
                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BH2_TILE			dcb $24,$EC,$26
					dcb $2A,$2E,$40			
BH_PRO				dcb $02,$02,$02
					dcb $07,$06,$06
SUB_GFX_BH2			LDA $1602,x
					ASL A
					CLC
					ADC $1602,x
					STA $02
					LDA $15AC,x
					CMP #$18
					BCS SUB_GFX_BH2_1
					INC $02
					CMP #$0C
					BCS SUB_GFX_BH2_1
					INC $02
SUB_GFX_BH2_1		JSR GET_DRAW_INFO
					LDA $1528,x
					TAY
					STA $15EA,x
					LDA $00
					STA $0200,y
					LDA $01
					STA $0201,y
					PHX
					LDX $02
					LDA BH2_TILE,x
					STA $0202,y
					LDA BH_PRO,x
					ORA $64
					STA $0203,y
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS
FLASH_TILE			dcb $2A,$2E,$40			
FLASH_PRO			dcb $07,$06,$06
SUB_GFX_FLASH		STZ $02
					LDA $1540,x
					CMP #$0A
					BCS SUB_GFX_FLASH_1
					INC $02
					LDA $1540,x
					CMP #$05
					BCS SUB_GFX_FLASH_1
					INC $02
SUB_GFX_FLASH_1		JSR GET_DRAW_INFO
					LDA $1528,x
					TAY
					STA $15EA,x
					LDA $00
					STA $0200,y
					LDA $01
					STA $0201,y
					PHX
					LDX $02
					LDA FLASH_TILE,x
					STA $0202,y
					LDA FLASH_PRO,x
					ORA $64
					STA $0203,y
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS
					
HORZ_BEAM			dcb $B0,$08,$38
					dcb $A8,$F0,$40
					dcb $B0,$F0,$48
					dcb $B8,$DC,$30
VERT_BEAM			dcb $28,$08,$10
					dcb $04,$00,$18
					dcb $10,$20,$00
					dcb $1C,$0C,$23
					
SUB_GFX_BEAM		LDA $C2,x
					ASL A
					CLC
					ADC $C2,x
					STA $02
					JSR GET_DRAW_INFO
					PHX
					LDX #$02
GFX_BEAM_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_BEAM,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_BEAM,x
					STA $0301,y
					PLX
					LDA #$EC
					STA $0302,y
					LDA #$02
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL GFX_BEAM_LOOP
					PLX
					LDY #$02
                    LDA #$02
                    JSL $01B7B3
					RTS


TUTA_D1				dcb $F8,$00,$08,$00,
TUTA_D2				dcb $FF,$00,$00,$00

TUTA_D_RA			RTS
TUTA_DAMAGE			LDA $C2,x
					BNE TUTA_D_RA
					LDA $E4,x
					STA $7FF1E4
					LDA $14E0,x
					STA $7FF1E0
					LDA $D8,x
					STA $7FF1D8
					LDA $14D4,x
					STA $7FF1D4
					LDA #$0F
					SEC
					SBC $15AC,x
					LSR A
					LSR A
					TAY
TUTA_DAMAGE_LOOP	LDA $7FF1E4
					CLC
					ADC TUTA_D1,y
					STA $E4,x
					LDA $7FF1E0
					ADC TUTA_D2,y
					STA $14E0,x
					PHY
					JSR DAMAGE_RT
					PLY
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					DEY
					BPL TUTA_DAMAGE_LOOP
					LDA $7FF1E4
					STA $E4,x
					LDA $7FF1E0
					STA $14E0,x
					LDA $7FF1D8
					STA $D8,x
					LDA $7FF1D4
					STA $14D4,x
					RTS



HORZ_TUTA			dcb $00,$08,$00,$F8
					dcb $F0,$EC,$EC,$F4
					dcb $FC,$04,$08,$08
					dcb $04,$02,$06,$08
VERT_TUTA			dcb $00,$F0,$E0,$D0


SUB_GFX_TUTA		LDA $C2,x
					ASL A
					ASL A
					STA $02
					LDA #$0F
					SEC
					SBC $15AC,x
					LSR A
					LSR A
					STA $03
					JSR GET_DRAW_INFO
					PHX
					LDX $03
TUTA_LOOP			PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC HORZ_TUTA,x
					STA $0300,y
					PLX
					LDA $01
					CLC
					ADC VERT_TUTA,x
					STA $0301,y
					LDA #$C4
					STA $0302,y
					LDA #$0A
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					DEX
					BPL TUTA_LOOP
					PLX
					LDY #$02
                    LDA $03
                    JSL $01B7B3
					RTS



SUB_GFX_SEED		LDA $1540,x
					BEQ SUB_GFX_SEED_1
					CMP #$30
					BCS SUB_GFX_SEED_1
					RTS
SUB_GFX_SEED_1		JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$A0
					STA $0302,y
					LDA #$0A
					ORA $64
					STA $0303,y
					LDA $1540,x
					BEQ SUB_GFX_SEED_2
					LDA #$2A
					STA $0302,y
					LDA #$07
					ORA $64
					STA $0303,y
SUB_GFX_SEED_2		LDY #$02
                    LDA #$00
                    JSL $01B7B3
					RTS





TILE_FT				dcb $0C,$0E
PROPETIES_FT		dcb $05,$45

SUB_GFX_FT			LDA $E4,x
					LSR A
					LSR A
					LSR A
					LSR A
					CLC
					ADC $1570,x
					LSR A
					AND #$01
					TAY
					LDA TILE_FT,y
					STA $02
					LDA PROPETIES_FT,y
					STA $03
					JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA $02
					STA $0302,y
					LDA $03
					ORA $64
					STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS

HORZ_AL				dcb $F8,$08,$E8,$F8
VERT_AL				dcb $F8,$F8,$F8,$F8
PROPETIES_AL		dcb $0A,$4A,$0A,$4A

SUB_GFX_AL			LDA $1602,x
					STA $02
					LDA $1528,x
					STA $03
					JSR GET_DRAW_INFO
					PHX
					LDX #$03
LOOP_AL				LDA $00
					CLC
					ADC HORZ_AL,x
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_AL,x
					STA $0301,y
					LDA #$EE
					STA $0302,y
					LDA PROPETIES_AL,x
					ORA $64
					STA $0303,y
					CPX #$02
					BCC SUB_GFX_AL_1
					LDA $0300,y
					CLC 
					ADC $02
					STA $0300,y
					LDA $0301,y
					CLC 
					ADC $03
					STA $0301,y
SUB_GFX_AL_1		INY
					INY
					INY
					INY
					DEX
					BPL LOOP_AL
					PLX
					LDY #$02
                    LDA #$03
                    JSL $01B7B3
                    RTS


HORZ_DISP			dcb $F8,$08,$F8,$08
VERT_DISP			dcb $F8,$F8,$08,$08
					dcb $F8,$F8,$08,$08
					dcb $F8,$F8,$08,$08
					dcb $F8,$F8,$08,$08
					dcb $F8,$F8,$08,$08
					dcb $FE,$FE,$0E,$0E
TILEMAP				dcb $8E,$8E,$8E,$8E ;#
					dcb $8C,$8C,$8C,$8C ;#D
					dcb $8A,$8A,$8A,$8A ;#
					dcb $88,$88,$88,$88 ;#BH
					dcb $84,$86,$A4,$A6 ;#
					dcb $80,$80,$A0,$A0 ;#}N
PROPETIES			dcb $06,$46,$86,$C6
					dcb $06,$46,$86,$C6
					dcb $06,$46,$86,$C6
					dcb $08,$48,$88,$C8
					dcb $06,$06,$06,$06
					dcb $0F,$4F,$0F,$4F

SUB_GFX				LDA $1602,x
					ASL A
					ASL A
					STA $03
					LDA $1570,x
					STA $02
					JSR GET_DRAW_INFO
					PHX                     ; push sprite index
                    LDX #$03              ; loop counter = (number of tiles per frame) - 1
LOOP_START          LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /
					TXA
					AND #$01
					BNE SUB_GFX_1
					LDA $0300,y
					SEC
					SBC $02
					STA $0300,y
					BRA SUB_GFX_2
SUB_GFX_1			LDA $0300,y
					CLC
					ADC $02
					STA $0300,y
SUB_GFX_2
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /
                    LDA PROPETIES,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03              ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
					
HORZ_DISP1			dcb $F8,$08,$F8,$08
					dcb $08,$F8,$08,$F8
VERT_DISP1			dcb $F8,$F8,$08,$08
TILEMAP1			dcb $AC,$AE,$CC,$CE
PROP1				dcb $0E,$0E,$0E,$0E
					dcb $4C,$4C,$4E,$4E

SUB_GFX1            LDA $157C,x
					ASL A
					ASL A
					STA $02
					JSR GET_DRAW_INFO
					PHX                     ; push sprite index
                    LDX #$03              ; loop counter = (number of tiles per frame) - 1
LOOP_START1         LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP1,x         ;  |
                    STA $0301,y             ; /
                    
					LDA TILEMAP1,x           ; \ store tile
                    STA $0302,y             ; / 

					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP1,x         ;  |
                    STA $0300,y             ; /
					
                    LDA PROP1,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START1          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03              ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

HORZ_DISP2			dcb $F8,$08,$E8,$F8,$08,$18,$E8,$F8,$08,$18,$E8,$F8,$08,$18
VERT_DISP2			dcb $E0,$E0,$F0,$F0,$F0,$F0,$00,$00,$00,$00,$10,$10,$10,$10
TILEMAP2			dcb $C6,$C6,$E4,$E6,$E6,$E4,$C0,$C2,$C2,$C0,$E0,$E2,$E2,$E0
PROPETIES2			dcb $02,$42,$02,$02,$42,$42,$02,$02,$42,$42,$02,$02,$42,$42

SUB_GFX2            JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					PHX                     ; push sprite index
                    LDX #$0D              ; loop counter = (number of tiles per frame) - 1
LOOP_START2         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP2,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP2,x         ;  |
                    STA $0201,y             ; /
                    
					LDA TILEMAP2,x           ; \ store tile
                    STA $0202,y             ; / 

                    LDA PROPETIES2,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
HORZ_DISP3			dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18,$EC,$E4,$D4,$BC,$B4,$CC,$BC
					dcb $14,$1C,$2C,$44,$4C,$34,$44
VERT_DISP3			dcb $F0,$F0,$00,$00,$10,$10,$20,$20,$20,$20,$08,$00,$00,$00,$08,$F0,$F0
					dcb $08,$00,$00,$00,$08,$F0,$F0
TILEMAP3			dcb $8A,$8A,$AC,$AC,$CC,$CC,$EC,$EC,$8C,$8C,$E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $A2,$A2,$88,$88,$A8,$A8,$C8,$C8,$A2,$A2,$E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $8E,$8E,$AE,$AE,$CE,$CE,$EE,$EE,$8C,$8C,$E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $E6,$D5,$D3,$D1,$E0,$0A,$08
PROPETIES3			dcb $0F,$4D,$0F,$4D,$0F,$4F,$0F,$4F,$0F,$4F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
					dcb $4F,$4F,$4F,$4F,$4F,$4F,$4F
WING_TILE			dcb $0C,$0E,$0E,$0C,$0E
					dcb $0E,$0C,$0E,$0E,$0C
					dcb $0C,$0E,$0E,$0E,$0E
					dcb $0C,$0E,$0E,$0E,$0C
WING_HORZ			dcb $D8,$E8,$10,$30,$38
					dcb $D4,$D0,$24,$30,$40
					dcb $C4,$D4,$EC,$1C,$2C
					dcb $C8,$D6,$E8,$26,$44
WING_VERT			dcb $08,$1C,$10,$18,$08
					dcb $14,$10,$12,$03,$10
					dcb $10,$03,$12,$18,$04
					dcb $00,$1C,$0C,$08,$0C
WING_PROP			dcb $05,$05,$45,$45,$45
					dcb $05,$05,$45,$45,$45
					dcb $05,$05,$05,$45,$45
					dcb $05,$05,$05,$45,$45

SUB_GFX3            JSR DAMAGE_CHECK_1
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					STZ $0F
					LDA $1602,x
					BEQ SUB_GFX3_3
					LDA #$18
					STA $0F
					LDA $1602,x
					CMP #$01
					BEQ SUB_GFX3_3
					LDA #$30
					STA $0F
SUB_GFX3_3			LDA $14
					AND #$07
					STA $02
					CMP #$05
					BCC SUB_GFX3_0
					LDA #$08
					SEC
					SBC $02
					STA $02
SUB_GFX3_0			LSR A
					STA $03
					PHX                     ; push sprite index
                    LDX #$00              ; loop counter = (number of tiles per frame) - 1
LOOP_START3         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP3,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP3,x         ;  |
                    STA $0201,y             ; /
                    
					CPX #$0A
					BCC SUB_GFX3_1
					LDA $0201,y
					CLC
					ADC $03
					STA $0201,y
					CPX #$11
					BCC SUB_GFX3_2
					LDA $0200,y
					SEC
					SBC $02
					STA $0200,y
					BRA SUB_GFX3_1
SUB_GFX3_2			LDA $0200,y
					CLC
					ADC $02
					STA $0200,y

SUB_GFX3_1			PHX
					TXA
					CLC
					ADC $0F
					TAX
					LDA TILEMAP3,x           ; \ store tile
                    STA $0202,y             ; / 
					PLX

                    LDA PROPETIES3,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    INX                     ;  | go to next tile of frame and loop
					CPX #$18
                    BCC LOOP_START3          ; / 
					
					LDX #$04
					LDA $14
					LSR A
					AND #$03
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
LOOP_START3_2       PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC WING_HORZ,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC WING_VERT,x         ;  |
                    STA $0201,y             ; /
                    
					LDA WING_TILE,x           ; \ store tile
                    STA $0202,y             ; / 

                    LDA WING_PROP,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
					BPL LOOP_START3_2          ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$1C              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
					
TILEMAP4			dcb $00,$02,$20,$22,$40,$42,$60,$62,$04,$A2
					dcb $8A,$8A,$AA,$AA,$CA,$CA,$EA,$EA,$8C,$8C
					dcb $24,$26,$28,$44,$46,$64,$66,$06,$A2,$A2
VERT_DISP4			dcb $E8,$E8,$F8,$F8,$08,$08,$18,$18,$18,$00
					dcb $EC,$EC,$FC,$FC,$0C,$0C,$1C,$1C,$1C,$1C
					dcb $F0,$F0,$F0,$00,$00,$10,$10,$10,$00,$00
					
HORZ_DISP4			dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$00
					dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18
					dcb $F6,$06,$16,$F6,$06,$F6,$06,$16,$00,$00
					
					dcb $08,$F8,$08,$F8,$08,$F8,$08,$F8,$18,$00
					dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18
					dcb $0A,$FA,$EA,$0A,$FA,$0A,$FA,$EA,$00,$00
PROPETIES4			dcb $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
					dcb $0F,$4D,$0F,$4D,$0F,$4F,$0F,$4F,$0F,$4F
					dcb $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
					dcb $4D,$4D,$4D,$4D,$4F,$4F,$4F,$4F,$4F,$0F
					dcb $0F,$4D,$0F,$4D,$0F,$4F,$0F,$4F,$0F,$4F
					dcb $4F,$4D,$4D,$4F,$4D,$4F,$4F,$4F,$4F,$4F

BORN_TILE			dcb $0E,$0E,$0C,$0C,$AA,$A8,$CA,$C8,$E8,$AA,$A8,$CA,$C8,$E8,
BORN_HORZ			dcb $F0,$10,$EC,$14,$F2,$E2,$F2,$E2,$E2,$0E,$1E,$0E,$1E,$1E
BORN_VERT			dcb $0C,$0C,$04,$04,$F0,$F0,$00,$00,$10,$F0,$F0,$00,$00,$10
BORN_PROP			dcb $05,$45,$05,$45,$0E,$0E,$0E,$0E,$0E,$4E,$4E,$4E,$4E,$4E


SUB_GFX4            JSR DAMAGE_CHECK_1
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					STZ $02
					LDA $1602,x
					BEQ SUB_GFX4_0
					CMP #$02
					BEQ SUB_GFX4_1
					LDA #$0A
					STA $02
					BRA SUB_GFX4_0
SUB_GFX4_1			LDA #$14
					STA $02
SUB_GFX4_0			STZ $03
					LDA $157C,x
					BEQ SUB_GFX4_2
					LDA #$1E
					STA $03
SUB_GFX4_2			PHX                     ; push sprite index
                    LDX #$09              ; loop counter = (number of tiles per frame) - 1
LOOP_START4         PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP4,x         ;  |
                    STA $0201,y             ; /
					LDA TILEMAP4,x           ; \ store tile
                    STA $0202,y             ; / 

					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP4,x         ;  |
                    STA $0200,y             ; /
                    LDA PROPETIES4,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX
                    BPL LOOP_START4          ; / 
					
					LDX #$0D
LOOP_START4_2		LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_HORZ,x         ;  |
                    STA $0200,y
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_VERT,x         ;  |
                    STA $0201,y
					LDA BORN_TILE,x         ;  |
                    STA $0202,y
					LDA BORN_PROP,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
					BPL LOOP_START4_2          ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$17             ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
TILEMAP5			dcb $0E,$0E,$0C,$0C,$48,$4A,$4C,$4E,$6E,$2C,$2E,$68,$6A,$6C
HORZ_DISP5			dcb $18,$20,$28,$30,$F8,$08,$18,$28,$38,$18,$28,$F8,$08,$18
					dcb $E8,$E0,$D8,$D0,$08,$F8,$E8,$D8,$C8,$E8,$D8,$08,$F8,$E8
VERT_DISP5			dcb $04,$06,$08,$0A,$00,$00,$00,$00,$00,$F0,$F0,$10,$10,$10
PROPETIES5			dcb $45,$45,$45,$45,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
					dcb $05,$05,$05,$05,$4D,$4D,$4F,$4F,$4F,$4F,$4F,$4F,$4F,$4F


SUB_GFX5            JSR DAMAGE_CHECK_1
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					STZ $03
					LDA $157C,x
					BEQ SUB_GFX5_2
					LDA #$0E
					STA $03
SUB_GFX5_2			PHX                     ; push sprite index
                    LDX #$0D              ; loop counter = (number of tiles per frame) - 1
LOOP_START5         LDA $01
                    CLC                     ;  |
                    ADC VERT_DISP5,x         ;  |
                    STA $0201,y             ; /
					LDA TILEMAP5,x           ; \ store tile
                    STA $0202,y             ; /
					CPX #$04
					BCS SUB_GFX5_1
					LDA $14
					LSR A
					AND #$01
					BNE SUB_GFX5_1
					LDA $0201,y
					CLC
					ADC #$08
					STA $0201,y
SUB_GFX5_1			PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP5,x         ;  |
                    STA $0200,y             ; /
                    LDA PROPETIES5,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX
                    BPL LOOP_START5         ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0D             ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
TILEMAP6			dcb $6E,$4E,$A2,$6E,$4E,$A2,$8A,$8A,$AC,$AC,$CC,$CC,$EC,$EC,$8C,$8C
					dcb $6E,$4E,$4E,$6E,$4E,$4E,$8A,$8A,$AC,$AC,$CC,$CC,$EC,$EC,$8C,$8C
HORZ_DISP6			dcb $F0,$00,$10,$10,$00,$F0,$F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18
VERT_DISP6			dcb $08,$08,$08,$08,$08,$08,$F0,$F0,$00,$00,$10,$10,$20,$20,$20,$20
					dcb $04,$04,$08,$04,$04,$08,$F0,$F0,$00,$00,$10,$10,$20,$20,$20,$20
PROPETIES6			dcb $CF,$CF,$CF,$8F,$8F,$8F,$0F,$4D,$0F,$4D,$0F,$4F,$0F,$4F,$0F,$4F
					dcb $4F,$CF,$CF,$0F,$8F,$8F,$0F,$4D,$0F,$4D,$0F,$4F,$0F,$4F,$0F,$4F


SUB_GFX6			STZ $03
					LDA $1570,x
					STA $02
					CMP #$18
					BCC SUB_GFX6_1
					LDA #$10
					STA $03
SUB_GFX6_1
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					PHX                     ; push sprite index
                    LDX #$0F              ; loop counter = (number of tiles per frame) - 1
LOOP_START6         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP6,x         ;  |
                    STA $0200,y             ; /
					CPX #$06
					BCS SUB_GFX6_2
					CPX #$03
					BCS SUB_GFX6_3
					LDA $0200,y
					SEC
					SBC $02
					STA $0200,y
					BRA SUB_GFX6_2
SUB_GFX6_3			LDA $0200,y
					CLC
					ADC $02
					STA $0200,y
SUB_GFX6_2
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP6,x           ; \ store tile
                    STA $0202,y             ; /
					LDA $01
                    CLC                     ;  |
                    ADC VERT_DISP6,x         ;  |
                    STA $0201,y             ; /
                    LDA PROPETIES6,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX
                    BPL LOOP_START6         ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0F            ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
HORZ_DISP7			dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10
VERT_DISP7			dcb $F8,$F8,$F8,$08,$08,$08,$18,$18,$18
TILEMAP7			dcb $84,$86,$84,$A4,$A6,$A4,$82,$E8,$82
PROPETIES7			dcb $0F,$0F,$4F,$0F,$0F,$4F,$0F,$0F,$4F

SUB_GFX7            JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					PHX                     ; push sprite index
                    LDX #$08              ; loop counter = (number of tiles per frame) - 1
LOOP_START7         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP7,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP7,x         ;  |
                    STA $0201,y             ; /
                    
					LDA TILEMAP7,x           ; \ store tile
                    STA $0202,y             ; / 

                    LDA PROPETIES7,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START7          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$08              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
HORZ_DISPCT			dcb $F4,$04,$04
					dcb $F4,$04,$04
					dcb $0C,$FC,$FC
					dcb $0C,$FC,$FC
VERT_DISPCT			dcb $FC,$FC,$0C
					dcb $04,$04,$F4
					dcb $04,$04,$F4
					dcb $FC,$FC,$0C
TILEMAPCT			dcb $80,$82,$A2
PROPETIESCT			dcb $06,$06,$06
					dcb $86,$86,$86
					dcb $C6,$C6,$C6
					dcb $46,$46,$46
					
SUB_GFX_CT			LDA $1570,x
					LSR A
					LSR A
					AND #$03
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					JSR GET_DRAW_INFO
					PHX
                    LDX #$02
LOOP_STARTCT        LDA TILEMAPCT,x           ; \ store tile
                    STA $0302,y
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISPCT,x         ;  |
                    STA $0300,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISPCT,x         ;  |
                    STA $0301,y             ; /
                    
					             ; / 

                    LDA PROPETIESCT,x
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					PLX

                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_STARTCT          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS              
					
					
HORZ_DISP8			dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18,$EC,$E4,$D4,$BC,$B4,$CC,$BC
					dcb $14,$1C,$2C,$44,$4C,$34,$44
VERT_DISP8			dcb $10,$10,$00,$00,$F0,$F0,$E0,$E0,$E0,$E0,$F8,$00,$00,$00,$F8,$10,$10
					dcb $F8,$00,$00,$00,$F8,$10,$10
TILEMAP8			dcb $8A,$8A,$AC,$AC,$CC,$CC,$EC,$EC,$8C,$8C,$E6,$D5,$D3,$D1,$E0,$0A,$08
					dcb $E6,$D5,$D3,$D1,$E0,$0A,$08
PROPETIES8			dcb $8D,$CF,$8D,$CF,$8F,$CF,$8F,$CF,$8F,$CF,$8F,$8F,$8F,$8F,$8F,$8F,$8F
					dcb $CF,$CF,$CF,$CF,$CF,$CF,$CF
WING_TILE8			dcb $0C,$0E,$0E,$0C,$0E
					dcb $0E,$0C,$0E,$0E,$0C
					dcb $0C,$0E,$0E,$0E,$0E
					dcb $0C,$0E,$0E,$0E,$0C
WING_HORZ8			dcb $D8,$E8,$10,$30,$38
					dcb $D4,$D0,$24,$30,$40
					dcb $C4,$D4,$EC,$1C,$2C
					dcb $C8,$D6,$E8,$26,$44
WING_VERT8			dcb $F8,$E4,$F0,$E8,$F8
					dcb $EC,$F0,$FE,$FD,$F0
					dcb $F0,$FD,$EE,$E8,$FC
					dcb $00,$E4,$F4,$F8,$F4
WING_PROP8			dcb $85,$85,$C5,$C5,$C5
					dcb $85,$85,$C5,$C5,$C5
					dcb $85,$85,$85,$C5,$C5
					dcb $85,$85,$85,$C5,$C5

SUB_GFX8            JSR DAMAGE_CHECK_2
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					STZ $0F
					LDA $14
					AND #$07
					STA $02
					CMP #$05
					BCC SUB_GFX8_0
					LDA #$08
					SEC
					SBC $02
					STA $02
SUB_GFX8_0			LSR A
					STA $03
					PHX                     ; push sprite index
                    LDX #$00              ; loop counter = (number of tiles per frame) - 1
LOOP_START8         LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP8,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP8,x         ;  |
                    STA $0201,y             ; /
                    
					CPX #$0A
					BCC SUB_GFX8_1
					LDA $0201,y
					CLC
					ADC $03
					STA $0201,y
					CPX #$11
					BCC SUB_GFX8_2
					LDA $0200,y
					SEC
					SBC $02
					STA $0200,y
					BRA SUB_GFX8_1
SUB_GFX8_2			LDA $0200,y
					CLC
					ADC $02
					STA $0200,y

SUB_GFX8_1			PHX
					TXA
					CLC
					ADC $0F
					TAX
					LDA TILEMAP8,x           ; \ store tile
                    STA $0202,y             ; / 
					PLX

                    LDA PROPETIES8,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    INX                     ;  | go to next tile of frame and loop
					CPX #$18
                    BCC LOOP_START8          ; / 
					
					LDX #$04
					LDA $14
					LSR A
					AND #$03
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
LOOP_START8_2       PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC WING_HORZ8,x         ;  |
                    STA $0200,y             ; /
					
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC WING_VERT8,x         ;  |
                    STA $0201,y             ; /
                    
					LDA WING_TILE8,x           ; \ store tile
                    STA $0202,y             ; / 

                    LDA WING_PROP8,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
					BPL LOOP_START8_2          ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$1C              ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
TILEMAP9			dcb $8A,$8A,$AA,$AA,$CA,$CA,$EA,$EA,$8C,$8C
					dcb $24,$26,$28,$44,$46,$64,$66,$06,$A2,$A2
VERT_DISP9			dcb $14,$14,$04,$04,$F4,$F4,$E4,$E4,$E4,$E4
					dcb $10,$10,$10,$00,$00,$F0,$F0,$F0,$00,$00
					
HORZ_DISP9			dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18
					dcb $F6,$06,$16,$F6,$06,$F6,$06,$16,$00,$00
					dcb $F8,$08,$F8,$08,$F8,$08,$F8,$08,$E8,$18
					dcb $0A,$FA,$EA,$0A,$FA,$0A,$FA,$EA,$00,$00
PROPETIES9			dcb $8D,$CF,$8D,$CF,$8F,$CF,$8F,$CF,$8F,$CF
					dcb $8F,$8D,$8D,$8F,$8D,$8F,$8F,$8F,$8F,$8F
					dcb $8D,$CF,$8D,$CF,$8F,$CF,$8F,$CF,$8F,$CF
					dcb $CF,$CF,$CF,$CF,$CF,$CF,$CF,$CF,$CF,$CF

BORN_TILE9			dcb $0E,$0E,$0C,$0C,$AA,$A8,$CA,$C8,$E8,$AA,$A8,$CA,$C8,$E8,
BORN_HORZ9			dcb $F0,$10,$EC,$14,$F2,$E2,$F2,$E2,$E2,$0E,$1E,$0E,$1E,$1E
BORN_VERT9			dcb $F4,$04,$FC,$FC,$10,$10,$00,$00,$F0,$10,$10,$00,$00,$F0
BORN_PROP9			dcb $85,$C5,$85,$C5,$8E,$8E,$8E,$8E,$8E,$CE,$CE,$CE,$CE,$CE

SUB_GFX9            JSR DAMAGE_CHECK_2
					JSR GET_DRAW_INFO
					LDY #$70
					TYA
					STA $15EA,x
					STZ $02
					LDA $1602,x
					BEQ SUB_GFX9_0
					LDA #$0A
					STA $02
SUB_GFX9_0			STZ $03
					LDA $157C,x
					BEQ SUB_GFX9_2
					LDA #$14
					STA $03
SUB_GFX9_2			PHX                     ; push sprite index
                    LDX #$09              ; loop counter = (number of tiles per frame) - 1
LOOP_START9         PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP9,x         ;  |
                    STA $0201,y             ; /
					LDA TILEMAP9,x           ; \ store tile
                    STA $0202,y             ; / 

					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP9,x         ;  |
                    STA $0200,y             ; /
                    LDA PROPETIES9,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX
                    BPL LOOP_START9          ; / 
					
					LDX #$0D
LOOP_START9_2		LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_HORZ9,x         ;  |
                    STA $0200,y
					LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_VERT9,x         ;  |
                    STA $0201,y
					LDA BORN_TILE9,x         ;  |
                    STA $0202,y
					LDA BORN_PROP9,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
					BPL LOOP_START9_2          ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$17             ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
TILEMAPA			dcb $8A,$AC,$CC,$EC,$8C
VERT_DISPA			dcb $EC,$FC,$0C,$1C,$1C
HORZ_DISPA			dcb $F8,$F8,$F8,$F8,$E8
					dcb $08,$08,$08,$08,$18
PROPETIESA			dcb $0F,$0F,$0F,$0F,$0F
					dcb $4D,$4D,$4F,$4F,$4F

BORN_TILEA			dcb $0E,$0C,$AA,$A8,$CA,$C8,$E8
BORN_HORZA			dcb $F0,$EC,$F2,$E2,$F2,$E2,$E2
					dcb $10,$14,$0E,$1E,$0E,$1E,$1E
BORN_VERTA			dcb $0C,$04,$F0,$F0,$00,$00,$10
BORN_PROPA			dcb $05,$05,$0E,$0E,$0E,$0E,$0E
					dcb $45,$45,$4E,$4E,$4E,$4E,$4E


SUB_GFXA            JSR DAMAGE_CHECK_3
					JSR GET_DRAW_INFO
					LDY #$50
					STZ $02
					STZ $03
					LDA $1602,x
					BEQ SUB_GFXA_0
					LDA #$05
					STA $02
					LDA #$07
					STA $03
					LDY #$80
SUB_GFXA_0			TYA
					STA $15EA,x
					PHX
                    LDX #$04
LOOP_STARTA         LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISPA,x         ;  |
                    STA $0201,y             ; /
					LDA TILEMAPA,x           ; \ store tile
                    STA $0202,y             ; / 
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISPA,x         ;  |
                    STA $0200,y             ; /
                    LDA PROPETIESA,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y             ; / store tile properties
					PLX
					
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX
                    BPL LOOP_STARTA          ; / 
					
					LDX #$06
LOOP_STARTA_2		LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_VERTA,x         ;  |
                    STA $0201,y
					LDA BORN_TILEA,x         ;  |
                    STA $0202,y
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC BORN_HORZA,x         ;  |
                    STA $0200,y
					LDA BORN_PROPA,x
                    ORA $64                 ;  | put in level properties
                    STA $0203,y
					PLX
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
					BPL LOOP_STARTA_2          ; / 
					
                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0B             ;  | A = number of tiles drawn - 1
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS                     ; return
					
KIRBY_HORZ			dcb $F8,$08,$F8,$08
KIRBY_VERT			dcb $F0,$F0,$00,$00
KIRBY_TILE			dcb $40,$42,$60,$62
					dcb $44,$46,$64,$66
					dcb $4C,$4E,$6C,$6E
					dcb $48,$4A,$68,$6A
					dcb $A2,$A2,$42,$48
					dcb $0E,$0E,$A2,$A2
KIRBY_PROP			dcb $0B,$0B,$0B,$0B
					dcb $0B,$0B,$0B,$0B
					dcb $0B,$0B,$0B,$0B
					dcb $0B,$0B,$0B,$0B
					dcb $0B,$0B,$0A,$0A
					dcb $0A,$4A,$0B,$0B
SUB_GFX_KIRBY		LDA $1602,x
					ASL A
					ASL A
					STA $02
					JSR GET_DRAW_INFO
					LDY #$50
					TYA
					STA $15EA,x
					PHX
					LDX #$03
SUB_GFX_KIRBY_L		LDA $00
                    CLC                     ;  |
                    ADC KIRBY_HORZ,x         ;  |
                    STA $0200,y
					LDA $01
                    CLC                     ;  |
                    ADC KIRBY_VERT,x         ;  |
                    STA $0201,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA KIRBY_TILE,x
					STA $0202,y
					LDA KIRBY_PROP,x
					ORA $64
					STA $0203,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL SUB_GFX_KIRBY_L
					PLX
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS
					
GFX_KIRBY1_DEL		LDA $1602,x
					CMP #$02
					BNE GFX_KIRBY1_DEL_R
					LDA #$A2
					STA $0272
					STA $0276
					LDA #$0F
					STA $0273
					STA $0277
					LDA $157C,x
					BNE GFX_KIRBY1_DEL_1
					LDA #$A2
					STA $027E
					RTS
GFX_KIRBY1_DEL_1	LDA #$A2
					STA $027A
GFX_KIRBY1_DEL_R	RTS

KIRBY1_HORZ			dcb $E4,$F4,$1C,$0C,$F8,$08,$F8,$08,$F8,$08
					dcb $1C,$0C,$E4,$F4,$08,$F8,$08,$F8,$08,$F8
KIRBY1_VERT			dcb $F6,$F6,$F6,$F6,$F0,$F0,$00,$00,$E0,$E0
KIRBY1_TILE			dcb $EA,$2A,$EA,$2A,$C0,$C2,$E0,$E2,$A2,$A2
					dcb $EA,$2A,$EA,$2A,$C4,$C6,$E4,$E6,$EC,$EE
					dcb $EA,$2A,$EA,$2A,$C8,$CA,$E8,$EA,$CC,$CE
KIRBY1_PROP			dcb $0E,$0E,$4E,$4E,$0B,$0B,$0B,$0B,$0B,$0B
					dcb $4E,$4E,$0E,$0E,$4B,$4B,$4B,$4B,$4B,$4B
KIRBY_WING_T		dcb $0C,$0E
					dcb $0E,$0C
KIRBY_WING_H		dcb $EC,$14
					dcb $F4,$0C
KIRBY_WING_V		dcb $FC,$FC
					dcb $00,$00
KIRBY_WING_P		dcb $05,$45
					dcb $05,$45
SUB_GFX_KIRBY1		LDA $1602,x
					ASL A
					STA $02
					ASL A
					ASL A
					CLC
					ADC $02
					STA $02
					STZ $03
					LDA $157C,x
					BEQ SUB_GFX_KIRBY1_1
					LDA #$0A
					STA $03
SUB_GFX_KIRBY1_1	JSR GET_DRAW_INFO
					LDY #$50
					TYA
					STA $15EA,x
					PHX
					LDX #$09
SUB_GFX_KIRBY1_L	LDA $01
                    CLC                     ;  |
                    ADC KIRBY1_VERT,x         ;  |
                    STA $0201,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA KIRBY1_TILE,x
					STA $0202,y
					PLX
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA $00
                    CLC                     ;  |
                    ADC KIRBY1_HORZ,x         ;  |
                    STA $0200,y
					LDA KIRBY1_PROP,x
					ORA $64
					STA $0203,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL SUB_GFX_KIRBY1_L
					PLX
					LDA $14
					LSR A
					AND #$01
					ASL A
					STA $02
					PHX
					LDX #$01
KIRBY_WING_L		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC KIRBY_WING_H,x
					STA $0200,y
					LDA $01
					CLC
					ADC KIRBY_WING_V,x
					STA $0201,y
					LDA KIRBY_WING_T,x
					STA $0202,y
					LDA KIRBY_WING_P,x
					ORA $64
					STA $0203,y
					PLX
					INY
					INY
					INY
					INY
					DEX
					BPL KIRBY_WING_L
					PLX
					JSR GFX_KIRBY1_DEL
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$0B
                    JSL $28FCC0             ;# / $200p̃OtBbN[`
                    RTS
					
					
					

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
					
					
SUB_SMOKE           PHX
					TYX
					LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
					PLX
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
					PLX
                    RTS 
					
LAYER_INIT			LDA #$40
					STA $7FFB30
					LDA #$00
					STA $7FFB31
					LDA #$2C
					STA $7FFB32
					LDA #$00
					STA $7FFB33
					LDA #$E9
					STA $7FFB34
					LDA #$7F
					STA $7FFB35
					LDA #$20
					STA $7FE900
					LDA #$17
					STA $7FE901
					LDA #$01
					STA $7FE902
					LDA #$13
					STA $7FE903
					LDA #$00
					STA $7FE904
					RTS
					
HDMA_SCL			LDA #$08
					STA $7FFB18
					LDA #$02
					STA $7FFB19
					LDA #$0D
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$E8
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$80
					STA $7FE800
					LDA #$00
					STA $7FE801
					STA $7FE802
					LDA #$20
					STA $7FE803
					LDA #$00
					STA $7FE804
					STA $7FE805
					LDA #$06
					STA $7FE806
					LDA #$00
					STA $7FE807
					STA $7FE808
					LDA #$06
					STA $7FE809
					LDA #$00
					STA $7FE80A
					STA $7FE80B
					LDA #$0B
					STA $7FE80C
					LDA #$00
					STA $7FE80D
					STA $7FE80E
					LDA #$16
					STA $7FE80F
					LDA #$00
					STA $7FE810
					STA $7FE811
					LDA #$01
					STA $7FE812
					LDA #$00
					STA $7FE813
					STA $7FE814
					STA $7FE815
HDMA_SCL_R			RTS
					



LIFE_GAGE			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$5024
					STA $2116
					LDA.W #$2030
					STA $2118
					LDA.W #$5025
					STA $2116
					LDA.W #$2031
					STA $2118
					LDA.W #$5026
					STA $2116
					LDA.W #$2032
					STA $2118
					LDA.W #$5027
					STA $2116
					LDA.W #$2033
					STA $2118
					LDA.W #$5028
					STA $2116
					LDA.W #$2034
					STA $2118
					
					LDA.W #$502B
					STA $03
LIFE_GAGE_LP1		LDA $03
					STA $2116
					LDA.W #$2044
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$5037
					BCC LIFE_GAGE_LP1
					
					LDA.W #$5064
					STA $2116
					LDA.W #$2416
					STA $2118
					LDA.W #$5065
					STA $2116
					LDA.W #$240A
					STA $2118
					LDA.W #$5066
					STA $2116
					LDA.W #$241B
					STA $2118
					LDA.W #$5067
					STA $2116
					LDA.W #$2421
					STA $2118
					LDA.W #$506B
					STA $03
LIFE_GAGE_LP2		LDA $03
					STA $2116
					LDA.W #$2444
					STA $2118
					INC $03
					LDA.W $03
					CMP.W #$5077
					BCC LIFE_GAGE_LP2
					SEP #$20
					RTS
					
DAMAGE_ROUTINE1		LDA $14AF
					BNE RETURN003
					LDA $96
					CMP #$70
					BEQ DAMAGE_ROUTINE1_2
					LDA $7D
					BMI DAMAGE_ROUTINE2
					JSL $01A7DC
					BCC RETURN003
					JSL $01AA33             ; set mario speed
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					LDA #$01
					STA $14AF
					JSR MARX_CHECK
RETURN003			RTS
DAMAGE_ROUTINE1_2	JSR DAMAGE_ROUTINE2
					RTS

DAMAGE_ROUTINE2		JSL $01A7DC
					BCC RETURN002
					LDA $14AF
					BNE RETURN002
					LDA $1497               ; \ if mario is invincible...
                    BNE RETURN002             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURN002           RTS                     ; return


DAMAGE_CHECK_1		LDA $9D
					BNE DAMAGE_CHECK_1_R
					LDA $7FF0DD
					BNE DAMAGE_CHECK_1_R
					LDA $7FF0D9
					BEQ DAMAGE_CHECK_1_M
					CMP #$04
					BEQ DAMAGE_CHECK_1_M
DAMAGE_CHECK_1_R	RTS
DAMAGE_CHECK_1_M	LDA $14AF
					BNE DAMAGE_CHECK_1_R
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					JSR DAMAGE_ROUTINE1
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSR DAMAGE_ROUTINE1
					LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSR DAMAGE_ROUTINE2
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSR DAMAGE_ROUTINE2
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
DAMAGE_CHECK_2		LDA $9D
					BNE DAMAGE_CHECK_1_R
					LDA $14AF
					BNE DAMAGE_CHECK_1_R
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					SBC #$00
					STA $14D4,x
					JSR DAMAGE_ROUTINE1
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSR DAMAGE_ROUTINE1
					LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR DAMAGE_ROUTINE2
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSR DAMAGE_ROUTINE2
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
DAMAGE_CHECK_3		LDA $9D
					BNE DAMAGE_CHECK_3_R
					LDA $7FF0D9
					BEQ DAMAGE_CHECK_3_M
					CMP #$04
					BEQ DAMAGE_CHECK_3_M
DAMAGE_CHECK_3_R	RTS
DAMAGE_CHECK_3_M	LDA $14AF
					BNE DAMAGE_CHECK_3_R
					LDA $E4,x
					PHA
					SEC
					SBC #$08
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $157C,x
					BEQ DAMAGE_CHECK_3_2
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
DAMAGE_CHECK_3_2	JSR DAMAGE_ROUTINE1
					LDA $D8,x
					PHA
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSR DAMAGE_ROUTINE2
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
					
MARX_CHECK			LDA $7FF029
					INC A
					STA $7FF029
					CMP #$01
					BEQ MARX_CHECK_1
					CMP #$02
					BEQ MARX_CHECK_2
					CMP #$03
					BEQ MARX_CHECK_3
					CMP #$04
					BEQ MARX_CHECK_4
					CMP #$05
					BEQ MARX_CHECK_5
					BRA MARX_CHECK_BR
					RTS
MARX_CHECK_1		REP #$30
					LDA.W #$5076
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_2		REP #$30
					LDA.W #$5075
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_3		REP #$30
					LDA.W #$5074
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_4		REP #$30
					LDA.W #$5073
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					LDA #$01
					STA $7FF0D9
					RTS
MARX_CHECK_5		REP #$30
					LDA.W #$5072
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_BR		LDA $7FF029
					CMP #$06
					BEQ MARX_CHECK_6
					CMP #$07
					BEQ MARX_CHECK_7
					CMP #$08
					BEQ MARX_CHECK_8
					CMP #$09
					BEQ MARX_CHECK_9
					CMP #$0A
					BEQ MARX_CHECK_A
					CMP #$0B
					BEQ MARX_CHECK_B
					CMP #$0C
					BEQ MARX_CHECK_C
					RTS
MARX_CHECK_6		REP #$30
					LDA.W #$5071
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_7		REP #$30
					LDA.W #$5070
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_8		REP #$30
					LDA.W #$506F
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_9		REP #$30
					LDA.W #$506E
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_A		REP #$30
					LDA.W #$506D
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_B		REP #$30
					LDA.W #$506C
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARX_CHECK_C		REP #$30
					LDA.W #$506B
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					LDA #$01
					STA $7FF0DD
					LDA #$1E
					STA $1DFB
					RTS

MARIO_CHECK			LDA $19
					CMP #$02
					BEQ MARIO_CHECK_R
					LDA #$02
					STA $19
					LDA $7FF028
					CMP #$0C
					BEQ MARIO_CHECK_R
					INC A
					STA $7FF028
					CMP #$01
					BEQ MARIO_CHECK_1
					CMP #$02
					BEQ MARIO_CHECK_2
					CMP #$03
					BEQ MARIO_CHECK_3
					CMP #$04
					BEQ MARIO_CHECK_4
					CMP #$05
					BEQ MARIO_CHECK_5
					CMP #$06
					BEQ MARIO_CHECK_6
					BRA MARIO_CHECK_NEXT
MARIO_CHECK_R		RTS
MARIO_CHECK_1		REP #$30
					LDA.W #$5036
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_2		REP #$30
					LDA.W #$5035
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_3		REP #$30
					LDA.W #$5034
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_4		REP #$30
					LDA.W #$5033
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_5		REP #$30
					LDA.W #$5032
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_6		REP #$30
					LDA.W #$5031
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_NEXT
					LDA $7FF028
					CMP #$07
					BEQ MARIO_CHECK_7
					CMP #$08
					BEQ MARIO_CHECK_8
					CMP #$09
					BEQ MARIO_CHECK_9
					CMP #$0A
					BEQ MARIO_CHECK_A
					CMP #$0B
					BEQ MARIO_CHECK_B
					CMP #$0C
					BEQ MARIO_CHECK_C
					RTS
MARIO_CHECK_7		REP #$30
					LDA.W #$5030
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_8		REP #$30
					LDA.W #$502F
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_9		REP #$30
					LDA.W #$502E
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_A		REP #$30
					LDA.W #$502D
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_B		REP #$30
					LDA.W #$502C
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					RTS
MARIO_CHECK_C		REP #$30
					LDA.W #$502B
					STA $2116
					LDA.W #$20FC
					STA $2118
					SEP #$30
					JSL $00F606 ;#
					RTS

LAYER3_1_TABLE1		dcb $E0,$E1,$E2,$E3
					dcb $E4,$E5,$E6,$E7
					dcb $E8,$E9,$EA,$EB
					dcb $EC,$ED,$EE,$EF
LAYER3_1			LDA #$80
					STA $2115
					LDA #$50
					STA $04
					LDA #$A0
					STA $03
					LDA #$0D
					STA $02
LAYER3_1_LOOP		LDA $03
					AND #$03
					STA $01
					LDA $03
					AND #$60
					LSR A
					LSR A
					LSR A
					ORA $01
					TAY
LAYER3_1_LOOP1		LDA LAYER3_1_TABLE1,y
					STA $01
					REP #$20
					LDA $03
					STA $2116
					LDA $01
					STA $2118
LAYER3_1_LOOP3		INC $03
					LDA $03
					CMP.W #$6000
					SEP #$20
					BCC LAYER3_1_LOOP
					RTS
					
HDMA_LASER			LDA #$20
					STA $7FDF00
					STA $7FE100
					LDA #$00
					STA $7FDF01
					LDA #$FF
					STA $7FE101
					LDA #$30
					STA $7FDF02
					STA $7FE102
					LDA #$00
					STA $7FDF03
					STA $7FE103
					LDA #$78
					STA $7FDF04
					STA $7FE104
					LDA #$00
					STA $7FDF05
					STA $7FE105
					LDA #$01
					STA $7FDF06
					STA $7FE106
					LDA #$00
					STA $7FDF07
					STA $7FE107
					LDA #$01
					STA $7FDF08
					STA $7FE108
					LDA #$00
					STA $7FDF09
					STA $7FE109
					STA $7FDF0A
					STA $7FE10A
					RTS
					

HDMA_CIRCLE			LDA #$03
					STA $42
					LDA #$04
					STA $212E
					LDA #$10
					STA $7FFB20
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB21
					STA $7FFB29
					LDA #$26
					STA $7FFB22
					LDA #$27
					STA $7FFB2A
					LDA #$00
					STA $7FFB23
					STA $7FFB2B
					LDA #$DF
					STA $7FFB24
					LDA #$E1
					STA $7FFB2C
					LDA #$7F
					STA $7FFB25
					STA $7FFB2D
					LDA #$01
					STA $7FDF00
					STA $7FE100
					LDA #$00
					STA $7FDF01
					STA $7FE101
					STA $7FDF02
					STA $7FE102
					RTS
					
CIRCLE_GEN			LDA $7FDEFD;#SxW
					STA $02
					LDA $7FDEFE;#SyW
					STA $03
					STZ $04
					LDA $7FDEFF;#~̔a
					STA $0F
					PHX
					REP #$30
					LDA $03
					ASL A
					STA $00
					LDY.W #$0000
CIRCLE_LOOP0		SEP #$30
					STY $4202
					LDA #$70
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA $0F
					STA $4206
					LDX $4214
					LDA CIRCLE,x
					STA $4202
					LDA $0F
					STA $4203
					LDA $4216
					STA $4204
					LDA $4217
					STA $4205
					LDA #$70
					STA $4206
					LDA $4214
					CLC
					ADC $02
					BCC NOT_RIGHT_OVER
					LDA #$FF
NOT_RIGHT_OVER		STA $04
					REP #$10
					LDX $00
					LDA $02
					SEC
					SBC $4214
					BCS NOT_LEFT_OVER
					LDA #$00
					BRA NOT_LEFT_OVER
CIRCLE_LOOP			BRA CIRCLE_LOOP0
NOT_LEFT_OVER		STA $05
					CPX.W #$1000
					BCS UP_OVER
					LDA $05
					STA $7FDF01,x
					LDA $04
					STA $7FE101,x
					LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
UP_OVER
					REP #$30
					STY $00
					PHX
					TXA
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC $00
					CLC
					ADC.W #$0002
					TAX
					SEP #$20
					CPX.W #$01C0
					BCS DOWN_OVER
					LDA $04
					STA $7FE101,x
					LDA $05
					STA $7FDF01,x
					LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					;LDA #$01 ;#\߉~ǂł
					;STA $7FDF02,x
					;STA $7FE102,x
					;LDA #$00
					;STA $7FDF03,x
					;STA $7FE103,x
					;STA $7FDF04,x
					;STA $7FE104,x
DOWN_OVER			PLX
					DEX
					DEX
					STX $00
					INY
					INC $14AF
					SEP #$30
					CPY $0F
					BCC CIRCLE_LOOP
					  ;#~㕔ǂ
					LDA $7FDEFE;#SyW
					INC A
					SEC
					SBC $7FDEFF;#~̔a
					BEQ CIRCLE_GEN4
					BCC CIRCLE_GEN4
					DEC A
					STA $03
					STZ $04
					REP #$30
					LDA $03
					ASL A
					TAX
					SEP #$20
CIRCLE_LOOP2		LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					LDA #$00
					STA $7FDF01,x
					STA $7FE101,x
					CPX.W #$0000
					BEQ CIRCLE_GEN4
					DEX
					DEX
					BRA CIRCLE_LOOP2
CIRCLE_GEN4			SEP #$30
					;#~ǂ
					LDA $7FDEFE;#SyW
					INC A
					CLC
					ADC $7FDEFF;#~̔a
					CMP #$E0
					BCC CIRCLE_GEN5
					REP #$10
					LDX.W #$01C0
					BRA CIRCLE_GEN6
					
CIRCLE_GEN5			STA $03
					STZ $04
					REP #$30
					LDA $03
					ASL A
					TAX
					SEP #$20
CIRCLE_GEN6			LDA #$01
					STA $7FDF00,x
					STA $7FE100,x
					LDA #$00
					STA $7FDF01,x
					STA $7FE101,x
					STA $7FDF02,x
					STA $7FE102,x
					SEP #$30
					
					LDX #$00
CIRCLE_LOOP3		LDA #$00
					STA $7FDF01,x
					LDA #$FF
					STA $7FE101,x
					INX
					INX
					CPX #$40
					BNE CIRCLE_LOOP3
					PLX
					RTS
					

VRAM1				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$EAF0 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$0D
					STA $2122
					LDA #$00
					STA $2122
					LDA #$0E
					STA $2121
					LDA #$3F
					STA $2122
					LDA #$01
					STA $2122
					LDA #$0F
					STA $2121
					LDA #$3F
					STA $2122
					LDA #$03
					STA $2122
					RTS
VRAM2				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$EBF0 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$7C
					STA $2122
					LDA #$0E
					STA $2121
					LDA #$D3
					STA $2122
					LDA #$7F
					STA $2122
					LDA #$0F
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					RTS
VRAM3				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$ECF0 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$0E
					STA $2121
					LDA #$15
					STA $2122
					LDA #$02
					STA $2122
					LDA #$0F
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$1F
					STA $2122
					RTS
					
VRAM4				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$EDF0 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$0E
					STA $2121
					LDA #$06
					STA $2122
					LDA #$41
					STA $2122
					LDA #$0F
					STA $2121
					LDA #$9A
					STA $2122
					LDA #$7F
					STA $2122
					RTS
					
VRAM5				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$F050 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$0E
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					RTS
VRAM6				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$4F00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$27
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$F150 ;#Source address
					STA $4312
					LDA.W #$0100
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$0D
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					RTS
					
KIRBY_RAM1			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$7400
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$AD00 ;#Source address
					STA $4312
					LDA.W #$0800
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					LDA #$D1
					STA $2121
					LDA #$C6
					STA $2122
					LDA #$18
					STA $2122
					LDA #$D2
					STA $2121
					LDA #$E0
					STA $2122
					LDA #$3C
					STA $2122
					LDA #$D3
					STA $2121
					LDA #$0E
					STA $2122
					LDA #$2C
					STA $2122
					LDA #$D4
					STA $2121
					LDA #$18
					STA $2122
					LDA #$00
					STA $2122
					LDA #$D5
					STA $2121
					LDA #$18
					STA $2122
					LDA #$20
					STA $2122
					LDA #$D6
					STA $2121
					LDA #$8E
					STA $2122
					LDA #$7C
					STA $2122
					LDA #$D7
					STA $2121
					LDA #$00
					STA $2122
					LDA #$00
					STA $2122
					LDA #$D8
					STA $2121
					LDA #$58
					STA $2122
					LDA #$58
					STA $2122
					LDA #$D9
					STA $2121
					LDA #$5F
					STA $2122
					LDA #$10
					STA $2122
					LDA #$DA
					STA $2121
					LDA #$60
					STA $2122
					LDA #$66
					STA $2122
					LDA #$DB
					STA $2121
					LDA #$1C
					STA $2122
					LDA #$69
					STA $2122
					LDA #$DC
					STA $2121
					LDA #$DE
					STA $2122
					LDA #$71
					STA $2122
					LDA #$DD
					STA $2121
					LDA #$94
					STA $2122
					LDA #$76
					STA $2122
					LDA #$DE
					STA $2121
					LDA #$9F
					STA $2122
					LDA #$76
					STA $2122
					LDA #$DF
					STA $2121
					LDA #$FF
					STA $2122
					LDA #$7F
					STA $2122
					RTS
KIRBY_RAM2			LDA #$80
					STA $2115
					REP #$20
					LDA.W #$7C00
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$B500 ;#Source address
					STA $4312
					LDA.W #$0800
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					RTS
