;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; test
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $1528,x
					STZ $1602,x
					STZ $1504,x
					LDA #$40
					STA $15AC,x
					STZ $1540,x
					STZ $C2,x
					LDA $1420
					ORA #$02
					STA $1420
                    RTL
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INTERVAL			dcb $10,$20,$20,$10,$20,$30,$20
COLOR				dcb $03,$03,$03,$09,$03,$0C,$06
SOUND				dcb $15,$15,$15,$13,$15,$17,$14
;ΐ
CHECK				dcb $29,$2A
INTERVAL2			dcb $24,$24,$24,$18,$18,$10,$18
COLOR2				dcb $0C,$09,$06,$09,$03,$03,$09
SOUND2				dcb $18,$15,$13,$16,$17,$17,$16
INTERVAL3			dcb $18,$18,$18,$18,$0C,$18,$18,$0C,$0C,$24
COLOR3				dcb $06,$09,$03,$0C,$03,$0C,$09,$06,$09,$06
SOUND3				dcb $13,$16,$18,$19,$17,$18,$16,$14,$15,$13

START_HB_CODE       LDA $C2,x
					AND #$01
					BEQ NO_GRA
					JSR SUB_GFX
NO_GRA				LDA #$FF
					STA $18BD
					LDA $1602,x
					STA $7FC004
					LDA $1540,x
					BNE MAIN2
					STZ $1602,x
MAIN2				LDA $C2,x
					BEQ LEVEL1
					CMP #$01
					BEQ LEVEL1_A
					CMP #$02
					BEQ LEVEL2
					CMP #$03
					BEQ LEVEL2_A
					CMP #$04
					BEQ LEVEL3
					CMP #$05
					BEQ LEVEL3_A
					RTS
LEVEL1				JSR SUB_LEVEL1
					RTS
LEVEL1_A			JSR SUB_LEVEL1_A
					RTS
LEVEL2				JSR SUB_LEVEL2
					RTS
LEVEL2_A			JSR SUB_LEVEL2_A
					RTS
LEVEL3				JSR SUB_LEVEL3
					RTS
LEVEL3_A			JSR SUB_LEVEL3_A
					RTS
SUB_LEVEL1			LDA $15AC,x
					BNE LEVEL1_R
					LDA $1504,x
					CMP #$07
					BCS LEVEL1_R2
					LDA $1504,x
					TAY
					LDA COLOR,y
					STA $1602,x
					LDA INTERVAL,y
					STA $15AC,x
					LDA SOUND,y
					STA $1DF9
					LDA #$08
					STA $1540,x
					INC $1504,x
LEVEL1_R			RTS
LEVEL1_R2			STZ $1602,x
					LDA #$10
					STA $15AC,x
					LDA #$01
					STA $C2,x
					STZ $1504,x
					STZ $151C,x
					RTS

SUB_LEVEL1_A		LDA $1504,x
					CMP #$07
					BCS LEVEL1_CHECK
					TAY
					LDA COLOR,y
					STA $03
					LDA $18
					AND #$80
					BNE LEVEL1_A_A
					LDA $16
					AND #$C0
					BEQ LEVEL1_A_R
					INC $1504,x
					LDA #$08
					STA $1540,x
					LDA $16
					AND #$80
					BNE LEVEL1_A_B
					LDA $18
					AND #$40
					BNE LEVEL1_A_X
					LDA #$13
					STA $1DF9
					LDA #$09
					STA $1602,x
					CMP $03
					BEQ LEVEL1_A_R
					LDA #$01
					STA $151C,x
LEVEL1_A_R			RTS
LEVEL1_A_X			LDA #$15
					STA $1DF9
					LDA #$03
					STA $1602,x
					CMP $03
					BEQ LEVEL1_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL1_A_B			LDA #$14
					STA $1DF9
					LDA #$06
					STA $1602,x
					CMP $03
					BEQ LEVEL1_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL1_A_A			INC $1504,x
					LDA #$17
					STA $1DF9
					LDA #$08
					STA $1540,x
					LDA #$0C
					STA $1602,x
					CMP $03
					BEQ LEVEL1_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL1_CHECK		LDA $15AC,x
					BEQ LEVEL1_C
					CMP #$30
					BEQ LEVEL1_CHECK_2
					CMP #$01
					BEQ LEVEL1_CHECK_3
					RTS
LEVEL1_C			LDA #$60
					STA $15AC,x
					RTS
LEVEL1_CHECK_2		LDA $151C,x
					TAY
					LDA CHECK,y
					STA $1DFC
					RTS
LEVEL1_CHECK_3		STZ $1504,x
					STZ $1602,x
					STZ $C2,x
					LDA $151C,x
					BNE LEVEL1_C_R
					LDA #$02
					STA $C2,x
LEVEL1_C_R			RTS
					
SUB_LEVEL2			LDA $15AC,x
					BNE LEVEL2_R
					LDA $1504,x
					CMP #$07
					BCS LEVEL2_R2
					LDA $1504,x
					TAY
					LDA COLOR2,y
					STA $1602,x
					LDA INTERVAL2,y
					STA $15AC,x
					LDA SOUND2,y
					STA $1DF9
					LDA #$08
					STA $1540,x
					INC $1504,x
LEVEL2_R			RTS
LEVEL2_R2			STZ $1602,x
					LDA #$10
					STA $15AC,x
					LDA #$03
					STA $C2,x
					STZ $1504,x
					STZ $151C,x
					RTS
					
SUB_LEVEL2_A		LDA $1504,x
					CMP #$07
					BCS LEVEL2_CHECK0
					TAY
					LDA COLOR2,y
					STA $03
					LDA $18
					AND #$80
					BNE LEVEL2_A_A
					LDA $16
					AND #$C0
					BEQ LEVEL2_A_R
					INC $1504,x
					LDA #$08
					STA $1540,x
					LDA $16
					AND #$80
					BNE LEVEL2_A_B
					LDA $18
					AND #$40
					BNE LEVEL2_A_X
					LDA $1504,x
					CMP #$03
					BCS LEVEL2_A_Y_2
					LDA #$15
					STA $1DF9
					BRA LEVEL2_A_Y_3
LEVEL2_A_Y_2		LDA #$16
					STA $1DF9
LEVEL2_A_Y_3		LDA #$09
					STA $1602,x
					CMP $03
					BEQ LEVEL2_A_R
					LDA #$01
					STA $151C,x
LEVEL2_A_R			RTS
LEVEL2_CHECK0		BRA LEVEL2_CHECK
LEVEL2_A_X			LDA #$17
					STA $1DF9
					LDA #$03
					STA $1602,x
					CMP $03
					BEQ LEVEL2_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL2_A_B			LDA $1504,x
					CMP #$08
					BEQ LEVEL2_A_B_2
					LDA #$13
					STA $1DF9
					BRA LEVEL2_A_B_3
LEVEL2_A_B_2		LDA #$14
					STA $1DF9
LEVEL2_A_B_3		
					LDA #$06
					STA $1602,x
					CMP $03
					BEQ LEVEL2_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL2_A_A			INC $1504,x
					LDA #$18
					STA $1DF9
					LDA #$08
					STA $1540,x
					LDA #$0C
					STA $1602,x
					CMP $03
					BEQ LEVEL2_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL2_CHECK		LDA $15AC,x
					BEQ LEVEL2_C
					CMP #$30
					BEQ LEVEL2_CHECK_2
					CMP #$01
					BEQ LEVEL2_CHECK_3
					RTS
LEVEL2_C			LDA #$60
					STA $15AC,x
					RTS
LEVEL2_CHECK_2		LDA $151C,x
					TAY
					LDA CHECK,y
					STA $1DFC
					RTS
LEVEL2_CHECK_3		STZ $1504,x
					STZ $1602,x
					LDA #$02
					STA $C2,x
					LDA $151C,x
					BNE LEVEL2_C_R
					LDA #$04
					STA $C2,x
LEVEL2_C_R			RTS

SUB_LEVEL3			LDA $15AC,x
					BNE LEVEL3_R
					LDA $1504,x
					CMP #$0A
					BCS LEVEL3_R2
					LDA $1504,x
					TAY
					LDA COLOR3,y
					STA $1602,x
					LDA INTERVAL3,y
					STA $15AC,x
					LDA SOUND3,y
					STA $1DF9
					LDA #$08
					STA $1540,x
					INC $1504,x
LEVEL3_R			RTS
LEVEL3_R2			STZ $1602,x
					LDA #$10
					STA $15AC,x
					LDA #$05
					STA $C2,x
					STZ $1504,x
					STZ $151C,x
					RTS
SUB_LEVEL3_A		LDA $1504,x
					CMP #$0A
					BCS LEVEL3_CHECK0
					TAY
					LDA COLOR3,y
					STA $03
					LDA $18
					AND #$80
					BNE LEVEL3_A_A
					LDA $16
					AND #$C0
					BEQ LEVEL3_A_R
					INC $1504,x
					LDA #$08
					STA $1540,x
					LDA $16
					AND #$80
					BNE LEVEL3_A_B
					LDA $18
					AND #$40
					BNE LEVEL3_A_X
					LDA $1504,x
					CMP #$08
					BCS LEVEL3_A_Y_2
					LDA #$16
					STA $1DF9
					BRA LEVEL3_A_Y_3
LEVEL3_A_Y_2		LDA #$15
					STA $1DF9
LEVEL3_A_Y_3		LDA #$09
					STA $1602,x
					CMP $03
					BEQ LEVEL3_A_R
					LDA #$01
					STA $151C,x
LEVEL3_A_R			RTS
LEVEL3_CHECK0		BRA LEVEL3_CHECK
LEVEL3_A_X			LDA $1504,x
					CMP #$04
					BCS LEVEL3_A_X_2
					LDA #$18
					STA $1DF9
					BRA LEVEL3_A_X_3
LEVEL3_A_X_2		LDA #$17
					STA $1DF9
LEVEL3_A_X_3
					LDA #$03
					STA $1602,x
					CMP $03
					BEQ LEVEL3_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL3_A_B			LDA #$13
					STA $1DF9
					LDA #$06
					STA $1602,x
					CMP $03
					BEQ LEVEL3_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL3_A_A			INC $1504,x
					LDA $1504,x
					CMP #$05
					BCS LEVEL3_A_A_2
					LDA #$19
					STA $1DF9
					BRA LEVEL3_A_A_3
LEVEL3_A_A_2		LDA #$18
					STA $1DF9
LEVEL3_A_A_3
					LDA #$18
					STA $1DF9
					LDA #$08
					STA $1540,x
					LDA #$0C
					STA $1602,x
					CMP $03
					BEQ LEVEL3_A_R
					LDA #$01
					STA $151C,x
					RTS
LEVEL3_CHECK		LDA $15AC,x
					BEQ LEVEL3_C
					CMP #$30
					BEQ LEVEL3_CHECK_2
					CMP #$01
					BEQ LEVEL3_CHECK_3
					RTS
LEVEL3_C			LDA #$60
					STA $15AC,x
					RTS
LEVEL3_CHECK_2		LDA $151C,x
					TAY
					LDA CHECK,y
					STA $1DFC
					RTS
LEVEL3_CHECK_3		STZ $1504,x
					STZ $1602,x
					LDA #$04
					STA $C2,x
					LDA $151C,x
					BNE LEVEL3_C_R
					PHP
					SEP #$30
					LDA #$06
					STA $71
					STZ $89
					STZ $88
					PLP
					STZ $14C8,x
LEVEL3_C_R			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $80,$82,$84,$86,$A0,$A2,$A4,$A6,$C0,$C2,$C4,$C6
HORZ_DISP           dcb $00,$10,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30
VERT_DISP           dcb $00,$00,$00,$00,$10,$10,$10,$10,$20,$20,$20,$20

SUB_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
					PHX                     ; push sprite index
                    LDX #$0B                ; loop counter = (number of tiles per frame) - 1
LOOP_START          PHX                     ; push current tile number
                    
                    
                    LDA $00                 ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC HORZ_DISP,x         ;  |
                    STA $0300,y             ; /   set y position of the tile
					
					LDA $01                ; \ tile y position = sprite y location ($01) + tile displacement
                    CLC                     ;  |
                    ADC VERT_DISP,x         ;  |
                    STA $0301,y             ; /   set y position of the tile
                    
					LDA TILEMAP,x           ; \ store tile
                    STA $0302,y            ; / 
					
					LDA #$0F
                    STA $0303,y             ; / store tile properties
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA #$0B                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

