;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; #
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$04
					STA $1528,x
					LDA #$00
					STA $7FC202
					LDA #$0F
					STA $7FEEEF
					STA $7FC201
					LDA #$01
					STA $157C,x
					LDA #$80
					STA $002126
					LDA #$7F
					STA $002127
					JSR LAYER3_DEL
					JSR HDMA_COLOR
					JSR HDMA_LASER
					JSR GAGE_RESET
					LDA $E4,x
					CMP #$00
					BEQ INIT_1
					CMP #$10
					BEQ INIT_2
					CMP #$20
					BEQ INIT_3
					CMP #$30
					BEQ INIT_4
					CMP #$40
					BEQ INIT_5
					CMP #$50
					BEQ INIT_0
					RTL
INIT_5				TXA
					STA $7FDD03
INIT_E              RTL
INIT_0				LDA #$54
					STA $E4,x
					LDA #$64
					STA $D8,x
					STZ $1570,x
					TXA
					STA $7FDD14
					RTL
INIT_1				LDA #$60
					STA $E4,x
					LDA #$20
					STA $D8,x
					STZ $157C,x
					LDA #$20
					STA $1570,x
					LDA #$00
					STA $1504,x
					TXA
					STA $7FDD10
					RTL
INIT_2				LDA #$68
					STA $E4,x
					LDA #$30
					STA $D8,x
					STZ $157C,x
					LDA #$18
					STA $1570,x
					LDA #$01
					STA $1504,x
					TXA
					STA $7FDD11
					RTL
INIT_3				LDA #$70
					STA $E4,x
					LDA #$40
					STA $D8,x
					LDA #$10
					STA $1570,x
					LDA #$02
					STA $1504,x
					TXA
					STA $7FDD12
					RTL
INIT_4				LDA #$64
					STA $E4,x
					LDA #$50
					STA $D8,x
					TXA
					STA $7FDD02
					LDA #$08
					STA $1570,x
					LDA #$03
					STA $1504,x
					TXA
					STA $7FDD13
INIT_E              RTL



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					
THUNDER_MAIN2		STZ $AA,x
					JSL $01802A
					JSL $01A7DC
					LDY #$00
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					SEC
					SBC #$30
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					RTS
THUNDER_MAIN2A		BRA THUNDER_MAIN2
STONE_MAIN			JSR S_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURNS
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURNS
					LDA $14E0,x
					CMP #$FF
					BEQ STONE_DEL
					LDA #$80
					STA $B6,x
					STZ $AA,x
					JSL $01802A
					RTS
STONE_DEL			STZ $14C8,x
RETURNS				RTS
THUNDER_MAIND		BRA THUNDER_MAIN
THUNDER_MAIN		JSR T_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN5
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN5
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1602,x
					BNE THUNDER_MAIN2A
					LDA #$60
					STA $AA,x
					STZ $B6,x
					JSL $01802A
					LDA $14D4,x
					BEQ THUNDER_MAIN1
					LDA $D8,x
					CMP #$60
					BCC THUNDER_MAIN1
					JSR TILE_CHANGE
					LDA #$04
					STA $1602,x
					LDA #$30
					STA $B6,x
					JSR GEN_SPRITE
					LDA #$00
					STA $1662,y
					STA $1686,y
					LDA #$04
					STA $1602,y
					LDA #$0B
					STA $167A,y
					LDA #$40
					STA $00C2,y
					LDA #$D0
					STA $00B6,y
RETURN5				RTS
STONE_MAINC			BRA STONE_MAIN
THUNDER_MAINC		BRA THUNDER_MAIND
THUNDER_MAIN1		JSL $01A7DC
					LDY #$00
THUNDER_LOOP		LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					PHY
					JSL $01A7DC
					PLY
					INY
					CPY #$03
					BNE THUNDER_LOOP
					LDA $D8,x
					CLC
					ADC #$30
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					RTS
STONE_MAINB			BRA STONE_MAINC
THUNDER_MAINB		BRA THUNDER_MAINC
NECK_MAIN			LDA $C2,x
					CMP #$10
					BEQ RETURN7
					JSR SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN7
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN7
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN7
					LDA $151C,x
					STA $AA,x
                    JSL $01802A
					LDA $7FDD00
					BEQ NECK_0
					LDA $C2,x
					BNE N_NOT_MODE0
					JSR N_MODE0
RETURN7				RTS
N_NOT_MODE0			;JSR N_MODE1
					RTS
RETURN4				RTS
					RTS
NECK_0				LDA #$10
					STA $AA,x
					JSL $01802A
					JSR IMG_CHECK
					RTS
					
ICE_MAIN			JSR I_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA #$D0
					STA $B6,x
					LDA #$30
					STA $AA,x
					JSL $01802A
					JSL $01A7DC
					RTS
NECK_MAIN0			BRA NECK_MAIN
STONE_MAINA			BRA STONE_MAINB
THUNDER_MAINA		BRA THUNDER_MAINB
ICE_MAIN00			BRA ICE_MAIN
FIRE_MAIN			JSR F_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					STZ $B6,x
					LDA #$20
					STA $AA,x
					JSL $01802A
					JSL $01A7DC
					LDA #$50
					STA $E4,x
					JSL $01A7DC
					LDA #$28
					STA $E4,x
					JSL $01A7DC
					LDA #$A0
					STA $E4,x
					JSL $01A7DC
					LDA #$C8
					STA $E4,x
					JSL $01A7DC
					LDA #$78
					STA $E4,x
					RTS

RETURN              RTS
CODE_START          LDA EXTRA_BITS,x
					AND #$04
					BNE NECK_MAIN0
					LDA $C2,x
					CMP #$50
					BEQ STONE_MAINA
					CMP #$40
					BEQ THUNDER_MAINA
					CMP #$30
					BEQ FIRE_MAIN
					CMP #$20
					BEQ ICE_MAIN00
					JSR D_SUB_GFX
					LDA $14C8,x             ; \ 
					BEQ RETURN
                    CMP #$02                ;  | if status != 8, return
                    BEQ RETURN
					LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN
					STZ $149F
					LDA $C2,x
					CMP #$0B
					BCS TEST1
					JSR POS_DEF
TEST1				LDA #$03
					STA $0F31
					LDA $7FEEEF
					STA $7FC004
					LDA $16
					ORA $18
					BEQ NO_DATA
					INC $1504,x
					LDA $1504,x
					STA $7FEEEE
NO_DATA				LDA $151C,x
					STA $AA,x
                    JSL $01802A
					LDA $C2,x
					CMP #$0B
					BCS MAIN_END
					LDA #$16
					STA $00212C
					LDA #$01
					STA $00212D
MAIN_END			LDA $C2,x
					CMP #$0B
					BCS MAIN_END2
					JSR IMG_CHECK2
MAIN_END2			LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					JSR MARIO_CHECK
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					JSR MARIO_CHECK
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					JSR MARIO_CHECK
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					JSR MARIO_CHECK
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					JSR MARIO_CHECK
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					JSR MARIO_CHECK
					RTS
NOT_MODE5			CMP #$06
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$07
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			CMP #$08
					BNE NOT_MODE8
					JSR MODE8
					RTS
NOT_MODE8			CMP #$09
					BNE NOT_MODE9
					JSR MODE9
					RTS
NOT_MODE9			CMP #$0A
					BNE NOT_MODEA
					JSR MODEA
					RTS
NOT_MODEA			JSR MODEB
RETURN4				RTS
					


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Action
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE0				DEC $1468
					LDA #$10
					STA $AA,x
					JSL $01802A
					LDA $1468
					CMP #$20
					BNE MODE0_R
					LDA #$01
					STA $C2,x
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					LDA #$01
					STA $7FDD00
					PHX
					LDA $7FDD03
					TAX
					LDA #$10
					STA $C2,x
					PLX
					LDA #$19
					STA $1DFB
					LDA #$80
					STA $15AC,x
MODE0_R				RTS

MODE1				LDA $15AC,x
					CMP #$40
					BNE MODE1_1
					LDA $1504,x
					CLC
					ADC $13
					CLC
					ADC $94
					AND #$01
					BEQ MODE1_0
					JSR MOVE0
					RTS
MODE1_0				JSR ATTACK0
					RTS

MODE1_1				INC $1570,x
					LDA $14
					AND #$03
					BNE MODE1_3
					LDA $1570,x
					AND #$20
					BEQ MODE1_2
					LDA $D8,x
					CLC
					ADC #$01
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					BRA MODE1_3
MODE1_2				LDA $D8,x
					SEC
					SBC #$01
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
MODE1_3				LDA $14
					AND #$07
					BNE MODE1_R
					LDA $1570,x
					AND #$20
					BEQ MODE1_4
					LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					RTS
MODE1_4				LDA $E4,x
					SEC
					SBC #$01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
MODE1_R				RTS
					
MODE2				LDA $15AC,x
					BEQ MODE2_2
					LDA #$18
					STA $B6,x
					PHX
					LDA $7FDD10
					TAX
					LDA #$04
					STA $B6,x
					LDA $7FDD11
					TAX
					LDA #$04
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$06
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$0E
					STA $B6,x
					PLX
					RTS
MODE2_2				PHX
					STZ $B6,x
					LDA $7FDD10
					TAX
					STZ $B6,x
					LDA $7FDD11
					TAX
					STZ $B6,x
					LDA $7FDD12
					TAX
					STZ $B6,x
					LDA $7FDD13
					TAX
					STZ $B6,x
					PLX
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FFD05
					LDA #$7E
					STA $15AC,x
					RTS
MODE3				LDA $15AC,x
					BEQ MODE3_2
					LDA #$E8
					STA $B6,x
					PHX
					LDA $7FDD10
					TAX
					LDA #$FC
					STA $B6,x
					LDA $7FDD11
					TAX
					LDA #$FC
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$FA
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$F2
					STA $B6,x
					PLX
					RTS
MODE3_2				JSR POS_STA
					PHX
					STZ $B6,x
					LDA $7FDD10
					TAX
					STZ $B6,x
					LDA $7FDD11
					TAX
					STZ $B6,x
					LDA $7FDD12
					TAX
					STZ $B6,x
					LDA $7FDD13
					TAX
					STZ $B6,x
					PLX
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FFD05
					LDA #$7E
					STA $15AC,x
					RTS

MODE4				STZ $151C,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$D0
					BCS MODE4_2
					CMP #$A8
					BCS MODE4_3_0
					CMP #$68
					BCS MODE4_2
					STZ $B6,x
					STZ $151C,x
					LDA #$01
					STA $C2,x
					JSR HDMA_COLOR
					LDA #$00
					STA $7FDD80
					LDA #$A2
					STA $15AC,x
					LDA #$00
					STA $7FFD05
					JSR POS_STA
					PHX
					LDA $7FDD10
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD11
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD12
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD13
					TAX
					STZ $B6,x
					STZ $151C,x
					PLX
					JSR END_CHECK
					RTS
MODE4_3_0			BRA MODE4_3
MODE4_2				LDA $1594,x
					LSR A
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $B6,x
					LDA #$E8
					STA $151C,x
					
					PHX
					LDA $7FDD10
					TAX
					LDA #$00
					STA $151C,x
					STZ $B6,x
					LDA $7FDD11
					TAX
					LDA #$FA
					STA $151C,x
					LDA $0F
					LSR A
					LSR A
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$F4
					STA $151C,x
					LDA $0F
					LSR A
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$EE
					STA $151C,x
					LDA $0F
					LSR A
					STA $0F
					LSR A
					CLC
					ADC $0F
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					PLX
					RTS
MODE4_3				LDA #$30
					STA $151C,x
					LDA $1594,x
					STA $B6,x
					STA $0F
					
					PHX
					LDA $7FDD10
					TAX
					LDA #$00
					STA $151C,x
					STZ $B6,x
					LDA $7FDD11
					TAX
					LDA #$0C
					STA $151C,x
					LDA $0F
					LSR A
					LSR A
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$18
					STA $151C,x
					LDA $0F
					LSR A
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$24
					STA $151C,x
					LDA $0F
					LSR A
					STA $0F
					LSR A
					CLC
					ADC $0F
					STA $B6,x
					PLX
					LDA $15AC,x
					CMP #$A8
					BNE MODE4_R
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					RTS
MODE4_R				RTS

MODE5				STZ $151C,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$D0
					BCS MODE5_2
					CMP #$A8
					BCS MODE5_3_0
					CMP #$68
					BCS MODE5_2
					STZ $B6,x
					STZ $151C,x
					LDA #$01
					STA $C2,x
					JSR HDMA_COLOR
					LDA #$00
					STA $7FDD80
					LDA #$A7
					STA $15AC,x
					LDA #$00
					STA $7FFD05
					JSR POS_STA
					PHX
					LDA $7FDD10
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD11
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD12
					TAX
					STZ $B6,x
					STZ $151C,x
					LDA $7FDD13
					TAX
					STZ $B6,x
					STZ $151C,x
					PLX
					JSR END_CHECK
					RTS
MODE5_3_0			BRA MODE5_3
MODE5_2				LDA $1594,x
					LSR A
					STA $0F
					STA $B6,x
					LDA #$E8
					STA $151C,x
					
					PHX
					LDA $7FDD10
					TAX
					LDA #$00
					STA $151C,x
					STZ $B6,x
					LDA $7FDD11
					TAX
					LDA #$FA
					STA $151C,x
					LDA $0F
					LSR A
					LSR A
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$F4
					STA $151C,x
					LDA $0F
					LSR A
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$EE
					STA $151C,x
					LDA $0F
					LSR A
					STA $0F
					LSR A
					CLC
					ADC $0F
					STA $B6,x
					PLX
					RTS
MODE5_3				LDA #$30
					STA $151C,x
					LDA $1594,x
					STA $0F
					LDA #$00
					SEC
					SBC $0F
					STA $B6,x
					PHX
					LDA $7FDD10
					TAX
					LDA #$00
					STA $151C,x
					STZ $B6,x
					LDA $7FDD11
					TAX
					LDA #$0C
					STA $151C,x
					LDA $0F
					LSR A
					LSR A
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					LDA $7FDD12
					TAX
					LDA #$18
					STA $151C,x
					LDA $0F
					LSR A
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					LDA $7FDD13
					TAX
					LDA #$24
					STA $151C,x
					LDA $0F
					LSR A
					STA $0F
					LSR A
					CLC
					ADC $0F
					STA $03
					LDA #$00
					SEC
					SBC $03
					STA $B6,x
					PLX
					LDA $15AC,x
					CMP #$A8
					BNE MODE5_R
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					RTS
MODE5_R				RTS

ICE_Y1				dcb $10,$A0,$20,$A0,$D0,$C0,$B0,$A0,$E0,$A0,$00,$A0,$D0,$A0,$A0
ICE_Y2				dcb $01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
ICE_X1				dcb $10,$A0,$10,$F0,$10,$10,$10,$C0,$10,$D0,$10,$B0,$10,$A0,$D0
ICE_X2				dcb $01,$00,$01,$00,$01,$01,$01,$00,$01,$00,$01,$00,$01,$00,$00

MODE6				LDA #$03
					STA $1602,x
					LDA $15AC,x
					BNE MODE6_R
					LDA $1594,x
					CMP #$0F
					BEQ MODE6_2
					LDA #$30
					STA $15AC,x
					JSR GEN_SPRITE
					LDA #$0B
					STA $167A,y
					LDA #$20
					STA $00C2,y
					PHX
					LDA $1594,x
					TAX
					LDA ICE_Y1,x
					STA $00D8,y
					LDA ICE_Y2,x
					STA $14D4,y
					LDA ICE_X1,x
					STA $00E4,y
					LDA ICE_X2,x
					STA $14E0,y
					PLX
					INC $1594,x
MODE6_R				RTS
MODE6_2				LDA #$C5
					STA $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FE301
					STA $7FE302
					LDA #$20
					STA $40
					STZ $1594,x
					LDA #$00
					STA $7FFD05
					STA $7FEEEF
					RTS
MODE7				LDA $1558,x
					BNE MODE7_7
					LDA $15AC,x
					BEQ MODE7_2
					LDA #$03
					STA $1602,x
					RTS
MODE7_2				LDA #$02
					STA $1602,x
					LDA $97
					BNE MODE7_3
					LDA $96
					CMP #$D0
					BCC MODE7_4
MODE7_3				LDA #$E0
					STA $7D
					STZ $7B
					RTS
MODE7_4				LDA $94
					AND #$FE
					CMP #$7E
					BEQ MODE7_6
					CMP #$80
					BEQ MODE7_6
					LDA $94
					CMP #$7F
					BCS MODE7_5
					STZ $7D
					LDA #$20
					STA $7B
					RTS
MODE7_5				LDA #$E0
					STA $7B
					STZ $7D
					RTS
MODE7_6				LDA #$80
					STA $1558,x
					STZ $7B
MODE7_R				RTS
MODE7_7				CMP #$01
					BNE MODE7_R
					LDY $1594,x
					LDA #$00
					STA $14C8,y
					LDA #$8A
					STA $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FFD05
					LDA #$00
					STA $7FE301
					STA $7FE302
					LDA #$20
					STA $40
					LDA #$0F
					STA $7FEEEF
					RTS
MODE8				LDA #$02
					STA $1602,x
					LDA $15AC,x
					CMP #$D0
					BEQ MODE8_2
					CMP #$60
					BEQ MODE8_3
					RTS
MODE8_2				LDA #$18
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$00
					STA $1662,y
					STA $1602,y
					STA $1686,y
					LDA #$0B
					STA $167A,y
					LDA #$40
					STA $00C2,y
					LDA #$70
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$A0
					STA $00D8,y
					RTS
MODE8_3				LDA #$85
					STA $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FFD05
					LDA #$00
					STA $7FE301
					STA $7FE302
					LDA #$20
					STA $40
					LDA #$00
					STA $7FEEEF
					RTS
MODE9				LDA #$03
					STA $1602,x
					LDA $15AC,x
					BEQ MODE9_2
					CMP #$01
					BEQ MODE9_5
					JSR LASER
					JSR HDMA_COLOR3
					JSR LASER_DAMAGE
					REP #$30
					LDA $7FFCD3
					CMP #$0100
					BCC MODE9_3
					LDA $7FFCD3
					SEC
					SBC.W #$03FF
					STA $7FFCD3
					BRA MODE9_4
MODE9_3				LDA.W #$7801
					STA $7FFCD3
MODE9_4				LDA $7FFCD3
					STA $7FFCD1
					SEP #$30
					LDA $7FFCC1
					CLC
					ADC #$04
					STA $7FFCC1
					STA $7FFCC3
					LDA $7FFCC2
					ADC #$00
					STA $7FFCC2
					LDA $7FFCC2
					AND #$01
					BEQ MODE9_R
					LDA #$00
					SEC
					SBC $7FFCC1
					STA $7FFCC3
MODE9_R				RTS
MODE9_2				JSR HDMA_COLOR
					LDA #$20
					STA $40
					LDA #$77
					STA $15AC,x
					LDA #$01
					STA $C2,x
					LDA #$00
					STA $7FFD05
					LDA #$00
					STA $7FEEEF
					RTS
MODE9_5				JSR HDMA_COLOR_RESET
					JSR HDMA_LASER
					RTS

MODEA_0				STZ $151C,x
					PHX
					LDA $7FDD10
					TAX
					STZ $151C,x
					LDA $7FDD11
					TAX
					STZ $151C,x
					LDA $7FDD12
					TAX
					STZ $151C,x
					LDA $7FDD13
					TAX
					STZ $151C,x
					PLX
					RTS
MODEA				LDA $1564,x
					BNE MODEA_8_0
					LDA $1468
					CMP #$C0
					BCS MODEA_2
					INC $1468
					INC $1468
					LDA #$E0
					STA $151C,x
					PHX
					LDA $7FDD10
					TAX
					LDA #$E0
					STA $151C,x
					LDA $7FDD11
					TAX
					LDA #$E0
					STA $151C,x
					LDA $7FDD12
					TAX
					LDA #$E0
					STA $151C,x
					LDA $7FDD13
					TAX
					LDA #$E0
					STA $151C,x
					PLX
					LDA #$FF
					STA $15AC,x
					RTS
MODEA_2				LDA #$04
					STA $1602,x
					STZ $B6,x
					LDA $15AC,x
					CMP #$FE
					BEQ MODEA_0
					CMP #$C0
					BCS MODEA_3
					CMP #$A8
					BCS MODEA_4
					CMP #$98
					BCS MODEA_5
					CMP #$89
					BEQ MODEA_R2
					CMP #$88
					BEQ MODEA_R3
					CMP #$88
					BCS MODEA_R
					CMP #$48
					BCS MODEA_6
					BRA MODEA_7
MODEA_R				RTS
MODEA_8_0			BRA MODEA_8_1
MODEA_R2			LDA #$17
					STA $1DFC
					STZ $1570,x
					LDA #$FF
					STA $1558,x
					LDA #$0A
					STA $7FE301
					LDA #$00
					STA $7FE302
					RTS
MODEA_R3			JSR HDMA_FLARE2
					RTS
MODEA_3				LDA #$10
					STA $E4,x
					LDA #$01
					STA $14E0,x
					LDA #$48
					STA $D8,x
					LDA #$01
					STA $14D4,x
					STZ $1594,x
					RTS
MODEA_4				LDA #$60
					STA $40
					LDA #$E0
					STA $B6,x
					RTS
MODEA_5				LDA #$20
					STA $B6,x
					RTS
MODEA_8_1			BRA MODEA_8
MODEA_6				JSR HDMA_FLARE
					JSR HDMA_FLARE3
					INC $1594,x
					JSR STONE_GEN
					LDA $15AC,x
					CMP #$48
					BNE MODEA_6_R
					JSR TILE_CHANGE2
MODEA_6_R			RTS
MODEA_7				LDA $1594,x
					BEQ MODEA_8
					JSR HDMA_FLARE3
					JSR STONE_GEN
					JSR FRAME_DAMAGE
					LDA $1558,x
					BNE MODEA_R4
					DEC $1594,x
					JSR HDMA_FLARE
MODEA_R4			RTS
MODEA_8				STZ $B6,x
					LDA $1564,x
					CMP #$D0
					BCS MODEA_9
					CMP #$CF
					BEQ MODEA_A
					CMP #$B0
					BCS MODEA_B
					JSR HDMA_COLOR
					LDA #$FF
					STA $1564,x
					RTS
MODEA_9				LDA #$20
					STA $B6,x
MODE0_R7			RTS
MODEA_B				STZ $1602,x
					DEC $1468
					LDA #$C0
					STA $1564,x
					LDA $1468
					CMP #$20
					BNE MODE0_R7
					LDA #$01
					STA $C2,x
					LDA #$09
					STA $1DFC
					LDA #$20
					STA $1887
					LDA #$81
					STA $15AC,x
					STZ $1564,x
					STZ $151C,x
					PHX
					LDA $7FDD10
					TAX
					STZ $151C,x
					LDA $7FDD11
					TAX
					STZ $151C,x
					LDA $7FDD12
					TAX
					STZ $151C,x
					LDA $7FDD13
					TAX
					STZ $151C,x
					PLX
					LDA #$00
					STA $7FFD05
					RTS
MODEA_A				DEC $1468
					LDA #$C0
					STA $1564,x
					LDA #$20
					STA $40
					LDA #$10
					STA $151C,x
					LDA #$54
					STA $E4,x
					STZ $14E0,x
					LDA #$64
					STA $D8,x
					STZ $14D4,x
					STZ $1570,x
					LDA #$01
					STA $1602,x
					STZ $B6,x
					PHX
					LDA $7FDD10
					TAX
					LDA #$10
					STA $151C,x
					LDA #$60
					STA $E4,x
					LDA #$20
					STA $D8,x
					STZ $157C,x
					STZ $B6,x
					LDA #$20
					STA $1570,x
					LDA $7FDD11
					TAX
					LDA #$10
					STA $151C,x
					LDA #$68
					STA $E4,x
					LDA #$30
					STA $D8,x
					STZ $157C,x
					STZ $B6,x
					LDA #$18
					STA $1570,x
					LDA $7FDD12
					TAX
					LDA #$10
					STA $151C,x
					LDA #$70
					STA $E4,x
					LDA #$40
					STA $D8,x
					LDA #$01
					STA $157C,x
					STZ $B6,x
					LDA #$10
					STA $1570,x
					LDA $7FDD13
					TAX
					LDA #$10
					STA $151C,x
					LDA #$64
					STA $E4,x
					LDA #$50
					STA $D8,x
					LDA #$01
					STA $157C,x
					STZ $B6,x
					LDA #$08
					STA $1570,x
					PLX
					LDA #$00
					STA $7FDC00
					RTS

					
MODEB				LDA $1558,x
					BNE MODEB_3_0
					LDA $15AC,x
					CMP #$F0
					BEQ MODEB_FLASH
					CMP #$E0
					BEQ MODEB_1
					CMP #$D0
					BEQ MODEB_FLASH
					CMP #$C0
					BEQ MODEB_1
					CMP #$B0
					BEQ MODEB_FLASH
					CMP #$A0
					BEQ MODEB_1
					CMP #$60
					BCS MODEB_R
					LDA $1463
					BEQ MODEB_2
					LDA $7FE301
					BNE MODEB_1
					JSR HDMA_VERT1
					JSR HDMA_VERT2
					LDA #$FF
					STA $1558,x
					STA $40
					STZ $1594,x
					LDA #$01
					STA $00212C
					LDA #$16
					STA $00212D
					LDA #$17
					STA $1DFC
MODEB_R				RTS
MODEB_1				JSR HDMA_COLOR
					RTS
MODEB_FLASH			LDA #$73
					STA $7FE301
					LDA #$4E
					STA $7FE302
					LDA #$18
					STA $1DFC
					RTS
MODEB_3_0			BRA MODEB_3
MODEB_2				LDA #$FF
					STA $7FE301
					LDA #$7F
					STA $7FE302
					JSR LAST_MOVE
					LDA #$01
					STA $7FE100
					LDA #$00
					STA $00212C
					LDA #$17
					STA $00212D
					RTS
MODEB_3				LDA #$10
					STA $7D
					LDA $1594,x
					CMP #$7F
					BEQ MODEB_4
					INC $1594,x
					LDA $1594,x
					STA $7FC802
					STA $7FC902
					LDA #$80
					SEC
					SBC $1594,x
					STA $7FC800
					STA $7FC900
					RTS
MODEB_4				LDA #$30
					STA $7FC801
					LDA #$03
					STA $7FC901
					LDA $1558,x
					CMP #$01
					BNE MODEB_R2
					STZ $14C8,x
					LDA #$10
                    STA $13C6
                    STA $1493
					JSR BLACK_OUT
MODEB_R2			RTS

N_MODE0				;JSR IMG_CHECK
					LDA $7FFD05
					BNE N_MODE0_5
					INC $1570,x
					LDA $14
					AND #$03
					BNE N_MODE0_3
					LDA $1570,x
					AND #$20
					BEQ N_MODE0_2
					LDA $D8,x
					CLC
					ADC #$01
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					BRA N_MODE0_3
N_MODE0_2			LDA $D8,x
					SEC
					SBC #$01
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
N_MODE0_3			LDA $14
					AND #$07
					BNE N_MODE0_R
					LDA $1570,x
					AND #$20
					BEQ N_MODE0_4
					LDA $E4,x
					CLC
					ADC #$01
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					RTS
N_MODE0_4			LDA $E4,x
					SEC
					SBC #$01
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
N_MODE0_R			RTS
N_MODE0_5			JSR IMG_CHECK
					RTS




IMG_CHECK			PHX
					LDA $1504,x
					TAX
					LDA $7FDD11,x
					TAX
					LDA $E4,x
					STA $0F
					PLX
					LDA $E4,x
					SEC
					SBC $0F
					STA $0F
					BCS IMG_CHECK_2
					STZ $157C,x
					STZ $1602,x
					LDA $0F
					CMP #$F0
					BCS IMG_CHECK_R
					LDA #$01
					STA $1602,x
IMG_CHECK_R			RTS
IMG_CHECK_2			LDA #$01
					STA $157C,x
					STZ $1602,x
					LDA $0F
					CMP #$10
					BCC IMG_CHECK_R
					LDA #$01
					STA $1602,x
					RTS

IMG_CHECK2			LDA $1602,x
					CMP #$04
					BEQ IMG_CHECK2_5
					LDA $14E0,x
					CMP #$FF
					BEQ IMG_CHECK2_1
					CMP #$01
					BEQ IMG_CHECK2_4
					LDA $E4,x
					CMP #$60
					BCC IMG_CHECK2_1
					CMP #$80
					BCC IMG_CHECK2_2
					CMP #$A0
					BCC IMG_CHECK2_3
IMG_CHECK2_4		STZ $157C,x
					STZ $1602,x
					RTS
IMG_CHECK2_1		LDA #$01
					STA $157C,x
					STZ $1602,x
					RTS
IMG_CHECK2_2		LDA #$01
					STA $157C,x
					LDA #$01
					STA $1602,x
					RTS
IMG_CHECK2_3		STZ $157C,x
					LDA #$01
					STA $1602,x
					RTS
IMG_CHECK2_5		LDA #$01
					STA $157C,x
					RTS
					
MOVE_OFFSET1		dcb $02,$02,$02,$01,$03,$02,$02,$01,$03,$03,$02,$01,$03,$03,$03,$01
MOVE_OFFSET2		dcb $14,$2C,$40,$53,$14,$18,$2C,$53,$2C,$18,$14,$53,$40,$2C,$14,$53
MOVE_OFFSET3		dcb $04,$08,$0C,$00,$00,$08,$0C,$04,$00,$04,$0C,$08,$00,$04,$08,$0C

MOVE0				LDA #$00
					STA $7FC200
					LDA $7FC205
					CMP #$02
					BCS ATTACK0
					INC A
					STA $7FC205
					LDA $1504,x
					LSR A
					CLC
					ADC $94
					AND #$03
					CLC
					ADC $7FDC00
					TAY
					LDA MOVE_OFFSET1,y
					STA $C2,x
					LDA MOVE_OFFSET2,y
					STA $15AC,x
					LDA MOVE_OFFSET3,y
					STA $7FDC00
					LDA #$00
					STA $7FFD05
					LDA $C2,x
					CMP #$01
					BEQ MOVE0_R
					LDA #$01
					STA $7FFD05
MOVE0_R				RTS

ATTACK_OFFSET1		dcb $00,$00,$01,$00,$01,$00,$00,$01,$00,$00,$01,$01,$00,$00,$01,$01
ATTACK_OFFSET2		dcb $00,$01,$00,$01,$01,$00,$02,$01,$00,$01,$00,$01,$00,$01,$02,$01

ATTACK0				LDA #$00
					STA $7FC205
					LDA $7FC200
					CMP #$02
					BCS MOVE0
					INC A
					STA $7FC200
					LDA #$01
					STA $7FFD05
					LDA $7FC201
					INC A
					STA $7FC201
					LDA $1528,x
					CMP #$0C
					BCS ATTACK0_2
					PHX
					LDA $7FC201
					AND #$0F
					TAX
					LDA ATTACK_OFFSET1,x
					STA $0F
					PLX
					BRA ATTACK0_1
ATTACK0_2			PHX
					LDA $7FC201
					AND #$0F
					TAX
					LDA ATTACK_OFFSET2,x
					STA $0F
					PLX
ATTACK0_1			LDA $0F
					CMP #$00
					BEQ ATTACK_NECK
					CMP #$02
					BEQ ATTACKF_0
ATTACK0_3			LDA $7FDC00
					CMP #$08
					BEQ ATTACK1
					CMP #$0C
					BEQ ATTACK3
					CMP #$00
					BEQ ATTACK2_0
					CMP #$04
					BEQ ATTACK4
ATTACK_NECK			LDA #$E0
					STA $15AC,x
					LDA $94
					SEC
					SBC $E4,x
					STA $0F
					LDA $95
					SBC $14E0,x
					BCC ATTACL0_LEFT
					LDA #$04
					STA $C2,x
					LDA $0F
					LSR A
					STA $1594,x
					RTS
ATTACL0_LEFT		LDA #$05
					STA $C2,x
					LDA #$00
					SEC
					SBC $0F
					LSR A
					STA $1594,x
					RTS
ATTACK1				LDA #$30
					STA $15AC,x
					LDA #$06
					STA $C2,x
					LDA #$54
					STA $7FE302
					LDA #$60
					STA $40
					STZ $1594,x
					LDA #$09
					STA $7FEEEF
					RTS
ATTACK3				LDA #$FF
					STA $15AC,x
					LDA #$08
					STA $C2,x
					LDA #$60
					STA $40
					LDA #$0D
					STA $7FEEEF
					RTS
ATTACKF_0			LDA $7FC202
					BEQ ATTACK0_3
					BRA ATTACKF
ATTACK2_0			BRA ATTACK2
ATTACK4				LDA #$FF
					STA $15AC,x
					LDA #$09
					STA $C2,x
					LDA #$05
					STA $7FEEEF
					LDA #$60
					STA $40
					LDA #$82
					STA $7FFCC1
					STA $7FFCC3
					LDA #$00
					STA $7FFCC2
					JSR HDMA_LASER
					JSR LASER2
					JSR HDMA_COLOR2
					RTS
ATTACKF				LDA #$0A
					STA $C2,x
					RTS
ATTACK2				LDA #$FF
					STA $15AC,x
					LDA #$07
					STA $C2,x
					LDA #$37
					STA $7FE301
					LDA #$04
					STA $7FE302
					LDA #$60
					STA $40
					STZ $1594,x
					LDA #$01
					STA $7FEEEF
					LDA #$17
					STA $1DFC
					JSR GEN_SPRITE
					LDA #$00
					STA $1662,y
					STA $1686,y
					LDA #$0B
					STA $167A,y
					LDA #$30
					STA $00C2,y
					LDA #$78
					STA $00E4,y
					LDA #$00
					STA $14E0,y
					STA $14D4,y
					LDA #$A0
					STA $00D8,y
					TYA
					STA $1594,x
					RTS

					
STONE_X				dcb $30,$10,$08,$40,$18,$60,$08,$48,$28,$50,$48,$38,$48,$18,$50,$30
STONE_GEN			LDA $1558,x
					CMP #$F0
					BEQ MODEA_G
					CMP #$D8
					BEQ MODEA_G
					CMP #$C0
					BEQ MODEA_G
					CMP #$A8
					BEQ MODEA_G
					CMP #$90
					BEQ MODEA_G
					CMP #$78
					BEQ MODEA_G
					CMP #$60
					BEQ MODEA_G
					CMP #$48
					BEQ MODEA_G
					CMP #$30
					BEQ MODEA_G
					CMP #$18
					BEQ MODEA_G
					CMP #$01
					BEQ MODEA_G2
					RTS
MODEA_G				JSR GEN_SPRITE
					LDA #$50
					STA $00C2,y
					PHX
					LDA $1570,x
					TAX
					LDA STONE_X,x
					STA $00D8,y
					PLX
					INC $1570,x
STONE_R				RTS
MODEA_G2			JSR GEN_SPRITE
					LDA #$50
					STA $00C2,y
					PHX
					LDA $1570,x
					TAX
					LDA STONE_X,x
					STA $00D8,y
					PLX
					JSR TILE_CHANGE3
					RTS

					
POS_STA				LDA $7FDC00
					BNE POS_STA_2
					PHX
					LDA $7FDD10
					TAX
					LDA #$60
					STA $E4,x
					LDA #$C0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$20
					STA $1570,x
					LDA $7FDD11
					TAX
					LDA #$68
					STA $E4,x
					LDA #$D0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$18
					STA $1570,x
					LDA $7FDD12
					TAX
					LDA #$70
					STA $E4,x
					LDA #$E0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$10
					STA $1570,x
					LDA $7FDD13
					TAX
					LDA #$64
					STA $E4,x
					LDA #$F0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$08
					STA $1570,x
					LDA $7FDD14
					TAX
					LDA #$54
					STA $E4,x
					LDA #$04
					STA $D8,x
					STZ $14E0,x
					LDA #$01
					STA $14D4,x
					STZ $1570,x
					PLX
					RTS
POS_STA_2			CMP #$04
					BNE POS_STA_3
					PHX
					LDA $7FDD10
					TAX
					LDA #$64
					STA $E4,x
					LDA #$C0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$20
					STA $1570,x
					LDA $7FDD11
					TAX
					LDA #$6C
					STA $E4,x
					LDA #$D0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$18
					STA $1570,x
					LDA $7FDD12
					TAX
					LDA #$77
					STA $E4,x
					LDA #$E0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$10
					STA $1570,x
					LDA $7FDD13
					TAX
					LDA #$74
					STA $E4,x
					LDA #$F0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$08
					STA $1570,x
					LDA $7FDD14
					TAX
					LDA #$70
					STA $E4,x
					LDA #$04
					STA $D8,x
					STZ $14E0,x
					LDA #$01
					STA $14D4,x
					STZ $1570,x
					PLX
					RTS
POS_STA_3			CMP #$08
					BNE POS_STA_4
					PHX
					LDA $7FDD10
					TAX
					LDA #$6A
					STA $E4,x
					LDA #$C0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$20
					STA $1570,x
					LDA $7FDD11
					TAX
					LDA #$72
					STA $E4,x
					LDA #$D0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$18
					STA $1570,x
					LDA $7FDD12
					TAX
					LDA #$80
					STA $E4,x
					LDA #$E0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$10
					STA $1570,x
					LDA $7FDD13
					TAX
					LDA #$89
					STA $E4,x
					LDA #$F0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$08
					STA $1570,x
					LDA $7FDD14
					TAX
					LDA #$94
					STA $E4,x
					LDA #$04
					STA $D8,x
					STZ $14E0,x
					LDA #$01
					STA $14D4,x
					STZ $1570,x
					PLX
					RTS
POS_STA_4			PHX
					LDA $7FDD10
					TAX
					LDA #$6F
					STA $E4,x
					LDA #$C0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$20
					STA $1570,x
					LDA $7FDD11
					TAX
					LDA #$77
					STA $E4,x
					LDA #$D0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$18
					STA $1570,x
					LDA $7FDD12
					TAX
					LDA #$87
					STA $E4,x
					LDA #$E0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$10
					STA $1570,x
					LDA $7FDD13
					TAX
					LDA #$9B
					STA $E4,x
					LDA #$F0
					STA $D8,x
					STZ $14E0,x
					STZ $14D4,x
					LDA #$08
					STA $1570,x
					LDA $7FDD14
					TAX
					LDA #$B2
					STA $E4,x
					LDA #$04
					STA $D8,x
					STZ $14E0,x
					LDA #$01
					STA $14D4,x
					STZ $1570,x
					PLX
					RTS
					
					
LAST_MOVE			STZ $7B
					LDA $1462
					CLC
					ADC #$10
					STA $1462
					LDA $1463
					ADC #$00
					STA $1463
					LDA $94
					CLC
					ADC #$10
					STA $94
					LDA $95
					ADC #$00
					STA $95
					LDA #$50
					STA $96
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					PHX
					LDA $7FDD10
					TAX
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $7FDD11
					TAX
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $7FDD12
					TAX
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					LDA $7FDD13
					TAX
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					PLX
					RTS
					
POS_DEF				LDA $94
					CMP #$18
					BCS POS_DEF2
					LDA #$18
					STA $94
					RTS
POS_DEF2			CMP #$C0
					BCC POS_DEF_R
					LDA #$C0
					STA $94
POS_DEF_R			RTS



MARIO_CHECK			LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					STA $7FDD82
					PHA
					LDA $14D4,x
					STA $7FDD83
					PHA
					LDA $1602,x
					BNE MARIO_CHECK_1_0
					JSL $01A7DC
					BCC MARIO_CHECK_0_1
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_0_1		LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC MARIO_CHECK_0_2
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_0_2		LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC MARIO_CHECK_0_3
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_0_3		LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC MARIO_CHECK_0_4
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_0_4		LDA $E4,x
					SEC
					SBC #$20
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC MARIO_CHECK_0_5
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_1_0		BRA MARIO_CHECK_1
MARIO_CHECK_0_6		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
MARIO_CHECK_0_5		LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC MARIO_CHECK_0_6
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_0_6
MARIO_CHECK_1		LDA $157C,x
					BNE MARIO_CHECK_1_1
					LDA $E4,x
					CLC
					ADC #$10
					STA $E4,x
					LDA $14E0,x
					ADC #$00
					STA $14E0,x
MARIO_CHECK_1_1		JSL $01A7DC
					BCC MARIO_CHECK_1_2
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
MARIO_CHECK_1_2		LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC MARIO_CHECK_1_3
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
MARIO_CHECK_1_3		LDA $D8,x
					SEC
					SBC #$20
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC MARIO_CHECK_1_4
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
MARIO_CHECK_1_4		LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					SBC #$00
					STA $14E0,x
					JSL $01A7DC
					BCC MARIO_CHECK_1_5
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
MARIO_CHECK_1_5		LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC MARIO_CHECK_1_7
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
MARIO_CHECK_1_6		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS
MARIO_CHECK_1_7		LDA $D8,x
					CLC
					ADC #$10
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					BCC MARIO_CHECK_1_6
					JSR SUB_MARIO_CHECK
					BRA MARIO_CHECK_1_6
					
SUB_MARIO_CHECK		LDA $C2,x
					CMP #$04
					BEQ SUB_MARIO_CHECK2
					CMP #$05
					BEQ SUB_MARIO_CHECK2
SUB_MARIO_CHECK2_2	LDA $1497
					BNE SUB_MARIO_CHECK_2
					JSL $00F5B7             ; hurt mario
SUB_MARIO_CHECK_2	RTS
					
SUB_MARIO_CHECK2	LDA $7FDD80
					BNE SUB_MARIO_CHECK_2
					LDA $7D
					CMP #$80
					BCS SUB_MARIO_CHECK3
					CMP #$10
					BCC SUB_MARIO_CHECK3
					BRA SUB_MARIO_CHECK4
SUB_MARIO_CHECK3	LDA $7FDD82
					SEC
					SBC $96
					STA $0F
					LDA $7FDD83
					SBC $97
					BCC SUB_MARIO_CHECK2_2
					LDA $0F
					CMP #$28
					BCC SUB_MARIO_CHECK2_2
SUB_MARIO_CHECK4	LDA #$01
					STA $7FDD80
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$20
                    STA $1DF9
					INC $1528,x
					JSR GAGE_CHECK
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HORIZ_DISP          dcb $08,$F8,$08,$F8,$08,$F8,$F8,$08,$F8,$08,$F8,$08
VERT_DISP           dcb $F0,$F0,$00,$00,$10,$10
TILEMAP             dcb $8C,$8E,$AC,$AE,$CC,$CE,$2C,$2E,$4C,$4E,$6C,$6E
PROPERTIES          dcb $4D,$0D


SUB_GFX             JSR GET_DRAW_INFO
					
					LDA $157C,x
					STA $02
					PHX
					LDX $02
					LDA PROPERTIES,x
					PLX
					STA $0F
					LDA $02
					ASL A
					ASL A
					CLC
					ADC $02
					ADC $02
					STA $02
					
					LDA $1602,x
					ASL A
					ASL A
					CLC 
					ADC $1602,x
					ADC $1602,x
					STA $03
					
					PHX
                    LDX #$05                ; run loop 4 times, cuz 4 tiles per frame
LOOP_START          PHX                     ; push, current tile

					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
					PHX
					TXA
					CLC
					ADC $02
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC HORIZ_DISP,x        ; |
                    STA $0300,y             ; /
                    PLX
                    
					PHX
					TXA
					CLC
					ADC $03
					TAX
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX

					LDA $0F
                    ORA $64                ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$05                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

I_HORIZ_DISP          dcb $F8,$08,$F8,$08
I_VERT_DISP           dcb $F0,$F0,$00,$00
I_TILEMAP             dcb $8C,$8E,$AC,$AE

I_SUB_GFX	        JSR GET_DRAW_INFO
					PHX
                    LDX #$03
I_LOOP_START        PHX                     ; push, current tile

					LDA $00
					CLC
					ADC I_HORIZ_DISP,x
					STA $300,y
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC I_VERT_DISP,x         ; |
                    STA $0301,y             ; /
                    
                    LDA I_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA #$08
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL I_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
S_HORIZ_DISP          dcb $F8,$08,$F8,$08
S_VERT_DISP           dcb $F0,$F0,$00,$00
S_TILEMAP             dcb $80,$82,$A0,$A2

S_SUB_GFX	        JSR GET_DRAW_INFO
					PHX
                    LDX #$03
S_LOOP_START        PHX                     ; push, current tile

					LDA $00
					CLC
					ADC S_HORIZ_DISP,x
					STA $300,y
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC S_VERT_DISP,x         ; |
                    STA $0301,y             ; /
                    
                    LDA S_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA #$06
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties


                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL S_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

F_HORIZ_DISP          dcb $B0,$D8,$00,$28,$50
F_TILEMAP             dcb $88,$8A,$88,$8A,$88
					  dcb $8A,$88,$8A,$88,$8A

F_SUB_GFX	        JSR GET_DRAW_INFO
					STZ $03
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					BNE F_SUB_GFX_2
					LDA #$05
					STA $03
F_SUB_GFX_2			PHX
                    LDX #$04
F_LOOP_START        PHX                     ; push, current tile

					LDA $00
					CLC
					ADC F_HORIZ_DISP,x
					STA $0300,y
					
					LDA $01                 ; |
                    STA $0301,y             ; /
                    
					TXA
					CLC
					ADC $03
					TAX
                    LDA F_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA #$0E
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL F_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$04                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
					
T_HORIZ_DISP          dcb $00,$00,$00,$00
					  dcb $E8,$F8,$08,$18
T_VERT_DISP           dcb $D0,$E0,$F0,$00
					  dcb $00,$00,$00,$00
T_TILEMAP             dcb $86,$A6,$C6,$E6,$84,$A4,$C4,$E4
					  dcb $C8,$CA,$CC,$CE,$C0,$C2,$E0,$E2

T_SUB_GFX	        JSR GET_DRAW_INFO
					LDA $1602,x
					STA $02
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$01
					ASL A
					ASL A
					STA $03
					PHX
                    LDX #$03
T_LOOP_START        PHX                     ; push, current tile
					TXA
					CLC
					ADC $02
					TAX
					LDA $00
					CLC
					ADC T_HORIZ_DISP,x
					STA $0300,y
					
					LDA $01                 ; |
					CLC
					ADC T_VERT_DISP,x
                    STA $0301,y             ; /
                    
					TXA
					CLC
					ADC $02
					CLC
					ADC $03
					TAX
                    LDA T_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /

					LDA #$02
                    ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL T_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$03                ; | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


D_HORIZ_DISP        dcb $00,$10,$20,$F0,$00,$10,$F0,$00,$10,$F0,$00,$F0
					dcb $00,$F0,$E0,$10,$00,$F0,$10,$00,$F0,$10,$00,$10
					dcb $F8,$08,$F0,$00,$10,$F0,$00,$10,$F4,$04,$F0,$00
					dcb $08,$F8,$10,$00,$F0,$10,$00,$F0,$0C,$FC,$10,$00
					dcb $F8,$08,$F8,$08,$18,$F8,$08,$18,$F8,$08,$F8
					dcb $08,$F8,$08,$F8,$E8,$08,$F8,$E8,$08,$F8,$08
					dcb $F8,$08,$F0,$00,$10,$F0,$00,$10,$F4,$04,$F0,$00
					dcb $08,$F8,$10,$00,$F0,$10,$00,$F0,$0C,$FC,$10,$00
					dcb $F0,$00,$10,$F0,$00,$10,$F0,$00,$10,$F0,$00,$10
					dcb $10,$00,$F0,$10,$00,$F0,$10,$00,$F0,$10,$00,$F0
D_VERT_DISP         dcb $E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00,$10,$10,$20
					dcb $E0,$E0,$F0,$F0,$F0,$00,$00,$00,$10,$10,$20,$20
					dcb $E0,$E0,$F0,$F0,$F0,$00,$00,$00,$10,$10,$20
					dcb $E0,$E0,$F0,$F0,$F0,$00,$00,$00,$10,$10,$20,$20
					dcb $D0,$D0,$D0,$E0,$E0,$E0,$F0,$F0,$F0,$00,$00,$00
D_TILEMAP           dcb $80,$82,$84,$A0,$A2,$A4,$C0,$C2,$C4,$E0,$E2,$E4
					dcb $06,$08,$26,$28,$2A,$46,$48,$4A,$66,$68,$0A,$0C
					dcb $00,$02,$20,$22,$24,$40,$42,$44,$60,$62,$04
					dcb $06,$08,$0E,$64,$2A,$EC,$EE,$4A,$66,$68,$0A,$0C
					dcb $86,$88,$8A,$A6,$A8,$AA,$C6,$C8,$CA,$E6,$E8,$EA
D_PROPERTIES        dcb $4D,$0D
TILE_NUM			dcb $0B,$0B,$0A,$0B,$0B
OFFSET				dcb $00,$0C,$18,$23,$2F

D_SUB_GFX_R			RTS
D_SUB_GFX           JSR GET_DRAW_INFO
					LDA $1540,x
					AND #$01
					BNE D_SUB_GFX_R
					LDA $1602,x
					STA $03
GFX4				PHX
					LDX $03
					LDA TILE_NUM,x
					STA $0F
					LDA OFFSET,x
					STA $7FEE0F
					CLC
					ADC $7FEE0F
					STA $7FEE0E
					PLX
					LDA $157C,x
					STA $02
					BNE GFX2
					LDA $7FEE0E
					CLC
					ADC $0F
					ADC #$01
					STA $7FEE0E
					
GFX2				PHX
					LDX $02
					LDA D_PROPERTIES,x
					STA $7FEE0D
					LDX $0F
D_LOOP_START        PHX                     ; push, current tile
                    
					TXA
					CLC
					ADC $7FEE0F
					TAX
					
					LDA $01                 ; |
                    CLC                     ; | tile y position = sprite y location ($01) + tile displacement
                    ADC D_VERT_DISP,x         ; |
                    STA $0301,y             ; /
					
                    LDA D_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; /
					PLX
					
					PHX
					TXA
					CLC
					ADC $7FEE0E
					TAX
					
					LDA $00                 ; \ tile x position = sprite x location ($00) + tile displacement
                    CLC                     ; |
                    ADC D_HORIZ_DISP,x        ; |
                    STA $0300,y             ; /

					LDA $7FEE0D
                    ORA $64                ; add in tile priority of level
                    STA $0303,y             ; store tile properties

                    PLX                     ; \ pull, current tile
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL D_LOOP_START

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA $0F
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_SPRITE          
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y
                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS                          ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; routines below can be shared by all sprites.  they are ripped from original
; SMW and poorly documented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817                ; Y = 1 if contact

SUB_GET_DIR         LDY #$00                
                    LDA $94                
                    SEC                     
                    SBC $E4,x               
                    STA $0F                 
                    LDA $95                 
                    SBC $14E0,x             
                    BPL LABEL16             
                    INY                     
LABEL16             RTS                     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HDMA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BLACK_OUT			LDA #$08
					STA $7FFB18
					LDA #$00
					STA $7FFB19
					LDA #$00
					STA $7FFB1A
					LDA #$00
					STA $7FFB1B
					LDA #$C5
					STA $7FFB1C
					LDA #$7F
					STA $7FFB1D
					LDA #$01
					STA $7FC500
					LDA #$00
					STA $7FC501
					STA $7FC502
					RTS


HDMA_VERT1			LDA #$1F
					STA $00212F
					LDA #$20
					STA $7FFB28
					LDA #$00
					STA $7FFB29
					LDA #$23
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$C8
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					LDA #$7F
					STA $7FC800
					LDA #$00
					STA $7FC801
					LDA #$01
					STA $7FC802
					LDA #$30
					STA $7FC803
					LDA #$01
					STA $7FC804
					LDA #$00
					STA $7FC805
					STA $7FC806
					RTS
					
HDMA_VERT2			LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB21
					LDA #$25
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$C9
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					LDA #$7F
					STA $7FC900
					LDA #$00
					STA $7FC901
					LDA #$01
					STA $7FC902
					LDA #$03
					STA $7FC903
					LDA #$01
					STA $7FC904
					LDA #$00
					STA $7FC905
					STA $7FC906
					RTS


LAYER3_DEL			LDA #$40
					STA $7FFB30
					LDA #$02
					STA $7FFB31
					LDA #$11
					STA $7FFB32
					LDA #$00
					STA $7FFB33
					LDA #$E1
					STA $7FFB34
					LDA #$7F
					STA $7FFB35
					LDA #$0F
					STA $7FE100
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE102
					LDA #$80
					STA $7FE103
					LDA #$00
					STA $7FE104
					LDA #$01
					STA $7FE105
					LDA #$00
					STA $7FE106
HDMA_R2				RTS

LAYER3_DEL2			LDA #$80
					STA $7FFB38
					LDA #$02
					STA $7FFB39
					LDA #$11
					STA $7FFB3A
					LDA #$00
					STA $7FFB3B
					LDA #$E1
					STA $7FFB3C
					LDA #$7F
					STA $7FFB3D
					LDA #$0F
					STA $7FE100
					LDA #$00
					STA $7FE101
					LDA #$00
					STA $7FE102
					LDA #$80
					STA $7FE103
					LDA #$00
					STA $7FE104
					LDA #$01
					STA $7FE105
					LDA #$00
					STA $7FE106
HDMA_R				RTS


HDMA_FLARE			LDA #$70
					SEC
					SBC $1594,x
					STA $7FE500
					LDA #$00
					STA $7FE501
					STA $7FE502
					LDA $1594,x
					ASL A
					STA $7FE503
					LDA #$00
					STA $7FE504
					LDA #$01
					STA $7FE505
					LDA #$01
					STA $7FE506
					LDA #$00
					STA $7FE507
					STA $7FE508
					STA $7FE509
					RTS

HDMA_FLARE3			LDA $7FE200
					DEC A
					DEC A
					STA $7FE200
					STA $7FE300
					LDA $7FE200
					BNE HDMA_FLARE_R
					LDA #$40
					STA $7FE200
					STA $7FE300
HDMA_FLARE_R		RTS




HDMA_FLARE2			LDA #$40
					STA $7FE200
					STA $7FE300
					LDA #$2D
					STA $7FE201
					LDA #$7F
					STA $7FE301
					LDA #$0F
					STA $7FE302
					
					LDA #$04
					STA $7FE202
					STA $7FE303
					LDA #$2D
					STA $7FE203
					LDA #$FF
					STA $7FE304
					LDA #$02
					STA $7FE305
					LDA #$04
					STA $7FE204
					STA $7FE306
					LDA #$2D
					STA $7FE205
					LDA #$FF
					STA $7FE307
					LDA #$02
					STA $7FE308
					LDA #$04
					STA $7FE206
					STA $7FE309
					LDA #$2D
					STA $7FE207
					LDA #$9F
					STA $7FE30A
					LDA #$02
					STA $7FE30B
					LDA #$04
					STA $7FE208
					STA $7FE30C
					LDA #$2D
					STA $7FE209
					LDA #$F9
					STA $7FE30D
					LDA #$00
					STA $7FE30E
					LDA #$04
					STA $7FE20A
					STA $7FE30F
					LDA #$2D
					STA $7FE20B
					LDA #$72
					STA $7FE310
					LDA #$00
					STA $7FE311
					LDA #$08
					STA $7FE20C
					STA $7FE312
					LDA #$2D
					STA $7FE20D
					LDA #$2A
					STA $7FE313
					LDA #$00
					STA $7FE314
					LDA #$04
					STA $7FE20E
					STA $7FE315
					LDA #$2D
					STA $7FE20F
					LDA #$72
					STA $7FE316
					LDA #$00
					STA $7FE317
					LDA #$04
					STA $7FE210
					STA $7FE318
					LDA #$2D
					STA $7FE211
					LDA #$F9
					STA $7FE319
					LDA #$00
					STA $7FE31A
					LDA #$04
					STA $7FE212
					STA $7FE31B
					LDA #$2D
					STA $7FE213
					LDA #$1E
					STA $7FE31C
					LDA #$02
					STA $7FE31D
					LDA #$04
					STA $7FE214
					STA $7FE31E
					LDA #$2D
					STA $7FE215
					LDA #$9F
					STA $7FE31F
					LDA #$02
					STA $7FE320
					LDA #$04
					STA $7FE216
					STA $7FE321
					LDA #$2D
					STA $7FE217
					LDA #$FF
					STA $7FE322
					LDA #$02
					STA $7FE323
					
					LDA #$10
					STA $7FE218
					STA $7FE324
					LDA #$2D
					STA $7FE219
					LDA #$7F
					STA $7FE325
					LDA #$0F
					STA $7FE326
					
					LDA #$04
					STA $7FE21A
					STA $7FE327
					LDA #$2D
					STA $7FE21B
					LDA #$FF
					STA $7FE328
					LDA #$02
					STA $7FE329
					LDA #$04
					STA $7FE21C
					STA $7FE32A
					LDA #$2D
					STA $7FE21D
					LDA #$9F
					STA $7FE32B
					LDA #$02
					STA $7FE32C
					LDA #$04
					STA $7FE21E
					STA $7FE32D
					LDA #$2D
					STA $7FE21F
					LDA #$1E
					STA $7FE32E
					LDA #$02
					STA $7FE32F
					LDA #$04
					STA $7FE220
					STA $7FE330
					LDA #$2D
					STA $7FE221
					LDA #$F9
					STA $7FE331
					LDA #$00
					STA $7FE332
					LDA #$04
					STA $7FE222
					STA $7FE333
					LDA #$2D
					STA $7FE223
					LDA #$72
					STA $7FE334
					LDA #$00
					STA $7FE335
					LDA #$08
					STA $7FE224
					STA $7FE336
					LDA #$2D
					STA $7FE225
					LDA #$2A
					STA $7FE337
					LDA #$00
					STA $7FE338
					LDA #$04
					STA $7FE226
					STA $7FE339
					LDA #$2D
					STA $7FE227
					LDA #$72
					STA $7FE33A
					LDA #$00
					STA $7FE33B
					LDA #$04
					STA $7FE228
					STA $7FE33C
					LDA #$2D
					STA $7FE229
					LDA #$F9
					STA $7FE33D
					LDA #$00
					STA $7FE33E
					LDA #$04
					STA $7FE22A
					STA $7FE33F
					LDA #$2D
					STA $7FE22B
					LDA #$1E
					STA $7FE340
					LDA #$02
					STA $7FE341
					LDA #$04
					STA $7FE22C
					STA $7FE342
					LDA #$2D
					STA $7FE22D
					LDA #$9F
					STA $7FE343
					LDA #$02
					STA $7FE344
					LDA #$04
					STA $7FE22E
					STA $7FE345
					LDA #$2D
					STA $7FE22F
					LDA #$FF
					STA $7FE346
					LDA #$02
					STA $7FE347
					
					LDA #$10
					STA $7FE230
					STA $7FE348
					LDA #$2D
					STA $7FE231
					LDA #$7F
					STA $7FE349
					LDA #$0F
					STA $7FE34A
					
					LDA #$04
					STA $7FE232
					STA $7FE34B
					LDA #$2D
					STA $7FE233
					LDA #$FF
					STA $7FE34C
					LDA #$02
					STA $7FE34D
					LDA #$04
					STA $7FE234
					STA $7FE34E
					LDA #$2D
					STA $7FE235
					LDA #$9F
					STA $7FE34F
					LDA #$02
					STA $7FE350
					LDA #$04
					STA $7FE236
					STA $7FE351
					LDA #$2D
					STA $7FE237
					LDA #$1E
					STA $7FE352
					LDA #$02
					STA $7FE353
					LDA #$04
					STA $7FE238
					STA $7FE354
					LDA #$2D
					STA $7FE239
					LDA #$F9
					STA $7FE355
					LDA #$00
					STA $7FE356
					LDA #$04
					STA $7FE23A
					STA $7FE357
					LDA #$2D
					STA $7FE23B
					LDA #$72
					STA $7FE358
					LDA #$00
					STA $7FE359
					LDA #$08
					STA $7FE23C
					STA $7FE35A
					LDA #$2D
					STA $7FE23D
					LDA #$2A
					STA $7FE35B
					LDA #$00
					STA $7FE35C
					LDA #$04
					STA $7FE23E
					STA $7FE35D
					LDA #$2D
					STA $7FE23F
					LDA #$72
					STA $7FE35E
					LDA #$00
					STA $7FE35F
					LDA #$04
					STA $7FE240
					STA $7FE360
					LDA #$2D
					STA $7FE241
					LDA #$F9
					STA $7FE361
					LDA #$00
					STA $7FE362
					LDA #$04
					STA $7FE242
					STA $7FE363
					LDA #$2D
					STA $7FE243
					LDA #$1E
					STA $7FE364
					LDA #$02
					STA $7FE365
					LDA #$04
					STA $7FE244
					STA $7FE366
					LDA #$2D
					STA $7FE245
					LDA #$9F
					STA $7FE367
					LDA #$02
					STA $7FE368
					LDA #$04
					STA $7FE246
					STA $7FE369
					LDA #$2D
					STA $7FE247
					LDA #$FF
					STA $7FE36A
					LDA #$02
					STA $7FE36B
					
					LDA #$01
					STA $7FE248
					STA $7FE36C
					LDA #$2D
					STA $7FE249
					LDA #$3C
					STA $7FE36D
					LDA #$4F
					STA $7FE36E
					LDA #$00
					STA $7FE24A
					STA $7FE36F
					RTS
					
					
GAGE_COLOR			LDA #$1A
					STA $7FE201
					LDA #$3E
					STA $7FE301
					LDA #$04
					STA $7FE302
					RTS

HDMA_COLOR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE301
					LDA #$00
					STA $7FE302
					LDA #$00
					STA $7FE202
					STA $7FE303
					RTS
					
HDMA_COLOR_RESET	LDA #$70
					STA $7FE200
					LDA #$3D
					STA $7FE201
					LDA #$00
					STA $7FE202
					LDA #$70
					STA $7FE300
					LDA #$96
					STA $7FE301
					LDA #$3A
					STA $7FE302
					LDA #$00
					STA $7FE303
					RTS

HDMA_COLOR2			REP #$30
					LDA.W #$7801
					STA $7FFCD3
					SEP #$30
					LDA #$70
					STA $7FE200
					LDA #$3D
					STA $7FE201
					PHX
					PHY
					LDX #$00
					LDY #$00
COLOR2_LOOP
					LDA #$03
					STA $7FE202,x
					LDA #$3D
					STA $7FE203,x
					INX
					INX
					INY
					CPY #$31
					BNE COLOR2_LOOP
					LDA #$00
					STA $7FE202,x
					PLY
					PLX
					RTS
					
HDMA_COLOR3			LDA #$70
					STA $7FE300
					LDA #$96
					STA $7FE301
					LDA #$3A
					STA $7FE302
					PHX
					PHY
					LDX #$00
					LDY #$00
					
COLOR3_LOOP			
					LDA #$03
					STA $7FE303,x
					REP #$30
					LDA $7FFCD1
					CMP #$7C00
					BNE COLOR3_LOOP_2
					LDA.W #$001F
					STA $7FFCD1
COLOR3_LOOP_2		LDA $7FFCD1
					CLC
					ADC.W #$03FF
					STA $7FE304,x
					STA $7FFCD1
					SEP #$30
					INX
					INX
					INX
					INY
					CPY #$31
					BNE COLOR3_LOOP
					LDA #$00
					STA $7FE303,x
					PLY
					PLX
					RTS
					
					
HDMA_LASER			LDA #$20
					STA $7FFB28
					LDA #$02
					STA $7FFB29
					LDA #$0F
					STA $7FFB2A
					LDA #$00
					STA $7FFB2B
					LDA #$E5
					STA $7FFB2C
					LDA #$7F
					STA $7FFB2D
					
					LDA #$70
					STA $7FE500
					LDA #$00
					STA $7FE501
					LDA #$00
					STA $7FE502
					LDA #$00
					STA $7FE503
					RTS

LAYER1_SCR			LDA #$01
					STA $95
					LDA #$01
					STA $1463
					RTS
					

LASER				PHX
					PHY
					LDX #$0000
					LDY #$0000
LOOP_L				TYA
					STA $004202
					LDA $7FFCC3
					STA $004203
					LDA $004216
					STA $004204
					LDA $004217
					STA $004205
					LDA #$50
					STA $004206
					REP #$30
					LDA $004214
					CLC
					ADC #$0100
					CLC
					ADC $7FE600,x
					STA $7FE504,x
					SEP #$30
					LDA #$02
					STA $7FE503,x
					INY
					INY
					INX
					INX
					INX
					CPY #$50
					BNE LOOP_L
					LDA #$01
					STA $7FE503,x
					LDA #$00
					STA $7FE504,x
					STA $7FE505,x
					STA $7FE506,x
					PLY
					PLX
					RTS
					
LASER2				PHX
					PHY
					LDX #$0000
					LDY #$0000
LOOP_L2				TYA
					STA $004202
					LDA #$80
					STA $004203
					LDA $004216
					STA $004204
					LDA $004217
					STA $004205
					LDA #$50
					STA $004206
					LDA $004214
					STA $0F
					LDA #$80
					SEC
					SBC $0F
					STA $7FE600,x
					LDA #$00
					STA $7FE601,x
					INY
					INY
					INX
					INX
					INX
					CPY #$50
					BNE LOOP_L2
					PLY
					PLX
					RTS
					
FRAME_DAMAGE		LDA $1558,x
					BEQ FRAME_DAMAGE_R
					LDA $97
					BEQ FRAME_DAMAGE2
					LDA $96
					CMP #$58
					BCC FRAME_DAMAGE2
FRAME_DAMAGE_R		RTS
FRAME_DAMAGE2		DEC $94
					DEC $94
					LDA $1497
                    BNE FRAME_DAMAGE_R
					JSL $00F5B7             ; hurt mario
					RTS

					
LASER_DAMAGE		LDA $97
					BEQ LASER_DAMAGE_R
					LDA $E4,x
					PHA
					LDA $14E0,x
					PHA
					LDA $D8,x
					PHA
					LDA $14D4,x
					PHA
					LDA $96
					SEC
					SBC #$20
					LSR A
					STA $0F
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					STZ $14E0,x
					PHX
					LDA $0F
					CLC
					ADC $0F
					CLC
					ADC $0F
					TAX
					LDA $7FE504,x
					STA $0F
					PLX
					LDA #$F0
					SEC
					SBC $0F
					STA $E4,x
					LDA $1497
                    BNE LASER_DAMAGE_R2
					JSL $01A7DC
					BCC LASER_DAMAGE_R2
					JSL $00F5B7             ; hurt mario
LASER_DAMAGE_R2		PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
LASER_DAMAGE_R		RTS

TILE_CHANGE			LDA #$01
					STA $7FC202
					LDA #$70
					STA $9A
					STZ $9B
					LDA #$50
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0B70
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					STZ $9B
					LDA #$60
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0B70
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					STZ $9B
					LDA #$70
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0682
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
TILE_CHANGE2		LDA #$70
					STA $9A
					STZ $9B
					LDA #$60
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$037F
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
TILE_CHANGE3		LDA #$70
					STA $9A
					STZ $9B
					LDA #$60
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0B70
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
END_CHECK			LDA $1528,x
					CMP #$14
					BNE END_CHECK_R
					LDA #$1E
					STA $1DFB
					LDA #$0B
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $7FFD05
END_CHECK_R			RTS



GAGE_RESET			LDA #$01
					STA $7FFFDF
					LDA #$0B
					STA $7FFFE0
					LDA #$18
					STA $7FFFE1
					LDA #$1C
					STA $7FFFE2
					LDA #$1C
					STA $7FFFE3
					LDA #$FC
					STA $7FFFE4
					LDA #$44
					STA $7FFFE5
					LDA #$44
					STA $7FFFE6
					LDA #$44
					STA $7FFFE7
					LDA #$44
					STA $7FFFE8
					LDA #$44
					STA $7FFFE9
					LDA #$44
					STA $7FFFEA
					LDA #$44
					STA $7FFFEB
					LDA #$44
					STA $7FFFEC
					LDA #$FC
					STA $7FFFED
					LDA #$FC
					STA $7FFFEE
					LDA #$FC
					STA $7FFFEF
					RTS

GAGE_CHECK			LDA $1528,x
					CMP #$06
					BEQ GAGE_CHECK4
					CMP #$08
					BEQ GAGE_CHECK5
					CMP #$0A
					BEQ GAGE_CHECK6
					CMP #$0C
					BEQ GAGE_CHECK7
					CMP #$0E
					BEQ GAGE_CHECK8
					CMP #$10
					BEQ GAGE_CHECK9
					CMP #$12
					BEQ GAGE_CHECKA
					CMP #$14
					BEQ GAGE_CHECKB
					RTS
GAGE_CHECK4			LDA #$FC
					STA $7FFFEC
					RTS
GAGE_CHECK5			LDA #$FC
					STA $7FFFEB
					RTS
GAGE_CHECK6			LDA #$FC
					STA $7FFFEA
					RTS
GAGE_CHECK7			LDA #$FC
					STA $7FFFE9
					JSR GAGE_COLOR
					RTS
GAGE_CHECK8			LDA #$FC
					STA $7FFFE8
					RTS
GAGE_CHECK9			LDA #$FC
					STA $7FFFE7
					RTS
GAGE_CHECKA			LDA #$FC
					STA $7FFFE6
					RTS
GAGE_CHECKB			LDA #$FC
					STA $7FFFE5
					RTS




