;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; STAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
EXTRA_BITS = $7FAB10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA $010B
					CMP #$78
					BEQ ITEM_INIT
					CMP #$79
					BEQ BOSS_INIT
					LDA #$10
					STA $15AC,x
					LDA $E4,x
					ORA #$08
					STA $E4,x
					RTL
ITEM_INIT			LDA #$01
					STA $1504,x
					LDA #$10
					STA $15AC,x
					STZ $14AF
					LDA #$19
					STA $1686,x
					RTL
BOSS_INIT			LDA #$80
					STA $D8,x
					LDA #$FF
					STA $14D4,x
					LDA #$70
					STA $E4,x
					LDA #$00
					STA $14E0,x
					LDA #$03 ;#Nbp[h
					STA $C2,x
					LDA #$1F
					STA $7FFFDD ;BG1pGFX^Cw
					JSL $03DD7D ;[`BBG1FFiGFX^C̉E^CjŖ߂܂BƂĂ܂
					LDA #$20
					STA $38
					STA $39
					LDA #$22
					STA $1DFB
					LDA #$02
					STA $1504,x
					LDA #$FF
					STA $15AC,x
					STZ $C2,x
					LDA #$01
					STA $1602,x
					LDA #$07
					STA $1662,x
					LDA #$13
					STA $167A,x
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  |
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR STAR
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR ITEM_MAIN
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR BOSS_MAIN
					RTS
MAIN3				CMP #$03
					BNE MAIN4
					JSR BOSS_ITEM
					RTS
MAIN4				CMP #$04
					BNE MAIN5
					JSR STAR_ENE
					RTS
MAIN5


RETURN				RTS
STAR				LDA $C2,x
					CMP #$02
					BCS STAR_0
					JSR SUB_GFX_STAR
					BRA STAR_MAIN
STAR_0				CMP #$04
					BCS STAR_1
					JSR SUB_GFX_STAR1
					BRA STAR_MAIN
					RTS
STAR_1				JSR SUB_GFX_STAR2
STAR_MAIN			LDA $9D
					BNE RETURN
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $15AC,x
					BEQ STAR_2
					STZ $15AC,x
					JSR STAR_CHECK
					RTS
STAR_2				LDA $1540,x
					BNE RETURN
					JSR STAR_SUB
					RTS
ITEM_MAIN			JSR SUB_GFX_ITEM
					LDA $9D
					BNE ITEM_MAIN_R
					LDA $15AC,x
					BEQ ITEM_2
					STZ $15AC,x
					LDA $95
					STA $1463
					STZ $1462
					LDA $95
					INC A
					ASL A
					ASL A
					ASL A
					ASL A
					STA $00
					LDA $1420
					AND $00
					BNE ITEM_DEL
					LDA $95
					STA $C2,x
ITEM_2				JSL $01802A
					LDA $14D4,x
					BEQ ITEM_MAIN_R
					LDA $D8,x
					CMP #$30
					BCC ITEM_MAIN_R
					LDA $95
					INC A
					ASL A
					ASL A
					ASL A
					ASL A
					STA $00
					LDA $1420
					ORA $00
					STA $1420
ITEM_DEL			LDA #$06
					STA $71
					STZ $89
					STZ $88
					STZ $14C8,x
ITEM_MAIN_R			RTS
					
SUB_GFX_STAR		JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$48
					STA $0302,y
					LDA #$04
					ORA $64
					STA $0303,y
					LDY #$02
                    LDA #$00
                    JSL $01B7B3
                    RTS
					
STAR_CHECK			LDA $14E0,x
					CMP #$05
					BEQ STAR_CHECK_1
					CMP #$07
					BEQ STAR_CHECK_2
					CMP #$08
					BEQ STAR_CHECK_02
					CMP #$0B
					BEQ STAR_CHECK_3
					CMP #$0A
					BEQ STAR_CHECK_4
					CMP #$0C
					BEQ STAR_CHECK_5
					CMP #$0D
					BEQ STAR_CHECK_6
					CMP #$0E
					BEQ STAR_CHECK_05
					CMP #$0F
					BEQ STAR_CHECK_06
					CMP #$10
					BEQ STAR_CHECK_03
					CMP #$11
					BEQ STAR_CHECK_00
					RTS
STAR_CHECK_1		LDA $14D4,x
					BNE STAR_CHECK_00
					BRA STAR_CHECK_03
STAR_CHECK_2		LDA $D8,x
					CMP #$30
					BEQ STAR_CHECK_03
					BRA STAR_CHECK_00
STAR_CHECK_3		LDA $D8,x
					CMP #$90
					BEQ STAR_CHECK_05
					LDA $E4,x
					CMP #$08
					BEQ STAR_CHECK_07
					BRA STAR_CHECK_03
STAR_CHECK_4		LDA $D8,x
					CMP #$A0
					BEQ STAR_CHECK_06
					BRA STAR_CHECK_04
STAR_CHECK_5		LDA $D8,x
					CMP #$30
					BEQ STAR_CHECK_01
					BRA STAR_CHECK_03
STAR_CHECK_6		LDA $D8,x
					CMP #$40
					BEQ STAR_CHECK_05
					BRA STAR_CHECK_03
					
STAR_CHECK_00		STZ $C2,x
					RTS
STAR_CHECK_01		LDA #$01
					STA $C2,x
					RTS
STAR_CHECK_02		LDA #$02
					STA $C2,x
					RTS
STAR_CHECK_03		LDA #$03
					STA $C2,x
					RTS
STAR_CHECK_04		LDA #$04
					STA $C2,x
					RTS
STAR_CHECK_05		LDA #$05
					STA $C2,x
					RTS
STAR_CHECK_06		LDA #$06
					STA $C2,x
					RTS
STAR_CHECK_07		LDA #$07
					STA $C2,x
					RTS

					
BOSS_MAIN			JSR GET_DRAW_INFO
					JSR SUB_GFX_STAR_S
					JSR BACK_GROUND ;wipXvCg̕`ł
					JSR DAMAGE
					LDA $E4,x
					CLC
					ADC #$08
					STA $7FFDE4
					LDA $14E0,x
					ADC #$00
					STA $7FFDE0
					LDA $D8,x
					CLC
					ADC #$38
					STA $7FFDD8
					LDA $14D4,x
					ADC #$00
					STA $7FFDD4
					LDA #$90
					STA $2A
					LDA #$C8
					STA $2C
					;LDA #$30
					;STA $64
					JSR GRAPHIC_ROUTINE
					JSR GRAPHIC ;Nbp̃OtBbNwł
					;JSL $03DEDF ;̓IWił
					LDA $9D
					BNE BOSS_R
					;STZ $149F ;#ss
					JSL $018022		;x speed
					JSL $01801A		;y speed
					JSR MODE_DO
BOSS_R				RTS


BOSS_ITEM			;JSR SUB_GFX_ITEM
					JSR CIRCLE
					LDA $9D
					BNE BOSS_ITEM_R
					LDA $7FFDDE
					CMP #$01
					BNE BOSS_ITEM_1
					JSR BOSS_MODE2
					BRA BOSS_ITEM_0
BOSS_ITEM_1			LDA $7FFDE4
					STA $E4,x
					LDA $7FFDE0
					STA $14E0,x
					LDA $7FFDD8
					STA $D8,x
					LDA $7FFDD4
					STA $14D4,x
BOSS_ITEM_0			LDA $C2,x
					BEQ BOSS_ITEM_2
					CMP #$01
					BEQ BOSS_ITEM_3
					CMP #$03
					BEQ BOSS_ITEM_4
BOSS_ITEM_R			RTS
BOSS_ITEM_2			LDA $7FFF28
					CMP #$01
					BEQ BOSS_ITEM_DEL
					RTS
BOSS_ITEM_3			LDA $7FFF28
					CMP #$02
					BEQ BOSS_ITEM_DEL
					RTS
BOSS_ITEM_4			LDA $7FFF28
					CMP #$03
					BEQ BOSS_ITEM_DEL
					RTS
BOSS_ITEM_DEL		PHX
					LDA $C2,x
					TAX
					LDA $7FFA00,x
					STA $00
					LDA $7FFA10,x
					STA $01
					LDA $7FFA20,x
					STA $02
					LDA $7FFA30,x
					STA $03
					PLX
					LDA $00
					STA $E4,x
					LDA $01
					STA $14E0,x
					LDA $02
					STA $D8,x
					LDA $03
					STA $14D4,x
					JSR SUB_SMOKE
					STZ $14C8,x
					RTS

STAR_ENE			JSR SUB_GFX_STAR_S
					LDA $9D
					BNE SAR_ENE_R
					JSL $018022 ;x speed
					JSL $01801A ;y speed
					JSL $01A7DC
					LDA $1540,x
					BNE SAR_ENE_R
					STZ $14C8,x
SAR_ENE_R			RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE_DO_R			RTS
MODE_DO				LDA $9D
					BNE MODE_DO_R
					LDA $C2,x
					BNE MODE_DO1
					JSR MODE0
					RTS
MODE_DO1			CMP #$01
					BNE MODE_DO2
					JSR MODE1
					RTS
MODE_DO2			CMP #$02
					BNE MODE_DO3
					JSR MODE2
					RTS
MODE_DO3			

MODE0				LDA #$08
					STA $AA,x
					LDA $15AC,x
					CMP #$FD
					BNE MODE0_1
					JSR GFX_LOAD
					JSR PALETE1
MODE0_1				CMP #$4C
					BEQ MODE0_G1
					CMP #$30
					BEQ MODE0_G2
					CMP #$14
					BEQ MODE0_G3
					CMP #$10
					BCC MODE0_2
					CMP #$20
					BCC MODE0_3
					JSR ROTATE
MODE0_3				JSR ROTATE
MODE0_2				JSR ROTATE
MODE0_R				RTS
MODE0_G1			JSR MODE0_G
					RTS
MODE0_G2			JSR MODE0_G
					LDA #$01
					STA $00C2,y
					RTS
MODE0_G3			JSR MODE0_G
					LDA #$03
					STA $00C2,y
					RTS
MODE0_G				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$28
					STA $187B,y
					LDA #$04
					STA $1540,y
					LDA #$13
					STA $167A,y
					RTS
					
MODE1				JSR BLK_CHECK
					LDA $15AC,x
					BNE MODE1_R
					LDA #$20
					STA $15AC,x
					LDA #$2B
					STA $1DFC
					JSL $01ACF9 ;#_֐
					CLC
					ADC $94
					AND #$0F
					CMP #$04
					BCC MODE1_1
					JSR GEN_SPRITE
					LDA #$13
					STA $167A,y
					LDA #$80
					STA $1540,y
					LDA #$04
					STA $1504,y
					JSL $01ACF9
					AND #$07
					STA $1570,y
					BRA MODE1_2
MODE1_1				JSR GEN_NORMAL
					LDA #$C0
					STA $1540,y
					LDA #$A0
					STA $1686,y
MODE1_2				LDA #$30
					STA $00AA,y
					JSL $01ACF9
					SEC
					SBC $94
					SEC
					SBC #$60
					STA $00D8,y
					LDA #$00
					SBC #$00
					STA $14D4,y
					JSL $01ACF9
					AND #$01
					BNE MODE1_3
					LDA #$00
					STA $00E4,y
					LDA #$01
					STA $14E0,y
					LDA #$D0
					STA $00B6,y
MODE1_R				RTS
MODE1_3				LDA #$F0
					STA $00E4,y
					LDA #$FF
					STA $14E0,y
					LDA #$30
					STA $00B6,y
					RTS
					
MODE2_A				INC $38
					INC $38
					INC $39
					INC $39
					RTS
MODE2_B				DEC $38
					DEC $38
					DEC $39
					DEC $39
					RTS
MODE2				JSR BLK_CHECK
					LDA $157C,x
					BNE MODE2_1
					LDA $15AC,x
					CMP #$DC
					BEQ MODE2_G1
					CMP #$C0
					BEQ MODE2_G2
					CMP #$A4
					BEQ MODE2_G3
					CMP #$80
					BEQ MODE2_2
					RTS
MODE2_1				LDA $1540,x
					BNE MODE2_0
					LDA $15AC,x
					BEQ MODE2_3
					JSR MODE2_MOVE
					RTS
MODE2_0				CMP #$70
					BCS MODE2_R
					CMP #$58
					BCS MODE2_A
					CMP #$40
					BCS MODE2_B
					CMP #$01
					BEQ MODE2_4
MODE2_R				RTS
MODE2_2				LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $157C,x
					LDA #$20
					STA $AA,x
					STA $B6,x
					RTS
MODE2_G1			LDA #$01
					STA $7FFDDD
					JSR MODE2_G
					RTS
MODE2_G2			JSR MODE2_G
					LDA #$01
					STA $00C2,y
					RTS
MODE2_G3			JSR MODE2_G
					LDA #$03
					STA $00C2,y
					RTS
MODE2_G				JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					LDA #$28
					STA $187B,y
					LDA #$04
					STA $1540,y
					LDA #$13
					STA $167A,y
					RTS
MODE2_4				LDA $7FFDB6
					STA $B6,x
					LDA $7FFDAA
					STA $AA,x
					LDA #$00
					STA $7FFDDE
					LDA #$FF
					STA $15AC,x
					LDA #$20
					STA $38
					STA $39
					RTS
MODE2_3				LDA $B6,x
					STA $7FFDB6
					LDA $AA,x
					STA $7FFDAA
					STZ $AA,x
					STZ $B6,x
					LDA #$01
					STA $7FFDDE
					LDA #$80
					STA $1540,x
					RTS

					
BOSS_MODE2_TBL1		dcb $00,$D0,$30,$30
BOSS_MODE2_TBL2		dcb $30,$00,$00,$00
BOSS_MODE2			LDA $15AC,x
					BNE BOSS_MODE2_2
					LDA #$80
					STA $15AC,x
BOSS_MODE2_R		RTS
BOSS_MODE2_2		CMP #$58
					BCS BOSS_MODE2_R
					CMP #$2C
					BCC BOSS_MODE2_3
					LDA $C2,x
					TAY
					LDA BOSS_MODE2_TBL1,y
					STA $B6,x
					LDA BOSS_MODE2_TBL2,y
					STA $AA,x
					JSL $01802A
					RTS
BOSS_MODE2_3		LDA $C2,x
					TAY
					LDA BOSS_MODE2_TBL1,y
					EOR #$FF
					;INC A
					STA $B6,x
					LDA BOSS_MODE2_TBL2,y
					EOR #$FF
					;INC A
					STA $AA,x
					JSL $01802A
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE2_MOVE			LDA $E4,x
					CMP #$10
					BCS MODE2_MOVE_1
					LDA #$20
					STA $B6,x
					BRA MODE2_MOVE_2
MODE2_MOVE_1		CMP #$D0
					BCC MODE2_MOVE_2
					LDA #$E0
					STA $B6,x
MODE2_MOVE_2		LDA $D8,x
					CMP #$04
					BCS MODE2_MOVE_3
					LDA #$20
					STA $AA,x
MODE2_MOVE_R		RTS
MODE2_MOVE_3		CMP #$70
					BCC MODE2_MOVE_R
					LDA #$E0
					STA $AA,x
					RTS


DAMAGE				LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$18
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					JSL $01A7DC
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

BLK_CHECK			LDA $E4,x
					PHA
					SEC
					SBC #$10
					STA $E4,x
					LDA $14E0,x
					PHA
					SBC #$00
					STA $14E0,x
					LDA $D8,x
					PHA
					CLC
					ADC #$18
					STA $D8,x
					LDA $14D4,x
					PHA
					ADC #$00
					STA $14D4,x
					
					LDY #$00
BLK_CHECK_LOOP		LDA $14C8,y
					CMP #$08
					BCC BLK_CHECK_1
					LDA $009E,y
					CMP #$53
					BNE BLK_CHECK_1
					LDA $00E4,y
					SEC
					SBC $E4,x
					STA $00
					BCC BLK_CHECK_1
					LDA $14E0,y
					SBC $14E0,x
					BNE BLK_CHECK_1
					LDA $00
					CMP #$40
					BCS BLK_CHECK_1
					LDA $00D8,y
					SEC
					SBC $D8,x
					STA $00
					BCC BLK_CHECK_1
					LDA $14D4,y
					SBC $14D4,x
					BNE BLK_CHECK_1
					LDA $00
					CMP #$40
					BCS BLK_CHECK_1
					LDA $00B6,y
					CMP #$30
					BEQ BLK_CHECK_1
					CMP #$D0
					BEQ BLK_CHECK_1
					LDA #$00
					STA $14C8,y
					LDA #$03
					STA $1DF9
					LDA $7FFF28
					INC A
					STA $7FFF28
					CMP #$04
					BCS BLK_CHECK_2
					BRA BLK_CHECK_1
BLK_CHECK_2			LDA #$28
					STA $1DFC
					LDA #$20
					STA $1887
					INC $C2,x
					LDA #$FF
					STA $15AC,x
BLK_CHECK_1			INY
					CPY #$0A
					BCC BLK_CHECK_LOOP
					PLA
					STA $14D4,x
					PLA
					STA $D8,x
					PLA
					STA $14E0,x
					PLA
					STA $E4,x
					RTS

GFX_LOAD			LDA #$80
					STA $7FC006
					LDA #$FF
					STA $7FC007
					LDA #$7F
					STA $7FC008
					LDA #$42
					STA $7FC009 ;#gAjpGFXǂݍ݃tO
					REP #$30
					LDA.W #$01D4 ;#ǂݍExGFX^Cԍ
					STA $7FFF90
					SEP #$30
					JSL $0FF780 ;#$7EAD00`$7EBCFFGFXf[^ǂݍ
					
					REP #$20
					LDA.W #$7000
					STA $00
					LDA.W #$AD00
					STA $02
					LDA.W #$1000
					STA $04
					SEP #$20
					JSR VRAM
					RTS


VRAM				LDA #$80
					STA $2115
					REP #$20
					LDA $00
					STA $2116
					SEP #$20
					LDA #$01 
					STA $4310
					LDA #$18
					STA $4311
					LDA #$7E
					STA $4314
					REP #$20
					LDA $02
					STA $4312
					LDA $04
					STA $4315
					SEP #$20
					LDA #$02
					STA $420B
					RTS
					
PALETE1_TBL1		dcb $E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
					dcb $F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF
					dcb $91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D
					dcb $B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD
					dcb $01,$02,$03,$04,$05,$06,$07
PALETE1_TBL2		dcb $1B,$1B,$FB,$5B,$9B,$DB,$1B,$3B,$5B,$9B,$DB,$1B,$3B,$7B,$BB
					dcb $B9,$B7,$B4,$B1,$AF,$8E,$8B,$88,$80,$80,$80,$80,$80,$61,$41
					dcb $FF,$11,$D5,$98,$9A,$DE,$9E,$0A,$4E,$33,$25,$88,$D3
					dcb $FF,$1A,$5D,$FE,$5C,$BD,$1E,$23,$A6,$D0,$B5,$39,$9C
					dcb $C7,$29,$11,$5C,$FF,$FF,$00
PALETE1_TBL3		dcb $1C,$00,$00,$01,$01,$01,$02,$02,$02,$02,$02,$03,$03,$03,$03
					dcb $03,$03,$03,$03,$03,$03,$03,$03,$03,$1B,$2F,$3F,$5B,$67,$6B
					dcb $7F,$75,$79,$7E,$45,$59,$66,$6E,$72,$77,$3B,$47,$63
					dcb $7F,$13,$13,$33,$16,$2E,$43,$67,$77,$7B,$56,$67,$73
					dcb $04,$15,$1E,$2B,$2B,$3F,$00

PALETE1				LDY #$00
PALETE1_LOOP		LDA PALETE1_TBL1,y
					STA $2121
					LDA PALETE1_TBL2,y
					STA $2122
					LDA PALETE1_TBL3,y
					STA $2122
					INY
					CPY #$3F
					BCC PALETE1_LOOP
					RTS
					
ROTATE				LDA $1602,x
					AND #$10
					BNE ROTATE_2
					LDA $38
					CMP #$30
					BCC ROTATE_0
					CMP #$40
					BCC ROTATE_01
					CMP #$80
					BCC ROTATE_02
					INC $38
					INC $38
					INC $38
					INC $38
					INC $38
					INC $38
					INC $38
					INC $38
ROTATE_02			INC $38
					INC $38
					INC $38
					INC $38
ROTATE_01			INC $38
ROTATE_0			INC $38
					LDA $38
					CMP #$E0
					BCS ROTATE_1
					RTS
ROTATE_1			LDA $1602,x
					ORA #$10
					EOR #$01
					STA $1602,x
					RTS
ROTATE_2			LDA $38
					CMP #$30
					BCC ROTATE_3
					CMP #$40
					BCC ROTATE_31
					CMP #$80
					BCC ROTATE_32
					DEC $38
					DEC $38
					DEC $38
					DEC $38
					DEC $38
					DEC $38
					DEC $38
					DEC $38
ROTATE_32			DEC $38
					DEC $38
					DEC $38
					DEC $38
ROTATE_31			DEC $38
ROTATE_3			DEC $38
					LDA $38
					CMP #$21
					BCC ROTATE_4
					RTS
ROTATE_4			LDA $1602,x
					AND #$0F
					STA $1602,x
					LDA $15AC,x
					BNE ROTATE_R
					LDA $C2,x
					BNE ROTATE_R
					LDA $1602,x
					AND #$01
					BNE ROTATE_R
					STZ $1602,x
					LDA #$01
					STA $C2,x
					STZ $AA,x
					LDA #$80
					STA $15AC,x
ROTATE_R			RTS
					
					
CIRCLE				LDA $9D
					BNE LABEL92
					LDA $7FFDDE
					CMP #$01
					BEQ LABEL92
					LDA #$06 ;#]x
					CLC
                    ADC $1602,x
                    STA $1602,x
                    LDA #$00
                    ADC $151C,x
                    AND #$01
                    STA $151C,x
LABEL92             LDA $151C,x
                    STA $01
                    LDA $1602,x
                    STA $00
                    REP #$30
                    LDA $00
                    CLC
                    ADC.W #$0080
                    AND.W #$01FF
                    STA $02
                    LDA $00
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $04
                    LDA $02
                    AND.W #$00FF
                    ASL A
                    TAX
                    LDA $07F7DB,x
                    STA $06
                    SEP #$30
                    LDX $15E9
                    LDA $04
                    STA $4202
					LDA $7FFDDD
					CMP #$01
					BEQ LABEL921
					LDA $187B,x
					BRA LABEL922
LABEL921            LDA $187B,x ;#a
					LSR A
					LSR A
					LSR A
LABEL922            LDY $05
                    BNE LABEL93
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL93             LSR $01
                    BCC LABEL94
                    EOR #$FF                ; \ reverse direction of rotation
                    INC A                   ; /
LABEL94             STA $04
                    LDA $06
                    STA $4202
					LDA $7FFDDD
					CMP #$01
					BNE LABEL941
					LDA $187B,x
					BRA LABEL942
LABEL941            LDA $187B,x ;#a
					LSR A
					LSR A
LABEL942            LDY $07
                    BNE LABEL95
                    STA $4203
                    ASL $4216
                    LDA $4217
                    ADC #$00
LABEL95             LSR $03
                    BCC LABEL96
                    EOR #$FF
                    INC A
LABEL96             STA $06
                    LDA $E4,x
                    PHA
                    LDA $14E0,x
                    PHA
                    LDA $D8,x
                    PHA
                    LDA $14D4,x
                    PHA
                    LDY $0F86,x
                    STZ $00
                    LDA $04
                    BPL LABEL97
                    DEC $00
LABEL97             CLC
                    ADC $E4,x
                    STA $E4,x
                    PHP
                    PHA
                    SEC
                    SBC $1534,x
                    STA $1528,x
                    PLA
                    STA $1534,x
                    PLP
                    LDA $14E0,x
                    ADC $00
                    STA $14E0,x
                    STZ $01
                    LDA $06
                    BPL LABEL98
                    DEC $01
LABEL98             CLC
                    ADC $D8,x
                    STA $D8,x
                    LDA $14D4,x
                    ADC $01
                    STA $14D4,x
					
					LDA $7FFDDD
					CMP #$01
					BNE LABEL9A
					LDA $C2,x
					BEQ LABEL9A
					CMP #$01
					BNE LABEL99
					LDA $E4,x
					CLC
					ADC $06
					STA $E4,x
					LDA $14E0,x
					ADC $01
					STA $14E0,x
					BRA LABEL9A
LABEL99				LDA $E4,x
					SEC
					SBC $06
					STA $E4,x
					LDA $14E0,x
					SBC $01
					STA $14E0,x
LABEL9A             LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					PHX
					LDA $C2,x
					TAX
					LDA $00
					STA $7FFA00,x
					LDA $01
					STA $7FFA10,x
					LDA $02
					STA $7FFA20,x
					LDA $03
					STA $7FFA30,x
					PLX
					JSR SUB_GFX_ITEM
					LDA $9D
					BNE LABEL9B
					JSL $01A7DC
					LDA $1540,x
					BEQ LABEL9B
					STZ $1540,x
					JSR SUB_SMOKE
LABEL9B             PLA     
                    STA $14D4,x
                    PLA        
                    STA $D8,x  
                    PLA        
                    STA $14E0,x
                    PLA        
                    STA $E4,x                   
                    RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


HORZ_STAR			dcb $F8,$08
PROP_STAR			dcb $0F,$4F,$8F,$CF

SUB_GFX_STAR		JSR GET_DRAW_INFO
					STZ $02
					LDA $C2,x
					BEQ SUB_GFX_STAR_2
					LDA #$02
					STA $02
SUB_GFX_STAR_2		PHX
					LDX #$01
GFX_STAR_LOOP		LDA #$A4
					STA $0302,y
					LDA $00
					CLC
					ADC HORZ_STAR,x
					STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA PROP_STAR,x
					ORA $64
					STA $0303,y
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL GFX_STAR_LOOP

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
VERT_STAR1			dcb $08,$F8
PROP_STAR1			dcb $0F,$8F,$4F,$CF

SUB_GFX_STAR1		JSR GET_DRAW_INFO
					STZ $02
					LDA $C2,x
					CMP #$02
					BEQ SUB_GFX_STAR1_2
					LDA #$02
					STA $02
SUB_GFX_STAR1_2		PHX
					LDX #$01
GFX_STAR1_LOOP		LDA #$88
					STA $0302,y
					LDA $01
					CLC
					ADC VERT_STAR1,x
					STA $0301,y
					LDA $00
					STA $0300,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA PROP_STAR1,x
					ORA $64
					STA $0303,y
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL GFX_STAR1_LOOP

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$01
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILE_ITEM			dcb $08,$0A,$0C,$0C
PROP_ITEM			dcb $09,$0B,$05,$05
SUB_GFX_ITEM		JSR GET_DRAW_INFO
					LDA $64
					STA $02
					LDA $7FFDDD
					CMP #$01
					BNE SUB_GFX_ITEM_0
					LDA $151C,x
					BNE SUB_GFX_ITEM_3
					BRA SUB_GFX_ITEM_2
SUB_GFX_ITEM_0		LDA $151C,x
					BNE SUB_GFX_ITEM_1
					LDA $1602,x
					CMP #$80
					BCC SUB_GFX_ITEM_3
					BRA SUB_GFX_ITEM_2
SUB_GFX_ITEM_1		LDA $1602,x
					CMP #$80
					BCS SUB_GFX_ITEM_3
SUB_GFX_ITEM_2		STZ $02
					BRA SUB_GFX_ITEM_3
SUB_GFX_ITEM_3		PHX
					LDA $C2,x
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILE_ITEM,x
					STA $0302,y
					LDA PROP_ITEM,x
					ORA $02
					STA $0303,y
					PLX
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

TILE_STAR			dcb $84,$86,$A6
HORZ_STAR2			dcb $F8,$08,$08
					dcb $08,$F8,$F8
					dcb $F8,$08,$08
					dcb $08,$F8,$F8
VERT_STAR2			dcb $F8,$F8,$08
					dcb $F8,$F8,$08
					dcb $08,$08,$F8
					dcb $08,$08,$F8
PROP_STAR2			dcb $0F,$0F,$0F
					dcb $4F,$4F,$4F
					dcb $8F,$8F,$8F
					dcb $CF,$CF,$CF

SUB_GFX_STAR2		JSR GET_DRAW_INFO
					LDA $C2,x
					SEC
					SBC #$04
					STA $02
					ASL A
					CLC
					ADC $02
					STA $02
					PHX
					LDX #$02
GFX_STAR2_LOOP		LDA TILE_STAR,x
					STA $0302,y
					PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA $01
					CLC
					ADC VERT_STAR2,x
					STA $0301,y
					LDA $00
					CLC
					ADC HORZ_STAR2,x
					STA $0300,y
					LDA PROP_STAR2,x
					ORA $64
					STA $0303,y
					PLX
                    INY                     ; | increase index to sprite tile map ($300)...
                    INY                     ; |    ...we wrote 1 16x16 tile...
                    INY                     ; |    ...sprite OAM is 8x8...
                    INY                     ; |    ...so increment 4 times
                    DEX                     ; | go to next tile of frame and loop
                    BPL GFX_STAR2_LOOP

                    PLX                     ; pull, X = sprite index
                    LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
					
TILE_STAR_S			dcb $28,$2A,$2C,$2E,$28,$2A,$2C,$2E
PROP_STAR_S			dcb $03,$03,$03,$03,$07,$07,$07,$07
SUB_GFX_STAR_S		LDA $1570,x
					AND #$07
					TAY
					LDA TILE_STAR_S,y
					STA $02
					LDA PROP_STAR_S,y
					STA $03
					JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA $02
					STA $0302,y
					LDA $03
					ORA $64
					STA $0303,y
					LDY #$02               ; \ we've already set 460 so use FF
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS

X_SPEED				dcb $00,$00,$A0,$60,$60,$A0,$60,$A0
Y_SPEED				dcb $A0,$60,$00,$00,$C0,$A0,$60,$60

STAR_SUB			JSL $01A7DC
					BCC STAR_SUB_R
					LDA #$18
					STA $1540,x
					LDA #$40
					STA $7FFFAC
					LDA $14E0,x
					CMP #$0B
					BCC STAR_SUB_2
					LDA #$80
					STA $7FFFAC
STAR_SUB_2			LDA $C2,x
					TAY
					LDA X_SPEED,y
					STA $7FFF7B
					LDA Y_SPEED,y
					STA $7FFF7D
					LDA #$09
					STA $1DFC
					JSR SUB_SMOKE
					LDA $E4,x
					STA $94
					LDA $14E0,x
					STA $95
					LDA $D8,x
					SEC
					SBC #$10
					STA $96
					LDA $14D4,x
					SBC #$00
					STA $97
STAR_SUB_R			RTS

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
					LDY #$00
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS
					
					
BACK_GROUND         ;XvCgœy`Ă܂
					PHX
					LDY #$10
					STZ $01
					LDA $190D
					STA $0F
					LDX #$0F	 ;#1ڂ̕`
BG_LOOP2			LDA #$C0
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA $01
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					CLC
					ADC #$10
					STA $01		;#xW10₷
					LDA #$0E	;#GFX^C
					STA $0202,y
					LDA #$0D
					ORA $64
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP2
					LDX #$0F	 ;#2ڂ̕`
BG_LOOP3			LDA #$D0
					SEC
					SBC $1C		;#ʈʒuyW
					STA $0201,y
					LDA $01
					SEC
					SBC $1A		;#ʈʒuxW
					STA $0200,y
					CLC
					ADC #$10
					STA $01		;#xW10₷
					LDA #$0E	;#GFX^C
					STA $0202,y
					LDA #$0F
					ORA $64
					STA $0203,y
					PHY
					TYA
					LSR A
					LSR A
					TAY
					LDA #$02
					STA $0420,y
					PLY
					INY
					INY
					INY
					INY
					DEX
					BPL BG_LOOP3
					PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GRAPHIC_ROUTINE		LDA $14E0,x		;A:87C8 X:0009 Y:0004 P:eNvMXdizC
					XBA				;A:8700 X:0009 Y:0004 P:envMXdiZC
					LDA $E4,x		;A:0087 X:0009 Y:0004 P:eNvMXdizC
					LDY #$00		;A:00B2 X:0009 Y:0004 P:eNvMXdizC
					JSR SUB_DFAE		;#AxW(16bit)AY=0Ŏs
					LDA $14D4,x
					XBA
					LDA $D8,x
					LDY #$02
					JSR SUB_DFAE		;#AyW(16bit)AY=2Ŏs
					PHX
					REP #$30
					STZ $06
					LDY.W #$0003
					LDA.W $0D9B
					LSR A
					SEP #$30
					PLX
					LDA #$20
					STA $C6C0
					RTS

SUB_DFAE			PHX
					TYX
					REP #$20
					EOR #$FFFF
					INC A
					CLC
					ADC $03DEBB,x
					CLC
					ADC $1A,x ;#(xWȂ1A yWȂȂ2C)
					STA $3A,x
					SEP #$20
					PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHIC_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Nbp͑Ŝ64x96sNZ̃TCY8x8TCYŃOtBbNw肵܂
;l̓^Cԍ~QŁA+1ōE]܂
;ʒuƃAhX͉̃e[u̒ʂł
;C6C0	C6C1	C6C2	C6C3	C6C4	C6C5	C6C6	C6C7
;C6C8	C6C9	C6CA	C6CB	C6CC	C6CD	C6CE	C6CF
;C6D0	C6D1	C6D2	C6D3	C6D4	C6D5	C6D6	C6D7
;C6D8	C6D9	C6DA	C6DB	C6DC	C6DD	C6DE	C6DF
;C688	C689	C68A	C68B	C68C	C68D	C68E	C68F
;C690	C691	C692	C693	C694	C695	C696	C697
;C698	C699	C69A	C69B	C69C	C69D	C69E	C69F
;C6A0	C6A1	C6A2	C6A3	C6A4	C6A5	C6A6	C6A7
;C6A8	C6A9	C6AA	C6AB	C6AC	C6AD	C6AE	C6AF
;C6B0	C6B1	C6B2	C6B3	C6B4	C6B5	C6B6	C6B7
;C6B8	C6B9	C6BA	C6BB	C6BC	C6BD	C6BE	C6BF
;C680	C681	C682	C683	C684	C685	C686	C687

GRA_TABLE			dcb $FF,$E2,$FF,$FF,$FF,$FF,$E3,$FF
					dcb $FF,$FF,$FF,$06,$07,$FF,$FF,$FF
					dcb $FF,$FF,$24,$26,$27,$25,$FF,$FF
					dcb $40,$42,$44,$00,$01,$45,$43,$41
					dcb $60,$62,$64,$66,$67,$65,$63,$61
					dcb $FF,$82,$84,$86,$87,$85,$83,$FF
					dcb $FF,$A2,$A4,$A6,$A7,$A5,$A3,$FF
					dcb $FF,$C2,$C4,$C6,$C7,$C5,$C3,$FF
					
					dcb $FF,$E2,$FF,$FF,$FF,$FF,$E3,$FF
					dcb $FF,$FF,$FF,$06,$07,$FF,$FF,$FF
					dcb $FF,$FF,$24,$26,$27,$25,$FF,$FF
					dcb $40,$42,$44,$86,$87,$45,$43,$41
					dcb $60,$62,$64,$86,$87,$65,$63,$61
					dcb $FF,$82,$84,$86,$87,$85,$83,$FF
					dcb $FF,$A2,$A4,$A6,$A7,$A5,$A3,$FF
					dcb $FF,$C2,$C4,$C6,$C7,$C5,$C3,$FF
					
					dcb $FF,$E2,$FF,$FF,$FF,$FF,$E3,$FF
					dcb $FF,$FF,$FF,$06,$07,$FF,$FF,$FF
					dcb $FF,$FF,$24,$26,$27,$25,$FF,$FF
					dcb $40,$42,$44,$46,$47,$45,$43,$41
					dcb $60,$62,$64,$66,$67,$65,$63,$61
					dcb $FF,$82,$84,$86,$87,$85,$83,$FF
					dcb $FF,$A2,$A4,$A6,$A7,$A5,$A3,$FF
					dcb $FF,$C2,$C4,$C6,$C7,$C5,$C3,$FF
					

GRAPHIC				LDA $1602,x
					AND #$0F
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					ASL A
					STA $02
					PHX
					LDX #$00
GRAPHIC_LOOP		PHX
					TXA
					CLC
					ADC $02
					TAX
					LDA GRA_TABLE,x
					PLX
					STA $7EC680,x
					INX
					CPX #$40
					BCC GRAPHIC_LOOP
					PLX
					RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN68            RTS     
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN68            ; / after: Y has index of sprite being generated

                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX

                    LDA $7FFDE4
                    STA $00E4,y

                    LDA $7FFDE0
                    STA $14E0,y             ; /

                    LDA $7FFDD8
                    STA $00D8,y             ;  |
					LDA $7FFDD4
                    STA $14D4,y             ; /

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX                     ; / 
                    RTS
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generate routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURNK61           RTS     
GEN_NORMAL          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURNK61            ; / after: Y has index of sprite being generated

                    LDA #$09                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

                    LDA #$53
                    STA $009E,y
					
					LDA $7FFDE4
                    STA $00E4,y

                    LDA $7FFDE0
                    STA $14E0,y             ; /

                    LDA $7FFDD8
                    STA $00D8,y             ;  |
					LDA $7FFDD4
                    STA $14D4,y             ; /

                    PHX
                    TYX
                    JSL $07F7D2             ;  
                    PLX
                    RTS
