;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mark
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					LDA #$FF
					STA $15AC,x
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					;# GFX05.bin(PCADDR 05DAB5 SNESADDR 0BD8B5)
					;# 30`335AD 5AA4^ČJԂ
					
START_HB_CODE       LDA $15AC,x
					CMP #$80
					BEQ VRAM4
					RTS
					
VRAM4				LDA #$80
					STA $2115
					REP #$20
					LDA.W #$0800
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 ;#levelnameDMA]00ł 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$AD00 ;#Source address
					STA $4312
					LDA.W #$0FE0
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					RTS
					
VRAM3				PHX

					PHA
					REP #$20
					LDA.W #$0080
					PHA
					LDX #$80
					STX $2115
					LDA.W #$1801
					STA $4320
					LDX #$7E
					STX $4324
					LDA $0D78 ;#0300
					STA $2116
					LDA $0D7A ;#AD00 5AD
					STA $4322
					PLA
					STA $4325
					LDX #$04
					STX $420B



					
VRAM2				LDA #$80
					STA $2115
					REP #$20
					LDA.# #$0100
					STA $2116 ;#VRAMAhX
					SEP #$20
					LDA #$01 ;#levelnameDMA]00ł 
					STA $4310
					LDA #$18 ;#VRAM݃f[^($2118)
					STA $4311
					LDA #$7E
					STA $4314 ;#Source bank address
					REP #$20
					LDA.W #$9500 ;#Source address
					STA $4312
					LDA.W #$0080
					STA $4315 ;#]oCg(4bbp 16x16
					LDY #$02
					STY $420B
					SEP #$20
					
					RTS
					
					
					
					
VRAM				PHX ;#pbNȂǂ̃Aj[V
					LDA #$80
					STA $2115
					REP #$20
					LDA.W #$1801
					STA $4320
					LDY #$7E
					STY $4324
					LDX #$04
					LDA $0D80 ;#0600
					BEQ LBL001
					STA $2116
					LDA $0D7A ;#9500
					STA $4322
					LDA.W #$0080
					STA $4325
					STX $420B
LBL001				LDA $0D7E ;#0640
					BEQ LBL002
					STA $2116
					LDA $0D78 ;#9580
					STA $4322
					LDA.W #$0080
					STA $4325
					STX $420B
LBL002				LDA $0D7C ;#0680
					BEQ LBL005
					STA $2116
					CMP.W #$0080
					BEQ LBL004
					LDA $0D76 ;#9600
					STA $4322
					LDA.W #$0080
					STA $4325
					STX $420B
					BRA LBL005
LBL004				;;;;;
LBL005				JSL $10946A
					RTS
					
;$10946A			SEP #$20
					LDA $7FC00A
					CMP #$42
					BNE LBL006
					LDA $14
					AND #$18
					CMP $7FC003
					BNE LBL007
LBL006				LDA #$64
					RTL
LBL007				;;;;;;;;
					RTS
					

					
