;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; C[ŏIXe[W
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 					MARIO_STATUS    = $19 
                    MARIO_X_SPEED   = $7B
                    MARIO_Y_SPEED   = $7D
                    MARIO_X_POS     = $94
                    MARIO_X_POS_HI  = $95
                    MARIO_Y_POS     = $96 
                    MARIO_Y_POS_HI  = $97
                    SPRITE_Y_SPEED  = $AA
                    SPRITE_X_SPEED  = $B6
                    SPRITE_STATE    = $C2       
                    SPRITE_Y_POS    = $D8
                    SPRITE_X_POS    = $E4
                    SPRITE_Y_POS_HI = $14D4
                    SPRITE_X_POS_HI = $14E0
                    SPR_OBJ_STATUS  = $1588
                    SPRITE_OAM      = $15EA
EXTRA_BITS = $7FAB10
NEW_SPRITE_NUM = $7FAB9E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
					STZ $1466
					STZ $1467
					LDA $010B
					CMP #$5C
					BEQ WILY3_2_INIT
					CMP #$5D
					BEQ WILY3_3_INIT
                    RTL
WILY3_2_INIT		LDA #$02
					STA $7FFFA1
					RTL
WILY3_3_INIT		LDA #$04
					STA $7FFFA1
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
HAMMER_BRO_JSL      PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN				RTS
START_HB_CODE		LDA $1504,x
					BNE MAIN1
					JSR MARIO
					RTS
MAIN1				CMP #$01
					BNE MAIN2
					JSR WALL
					RTS
MAIN2				CMP #$02
					BNE MAIN3
					JSR FLAME
					RTS
MAIN3				JSR LEAF
					RTS


MARIO				LDA $0DDA
					CMP #$FF
					BNE MARIO_1
					JSR SUB_GEN2
					STZ $14C8,x
					RTS
MARIO_1				JSR DEFAULT
					JSR MODE_CHANGE
					JSR COLOUR
					JSR FLASH_COLOR
					JSR GENERATE
					LDA $010B
					CMP #$5D
					BEQ MARIO_6
					LDA $7FFFA1
					BNE MARIO_2
					JSR SCRL_CHECK
					RTS
MARIO_2				CMP #$01
					BNE MARIO_3
					JSR SCRL_CHECK2
					RTS
MARIO_3				CMP #$02
					BNE MARIO_4
					JSR SCRL_CHECK3
					RTS
MARIO_4				CMP #$03
					BNE MARIO_5
					JSR SCRL_CHECK4
					RTS
MARIO_5				JSR SCRL_CHECK5
					RTS
MARIO_6				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; WEAPON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WALL				JSR SUB_GFX_W
					LDA $9D
					BNE WALL_R
					JSR SUB_B852
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1558,x
					BNE WALL_R
					JSL $01802A
					LDA $15AC,x
					BEQ WALL_D
					LDA $C2,x
					BEQ WALL_R
					LDA $157C,x
					BNE WALL_2
					LDA $1588,x
					AND #$02
					BNE WALL_D
					LDA $B6,x
					CMP #$D8
					BEQ WALL_1_2
					LDA $14
					AND #$01
					BNE WALL_1_2
					DEC $B6,x
WALL_1_2			LDA $7FFFA8
					BEQ WALL_3
					LDA $1570,x
					BEQ WALL_3
					LDA $77
					AND #$02
					BNE WALL_3
					JSR WALL_MOVE
					BRA WALL_3
WALL_2				LDA $1588,x
					AND #$01
					BNE WALL_D
					LDA $B6,x
					CMP #$28
					BEQ WALL_2_2
					LDA $14
					AND #$01
					BNE WALL_2_2
					INC $B6,x
WALL_2_2			LDA $7FFFA8
					BEQ WALL_3
					LDA $1570,x
					BEQ WALL_3
					LDA $77
					AND #$01
					BNE WALL_3
					JSR WALL_MOVE
					BRA WALL_3
WALL_D				STZ $14C8,x
					JSR SUB_SMOKE
WALL_R				RTS
WALL_3				LDA $1570,x
					STA $7FFFA8
					LDA $E4,x
					STA $7FFFA9
					LDA $14E0,x
					STA $7FFFAA
					LDA $D8,x
					STA $7FFFAB
					LDA $14D4,x
					STA $7FFFAC
					RTS
WALL_MOVE			LDA $E4,x
					SEC
					SBC $7FFFA9
					STA $00
					LDA $14E0,x
					SBC $7FFFAA
					STA $01
					REP #$20
					LDA $94
					CLC
					ADC $00
					STA $94
					SEP #$20
					LDA $D8,x
					SEC
					SBC $7FFFAB
					STA $00
					LDA $14D4,x
					SBC $7FFFAC
					STA $01
					REP #$20
					LDA $96
					CLC
					ADC $00
					STA $96
					SEP #$20
					RTS
					
FLAME				LDA $C2,x
					BNE FLAME_1
					JSR SUB_GFX_FL1
					BRA FLAME_2
FLAME_1				JSR SUB_GFX_FL2
FLAME_2				LDA $9D
					BNE FLAME_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					LDA $1558,x
					BNE FLAME_R
					LDA $C2,x
					BNE FLAME_3
					JSL $01802A
					LDA $1588,x
					AND #$04
					BEQ FLAME_R
					INC $C2,x
					LDA #$17
					STA $1DFC
FLAME_R				RTS
FLAME_3				INC $1570,x
					LDA $1570,x
					CMP #$20
					BEQ FLAME_4
					RTS
FLAME_4				STZ $14C8,x
					RTS

LEAF_SPEED			dcb $C0,$40
LEAF				JSR SUB_GFX_LE1
					LDA $9D
					BNE LEAF_R
					JSL $27FAF4 ;SUB_OFF_SCREEN_X0
					JSR SUB_LEAF
					JSR SUB_LEAF2
					JSR FLAME_CHECK
					LDA $C2,x
					CMP #$01
					BEQ LEAF_2
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$04
					STA $D8,x
					LDA $97
					STA $14D4,x
					ADC #$00
					LDA $15AC,x
					BNE LEAF_R
					LDA $18
					AND #$10
					BEQ LEAF_R
					LDY $76
					LDA LEAF_SPEED,y
					STA $B6,x
					INC $C2,x
LEAF_R				RTS
LEAF_2				LDA $1558,x
					BNE LEAF_R
					JSL $018022
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SCRL_CHECK			LDA $C2,x
					BNE SCRL_CHECK_R
					LDA $1463
					CMP #$04
					BNE SCRL_CHECK_R
					STZ $1462
					STZ $1411
					INC $C2,x
SCRL_CHECK_R		RTS

SCRL_CHECK2			LDA $C2,x
					CMP #$02
					BEQ SCRL_CHECK2_R
					LDA $1463
					CMP #$0C
					BNE SCRL_CHECK2_0
					STZ $1462
					STZ $1411
					INC $C2,x
					RTS
SCRL_CHECK2_0		LDA $7D
					BEQ SCRL_CHECK2_R
					BMI SCRL_CHECK2_1
					REP #$20
					LDA $94
					CMP.W #$0740
					BCS SCRL_CHECK2_3
SCRL_CHECK2_1		REP #$20
					LDA $1462
					CMP.W #$06D1
					BCC SCRL_CHECK2_2
					SEP #$20
					RTS
SCRL_CHECK2_3		SEP #$20
					LDA #$01
					STA $1411
					RTS	
SCRL_CHECK2_2		SEP #$20
					STZ $1411
SCRL_CHECK2_R		RTS

SCRL_CHECK3			LDA $C2,x
					BNE SCRL_CHECK3_R
					LDA $1463
					CMP #$03
					BNE SCRL_CHECK3_R
					STZ $1462
					STZ $1411
					INC $C2,x
SCRL_CHECK3_R		RTS

SCRL_CHECK4			LDA $C2,x
					CMP #$02
					BEQ SCRL_CHECK4_R
					LDA $1463
					CMP #$08
					BNE SCRL_CHECK4_0
					STZ $1462
					STZ $1411
					INC $C2,x
					RTS
SCRL_CHECK4_0		LDA $7D
					BEQ SCRL_CHECK4_R
					BMI SCRL_CHECK4_1
					REP #$20
					LDA $94
					CMP.W #$0640
					BCS SCRL_CHECK4_3
SCRL_CHECK4_1		REP #$20
					LDA $1462
					CMP.W #$05D1
					BCC SCRL_CHECK4_2
					SEP #$20
					RTS
SCRL_CHECK4_3		SEP #$20
					LDA #$01
					STA $1411
					RTS	
SCRL_CHECK4_2		SEP #$20
					STZ $1411
SCRL_CHECK4_R		RTS

SCRL_CHECK5			LDA $1463
					CMP #$12
					BNE SCRL_CHECK5_0
					STZ $1462
					STZ $1411
					STZ $14C8,x
					JSR TELEPORT
					RTS
SCRL_CHECK5_0		LDA $7D
					BEQ SCRL_CHECK5_R
					BMI SCRL_CHECK5_1
					REP #$20
					LDA $94
					CMP.W #$0B40
					BCS SCRL_CHECK5_3
SCRL_CHECK5_1		REP #$20
					LDA $1462
					CMP.W #$0AD1
					BCC SCRL_CHECK5_2
					SEP #$20
					RTS
SCRL_CHECK5_3		SEP #$20
					LDA #$01
					STA $1411
					RTS	
SCRL_CHECK5_2		SEP #$20
					STZ $1411
SCRL_CHECK5_R		RTS


MODE_CHANGE			LDA $18
					AND #$20
					BEQ MODE_CHANGE_R
					INC $1602,x
					LDA $1602,x
					CMP #$01
					BEQ MODE_CHANGE_1
					CMP #$02
					BEQ MODE_CHANGE_2
					CMP #$03
					BEQ MODE_CHANGE_3
					CMP #$04
					BEQ MODE_CHANGE_4
					CMP #$05
					BEQ MODE_CHANGE_5
MODE_CHANGE_R		RTS
MODE_CHANGE_1		LDA $7FFFA1
					BEQ MODE_CHANGE_5
					RTS
MODE_CHANGE_2		LDA $7FFFA1
					CMP #$02
					BCC MODE_CHANGE_5
					RTS
MODE_CHANGE_3		LDA $7FFFA1
					CMP #$03
					BCC MODE_CHANGE_5
					RTS
MODE_CHANGE_4		LDA $7FFFA1
					CMP #$04
					BCS MODE_CHANGE_R
MODE_CHANGE_5		STZ $1602,x
					RTS

COLOUR				LDA $18
					AND #$20
					BEQ COLOUR_R
					LDA $1602,x
					BNE COLOUR_0
					LDA #$00
					STA $7FE200
					STA $7FE300
					RTS
COLOUR_0			JSR HDMA_COLOUR
					LDA $1602,x
					CMP #$01
					BEQ COLOUR_10
					CMP #$02
					BEQ COLOUR_20
					CMP #$03
					BEQ COLOUR_30
					CMP #$04
					BEQ COLOUR_40
					RTS
					LDA #$00
					STA $7FFB18
					STA $7FFB20
COLOUR_R			RTS
COLOUR_10			JSR COLOUR_1
					RTS
COLOUR_20			JSR COLOUR_2
					RTS
COLOUR_30			JSR COLOUR_3
					RTS
COLOUR_40			JSR COLOUR_4
					RTS
COLOUR_1			LDA #$01
					STA $7FE301
					LDA #$28
					STA $7FE302
					LDA #$08
					STA $7FE304
					LDA #$7D
					STA $7FE305
					LDA #$A6
					STA $7FE307
					LDA #$5C
					STA $7FE308
					LDA #$88
					STA $7FE30A
					LDA #$7D
					STA $7FE30B
					LDA #$A3
					STA $7FE30D
					LDA #$77
					STA $7FE30E
					RTS
COLOUR_2			LDA #$B9
					STA $7FE301
					LDA #$09
					STA $7FE302
					LDA #$BF
					STA $7FE304
					LDA #$3A
					STA $7FE305
					LDA #$9E
					STA $7FE307
					LDA #$2E
					STA $7FE308
					LDA #$FF
					STA $7FE30A
					LDA #$0D
					STA $7FE30B
					LDA #$9F
					STA $7FE30D
					LDA #$32
					STA $7FE30E
					RTS
COLOUR_3			LDA #$40
					STA $7FE301
					LDA #$05
					STA $7FE302
					LDA #$01
					STA $7FE304
					LDA #$07
					STA $7FE305
					LDA #$06
					STA $7FE307
					LDA #$0A
					STA $7FE308
					LDA #$A2
					STA $7FE30A
					LDA #$0A
					STA $7FE30B
					LDA #$62
					STA $7FE30D
					LDA #$07
					STA $7FE30E
					RTS
COLOUR_4			LDA #$31
					STA $7FE301
					LDA #$44
					STA $7FE302
					LDA #$1A
					STA $7FE304
					LDA #$7C
					STA $7FE305
					LDA #$37
					STA $7FE307
					LDA #$5C
					STA $7FE308
					LDA #$3A
					STA $7FE30A
					LDA #$68
					STA $7FE30B
					LDA #$1D
					STA $7FE30D
					LDA #$7D
					STA $7FE30E
					RTS
					


FLASH_COLOR			LDA $9D
					BNE FLASH_COLOR_R
					REP #$20
					LDA $7FF500
					BEQ FLASH_COLOR_2
					SEC
					SBC #$421
					STA $7FF500
FLASH_COLOR_2		SEP #$20
					LDA #$00
					STA $2121
					LDA $7FF500
					STA $2122
					LDA $7FF501
					STA $2122
FLASH_COLOR_R		RTS
					
DEFAULT				LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					STZ $1401
					RTS
					
GENERATE			LDA $9D
					BNE GENERATE_R
					LDA $18BD
					BNE GENERATE_R
					LDA $16
					AND #$03
					CMP #$01
					BEQ PUSH_RIGHT
					CMP #$02
					BEQ PUSH_LEFT
					BRA GENERATE_0
PUSH_RIGHT			LDA #$01
					STA $157C,x
					BRA GENERATE_0
PUSH_LEFT			STZ $157C,x
GENERATE_0			LDA $18
					AND #$10
					BEQ GENERATE_R
					LDA $1602,x
					BEQ GENERATE_R
					CMP #$01
					BEQ GENERATE_1
					CMP #$02
					BEQ GENERATE_2
					CMP #$03
					BEQ GENERATE_3
					CMP #$04
					BEQ GENERATE_4
GENERATE_R			RTS
GENERATE_1			LDA #$01
					STA $0F
					JSR SAME_CHECK1
					CPY #$01
					BEQ GENERATE_R
					JSR GEN_WEAPON1
					RTS
GENERATE_2			LDA #$02
					STA $0F
					JSR SAME_CHECK1
					CPY #$01
					BEQ GENERATE_R
					JSR GEN_WEAPON2
					RTS
GENERATE_3			LDA #$03
					STA $0F
					JSR SAME_CHECK1
					CPY #$01
					BEQ GENERATE_R
					JSR GEN_WEAPON3
					RTS
GENERATE_4			JSR FLASH_GEN
					RTS
					
SAME_CHECK1			PHX
					LDY #$00
					LDX #$00
LOOP_SAME1			LDA $9E,x
					CMP #$22
					BNE LOOP_SAME1_1
					LDA $14C8,x
					BEQ LOOP_SAME1_1
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE LOOP_SAME1_1
					LDA $1504,x
					CMP $0F
					BNE LOOP_SAME1_1
					LDY #$01
LOOP_SAME1_1		INX
					CPX #$0A
					BCC LOOP_SAME1
					PLX
					RTS

					
GEN_WEAPON1_TBL		dcb $EC,$14
GEN_WEAPON1_TBL2	dcb $FF,$00
GEN_WEAPON1			JSR GEN_SPRITE
					PHY
					LDY $76
					LDA GEN_WEAPON1_TBL,y
					STA $00
					LDA GEN_WEAPON1_TBL2,y
					STA $01
					PLY
					LDA #$FF
					STA $15AC,y
					LDA #$01
					STA $1504,y
					LDA $E4,x
					CLC
					ADC $00
					STA $00E4,y
					LDA $14E0,x
					ADC $01
					STA $14E0,y
					LDA #$07
					STA $1DFC
					RTS
					
GEN_WEAPON2_TBL		dcb $F8,$08
GEN_WEAPON2_TBL2	dcb $FF,$00
GEN_WEAPON2_TBL3	dcb $E8,$18
GEN_WEAPON2			JSR GEN_SPRITE
					LDA $76
					STA $0F
					LDA $74
					BEQ GEN_WEAPON2_1
					LDA $157C,x
					STA $0F
GEN_WEAPON2_1		PHY
					LDY $0F
					LDA GEN_WEAPON2_TBL,y
					STA $00
					LDA GEN_WEAPON2_TBL2,y
					STA $01
					LDA GEN_WEAPON2_TBL3,y
					STA $02
					PLY
					LDA #$FF
					STA $15AC,y
					LDA #$02
					STA $1504,y
					LDA $E4,x
					CLC
					ADC $00
					STA $00E4,y
					LDA $14E0,x
					ADC $01
					STA $14E0,y
					LDA $02
					STA $00B6,y
					LDA #$B8
					STA $00AA,y
					LDA #$00
					STA $1570,y
					RTS
					
GEN_WEAPON3			JSR GEN_SPRITE
					LDA #$03
					STA $1504,y
					STA $15AC,y
					LDA #$99
					STA $1686,y
					RTS

SUB_GEN2			JSR GEN_SPRITE
					PHX
					TYX
					LDA #$3B
					STA NEW_SPRITE_NUM,x
					PLX
					LDA #$00
					STA $1570,y
					LDA #$99
					STA $7FFEE0
					RTS
					
RETURN67            RTS
GEN_SPRITE          JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
                    TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
                    RTS
					
SUB_LEAF			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					PHX
					LDX #$00
SUB_LEAF_LOOP		LDA $14C8,x
					CMP #$08
					BCC SUB_LEAF_2
					LDA $167A,x
					AND #$02
                    BNE SUB_LEAF_2
					LDA $E4,x
					STA $0E
					LDA $14E0,x
					STA $0F
					REP #$20
					LDA $0E
					SEC
					SBC $00
					CMP.W #$0021
					BCC SUB_LEAF_1
					CMP.W #$FFE0
					BCS SUB_LEAF_1
					SEP #$20
					BRA SUB_LEAF_2
SUB_LEAF_1			SEP #$20
					LDA $D8,x
					STA $0E
					LDA $14D4,x
					STA $0F
					REP #$20
					LDA $0E
					SEC
					SBC $02
					CMP.W #$0021
					BCC SUB_LEAF_3
					CMP.W #$FFE0
					BCS SUB_LEAF_3
					SEP #$20
					BRA SUB_LEAF_2
SUB_LEAF_3			SEP #$20
					LDA #$02
                    STA $14C8,x
                    LDA #$37
                    STA $1DFC
SUB_LEAF_2			INX
					CPX #$0A
					BCC SUB_LEAF_LOOP
					PLX
					RTS
					
SUB_LEAF2			LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					PHX
					LDX #$00
SUB_LEAF2_LOOP		LDA $170B,x
					CMP #$02
					BNE SUB_LEAF2_2
					LDA $171F,x
					STA $0E
					LDA $1733,x
					STA $0F
					REP #$20
					LDA $0E
					SEC
					SBC $00
					CMP.W #$0021
					BCC SUB_LEAF2_1
					CMP.W #$FFE0
					BCS SUB_LEAF2_1
					SEP #$20
					BRA SUB_LEAF2_2
SUB_LEAF2_1			SEP #$20
					LDA $1715,x
					STA $0E
					LDA $1729,x
					STA $0F
					REP #$20
					LDA $0E
					SEC
					SBC $02
					CMP.W #$0021
					BCC SUB_LEAF2_3
					CMP.W #$FFE0
					BCS SUB_LEAF2_3
					SEP #$20
					BRA SUB_LEAF2_2
SUB_LEAF2_3			SEP #$20
                    STZ $170B,x
SUB_LEAF2_2			INX
					CPX #$08
					BCC SUB_LEAF2_LOOP
					PLX
					RTS
					
FLASH_GEN			LDA $1558,x
					CMP #$60
					BCS FLASH_GEN_R2
					LDA #$01
					STA $1DFC
					REP #$20
					LDA.W #$7FFF
					STA $7FF500
					SEP #$20
					PHX
					LDX #$00
FLASH_GEN_L			LDA $14C8,x
					CMP #$08
					BCC FLASH_GEN_R
					LDA $9E,x
					CMP #$B9
					BEQ FLASH_GEN_R
					LDA #$80
					STA $1558,x
FLASH_GEN_R			INX
					CPX #$0A
					BCC FLASH_GEN_L
					PLX
FLASH_GEN_R2		RTS

FLAME_CHECK_R		RTS
FLAME_CHECK			LDA $1528,x
					BNE FLAME_CHECK_R
					LDA $E4,x
					STA $00
					LDA $14E0,x
					STA $01
					LDA $D8,x
					STA $02
					LDA $14D4,x
					STA $03
					STX $04
					PHX
					LDX #$00
FLAME_CHECK_L0		LDA $14C8,x
					BEQ FLAME_CHECK_2
					LDA $9E,x
					CMP #$22
					BNE FLAME_CHECK_2
					LDA NEW_SPRITE_NUM,x
					CMP #$13
					BNE FLAME_CHECK_2
					LDA $1504,x
					CMP #$02
					BNE FLAME_CHECK_2
					LDA $B6,x
					BEQ FLAME_CHECK_2
					LDA $E4,x
					SEC
					SBC $00
					STA $0E
					LDA $14E0,x
					SBC $01
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0020
					BCC FLAME_CHECK_3
					CMP.W #$FFE0
					BCS FLAME_CHECK_3
					SEP #$20
					BRA FLAME_CHECK_2
FLAME_CHECK_L		BRA FLAME_CHECK_L0
FLAME_CHECK_3		SEP #$20
					LDA $D8,x
					SEC
					SBC $02
					STA $0E
					LDA $14D4,x
					SBC $03
					STA $0F
					REP #$20
					LDA $0E
					CMP.W #$0020
					BCC FLAME_CHECK_4
					CMP.W #$FFE0
					BCS FLAME_CHECK_4
					SEP #$20
FLAME_CHECK_2		BRA FLAME_CHECK_20
FLAME_CHECK_4		SEP #$20
					PHX
					LDX $04
					LDA #$01
					STA $1528,x
					PLX
FLAME_CHECK_20		INX
					CPX #$0A
					BCC FLAME_CHECK_L
					PLX
					RTS

TELEPORT			JSR GEN_SPRITE
					PHX
					TYX
					LDA #$10
					STA NEW_SPRITE_NUM,x
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					CLC
					ADC #$10
					STA $D8,x
					LDA $97
					ADC #$00
					STA $14D4,x
					LDA #$04
					STA $1504,x
					LDA #$60
					STA $15AC,x
					LDA #$23
					STA $1DF9
					PLX
					RTS
					
HDMA_COLOUR			LDA #$08
					STA $7FFB18
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB19
					LDA #$02
					STA $7FFB21
					LDA #$21
					STA $7FFB1A
					LDA #$22
					STA $7FFB22
					LDA #$00
					STA $7FFB1B
					STA $7FFB23
					LDA #$E2
					STA $7FFB1C
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB1D
					STA $7FFB25
					
					LDA #$01
					STA $7FE200
					STA $7FE300
					LDA #$88
					STA $7FE201
					LDA #$01
					STA $7FE301
					LDA #$28
					STA $7FE302
					
					LDA #$01
					STA $7FE202
					STA $7FE303
					LDA #$89
					STA $7FE203
					LDA #$01
					STA $7FE304
					LDA #$28
					STA $7FE305
					
					LDA #$01
					STA $7FE204
					STA $7FE306
					LDA #$8D
					STA $7FE205
					LDA #$A6
					STA $7FE307
					LDA #$5C
					STA $7FE308
					
					LDA #$01
					STA $7FE206
					STA $7FE309
					LDA #$8E
					STA $7FE207
					LDA #$88
					STA $7FE30A
					LDA #$7D
					STA $7FE30B
					
					LDA #$01
					STA $7FE208
					STA $7FE30C
					LDA #$8F
					STA $7FE209
					LDA #$A3
					STA $7FE30D
					LDA #$77
					STA $7FE30E
					LDA #$00
					STA $7FE20A
					STA $7FE30F
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GFX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x
                    STA $17C4,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x
                    STA $17C8,y             ; /
                    RTS
					
TILEMAP_W			dcb $20,$40,$60
VERT_DISP_W			dcb $E4,$F4,$04

SUB_GFX_W			JSR GET_DRAW_INFO
					PHX
					LDX #$02
LOOP_W				LDA $00
					STA $0300,y
					LDA $01
					CLC
					ADC VERT_DISP_W,x
					STA $0301,y
					LDA TILEMAP_W,x
					STA $0302,y
					LDA #$0D
					ORA $64
					STA $0303,y
					INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_W
					PLX
                    LDY #$02
                    LDA #$02
                    JSL $01B7B3
					STZ $01       
					LDA #$18
                    STA $02       
                    STZ $03       
					STZ $00
                    RTS
					
TILEMAP_FL1			dcb $2C,$2D,$2C,$2D
PROP_FL1			dcb $04,$04,$C4,$C4
SUB_GFX_FL1			JSR GET_DRAW_INFO
					LDA $14
					LSR A
					LSR A
					AND #$03
					PHX
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILEMAP_FL1,x
					STA $0302,y
					LDA PROP_FL1,x
					ORA $64
					STA $0303,y
					PLX
					LDY #$00
                    LDA #$00
                    JSL $01B7B3
                    RTS
					
TILEMAP_FL2			dcb $62,$42,$62,$42
PROPETIES_FL2		dcb $0D,$0D,$CD,$CD
SUB_GFX_FL2			JSR GET_DRAW_INFO
					LDA $1570,x
					STA $02
					CMP #$10
					BCC SUB_GFX_FL2_2
					LDA #$20
					SEC
					SBC $1570,x
					STA $02
SUB_GFX_FL2_2
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA TILEMAP_FL2,x
					STA $0302,y
					LDA PROPETIES_FL2,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL2,x
					STA $0302,y
					LDA PROPETIES_FL2,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					SEC
					SBC $02
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL2,x
					STA $0302,y
					LDA PROPETIES_FL2,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					LDA $00
					STA $0300,y
					LDA $01
					LDA $01
					SEC
					SBC $02
					SBC $02
					SBC $02
					STA $0301,y
					LDA TILEMAP_FL2,x
					STA $0302,y
					LDA PROPETIES_FL2,x
					ORA $64
					STA $0303,y
					INY
					INY
					INY
					INY
					PLX
					LDY #$02
                    LDA #$03
                    JSL $01B7B3
                    RTS
					
HORZ_DISP_LE1       dcb $E0,$00,$20,$00,$E4,$0C,$1C,$F4
                    dcb $EB,$15,$15,$EB,$F4,$1C,$0C,$E4
VERT_DISP_LE1       dcb $00,$E0,$00,$20,$F4,$E4,$0C,$1C
                    dcb $EB,$EB,$15,$15,$E4,$F4,$1C,$0C

SUB_GFX_LE1			JSR GET_DRAW_INFO
					LDA #$44
					STA $02
					LDA #$0D
					STA $0F
					LDA $1528,x
					BEQ SUB_GFX_LE1_2
					PHX
					LDA $14
					LSR A
					LSR A
					LSR A
					AND #$03
					TAX
					LDA TILEMAP_FL2,x
					STA $02
					LDA PROPETIES_FL2,x
					STA $0F
					PLX
SUB_GFX_LE1_2		LDA $14
					LSR A
					LSR A
					AND #$03
					ASL A
					ASL A
					STA $03
					PHX
					LDX #$03
LOOP_LE1			PHX
                    TXA
                    CLC
                    ADC $03
                    TAX
                    LDA $00
                    CLC
                    ADC HORZ_DISP_LE1,x
                    STA $0300,y
                    LDA $01
                    CLC
                    ADC VERT_DISP_LE1,x
                    STA $0301,y
					PLX
                    LDA $02
                    STA $0302,y
                    LDA $0F
                    ORA $64
                    STA $0303,y
                    INY
                    INY
                    INY
                    INY
                    DEX
                    BPL LOOP_LE1
                    PLX
                    LDY #$02
                    LDA #$03
                    JSL $01B7B3
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
					
					
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Lift Data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN892			RTS
SUB_B852            JSR LENG_CHECK
					CPY #$01
					BEQ RETURN892
					STZ $1570,x
					LDA $1504,x
					CMP #$09
					BEQ SUB_B852_2
					LDA $1602,x
					BNE RETURN892
SUB_B852_2			JSR SUB_B8FF
                    BCC RETURN05      
                    LDA $15C4,x
					ORA $154C,x
                    BNE RETURN05
					
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $1C      
                    STA $02      
                    SEC          
                    SBC $0D      
                    STA $09      
                    LDA $80      
                    CLC          
                    ADC #$18     
                    CMP $09      
                    BCS LBL06
                    LDA MARIO_Y_SPEED    
                    BMI RETURN05     
                    STZ MARIO_Y_SPEED  ;#ɏĂ
                    LDA #$01     
                    STA $1471       
					STA $1570,x
					LDA $0D
                    CLC          
                    ADC #$1F     ;#1F?
                    
					STA $00

                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $00      
                    STA MARIO_Y_POS      
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA MARIO_Y_POS_HI      
                    LDY #$00     
RETURN05            RTS           
LBL06				LDA $02       
                    CLC           
                    ADC $0D       ;#^e/2
                    STA $02       
                    LDA #$FF      
                    LDY $73       
                    BNE LBL07      
                    LDY MARIO_STATUS       
                    BNE SMALL_MARIO
LBL07
                    LDA #$08   
SMALL_MARIO
                    CLC                     
                    ADC $80      
                    CMP $02      
                    BCC LBL10      
                    LDA MARIO_Y_SPEED       ;#ɂԂĂ
					BPL LBL09
                    LDA #$10                
                    STA MARIO_Y_SPEED    
LBL09				RTS       
LBL10
                    LDA $0E       ;#/2
                    CLC           
                    ADC #$10      
                    STA $00       
                    LDY #$00      
                    LDA SPRITE_X_POS,x     
                    SEC           
                    SBC $1A       
                    CMP $7E       
                    BCC LBL11     
                    LDA $00       
                    EOR #$FF      
                    INC A         
                    STA $00       
                    DEY
LBL11
                    LDA SPRITE_X_POS,x     ;#ɐGĂ
                    CLC           
                    ADC $00       
                    STA MARIO_X_POS       
                    TYA           
                    ADC SPRITE_X_POS_HI,x   
                    STA MARIO_X_POS_HI       
                    STZ MARIO_X_SPEED
					LDA $C2,x
					BNE RETURN341
					LDA #$01
					STA $C2,x
					STZ $157C,x
					LDA $94
					SEC
					SBC $E4,x
					LDA $95
					SBC $14E0,x
					BCS RETURN341
					LDA #$01
					STA $157C,x
RETURN341			RTS

LENG_CHECK			LDY #$01
					LDA $E4,x
					SEC
					SBC $94
					STA $0E
					LDA $14E0,x
					SBC $95
					STA $0F
					REP #$30
					LDA $0E
					CMP.W #$0040
					BCC LENG_CHECK_3
					CMP.W #$FFC0
					BCS LENG_CHECK_3
					SEP #$30
					RTS
					
LENG_CHECK_3		SEP #$30
					LDA $D8,x
					SEC
					SBC $96
					STA $0E
					LDA $14D4,x
					SBC $97
					STA $0F
					REP #$30
					LDA $0E
					CMP.W #$0040
					BCC LENG_CHECK_4
					CMP.W #$FFC0
					BCS LENG_CHECK_4
					SEP #$30
					RTS
LENG_CHECK_4		SEP #$30
					LDY #$00
					RTS
					
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; make standable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_B8FF			;#$00XvCg̉ $01 0 $02 0
                    LDA $00      
                    STA $0E      ;#/2
                    LDA $02      
                    STA $0D      ;#^e/2
                    LDA SPRITE_X_POS,x    
                    SEC          
                    SBC $00      
                    STA $04      ;#XvCg̍Low
                    LDA SPRITE_X_POS_HI,x  
                    SBC #$00     
                    STA $0A      ;#XvCg̍Hi
                    LDA $00      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $06      ;#XvCg̕{10
                    LDA SPRITE_Y_POS,x    
                    SEC          
                    SBC $02      ;#0
                    STA $05      ;#XvCg̏㑤Low
                    LDA SPRITE_Y_POS_HI,x  
                    SBC #$00     
                    STA $0B      ;#XvCg̏㑤Hi
                    LDA $02      
                    ASL A        
                    CLC          
                    ADC #$10     
                    STA $07      ;#XvCg̍+10
                    JSL $03B664  
                    JSL $03B72B  
                    RTS 
