;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Zable-Fahr
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E    ;08 bytes   custom sprite number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
                    dcb "INIT"
					LDA $D8,x
					CMP #$90
					BEQ GAGE_INIT
					LDA EXTRA_BITS,x
					AND #$04
					BNE INIT2
					LDA #$02
					STA $19
					LDA $E4,x
					CLC
					ADC #$08
					STA $E4,x
					JSR HDMA1
					STZ $40
					LDA #$00
					STA $7FDDDD
					RTL
INIT2               STZ $C2,x
					STZ $1528,x
					LDA #$40
					STA $15AC,x
					LDA $E4,x
					CMP #$80
					BCS INIT2_R
					RTL
INIT2_R				LDA #$01
					STA $1528,x
					RTL
GAGE_INIT			LDA #$01
					STA $1504,x
					STZ $1528,x
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAIN_LAST2_7		LDA #$00
					STA $7FE201
					LDA #$00
					STA $7FE202
					RTS
MAIN_LAST2_2		LDA #$18
					STA $1DFC
					LDA #$88
					STA $7FE201
					LDA #$23
					STA $7FE202
					LDA #$00
					STA $7FE102
					STA $7FE203
					RTS
MAIN_LAST2_3		LDA #$18
					STA $1DFC
					LDA #$FF
					STA $7FE201
					LDA #$0B
					STA $7FE202
					RTS
MAIN_LAST2_6		LDA #$18
					STA $1DFC
					LDA #$FF
					STA $7FE201
					LDA #$7F
					STA $7FE202
					STA $7FDAAA
					STA $7FDAAB
					LDA $7FDDDD
					INC A
					STA $7FDDDD
					JSR HDMA4
					RTS
MAIN_LAST2_2_0		BRA MAIN_LAST2_2
MAIN_LAST2_3_0		BRA MAIN_LAST2_3
MAIN_LAST2_7_0		BRA MAIN_LAST2_7
MAIN_LAST2_6_0		BRA MAIN_LAST2_6
MAIN_LAST2_4		LDA #$18
					STA $1DFC
					LDA #$46
					STA $7FE201
					LDA #$7D
					STA $7FE202
					RTS
MAIN_LAST2_5		LDA #$18
					STA $1DFC
					LDA #$7F
					STA $7FE201
					LDA #$51
					STA $7FE202
					RTS
MAIN_LAST3			JSR HDMA4
					LDA $7FDAAA
					CMP #$01
					BEQ MAIN_LAST3_2
					DEC A
					STA $7FDAAA
					RTS
MAIN_LAST2			CMP #$06
					BCS MAIN_LAST3
					LDA #$FF
					STA $14AD
					STA $14AE
					LDA $15AC,x
					CMP #$C0
					BEQ MAIN_LAST2_2_0
					CMP #$BC
					BEQ MAIN_LAST2_7_0
					CMP #$90
					BEQ MAIN_LAST2_3_0
					CMP #$8C
					BEQ MAIN_LAST2_7_0
					CMP #$60
					BEQ MAIN_LAST2_4
					CMP #$5C
					BEQ MAIN_LAST2_7_0
					CMP #$30
					BEQ MAIN_LAST2_5
					CMP #$2C
					BEQ MAIN_LAST2_7_0
					CMP #$00
					BEQ MAIN_LAST2_6_0
					RTS
MAIN_LAST3_2		LDA $7FDAAB
					CMP #$01
					BEQ MAIN_LAST3_3
					DEC A
					STA $7FDAAB
					RTS
MAIN_LAST3_3		LDA #$0B
                    STA $1DFB
					LDA #$FF
                    STA $13C6
                    STA $1493
					LDA #$00
					STA $7FE201
					STA $7FE202
					LDA #$10
					STA $00212C
					LDA #$0F
					STA $00212D
					STZ $14C8,x
					RTS
MAIN_LAST			LDA #$13
					STA $00212C
					LDA #$0C
					STA $00212D
					LDA $7FDDDD
					CMP #$05
					BCS MAIN_LAST2
					JSR SPRITE_DEL
					LDA #$1E
					STA $1DFB
					LDA #$FF
					STA $14AD
					STA $14AE
					STA $15AC,x
					JSR FACE_CHANGE4
					JSR CLOSE_MOUSE_L
					JSR CLOSE_MOUSE_R
					LDA $7FDDDD
					INC A
					STA $7FDDDD
					RTS
RETURN              RTS                     ; return           
CODE_START          LDA $1504,x
					CMP #$01
					BNE START1
					JSR GAGE_MAIN
					RTS
START1				CMP #$02
					BCC START2
					JSR SHOT
					RTS
MAIN_LAST_A			BRA MAIN_LAST
START2				LDA $C2,x
					CMP #$10
					BEQ CROSS_0
					LDA EXTRA_BITS,x
					AND #$04
					BNE SIDE_MAIN
					;JSR MARIO_LIFE
					LDA $1602,x
					BEQ NO_GFX
					JSR SUB_GFX
NO_GFX				LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					LDA #$03
					STA $0F31
					LDA $16
					BEQ MAIN2
					LDA $7FE000
					INC A
					STA $7FE000
MAIN2				LDA $7FDDDD
					CMP #$04
					BCS MAIN_LAST_A
					JSR BOMB_CHECK
					LDA $C2,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0			CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1			CMP #$02
					BNE NOT_MODE2
					JSR MODE2
					RTS
NOT_MODE2			CMP #$03
					BNE NOT_MODE3
					JSR MODE3
					RTS
NOT_MODE3			CMP #$04
					BNE NOT_MODE4
					JSR MODE4
					RTS
NOT_MODE4			CMP #$05
					BNE NOT_MODE5
					JSR MODE5
					RTS
NOT_MODE5			CMP #$06
					BNE NOT_MODE6
					JSR MODE6
					RTS
NOT_MODE6			CMP #$07
					BNE NOT_MODE7
					JSR MODE7
					RTS
NOT_MODE7			JSR MODE8
					RTS

CROSS_0				BRA CROSS_1
SIDE_MAIN			LDA $1528,x
					BNE SIDE_RIGHT
					LDA $C2,x
					CMP #$06
					BEQ L_GFX2
					CMP #$02
					BNE L_GFX
					JSR SUB_L_GFX
					BRA NOT_L_GFX
L_GFX				CMP #$05
					BNE NOT_L_GFX
					JSR SUB_L_GFX2
					BRA NOT_L_GFX
L_GFX2				JSR SUB_L_GFX3
NOT_L_GFX			LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					LDA $C2,x
					BNE NOT_L_MODE0
					JSR L_MODE0
					RTS
NOT_L_MODE0			CMP #$01
					BNE NOT_L_MODE1
					JSR L_MODE1
RETURN2				RTS
NOT_L_MODE1			CMP #$02
					BNE NOT_L_MODE2
					JSR L_MODE2
					RTS
NOT_L_MODE2			CMP #$03
					BNE NOT_L_MODE3
					JSR L_MODE3
					RTS
NOT_L_MODE3			CMP #$04
					BNE NOT_L_MODE4
					JSR L_MODE4
					RTS
NOT_L_MODE4			CMP #$05
					BNE NOT_L_MODE5
					JSR L_MODE4
					RTS
NOT_L_MODE5			JSR L_MODE6
					RTS
CROSS_1				BRA CROSS_MAIN
					
SIDE_RIGHT			LDA $C2,x
					CMP #$06
					BNE NO_R_GFX
					JSR SUB_R_GFX
NO_R_GFX			LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN2              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN2
					LDA $C2,x
					BNE NOT_R_MODE0
					JSR R_MODE0
					RTS
NOT_R_MODE0			CMP #$01
					BNE NOT_R_MODE1
					JSR R_MODE1
					RTS
NOT_R_MODE1			CMP #$02
					BNE NOT_R_MODE2
					JSR R_MODE2
					RTS
NOT_R_MODE2			CMP #$03
					BNE NOT_R_MODE3
					JSR R_MODE3
					RTS
NOT_R_MODE3			CMP #$04
					BNE NOT_R_MODE4
					JSR R_MODE4
					RTS
NOT_R_MODE4			CMP #$05
					BNE NOT_R_MODE5
					JSR R_MODE4
					RTS
NOT_R_MODE5			JSR R_MODE6
RETURN4				RTS

CROSS_MAIN			JSR C_SUB_GFX
					LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE RETURN4              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN4
					STZ $B6,x
					LDA #$30
					STA $AA,x
					JSL $01802A
					JSR CROSS_CHECK
					LDA $14D4,x
					BEQ RETURN4
					LDA $D8,x
					CMP #$70
					BCC RETURN4
					STZ $14C8,x
					RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X_SPEED1			dcb $30,$20,$28,$20
Y_SPEED1			dcb $00,$10,$F8,$E0
X_SPEED2			dcb $D0,$E0,$D8,$E0
Y_SPEED2			dcb $00,$F0,$08,$20

MODE0				LDA #$11
					STA $00212C
					LDA #$0E
					STA $00212D
					LDA $14AD
					BEQ MODE0_E
					LDA $14AE
					BEQ MODE0_E
					LDA $1570,x
					BEQ MODE0_1
					CMP #$E0
					BEQ MODE0_2
					CMP #$01
					BEQ MODE0_3
					LDA $14
					AND #$01
					BEQ MODE0_E
					DEC $1570,x
MODE0_E				RTS
MODE0_1				LDA #$FF
					STA $1570,x
					RTS
MODE0_2				LDA #$0B
					STA $1DFB
					DEC $1570,x
					RTS
MODE0_3				LDA #$01
					STA $C2,x
					LDA #$FF
					STA $1570,x
					RTS
					
MODE1				LDA $1570,x
					BEQ MODE1_4
					CMP #$A0
					BEQ MODE1_2
					CMP #$90
					BEQ MODE1_1
					CMP #$60
					BEQ MODE1_3
					LDA $14
					AND #$01
					BEQ MODE1_E
					DEC $1570,x
MODE1_E				RTS
MODE1_1				LDA #$01
					STA $7FDD00
					DEC $1570,x
					RTS
MODE1_2				LDA #$01
					STA $1602,x
					DEC $1570,x
					RTS
MODE1_3				STZ $1602,x
					DEC $1570,x
					RTS
MODE1_4				LDA #$03
					STA $7FD000
					JSR HDMA3
					LDA #$02
					STA $C2,x
					RTS

MODE2				LDA #$13
					STA $00212C
					LDA #$0C
					STA $00212D
					LDA $7FE302
					CMP #$7F
					BEQ MODE2_2
					INC A
					STA $7FE302
					RTS
MODE2_2				LDA #$19
					STA $1DFB
					LDA #$03
					STA $C2,x
					LDA #$00
					STA $7FD900
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $7FDDDD
					RTS

MODE3				LDA $15AC,x
					BEQ MODE3_1
					RTS
MODE3_1				LDA $14AD
					BEQ MODE3_0
					LDA $14AE
					BEQ MODE3_0
					LDA #$FF
					STA $15AC,x
					LDA #$08
					STA $C2,x
					RTS
MODE3_0				LDA $7FD900
					BNE MODE3_2
					LDA #$01
					STA $7FD900
					LDA #$04
					STA $C2,x
					LDA $94
					CMP #$80
					BCS MODE3_1_2
					JSR FACE_CHANGE1
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$01
					STA $157C,x
					RTS 
MODE3_1_2			JSR FACE_CHANGE2
					LDA #$04
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $157C,x
					RTS
MODE3_2				CMP #$02
					BEQ MODE3_3
					LDA #$02
					STA $7FD900
					LDA #$05
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					JSR FACE_CHANGE3
					RTS
MODE3_3				LDA #$00
					STA $7FD900
					LDA #$06
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					JSR FACE_CHANGE4
					RTS

MODE4				LDA $15AC,x
					BEQ MODE4_4
					CMP #$C0
					BEQ MODE4_1
					CMP #$80
					BEQ MODE4_2
					CMP #$40
					BEQ MODE4_3
					RTS
MODE4_1				LDA #$04
					STA $1602,x
					RTS
MODE4_2				STZ $1602,x
					RTS
MODE4_3				JSR BULL_GEN
					RTS
MODE4_4				JSR FACE_DEFAULT
					LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					RTS
					
MODE5				LDA $15AC,x
					BEQ MODE5_4
					CMP #$C0
					BEQ MODE5_1
					CMP #$80
					BEQ MODE5_2
					CMP #$40
					BEQ MODE5_3
					RTS
MODE5_1				LDA #$03
					STA $1602,x
					RTS
MODE5_2				STZ $1602,x
					RTS
MODE5_3				JSR GEN_DEATH
					RTS
MODE5_4				JSR FACE_DEFAULT
					LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					RTS
					
MODE6				LDA $15AC,x
					BEQ MODE6_4
					CMP #$C0
					BEQ MODE6_1
					CMP #$80
					BEQ MODE6_2
					RTS
MODE6_1				LDA #$02
					STA $1602,x
					RTS
MODE6_2				STZ $1602,x
					RTS
MODE6_4				
					LDA #$F0
					STA $1570,x
					LDA #$07
					STA $C2,x
					RTS

MODE7				LDA $14
					AND #$01
					BNE MODE7_0
					DEC $1570,x
MODE7_0				LDA $1570,x
					BEQ MODE7_1
					CMP #$E0
					BEQ MODE7_2
					CMP #$B0
					BEQ MODE7_3
					CMP #$80
					BEQ MODE7_4
					CMP #$50
					BEQ MODE7_5
					RTS
MODE7_1				LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					JSR FACE_DEFAULT
					RTS
MODE7_2				LDA #$2B
					STA $1DFC
					LDA #$78
					STA $02
					JSR GEN_CROSS
					LDA #$0B
					STA $1602,y
					DEC $1570,x
					RTS
MODE7_3				LDA #$2B
					STA $1DFC
					LDA #$50
					STA $02
					JSR GEN_CROSS
					LDA #$05
					STA $1602,y
					DEC $1570,x
					RTS
MODE7_4				LDA #$2B
					STA $1DFC
					LDA #$A0
					STA $02
					JSR GEN_CROSS
					LDA #$07
					STA $1602,y
					DEC $1570,x
					RTS
MODE7_5				LDA #$2B
					STA $1DFC
					LDA #$78
					STA $02
					JSR GEN_CROSS
					LDA #$09
					STA $1602,y
					DEC $1570,x
					RTS

MODE8				LDA $15AC,x
					BEQ MODE8_4
					CMP #$C0
					BEQ MODE8_1
					CMP #$80
					BEQ MODE8_2
					CMP #$40
					BEQ MODE8_3
					RTS
MODE8_1				LDA #$01
					STA $1602,x
					RTS
MODE8_2				STZ $1602,x
					RTS
MODE8_3				LDA #$01
					STA $7FDD00
					RTS
MODE8_4				LDA #$FF
					STA $15AC,x
					LDA #$03
					STA $C2,x
					RTS
					
L_MODE0				LDA $15AC,x
					BNE L_MODE0_R
					LDA #$20
					STA $15AC,x
					LDA $94
					CLC
					ADC $7FE000
					AND #$07
					BNE L_MODE0_R
					JSR OPEN_MOUSE_L
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA $94
					AND #$01
					BNE L_MODE0_2
L_MODE0_R			RTS
L_MODE0_2			LDA #$04
					STA $C2,x
					LDA #$00
					STA $7FD203
					RTS
					
L_MODE1				LDA $15AC,x
					CMP #$D0
					BCS L_MODE1_R
					CMP #$3F
					BEQ L_MODE1_3
					CMP #$6F
					BEQ L_MODE1_2
					CMP #$6F
					BCC L_MODE1_R 
					JSR TARGET
					RTS
L_MODE1_2			LDY #$03
					LDA #$00
					STA $17CC,y
					JSR POS_CHECK
					RTS
L_MODE1_3			LDA #$02
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					STZ $151C,x
L_MODE1_R			RTS

L_MODE2				STZ $B6,x
					STZ $AA,x
					LDA $15AC,x
					CMP #$B0
					BEQ L_MODE2_3
					LDA $15AC,x
					CMP #$D0
					BCC L_MODE2_2
					CMP #$E0
					BCC L_MODE2_4
					LDA #$30
					LDA $157C,x
					TAY
					LDA X_SPEED1,y
					STA $B6,x
					LDA Y_SPEED1,y
					STA $AA,x
L_MODE2_4			JSR MARIO_CHECK
					JSL $01802A
					LDA $15AC,x
					CMP #$D8
					BNE L_MODE2_R
					LDA $157C,x
					CMP #$03
					BNE L_MODE2_R
					LDA $7FDDDD
					BEQ L_MODE2_R
					INC A
					STA $7FDDDD
					LDA #$28
					STA $1DFC
					RTS
L_MODE2_2			LDA $157C,x
					TAY
					LDA X_SPEED2,y
					STA $B6,x
					LDA Y_SPEED2,y
					STA $AA,x
					JSR MARIO_CHECK
					JSL $01802A
					RTS
L_MODE2_3			LDA #$30
					STA $E4,x
					LDA #$40
					STA $D8,x
					LDA #$01
					STA $14D4,x
					JSR CLOSE_MOUSE_L
					STZ $C2,x
					LDA #$20
					STA $15AC,x
					LDA $1602,x
					CMP #$03
					BCC L_MODE2_R
					LDA #$28
					STA $1DFC
					LDA #$03
					STA $C2,x
L_MODE2_R			RTS

L_MODE4				LDA $15AC,x
					CMP #$40
					BEQ L_MODE4_3
					CMP #$50
					BCC L_MODE4_4
					CMP #$90
					BEQ L_MODE4_1
					CMP #$8F
					BCC L_MODE4_2
					RTS
L_MODE4_1			LDA #$17
					STA $1DFC
					LDA #$05
					STA $C2,x
L_MODE4_2			JSR FRAME_CHECK
					LDA $7FD203
					INC A
					INC A
					AND #$0F
					STA $7FD203
					RTS
L_MODE4_3			JSR CLOSE_MOUSE_L
					STZ $C2,x
					LDA #$20
					STA $15AC,x
L_MODE4_R			RTS
L_MODE4_4			LDA #$04
					STA $C2,x
					RTS


L_MODE3				LDA $7FDD00
					BNE L_MODE3_2
					LDA #$FF
					STA $14AD
					RTS
L_MODE3_2
					LDA #$06
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA #$00
					STA $7FD800
					STA $7FD801
					RTS
					
L_MODE6				LDA #$FF
					STA $14AD
					LDA $15AC,x
					CMP #$A0
					BEQ L_MODE6_3
					LDA $7FD801
					INC A
					STA $7FD801
					RTS
L_MODE6_3			LDA #$FF
					STA $15AC,x
					STZ $14AD
					STZ $C2,x
					STZ $1602,x
					LDA #$00
					STA $7FDD00
					RTS


R_MODE0				JSR FIRE_CHECK
					LDA $15AC,x
					BNE R_MODE0_R
					LDA #$27
					STA $15AC,x
					LDA $94
					SEC
					SBC $7FE000
					CLC
					ADC $14
					AND #$07
					BNE R_MODE0_R
					JSR OPEN_MOUSE_R
					LDA #$01
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					LDA $94
					AND #$01
					BNE R_MODE0_2
					LDY #$00
R_MODE0_R			RTS
R_MODE0_2			LDA #$04
					STA $C2,x
					RTS
					
R_MODE1				LDA $15AC,x
					CMP #$A0
					BEQ R_MODE1_1
					CMP #$70
					BEQ R_MODE1_2
					RTS
R_MODE1_1			JSR GEN_SHOT
					RTS
R_MODE1_2			JSR CLOSE_MOUSE_R
					STZ $C2,x
					LDA #$20
					STA $15AC,x
					RTS

R_MODE2				RTS

R_MODE3				LDA $7FDD00
					BNE R_MODE3_2
					LDA #$FF
					STA $14AE
					RTS
R_MODE3_2			LDA #$06
					STA $C2,x
					LDA #$FF
					STA $15AC,x
					RTS

R_MODE4				JSR FIRE_CHECK
					LDA $15AC,x
					CMP #$80
					BEQ R_MODE4_3
					CMP #$C0
					BEQ R_MODE4_1
					CMP #$BF
					BCC R_MODE4_2
					RTS
R_MODE4_1			LDA #$17
					STA $1DFC
R_MODE4_2			DEC $94
					RTS
R_MODE4_3			JSR CLOSE_MOUSE_R
					STZ $C2,x
					LDA #$20
					STA $15AC,x
R_MODE4_R			RTS

R_MODE6				LDA #$FF
					STA $14AE
					LDA $15AC,x
					CMP #$F8
					BEQ R_MODE6_2
					CMP #$D0
					BEQ R_MODE6_2
					CMP #$A8
					BEQ R_MODE6_2
					CMP #$A0
					BEQ R_MODE6_3
					RTS
R_MODE6_2			LDA #$1C
					STA $1DF9
					RTS
R_MODE6_3			LDA #$FF
					STA $15AC,x
					STZ $14AE
					STZ $C2,x
					STZ $1602,x
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Etc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TARGET				LDA $13
					AND #$0F
					BNE TARGET2
					LDA #$01
					STA $1DFC
TARGET2				LDY #$03
					LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $96
					CLC
					ADC #$10
                    STA $17C4,y             ; /
                    
                    LDA #$33                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $94
                    STA $17C8,y             ; /
                    RTS      
					
					
MARIO_CHECK			LDA $151C,x
					BNE CHECK_R
					JSL $01A7DC
					BCC CHECK_R
					LDA $7D
					CMP #$80
					BCS ENE_WINS
					CMP #$08
					BCC ENE_WINS
					LDA #$B0
					STA $7D
					JSL $01AB99             ; display contact graphic
					LDA #$03
                    STA $1DF9
					INC $1602,x
					LDA #$01
					STA $151C,x
CHECK_R				RTS
ENE_WINS            LDA $1497               ; \ if mario is invincible...
                    BNE RETURNC_2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
RETURNC_2           RTS

POS_CHECK			LDA $97
					BEQ POS_UP
					LDA $96
					CMP #$30
					BCC POS_UP
					LDA $94
					CMP #$80
					BCS POS_DOWN_R
					LDA #$01
					STA $157C,x
					RTS
POS_DOWN_R			STZ $157C,x
					RTS
POS_UP				LDA $94
					CMP #$80
					BCS POS_UP_R
					LDA #$03
					STA $157C,x
					RTS
POS_UP_R			LDA #$02
					STA $157C,x
					RTS
					
FRAME_CHECK			LDA $94
					CMP #$30
					BCC FRAME_R
					CMP #$B0
					BCS FRAME_R
					LDA $94
					STA $E4,x
					JSL $01A7DC
					BCC FRAME_R2
		            LDA $1497               ; \ if mario is invincible...
                    BNE FRAME_R2             ; /   ... return
                    JSL $00F5B7             ; hurt mario
FRAME_R2			LDA #$30
					STA $E4,x
FRAME_R		        RTS

					
FIRE_CHECK			PHX
					LDX #$00
FIRE_CHECK_LOOP		LDA $14C8,x
					CMP #$08
					BNE FIRE_CHECK_2
					LDA $1504,x
					CMP #$03
					BNE FIRE_CHECK_2
					LDA $14E0,x
					BNE FIRE_CHECK_2
					LDA $E4,x
					CMP #$C0
					BCC FIRE_CHECK_2
					LDY #$01
					STZ $14C8,x
					LDA #$28
					STA $1DFC
					PLX
					INC $1602,x
					PHX
FIRE_CHECK_2		INX
					CPX #$0A
					BCC FIRE_CHECK_LOOP
					PLX
					LDA $1602,x
					CMP #$03
					BCS FIRE_CHECK_3
					RTS
FIRE_CHECK_3		LDA #$03
					STA $C2,x
					JSR CLOSE_MOUSE_R
					RTS
					
BOMB_CHECK			PHX
					LDX #$00
BOMB_LOOP			LDA $9E,x
					CMP #$0D
					BNE BOMB_CHECK_2
					LDA $14C8,x
					CMP #$08
					BNE BOMB_CHECK_2
					LDA $E4,x
					CMP #$A0
					BCS BOMB_CHECK_1
					CMP #$50
					BCS BOMB_CHECK_2
					STZ $157C,x
					BRA BOMB_CHECK_2
BOMB_CHECK_1		LDA #$01
					STA $157C,x
BOMB_CHECK_2		CPX #$09
					BCS BOMB_CHECK_3
					INX
					BRA BOMB_LOOP
BOMB_CHECK_3		PLX
					RTS
					
CROSS_CHECK			JSR CROSS_CHECK2
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CROSS_CHECK2
					LDA $D8,x
					CLC
					ADC #$20
					STA $D8,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR CROSS_CHECK2
					LDA $D8,x
					SEC
					SBC #$10
					STA $D8,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					JSR CROSS_CHECK2
					LDA $E4,x
					CLC
					ADC #$20
					STA $E4,x
					LDA $14D4,x
					ADC #$00
					STA $14D4,x
					JSR CROSS_CHECK2
					LDA $E4,x
					SEC
					SBC #$10
					STA $E4,x
					LDA $14D4,x
					SBC #$00
					STA $14D4,x
					RTS


CROSS_CHECK2		JSL $01A7DC
					BCC CROSS_R2
		            LDA $1497               ; \ if mario is invincible...
                    BNE CROSS_R2             ; /   ... return
                    JSL $00F5B7
CROSS_R2			RTS

SPRITE_DEL			STZ $1602,x
					TXA
					STA $0F
					PHX
					LDX #$00
SPRITE_DEL_LOOP		CPX $0F
					BEQ SPRITE_DEL2
					STZ $14C8,x
SPRITE_DEL2			INX
					CPX #$0A
					BCC SPRITE_DEL_LOOP
					PLX
					RTS
					
GAGE_R				RTS
GAGE_MAIN			JSR SUB_GFX_GA
					LDA $9D
					BNE GAGE_R
					STZ $0DBC
					STZ $0DC1
					STZ $0DC2
					LDA $19
					BEQ GAGE_2
					RTS
GAGE_2				LDA #$02
					STA $19
					INC $1528,x
					LDA $1528,x
					CMP #$06
					BEQ GAGE_3
					RTS
GAGE_3				JSL $00F606
					STZ $14C8,x
					RTS
					
SHOT_SPEED			dcb $20,$E0

SHOT				JSR SUB_GFX_SH
					LDA $9D
					BNE SHOT_R
					LDA $14E0,x
					CMP #$00
					BNE SHOT_DELETE
					LDA $14C8,x
					BEQ SHOT_R
					CMP #$02
					BEQ SHOT2
					STZ $AA,x
					LDA $157C,x
					TAY
					LDA SHOT_SPEED,y
					STA $B6,x
					JSL $01802A
					JSR DAMAGE_CHECK
SHOT_R				RTS
SHOT_DELETE			STZ $14C8,x
					RTS
SHOT2				LDA #$08
					STA $14C8,x
					LDA #$83
					STA $167A,x
					LDA #$39
					STA $166E,x
					LDA #$03
					STA $1504,x
					LDA $E4,x
					SEC
					SBC $94
					LDA $14E0,x
					SBC $95
					BCS SHOT3
					RTS
SHOT3				STZ $157C,x
					RTS
					
DAMAGE_CHECK		JSL $01A7DC
					BCC SHOT_R2
		            LDA $1497               ; \ if mario is invincible...
                    BNE SHOT_R2
                    JSL $00F5B7
SHOT_R2				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN67            RTS
GEN_CROSS           JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN67            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    LDA NEW_SPRITE_NUM,x
					TYX
                    STA NEW_SPRITE_NUM,x
                    PLX
                    
                    LDA $02
                    STA $00E4,y

                    LDA #$00
                    STA $14E0,y             ; /

                    LDA #$80
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$10
					STA $00C2,y
                    RTS                          ; return
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite generator routine2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




BULL_OFFSET			dcb $A0,$50
BULL_GEN        	JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots ful
                    BMI RETURN68            ; / after: Y has index of sprite being generated
					LDA #$40
					STA $009E,y
					LDA #$08
					STA $14C8,y
					LDA $157C,x
					TAX
					LDA BULL_OFFSET,x
                    STA $00E4,y
                    LDA #$00
                    STA $14E0,y             ; /
                    LDA #$A0
                    STA $00D8,y             ;  |
                    LDA #$00
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    PLX
					LDA $157C,x
					STA $157C,y
RETURN68			RTS
					
RETURN66            RTS
GEN_DEATH           LDA #$23
					STA $1DF9
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN66            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    TYX
					LDA #$2F
                    STA NEW_SPRITE_NUM,x
					STA $009E,y
                    PLX
                    
					LDA $94
                    STA $00E4,y

                    LDA $95
                    STA $14E0,y             ; /

					LDA $96
                    STA $00D8,y             ;  |
                    LDA $97
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
RETURN6A            RTS                          ; return
					
					
GEN_SHOT			LDA #$10
					STA $1DFC
					JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN6A            ; / after: Y has index of sprite being generated
                    LDA #$08                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /
                    PHX
                    TYX
					LDA #$5D
                    STA NEW_SPRITE_NUM,x
					STA $009E,y
                    PLX
                    
					LDA $E4,x
                    STA $00E4,y

                    LDA $14E0,x
                    STA $14E0,y             ; /

					LDA $D8,x
                    STA $00D8,y             ;  |
                    LDA $14D4,x
                    STA $14D4,y             ; /
                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ;  | routine clears *all* old sprite values...
                    JSL $07F7D2             ;  | ...and loads in new values for the 6 main sprite tables
                    JSL $0187A7             ;  get table values for custom sprite
                    LDA #$88
                    STA EXTRA_BITS,x
                    PLX
					LDA #$02
					STA $1504,y
					LDA #$19
					STA $166E,y
					LDA #$81
					STA $167A,y
					LDA #$01
					STA $157C,y
                    RTS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP_GA			dcb $86,$86,$86,$86,$86
					dcb $86,$86,$86,$86,$C0
					dcb $86,$86,$86,$C0,$C0
					dcb $86,$86,$C0,$C0,$C0
					dcb $86,$C0,$C0,$C0,$C0
					dcb $C0,$C0,$C0,$C0,$C0
HORZ_OFFSET			dcb $00,$18,$30,$48,$60

SUB_GFX_GA			JSR GET_DRAW_INFO
					LDA $1528,x
					ASL A
					ASL A
					CLC
					ADC $1528,x
					STA $03
					PHX
					LDX #$04
LOOP_GA				LDA $00                 ; \ 
                    CLC                     ;  |
                    ADC HORZ_OFFSET,x         ;  |
                    STA $0300,y
					LDA $01
					STA $0301,y
					PHX
					TXA
					CLC
					ADC $03
					TAX
					LDA TILEMAP_GA,x
					STA $0302,y
					PLX
					LDA #$01
					ORA $64
					STA $0303,y
					INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_GA
					PLX                     ; pull, X = sprite index
                    LDY #$02                ;
                    LDA #$04
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS         


TILEMAP             dcb $40,$42,$20,$22,$24,$26,$28,$2A,$60,$62,$64,$66,$68,$6A,$6C,$00,$02,$04
HORIZ_DISP          dcb $F8,$08,$E0,$F0,$00,$10,$20,$30,$D0,$E0,$F0,$00,$10,$20,$30,$F0,$00,$10
LENGTH				dcb $00,$01,$05,$06,$02
OFFSET				dcb $00,$00,$02,$08,$0F

SUB_GFX            JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder                
                    PHX                     ; push sprite index
					LDA $1602,x
					TAX
					LDA LENGTH,x
					STA $02
					LDA OFFSET,x
					STA $03
                    LDX $02
LOOP_START          PHX                     ; push current tile number
                    
					TXA
					CLC
					ADC $03
					TAX
                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    CLC                     ;  |
                    ADC HORIZ_DISP,x         ;  |
                    STA $0300,y             ; /   set x position of the tile
                    
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /   set y position of the tile
                    
                    LDA TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 

                    PHX
					LDA #$09             ;  | get palette info
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX
                    
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
                    LDY #$02                ; \ 02, because we didn't write to 460 yet   460 = Tile Size 02:16x16
                    LDA $02
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 PROPETIESH			dcb $49,$09
 SUB_GFX_SH			LDA $157C,x
					TAY
					LDA PROPETIESH,y
					STA $0F
					JSR GET_DRAW_INFO
					LDA $00
					STA $0300,y
					LDA $01
					STA $0301,y
					LDA #$8A
					STA $0302,y
					LDA $0F
					ORA $64
					STA $0303,y
					LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$00
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS 



L_TILEMAP             dcb $46,$46,$46,$46,$46,$46,$46,$44

SUB_L_GFX             JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder  
					PHX                     ; push sprite index
					LDA $00
					STA $7FD200
					LDA $01
					STA $7FD201
					
					LDA $E4,x
					SEC
					SBC #$30
					LSR A
					LSR A
					LSR A
					STA $03
					
					LDA $D8,x
					CMP #$41
					BCS L_GFX_D
					LDA #$40
					SEC
					SBC $D8,x
					LSR A
					LSR A
					LSR A
					STA $02
					STZ $0F
					BRA SUB_L_GFX_S
L_GFX_D				LDA $D8,x
					SEC
					SBC #$40
					LSR A
					LSR A
					LSR A
					STA $02
					LDA #$01
					STA $0F

SUB_L_GFX_S
                    LDX #$07                ; loop counter = (number of tiles per frame) - 1
L_LOOP_START        PHX                     ; push current tile number

					LDA $7FD200
                    STA $0300,y             ; /      

                    LDA $7FD201 
                    STA $0301,y             ; /
                    
					
                    LDA L_TILEMAP,x           ; \ store tile
                    STA $0302,y             ; / 
        
                    LDA #$0F
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
					
					LDA $7FD200
					SEC
					SBC $03
					STA $7FD200
					
					LDA $0F
					BNE L_LOOP2
					LDA $7FD201
					CLC
					ADC $02
					STA $7FD201
					BRA L_LOOP3
L_LOOP2				LDA $7FD201
					SEC
					SBC $02
					STA $7FD201
L_LOOP3
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL L_LOOP_START          ; / 

                    PLX                     ; pull, X = sprite index
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

L_TILEMAP2             dcb $48,$4A

SUB_L_GFX2          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index
					STA $0F
					LDA #$08
					STA $7FD201

                    LDX #$07                ; loop counter = (number of tiles per frame) - 1
L_LOOP_START2        PHX                     ; push current tile number

					LDA $00
					CLC
					ADC $7FD201
					CLC
					ADC $7FD203
					STA $0300,y             ; /      

                    LDA $01 
                    STA $0301,y             ; /
                    
					TXA
					AND #$01
					PHX
					TAX
                    LDA L_TILEMAP2,x           ; \ store tile
                    STA $0302,y             ; / 
					PLX
        			
					LDA $7FD201
					CLC
					ADC #$10
					STA $7FD201
					
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    PLX                     ; \ pull, X = current tile of the frame we're drawing
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL L_LOOP_START2          ; / 

                    PLX                     ; pull, X = sprite index
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$07                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

L_TILEMAP3          dcb $4C,$6E,$4C,$6E,$4C,$6E
L_HORZ3				dcb $00,$E0,$F8,$08,$D8,$F8
L_VERT3				dcb $C0,$B8,$C0,$A8,$98,$B0

SUB_L_GFX3          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index

					LDX #$03
L_LOOP_START3		PHX
					TXA
					CLC
					ADC $7FD800
					TAX
                    LDA $00
					CLC
					ADC L_HORZ3,x
					STA $0300,y             ; /      

                    LDA $01
					CLC
					ADC L_VERT3,x
					CLC
					ADC $7FD801
                    STA $0301,y             ; /
					PLX
                    
                    LDA L_TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; / 
					
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL L_LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

R_TILEMAP3          dcb $4C,$6E,$4C,$6E,$4C,$6E
R_HORZ3				dcb $00,$30,$20,$18,$08,$28
R_VERT3				dcb $B0,$A8,$A0,$C0,$B8,$C0

SUB_R_GFX          JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index

					LDX #$03
R_LOOP_START3		PHX
					TXA
					CLC
					ADC $7FD800
					TAX
                    LDA $00
					CLC
					ADC R_HORZ3,x
					STA $0300,y             ; /      

                    LDA $01
					CLC
					ADC R_VERT3,x
					CLC
					ADC $7FD801
                    STA $0301,y             ; /
					PLX
                    
                    LDA R_TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; / 
					
                    LDA #$0D
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL R_LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$03                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

C_TILEMAP3          dcb $06,$08,$0A,$0C,$0E
C_HORZ3				dcb $00,$F0,$00,$10,$00
C_VERT3				dcb $F0,$00,$00,$00,$10

C_SUB_GFX           JSR GET_DRAW_INFO       ; after: Y = index to sprite tile map ($300)
					PHX                     ; push sprite index
					LDA $1602,x
					STA $03

					LDX #$04
C_LOOP_START3		LDA $00
					CLC
					ADC C_HORZ3,x
					STA $0300,y             ; /      

                    LDA $01
					CLC
					ADC C_VERT3,x
                    STA $0301,y             ; /

                    LDA C_TILEMAP3,x           ; \ store tile
                    STA $0302,y             ; / 
					
                    LDA $03
                    ORA $64                 ;  | put in level properties
                    STA $0303,y             ; / store tile properties
                    INY                     ;  | increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ;  |    ...so increment 4 times
                    DEX                     ;  | go to next tile of frame and loop
                    BPL C_LOOP_START3          ; / 

                    PLX                     ; pull, X = sprite index
	                LDY #$02                ; \ FF, because we wrote to 460
                    LDA #$04                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

					
RETURN_H			RTS
HDMA1				LDA $7FFB28
					BNE HDMA1_1 ;#wi

					LDA #$17
					STA $00212C
					LDA #$00
					STA $00212D

					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35

HDMA1_1				LDA #$08 ;1
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$08
					STA $7FE201
					LDA #$40
					STA $7FE202
					
					LDA #$08  ;2
					STA $7FE102
					STA $7FE203
					LDA #$00
					STA $7FE103
					LDA #$08
					STA $7FE204
					LDA #$3C
					STA $7FE205
					
					LDA #$08 ;3
					STA $7FE104
					STA $7FE206
					LDA #$00
					STA $7FE105
					LDA #$07
					STA $7FE207
					LDA #$38
					STA $7FE208
					
					LDA #$08  ;4
					STA $7FE106
					STA $7FE209
					LDA #$00
					STA $7FE107
					LDA #$07
					STA $7FE20A
					LDA #$34
					STA $7FE20B
					
					LDA #$08 ;5
					STA $7FE108
					STA $7FE20C
					LDA #$00
					STA $7FE109
					LDA #$06
					STA $7FE20D
					LDA #$30
					STA $7FE20E
					
					LDA #$08  ;6
					STA $7FE10A
					STA $7FE20F
					LDA #$00
					STA $7FE10B
					LDA #$06
					STA $7FE210
					LDA #$2C
					STA $7FE211
					
					LDA #$08 ;7
					STA $7FE10C
					STA $7FE212
					LDA #$00
					STA $7FE10D
					LDA #$05
					STA $7FE213
					LDA #$28
					STA $7FE214
					
					LDA #$08  ;8
					STA $7FE10E
					STA $7FE215
					LDA #$00
					STA $7FE10F
					LDA #$05
					STA $7FE216
					LDA #$24
					STA $7FE217
					
					LDA #$08 ;9
					STA $7FE110
					STA $7FE218
					LDA #$00
					STA $7FE111
					LDA #$04
					STA $7FE219
					LDA #$20
					STA $7FE21A
					
					LDA #$08  ;10
					STA $7FE112
					STA $7FE21B
					LDA #$00
					STA $7FE113
					LDA #$04
					STA $7FE21C
					LDA #$1C
					STA $7FE21D
					
					LDA #$08 ;11
					STA $7FE114
					STA $7FE21E
					LDA #$00
					STA $7FE115
					LDA #$03
					STA $7FE21F
					LDA #$18
					STA $7FE220
					
					LDA #$08  ;12
					STA $7FE116
					STA $7FE221
					LDA #$00
					STA $7FE117
					LDA #$03
					STA $7FE222
					LDA #$14
					STA $7FE223
					
					LDA #$08 ;13
					STA $7FE118
					STA $7FE224
					LDA #$00
					STA $7FE119
					LDA #$02
					STA $7FE225
					LDA #$10
					STA $7FE226
					
					LDA #$08  ;14
					STA $7FE11A
					STA $7FE227
					LDA #$00
					STA $7FE11B
					LDA #$02
					STA $7FE228
					LDA #$0C
					STA $7FE229
					
					LDA #$08 ;15
					STA $7FE11C
					STA $7FE22A
					LDA #$00
					STA $7FE11D
					LDA #$01
					STA $7FE22B
					LDA #$08
					STA $7FE22C
					
					LDA #$08  ;16
					STA $7FE11E
					STA $7FE22D
					LDA #$00
					STA $7FE11F
					LDA #$02
					STA $7FE22E
					LDA #$0C
					STA $7FE22F
					
					LDA #$08 ;17
					STA $7FE120
					STA $7FE230
					LDA #$00
					STA $7FE121
					LDA #$02
					STA $7FE231
					LDA #$10
					STA $7FE232
					
					LDA #$08  ;18
					STA $7FE122
					STA $7FE233
					LDA #$00
					STA $7FE123
					LDA #$03
					STA $7FE234
					LDA #$14
					STA $7FE235
					
					LDA #$08 ;19
					STA $7FE124
					STA $7FE236
					LDA #$00
					STA $7FE125
					LDA #$03
					STA $7FE237
					LDA #$18
					STA $7FE238
					
					LDA #$08  ;20
					STA $7FE126
					STA $7FE239
					LDA #$00
					STA $7FE127
					LDA #$04
					STA $7FE23A
					LDA #$1C
					STA $7FE23B
					
					LDA #$08 ;21
					STA $7FE128
					STA $7FE23C
					LDA #$00
					STA $7FE129
					LDA #$04
					STA $7FE23D
					LDA #$20
					STA $7FE23E
					
					LDA #$08  ;22
					STA $7FE12A
					STA $7FE23F
					LDA #$00
					STA $7FE12B
					LDA #$05
					STA $7FE240
					LDA #$24
					STA $7FE241
					
					LDA #$08 ;23
					STA $7FE12C
					STA $7FE242
					LDA #$00
					STA $7FE12D
					LDA #$05
					STA $7FE243
					LDA #$28
					STA $7FE244
					
					LDA #$08  ;24
					STA $7FE12E
					STA $7FE245
					LDA #$00
					STA $7FE12F
					LDA #$06
					STA $7FE246
					LDA #$2C
					STA $7FE247
					
					LDA #$08 ;25
					STA $7FE130
					STA $7FE248
					LDA #$00
					STA $7FE131
					LDA #$06
					STA $7FE249
					LDA #$30
					STA $7FE24A
					
					LDA #$08  ;26
					STA $7FE132
					STA $7FE24B
					LDA #$00
					STA $7FE133
					LDA #$07
					STA $7FE24C
					LDA #$34
					STA $7FE24D
					
					LDA #$08 ;27
					STA $7FE134
					STA $7FE24E
					LDA #$00
					STA $7FE135
					LDA #$07
					STA $7FE24F
					LDA #$38
					STA $7FE250
					
					LDA #$08  ;28
					STA $7FE136
					STA $7FE251
					LDA #$00
					STA $7FE137
					LDA #$08
					STA $7FE252
					LDA #$3C
					STA $7FE253
					
					LDA #$00
					STA $7FE138
					STA $7FE254
					RTS

OPEN_MOUSE_L		LDA #$0E
					STA $1DFC
					LDA #$20
					STA $9A
					STZ $9B
					LDA #$20
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D00
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D40
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D64
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					LDA #$30
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D50
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D10
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$20
					STA $9A
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D51
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D60
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D14
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$20
					STA $9A
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D70
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D54
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
					
CLOSE_MOUSE_L		LDA #$20
					STA $9A
					STZ $9B
					LDA #$20
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0D36
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D37
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D76
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					LDA #$30
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D47
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D77
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$20
					STA $9A
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D56
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D57
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$40
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$20
					STA $9A
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D66
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$30
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D67
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS

OPEN_MOUSE_R		LDA #$0E
					STA $1DFC
					LDA #$B0
					STA $9A
					STZ $9B
					LDA #$20
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0DEB
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DCF
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0D8F
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$B0
					STA $9A
					LDA #$30
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D9F
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DDF
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$B0
					STA $9A
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0D9B
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DEF
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DDE
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0DDB
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DFF
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
					
CLOSE_MOUSE_R		LDA #$B0
					STA $9A
					STZ $9B
					LDA #$20
					STA $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0DF9
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DB8
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DB9
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$B0
					STA $9A
					LDA #$30
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0DF8
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DC8
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$B0
					STA $9A
					LDA #$40
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DD8
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DD9
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$C0
					STA $9A
					LDA #$50
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0DE8
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$D0
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0DE9
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
					
HDMA3				LDA #$02 ;C[2
					STA $00212E
					LDA #$00
					STA $002126
					STA $002127
					LDA #$10
					STA $7FFB20
					LDA #$00
					STA $7FFB21
					LDA #$23
					STA $7FFB22
					LDA #$00
					STA $7FFB23
					LDA #$E3
					STA $7FFB24
					LDA #$7F
					STA $7FFB25
					
					LDA #$08
					STA $7FE300
					LDA #$00
					STA $7FE301
					LDA $7FD000
					STA $7FE302
					LDA #$00
					STA $7FE303
					LDA #$01
					STA $7FE304
					LDA #$30
					STA $7FE305
					LDA #$00
					STA $7FE306
					RTS
					
HDMA4				LDA #$03 ;#Ō
					STA $00212E
					
					LDA $7FDAAA
					STA $7FE300
					LDA #$00
					STA $7FE301
					LDA $7FDAAB
					STA $7FE302
					LDA #$00
					STA $7FE303
					LDA #$01
					STA $7FE304
					LDA #$33
					STA $7FE305
					LDA #$00
					STA $7FE306
					RTS
					
FACE_CHANGE1		LDA #$70
					STA $9A
					STZ $9B
					STZ $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A8B
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A8C
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$10
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A9C
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A88
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A89
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A8A
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$20
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A98
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A99
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A9A
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A9B
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
					
FACE_CHANGE2		LDA #$70
					STA $9A
					STZ $9B
					STZ $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A83
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A84
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$10
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A85
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A86
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A87
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A93
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$20
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A94
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A95
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A96
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A97
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
					
FACE_CHANGE3		LDA #$70
					STA $9A
					STZ $9B
					STZ $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A90
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A9F
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$10
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A91
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A9E
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$20
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A92
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A9D
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
FACE_CHANGE4		LDA #$70
					STA $9A
					STZ $9B
					STZ $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0A80
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A8F
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$10
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A81
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A8E
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					LDA #$20
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0A82
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0A8D
                    STA $03
                    JSL $2E8DF0
					PLP
					RTS
					
FACE_DEFAULT		LDA #$70
					STA $9A
					STZ $9B
					STZ $98
					LDA #$01
					STA $99
					PHP                     ;
                    REP #$30                ; 
                    LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$10
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$60
					STA $9A
					LDA #$20
					STA $98
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$70
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$80
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
					PLP
					LDA #$90
					STA $9A
					PHP                     ;
                    REP #$30
					LDA.W #$0025
                    STA $03
                    JSL $2E8DF0
                    PLP
					RTS
